/****************************************************************************************
//LED SMT
*****************************************************************************************/
#macro DIODE_SMD_LED_GRND(s,col,tra)
union{
box{<0.1,0,0.1><1.9,0.60,1.15> pigment{col filter tra}translate<0,0.05,0> }      //Widerstandskoerper
box{<0,0.0,0><0.6,0.3,1.25> }                                        //Metall links
box{<0,0.0,0><0.6,0.3,1.25> translate<2.0-0.6,0,0>}                 //Metall rechts
box{<0.4,0.3,0.5><0.6,0.5,0.75>}
box{<1.4,0.3,0.5><1.6,0.5,0.75>}
box{<0.85,0.3,0.475><1.15,0.4,0.775> pigment{col} finish{ambient 1}}
lathe{linear_spline 4, <0, 0>, <0.4, 0.4>, <0.5,0.4>,<0.05,0>
translate<1,0.1,0.625>}
texture{col_silver} 
translate<-1,0,-0.625>
rotate <0,90,0>
scale s
}
#end

#macro DIODE_SMD_LED_1206(col,tra,height)
object{DIODE_SMD_LED_GRND(<1.5,1.5,1.2>,col,tra)}
#end
                       
//****************************************************************************************
//2x7 Box header (grey)
//Designed by Doug Commons
//Rev. 1.0  Feb 2009
//****************************************************************************************
                       
#macro CON_2x7BOXEDGE(value)
object{CON_DIS_WS_XX_G_GRND(14)  translate<0,+2.5,0> rotate -90*x}
#end                       

//****************************************************************************************
//Macros for SMD bridge MBS1 
//Designed by Doug Commons
//Rev. 1.0  June 3 2007
//****************************************************************************************
#macro IC_SMD_MBS1_GRND()
union{
    difference{
        box{<-2.4,0.3,2.1><2.4,1.9,-2.1>}   
        pigment{Gray20}
    }
//    text {ttf global_fontfile_eagle3d "j" 0.02, 0 pigment{Gray80} scale 2 rotate<90,0,0> translate<-2.0,1.91,-0.8>}  // Marking
    text {ttf global_fontfile_arial_bold "+" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<+1.8,1.91,+1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "-" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<-1.8,1.91,+1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "~" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<+1.8,1.91,-1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "~" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<-1.8,1.91,-1.4>}  // Marking
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-1.7,0,1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+1.9,0,1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate +90*y translate<-1.7,0,-1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate +90*y translate<+1.9,0,-1.9>}
}
translate<-1,0,0>
#end

#macro IC_SMD_MBS()
object{IC_SMD_MBS1_GRND()}
#end 

//****************************************************************************************
//USB A
//****************************************************************************************
#macro USBA()  
union{
union{
    difference{
        union{
        box{< 6.0, 0.0,+1.3>  <-6.0, 3.07,-17.5>  texture{col_silver}}//top level shell
        box{< 6.0,-1.5,-2.8>  <-6.0, 0.00,-17.5>  texture{col_silver}}//PCB level shell 
        box{<+2.0,+3.08,-13.5><+4.0,+2.97,-11.5>  pigment{Gray20}}  //top detent front
        box{<-2.0,+3.08,-13.5><-4.0,+2.97,-11.5>  pigment{Gray20}}  //top detent front
        box{<+3.0,+3.08,-10.5><+4.0,+2.97,- 9.5>  pigment{Gray20}}  //top detent back
        box{<-3.0,+3.08,-10.5><-4.0,+2.97,- 9.5>  pigment{Gray20}}  //top detent back     
        box{<+0.5,+3.08,- 1.0><-0.5,+2.97,+ 0.0>  pigment{Gray20}}  //top back detent 
        
        box{<+2.0,-1.51,-13.5><+4.0,-1.48,-11.5>  pigment{Gray20}}  //bottom detent   
        box{<-2.0,-1.51,-13.5><-4.0,-1.48,-11.5>  pigment{Gray20}}  //bottom detent  
        
//bottom joint
        box{< 0.0,-1.7,-17.5>< 0.0,-1.49,-14.5> pigment{Gray20}}  //segment A     
        box{< 0.0,-1.7,-14.5><-1.0,-1.49,-14.5> pigment{Gray20}}  //segment B
        box{<-1.0,-1.7,-14.5><-1.0,-1.49,-13.5> pigment{Gray20}}  //segment C 
        box{<-1.0,-1.7,-13.5>< 0.0,-1.49,-13.5> pigment{Gray20}}  //segment D
        box{< 0.0,-1.7,-13.5>< 0.0,-1.49,-3.5>  pigment{Gray20}}  //segment E
        box{<-1.0,-1.7,- 7.5><-1.0,-1.49,-6.5>  pigment{Gray20}}  //segment F
        box{<-1.0,-1.7,- 6.5>< 0.0,-1.49,-6.5>  pigment{Gray20}}  //segment G
        box{< 0.0,-1.7,  0.0>< 0.0,-1.49, 0.0>  pigment{Gray20}}  //segment H   
        
//mounting pins plastic
        cylinder{<+2.25,0.0,0.0><+2.25,-2.43,0.0>0.5 pigment{Gray20}}
        cylinder{<-2.25,0.0,0.0><-2.25,-2.43,0.0>0.5 pigment{Gray20}}        
        }   
    }  
        box{<-5.93,-1.43,-2.8><5.93,3.0,-17.51>  texture{col_silver}}   //remove inside shell  
        box{<-5.3,-1.43,-2.8><5.3,1.0,-17.52>  pigment{Gray20}}         //pin support
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-3.5,0,+1.3>} //SMT pins
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-1.0,0,+1.3>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+1.0,0,+1.3>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+3.5,0,+1.3>} 
	    
}      
        cylinder{<+3.5,1.6,-17.52><+3.5,1.6,0>0.5  texture{col_gold}} //USB A pin	
        cylinder{<+1.0,1.6,-17.52><+1.0,1.6,0>0.5  texture{col_gold}} //USB A pin
        cylinder{<-1.0,1.6,-17.52><-1.0,1.6,0>0.5  texture{col_gold}} //USB A pin
        cylinder{<-3.5,1.6,-17.52><-3.5,1.6,0>0.5  texture{col_gold}} //USB A pin 
}  
#end

//****************************************************************************************
// Small AC input jack
//****************************************************************************************
#macro CON_AC_IN_GRND()
union{ 
union{
difference{
 box{<0,0,-2.5><11,5,2.5>}                              //body
 cylinder{<-0.1,2.5,0><8,2.5,0>1.3  pigment{Gray40}}    //body socket
}      
 cylinder{<-0.1,2.5,0><8,2.5,0>0.5  texture{col_silver}} //pin
}
union{ 
  box{<0,0,0><2.0,0.1,1.5> translate <2.5,0,2.5>}	//front leg left
  box{<0,0,0><2.0,0.1,1.5> translate <3.5,0,-2.5>}	//front leg right         
  box{<0,0,0><2.0,0.1,2.0> translate <8,0,2.5>}         //rear leg left
  box{<0,0,0><2.0,0.1,2.0> translate <9,0,2.5>}	        //rear leg right
  box{<-1,0.1,0><2,0.1,2> translate <11,0,-1>}	        //rear leg

  box{<0,0,-0.1><-3.5,5.2,0.1> translate <10,0,2.5>}	//left side
  box{<0,0,-0.1><-3.5,5.2,0.1> translate <10,0,-2.5>}	//right side
  box{<-2.8,-.1,0><2.8,.1,5> translate <7,5,-2.5>}	//top

  texture{T_Chrome_5A} 
}
}                                                                                         
#end

#macro CON_AC_IN_SMT()
object{CON_AC_IN_GRND()}
#end

//*********************************************************************************
//SMT Dipswitch
//
//**********************************************************************************
#macro SMT_DIP_GRND(nrSwitches) 
  #local well  = box { <0,3.8,2> <1,3.96,4.7> pigment { MediumWood } }
  #local housing = difference { box { <0,0,0> <2.54*(nrSwitches+0.5),3.95,6.7> }
                                box { <0,3.8,2> <.3,3.96,4.7> }
                                pigment{color red 0.7 green 0.15 blue 0.15}}//SteelBlue
  #local offSwitch = union { box { <0.1,3.71,2.1> <.9,3.71,4.6> }
                             box { <0.1,3.71,2.1> <.9,4.1,3> }
                             pigment { NewTan }}
  #local onSwitch = union { box { <0.1,3.71,2.1> <.9,3.71,4.6> }
                            box { <0.1,3.71,3.6> <.9,4.1,4.6> }
                            pigment { NewTan }}
  union {
    difference {
      object { housing }

      #local wellNr = 0;
      #while (wellNr < nrSwitches)
        object { well translate<(wellNr+0.5)*2.54,0,0> }
        #local wellNr = wellNr + 1;
      #end
    }
    #local switchNr = 0;
    #while (switchNr < nrSwitches)
      #local xShift = (switchNr+0.5)*2.54;
      object {IC_SMD_PIN(1.5,1.5,0.8,0.3) rotate +90*y translate<xShift+0.5,0,0.0>} 
      object {IC_SMD_PIN(1.5,1.5,0.8,0.3) rotate -90*y translate<xShift+0.5,0,6.7>} 
      #local onOff = SRand(1);
      #if (onOff < 0)
        object { offSwitch translate<xShift,0,0> }
      #else
        object { onSwitch translate<xShift,0,0> }
      #end
      text {
        ttf besch_font str(switchNr,2,0) .01, 0
        pigment { NewTan }
        scale 1.5
        rotate<90,0,0>
        translate<xShift-.2,3.96,.5>
      }
      #local switchNr = switchNr + 1;
    #end
    text {
      ttf besch_font "ON" .01, 0
      pigment { NewTan }
      scale 1.5
      rotate<90,0,0>
      translate<0.5,3.96,5.2>}
 //   translate<-nrSwitches-.5,0,-3.9>     
      translate<(-nrSwitches-.5)*2.54/2,0,-3.35>  
//    scale 2.54/2
    }
#end

#macro SMTDIP4()
object{SMT_DIP_GRND(4)}
#end

//****************************************************************************************
// Small stereo audio jack from CUI
//****************************************************************************************
#macro CON_SJ1_3515_GRND()
union{ 
union{    
difference{      
 box{<5,0,-7.5><-4.5,5,7.5>}                            //body    
 box{<-4.5,0,-3.7><-4.0,5.01,-2.2> texture{col_gold}}   //detent 
 }    
 cylinder{<0,0,0><0,-0.2,0>0.8     translate <0,0,-4.5>}//mounting pin 
 cylinder{<0,0,0><0,-0.2,0>0.8     translate <0,0,+2.5>}//mounting pin
  difference{                                    
  cylinder{<0,2.5,0><0,2.5,-3>2.5     translate <0,0,-7.5> texture{col_silver}}//plug 
  cylinder{<0,2.5,0><0,2.5,-3.01>1.8  translate <0,0,-7.5> pigment{Gray80}}//socket
 } 
}
polygon {5,<-4,-2.2>,<-4,-3.7>,<-0.75,-7.5>,<0.75,-7.5><-4,-2.2> texture{col_gold}
rotate<90,0,0> translate <0,5.01,0> }
union{ 
  box{<-.75,0,-.5><.75,0.1,0.5> translate <5,0,-1.0>}   //pin 4  
  box{<-.75,0,-.75><.75,0.1,0.75> translate <5.25,0,3>} //pin 2
  box{<-.75,0,-.75><.75,0.1,0.75> translate <-5.5,0,-3.2>}//pin 1
  box{<-.75,0,-.5><.75,0.1,0.5> translate <-5.5,0,0.1>} //pin 5
  box{<-.75,0,-.5><.75,0.1,0.5> translate <-5.5,0,3>}   //pin 3            
texture{col_gold}
} 
}                                                                                         
#end

#macro CON_SJ1_3515_SMT()
object{CON_SJ1_3515_GRND()}
#end                          
//****************************************************************************************
// Small stereo audio jack from CUI with PTH pins and thread lock
//****************************************************************************************      
#macro CON_3515_PTH_pin()  
difference{
        union{ 
                box{<-0.5,0,0.25><0.5,-3,-0.25>}                            //body          
                cylinder{<0,-3,0.25><0,-3,-0.25>0.5 }    
        }
        cylinder{<0,-3,0.26><0,-3,-0.26>0.25 }            
}
#end

#macro CON_3515_threads() 
  difference{
        union{  
          object{SMA_THREADS(3.6,6.0,0.5,3.5) translate <0,3,-3.5> texture{col_gold}} 
          cylinder{<0,3,0><0,3,-3.5>2.8 } 
        }
    cylinder{<0,3,-0.1><0,3,-3.6>1.8 } 
  } 
#end  

#macro CON_3515_PTH()
union{    
union{      
 box{<5.75,0,0><-5.75,5,14>}                            //body black base   
 box{<5.75,5,0><-5.75,6,14>texture{col_silver}}         //body white cap 
}  
  
object{CON_3515_threads()} 
//object{SMA_THREADS(3.6,6.0,0.5,3.5) translate <0,3,-3.5> texture{col_gold}} 
  
object{CON_3515_PTH_pin() translate<0,0,1.8>       texture{col_silver}} //pin1
object{CON_3515_PTH_pin() translate <-5.3,0,-4.5>  rotate<0,90,0> texture{col_silver}} //pin2
object{CON_3515_PTH_pin() translate <-10.1,0,5>    rotate<0,90,0> texture{col_silver}} //pin3
object{CON_3515_PTH_pin() translate <-4.2,0,12.9> texture{col_silver}} //pin4
object{CON_3515_PTH_pin() translate <-8.4,0,2.5>   rotate<0,90,0> texture{col_silver}} //pin5

}                                                                                         
#end

//****************************************************************************************
// Slide switch EG1313 
//****************************************************************************************
#macro CON_SLIDE_SWITCH_GRND()
union{
  box{<-8,0,0><8,5,3.8> texture{col_silver}}            //body
  box{<0,2.5,0><2,4.5,-2>}                              //button 
                                         
union{ 
  cylinder{<8.3,-1,1.9><8.3,0.4,1.9>0.6}	        //mounting pin
  cylinder{<8.3,-1,1.9><-8.3,0.4,1.9>0.6}	        //mounting pin   
  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,1.9>}	//pin 1  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,1.9>}	//pin 2 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,1.9>}	//pin 3 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,1.9>}	//pin 4       
  texture{T_Chrome_5A} 
}
}
pigment{Gray20} 
#end

#macro CON_SWITCH1313()
object{CON_SLIDE_SWITCH_GRND()}
#end
           
//****************************************************************************************
// Slide switch SWITCHDP3T 
//****************************************************************************************
#macro CON_SWITCHDP3T_GRND()
union{                          
     difference{
        box{<-7.45,0,0><7.45,5.5,6> texture{col_silver}}//body   
        box{<-4,0.7,-0.01><4,4.8,0.1> texture{Dull}}//body detent   ??
     }
     box{<-4,1.05,-2><-2,3.15,0>}                       //button 
     box{<-4,1.05,-2><-3.6,3.15,-2.1>}                  //button texture
     box{<-3.2,1.05,-2><-2.8,3.15,-2.1>}                //button texture
     box{<-2.4,1.05,-2><-2.0,3.15,-2.1>}                //button texture
                                         
union{ 
  cylinder{<-7.45,0.4,5.375><-7.45,-1,5.375>0.6}	//mounting pin
  cylinder{<7.45,0.4,0.625><7.45,-1,0.625>0.6}	        //mounting pin   
  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,1.55>}	//pin 5  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,1.55>}	//pin 6 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,1.55>}	//pin 7 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,1.55>}	//pin 8  

  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,4.05>}	//pin 1  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,4.05>}	//pin 2 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,4.05>}	//pin 3 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,4.05>}	//pin 4        
  texture{T_Chrome_5A} 
}
}
pigment{Gray20} 
#end

#macro CON_SWITCHDP3T()
  object{CON_SWITCHDP3T_GRND()}
  translate<7.45,0,-6>
#end           
           
//****************************************************************************************
// Microphone  WM63PR 
//****************************************************************************************
#macro MICROPHONE()    
union{
union{
  torus{2.5,0.5 translate <0,0.8,0>}                    //body top  
  cylinder{<0,0,0><0,1.3,0>3.0}	                        //body 
  torus{2.5,0.5 translate <0,0.5,0>}                    //body bottom  
  texture{T_Chrome_5A}  
}
union{
  cylinder{<0,0,0><0,-1,0>0.25 translate <1,0,1>}	//pin 
  cylinder{<0,0,0><0,-1,0>0.25 translate <-1,0,1>}	//pin
  texture{T_Chrome_5A} 
}  
  cylinder{<0,0,0><0,0.5,0>2.8 translate <0,1.32,0>}	//screen 
}  
       
pigment{Gray20} 
#end
       
#macro WM63PRMIC()       
  object{MIC()}
#end
 
//****************************************************************************************
// 1x4 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_1X4EDGE(value)  
object{PH_GRND(1,4,0,2.54)}
rotate<90,0,0> 
translate<+3.81,0.1,+2.54>
#end

//****************************************************************************************
// 2X2 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X2EDGE(value)  
object{PH_GRND(2,2,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end
     
//****************************************************************************************
// 2X3 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X3EDGE(value)  
object{PH_GRND(2,3,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end
     
//****************************************************************************************
// 2X5 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X5EDGE(value)  
object{PH_GRND(2,5,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end 

//****************************************************************************************
// 2X7 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X7EDGE(value)  
object{PH_GRND(2,7,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end

//****************************************************************************************
// 2X18 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X18EDGE(value)  
object{PH_GRND(2,18,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end

//****************************************************************************************
// Tantalum 1206 pkg 
//****************************************************************************************
#macro C1206P(value)  
object{CAP_SMD_CHIP_TT_GRND(3.2,1.6,1.6,3.2,1.2,1.6,0.8,value)}
#end

//****************************************************************************************
// Voltage regulator SOT3233 pkg 
//****************************************************************************************
#macro SOT3233(value,logo)  
object{IC_SMD_GRND(3.0,1.7,1.45,3,3,2,0.95,1.9,0.5,0.5,0.2,0.15,0,1,0,0.3,0,0,logo)}  
translate<+1.5,0.0>
#end    

//****************************************************************************************
// Voltage regulator DBVSOT pkg 
//****************************************************************************************
#macro DBVSOT(value,logo)  
object{IC_SMD_GRND(3.0,1.7,1.45,3,3,2,0.95,1.9,0.5,0.5,0.2,0.15,0,1,0,0.3,0,0,logo)}  
#end 

//****************************************************************************************
// Voltage regulator SOT89 pkg 
//****************************************************************************************
#macro SOT89(value,logo)  
object{IC_SMD_GRND(4.6,2.6,1.6,4.25,3,1,1.57,1.83,0.44,0.1,0.2,0.15,0,1,0,0.3,0,0,logo)}  
#end


//****************************************************************************************
// SMD Oscillator
//****************************************************************************************
#macro OSC_GRND(value)
union{ 
difference{
 box{<-3.5,0,0><3.5,1.6,5> texture{col_gold}}          //body
 cylinder{<0,0,0><0,1.6,0>0.8  translate<-2.5,0,0> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<+2.5,0,0> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<-2.5,0,5> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<+2.5,0,5> texture{col_silver}} //pin 4     
}
 box{<-3.0,1.6,0.5><+3.0,1.7,4.5> texture{col_gold}}  //body   
 cylinder{<-2.5,1.7,1><-2.5,1.71,1>0.3 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale 1 rotate <90,0,0> translate<-3,1.71,2.5> pigment{Black}}
}         
translate<+3.5,1>
#end 
        
//****************************************************************************************
// SMD Crystal  3.2x2.5mm
//****************************************************************************************
#macro XTAL_small(value)
union{ 
difference{
 box{<-1.6,0,1.25><1.6,0.7,-1.25> pigment{Gray10}}          //body 
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,1.25> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,1.25> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,-1.25> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,-1.25> texture{col_silver}} //pin 4    
}
 box{<-1.2,0.71,-0.85><+1.2,0.75,0.85> texture{col_gold}}  //body   
 cylinder{<-1.4,0.75,1.25><-1.4,0.76,1.25>0.2 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale .7 rotate <90,0,0> translate<-1.0,0.76,-0.25> pigment{Black}}
}
translate<+1.6,0,1.25>         
#end         
        
//****************************************************************************************
// SMD Oscillator  3.2x2.5mm
//****************************************************************************************
#macro OSC_small(value)
union{ 
difference{
 box{<-1.6,0,1.25><1.6,0.7,-1.25> pigment{Gray10}}          //body 
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,1.25> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,1.25> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,-1.25> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,-1.25> texture{col_silver}} //pin 4    
}
 box{<-1.2,0.71,-0.85><+1.2,0.75,0.85> texture{col_gold}}  //body   
 cylinder{<-1.4,0.75,1.25><-1.4,0.76,1.25>0.2 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale .7 rotate <90,0,0> translate<-1.0,0.76,-0.25> pigment{Black}}
}        
#end                      

//
// 20 pin QLP
//
#macro IC_SMD_QLP20(value,logo)
object{QFP_GRND(2.8,2.8,0.6,5,5,5,5,0.5,0.28,0.1,2.4,2.8,0.22,90,0,logo)}
#end

//****************************************************************************************
// CASON8 Flash memory
//****************************************************************************************
#macro IC_SMD_CASON8(value)
union{
 box{<-4,0,0><4,1,6> }        //body
 cylinder{<-3,1,5><-3,1.1,5>0.2 texture{col_silver}}  //pin 1 
 text{ttf besch_font value 1, 0 scale 1 rotate <90,0,0> translate<-3,1.01,1.5> pigment{White}}
 text{ttf global_fontfile_eagle3d "a" 1, 0 scale 2 rotate <90,0,0> translate<-2,1.01,3> pigment{White}} 
}             
pigment{Gray20} 
translate<+4,0.0>
#end
    
//****************************************************************************************
// Xilinx Platform Flash memory  
//IC_SMD_GRND(LK,BK,HK,B,pin_u,pin_o,ptch_u,ptch_o,pinb_u,pinb_o,pin_s,di_pcb,kor_w,pin0_m,pin0_45,pin0_a,besch_s,besch_w,logo)
//****************************************************************************************
#macro IC_SMD_VOG20(value,logo)
object{IC_SMD_GRND(6.6,4.5,1.2,6.6,10,10,0.625,0.625,0.305,0.305,0.15,1.1,0,1,0,0.3,0,0,logo)}  
#end                          

   
//****************************************************************************************
// Edge connector socket 
//****************************************************************************************
#macro CON_EDGESKT(value)  
union{ 
 box{<-1.270,+0.000,+0.000><+1.270,+1.000,+8.250> pigment{Black}}       //socket body
 box{<-1.092,+0.285,-0.300><+1.092,+0.715,+8.250> texture{col_gold}}    //socket contact 
 box{<-0.430,+0.285,+8.250><+0.430,+0.385,+11.76> texture{col_gold}}    //socket pin  
// polygon{<-1.270,+2.54,+0.100><+1.270,+2.54,+0.100><+1.092,+2.362,+0.100><-1.270,+2.54,+0.100>}
} 
translate<+0.000,-0.285,-11.00>  

#end    

/********************************************************************************************************************************************
//
********************************************************************************************************************************************/
#macro EDGESKT(rows,pins)
union{
#if(rows=1)
#local i=0;
        #while(i<pins)
                object{CON_EDGESKT() translate<i*2.54,0,0>}
                #local i=i+1;
        #end
        translate<-(pins-1)*1.27,0,0>
#else
        #local i=0;
        #while(i<pins)
                object{CON_EDGESKT(value) translate<i*2.54,0,1.27>}
                object{CON_EDGESKT(value) translate<i*2.54,0,-1.27>}
                #local i=i+1;
        #end
        translate<-(pins-1)*1.27,0,0>
#end
}
#end

#macro CON_2x5EDGESKT(value)
object{EDGESKT(2,5)}
#end
            
            
/********************************************************************************************************************************************
//L     = Laenge ueber alles (x-Achse)
//B     = Breite ueber alles (z-Achse)
//H     = Hoehe des Kunststoff (Y-Achse)
//pin_l = Anzahl Pins links
//pin_r = Anzahl Pins rechts
//pin_o = Anzahl Pins "oben"
//pin_u = Anzahl Pins "unten"
//pitch = Abstand der einzelnen Pins
//pin_br= Breite eines Pins
//pin_h = Staerke des Pinmaterials
//LK    = Laenge des Kunststoff (x-Achse)
//BK    = Breite des Kunststoff (z-Achse)
//HKoP  = Hoehe des Kunststoffs ueber der Platine (Y-Achse)
//KORW  = Korrekturwinkel
//kp1ab = Wenn nicht 0 wird keine Abschraegung an Pin1 erzeugt
//logo  = Name of the logo        
//
//
//L = length over everything (x axis) 
//B = width over everything (Z-axis) 
//H = height plastic (y axis) 
//pin_l = number of pin left 
//pin_r = number of pin right 
//pin_o = number of pin above 
//pin_u = number of pin down 
//pitch = distance of the individual pins 
//pin_br = width of a pin 
//pin_h = strength of the pin material 
//LK = length plastic (x axis) 
//BK = width plastic (Z-axis) 
//HKoP = height of the plastic over the plate (y axis) 
//KORW = correction angle 
//kp1ab = if not 0 is produced no chamfer at Pin1 
//logo = name OF the logo
********************************************************************************************************************************************/
#macro QFP_GRND_DNC(L,B,H,pin_l,pin_r,pin_o,pin_u,pitch,pin_br,pin_h,LK,BK,HKoP,KORW,kp1ab,logo)
union{
	difference{
		box{<-LK/2,HKoP,-BK/2><LK/2,HKoP+H,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,-1> rotate<-10,0,0> translate<0,HKoP+H/2-pin_h/2,-BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,1> rotate<10,0,0> translate<0,HKoP+H/2-pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,1> rotate<-10,0,0> translate<0,HKoP+H/2+pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,-1> rotate<10,0,0> translate<0,HKoP+H/2+pin_h/2,-BK/2>}
		box{<0,0,-BK/2-0.01><1,2,BK/2+0.01> rotate<0,0,10> translate<LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,2,BK/2+0.01> rotate<0,0,-10> translate<-LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><1,-2,BK/2+0.01> rotate<0,0,-10> translate<LK/2,HKoP+H/2-pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,-2,BK/2+0.01> rotate<0,0,10> translate<-LK/2,HKoP+H/2-pin_h/2,0>}
		#if(kp1ab=0)
			box{<0,0,-3><-2,5,3> rotate<0,-45,0> translate<-LK/2+LK/40,0,-BK/2+BK/40>}
		#end
		cylinder{<0,H+HKoP-0.1,0><0,H+HKoP+1,0>0.4 translate<-LK/2+LK/10,0,-BK/2+BK/10>}
		pigment{Gray20}
	}
	
	#local i=0;
	#while(i<(pin_l/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i+pitch/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end
	
	#local i=0;
	#while(i<(pin_r/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i+pitch/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_u/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i+pitch/2,0,-BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i-pitch/2,0,-BK/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i,0,-BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i,0,-BK/2>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_o/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i+pitch/2,0,BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i-pitch/2,0,BK/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i,0,BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i,0,BK/2>}
		#end
		#local i=i+1;
	#end
	
	#local scl_fa = BK/10;
	#local value_arial_size_min = 0.0;
	#local value_arial_size_max = 0.0;
	#local value_arial_size = 0.0;
	#local value_courier_size_min = 0.0;
	#local value_courier_size_max = 0.0;
	#local value_courier_size = 0.0;
//	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_courier_bold = text{ttf global_fontfile_courier_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_arial_bold, value_arial_size_min, value_arial_size_max)
	Extents(value_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_arial_size = value_arial_size_max - value_arial_size_min; 
	#local value_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_scale_factor_arial = BK/value_arial_size.z * 0.7;
	#local value_scale_factor_courier = BK/value_courier_size.z * 0.7;	
	
	#if(value_arial_size.x*value_scale_factor_arial > LK/6.0) 
                #local value_scale_factor_arial = LK/6.0 / value_arial_size.x;	
	#end
	#if(value_courier_size.x*value_scale_factor_courier > LK/6.0) 
                #local value_scale_factor_courier = LK/6.0 / value_courier_size.x;	
	#end
		
	#local value_arial_size = value_arial_size * value_scale_factor_arial; 
	#local value_courier_size = value_courier_size * value_scale_factor_courier;
	//a random datecode string
	#local value_datecode_arial_size_min = 0.0;
	#local value_datecode_arial_size_max = 0.0;
	#local value_datecode_arial_size = 0.0;
	#local value_datecode_courier_size_min = 0.0;
	#local value_datecode_courier_size_max = 0.0;
	#local value_datecode_courier_size = 0.0;
	#local value_datecode_string = concat(str(rand(global_seed)*52.9, -2, 0),str(rand(global_seed)*3.9+2, -2, 0));	
//	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_courier_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_datecode_arial_bold, value_datecode_arial_size_min, value_datecode_arial_size_max)
	Extents(value_datecode_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_datecode_arial_size = value_datecode_arial_size_max - value_datecode_arial_size_min; 
	#local value_datecode_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_datecode_scale_factor_arial = value_scale_factor_arial;
	#local value_datecode_scale_factor_courier = value_scale_factor_courier;
	#local value_datecode_arial_size = value_datecode_arial_size * value_scale_factor_arial; 
	#local value_datecode_courier_size = value_datecode_courier_size * value_scale_factor_courier;
	
		
	#local logo_assigned = 0;
		
	#if(strcmp(logo,"FTDI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "f" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end
	
	#if(strcmp(logo,"ATMEL")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "a" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} rotate<0,+90,0>}		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2> rotate<0,+90,0>} 
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>rotate<0,+90,0>}
	#end

	#if(strcmp(logo,"TI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "t" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/10> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end

	#if(strcmp(logo,"XILINX")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "#" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	

	#if(strcmp(logo,"MICROCHIP")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "m" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	


	#if(strcmp(logo,"CYPRESS")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "}" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	

	
	#if(logo_assigned < 0.5)
		text{ttf besch_font value 0.2,0 scale<scl_fa,scl_fa,1> rotate<90,-90,0> translate<-LK/2+LK/4,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }
	#end
	
	rotate<0,KORW,0>
}
#end


//LQFP-64 aus DS80C390 Datasheet
#macro LQFP_64_050MM_DNC(value,logo)
object{QFP_GRND_DNC(12,12,1.4,16,16,16,16,0.5,0.22,0.15,10,10,0.1,0,0,logo)}
#end
            
            
/********************************************************************************************************************************************
//
********************************************************************************************************************************************/    
//Pin
#macro Pin()  
	box{<1.0,0,-0.3><0,0.1,0.3>}                									//pin pad        
#end           

//Body
#macro Body_detent() 
union{
	box{<-0.8,-0.5,0><-0.7,1.5,-0.1>}   
	box{<-0.7,1.3,0><0.7,1.5,-0.1>} 
	box{<0.8,-0.5,0><0.7,1.5,-0.1>}  
}   
rotate <90,0,0> 
translate<0,1.72,3.05> 
texture{pigment{Blue}}           
#end 


//Body
#macro Body()   
difference{ 
        union{
	        box{<-2.0,0,0><2,1.8,6.1> texture{pigment{White*.9}}}
	        object{Body_plate()}   
	}             										//body   
	object{Body_detent()} 								//pin4 
}
#end    

//Body_plate
#macro Body_plate()   
union{
	box{<-1.91,0,-0.01><1.91,0.1,6.11>}   
	box{<-1.9,0.1,1.3><-2,-0.75,3.9>} 
	box{<+1.9,0.1,1.3><+2,-0.75,3.9>}             										  
} 
translate<0,1.71,0>
texture{T_Silver_1B}   
//texture{pigment{Blue}}
#end      

//Mounting Pin
#macro Mount_Pin()        
union{
	cylinder{<0,0,0><0,-0.5,0>0.45 translate<0,0,1.55> texture{pigment{Yellow}}}  	//pin pad  
	cylinder{<0,0,0><0,-0.5,0>0.45 translate<0,0,4.55>  texture{pigment{Yellow}}}        
}
#end      

//Button
#macro Button()  
union{   
        difference{      
                box{<-1.2,0.1,0><1.2,1.6,-1.3> texture{pigment{Blue}}}             	        //button   
                union{
                        box{<-0.7,1.4,-0.65><0.7,1.61,0> texture{pigment{Blue*0.1}}}                            //button top deepest detent 
                        box{<-0.7,0.1,-0.65><0.7,0.3,0> texture{pigment{Blue*0.1}}} 
                        box{<-2,0,-2><2,1.7,0> rotate<0,+45,0> translate<-0.7,0,-1.3> texture{pigment{Blue*0.8}}} 
                        box{<-2,0,-2><2,1.7,0> rotate<0,-45,0> translate<+0.7,0,-1.3> texture{pigment{Blue*0.8}}}     
                }
        }  
        box{<-0.5,1.5,-0.65><0.5,1.4,0> texture{pigment{Blue*0.5}}}                                     //button top shallow detent
        box{<-0.5,0.1,-0.65><0.5,0.2,0> texture{pigment{Blue*0.5}}}   

}
#end   

                                             
 
 
#macro CON_COLLISION()
union{
object{Pin() translate<2,0,4.55>       texture{col_silver}} 						//pin1
object{Pin() translate<2,0,1.55>       texture{col_silver}} 						//pin2 
object{Pin() rotate<0,180,0> translate<-2,0,4.55>      texture{col_silver}} 		//pin3
object{Pin() rotate<0,180,0> translate<-2,0,1.55>      texture{col_silver}} 		//pin4  

object{Body()} 										//body   
object{Mount_Pin()} 																//mounting     
object{Button()}  
translate<0,0,-3.01>
}  
#end     


//****************************************************************************************
// JTI_ANTENNA Johanson Technology SMT Antenna 2.45GHz 50 ohm 
// Part #
// Digi-Key #
//****************************************************************************************                                                     					// pin at origin       
#macro JTI_ANTENNA()                                              
union{                
        box{<-1.75,0,0><1.75,1.3,7.6> texture{pigment{Blue*0.8}}}       //body    
        
        box{<+1.751,0,-0.001><+1.05,1.31,0.8> texture{col_silver}}      //pin 1
        box{<-0.35,0,-0.001><+0.35,1.31,0.8> texture{col_silver}}       //pin 2  
        box{<-1.751,0,-0.001><-1.05,1.31,0.8> texture{col_silver}}      //pin 3

        box{<-1.751,0,+7.601><-1.05,1.31,+7.20> texture{col_silver}}    //pin 4
        box{<-0.35,0,+7.601><+0.35,1.31,+7.20> texture{col_silver}}     //pin 5
        box{<+1.751,0,+7.601><+1.05,1.31,+7.20> texture{col_silver}}    //pin 6 
          
        box{<+0.4,1.311,1.5><-0.4,1.311,2.3> texture{pigment{Brown}}}   //mount dot
}  
translate<0,0,-3.8>
rotate<0,90,0>
#end   


//****************************************************************************************
// JTI_BALUN Johanson Technology Balun 2.45GHz balance to 50 ohm 
// Part #
// Digi-Key #
//****************************************************************************************                                                 					     
#macro JTI_BALUN()                                              
union{
        box{<-0.75,0,0><0.75,0.9,2> texture{pigment{Yellow*0.8}}}       //body
        																    
        box{<-0.5,0,-0.01><-0.2,0.91,0.2> texture{col_silver}}          //pin 1
        box{<+0.5,0.91,0.2><+0.2,0,-0.01> texture{col_silver}}          //pin 2 

        box{<+0.2,0,2.01><+0.5,0.91,1.8> texture{col_silver}}           //pin 3 
        box{<-0.5,0,2.01><-0.2,0.91,1.8> texture{col_silver}}           //pin 4
                
        box{<-0.76,0,0.6><-0.55,0.91,1.4> texture{col_silver}}          //pin 5 side gnd 
        box{<+0.76,0,0.6><+0.55,0.91,1.4> texture{col_silver}}          //pin 6 side gnd
   
        
        box{<+0.35,0.91,0.7><-0.35,0.91,1.0> texture{pigment{Brown}}}  
}   
translate<0,0,-1>
rotate<0,90,0>
#end