/********************************************************************************************************************************************
//SR(Tiefe, Breite, Hoehe, Breite Loetflaeche, Schriftzug)
********************************************************************************************************************************************/
#macro RES_SMD_CHIP(b,l,h,blf,value,body)
union{
	box{<0    ,0    ,0.01> <blf    ,h+0.05 ,b-0.01>}
	box{<l    ,0    ,0.01> <l-blf  ,h+0.05 ,b-0.01>}
	box{<0.05 ,0.05 ,0   > <l-0.05 ,h      ,b     > pigment{White}}
	box{<blf  ,h    ,0   > <l-blf  ,h+0.07 ,b     > texture{pigment{body} finish{phong 0.5}}}
	text {ttf besch_font value 0.1, 0
		pigment{White} rotate<90,0,0> scale<l/3.5,1,b/1.5>
		translate<l/3.8,h+0.08,b/3>}
	texture{col_silver}
	translate<-l/2,0,-b/2>
}
#end

#macro RES_SMD_CHIP_0805_RED(value)
object{RES_SMD_CHIP(1.25,2.00,0.45,0.40,value,Red)}
#end  

#macro RES_SMD_CHIP_0805_GRN(value)
object{RES_SMD_CHIP(1.25,2.00,0.45,0.40,value,Green)}
#end              
#macro RES_SMD_CHIP_0805_BLU(value)
object{RES_SMD_CHIP(1.25,2.00,0.45,0.40,value,Blue)}
#end


#macro LED_0805_RED() 
object{ L0805(Red,1,1)}
#end   
#macro LED_0805_BLU() 
object{ L0805(Blue,1,1)}
#end      
#macro LED_0805_GRN() 
object{ L0805(Green,1,1)}
#end     
#macro LED_0805_YEL() 
object{ L0805(Yellow,1,1)}
#end


#macro ADM70_pin()                                              
union{ 
        difference{
                union{
                        cylinder{<0,-0.5,0><0,+0.5,0>1 texture{pigment{Gold} finish {phong 1}}}    
                        box{<0,-0.5,-3><1,+0.5,0> rotate<0,-45,0> translate<0,0,0> texture{pigment{Gold} finish {phong 1}}}    
                        box{<0,-0.5,-3><-1,+0.5,0> rotate<0,45,0> translate<0,0,0> texture{pigment{Gold} finish {phong 1}}}    
                }
                union{
                        cylinder{<0,-0.6,0><0,+0.6,0>1 texture{pigment{Gold} finish {phong 1}}}    
                        box{<0,-0.6,-3><1,+0.6,0> rotate<0,-45,0> translate<0,0,0> texture{pigment{Gold} finish {phong 1}}}    
                        box{<0,-0.6,-3><-1,+0.6,0> rotate<0,45,0> translate<0,0,0> texture{pigment{Gold} finish {phong 1}}}    
                translate<0,0,-.2>}
        } rotate<-90,0,0>     
}
#end

#macro ADM70()                                              
union{ 
        difference{   
                box{<-5.6,0,12><5.6,4,-12> texture{pigment{Black*2} finish {phong 3}}}       //body      
                union{
                        box{<-2,0,12.1><2,1,-12.1> rotate<0,0,5> translate<-4.6,3.8,0>  texture{pigment{Black*2} finish {phong 3}}}       //clip corners    
                        box{<-2,0,12.1><2,1,-12.1> rotate<0,0,-5> translate<4.6,3.8,0>  texture{pigment{Black*2} finish {phong 3}}}      
                }
        }  
        object{ADM70_pin()translate<0,5,+2>  }     
        object{ADM70_pin()translate<0,5,-2>  } 
        object{ADM70_pin()translate<0,5,+6>  }     
        object{ADM70_pin()translate<0,5,-6>  }                                   
        object{ADM70_pin()translate<0,5,+10> }     
        object{ADM70_pin()translate<0,5,-10> }  
        rotate<0,90,0>                                             
}          
#end 



//1N5819 schotkey diode
#macro SOD123()     
union{ 
        box{<+1.35,0,+0.9><-1.35,1.2,-0.9>texture{pigment{Black}}}              //body   
        box{<+1.35,1.2,+0.7><+1.25,1.21,-0.7>texture{pigment{White}}}             //Polarity stripe  
        box{<+1.35,-0.01,+0.25><+1.7,0.25,-0.25>texture{pigment{Silver}}}   
        box{<-1.35,-0.01,+0.25><-1.7,0.25,-0.25>texture{pigment{Silver}}} 
        
 
        text{ttf besch_font "1N5819" 0.1,0 scale<0.6,0.6,0.6> rotate<90,0,0>translate<-1.,1.21,-0.3> pigment{White} } 
}  
#end 


//Inductor
#macro SDR7045()     
union{ 
        difference{
                box{<-3.5,0,-3.5><+3.5,1,+3.5>texture{pigment{Black}}}                  //body   
                box{<-10,-1,-10><+10,+2,+10> rotate<0,45,0> translate<-10,0,-10>texture{pigment{Black}}} //clip corner   
                box{<-10,-1,-10><+10,+2,+10> rotate<0,45,0> translate<+10,0,+10>texture{pigment{Black}}} //clip corner  
        }
                 
        cylinder{<0,1,0><0,1.4,0>3.5 texture{pigment{Grey*.3}}}                 //bottom coil form
        cylinder{<0,4.1,0><0,4.5,0>3.5 texture{pigment{Grey*.3}}}               //top coil form
        cylinder{<0,1.4,0><0,4.1,0>3 texture{pigment{Copper}}}                  //coil
        box{<-3.51,0,-1><-3.4,1,+1>texture{pigment{Silver}}}                    //pin  
        box{<+3.51,0,-1><+3.4,1,+1>texture{pigment{Silver}}}                    //pin 

        text{ttf besch_font "220uH" 0.1,0 scale<1,1,1> rotate<90,0,0>translate<-1.9,4.51,-0.3> pigment{White} } 
        finish {
                ambient .2
                diffuse .6
                phong 0.75
                phong_size 25
        }          
}  
#end  

#macro MC33063(value)  
object{QFN(4,4,0.9,4,4,0,0,0.5,0.25,0.65,3.9,3.9,0.0,90,0,"TI",Grey*0.4)}
#end  


#macro HLK_RM04_pins()    
union{             
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,  0> texture{col_gold}}           //pin    
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,  2> texture{col_gold}}           //pin  
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,  4> texture{col_gold}}           //pin  
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,  6> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,  8> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, 10> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, 12> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, 14> texture{col_gold}}           //pin     
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, -2> texture{col_gold}}           //pin  
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, -4> texture{col_gold}}           //pin  
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, -6> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0, -8> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,-10> texture{col_gold}}           //pin 
        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,-12> texture{col_gold}}           //pin 
//        box{<-0.25,-4,-0.25><+0.25,+4,+0.25> translate <0,0,-14> texture{col_gold}}           //pin     
        box{<-1,0,-2*7.5><+1,+2,+2*7.5> translate <0,0, 0> texture{pigment{Black}}}      //plastic 

                                                                                                         
} 
#end     
 
  
#macro HLK_RM04() 
union{   
        union{      
                box{<-14.5,2,-20><+14.5,3.1,+20> texture{pigment{Green*0.7}}}                   //PCB       
                object{HLK_RM04_pins() translate <26.75/2,0,4.5>}                               //right pin header
                object{HLK_RM04_pins() translate <-26.75/2,0,4.5>}                              //left pin header 
                box{<+12,3.1,-19><-7.5,5.3,+19> texture{pigment{White*2}}}                      //tin can                           //tin can
                box{<-7.5,3.1,-11><-12.5,5.3,+19> texture{pigment{White*2}}}                    //tin can    
                rotate<0,-90,0>                                                                                                  
        }   
        difference{
                union{    
                        box{<0,0,0><1,1,0> texture{pigment{image_map{gif "HLK_RM04_WiFi.gif" map_type 0}}}}   
                        scale<23,37,0>   rotate<90,90,0>  translate<-18.5,5.31,11.5>
                } 
                box{<+10,5.31,-15><+19,5.5,-6> texture{pigment{White*2}}}
        }  
}

#end    

#macro UDE_RJ45()    
  object{CON_RJ45()}
#end 



#macro WSLED()    
union{  
        difference{    
                box{<-2.5,0,-2.5><+2.5,1,+2.5> texture{pigment{White*1.9}finish {phong 1}}}                           //body    
                box{<-1,0.9,-1><1,1.1,1> rotate<0,45,0> translate<+2.5,0,-2.5> texture{pigment{Grey}finish {phong 1}}}          
        }
        box{<-0.5,0,-0.5><+0.5,0.3,+0.5> translate <-2.2,0,+1.6> texture{col_gold}}           //pin   
        box{<-0.5,0,-0.5><+0.5,0.3,+0.5> translate <+2.2,0,+1.6> texture{col_gold}}           //pin                                                                                                     
        box{<-0.5,0,-0.5><+0.5,0.3,+0.5> translate <-2.2,0,-1.6> texture{col_gold}}           //pin   
        box{<-0.5,0,-0.5><+0.5,0.3,+0.5> translate <+2.2,0,-1.6> texture{col_gold}}           //pin  
        cylinder{<0,0,0><0,1.1,0>2 texture{pigment{color rgbt<0.75,0.2,0.5,0.3>} finish {phong 1}}}
        rotate<0,0,0>                                                                                                         
} 
#end  


#macro On_shore_technology_body()   
union{  
        difference{ 
                union{
                        box{<-5.08/2,0,+4.2><+5.08/2,10,-3.4> texture{pigment{Blue}}}           //body       
                        box{<-0.95/2,0,+0.1><+0.95/2,-3.5,-0.1> texture{pigment{Silver}}}       //pin
	        } 
	        box{<-4/2,+0.54,-4.21><+4/2,4.54,-3.3> texture{pigment{Blue}}}                  //wire entry 
	        cylinder{<0,+4.54/2,-4.2><0,+4.54/2,-1.0>1.5 texture{pigment{Green}}}           //wire hole 
	         
                cylinder{<0,+8.1,0><0,+10.1,0>3/2 }                                           //screw hole       
                prism {linear_sweep 0.0, 8.42, 4,<0,0>,<-2.54,0>,<0,-2.38>,<0,0>   rotate<-90,-90,0> translate<-4.21,+10.01,4.21> texture{pigment{Blue*.5}}}  //slope back
                prism {linear_sweep 0.0, 8.42, 4,<0,0>,<1.27,0>,<0,-4.92>,<0,0>   rotate<-90,-90,0> translate<-4.21,10.01,-3.41> texture{pigment{Blue*.5}}}   //slope front     
        }
        difference{ 
                 cylinder{<0,8.1,0><0,10.1,0>2.9/2  texture{pigment{Silver*.9}}}                //screw head  
                 box{<-1.45,8,+0.2><+1.45,10.11,-0.2> texture{pigment{Silver*.5}}}              //screw slot
        } 
        box{<-1,+3.4,-3.5><+1,+3.3,-1.0> texture{pigment{Silver}}}                              //top metal contact   
        box{<-1,+4.1,-3.5><+1,+3.3,-1.0> texture{pigment{Silver}}}                              //top metal contact face
        box{<-1,+1.4,-3.5><+1,+1.3,-1.0> texture{pigment{Silver}}}                              //bottom metal contact  
        box{<-1,+1.4,-3.5><+1,+0.8,-1.0> texture{pigment{Silver}}}                              //bottom metal contact face
}
#end 

#macro On_shore_technology(N)   
union{  
        #local positions= 1 ;  
        #while (positions <= N)   
                object{On_shore_technology_body() translate<positions*5.08,0,0>}  
	        #local positions = positions+1;
	#end  
}
  translate<-positions*5.08/2,0,0>      
#end   

#macro OST_3(value)              
object{On_shore_technology(3)} 		 
#end    
 
#macro OST_2(value)              
object{On_shore_technology(2)} 		 
#end   



//USB china  based on CON_USB_B_002
#macro USB_CHINA()
union{
    union{      
     // Sheet metal housing                  
    difference{      
    union{      
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,4,0)translate<-3.355,0.15,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,4,0)rotate<0,180,0>translate<3.355,0.15,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,0,1)translate<-3.85,2.15,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,0,1)rotate<0,180,0>translate<3.85,2.15,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,0,1.3)rotate<0,0,180>translate<-3.35,2.2,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,0,1.3)rotate<0,180,180>translate<3.35,2.2,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,4,0)rotate<0,0,180>translate<3.85,3.85,-4>}
          union{TOOLS_RECT_BOGEN(0.25,90,0.25,8,4,0)rotate<0,180,180>translate<-3.85,3.85,-4>}
         }     
          box { <-4.5, -0.1, -2.9>, <4.5,2.75,-9> }       
             difference{                                                                           
             cone {<-2.5,4,-4.5> , 0.75 , <-2.5,4,-1> , 0.5}
             cone {<-2.5,4,-4.5> , 0.5 , <-2.5,4,-2> , 0.25}
                }
             difference{                                                                          
             cone {<2.5,4,-4.5> , 0.75 , <2.5,4,-1> , 0.5}
             cone {<2.5,4,-4.5> , 0.5 , <2.5,4,-2> , 0.25}
                }
             difference{                                                                           
             box { <-0.75, 3, -1>, <0.75,5,-6> }      
             box { <-0.5, 3, -1>, <0.5,5,-5> }      
                }
          }
     // Solder tabs
     difference{     
     union{              
          union{TOOLS_RECT_BOGEN(0.5,90,0.25,6.5,0.5,2.5)translate<3.85,0.1,-5>}     //DNC
          union{TOOLS_RECT_BOGEN(0.5,90,0.25,6.5,0.5,2.5)rotate<0,180,0>translate<-3.85,0.1,-5>}
          }
                box { <4.01, -0.1, -3.5>, <5.1,1,-7> }            //dnc   
                box { <-4.01, -0.1, -3.5>, <-5.1,1,-7> } 
          }
          texture{col_silver}
         }
     // black contact carrier in the middle
        difference{
                box { <-2.5,1,-1>,<2.5,2,-7>} 
                box { <-0.25,1.25,0>,<0.25,1.75,-8>} 
                box { <-1.00,1.25,0>,<-0.50,1.75,-8>} 
                box { <-1.75,1.25,0>,<-1.25,1.75,-8>} 
                box { <1.00,1.25,0>,<0.50,1.75,-8>} 
                box { <1.75,1.25,0>,<1.25,1.75,-8>} 
                texture{pigment{color rgb <0.1, 0.1, 0.1>}}
                }
     // black contact support rear
         difference{
                box { <-3.75,0,-6>,<3.75,3.75,-8.5>} 
                box { <-2,1.9,-7>,<3,4,-8.6>} 
                box { <-4,3,-8>,<4,4,-8.6>} 
                box { <-3,-0.1,-7.5>,<3,4,-8.6>} 
                box { <-0.25,-0.1,0>,<0.25,2,-8.6>} 
                box { <-1.00,-0.1,0>,<-0.50,2,-8.6>} 
                box { <-1.75,-0.1,0>,<-1.25,2,-8.6>} 
                box { <1.00,-0.1,0>,<0.50,2,-8.6>} 
                box { <1.75,-0.1,0>,<1.25,2,-8.6>} 
                texture{pigment{color rgb <0.1, 0.1, 0.1>}}
                }                
        // Contacts
                difference{
                union{
                      union{TOOLS_RECT_BOGEN(0.25,90,0.25,3.5,1,0.65)rotate<0,90,0>translate<0,0.125,-7.3>}
                      union{TOOLS_RECT_BOGEN(0.25,90,0.25,3.5,0,0)rotate<180,270,0>translate<0,1.5,-7.3>}
                      box { <-0.25,1.5,-1>,<0.25,1.75,-7>rotate<7,0,0>} 
                      box { <-1.00,1.5,-1>,<-0.50,1.75,-7>rotate<7,0,0>} 
                      box { <-1.25,1.5,-1>,<-1.75,1.75,-7>rotate<7,0,0>} 
                      box { <1.00,1.5,-1>,<0.50,1.75,-7>rotate<7,0,0>} 
                      box { <1.25,1.5,-1>,<1.75,1.75,-7>rotate<7,0,0>} 
                     }   
                box { <-0.5,-0.1,-7>,<-0.25,1.25,-9.5>}      
                box { <0.5,-0.1,-7>,<0.25,1.25,-9.5>}      
                box { <-1.0,-0.1,-7>,<-1.25,1.25,-9.5>}      
                box { <1.0,-0.1,-7>,<1.25,1.25,-9.5>}      
                texture{col_silver}
                }
        // Sticker
                union{
                box{<-3.2,3.9,-0.5><3.2,4.05,-7>}
                pigment{color rgbf <1, 0, 0, 0.9>}
               }
}
#end 




//     Sharp GP1UX31QS detector
#macro IR_DETECTOR()  
union{        
        union{
                box{<-2.25,1.3,-1.6><+2.25,8.8,+1.6>}                //body  
                sphere{<0,6,-1.>2}                   
                texture{
                        pigment{Gray30}	
                        finish {phong 1}
                }  
        }   
        
        union{
                box{<-2.74,-4,+0.2><-2.34,0,-0.2>} 
                box{<-2.74,0,+0.2><-0.54,1,-0.2>}  
                box{<-0.74,0,+0.2><-0.54,1.3,-0.2>}       
                
                
                box{<-0.2,-4,+0.2><+0.2,1.3,-0.2>} 
                
                
                box{<+2.74,-4,+0.2><+2.34,0,-0.2>} 
                box{<+2.74,0,+0.2><+0.54,1,-0.2>}  
                box{<+0.74,0,+0.2><+0.54,1.3,-0.2>}  
                texture{Polished_Chrome
                        pigment{color rgb<1,0.85,0>}
                        finish {phong 1}
                }  
        }  
        rotate<0,180,0>
       
}       
#end



 //Side Sitch Tyco Electronics TE825232 
#macro TE825232()   
union{   
        union{       
        box{<+4.3,0,+0.47><+4.2,-2.77,-0.47>}                           //left mounting tab     
        box{<-4.3,0,+0.47><-4.2,-2.77,-0.47>}                           //right mounting tab
        difference{
                Round_Box(<-4.3,-2.0,-2.15><+4.3,+3.5,+2.15>, 0.5, 0)   //body
                box{<-4.31,-2.1,-2.16><+4.31,0,+2.16>}                  //clip bottom of body
                Round_Box(<-4.2,-1.9,-2.05><+4.2,+3.4,+2.05>, 0.5, 0)   //hollow inside body
                box{<-2,0.5,+3><+2,2.5,0>}                              //switch slot
        }
        texture{ Polished_Chrome
                pigment{ color rgb<1,0.85,0>}
                finish { phong 1}
        } 
        }           
        object{SideSwitchpin()translate<+2,0,0>}                        //pins
        object{SideSwitchpin()translate<0,0,0>}                         //pins
        object{SideSwitchpin()translate<-2,0,0>}                        //pins
        box{<-2,0.6,5.3><0,2.4,0>}                                      //switch       
        union{ 
                difference{
                Round_Box(<-4.2,-3,-2.05><+4.2,+3,+2.05>, 0.5, 0)       //PCB
                box{<-4.21,0.1,-2.06><+4.21,-4,+2.06>}                  //clip bottom of PCB   
                box{<-4.21,0.5,-2.06><+4.21,+4,+2.06>}                  //clip top of PCB
                }  
                texture{ 
                        pigment{ color DarkGreen}
                        finish { phong 1}
        }
}
        
       
}  rotate<0,180,0>  
#end             

   
#macro SideSwitchpin()
union{
        union{
                box{<0.25,0,0.1><-0.25,-2.15,-0.1> }
                cylinder{<0,-2.15,-0.1><0,-2.15,+0.1> 0.25}
        } 
        texture{ Polished_Chrome
                pigment{ color rgb<1,1,.8>}
                finish { phong 1}
        }
}
   
#end     



//MURS120 schotkey diode
#macro DO214()     
union{ 
        box{<+2.16,0,+1.8><-2.16,2.3,-1.8>texture{pigment{Black}}}              //body   
        box{<+1.0,2.3,+1.8><+1.7,2.31,-1.8>texture{pigment{White}}}             //Polarity stripe
        difference{
                box{<+2.7,-0.1,+1.0><+2.16,1.5,-1.0>texture{pigment{Silver}}} 
                box{<+2.6,+0.1,+1.1><+2,1.4,-1.1>texture{pigment{Silver}}}
        }    
        difference{
                box{<-2.7,-0.1,+1.0><-2.16,1.5,-1.0>texture{pigment{Silver}}} 
                box{<-2.6,+0.1,+1.1><-2,1.4,-1.1>texture{pigment{Silver}}}
        }
        text{ttf besch_font "MURS120" 0.1,0 scale<0.6,0.6,0.6> rotate<90,0,0>translate<-1.9,2.31,-0.3> pigment{White} } 
}  
#end      
 
//AVX tantalum capacitor 
#macro EIA2917(value)     
union{ 
        box{<+3.65,0,+2.15><-3.65,2.9,-2.15>texture{pigment{DarkWood}}}              //body   
        box{<+2.65,2.91,+2.15><+3.65,2.9,-2.15>texture{pigment{DarkWood*.4}}}        //Polarity stripe
        difference{
                box{<+3.65,0,+1.2><+3.651,+1.2,-1.2>texture{pigment{Silver}}} 
                box{<+3.6,+0.8,+0.7><+3.67,+1.3,-0.7>texture{pigment{Red}}}
        }   
        difference{
                box{<-3.65,0,+1.2><-3.651,+1.2,-1.2>texture{pigment{Silver}}} 
                box{<-3.6,+0.8,+0.7><-3.67,+1.3,-0.7>texture{pigment{Red}}}
        }     
        text{ttf besch_font value 0.1,0 scale<1.5,1.5,1.5> rotate<90,0,0>translate<-2.8,2.91,-0.5> pigment{DarkWood*.4} }
}
#end       
            
//Inductor 
#macro PM3316()     
union{ 
        cylinder{<0,0,0><0,1,0>5 texture{pigment{Black}}}  
        cylinder{<0,1,0><0,1.5,0>3.8 texture{pigment{Black+1.5}}}   
        cylinder{<0,4,0><0,5,0>3.8 texture{pigment{Black}}} 
        cylinder{<0,1.5,0><0,4,0>3.5 texture{pigment{Copper}}}
        prism {linear_sweep 0, 1.0, 5,
                <-1,-4.9><-1,+4.9><-6.35,+2.5><-6.35,-2.5><-1,-4.9>  
                 pigment { Black*.4 }
                 finish {
                        ambient .2
                        diffuse .6
                        phong 0.75
                        phong_size 25
                 }   
        }    
        prism {linear_sweep 0, 1.0, 5,
                 <1,-4.9><1,+4.9><+6.35,+2.5><+6.35,-2.5><1,-4.9>  
                 pigment { Black*.4 }
                 finish {
                        ambient .2
                        diffuse .6
                        phong 0.75
                        phong_size 25
                 }   
        }
        box{<+3.95,0,+1.25><+6.35,1.1,-1.25>texture{pigment{Silver}}}  
        box{<-3.95,0,+1.25><-6.35,1.1,-1.25>texture{pigment{Silver}}}      
        text{ttf besch_font"." 0.1,0 scale<5,5,5> rotate<90,-90,0>translate<-2,5.1,-0.5> pigment{White} } 
	text{ttf besch_font"101" 0.1,0 scale<2,2,2> rotate<90,-90,0>translate<-0.3,5.1,-1.5> pigment{White} }		
}
#end


//_____________________________________________________________ 
//P2950 Linear regulator   
//Macro for SMD IC's with pins on 2-sides 
//LK = length of plastic (side with the pins)
//BK = width of plastic (side without the pins) 
//HK = height of plastic
//B = length of the side without pins over all 
//pin_u = pin on the lower side 
//pin_o = pin on the upper side 
//ptch_u = pitch of the pins on the lower side 
//ptch_o = pitch of the pins on the upper side 
//pinb_u = width of the pins up the lower side 
//pinb_o = width of the pins on the upper side 
//pin_s = thickness of the pin material 
//di_pcb = distance of plastic to the PCB 
//kor_w = correction angle 
//pin0_m = Pin-1-Marking: 0 = none, 1 = dot, 2 = notch as if with DIP, 3 = PowerSO, 4 = DPAK 
//pin0_45 =! = 0 at the lower side an angle at the body of 45 is used instead of 10 (SO) 
//pin0_a = distance of the Pin0-marking from the edge 
//besch_s = Scale factor of the inscription 
//besch_w = if! = 0 inscription turned 
//logo = name of the logo
#macro PFM3(value)
//object{IC_SMD_GRND(6.58,6.1,2.3,9.91,2,1,4.57,0,0.76,5.36,0.74,0.1,0,4,0,1.5,1.0,0,"TI")} 
object{IC_SMD_DNC(6.58,6.1,2.3,9.91,2,1,4.57,0,0.76,5.36,0.74,0.1,0,4,0,1.5,1.0,0,"TI")}
#end


#macro HV14M_pin()     
union{
        union{ 
                box{<-0.32,0,0><+0.32,0.64,+2.44>texture{pigment{Silver}}}              //pad         
                box{<-0.32,0.32,-0.32><+0.32,+9.73,+0.32>texture{pigment{Gold}}}        //pin  
                cylinder{<-0.32,+0.32,0><+0.32,+0.32,0>0.32 texture{pigment{Gold}}}
                translate<0,0,+1.27> 
        }  

        union{ 
                box{<-0.32,0,0><+0.32,0.64,+2.44>texture{pigment{Silver}}}              //pad         
                box{<-0.32,0.32,-0.32><+0.32,+9.73,+0.32>texture{pigment{Gold}}}        //pin  
                cylinder{<-0.32,+0.32,0><+0.32,+0.32,0>0.32 texture{pigment{Gold}}}
                rotate<0,180,0>translate<0,0,-1.27>     
        } 
        difference{    
                prism {linear_sweep 1.6, 3.89, 9,
                        <-1.27,+1.27><-1,+2.44>,<+1,+2.44>,<+1.27,+1.27>,<+1.27,-1.27>,<+1,-2.44>,<-1,-2.44>,<-1.27,-1.27>,<-1.27,+1.27>   
                        pigment { Black*.4 }
                        finish {
                                ambient .2
                                diffuse .6
                                phong 0.75
                                phong_size 25
                        }   
                }  
                cylinder{<-1.27,+3.89,-5><-1.27,+3.89,+5>0.3}   
                cylinder{<+1.27,+3.89,-5><+1.27,+3.89,+5>0.3}        
        }     
}
#end           
                
#macro HV14M()      
union{  
     object{HV14M_pin() translate<0,0,0>}  
     object{HV14M_pin() translate<+2.54*1,0,0>}  
     object{HV14M_pin() translate<-2.54*1,0,0>} 
     object{HV14M_pin() translate<+2.54*2,0,0>}  
     object{HV14M_pin() translate<-2.54*2,0,0>} 
     object{HV14M_pin() translate<+2.54*3,0,0>}  
     object{HV14M_pin() translate<-2.54*3,0,0>}              
}    
#end    


#macro H655_53AB_fin()      
union{   
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<0,+3.37,0>} 
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<+0.966*4,+3.37,0>}
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<+0.966*8,+3.37,0>}
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<+0.966*12,+3.37,0>}  
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<+0.966*16,+3.37,0>}  
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<+0.966*20,+3.37,0>} 
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<-0.966*4,+3.37,0>}
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<-0.966*8,+3.37,0>}
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<-0.966*12,+3.37,0>}  
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<-0.966*16,+3.37,0>}  
        prism {linear_sweep -0.966, +0.966, 5, <-0.966,0>, <+0.966,0>, <+0.8,13.3>,<-0.8,13.3>,<-0.966,0>rotate<-90,0,0>translate<-0.966*20,+3.37,0>} 
}
#end          
                
#macro H655_53AB()      
union{          
        box{<-20.3,+3.37,-20.3> <+20.3,0,+20.3>}      
        object{H655_53AB_fin()translate<0,0,0>} 
        object{H655_53AB_fin()translate<0,0,+0.966*4>}  
        object{H655_53AB_fin()translate<0,0,+0.966*8>}  
        object{H655_53AB_fin()translate<0,0,+0.966*12>}
        object{H655_53AB_fin()translate<0,0,+0.966*16>} 
        object{H655_53AB_fin()translate<0,0,+0.966*20>}  
        object{H655_53AB_fin()translate<0,0,-0.966*4>} 
        object{H655_53AB_fin()translate<0,0,-0.966*4>}  
        object{H655_53AB_fin()translate<0,0,-0.966*8>}  
        object{H655_53AB_fin()translate<0,0,-0.966*12>}
        object{H655_53AB_fin()translate<0,0,-0.966*16>} 
        object{H655_53AB_fin()translate<0,0,-0.966*20>} 

        
pigment { Black }
        finish {
           ambient .2
           diffuse .6
           phong .75
           phong_size 25
        }     
}    
#end 

#macro HV14_pin()
union{ 
        box{<0,0,0.35><+0.5,0.15,-0.35>rotate<0,0,+45>translate<3.325,0,0>}        //right          
        box{<0,0,0.35><-2,0.15,-0.35>translate<3.325,0,0>}
        
        box{<0,0,0.35><-0.5,0.15,-0.35>rotate<0,0,-45>translate<-3.325,0,0>}       //left
        box{<0,0,0.35><+2,0.15,-0.35>translate<-3.325,0,0>}

rotate<0,90,0>
texture{pigment{Gold}}
}
#end             
                
#macro HV14()      
union{  
        difference{        
                box{<-8.79,0,-5.06/2><+8.79,+6.2,+5.06/2> }                     //body   
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<0,0,+5.06/4>}         //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<0,0,-5.06/4>}         //pin      
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+5.06/2,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+5.06/2,0,-5.06/4>}   //pin      
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-5.06/2,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-5.06/2,0,-5.06/4>}   //pin 
                
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+5.06,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+5.06,0,-5.06/4>}   //pin      
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-5.06,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-5.06,0,-5.06/4>}   //pin    
                
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+7.59,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<+7.59,0,-5.06/4>}   //pin      
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-7.59,0,+5.06/4>}   //pin  
                box{<-0.5,0,-0.5><+0.5,+7,+0.5> translate<-7.59,0,-5.06/4>}   //pin 
        }  
        
        object{HV14_pin() translate<0,0,0>}
        object{HV14_pin() translate<+1*2.54,0,0>}  
        object{HV14_pin() translate<-1*2.54,0,0>}
        object{HV14_pin() translate<+2*2.54,0,0>}  
        object{HV14_pin() translate<-2*2.54,0,0>}      
        object{HV14_pin() translate<+3*2.54,0,0>}  
        object{HV14_pin() translate<-3*2.54,0,0>}
texture{pigment{White*1.7}}     
}    
#end  



#macro HPI_2mm_pin()
union{ 
        box{<-0.5,2.85,0.47><+0.5,+3.6,+5.1>}        //pin
        cylinder{<-0.5,3.1,5.1><+0.5,3.1,5.1>0.5 }
        box{<-0.5,3.1,4.6><+0.5,+0.5,+5.6>}        //pin vertical
        cylinder{<-0.5,+0.5,5.1><+0.5,+0.5,5.1>0.5 }  
        box{<-0.5,1,5.1><+0.5,0,+8.6>}              //pin pad 
        texture{pigment{Gold}}
}
#end             
                
#macro HPI_2MM()      
union{
    difference{           
	box{<-5.7,0,0><+5.7,+5.5,+7.6> }        //body  
	box{<-4.45,+0.7,-0.1><+4.45,+4.3,+4>}   //cavity
	box{<-2,+0.7,-0.1><+2,+5,+4>}           //tab   
	box{<-6,+3.1,-0.1><+6,+4.1,+1>}         //side cuts  
	box{<-4.45,-0.1,+5.1><+4.45,+6,+7.7>}   //cut at back
    }  
    object{HPI_2mm_pin() translate<-1,0,0>}
    object{HPI_2mm_pin() translate<+1,0,0>}     
    object{HPI_2mm_pin() translate<-3,0,0>}
    object{HPI_2mm_pin() translate<+3,0,0>}
texture{pigment{White*1.7}}     
rotate<0,180,0>  translate<0,0,+7.6>
}    
#end             


#macro fin()     
union{
        box{<-59/2,0,-1.2/2/2><+59/2,11.5,+1.2/2>}  
        box{<-61/2,0,-1.2/2/2><+61/2,10.5,+1.2/2>}     
        cylinder{<-59/2,10.5,-1.2/2/2><-59/2,10.5,+1.2/2/2>1}   
        cylinder{<+59/2,10.5,-1.2/2/2><+59/2,10.5,+1.2/2/2>1} 
        pigment { Black }
        finish {
           ambient .2
           diffuse .6
           phong .75
           phong_size 25
        }
}   
#end                     

#macro VHS_45()
union{    
        difference{
                box{<-61/2,0,-57.5/2><+61/2,2,57.5/2>}   
                cylinder{<-51/2,-1,-48.1/2><-51/2,3,-48.1/2>2}    
                cylinder{<+51/2,-1,-48.1/2><+51/2,3,-48.1/2>2} 
                cylinder{<-51/2,-1,+48.1/2><-51/2,3,+48.1/2>2}    
                cylinder{<+51/2,-1,+48.1/2><+51/2,3,+48.1/2>2}
        }  
        object{fin() translate<0,0,0>} 
        object{fin() translate<0,0,+1*3.28>}   
        object{fin() translate<0,0,-1*3.28>}  
        object{fin() translate<0,0,+2*3.28>}   
        object{fin() translate<0,0,-2*3.28>}   
        object{fin() translate<0,0,+3*3.28>}   
        object{fin() translate<0,0,-3*3.28>} 
        object{fin() translate<0,0,+4*3.28>}   
        object{fin() translate<0,0,-4*3.28>}
        object{fin() translate<0,0,+5*3.28>}   
        object{fin() translate<0,0,-5*3.28>} 
        object{fin() translate<0,0,+6*3.28>}   
        object{fin() translate<0,0,-6*3.28>}  
        object{fin() translate<0,0,+8*3.28+3.28/2>}   
        object{fin() translate<0,0,-8*3.28-3.28/2>} 
        pigment { Black }
        finish {
           ambient .2
           diffuse .6
           phong .75
           phong_size 25
        } 
}
#end





#declare global_fontfile_NXP = "NXP.ttf"

#macro DRV8818(value)  
object{IC_SMD_DNC(10.2,5.3,1.7,7.7,14,14,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.95,0,"TI")}
#end       

#macro DRV8825(value)  
object{IC_SMD_DNC(10.2,5.3,1.7,7.7,14,14,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.95,0,"TI")}
#end   

#macro FT230X(value)  
object{IC_SMD_DNC(5.08,3.937,2.35,4.06,8,8,0.635,0.635,0.4,0.4,0.27,0.2,0,1,1,3.937/6,0.5,0,"FTDI")}
#end     

#macro ADU4160(value)  
object{IC_SMD_DNC(10.3,7.5,2.35,10.3,8,8,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,"ANALOG")}
#end    

#macro LPC1347(value)  
object{QFN(7,7,0.9,8,8,8,8,0.5,0.25,0.65,6.9,6.9,0.0,90,0,"ST",Grey*0.4)}
#end        

#macro SOT23_BAT54C(value)   
object{IC_SMD_DNC(2.9,1.3,1,2.8,2,1,1.9,1.9,0.45,0.45,0.13,0.1,0,0,0,1.5,0.7,0,"")}
#end     

#macro SOT23_BEC(value)   
object{IC_SMD_DNC(2.9,1.3,1,2.8,2,1,1.9,1.9,0.45,0.45,0.13,0.1,0,0,0,1.5,0.7,0,"")}
#end                                         

#macro SOT89_78L(value)   
object{IC_SMD_DNC(4.6,2.6,1.6,4.25,3,1,1.57,1.83,0.44,0.1,0.2,0.15,0,1,0,0.3,0,0,"")}  
#end                              

/********************************************************************************************************************************************
//Makro fuer SMD-IC's die Pins nur auf 2-Seiten haben(SO, TSOP, TSSOP usw.)
//ueberarbeitet von Tilmann Reh <tilmann.reh(replace with at)autometer.de>
//erweitert fuer DPAK Friedrich Bleikamp <fbleikamp(replace with at)web.de>
//LK      = Laenge des Kunststoff(Seite der Pins)
//BK      = Breite des Kunststoff(Seite ohne Pins)
//HK      = Hoehe des Kunststoff
//B       = Laenge der Seite ohne Pins ueber alles
//pin_u   = Pins auf der "unteren" Seite
//pin_o   = Pins auf der "oberen" Seite
//ptch_u  = Pitch der Pins auf der "unteren" Seite
//ptch_o  = Pitch der Pins auf der "oberen" Seite
//pinb_u  = Breite der Pins auf der "unteren" Seite
//pinb_o  = Breite der Pins auf der  "oberen" Seite
//pin_s   = Staerke des Pinmaterials
//di_pcb  = Abstand des Kunststoff zur Platine
//kor_w   = Korrekturwinkel
//pin0_m  = Pin-1-Markierung: 0 = keine, 1 = Farbklecks, 2 = Kerbe wie bei DIP, 3 = PowerSO, 4 = DPAK
//pin0_45 = Wenn != 0 wird an der unteren Seite ein Winkel am Koerper von 45 statt 10 verwendet (SO)
//pin0_a  = Abstand des Pin0-Kennzeichners vom Rand
//besch_s = Scalefaktor der Beschriftung
//besch_w = Wenn != 0 wird Beschriftung gedreht
//logo  = Name of the logo

//Macro for SMD IC's with pins on 2-sides 
//LK = length of plastic (side with the pins)
//BK = width of plastic (side without the pins) 
//HK = height of plastic
//B = length of the side without pins over all 
//pin_u = pin on the lower side 
//pin_o = pin on the upper side 
//ptch_u = pitch of the pins on the lower side 
//ptch_o = pitch of the pins on the upper side 
//pinb_u = width of the pins up the lower side 
//pinb_o = width of the pins on the upper side 
//pin_s = thickness of the pin material 
//di_pcb = distance of plastic to the PCB 
//kor_w = correction angle 
//pin0_m = Pin-1-Marking: 0 = none, 1 = dot, 2 = notch as if with DIP, 3 = PowerSO, 4 = DPAK 
//pin0_45 =! = 0 at the lower side an angle at the body of 45 is used instead of 10 (SO) 
//pin0_a = distance of the Pin0-marking from the edge 
//besch_s = Scale factor of the inscription 
//besch_w = if! = 0 inscription turned 
//logo = name of the logo
********************************************************************************************************************************************/
#macro IC_SMD_DNC(LK,BK,HK,B,pin_u,pin_o,ptch_u,ptch_o,pinb_u,pinb_o,pin_s,di_pcb,kor_w,pin0_m,pin0_45,pin0_a,besch_s,besch_w,logo)
union{
	difference{
		box{<LK/2,di_pcb,BK/2><-LK/2,di_pcb+HK,-BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,-HK,1>  rotate<10,0,0> translate<0,(di_pcb+HK)/2-pin_s/2,BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,-HK,-1>  rotate<-10,0,0> translate<0,(di_pcb+HK)/2-pin_s/2,-BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,HK,1>  rotate<-10,0,0> translate<0,(di_pcb+HK)/2+pin_s/2,BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,HK,-1>  rotate<10,0,0> translate<0,(di_pcb+HK)/2+pin_s/2,-BK/2>}
		#if(pin0_45!=0)
			box{<LK/2+0.01,0,0><-LK/2-0.1,HK,-1>  rotate<45,0,0> translate<0,(di_pcb+HK)/2+pin_s/2+pin_s*1.5,-BK/2>}
		#end
		box{<0,0,-BK/2-0.1><1,HK,BK/2+0.1>  rotate<0,0,10> translate<LK/2,(di_pcb+HK)/2+pin_s/2,0>}
		box{<0,0,-BK/2-0.1><-1,HK,BK/2+0.1>  rotate<0,0,-10> translate<-LK/2,(di_pcb+HK)/2+pin_s/2,0>}
		box{<0,0,-BK/2-0.1><1,-HK,BK/2+0.1>  rotate<0,0,-10> translate<LK/2,(di_pcb+HK)/2-pin_s/2,0>}
		box{<0,0,-BK/2-0.1><-1,-HK,BK/2+0.1>  rotate<0,0,10> translate<-LK/2,(di_pcb+HK)/2-pin_s/2,0>}
		#if(pin0_m = 0) 
			#local TextX = -LK/2+0.1*LK; 
		#end // ohne Pin-1-Markierung
		#if(pin0_m = 1)  // SO-Farbmarkierung
			#local TextX = -LK/2+0.1*LK;
			#if((((pin_u-1)/2*ptch_u)+0.3)>LK/2) 
				#local i = -(pin_u-1)/2*ptch_u+0.3;
			#else 
				#local i = -(pin_u-1)/2*ptch_u; 
			#end
			sphere{<i,HK+di_pcb+0.1,-BK/2+pin0_a>0.15 pigment{White}}
		#end
		#if(pin0_m = 2)  // VSO-Kerbe
			#local TextX = -LK/2+0.15*LK;
			cylinder{<-LK/2,di_pcb+0.7*HK,0><-LK/2,di_pcb+HK+0.1,0> 1}
		#end
		#if(pin0_m = 3)  // PSO-Kerben und Fase (vereinfacht rechteckig)
			#local TextX = -LK/2+0.25*LK;
			box{<3,di_pcb-0.1,-3> <-3,HK+di_pcb+0.1,0> rotate<0,45,0> translate<1-LK/2,0,1-BK/2>}
			box{<0,di_pcb-0.1,-1.45> <-2,HK+di_pcb+0.1,1.45> translate<1.45-LK/2,0,0>}
			box{<0,di_pcb-0.1,-1.45> <2,HK+di_pcb+0.1,1.45> translate<-1.45+LK/2,0,0>}
		#end
		
		#if(pin0_m = 4) // fuer DPAK ohne Pin-1-Markierung
			#local TextX = -LK/2+0.15*LK; 
		#end 
	}
	#if(pin0_m = 3)  // PSO-Metallboden (vereinfacht, da der Rest sowieso unsichtbar bleibt)
		box{<-LK/2,0,-1.5> <LK/2,1,1.5> texture{col_silver}}
	#end

	#if(pin0_m = 4)  // DPAK-SEATING PLANE & BLIND PIN
	        box{<-pinb_u/2,(HK+di_pcb)/2+pin_s/2,-(BK/2+1)> <pinb_u/2,(HK+di_pcb)/2-pin_s/2,-(BK/2-0.1)> texture{col_silver}}
	        box{<-0.57,0,-5.25> <0.57,0.5,-4.5> translate<ptch_u/2,0,0> texture{col_silver}} 
	        box{<-0.57,0,-5.25> <0.57,0.5,-4.5> translate<-ptch_u/2,0,0> texture{col_silver}} 
	        difference{
		        box{<-2.5,0,-0.85> <2.5,0.55,4.5>} 
		        box{<-0.5,-0.1,-0.5> <0.5,1.1,0.5> rotate <0,45,0> translate<-2.5,0,4.5>}
		        box{<-0.5,-0.1,-0.5> <0.5,0.6,0.5> rotate <0,45,0> translate<2.5,0,4.5>}
		        texture{col_silver}
		        }
	#end
		
	#local i=0;
	#while(i<(pin_u/2))
		#if((pin_u/2)=div(pin_u,2))
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<ptch_u*i+ptch_u/2,0,-BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<-ptch_u*i-ptch_u/2,0,-BK/2>}
		#else
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<ptch_u*i,0,-BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<-ptch_u*i,0,-BK/2>}
		#end
		#local i=i+1;
	#end
	
	#local i=0;
	#while(i<(pin_o/2))
		#if((pin_o/2)=div(pin_o,2))
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<ptch_o*i+ptch_o/2,0,BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<-ptch_o*i-ptch_o/2,0,BK/2>}
		#else
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<ptch_o*i,0,BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<-ptch_o*i,0,BK/2>}
		#end
	#local i=i+1;
	#end
		
	#local scl_fa = BK/10;
	#local value_arial_size_min = 0.0;
	#local value_arial_size_max = 0.0;
	#local value_arial_size = 0.0;
	#local value_courier_size_min = 0.0;
	#local value_courier_size_max = 0.0;
	#local value_courier_size = 0.0;
	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_courier_bold = text{ttf global_fontfile_courier_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_arial_bold, value_arial_size_min, value_arial_size_max)
	Extents(value_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_arial_size = value_arial_size_max - value_arial_size_min; 
	#local value_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_scale_factor_arial = LK/value_arial_size.z * 0.7;
	#local value_scale_factor_courier = LK/value_courier_size.z * 0.7;	
	
	#if(value_arial_size.x*value_scale_factor_arial > LK/6.0) 
                #local value_scale_factor_arial = LK/6.0 / value_arial_size.x;	
	#end
	#if(value_courier_size.x*value_scale_factor_courier > LK/6.0) 
                #local value_scale_factor_courier = LK/6.0 / value_courier_size.x;
                //#error "fuck"	
	#end
		
	#local value_arial_size = value_arial_size * value_scale_factor_arial; 
	#local value_courier_size = value_courier_size * value_scale_factor_courier;
	//a random datecode string
	#local value_datecode_arial_size_min = 0.0;
	#local value_datecode_arial_size_max = 0.0;
	#local value_datecode_arial_size = 0.0;
	#local value_datecode_courier_size_min = 0.0;
	#local value_datecode_courier_size_max = 0.0;
	#local value_datecode_courier_size = 0.0;
	#local value_datecode_string = concat(str(rand(global_seed)*52.9, -2, 0),str(rand(global_seed)*3.9+2, -2, 0));	
	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_courier_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_datecode_arial_bold, value_datecode_arial_size_min, value_datecode_arial_size_max)
	Extents(value_datecode_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_datecode_arial_size = value_datecode_arial_size_max - value_datecode_arial_size_min; 
	#local value_datecode_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_datecode_scale_factor_arial = value_scale_factor_arial;
	#local value_datecode_scale_factor_courier = value_scale_factor_courier;
	#local value_datecode_arial_size = value_datecode_arial_size * value_scale_factor_arial; 
	#local value_datecode_courier_size = value_datecode_courier_size * value_scale_factor_courier;
	
		
	#local logo_assigned = 0;
		
	#if(strcmp(logo,"PHILIPS")=0.0)
	        #local logo_assigned = 1;
	        #local label = union{
	            text{ttf global_fontfile_eagle3d "p" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
	            text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
	            translate<0,HK+di_pcb+0.001,0>
	            pigment{Gray60}
	        }
     #end   
     
     #if(strcmp(logo,"NXP")=0.0)
	        #local logo_assigned = 1;
	        #local label = union{
	            text{ttf global_fontfile_NXP "A" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/2.5,0,-BK/3>}		
	            text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,value_arial_size.x/2>}
	            translate<0,HK+di_pcb+0.001,0>
	            pigment{Gray60}
	        }
    #end     
        
     #if(strcmp(logo,"ST")=0.0)
	        #local logo_assigned = 1;
	        #local label = union{
	            text{ttf global_fontfile_eagle3d "s" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/2.5,0,-BK/3>}		
	            text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,value_arial_size.x/2>}
	            translate<0,HK+di_pcb+0.001,0>
	            pigment{Gray60}
	        }
    #end
    
    #if(strcmp(logo,"ATMEL")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "a" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end
	 
  	#if(strcmp(logo,"FTDI")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "f" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end        
  	
  	#if(strcmp(logo,"XILINX")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "#" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end         	
  	
  	
  	#if(strcmp(logo,"MICROCHIP")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "m" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end   	
  	
  	
  	#if(strcmp(logo,"CYPRESS")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "}" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end   
  	
 
   	#if(strcmp(logo,"TI")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "t" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end   	
  
     	#if(strcmp(logo,"ANALOG")=0.0)
  		#local logo_assigned = 1;
  		#local label = union{
			text{ttf global_fontfile_eagle3d "3" 0.2,0 scale<besch_s*2,besch_s*2,1> rotate<90,0,0> translate<-LK/3,0,0>}		
			text{ttf global_fontfile_arial value 0.2,0 rotate<90,0,0> scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<-value_arial_size.z/2,0,-value_arial_size.x/2-BK/6>}
			translate<0,HK+di_pcb+0.001,0>
			pigment{Gray60}
  		}
  	#end   			
  	
	
	#if(logo_assigned < 0.5)
		#local label = text{ttf besch_font value 0.2,0 rotate<90,0,0> scale<besch_s,1,besch_s> translate<TextX,HK+di_pcb+0.01,-besch_s/2> pigment{Gray60} }
	#end
	
	
	#if(besch_w=0)
		//text{ttf besch_font value 0.2,0 rotate<90,0,0> scale<besch_s,1,besch_s> translate<TextX,HK+di_pcb+0.01,-besch_s/2> pigment{Gray60} }
		object{label}
	#else
		//text{ttf besch_font value 0.2,0 rotate<90,270,0> scale<besch_s,1,besch_s> translate<0,HK+di_pcb+0.01,-BK/2+BK/15> pigment{Gray60} }
		object{label rotate<0,270,0>}
	#end
	rotate<0,kor_w,0>
	pigment{Gray20}
}
#end

//****************************************************************************************
//2x14 Box header (grey)
//****************************************************************************************
                       
#macro BUTTON(value)
object{CON_DIS_WS_XX_G_GRND(26)  translate<0,+2.5,0>  rotate -180*y}
#end   

#macro RPI(value)
object{CON_DIS_WS_XX_G_GRND(26)  translate<0,+2.5,0>  rotate<180,180,0>}
#end  

//****************************************************************************************
// 1x6 female connector 2.54mm 
//****************************************************************************************
#macro PICKIT3()  
object{BL_1X6()}
rotate<0,180,0> 
#end    

#macro PICKIT_SERIAL()  
object{BL_1X6()}
rotate<0,180,0> 
#end  


//****************************************************************************************
// Mill Max spring loaded connector pin 7.49mm total 1.4mm action 
// Part #0907-2-15-20-75-14-11-0
// Digi-Key #ED5065-ND
//****************************************************************************************       
#macro MILL_MAX_907_2()                                              
union{    
        cylinder{<0,0,0><0,5.03,0>1.5/2 texture{pigment{Brass} finish {phong 1}}}       //upper body        
        cylinder{<0,0,0><0,1.12,0>1.63/2 texture{pigment{Brass} finish {phong 1}}}      //PCB stop    
        cylinder{<0,0,0><0,0.41,0>1.83/2 texture{pigment{Brass} finish {phong 1}}}      //bottom  
         
        cylinder{<0,0,0><0,7.49-(1.07/2),0>1.07/2 texture{pigment{Brass} finish {phong 1}}}       //max pin   
        sphere{<0,7.49-(1.07/2),0>1.07/2 texture{pigment{Brass} finish {phong 1}}}        
}          
rotate<180,0,0>  translate<0,-2.69,0> 
#end


#macro FLEX44_PRG_METRIC()
union{
        object{MILL_MAX_907_2() translate<-13,0,+8>}    
        object{MILL_MAX_907_2() translate<-14.5,0,0>}      
        object{MILL_MAX_907_2() translate<-12.5,0,-8>}    
        object{MILL_MAX_907_2() translate<+13,0,+8>} 
        object{MILL_MAX_907_2() translate<+13,0,-8>}    
        object{MILL_MAX_907_2() translate<+14.5,0,0>} 
       

}
translate<0,+1.6,0>
#end

 //90 degree Molex connector
 #macro MOLEX1X4RTpin()  
union{  
        union{ 
        prism {linear_sweep 0, 0.025*25.4, 7,
                <-0.03*25.4,+0.2225*25.4>, <+0.03*25.4,+0.2225*25.4>, <+0.03*25.4,-0.1*25.4>,<+0.015*25.4,-0.14*25.5>,<-0.015*25.4,-0.14*25.4>,<-0.03*25.4,-0.1*25.4>,<-0.03*25.4,+0.2225*25.4> 
                }texture{pigment{Silver}} rotate<-90,0,0> translate<0,0,0>
        } 
        cylinder{<0,+0.2225*25.4,-0.025*25.4><0,+0.2225*25.4,0.45*25.4>0.03*25.4  texture{pigment{Silver}}} 
        sphere{<0,+0.2225*25.4,0.45*25.4>0.03*25.4 texture{pigment{Silver}}} 
}   
#end     
  
 
#macro MOLEX1X4RT()      
union{
    difference{           
        union{
	        box{<-0.458*25.4,0,0><+0.458*25.4,0.34*25.45,+0.484*25.4> texture{pigment{White*1.1}}}    
	        box{<-0.5*25.4,0.1225*25.4,0><+0.5*25.4,0.2225*25.4,+0.05*25.4> texture{pigment{White*1.1}}} 

	} 
	union{
	        prism {linear_sweep 0.7*25.4, 0.03*25.4,  7,
                <-0.428*25.4,0.315*25.4>, <+0.428*25.4,0.315*25.4>, <+0.428*25.4,0.13*25.4><+0.378*25.4,0.03*25.4>,
                <-0.378*25.4,0.063*25.4>,<-0.428*25.4,0.13*25.4> ,<-0.428*25.4,0.315*25.4> 
                }    texture{pigment{White*1.7}}rotate<90,0,180> 
        } 
        box{<-0.1*25.4,0,-0.15*25.4><+0.1*25.4,0.1*25.45,+0.15*25.4> texture{pigment{White*1.1}}translate<+0.1*25.4,+0.32*25.4,0>}	 
        box{<-0.1*25.4,0,-0.15*25.4><+0.1*25.4,0.1*25.45,+0.15*25.4> texture{pigment{White*1.1}}translate<-0.125*25.4,+0.32*25.4,0>}
        box{<-0.1*25.4,0,-0.15*25.4><+0.1*25.4,0.1*25.45,+0.15*25.4> texture{pigment{White*1.1}}translate<+0.325*25.4,+0.32*25.4,0>}  
        box{<-0.1*25.4,0,-0.15*25.4><+0.1*25.4,0.1*25.45,+0.15*25.4> texture{pigment{White*1.1}}translate<-0.35*25.4,+0.32*25.4,0>}
    }     
    union{MOLEX1X4RTpin() translate<+0.1*25.4,0,0>}  
    union{MOLEX1X4RTpin() translate<-0.1*25.4,0,0>}
    union{MOLEX1X4RTpin() translate<+0.3*25.4,0,0>}
    union{MOLEX1X4RTpin() translate<-0.3*25.4,0,0>}     
    cylinder{<+0.4*25.4,0,+0.1*25.4><+0.4*25.4,-0.14*25.4,+0.1*25.4>0.05*25.4  texture{pigment{Silver}}}    
    cylinder{<-0.4*25.4,0,+0.1*25.4><-0.4*25.4,-0.14*25.4,+0.1*25.4>0.05*25.4  texture{pigment{Silver}}}   
    cylinder{<-0.2*25.4,0,+0.4*25.4><-0.2*25.4,-0.14*25.4,+0.4*25.4>0.075*25.4  texture{pigment{Silver}}}     
    cylinder{<+0.2*25.4,0,+0.4*25.4><+0.2*25.4,-0.14*25.4,+0.4*25.4>0.075*25.4  texture{pigment{Silver}}}
}                                            

#end    
//Flex foil 44 outline
#macro FLEX44_METRIC()                         
   union{       

        prism {linear_sweep 0.0, 0.1, 6,
               <2.0,0.5>, <7.0,0.5>, <7.0,3.5> 
               <0.5,3.5>, <0.5,2.0>, <2.0,0.5>   
               texture{pigment{White*1.7}}translate<0,0,0>}   //RST      
        prism {linear_sweep 0.0, 0.1, 6,
               <2.0,0.5>, <7.0,0.5>, <7.0,3.5> 
               <0.5,3.5>, <0.5,2.0>, <2.0,0.5>   
               texture{pigment{White*1.7}}translate<0,-1.6,0>}   //RST         
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<9.0,0,0.5> }   //D6     
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<9.0,-1.6,0.5> }   //D6  
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<17.5,0,0.5> }  //D5    
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<17.5,-1.6,0.5> }  //D5   
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<26.0,0,0.5> }  //D4  
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<26.0,-1.6,0.5> }  //D4  
        
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<0.5,0,16.5> }  //D3    
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<0.5,-1.6,16.5> }  //D3 
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<9.0,0,16.5> }  //D2        
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<9.0,-1.6,16.5> }  //D2  
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<17.5,0,16.5> } //D1   
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<17.5,-1.6,16.5> } //D1  
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<26.0,0,16.5> } //D0     
        box{<0,0,0><6,0.1,3> texture{pigment{White*1.7}} translate<26.0,-1.6,16.5> } //D0  
                                                                                                
        box{<0,0,0><3,0.1,6> texture{pigment{White*1.7}} translate<0.5,0,6.75> }    //VCC    
        box{<0,0,0><3,0.1,6> texture{pigment{White*1.7}} translate<0.5,-1.6,6.75> } //VCC   
        box{<0,0,0><3,0.1,6> texture{pigment{White*1.7}} translate<29.5,0,6.75> }   //GND   
        box{<0,0,0><3,0.1,6> texture{pigment{White*1.7}} translate<29.5,-1.6,6.75> } //GND     
    }  
#end 



//Tiny 44
#macro TINY_SOIC44(value,logo)                                  
object{IC_SMD_GRND(8.65,3.9,1.35,6,7,7,1.27,1.27,0.4,0.4,0.22,0.18,0,1,1,3.9/5,3.9/4,0,logo)}
#end 

//Molex 8 pin PC-AT power connector +12V
#macro MOLEX8_pin_hole()  
union{   
prism {linear_sweep 4.0, 12.9, 7,
               <-2,2>, <2,2>, <2,-1>,<1,-2>,<-1,-2>,<-2,-1>,<-2,2> 
               }    texture{pigment{White*.4}}  rotate<0,180,0> translate<0,0,0>  
}   
#end     

#macro MOLEX8_tab()  
union{   
prism {linear_sweep 0.0, 3.4, 5,
               <0,0>, <0,3.1>, <-1.4,0.7><-1.4,0>,<0,0> 
               }    texture{pigment{White*1.7}}  rotate<90,-90,0> translate<3.4/2,12.8,-9.6>  
}   
#end    
 
#macro MOLEX8()      
union{
    difference{           
        union{
	        box{<-9,0,0><+9,12.8,-9.6> texture{pigment{White*1.1}}}    
	        object{MOLEX8_tab()}  
	}
	box{<-2,4,-2><+2,12.9,2> texture{pigment{White*1.7}} translate<-6.6,0,-2.5> }   //pin1  
	object{MOLEX8_pin_hole() texture{pigment{White*1.7}} translate<-2.2,0,-2.5>}    //pin2    
	object{MOLEX8_pin_hole() texture{pigment{White*1.7}} translate<+2.2,0,-2.5>}    //pin3   
	box{<-2,4,-2><+2,12.9,2> texture{pigment{White*1.7}} translate<+6.6,0,-2.5> }   //pin4        
	object{MOLEX8_pin_hole() texture{pigment{White*1.7}} translate<-6.6,0,-7.1>}    //pin5    
	box{<-2,4,-2><+2,12.9,2> texture{pigment{White*1.7}} translate<-2.2,0,-7.1> }   //pin6      
	box{<-2,4,-2><+2,12.9,2> texture{pigment{White*1.7}} translate<+2.2,0,-7.1> }   //pin7
	object{MOLEX8_pin_hole() texture{pigment{White*1.7}} translate<+6.6,0,-7.1>}    //pin8
    }     
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<-6.6,0,-2.5> }//pin1 
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<-2.2,0,-2.5> }//pin2  
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<+2.2,0,-2.5> }//pin3   
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<+6.6,0,-2.5> }//pin4
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<-6.6,0,-7.1> }//pin5
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<-2.2,0,-7.1> }//pin6
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<+2.2,0,-7.1> }//pin7
    box{<-0.5,-3.5,-0.5><+0.5,10.7,+0.5> texture{pigment{Gold}} translate<+6.6,0,-7.1> }//pin8
} translate<0,0,9.6/2>  
#end    

//Amp 4 pin PC-AT power connector +5V
#macro AMP4() 
union{ 
        union{   
        prism {linear_sweep 0.0, 10, 8,
               <0,0>, <0,10.4>, <-1,10.4>,<-2,9.4>,<-2,2.9>,<-4.9,2.9>,<-4.9,0>,<0,0> 
              }    texture{pigment{White*.8}} rotate<-90,-90,0> translate<-10/2,0,+2.5>   
        } 
        box{<+0.32,10.4,-0.32><-0.32,-3.6,0.32> texture{pigment{Gold}} translate<+1.25,0,0> }//pin1 
        box{<+0.32,10.4,-0.32><-0.32,-3.6,0.32> texture{pigment{Gold}} translate<-1.25,0,0> }//pin1 
        box{<+0.32,10.4,-0.32><-0.32,-3.6,0.32> texture{pigment{Gold}} translate<+3.25,0,0> }//pin1 
        box{<+0.32,10.4,-0.32><-0.32,-3.6,0.32> texture{pigment{Gold}} translate<-3.25,0,0> }//pin1    
}
#end  

#macro MATE_N_LOK4()
object{CON_PCPWR514M_GRND() 
rotate<0,-90,0>}
#end   


//****************************************************************************************
// Mill Max spring loaded connector pin 4.5mmtotal 1.4mm action 
// Part #0910-1-57-20-75-14-11-0
// Digi-Key #ED90454DKR-ND
//****************************************************************************************                                                     					// pin at origin       
#macro MILL_MAX()                                              
union{    
        cylinder{<0,0,0><0,2.69,0>1.70/2 texture{pigment{Brass} finish {phong 1}}}      //inner body  
        cylinder{<0,0,0><0,0.41,0>1.83/2 texture{pigment{Brass} finish {phong 1}}}      //bottom   
        cylinder{<0,2.69,0><0,0.66,0>1.78/2 texture{pigment{Brass} finish {phong 1}}}   //upper body        
        cylinder{<0,2.69,0><0,2.5,0>1.98/2 texture{pigment{Brass} finish {phong 1}}}    //PCB stop  
         
        cylinder{<0,0,0><0,4.5-(1.07/2),0>1.07/2 texture{pigment{Brass} finish {phong 1}}}       //max pin   
        sphere{<0,4.5-(1.07/2),0>1.07/2 texture{pigment{Brass} finish {phong 1}}}       
        
     //   cylinder{<0,4.5-(1.07/2),0><0,4.5-1.4-(1.07/2),0>1.07/2 texture{pigment{Red}}}    //min pin  
     //   sphere{<0,4.5-(1.07/2),0>1.07/2 texture{pigment{Red}}}   
}          
translate<0,0,0>
#end

//object{MILL_MAX()}   


#macro PC_PGM()
union{
        object{MILL_MAX() translate<+0.2*25.4,+1.6,+0.05*25.4>}    
        object{MILL_MAX() translate<-0.2*25.4,+1.6,+0.05*25.4>}      
        object{MILL_MAX() translate<+0.2*25.4,+1.6,-0.15*25.4>}    
        object{MILL_MAX() translate<-0.2*25.4,+1.6,-0.15*25.4>} 
        object{MILL_MAX() translate<0,+1.6,+0.2*25.4>}    
        object{MILL_MAX() translate<0,+1.6,-0.2*25.4>} 
       

}
translate<0,-1.8,0>
#end



#macro PGM8U2(value,logo)
object{QFN(5,5,0.9,8,8,8,8,0.5,0.25,0.65,4.9,4.9,0.0,90,0,logo,Grey*0.4)}
#end  




//--------------------------------------------------------- Pyramid_N macro
#macro Pyramid_N (N, Radius1, Radius2, Height)
//-------------------------------------------------------------------------
#local D= 0.00001;

intersection{
 #local Nr = 0;    // start
 #local EndNr = N; // end
 #while (Nr < EndNr)

  // linear prism in z-direction:
  prism { -2.00 ,2.00 , 5 // from z1, to z2 , number of points (first = last)
         <-2.00, 0.00>, < 1.00,  0.00>,
         < 0.00+Radius2/Radius1,1.00>,
         <-2.00,1.00>, <-2.00, 0.00>
         rotate<-90,0,0> scale<1,1,-1> //turns prism in z direction!
         scale <Radius1+Nr*D,Height+Nr*D,Radius1+Nr*D>
         rotate<0,Nr * 360/EndNr,0>
     } // end of prism ----------------------------------------------------

 #local Nr = Nr + 1;    // next Nr
 #end // ----------------  end of loop
} // end of intersection

#end // ------------------------------------------------------ end of macro                  



#macro channel() 
prism{ 0, -80.00, 7
   <-3.81, 0.00>,
   <+3.81, 0.00>,
   <+3.81,+7.9375>,
   <+3.31,+6.4375>,
   <-3.31,+6.4375>,
   <-3.815,+7.9375>,
   <-3.815, 0.00>
  texture{
    pigment{color White}
    finish {ambient 0.15
            diffuse 0.85}}
  rotate<-90,0,0>
  translate<0,0,0>
   }//end of prism 
    
#end                          

#macro pin_arrayl()  
union{
#declare NrX = 0;     // start
#declare EndNrX = 30; // end
#while (NrX < EndNrX+1)
        object{pina()translate<-3*2.54/2-1.5875,0,NrX*2.54>}           //left 5 
        object{pina()translate<-3*2.54/2-1*2.54-1.5875,0,NrX*2.54>}    
        object{pina()translate<-3*2.54/2-2*2.54-1.5875,0,NrX*2.54>} 
        object{pina()translate<-3*2.54/2-3*2.54-1.5875,0,NrX*2.54>}  
        object{pina()translate<-3*2.54/2-4*2.54-1.5875,0,NrX*2.54>}     
        
  //      object{pina()translate<-3*2.54/2-7*2.54,0,NrX*2.54>}    //power -
  //      object{pina()translate<-3*2.54/2-8*2.54,0,NrX*2.54>}    //power +
        
        object{pina()translate<+3*2.54/2+1.5875,0,NrX*2.54>}           //right 5
        object{pina()translate<+3*2.54/2+1*2.54+1.5875,0,NrX*2.54>}    
        object{pina()translate<+3*2.54/2+2*2.54+1.5875,0,NrX*2.54>} 
        object{pina()translate<+3*2.54/2+3*2.54+1.5875,0,NrX*2.54>}  
        object{pina()translate<+3*2.54/2+4*2.54+1.5875,0,NrX*2.54>} 
        object{pina()translate<+3*2.54/2+7*2.54,0,NrX*2.54>}    //power -
        object{pina()translate<+3*2.54/2+8*2.54,0,NrX*2.54>}    //power +  
 #declare NrX = NrX + 1;  //next Nr

#end    
}
#end 


#macro pina()
union{  
        difference{
                box{<-2.54/2,0,0><+2.54/2,5/16*25.4,+2.54>}   
                box{<-2.54/4,-0.1,+2.54/4><+2.54/4,0.1+5/16*25.4,3*+2.54/4>} 
                object{ Pyramid_N (4, 2./2, 2.54/4, 2.54/8 ) rotate<180,0,0>translate<0,0.01+5/16*25.4,+2.54/2>}
        }texture{pigment{White}}         

}
#end   
        
#macro pin_array()  
union{
#declare NrX = 0;     // start
#declare EndNrX = 30; // end
#while (NrX < EndNrX+1)
        object{pina()translate<-3*2.54/2-1.5875,0,NrX*2.54>}           //left 5 
        object{pina()translate<-3*2.54/2-1*2.54-1.5875,0,NrX*2.54>}    
        object{pina()translate<-3*2.54/2-2*2.54-1.5875,0,NrX*2.54>} 
        object{pina()translate<-3*2.54/2-3*2.54-1.5875,0,NrX*2.54>}  
        object{pina()translate<-3*2.54/2-4*2.54-1.5875,0,NrX*2.54>}     
        
        object{pina()translate<-3*2.54/2-7*2.54,0,NrX*2.54>}    //power -
        object{pina()translate<-3*2.54/2-8*2.54,0,NrX*2.54>}    //power +
        
        object{pina()translate<+3*2.54/2+1.5875,0,NrX*2.54>}           //right 5
        object{pina()translate<+3*2.54/2+1*2.54+1.5875,0,NrX*2.54>}    
        object{pina()translate<+3*2.54/2+2*2.54+1.5875,0,NrX*2.54>} 
        object{pina()translate<+3*2.54/2+3*2.54+1.5875,0,NrX*2.54>}  
        object{pina()translate<+3*2.54/2+4*2.54+1.5875,0,NrX*2.54>}   
         
        object{pina()translate<+3*2.54/2+7*2.54,0,NrX*2.54>}    //power -
        object{pina()translate<+3*2.54/2+8*2.54,0,NrX*2.54>}    //power +

 #declare NrX = NrX + 1;  //next Nr

#end    
}
#end   

#macro pin_array17()  
union{
#declare NrX = 0;     // start
#declare EndNrX = 16; // end
#while (NrX < EndNrX+1)
        object{pina()translate<-1.3*2.54/2-1.5875,0,NrX*2.54>}           //left 5 
        object{pina()translate<-1.3*2.54/2-1*2.54-1.5875,0,NrX*2.54>}    
        object{pina()translate<-1.3*2.54/2-2*2.54-1.5875,0,NrX*2.54>} 
        object{pina()translate<-1.3*2.54/2-3*2.54-1.5875,0,NrX*2.54>}  
        object{pina()translate<-1.3*2.54/2-4*2.54-1.5875,0,NrX*2.54>}     
        
        
        object{pina()translate<+1.3*2.54/2+1.5875,0,NrX*2.54>}           //right 5
        object{pina()translate<+1.3*2.54/2+1*2.54+1.5875,0,NrX*2.54>}    
        object{pina()translate<+1.3*2.54/2+2*2.54+1.5875,0,NrX*2.54>} 
        object{pina()translate<+1.3*2.54/2+3*2.54+1.5875,0,NrX*2.54>}  
        object{pina()translate<+1.3*2.54/2+4*2.54+1.5875,0,NrX*2.54>}   

 #declare NrX = NrX + 1;  //next Nr

#end    
}
#end
      
#macro PROTO170()  
union{
        #object{ pin_array17() translate<0,0,+2.54/2>}  
        prism{ 0, -46.00, 7
         <-3.81, 0.00>,
            <+3.81, 0.00>,
            <+3.81,+7.9375>,
            <+3.31,+6.4375>,
            <-3.31,+6.4375>,
            <-3.815,+7.9375>,
             <-3.815, 0.00>
        texture{
        pigment{color White}
        finish {ambient 0.15
        diffuse 0.85}}
        rotate<-90,0,0>  
        scale<0.5,0,0>
   }//end of prism    
   box{<-35/2,0,0><-35/2+2.9,5/16*25.4,46>texture{pigment{White}} }  
   box{<+35/2-2.9,0,0><+35/2,5/16*25.4,46>texture{pigment{White}} }    
        
   box{<+35/2,0,0><-35/2,5/16*25.4,3.2/2>texture{pigment{White}} }  
   box{<+35/2,0,46><-35/2,5/16*25.4,46-3.2/2>texture{pigment{White}} } 
   translate<0,0,-47/2>
}
#end                

#macro PROTO()
union{
        #object{ pin_array() }  
        object{ channel() }  
        box{<-55/2,0,0><+55/2,4/16*25.4,83>texture{pigment{White}} }    
        rotate<0,90,0>     
        translate<-83/2,0,0>
}
#end
                
#macro BREADBOARD1()
union{
        #object{ pin_arrayl()translate<-0.2*25.4,0,+0.1*25.4> }  
        object{ channel() translate<-0.2*25.4,0,+0.1*25.4>}  
        box{<-45/2,0,0><+45/2,4/16*25.4,84>texture{pigment{White}} }    
        rotate<0,90,0>  
        translate<-84/2,0,0>
}
#end               
                
//****************************************************************************************
// Mill Max spring loaded connector pin 4.5mmtotal 1.4mm action 
// Part #0910-1-57-20-75-14-11-0
// Digi-Key #ED90454DKR-ND
//****************************************************************************************                                                     					// pin at origin       
#macro MILLMAX()                                              
union{    
        cylinder{<0,0,0><0,2.69,0>1.70/2 texture{pigment{Yellow}}}      //inner body  
        cylinder{<0,0,0><0,0.41,0>1.83/2 texture{pigment{Yellow}}}      //bottom   
        cylinder{<0,2.69,0><0,0.66,0>1.78/2 texture{pigment{Yellow}}}   //upper body        
        cylinder{<0,2.69,0><0,2.5,0>1.98/2 texture{pigment{Yellow}}}    //PCB stop  
         
        cylinder{<0,0,0><0,4.5-(1.07/2),0>1.07/2 texture{pigment{Yellow}}}       //max pin   
        sphere{<0,4.5-(1.07/2),0>1.07/2 texture{pigment{Yellow}}}       
        
        cylinder{<0,4.5-(1.07/2),0><0,4.5-1.4-(1.07/2),0>1.07/2 texture{pigment{Red}}}    //min pin  
        sphere{<0,4.5-(1.07/2),0>1.07/2 texture{pigment{Red}}}   
}          
translate<0,-2.69,0>
#end


#macro Nut375(dia,hole)   
difference{
        union{  
                intersection{
                        union{                                                  //nut body
                                cylinder{<0,-1,0>,<0,1,0>,dia}
                                torus{0.9*dia,dia/3}
                        }
                        plane{z,dia}                                            //60 degree facets
                        plane{z,dia rotate -60*y} 
                        plane{z,dia rotate +60*y}
                
                        plane{z,-dia inverse}  
                        plane{z,-dia inverse rotate -60*y}   
                        plane{z,-dia inverse rotate +60*y}     
                } 
        } 
        cylinder{<0,-0.1-hole/2,0>,<0,+0.1+hole/2,0>,hole/2}                       //threaded hole
        #declare rs=.1;
        #declare ns=hole/rs;
        #declare is=1;
        #while (is<=ns)                                                         //threads
                torus{hole/2,rs  rotate 2*y translate ((-hole/2)+2*rs*is)*y}
                #declare is=is+1;
        #end            
 
        texture{ Chrome_Metal finish {phong 1}}   
}  
#end   



/*******************************
// Macro for pin QFP packages
// H = height of the pins
// B = depth of the pins
// T = Width of pins
// S = material thickness of the pins
******************************/
#macro QFN_PIN(H,B,T,S)
union{
	box{<-H/2,H/2,0><0.01,-0.02,T>}
        texture{col_silver}        
}
#end      

/********************************************************************************************************************************************
//
//L = length over everything (x axis) 
//B = width over everything (Z-axis) 
//H = height plastic (y axis) 
//pin_l = number of pin left 
//pin_r = number of pin right 
//pin_o = number of pin above 
//pin_u = number of pin down 
//pitch = distance of the individual pins 
//pin_br = width of a pin 
//pin_h = strength of the pin material 
//LK = length plastic (x axis) 
//BK = width plastic (Z-axis) 
//HKoP = height of the plastic over the plate (y axis) 
//KORW = correction angle 
//kp1ab = if not 0 is produced no chamfer at Pin1 
//logo = name OF the logo    
//package colour 
********************************************************************************************************************************************/
#macro QFN(L,B,H,pin_l,pin_r,pin_o,pin_u,pitch,pin_br,pin_h,LK,BK,HKoP,KORW,kp1ab,logo,pkgcolour)
union{
	difference{
		box{<-LK/2,HKoP,-BK/2><LK/2,HKoP+H,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,-1> rotate<-10,0,0> translate<0,HKoP+H/2-pin_h/2,-BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,1> rotate<10,0,0> translate<0,HKoP+H/2-pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,1> rotate<-10,0,0> translate<0,HKoP+H/2+pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,-1> rotate<10,0,0> translate<0,HKoP+H/2+pin_h/2,-BK/2>}
		box{<0,0,-BK/2-0.01><1,2,BK/2+0.01> rotate<0,0,10> translate<LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,2,BK/2+0.01> rotate<0,0,-10> translate<-LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><1,-2,BK/2+0.01> rotate<0,0,-10> translate<LK/2,HKoP+H/2-pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,-2,BK/2+0.01> rotate<0,0,10> translate<-LK/2,HKoP+H/2-pin_h/2,0>}
		#if(kp1ab=0)
			box{<0,0,-3><-2,5,3> rotate<0,-45,0> translate<-LK/2+LK/40,0,-BK/2+BK/40>}
		#end
		cylinder{<0,H+HKoP-0.1,0><0,H+HKoP+1,0>0.4 translate<-LK/2+LK/10,0,-BK/2+BK/10>}
		pigment{pkgcolour}
	}
	
	#local i=0;
	#while(i<(pin_l/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i+pitch/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end
	
	#local i=0;
	#while(i<(pin_r/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i+pitch/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_u/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i+pitch/2,0,-BK/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i-pitch/2,0,-BK/2>}
		#else
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i,0,-BK/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i,0,-BK/2>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_o/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i+pitch/2,0,BK/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i-pitch/2,0,BK/2>}
		#else
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i,0,BK/2>}
			object{QFN_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i,0,BK/2>}
		#end
		#local i=i+1;
	#end   
	
	#local scl_fa = BK/10;
	#local value_arial_size_min = 0.0;
	#local value_arial_size_max = 0.0;
	#local value_arial_size = 0.0;
	#local value_courier_size_min = 0.0;
	#local value_courier_size_max = 0.0;
	#local value_courier_size = 0.0;
//	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_courier_bold = text{ttf global_fontfile_courier_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_arial_bold, value_arial_size_min, value_arial_size_max)
	Extents(value_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_arial_size = value_arial_size_max - value_arial_size_min; 
	#local value_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_scale_factor_arial = BK/value_arial_size.z * 0.7;
	#local value_scale_factor_courier = BK/value_courier_size.z * 0.7;	
	
	#if(value_arial_size.x*value_scale_factor_arial > LK/6.0) 
                #local value_scale_factor_arial = LK/6.0 / value_arial_size.x;	
	#end
	#if(value_courier_size.x*value_scale_factor_courier > LK/6.0) 
                #local value_scale_factor_courier = LK/6.0 / value_courier_size.x;	
	#end
		
	#local value_arial_size = value_arial_size * value_scale_factor_arial; 
	#local value_courier_size = value_courier_size * value_scale_factor_courier;
	//a random datecode string
	#local value_datecode_arial_size_min = 0.0;
	#local value_datecode_arial_size_max = 0.0;
	#local value_datecode_arial_size = 0.0;
	#local value_datecode_courier_size_min = 0.0;
	#local value_datecode_courier_size_max = 0.0;
	#local value_datecode_courier_size = 0.0;
	#local value_datecode_string = concat(str(rand(global_seed)*52.9, -2, 0),str(rand(global_seed)*3.9+2, -2, 0));	
//	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_courier_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_datecode_arial_bold, value_datecode_arial_size_min, value_datecode_arial_size_max)
	Extents(value_datecode_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_datecode_arial_size = value_datecode_arial_size_max - value_datecode_arial_size_min; 
	#local value_datecode_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_datecode_scale_factor_arial = value_scale_factor_arial;
	#local value_datecode_scale_factor_courier = value_scale_factor_courier;
	#local value_datecode_arial_size = value_datecode_arial_size * value_scale_factor_arial; 
	#local value_datecode_courier_size = value_datecode_courier_size * value_scale_factor_courier;
	
		
	#local logo_assigned = 0;
		
	#if(strcmp(logo,"FTDI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "f" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end
	
	#if(strcmp(logo,"ATMEL")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "a" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} rotate<0,+90,0>}		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2> rotate<0,+90,0>} 
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>rotate<0,+90,0>}
	#end

	#if(strcmp(logo,"TI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "t" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/10> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end

	#if(strcmp(logo,"XILINX")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "#" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	

	#if(strcmp(logo,"MICROCHIP")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "m" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	


	#if(strcmp(logo,"CYPRESS")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "}" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	 
	
	#if(strcmp(logo,"ANALOG")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "3" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end
	#if(strcmp(logo,"ST")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "s" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end		

	#if(strcmp(logo,"NXP")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_NXP "!" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	
	#if(logo_assigned < 0.5)
		text{ttf besch_font value 0.2,0 scale<scl_fa,scl_fa,1> rotate<90,-90,0> translate<-LK/2+LK/4,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }
	#end
	
	rotate<0,KORW,0>
}
#end     

#macro LPC1347_QFN(value,logo)
object{QFN(7,7,0.9,8,8,8,8,0.5,0.25,0.65,6.9,6.9,0.0,90,0,logo,Grey*0.4)}
#end      

#macro ATMEGA128RFA1(value,logo)
object{QFN(9,9,0.9,16,16,16,16,0.5,0.25,0.65,8.9,8.9,0.0,90,0,logo,Grey*0.4)}
#end              

#macro MAX9768(value,logo)
object{QFN(4,4,0.9,6,6,6,6,0.5,0.25,0.65,3.9,3.9,0.0,90,0,logo,Grey*0.4)}
#end  

#macro ATTINY40(value,logo)
object{QFN(3,3,0.9,5,5,5,5,0.5,0.25,0.65,2.9,2.9,0.0,90,0,logo,Grey*0.4)}
#end 
                                                                            
                                                                      
#macro FT231(value)  
//     QFN(PinLength X,PinWidth Z,Height,pin_l,pin_r,pin_up,pin_down,pitch ,pin_br,pin_h,Pkg Width X ,Pkg Length Z ,HKoP,KORW ,kp1ab,logo    ,pkgcolour) 
object{QFN(2          ,2         ,0.75  ,5    ,5     ,5    ,5       ,0.5   ,0.25  ,0.65 ,4.0         ,4.0          ,0.0 ,90   ,0    ,"FTDI"  ,Grey*0.4)}
#end                                        

//****************************************************************************************
// Antenna Factor 2.45GHz 50 ohm antenna
// Part # ANT-2.4-CHP-x1   
// Digi-Key #
//****************************************************************************************                                                 					     
#macro ANT_24_CHP()                                              
union{
        box{<+1.27,0,+3.302><-1.27,1,-3.302> texture{pigment{White*0.6}}}       //body      
        
        box{<+1.271,-0.01,-0.508><-1.271,+1.01,+0.508> texture{col_silver}translate<0,0,-3.302+0.507>}      //pin 1													
        box{<+1.271,-0.01,-0.508><-1.271,+1.01,+0.508> texture{col_silver}translate<0,0,+3.302-0.507>}      //mount	
        text{ttf besch_font "AF 2.4" 0.2,0 scale<1,1,1> rotate<90,+90,0> translate<-0.8,+1.02,+3.302*.5> pigment{White} }
}  rotate<0,-90,0> 
#end       

//****************************************************************************************
// JTI_BALUN Johanson Technology Balun 2.45GHz balance to 50 ohm 
// Part # J2450FB15L0001    
// Digi-Key #
//****************************************************************************************                                                 					     
#macro J2450FB15L0001()                                              
union{
        box{<-1.00,0,-0.625><+1.00,0.8,+0.625> texture{pigment{Yellow*0.8}}}       //body      
        
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<+0.65,0,+0.625-0.14>}      //pin 1													
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<0,0,+0.625-0.14>}          //pin 2	
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<-0.65,0,+0.625-0.14>}      //pin 3	
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<0,0,-0.625+0.14>}          //pin 4	    
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<-0.65,0,-0.625+0.14>}      //pin 5    
        box{<-0.15,-0.01,-0.15><+0.15,+0.81,+0.15> texture{col_silver}translate<+0.65,0,-0.625+0.14>}      //pin 6 
        
        box{<+0.15,0.79,+0.15><-0.15,0.81,-0.15> texture{pigment{Brown}}translate<+0.65,0,0>}  
}   
#end


/*************************************************************************/
//CT3002 Rotary Encoder manufactured by CTS
#macro CT3002_ND()   
union{ 
        cylinder{<0,0,0><0,25+10.2,0>3.175 texture{Chrome_Metal}}      //shaft         
        cylinder{<0,0,0><0,5+10.2,0>4.7625 texture{Brass_Metal}}       //thread   
        isosurface{ //------------------------------------
        function{ f_helix1( x,y,z,
                1,    // number of helixes, (1 = single helix, 2 = double helix etc.)
                22,   // period,      turns on the length of 2*pi
                0.07, // minor radius,
                1.0,  // major radius,
                1,    // shape parameter,
                1.8,  // cross section type,
                      // (0.0 to 1.0 = square ... rounded to circle
                      // over 2.0 to 3.0 = rounded to diamond and concave diamond
                0 )   // cross section rotation angle
        }    
        texture{     
                Brass_Metal
                finish { diffuse 0.75 specular 0.1
                         roughness 0.1 phong 0.2  }
        } // end of texture    
        scale <4.7625,3,4.7625>    
        translate <0,12,0>
        }      
        cylinder{<0,0,0><0,10.2,0>8.5 texture{Chrome_Metal}}   //body
        box{<-9,0,+7.5><+9,7.7,-7.5>texture{pigment{Black}}}       //body 
         
        object{ENC_PCB()}
        object{ENC_TAB() translate<11.2,-8,0>} 
        object{ENC_TAB() translate<11.2,-8,+5>} 
        object{ENC_TAB() translate<11.2,-8,-5>}    
        object{Nut375(6.35,9.375) translate<0,12,0>} 
        translate<0,-10.5,0>
        rotate<0,-90,0>        
   
}
#end    

#macro ENC_TAB()   
union{     
        difference{  
                union{
                        box{<0,0,2.92/2><7.3-2.92/2,1,-2.92/2>texture{Chrome_Metal}}       //tab
                        cylinder{<7.3-2.92/2,0,0><7.3-2.92/2,1,0>2.92/2 texture{pigment{Grey}}}  //rounded end
                }
                box{<4.15,-0.01,+0.75><6.3,+1.01,-0.75>texture{Chrome_Metal}}             //hole  
                cylinder{<4.15,-0.01,0><4.15,1.01,0>0.75 texture{Chrome_Metal}} 
                cylinder{<6.3,-0.01,0><6.3,1.01,0>0.75 texture{Chrome_Metal}}
        }
}
#end   

#macro ENC_PCB()
union{    
       difference{
                Round_Box(<11.2,0,-8><-8.5,1,8>, 1, 0)    
                cylinder{<9.2,+0.01,0><9.2,-30,0>0.75}
                cylinder{<9.2,+0.01,5><9.2,-1.1,5>0.75}  
                cylinder{<9.2,+0.01,-5><9.2,-1.1,-5>0.75}
       }   
       difference{
                union{
                        box{<-7,0,-3.5><+7,-0.6,+3.5>}
                        box{<-8,0,+3.5><+8,-0.6,+4.5>} 
                        box{<-8,0,-3.5><+8,-0.6,-4.5>}
                        box{<-6,0,+4.5><+6,-0.6,+5.0>}  
                        box{<-6,0,-4.5><+6,-0.6,-5.0>}  
                }                    
                cylinder{<0,+0.01,0><0,-0.7,0>3.5}  
                texture{Chrome_Metal}   
                rotate<0,90,0>
       }
       texture{pigment{Brown}}  
       translate <0,-6.5,0>
        
}
#end




/*************************************************************************/
//Pin
#macro NHDC0220AZ_Pin()
union{
     box{<-0.5,0,-0.75><+0.5,0.1,+0.75> texture{pigment{Silver*.7}}}  
     box{<-0.25,0.1,-0.75><+0.25,-7.6,-0.85> texture{pigment{Silver*.7}}}    
}                             
#end    

#macro NHDC0220AZ_LCDPin()
union{
     object {NHDC0220AZ_Pin() translate<-13,4.0,-25>}
     object {NHDC0220AZ_Pin() translate<-11,4.0,-25>}  
     object {NHDC0220AZ_Pin() translate<-9,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<-7,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<-5,4.0,-25>}  
     object {NHDC0220AZ_Pin() translate<-3,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<-1,4.0,-25>}  
     object {NHDC0220AZ_Pin() translate<+13,4.0,-25>} 
     object {NHDC0220AZ_Pin() translate<+11,4.0,-25>}  
     object {NHDC0220AZ_Pin() translate<+9,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<+7,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<+5,4.0,-25>}  
     object {NHDC0220AZ_Pin() translate<+3,4.0,-25>}   
     object {NHDC0220AZ_Pin() translate<+1,4.0,-25>}     
     box{<-0.3,0,-0.375><+0.3,-4,0.375> translate<-38.1,0,-13.5>}      
     box{<-0.3,0,-0.375><+0.3,-4,0.375> translate<-38.1,0,-5.5>}
}                             
#end      
                                            
  
#macro NHDC0220AZ_body()
union{
     box{<-35.2,2.9,-25><+35.2,4.0,0> pigment{color rgbt<0.7,0.7,0.7,0.3>}finish { phong 1}}  //PCB
     box{<-35.2,0,-18.5><+35.2,2.9,0> texture{pigment{White*0.95}}}  //backlight    
     box{<-35.2,4.0,-17.5><+35.2,5.1,0> pigment{color rgbt<0.5,0.5,0.5,0.8>}finish { phong 1}}//LCD
     prism {linear_sweep 0.0, 2.9, 5,<35.2,-0>, <39.3,-1.7>, <39.3,-16.7>,<35.2,-17.5>, <35.2,0> texture{pigment{White*0.95}}rotate<0,180,0>translate<0,0,-17.5>}   
     NHDC0220AZ_LCDPin() 
}  
         
#end  

#macro NHDC0220AZ()
object{NHDC0220AZ_body()rotate<0,180,0>translate<0,0,-25>}       
#end

//Macro for SMD IC's with pins on 2-sides 
//LK = length of plastic (side with the pins)
//BK = width of plastic (side without the pins) 
//HK = height of plastic
//B = length of the side without pins over all 
//pin_u = pin on the lower side 
//pin_o = pin on the upper side 
//ptch_u = pitch of the pins on the lower side 
//ptch_o = pitch of the pins on the upper side 
//pinb_u = width of the pins up the lower side 
//pinb_o = width of the pins on the upper side 
//pin_s = thickness of the pin material 
//di_pcb = distance of plastic to the PCB 
//kor_w = correction angle 
//pin0_m = Pin-1-Marking: 0 = none, 1 = dot, 2 = notch as if with DIP, 3 = PowerSO, 4 = DPAK 
//pin0_45 =! = 0 at the lower side an angle at the body of 45 is used instead of 10 (SO) 
//pin0_a = distance of the Pin0-marking from the edge 
//besch_s = Scale factor of the inscription 
//besch_w = if! = 0 inscription turned 
//logo = name of the logo
 
#macro IC_SMD_TSOP66(value,logo)
object{IC_SMD_GRND(22.22,10.1,1,11.7,33,33,0.65,0.65,0.32,0.32,0.15,0.1,0,1,0,0.5,1.5,0,logo) rotate<0,90,0>}
#end

/****************************************************************************************
//LED SMT
*****************************************************************************************/
#macro DIODE_SMD_LED_GRND(s,col,tra)
union{
box{<0.1,0,0.1><1.9,0.60,1.15> pigment{col filter tra}translate<0,0.05,0> }      //Widerstandskoerper
box{<0,0.0,0><0.6,0.3,1.25> }                                        //Metall links
box{<0,0.0,0><0.6,0.3,1.25> translate<2.0-0.6,0,0>}                 //Metall rechts
box{<0.4,0.3,0.5><0.6,0.5,0.75>}
box{<1.4,0.3,0.5><1.6,0.5,0.75>}
box{<0.85,0.3,0.475><1.15,0.4,0.775> pigment{col} finish{ambient 1}}
lathe{linear_spline 4, <0, 0>, <0.4, 0.4>, <0.5,0.4>,<0.05,0>
translate<1,0.1,0.625>}
texture{col_silver} 
translate<-1,0,-0.625>
rotate <0,90,0>
scale s
}
#end

#macro DIODE_SMD_LED_1206(col,tra,height)
object{DIODE_SMD_LED_GRND(<1.5,1.5,1.2>,col,tra)}
#end  

#macro L0805(col,tra,height)
object{DIODE_SMD_LED_GRND(<1,1,1>,col,tra)rotate <0,0,0>}
#end
                       
//****************************************************************************************
//2x7 Box header (grey)
//Designed by Doug Commons
//Rev. 1.0  Feb 2009
//****************************************************************************************
                       
#macro CON_2x7BOXEDGE(value)
object{CON_DIS_WS_XX_G_GRND(14)  translate<0,+2.5,0> rotate -90*x}
#end     

//****************************************************************************************
//2x7 vertical Box header (grey)
//Designed by Doug Commons
//Rev. 1.0  Feb 2009
//****************************************************************************************
                       
#macro CON_2X7V(value)
object{CON_DIS_WS_XX_G_GRND(14)  translate<0,+2.5,0> rotate -180*y}
#end              

//****************************************************************************************
//2x7 vertical Box header (grey)
//Designed by Doug Commons
//Rev. 1.0  Feb 2009
//****************************************************************************************
                       
#macro CON_2X3V(value)
object{CON_DIS_WS_XX_G_GRND(6)  translate<0,+2.5,0> rotate -90*y}
#end    

//****************************************************************************************
//2x5 Box header (grey)
//Designed by Doug Commons
//Rev. 1.0  Feb 2009
//****************************************************************************************
                       
#macro CON_2x5BOXEDGE(value)
object{CON_DIS_WS_XX_G_GRND(10)  translate<0,+2.5,0>  rotate -180*y}
#end                      

//****************************************************************************************
//Macros for SMD bridge MBS1 
//Designed by Doug Commons
//Rev. 1.0  June 3 2007
//****************************************************************************************
#macro IC_SMD_MBS1_GRND()
union{
    difference{
        box{<-2.4,0.3,2.1><2.4,1.9,-2.1>}   
        pigment{Gray20}
    }
//    text {ttf global_fontfile_eagle3d "j" 0.02, 0 pigment{Gray80} scale 2 rotate<90,0,0> translate<-2.0,1.91,-0.8>}  // Marking
    text {ttf global_fontfile_arial_bold "+" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<+1.8,1.91,+1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "-" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<-1.8,1.91,+1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "~" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<+1.8,1.91,-1.4>}  // Marking
    text {ttf global_fontfile_arial_bold "~" 0.04, 0 pigment{Gray80} scale 1 rotate<90,0,0> translate<-1.8,1.91,-1.4>}  // Marking
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-1.7,0,1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+1.9,0,1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate +90*y translate<-1.7,0,-1.9>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate +90*y translate<+1.9,0,-1.9>}
}
translate<-1,0,0>
#end

#macro IC_SMD_MBS()
object{IC_SMD_MBS1_GRND()}
#end 

//****************************************************************************************
//USB A
//****************************************************************************************
#macro USBA()  
union{
union{
    difference{
        union{
        box{< 6.0, 0.0,+1.3>  <-6.0, 3.07,-17.5>  texture{col_silver}}//top level shell
        box{< 6.0,-1.5,-2.8>  <-6.0, 0.00,-17.5>  texture{col_silver}}//PCB level shell 
        box{<+2.0,+3.08,-13.5><+4.0,+2.97,-11.5>  pigment{Gray20}}  //top detent front
        box{<-2.0,+3.08,-13.5><-4.0,+2.97,-11.5>  pigment{Gray20}}  //top detent front
        box{<+3.0,+3.08,-10.5><+4.0,+2.97,- 9.5>  pigment{Gray20}}  //top detent back
        box{<-3.0,+3.08,-10.5><-4.0,+2.97,- 9.5>  pigment{Gray20}}  //top detent back     
        box{<+0.5,+3.08,- 1.0><-0.5,+2.97,+ 0.0>  pigment{Gray20}}  //top back detent 
        
        box{<+2.0,-1.51,-13.5><+4.0,-1.48,-11.5>  pigment{Gray20}}  //bottom detent   
        box{<-2.0,-1.51,-13.5><-4.0,-1.48,-11.5>  pigment{Gray20}}  //bottom detent  
        
//bottom joint
        box{< 0.0,-1.7,-17.5>< 0.0,-1.49,-14.5> pigment{Gray20}}  //segment A     
        box{< 0.0,-1.7,-14.5><-1.0,-1.49,-14.5> pigment{Gray20}}  //segment B
        box{<-1.0,-1.7,-14.5><-1.0,-1.49,-13.5> pigment{Gray20}}  //segment C 
        box{<-1.0,-1.7,-13.5>< 0.0,-1.49,-13.5> pigment{Gray20}}  //segment D
        box{< 0.0,-1.7,-13.5>< 0.0,-1.49,-3.5>  pigment{Gray20}}  //segment E
        box{<-1.0,-1.7,- 7.5><-1.0,-1.49,-6.5>  pigment{Gray20}}  //segment F
        box{<-1.0,-1.7,- 6.5>< 0.0,-1.49,-6.5>  pigment{Gray20}}  //segment G
        box{< 0.0,-1.7,  0.0>< 0.0,-1.49, 0.0>  pigment{Gray20}}  //segment H   
        
//mounting pins plastic
        cylinder{<+2.25,0.0,0.0><+2.25,-2.43,0.0>0.5 pigment{Gray20}}
        cylinder{<-2.25,0.0,0.0><-2.25,-2.43,0.0>0.5 pigment{Gray20}}        
        }   
    }  
        box{<-5.93,-1.43,-2.8><5.93,3.0,-17.51>  texture{col_silver}}   //remove inside shell  
        box{<-5.3,-1.43,-2.8><5.3,1.0,-17.52>  pigment{Gray20}}         //pin support
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-3.5,0,+1.3>} //SMT pins
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<-1.0,0,+1.3>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+1.0,0,+1.3>}
	object {IC_SMD_PIN(1.5,1.5,1.2,0.3) rotate -90*y translate<+3.5,0,+1.3>} 
	    
}      
        cylinder{<+3.5,1.6,-17.52><+3.5,1.6,0>0.5  texture{col_gold}} //USB A pin	
        cylinder{<+1.0,1.6,-17.52><+1.0,1.6,0>0.5  texture{col_gold}} //USB A pin
        cylinder{<-1.0,1.6,-17.52><-1.0,1.6,0>0.5  texture{col_gold}} //USB A pin
        cylinder{<-3.5,1.6,-17.52><-3.5,1.6,0>0.5  texture{col_gold}} //USB A pin 
}  
#end

//****************************************************************************************
// Small AC input jack
//****************************************************************************************
#macro CON_AC_IN_GRND()
union{ 
union{
difference{
 box{<0,0,-2.5><11,5,2.5>}                              //body
 cylinder{<-0.1,2.5,0><8,2.5,0>1.3  pigment{Gray40}}    //body socket
}      
 cylinder{<-0.1,2.5,0><8,2.5,0>0.5  texture{col_silver}} //pin
}
union{ 
  box{<0,0,0><2.0,0.1,1.5> translate <2.5,0,2.5>}	//front leg left
  box{<0,0,0><2.0,0.1,1.5> translate <3.5,0,-2.5>}	//front leg right         
  box{<0,0,0><2.0,0.1,2.0> translate <8,0,2.5>}         //rear leg left
  box{<0,0,0><2.0,0.1,2.0> translate <9,0,2.5>}	        //rear leg right
  box{<-1,0.1,0><2,0.1,2> translate <11,0,-1>}	        //rear leg

  box{<0,0,-0.1><-3.5,5.2,0.1> translate <10,0,2.5>}	//left side
  box{<0,0,-0.1><-3.5,5.2,0.1> translate <10,0,-2.5>}	//right side
  box{<-2.8,-.1,0><2.8,.1,5> translate <7,5,-2.5>}	//top

  texture{T_Chrome_5A} 
}
}                                                                                         
#end

#macro CON_AC_IN_SMT()
object{CON_AC_IN_GRND()}
#end

//*********************************************************************************
//SMT Dipswitch
//
//**********************************************************************************
#macro SMT_DIP_GRND(nrSwitches) 
  #local well  = box { <0,3.8,2> <1,3.96,4.7> pigment { MediumWood } }
  #local housing = difference { box { <0,0,0> <2.54*(nrSwitches+0.5),3.95,6.7> }
                                box { <0,3.8,2> <.3,3.96,4.7> }
                                pigment{color red 0.7 green 0.15 blue 0.15}}//SteelBlue
  #local offSwitch = union { box { <0.1,3.71,2.1> <.9,3.71,4.6> }
                             box { <0.1,3.71,2.1> <.9,4.1,3> }
                             pigment { NewTan }}
  #local onSwitch = union { box { <0.1,3.71,2.1> <.9,3.71,4.6> }
                            box { <0.1,3.71,3.6> <.9,4.1,4.6> }
                            pigment { NewTan }}
  union {
    difference {
      object { housing }

      #local wellNr = 0;
      #while (wellNr < nrSwitches)
        object { well translate<(wellNr+0.5)*2.54,0,0> }
        #local wellNr = wellNr + 1;
      #end
    }
    #local switchNr = 0;
    #while (switchNr < nrSwitches)
      #local xShift = (switchNr+0.5)*2.54;
      object {IC_SMD_PIN(1.5,1.5,0.8,0.3) rotate +90*y translate<xShift+0.5,0,0.0>} 
      object {IC_SMD_PIN(1.5,1.5,0.8,0.3) rotate -90*y translate<xShift+0.5,0,6.7>} 
      #local onOff = SRand(1);
      #if (onOff < 0)
        object { offSwitch translate<xShift,0,0> }
      #else
        object { onSwitch translate<xShift,0,0> }
      #end
      text {
        ttf besch_font str(switchNr,2,0) .01, 0
        pigment { NewTan }
        scale 1.5
        rotate<90,0,0>
        translate<xShift-.2,3.96,.5>
      }
      #local switchNr = switchNr + 1;
    #end
    text {
      ttf besch_font "ON" .01, 0
      pigment { NewTan }
      scale 1.5
      rotate<90,0,0>
      translate<0.5,3.96,5.2>}
 //   translate<-nrSwitches-.5,0,-3.9>     
      translate<(-nrSwitches-.5)*2.54/2,0,-3.35>  
//    scale 2.54/2
    }
#end

#macro SMTDIP4()
object{SMT_DIP_GRND(4)}
#end   

#macro SMTDIP8(value1,value2)
object{SMT_DIP_GRND(8)}
#end          
 
#macro PC_POWER() 
object{CON_PCPWR514M_GRND()} 
rotate<0,-90,0>
#end                          

#macro RES_SMD_CHIP_0805(value)
object{RES_SMD_CHIP_GRND(1.25,2.00,0.45,0.40,value)}
#end

//****************************************************************************************
// Small stereo audio jack from CUI
//****************************************************************************************
#macro CON_SJ1_3515_GRND()
union{ 
union{    
difference{      
 box{<5,0,-7.5><-4.5,5,7.5>}                            //body    
 box{<-4.5,0,-3.7><-4.0,5.01,-2.2> texture{col_gold}}   //detent 
 }    
 cylinder{<0,0,0><0,-0.2,0>0.8     translate <0,0,-4.5>}//mounting pin 
 cylinder{<0,0,0><0,-0.2,0>0.8     translate <0,0,+2.5>}//mounting pin
  difference{                                    
  cylinder{<0,2.5,0><0,2.5,-3>2.5     translate <0,0,-7.5> texture{col_silver}}//plug 
  cylinder{<0,2.5,0><0,2.5,-3.01>1.8  translate <0,0,-7.5> pigment{Gray80}}//socket
 } 
}
polygon {5,<-4,-2.2>,<-4,-3.7>,<-0.75,-7.5>,<0.75,-7.5><-4,-2.2> texture{col_gold}
rotate<90,0,0> translate <0,5.01,0> }
union{ 
  box{<-.75,0,-.5><.75,0.1,0.5> translate <5,0,-1.0>}   //pin 4  
  box{<-.75,0,-.75><.75,0.1,0.75> translate <5.25,0,3>} //pin 2
  box{<-.75,0,-.75><.75,0.1,0.75> translate <-5.5,0,-3.2>}//pin 1
  box{<-.75,0,-.5><.75,0.1,0.5> translate <-5.5,0,0.1>} //pin 5
  box{<-.75,0,-.5><.75,0.1,0.5> translate <-5.5,0,3>}   //pin 3            
texture{col_gold}
} 
}                                                                                         
#end

#macro CON_SJ1_3515_SMT()
object{CON_SJ1_3515_GRND()}
#end                          
//****************************************************************************************
// Small stereo audio jack from CUI with PTH pins and thread lock
//****************************************************************************************      
#macro CON_3515_PTH_pin()  
difference{
        union{ 
                box{<-0.5,0,0.25><0.5,-3,-0.25>}                            //body          
                cylinder{<0,-3,0.25><0,-3,-0.25>0.5 }    
        }
        cylinder{<0,-3,0.26><0,-3,-0.26>0.25 }            
}
#end

#macro CON_3515_threads() 
  difference{
        union{  
          object{SMA_THREADS(3.6,6.0,0.5,3.5) translate <0,3,-3.5> texture{col_gold}} 
          cylinder{<0,3,0><0,3,-3.5>2.8 } 
        }
    cylinder{<0,3,-0.1><0,3,-3.6>1.8 } 
  } 
#end  

#macro CON_3515_PTH()
union{    
union{      
 box{<5.75,0,0><-5.75,5,14>}                            //body black base   
 box{<5.75,5,0><-5.75,6,14>texture{col_silver}}         //body white cap 
}  
  
object{CON_3515_threads()} 
//object{SMA_THREADS(3.6,6.0,0.5,3.5) translate <0,3,-3.5> texture{col_gold}} 
  
object{CON_3515_PTH_pin() translate<0,0,1.8>       texture{col_silver}} //pin1
object{CON_3515_PTH_pin() translate <-5.3,0,-4.5>  rotate<0,90,0> texture{col_silver}} //pin2
object{CON_3515_PTH_pin() translate <-10.1,0,5>    rotate<0,90,0> texture{col_silver}} //pin3
object{CON_3515_PTH_pin() translate <-4.2,0,12.9> texture{col_silver}} //pin4
object{CON_3515_PTH_pin() translate <-8.4,0,2.5>   rotate<0,90,0> texture{col_silver}} //pin5

}                                                                                         
#end

//****************************************************************************************
// Slide switch EG1313 
//****************************************************************************************
#macro CON_SLIDE_SWITCH_GRND()
union{
  box{<-8,0,0><8,5,3.8> texture{col_silver}}            //body
  box{<0,2.5,0><2,4.5,-2>}                              //button 
                                         
union{ 
  cylinder{<8.3,-1,1.9><8.3,0.4,1.9>0.6}	        //mounting pin
  cylinder{<8.3,-1,1.9><-8.3,0.4,1.9>0.6}	        //mounting pin   
  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,1.9>}	//pin 1  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,1.9>}	//pin 2 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,1.9>}	//pin 3 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,1.9>}	//pin 4       
  texture{T_Chrome_5A} 
}
}
pigment{Gray20} 
#end

#macro CON_SWITCH1313()
object{CON_SLIDE_SWITCH_GRND()}
#end
           
//****************************************************************************************
// Slide switch SWITCHDP3T 
//****************************************************************************************
#macro CON_SWITCHDP3T_GRND()
union{                          
     difference{
        box{<-7.45,0,0><7.45,5.5,6> texture{col_silver}}//body   
        box{<-4,0.7,-0.01><4,4.8,0.1> texture{Dull}}//body detent   ??
     }
     box{<-4,1.05,-2><-2,3.15,0>}                       //button 
     box{<-4,1.05,-2><-3.6,3.15,-2.1>}                  //button texture
     box{<-3.2,1.05,-2><-2.8,3.15,-2.1>}                //button texture
     box{<-2.4,1.05,-2><-2.0,3.15,-2.1>}                //button texture
                                         
union{ 
  cylinder{<-7.45,0.4,5.375><-7.45,-1,5.375>0.6}	//mounting pin
  cylinder{<7.45,0.4,0.625><7.45,-1,0.625>0.6}	        //mounting pin   
  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,1.55>}	//pin 5  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,1.55>}	//pin 6 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,1.55>}	//pin 7 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,1.55>}	//pin 8  

  cylinder{<0,0,0><0,-1,0>0.25 translate <-4,0,4.05>}	//pin 1  
  cylinder{<0,0,0><0,-1,0>0.25 translate <-2,0,4.05>}	//pin 2 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 0,0,4.05>}	//pin 3 
  cylinder{<0,0,0><0,-1,0>0.25 translate < 4,0,4.05>}	//pin 4        
  texture{T_Chrome_5A} 
}
}
pigment{Gray20} 
#end

#macro CON_SWITCHDP3T()
  object{CON_SWITCHDP3T_GRND()}
  translate<7.45,0,-6>
#end           
           
//****************************************************************************************
// Microphone  WM63PR 
//****************************************************************************************
#macro MICROPHONE()    
union{
union{
  torus{2.5,0.5 translate <0,0.8,0>}                    //body top  
  cylinder{<0,0,0><0,1.3,0>3.0}	                        //body 
  torus{2.5,0.5 translate <0,0.5,0>}                    //body bottom  
  texture{T_Chrome_5A}  
}
union{
  cylinder{<0,0,0><0,-1,0>0.25 translate <1,0,1>}	//pin 
  cylinder{<0,0,0><0,-1,0>0.25 translate <-1,0,1>}	//pin
  texture{T_Chrome_5A} 
}  
  cylinder{<0,0,0><0,0.5,0>2.8 translate <0,1.32,0>}	//screen 
}  
       
pigment{Gray20} 
#end
       
#macro WM63PRMIC()       
  object{MIC()}
#end
                   
//****************************************************************************************
// 1x6 female connector 2.54mm 
//****************************************************************************************
#macro BL_1X6_t()  
object{BL_1X6()}
rotate<0,180,0> 
#end   
//****************************************************************************************
// 1x8 female connector 2.54mm 
//****************************************************************************************
#macro BL_1X8_t()  
object{BL_1X8()}
rotate<0,180,0> 
#end    
                   
//****************************************************************************************
// 1x6 female connector 2.54mm 
//****************************************************************************************
#macro BL_1X6_f()  
object{BL_1X6()}
rotate<180,180,0> 
#end   
//****************************************************************************************
// 1x8 female connector 2.54mm 
//****************************************************************************************
#macro BL_1X8_f()  
object{BL_1X8()}
rotate<180,180,0> 
#end       
          
//****************************************************************************************
// 1x6 Stake connector 2.54mm 
//****************************************************************************************
#macro POWER_PIN(value)  
object{PH_GRND(1,6,0,2.54)}
rotate<180,0,0> 
#end    
//****************************************************************************************
// 1x6 Stake connector 2.54mm 
//****************************************************************************************
#macro ANALOG_PIN(value)  
object{PH_GRND(1,6,0,2.54)}
rotate<180,0,0> 
#end    
//****************************************************************************************
// 1x8 Stake connector 2.54mm 
//****************************************************************************************
#macro IOH_PIN(value)  
object{PH_GRND(1,8,0,2.54)}
rotate<180,0,0> 
#end
//****************************************************************************************
// 1x8 Stake connector 2.54mm 
//****************************************************************************************
#macro IOL_PIN(value)  
object{PH_GRND(1,8,0,2.54)}
rotate<180,0,0> 
#end
       
//****************************************************************************************
// 1x4 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_1X4EDGE(value)  
object{PH_GRND(1,4,0,2.54)}
rotate<90,0,0> 
translate<+3.81,0.1,+2.54>
#end

//****************************************************************************************
// 2X2 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X2EDGE(value)  
object{PH_GRND(2,2,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end
     
//****************************************************************************************
// 2X3 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X3EDGE(value)  
object{PH_GRND(2,3,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end
     
//****************************************************************************************
// 2X5 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X5EDGE(value)  
object{PH_GRND(2,5,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end 

//****************************************************************************************
// 2X7 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X7EDGE(value)  
object{PH_GRND(2,7,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end

//****************************************************************************************
// 2X18 Edge connector 2.54mm 
//****************************************************************************************
#macro CON_2X18EDGE(value)  
object{PH_GRND(2,18,0,2.54)}
rotate<-90,0,0> 
translate<0,-1.27,-2.54>
#end

//****************************************************************************************
// Tantalum 1206 pkg 
//****************************************************************************************
#macro C1206P(value)  
object{CAP_SMD_CHIP_TT_GRND(3.2,1.6,1.6,3.2,1.2,1.6,0.8,value)}
#end

//****************************************************************************************
// Voltage regulator SOT3233 pkg 
//****************************************************************************************
#macro SOT3233(value,logo)  
object{IC_SMD_GRND(3.0,1.7,1.45,3,3,2,0.95,1.9,0.5,0.5,0.2,0.15,0,1,0,0.3,0,0,logo)}  
translate<+1.5,0.0>
#end    

//****************************************************************************************
// Voltage regulator DBVSOT pkg 
//****************************************************************************************
#macro DBVSOT(value,logo)  
object{IC_SMD_GRND(3.0,1.7,1.45,3,3,2,0.95,1.9,0.5,0.5,0.2,0.15,0,1,0,0.3,0,0,logo)}  
#end 

//****************************************************************************************
// Voltage regulator SOT89 pkg 
//****************************************************************************************
#macro SOT89(value,logo)  
object{IC_SMD_GRND(4.6,2.6,1.6,4.25,3,1,1.57,1.83,0.44,0.1,0.2,0.15,0,1,0,0.3,0,0,logo)}  
#end


//****************************************************************************************
// SMD Oscillator
//****************************************************************************************
#macro OSC_GRND(value)
union{ 
difference{
 box{<-3.5,0,0><3.5,1.6,5> texture{col_gold}}          //body
 cylinder{<0,0,0><0,1.6,0>0.8  translate<-2.5,0,0> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<+2.5,0,0> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<-2.5,0,5> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,1.6,0>0.8  translate<+2.5,0,5> texture{col_silver}} //pin 4     
}
 box{<-3.0,1.6,0.5><+3.0,1.7,4.5> texture{col_gold}}  //body   
 cylinder{<-2.5,1.7,1><-2.5,1.71,1>0.3 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale 1 rotate <90,0,0> translate<-3,1.71,2.5> pigment{Black}}
}         
translate<+3.5,1>
#end 
        
//****************************************************************************************
// SMD Crystal  3.2x2.5mm
//****************************************************************************************
#macro XTAL_small(value)
union{ 
difference{
 box{<-1.6,0,1.25><1.6,0.7,-1.25> pigment{Gray10}}          //body 
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,1.25> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,1.25> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,-1.25> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,-1.25> texture{col_silver}} //pin 4    
}
 box{<-1.2,0.71,-0.85><+1.2,0.75,0.85> texture{col_gold}}  //body   
 cylinder{<-1.4,0.75,1.25><-1.4,0.76,1.25>0.2 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale .7 rotate <90,0,0> translate<-1.0,0.76,-0.25> pigment{Black}}
}
translate<+1.6,0,1.25>         
#end         
        
//****************************************************************************************
// SMD Oscillator  3.2x2.5mm
//****************************************************************************************
#macro OSC_small(value)
union{ 
difference{
 box{<-1.6,0,1.25><1.6,0.7,-1.25> pigment{Gray10}}          //body 
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,1.25> texture{col_silver}} //pin 1     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,1.25> texture{col_silver}} //pin 2     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<-1.6,0,-1.25> texture{col_silver}} //pin 3     
 cylinder{<0,0,0><0,0.71,0>0.3  translate<+1.6,0,-1.25> texture{col_silver}} //pin 4    
}
 box{<-1.2,0.71,-0.85><+1.2,0.75,0.85> texture{col_gold}}  //body   
 cylinder{<-1.4,0.75,1.25><-1.4,0.76,1.25>0.2 pigment{Black}}      //pin 1 dot
 text{ttf besch_font value 1, 0 scale .7 rotate <90,0,0> translate<-1.0,0.76,-0.25> pigment{Black}}
}        
#end                      

//
// 20 pin QLP
//
#macro IC_SMD_QLP20(value,logo)
object{QFP_GRND(2.8,2.8,0.6,5,5,5,5,0.5,0.28,0.1,2.4,2.8,0.22,90,0,logo)}
#end

//****************************************************************************************
// CASON8 Flash memory
//****************************************************************************************
#macro IC_SMD_CASON8(value)
union{
 box{<-4,0,0><4,1,6> }        //body
 cylinder{<-3,1,5><-3,1.1,5>0.2 texture{col_silver}}  //pin 1 
 text{ttf besch_font value 1, 0 scale 1 rotate <90,0,0> translate<-3,1.01,1.5> pigment{White}}
 text{ttf global_fontfile_eagle3d "a" 1, 0 scale 2 rotate <90,0,0> translate<-2,1.01,3> pigment{White}} 
}             
pigment{Gray20} 
translate<+4,0.0>
#end
    
//****************************************************************************************
// Xilinx Platform Flash memory  
//IC_SMD_GRND(LK,BK,HK,B,pin_u,pin_o,ptch_u,ptch_o,pinb_u,pinb_o,pin_s,di_pcb,kor_w,pin0_m,pin0_45,pin0_a,besch_s,besch_w,logo)
//****************************************************************************************
#macro IC_SMD_VOG20(value,logo)
object{IC_SMD_GRND(6.6,4.5,1.2,6.6,10,10,0.625,0.625,0.305,0.305,0.15,1.1,0,1,0,0.3,0,0,logo)}  
#end                          

   
//****************************************************************************************
// Edge connector socket 
//****************************************************************************************
#macro CON_EDGESKT(value)  
union{ 
 box{<-1.270,+0.000,+0.000><+1.270,+1.000,+8.250> pigment{Black}}       //socket body
 box{<-1.092,+0.285,-0.300><+1.092,+0.715,+8.250> texture{col_gold}}    //socket contact 
 box{<-0.430,+0.285,+8.250><+0.430,+0.385,+11.76> texture{col_gold}}    //socket pin  
// polygon{<-1.270,+2.54,+0.100><+1.270,+2.54,+0.100><+1.092,+2.362,+0.100><-1.270,+2.54,+0.100>}
} 
translate<+0.000,-0.285,-11.00>  

#end    

/********************************************************************************************************************************************
//
********************************************************************************************************************************************/
#macro EDGESKT(rows,pins)
union{
#if(rows=1)
#local i=0;
        #while(i<pins)
                object{CON_EDGESKT() translate<i*2.54,0,0>}
                #local i=i+1;
        #end
        translate<-(pins-1)*1.27,0,0>
#else
        #local i=0;
        #while(i<pins)
                object{CON_EDGESKT(value) translate<i*2.54,0,1.27>}
                object{CON_EDGESKT(value) translate<i*2.54,0,-1.27>}
                #local i=i+1;
        #end
        translate<-(pins-1)*1.27,0,0>
#end
}
#end

#macro CON_2x5EDGESKT(value)
object{EDGESKT(2,5)}
#end
            
            
/********************************************************************************************************************************************
//
//L = length over everything (x axis) 
//B = width over everything (Z-axis) 
//H = height plastic (y axis) 
//pin_l = number of pin left 
//pin_r = number of pin right 
//pin_o = number of pin above 
//pin_u = number of pin down 
//pitch = distance of the individual pins 
//pin_br = width of a pin 
//pin_h = strength of the pin material 
//LK = length plastic (x axis) 
//BK = width plastic (Z-axis) 
//HKoP = height of the plastic over the plate (y axis) 
//KORW = correction angle 
//kp1ab = if not 0 is produced no chamfer at Pin1 
//logo = name OF the logo    
//package colour 
********************************************************************************************************************************************/
#macro QFP_GRND_DNC(L,B,H,pin_l,pin_r,pin_o,pin_u,pitch,pin_br,pin_h,LK,BK,HKoP,KORW,kp1ab,logo,pkgcolour)
union{
	difference{
		box{<-LK/2,HKoP,-BK/2><LK/2,HKoP+H,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,-1> rotate<-10,0,0> translate<0,HKoP+H/2-pin_h/2,-BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,-2,1> rotate<10,0,0> translate<0,HKoP+H/2-pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,1> rotate<-10,0,0> translate<0,HKoP+H/2+pin_h/2,BK/2>}
		box{<-LK/2-0.01,0,0><LK/2+0.01,2,-1> rotate<10,0,0> translate<0,HKoP+H/2+pin_h/2,-BK/2>}
		box{<0,0,-BK/2-0.01><1,2,BK/2+0.01> rotate<0,0,10> translate<LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,2,BK/2+0.01> rotate<0,0,-10> translate<-LK/2,HKoP+H/2+pin_h/2,0>}
		box{<0,0,-BK/2-0.01><1,-2,BK/2+0.01> rotate<0,0,-10> translate<LK/2,HKoP+H/2-pin_h/2,0>}
		box{<0,0,-BK/2-0.01><-1,-2,BK/2+0.01> rotate<0,0,10> translate<-LK/2,HKoP+H/2-pin_h/2,0>}
		#if(kp1ab=0)
			box{<0,0,-3><-2,5,3> rotate<0,-45,0> translate<-LK/2+LK/40,0,-BK/2+BK/40>}
		#end
		cylinder{<0,H+HKoP-0.1,0><0,H+HKoP+1,0>0.4 translate<-LK/2+LK/10,0,-BK/2+BK/10>}
		pigment{pkgcolour}
	}
	
	#local i=0;
	#while(i<(pin_l/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i+pitch/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,pitch*i>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,0,0> translate<LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end
	
	#local i=0;
	#while(i<(pin_r/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i+pitch/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i-pitch/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,pitch*i>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(L-LK)/2,pin_br,pin_h) rotate<0,180,0> translate<-LK/2,0,-pitch*i>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_u/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i+pitch/2,0,-BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i-pitch/2,0,-BK/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<pitch*i,0,-BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,90,0> translate<-pitch*i,0,-BK/2>}
		#end
		#local i=i+1;
	#end

	#local i=0;
	#while(i<(pin_o/2))
		#if((pin_l/2)=div(pin_l,2))
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i+pitch/2,0,BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i-pitch/2,0,BK/2>}
		#else
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<pitch*i,0,BK/2>}
			object{QFP_PIN((H+HKoP)/2+pin_h/2,(B-BK)/2,pin_br,pin_h) rotate<0,-90,0> translate<-pitch*i,0,BK/2>}
		#end
		#local i=i+1;
	#end
	
	#local scl_fa = BK/10;
	#local value_arial_size_min = 0.0;
	#local value_arial_size_max = 0.0;
	#local value_arial_size = 0.0;
	#local value_courier_size_min = 0.0;
	#local value_courier_size_max = 0.0;
	#local value_courier_size = 0.0;
//	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_arial_bold =  text{ttf global_fontfile_arial_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_courier_bold = text{ttf global_fontfile_courier_bold value 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_arial_bold, value_arial_size_min, value_arial_size_max)
	Extents(value_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_arial_size = value_arial_size_max - value_arial_size_min; 
	#local value_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_scale_factor_arial = BK/value_arial_size.z * 0.7;
	#local value_scale_factor_courier = BK/value_courier_size.z * 0.7;	
	
	#if(value_arial_size.x*value_scale_factor_arial > LK/6.0) 
                #local value_scale_factor_arial = LK/6.0 / value_arial_size.x;	
	#end
	#if(value_courier_size.x*value_scale_factor_courier > LK/6.0) 
                #local value_scale_factor_courier = LK/6.0 / value_courier_size.x;	
	#end
		
	#local value_arial_size = value_arial_size * value_scale_factor_arial; 
	#local value_courier_size = value_courier_size * value_scale_factor_courier;
	//a random datecode string
	#local value_datecode_arial_size_min = 0.0;
	#local value_datecode_arial_size_max = 0.0;
	#local value_datecode_arial_size = 0.0;
	#local value_datecode_courier_size_min = 0.0;
	#local value_datecode_courier_size_max = 0.0;
	#local value_datecode_courier_size = 0.0;
	#local value_datecode_string = concat(str(rand(global_seed)*52.9, -2, 0),str(rand(global_seed)*3.9+2, -2, 0));	
//	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_arial_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	#local value_datecode_courier_bold = text{ttf global_fontfile_arial_bold value_datecode_string 0.2,0 rotate<90,-90,0> pigment{White}}
	Extents(value_datecode_arial_bold, value_datecode_arial_size_min, value_datecode_arial_size_max)
	Extents(value_datecode_courier_bold, value_courier_size_min, value_courier_size_max)
	#local value_datecode_arial_size = value_datecode_arial_size_max - value_datecode_arial_size_min; 
	#local value_datecode_courier_size = value_courier_size_max - value_courier_size_min;	
	#local value_datecode_scale_factor_arial = value_scale_factor_arial;
	#local value_datecode_scale_factor_courier = value_scale_factor_courier;
	#local value_datecode_arial_size = value_datecode_arial_size * value_scale_factor_arial; 
	#local value_datecode_courier_size = value_datecode_courier_size * value_scale_factor_courier;
	
		
	#local logo_assigned = 0;
		
	#if(strcmp(logo,"FTDI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "f" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end
	
	#if(strcmp(logo,"ATMEL")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "a" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/2+BK/6> pigment{White} rotate<0,+90,0>}		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2> rotate<0,+90,0>} 
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>rotate<0,+90,0>}
	#end

	#if(strcmp(logo,"TI")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d ":" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/10> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end

	#if(strcmp(logo,"XILINX")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "#" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	

	#if(strcmp(logo,"MICROCHIP")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "m" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	


	#if(strcmp(logo,"CYPRESS")=0.0)
	        #local logo_assigned = 1;
		text{ttf global_fontfile_eagle3d "}" 0.2,0 scale<scl_fa*2,scl_fa*2,1> rotate<90,-90,0> translate<-LK/2+LK/3,H+HKoP+0.001,-BK/4> pigment{White} }		
		object{value_arial_bold scale<value_scale_factor_arial,1,value_scale_factor_arial> translate<value_arial_size.x/2,H+HKoP+0.001,-value_arial_size.z/2>}
		object{value_datecode_arial_bold scale<value_datecode_scale_factor_arial,1,value_datecode_scale_factor_arial> translate<value_datecode_arial_size.x/2,H+HKoP+0.001,-value_datecode_arial_size.z/2> translate<LK/2-LK/4,0,0>}
	#end	

	
	#if(logo_assigned < 0.5)
		text{ttf besch_font value 0.2,0 scale<scl_fa,scl_fa,1> rotate<90,-90,0> translate<-LK/2+LK/4,H+HKoP+0.001,-BK/2+BK/6> pigment{White} }
	#end
	
	rotate<0,KORW,0>
}
#end


//LQFP-64 aus DS80C390 Datasheet
#macro LQFP_64_050MM_DNC(value,logo)
object{QFP_GRND_DNC(12,12,1.4,16,16,16,16,0.5,0.22,0.15,10,10,0.1,0,0,logo)}
#end
            
            
/********************************************************************************************************************************************
//
********************************************************************************************************************************************/    
//Pin
#macro Pin()  
	box{<1.0,0,-0.3><0,0.1,0.3>}                									//pin pad        
#end           

//Body
#macro Body_detent() 
union{
	box{<-0.8,-0.5,0><-0.7,1.5,-0.1>}   
	box{<-0.7,1.3,0><0.7,1.5,-0.1>} 
	box{<0.8,-0.5,0><0.7,1.5,-0.1>}  
}   
rotate <90,0,0> 
translate<0,1.72,3.05> 
texture{pigment{Blue}}           
#end 


//Body
#macro Body()   
difference{ 
        union{
	        box{<-2.0,0,0><2,1.8,6.1> texture{pigment{White*.9}}}
	        object{Body_plate()}   
	}             										//body   
	object{Body_detent()} 								//pin4 
}
#end    

//Body_plate
#macro Body_plate()   
union{
	box{<-1.91,0,-0.01><1.91,0.1,6.11>}   
	box{<-1.9,0.1,1.3><-2,-0.75,3.9>} 
	box{<+1.9,0.1,1.3><+2,-0.75,3.9>}             										  
} 
translate<0,1.71,0>
texture{T_Silver_1B}   
//texture{pigment{Blue}}
#end      

//Mounting Pin
#macro Mount_Pin()        
union{
	cylinder{<0,0,0><0,-0.5,0>0.45 translate<0,0,1.55> texture{pigment{Yellow}}}  	//pin pad  
	cylinder{<0,0,0><0,-0.5,0>0.45 translate<0,0,4.55>  texture{pigment{Yellow}}}        
}
#end      

//Button
#macro Button()  
union{   
        difference{      
                box{<-1.2,0.1,0><1.2,1.6,-1.3> texture{pigment{Blue}}}             	        //button   
                union{
                        box{<-0.7,1.4,-0.65><0.7,1.61,0> texture{pigment{Blue*0.1}}}                            //button top deepest detent 
                        box{<-0.7,0.1,-0.65><0.7,0.3,0> texture{pigment{Blue*0.1}}} 
                        box{<-2,0,-2><2,1.7,0> rotate<0,+45,0> translate<-0.7,0,-1.3> texture{pigment{Blue*0.8}}} 
                        box{<-2,0,-2><2,1.7,0> rotate<0,-45,0> translate<+0.7,0,-1.3> texture{pigment{Blue*0.8}}}     
                }
        }  
        box{<-0.5,1.5,-0.65><0.5,1.4,0> texture{pigment{Blue*0.5}}}                                     //button top shallow detent
        box{<-0.5,0.1,-0.65><0.5,0.2,0> texture{pigment{Blue*0.5}}}   

}
#end   

                                             
 
 
#macro CON_COLLISION()
union{
object{Pin() translate<2,0,4.55>       texture{col_silver}} 						//pin1
object{Pin() translate<2,0,1.55>       texture{col_silver}} 						//pin2 
object{Pin() rotate<0,180,0> translate<-2,0,4.55>      texture{col_silver}} 		//pin3
object{Pin() rotate<0,180,0> translate<-2,0,1.55>      texture{col_silver}} 		//pin4  

object{Body()} 										//body   
object{Mount_Pin()} 																//mounting     
object{Button()}  
translate<0,0,-3.01>
}  
#end     


//****************************************************************************************
// JTI_ANTENNA Johanson Technology SMT Antenna 2.45GHz 50 ohm 
// Part #
// Digi-Key #
//****************************************************************************************                                                     					// pin at origin       
#macro JTI_ANTENNA()                                              
union{                
        box{<-1.75,0,0><1.75,1.3,7.6> texture{pigment{Blue*0.8}}}       //body    
        
        box{<+1.751,0,-0.001><+1.05,1.31,0.8> texture{col_silver}}      //pin 1
        box{<-0.35,0,-0.001><+0.35,1.31,0.8> texture{col_silver}}       //pin 2  
        box{<-1.751,0,-0.001><-1.05,1.31,0.8> texture{col_silver}}      //pin 3

        box{<-1.751,0,+7.601><-1.05,1.31,+7.20> texture{col_silver}}    //pin 4
        box{<-0.35,0,+7.601><+0.35,1.31,+7.20> texture{col_silver}}     //pin 5
        box{<+1.751,0,+7.601><+1.05,1.31,+7.20> texture{col_silver}}    //pin 6 
          
        box{<+0.4,1.311,1.5><-0.4,1.311,2.3> texture{pigment{Brown}}}   //mount dot
}  
translate<0,0,-3.8>
rotate<0,90,0>
#end   


//****************************************************************************************
// JTI_BALUN Johanson Technology Balun 2.45GHz balance to 50 ohm 
// Part #
// Digi-Key #
//****************************************************************************************                                                 					     
#macro JTI_BALUN()                                              
union{
        box{<-0.75,0,0><0.75,0.9,2> texture{pigment{Yellow*0.8}}}       //body
        																    
        box{<-0.5,0,-0.01><-0.2,0.91,0.2> texture{col_silver}}          //pin 1
        box{<+0.5,0.91,0.2><+0.2,0,-0.01> texture{col_silver}}          //pin 2 

        box{<+0.2,0,2.01><+0.5,0.91,1.8> texture{col_silver}}           //pin 3 
        box{<-0.5,0,2.01><-0.2,0.91,1.8> texture{col_silver}}           //pin 4
                
        box{<-0.76,0,0.6><-0.55,0.91,1.4> texture{col_silver}}          //pin 5 side gnd 
        box{<+0.76,0,0.6><+0.55,0.91,1.4> texture{col_silver}}          //pin 6 side gnd
   
        
        box{<+0.35,0.91,0.7><-0.35,0.91,1.0> texture{pigment{Brown}}}  
}   
translate<0,0,-1>
rotate<0,90,0>
#end


 
//****************************************************************************************
// micro SD
//****************************************************************************************

//SD Pin
#macro SDPin()
union{
     box{<-0.175,0,0><+0.175,0.2,1.6> texture{pigment{Gold*.9}}}  
     box{<-0.175,0,1.6><+0.175,0.2,2.4> texture{pigment{Gold*.7}}} 
     box{<-0.175,0,2.4><+0.175,0.2,3.2> texture{pigment{Gold*.5}}} 
     cylinder{<0,0,3.2><0,0.05,3.2>0.175 texture{pigment{Gold*.5}}}    
} 
#end       


//Body
#macro CON_MICROSD()   
union{
difference{
     union{
	     box{<0,0,0><14,1.85,14.2> texture{pigment{Grey*.9}}}             //body
	     box{<0,1.85,15.2><5.65,0,14.2> texture{pigment{Grey*.9}}}   
	     text{ttf besch_font "3M" 1,0 scale<2,2,1> rotate<90,90,0> texture{pigment{Grey*0.7}} translate<12,1.9,6.5>}
	}             
	box{<0.1,-0.01,2><13.9,1.65,14.1> texture{pigment{Grey*.5}}}     //hollow body
	
	box{<7.05,-0.01,-0.01><5.85,1.95,0.6> texture{pigment{White*.9}}}    //solder pad detents
	box{<11.55,1.95,0.6><12.75,-0.01,-0.01> texture{pigment{White*.9}}}   
	box{<6.25,-0.01,13.6><13.4,1.86,14.21> texture{pigment{White*.9}}}  
	box{<-0.01,1.86,15.21><0.6,-0.01,13.9> texture{pigment{White*.9}}} 
	
	box{<0,-0.01,0><3,1.86,-7.1> translate<0.6,0,13> texture{pigment{White*.9}}}             //Eject detent
	//slot
	union{
	     box{<2.7,-0.01,2><3.3,1.86,5> texture{pigment{White*.9}}}  
	     cylinder{<3,-0.01,2><3,1.86,2>0.3texture{pigment{White*.9}}}  
	     cylinder{<3,-0.01,5><3,1.86,5>0.3texture{pigment{White*.9}}}         
	} 
	//detents
	cylinder{<5,1.66,3><5,1.86,3>0.3texture{pigment{White*.9}}}   
	cylinder{<8.5,1.66,3><8.5,1.86,3>0.3texture{pigment{White*.9}}}   
     cylinder{<12,1.66,3><12,1.86,3>0.3texture{pigment{White*.9}}}  
     cylinder{<5,1.75,3><5,1.86,3>0.4texture{pigment{White*.9}}}   
	cylinder{<8.5,1.75,3><8.5,1.86,3>0.4texture{pigment{White*.9}}}   
     cylinder{<12,1.75,3><12,1.86,3>0.4texture{pigment{White*.9}}}   

     
//Pin Detent 
     union{
          union{
               box{<-3.85,0,0.15><-2.85,0.3,-0.45> texture{pigment{Grey*.9}}}      //left 
               box{<-1.55,0,0.15><+1.55,0.3,-0.45> texture{pigment{Grey*.9}}}      //middle
               box{<+3.85,0,0.15><+2.85,0.3,-0.45> texture{pigment{Grey*.9}}}      //right
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<-3.85,0,-0.15>texture{pigment{Grey*.9}}}  
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<-2.85,0,-0.15>texture{pigment{Grey*.9}}}    
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<-1.55,0,-0.15>texture{pigment{Grey*.9}}} 
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<+1.55,0,-0.15>texture{pigment{Grey*.9}}} 
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<+2.85,0,-0.15>texture{pigment{Grey*.9}}} 
               cylinder{<0,-0.01,0><0,0.3,0>0.3 translate<+3.85,0,-0.15>texture{pigment{Grey*.9}}} 
     
               prism {linear_sweep 0.0, 0.3, 6,
               <-4.15,-0.15>, <-4.15,-2.4>, <-3.2,-3.2>  //left side
               <+3.2,-3.2>, <+4.15,-2.4>, <+4.15,-0.15>  //right side  
               texture{pigment{Grey*.9}}}
          }  
          translate<8.5,1.60,12>
     }    
     		
}                 
//Eject 
     union{
          union{
               box{<1.5,0,0><2.5,0.11,-6.1> texture{pigment{Grey*.9}}}
               cylinder{<1.5,0,-5.9><1.5,0.11,-5.9>0.6texture{pigment{Grey*.9}}}  
               cylinder{<2.5,0,-6.1><2.5,0.11,-6.1>0.6texture{pigment{Grey*.9}}}   
          }   
          translate<0,1.75,13> 
     }
  
      
//Pin array
     union{
          union{
               object{SDPin() translate<0.0,0.0,0.0>}   
               object{SDPin() translate<1.1,0.0,-0.8>}
               object{SDPin() translate<2.2,0.0,0.0>} 
               object{SDPin() translate<3.3,0.0,0.0>}
               object{SDPin() translate<4.4,0.0,0.0>}
               object{SDPin() translate<5.5,0.0,0.0>} 
               object{SDPin() translate<6.6,0.0,0.0>} 
               object{SDPin() translate<7.7,0.0,0.0>}     
          } 
     translate<4.96,0,10>
     } 
      
//PinClip   
     union{
          union{
               prism {linear_sweep 0.0, 0.3, 5,
               <-2.7,-0.15>, <-2,-2.6>, <-1.7,-2.6>  //left side
               <-1.7,-0.15>, <-2.7,-0.15>  //right side  
               texture{pigment{Grey*.9}}}     
     
               prism {linear_sweep 0.0, 0.3, 5,
               <+2.7,-0.15>, <+2,-2.6>, <+1.7,-2.6>  //left side
               <+1.7,-0.15>, <+2.7,-0.15>  //right side   
               texture{pigment{Grey*.9}}}  
          } 
          translate<8.5,1.60,12>
     }  
                                                                                 
}
#end                                                


//Coin cell holder
#macro CON_BA2032()  
union{
union{
     difference{ 
          union{ 
               box{<0,0,1.5><16,6.7,26.5> texture{pigment{Yellow}}}  
               box{<1.5,0,0><14.5,6.7,28> texture{pigment{Yellow}}}
	          cylinder{<0,0,0><0,6.7,0>1.5 translate< 1.5,0, 1.5> texture{pigment{Yellow}}}  
               cylinder{<0,0,0><0,6.7,0>1.5 translate<14.5,0, 1.5> texture{pigment{Yellow}}} 
               cylinder{<0,0,0><0,6.7,0>1.5 translate< 1.5,0,26.5> texture{pigment{Yellow}}} 
               cylinder{<0,0,0><0,6.7,0>1.5 translate<14.5,0,26.5> texture{pigment{Yellow}}} 
          }     
     cylinder{<8,3.0,14><8,6.8,14>12.52 texture{pigment{White}}}     
     cylinder{<8,2.0,14><8,6.8,14>11.5 texture{pigment{White*0.9}}}  
     }
     object{BA2032Pad() translate <8,0,0>}    
     object{BA2032Pad() rotate<0,180,0> translate <8,0,28>}   
     
//Plus plate
     union{ 
          union{
               difference{ 
                    union{ 
                         box{<-7.5,0,0><7.5,1,-4> texture{pigment{Yellow}}}    
                         box{<-8,0,-0.5><8,1,-4> texture{pigment{Yellow}}}  
                         cylinder{<0,-0.01,0><0,1.02,0>0.5 translate<-7.5,0,-0.5> texture{pigment{Yellow}}}      
                         cylinder{<0,-0.01,0><0,1.02,0>0.5 translate<+7.5,0,-0.5> texture{pigment{Yellow}}}  
                    }    
               cylinder{<0,-0.01,-14><0,1.02,-14>12.57 texture{pigment{Yellow*0.9}}}       
          } 
          box{<2,0,0><-2,1,-10> texture{pigment{Yellow}}}  
          cylinder{<0,0,-10><0,1,-10>3  texture{pigment{Yellow}}}
          }
          translate <8,5.71,28> 
     }
     
//Minus plate
     union{ 
          union{
               cylinder{<1.5,0,1.5><1.5,1,1.5>1.5  texture{pigment{Yellow}}}  
               cylinder{<14.5,0,1.5><14.5,1,1.5>1.5  texture{pigment{Yellow}}}
               prism {linear_sweep 0.0, 1, 9,
               <1.5,0>, <14.5,0>, <14.5,3>  //left side
               <12,3>, <12,3.5>, <4,3.5>  //right side  
               <4,3>, <1.5,3>, <1.5,0>
               texture{pigment{Yellow*.9}}}  
     
               box{<-0.75,0,0><+0.75,1,5> rotate<0,20,0> translate<0.75,0,0.75>  texture{pigment{Yellow}}}    
               box{<-0.75,0,0><+0.75,1,5> rotate<0,-20,0> translate<15.25,0,0.75>  texture{pigment{Yellow}}}
          }  
          translate <0,6.71,0>
     }   
     
//MinusContact
     union{      
          union{
               cylinder{<1,0,4><1,0.1,4>1  texture{pigment{Gold}}}  
               cylinder{<7,0,4><7,0.1,4>1  texture{pigment{Gold}}}
               prism {linear_sweep 0.0, 0.1, 9,
               <0,0>, <8,0>, <8,4>           //left side
                    <6,4>, <6,2>, <2,2>      //right side  
               <2,4>, <0,4>, <0,0>
               texture{pigment{Gold*.9}}}  
          }      
          translate <4,2,+3>
      }  
rotate<0,90,0>translate <-14,0,8>
}        
}
#end    
  
  
  

#macro BA2032Pad() 
difference{ 
union{ 
     box{<0,0,0.5><3.56,1,2> texture{pigment{Gold}}}  
     box{<0.5,0,0><3.06,1,2> texture{pigment{Gold}}}  
     cylinder{<0,-0.01,0><0,1.02,0>0.5 translate<0.5,0,0.5> texture{pigment{Gold}}}      
     cylinder{<0,-0.01,0><0,1.02,0>0.5 translate<3.06,0,0.5> texture{pigment{Gold}}}
}    
cylinder{<0,-0.01,0.78><1.75,1.01,0.75>0.2 texture{pigment{White}}}       
}  
translate <-1.78,0,-2>
#end 


//****************************************************************************************
// BNC Connector
//****************************************************************************************    
#macro CON_BNC()   
union{  
        difference{
                union{
                        box{<-7.35,0,0><7.35,14.8,12.3> texture{pigment{White*1.3}}}      //body   
                        box{<-6.35,0,0><6.35,15.8,12.3> texture{pigment{White*1.3}}}                          
	                cylinder{<0,0,0><0,0,12.3>1 texture{pigment{White*1.3}} translate<-6.35,14.8,0>}     
	                cylinder{<0,0,0><0,0,12.3>1 texture{pigment{White*1.3}} translate<+6.35,14.8,0>}    
	        }
	        cylinder{<0,8.15,12.41><0,8.15,12.4-5>4.8 texture{pigment{White}}}      //backside detents
	        cylinder{<0,8.15,12.41-5><0,8.15,12.4-5-2>4.0 texture{pigment{Silver}}}  
	        cylinder{<-6,1.35,12.42><-6,1.35,12.42-5>0.6 texture{pigment{White*1.3}}}  
	        cylinder{<+6,14.8-1.35,12.42><+6,14.8-1.35,12.42-5>0.6 texture{pigment{White*1.3}}} 
	}  
	difference{
	        cylinder{<0,8.15,12.41-3><0,8.15,12.41-7>1.0 texture{pigment{White*.9}}} //coax pin
	        cylinder{<0,8.15,12.42-3><0,8.15,12.41-7>0.89/2 texture{pigment{Gold*.9}}}   
	}
	
	union{union{
	        box{<0,-0.25,-0.5><1.2,+0.25,0.5>}                                       //plastic tabs
	        cylinder{<1.2,-0.25,0><1.2,+0.25,0>0.5}
	}texture{pigment{White*1.2}}rotate<90,-180,0> translate<7.35,6.15,12.4> 
	}  
	union{union{
	        box{<0,-0.25,-0.5><1.2,+0.25,0.5>}
	        cylinder{<1.2,-0.25,0><1.2,+0.25,0>0.5}
	}texture{pigment{White*1.2}}rotate<90,-180,0> translate<7.35,10.15,12.4> 
	} 
	union{union{
	        box{<0,-0.25,-0.5><1.2,+0.25,0.5>}
	        cylinder{<1.2,-0.25,0><1.2,+0.25,0>0.5}
	}texture{pigment{White*1.2}}rotate<90,0,0> translate<-7.35,10.15,12.4> 
	}	
	union{union{
	        box{<0,-0.25,-0.5><1.2,+0.25,0.5>}
	        cylinder{<1.2,-0.25,0><1.2,+0.25,0>0.5}
	}texture{pigment{White*1.2}}rotate<90,0,0> translate<-7.35,6.15,12.4> 
	}
	
	text{ttf besch_font "+" 0.1,0 scale<2,2,1> rotate<0,0,0> texture{pigment{Grey*1}} translate<-5,12,12.41>}     
	text{ttf besch_font "+" 0.1,0 scale<2,2,1> rotate<0,0,0> texture{pigment{Grey*1}} translate<+5,3,12.41>}  
	
	union{
	cylinder{<0,8.15,12.41><0,-3.7,12.41>0.89/2 texture{pigment{Gold*1.5}}}           //pins
	cylinder{<+2.54,8.15,12.41><+2.54,-3.7,12.41>0.89/2 texture{pigment{Silver*1.5}}}  		
        sphere{<0,8.15,12.41>,0.89/2 texture{pigment{Gold*1.5}}}
        sphere{<+2.54,8.15,12.41>,0.89/2 texture{pigment{Silver*1.5}}}  
        cylinder{<0,8.15,12.41><0,8.15,12.41-6>0.89/2 texture{pigment{Gold*1.5}}}       //pins 
        cylinder{<+2.54,8.15,12.41><+2.54,8.15,12.41-6>0.89/2 texture{pigment{Silver*1.5}}}       //pins    
        }
         
        cylinder{<0,0,0><0,-3.8,0>1.0 texture{pigment{White*.9}} translate<+5.08,0,7.3>}  //mounting pin
        cylinder{<0,0,0><0,-3.8,0>1.0 texture{pigment{White*.9}} translate<-5.08,0,7.3>}  //mounting pin   



	union{
	difference{ 
	        union{
	                cylinder{<0,8.15,0><0,8.15,-20.3>4.8 texture{Chrome_Metal}}       //coax    
	             //   cylinder{<-5.5,8.15,-18><+5.5,8.15,-18>0.5 texture{Chrome_Metal}} //bayonet  
	                cylinder{<0,8.15-5.5,-18><0,8.15+5.5,-18>0.5 texture{Chrome_Metal}} //bayonet
	        }
	        cylinder{<0,8.15,0><0,8.15,-20.31>4.3 texture{pigment{White*.9}}}         //coax inside
	}     
        cylinder{<0,8.15,0><0,8.15,-8.3>5.5 texture{Chrome_Metal}}                        //thread   
        isosurface{ //------------------------------------
        function{ f_helix1( x,y,z,
                1,    // number of helixes, (1 = single helix, 2 = double helix etc.)
                22,   // period,      turns on the length of 2*pi
                0.07, // minor radius,
                1.0,  // major radius,
                1,    // shape parameter,
                1.8,  // cross section type,
                      // (0.0 to 1.0 = square ... rounded to circle
                      // over 2.0 to 3.0 = rounded to diamond and concave diamond
                0 )   // cross section rotation angle
        }    
        texture{     
                Chrome_Metal
                finish { diffuse 0.75 specular 0.1
                         roughness 0.1 phong 0.2  }
        } // end of texture

        scale <5.5,8.3/2,5.5>
        rotate <90,0,0>
        translate <0,8.15,-8.3/2>
        } // end of isosurface ----------------
        cylinder{<0,8.15,0><0,8.15,-20.31>2.5 texture{pigment{White}}}                    //pin     
        texture{                 
                finish { diffuse 0.75 specular 0.1
                         roughness 0.1 phong 0.2  }
                } // end of texture
	} 
	rotate <0,180,0> 
	translate<0,0,7.3>                                                                                                        
}    
#end                   
      
      
      
      
      

//****************************************************************************************
// Relay
//****************************************************************************************  
#macro IC_Relay()   
union{   
        union{
        difference{
                Round_Box(<-3.6,-2,-7.3><+3.6,10,+7.3>, 1, 0)   
                box{<-3.61,-2.1,-7.31><+3.61,0,+7.31>}   
        }
        texture{
                pigment{ color rgb<1,0.85,0>}
                finish { phong 1}
        }
        } 
        text{ttf besch_font "AXICOM" .1,0 scale<2,2,1> rotate<90,-90,0> texture{pigment{Grey*0.7}} translate<-1.5,10.1,-6.2>}   
        text{ttf besch_font "CZECH" .1,0 scale<1.5,1.5,1> rotate<90,-90,0> texture{pigment{Grey*0.7}} translate<-1.5,10.1,+1.7>}   
        text{ttf besch_font "HF3" .1,0 scale<2,2,1> rotate<90,-90,0> texture{pigment{Grey*0.7}} translate<0.5,10.1,-6.2>}   
        text{ttf besch_font "3.3V DC" .1,0 scale<1.9,1.9,1> rotate<90,-90,0> texture{pigment{Grey*0.7}} translate<+2.5,10.1,-6.2>}   
        text{ttf besch_font "10640" .1,0 scale<1.5,1.5,1> rotate<90,-90,0> texture{pigment{Grey*0.7}} translate<+2.5,10.1,+1.7>} 
        
        union{
//0.7mm x 2.5mm pins        
        box{<-0.35,0,-1.25><+0.35,0.3,1.25> rotate<0,90,0> translate <4,0,-5*1.27>}     //4
        box{<-0.35,0,-1.25><+0.35,0.3,1.25> rotate<0,90,0> translate <4,0,+5*1.27>}     //11
        box{<-0.35,0,-1.25><+0.35,0.3,1.25> rotate<0,90,0> translate <-4,0,-5*1.27>}    //12
        box{<-0.35,0,-1.25><+0.35,0.3,1.25> rotate<0,90,0> translate <-4,0,+5*1.27>}    //22  
//0.9mm x 2.0mm pins         
        box{<-0.45,0,-1><+0.45,0.3,1>  rotate<0,90,0> translate <4,0,-4*1.27>}     //2   
        box{<-0.45,0,-1><+0.45,0.3,1>  rotate<0,90,0> translate <4,0,0>}           //6
        box{<-0.45,0,-1><+0.45,0.3,1>  rotate<0,90,0> translate <4,0,+4*1.27>}     //10
        box{<-0.45,0,-1><+0.45,0.3,1>  rotate<0,90,0> translate <-4,0,-3*1.27>}    //20
        box{<-0.45,0,-1><+0.45,0.3,1>  rotate<0,90,0> translate <-4,0,+3*1.27>}    //14 
//0.7mm x 2.0mm pins        
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <4,0,-1*1.27>}     //5 
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <4,0,+1*1.27>}     //7
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <-4,0,-4*1.27>}    //13
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <-4,0,+4*1.27>}    //21
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <-4,0,-2*1.27>}    //15
        box{<-0.35,0,-1><+0.35,0.3,1>  rotate<0,90,0> translate <-4,0,+2*1.27>}    //19  

        texture{Polished_Chrome
               pigment{color rgb<1,1,1>}
               finish {phong 1}}
        } 
        rotate<0,90,0>  
        translate<0,0,1.6> 
}    
#end                            
     
     
//****************************************************************************************
// LT3582 in a QFN16 package
//****************************************************************************************      
#macro QFN16(pins,value)   
union{  
        difference{
        box{<-1.5,0.1,-1.5><+1.5,0.75,+1.5> texture{pigment{Gray20}}}           //body
        cylinder{<-1,0.7,-1><-1,0.751,-1>0.1 texture{pigment{Gray20}}}          //pin 1 mark 
        } 
union{
#local i = 0;
#while (i<pins/8)
        box{<-0.125,0,0><+0.125,0.2,+0.7> translate<i*0.5+0.25,0,-1.75> }       //front pins
        box{<-0.125,0,0><+0.125,0.2,+0.7> translate<-i*0.5-0.25,0,-1.75> }  
        
        box{<-0.7,0.2,+0.125><0,0,-0.125> translate<+1.75,0,i*0.5+0.25> }       //right pins
        box{<-0.7,0.2,+0.125><0,0,-0.125> translate<+1.75,0,-i*0.5-0.25> }           

        box{<0,0.2,+0.125><+0.7,0,-0.125> translate<-1.75,0,i*0.5+0.25> }       //left pins
        box{<0,0.2,+0.125><+0.7,0,-0.125> translate<-1.75,0,-i*0.5-0.25> }             

        box{<-0.125,0,-0.7><+0.125,0.2,0> translate<i*0.5+0.25,0,+1.75> }       //back pins
        box{<-0.125,0,-0.7><+0.125,0.2,0> translate<-i*0.5-0.25,0,+1.75> }           
#local i = i+1;                                                                                       
#end   
texture{pigment{Silver}} 
}  
        text{ttf global_fontfile_eagle3d "k" 0.2,0
                scale<1,1,1> rotate<90,-90,0>
                translate<-3/2+3/3,0.751,-3/2.5+3/6> pigment{White}} 
        text{ttf global_fontfile_arial value 0.2,0
                scale<0.75,0.75,0.75> rotate<90,-90,0>
                translate<+3/2-3/3,0.751,-3/2+3/6> pigment{White}}                                                                                     
}   
 
#end  

//****************************************************************************************
// 17C724 in a QFN16 package
//****************************************************************************************     
#declare global_fontfile_Freescale = "Freescale.ttf" 
#macro F17C724(value) 
union{  
        difference{
        box{<-1.5,0.1,-1.5><+1.5,0.75,+1.5> texture{pigment{Gray20}}}           //body
        cylinder{<-1,0.7,-1><-1,0.751,-1>0.1 texture{pigment{Gray20}}}          //pin 1 mark 
        } 
union{
#local i = 0;
#while (i<2)
        box{<-0.125,0,0><+0.125,0.2,+0.7> translate<i*0.5+0.25,0,-1.75> }       //front pins
        box{<-0.125,0,0><+0.125,0.2,+0.7> translate<-i*0.5-0.25,0,-1.75> }  
        
        box{<-0.7,0.2,+0.125><0,0,-0.125> translate<+1.75,0,i*0.5+0.25> }       //right pins
        box{<-0.7,0.2,+0.125><0,0,-0.125> translate<+1.75,0,-i*0.5-0.25> }           

        box{<0,0.2,+0.125><+0.7,0,-0.125> translate<-1.75,0,i*0.5+0.25> }       //left pins
        box{<0,0.2,+0.125><+0.7,0,-0.125> translate<-1.75,0,-i*0.5-0.25> }             

        box{<-0.125,0,-0.7><+0.125,0.2,0> translate<i*0.5+0.25,0,+1.75> }       //back pins
        box{<-0.125,0,-0.7><+0.125,0.2,0> translate<-i*0.5-0.25,0,+1.75> }           
#local i = i+1;                                                                                       
#end   
texture{pigment{Silver}} 
}  
        text{ttf global_fontfile_Freescale "b" 0.2,0
                scale<2,2,2> rotate<90,-90,0>            
                translate<0.2,0.751,-0.8> pigment{White}} 
//                translate<-3/2+3/3,0.751,-3/2.5+3/6> pigment{White}} 
        text{ttf global_fontfile_arial value 0.2,0
                scale<0.65,0.65,0.65> rotate<90,-90,0>
                translate<+0.5,0.751,-1> pigment{White}}                                                                                     
}       translate<+1.5,0,+1.5>
#end 


//****************************************************************************************
// MMA7455L	LGA14 package
//****************************************************************************************      
#macro LGA14_MMA7455L(value)   
union{  
        difference{
        box{<-1.5,0.1,-2.5><+1.5,1.0,+2.5> texture{pigment{Gray20}}}           //body
        cylinder{<-1,0.8,+2><-1,1.01,+2>0.1 texture{pigment{Gray20}}}          //pin 1 mark 
        } 
union{    
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> translate<0,0,-2.31>}    
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> translate<0,0,+2.31>} 
        
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+2.0>} 
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-2.0>}   
        
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+2.0>} 
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-2.0>}
texture{pigment{Silver}} 
} 
  
        text{ttf "Freescale.ttf" "F" 0.9,0
                scale<2,2,2> rotate<90,-90,0>
                translate<0,1.01,-2> pigment{White}} 
        text{ttf global_fontfile_arial "MMA7455L" 0.2,0
                scale<0.75,0.75,0.75> rotate<90,-90,0>
                translate<+0.7,1.01,-1.8> pigment{White}}                                                                                     
}   
 
#end  


#macro MMA7455L(pins,value) 
union{  
        object{LGA14_MMA7455L(value)}
}
#end  

//****************************************************************************************
// BMP085	LCC8 package
//****************************************************************************************      
#macro LCC8()   
union{  
        difference{
        box{<-2.35,1.05,-2.35><+2.35,1.2,+2.35>  texture{pigment{Silver}}} 
        cylinder{<-2,1.05,+2><-2,1.21,+2>0.1 texture{pigment{Gray20}}}   
        cylinder{<0,1.0,0><0,1.21,0>0.25 texture{pigment{Silver}}}  
        }      
union{
        box{<-2.5,1.05,-2.5><+2.5,0,+2.5> texture{pigment{Gray20}}}            //body  
       
}               
                                                                      
  
        text{ttf global_fontfile_arial "BOSCH" 0.2,0
                scale<1,1,1> rotate<90,0,0>
                translate<-1.5,1.211,+1> pigment{Black}} 
        text{ttf global_fontfile_arial "WWCC" 0.2,0
                scale<0.75,0.75,0.75> rotate<90,0,0>
                translate<-1,1.211,-1> pigment{Black}}                                                                                     
}   
 
#end  

#macro BMP085() 
union{  
        object{LCC8()}
}
#end  


//****************************************************************************************
// HMC5883L	LGA14 package
//****************************************************************************************      
#macro LLC16()   
union{  
        difference{
        box{<-1.5,0.9,-1.5><+1.5,0,+1.5> texture{pigment{Gray20}}}            //body
        cylinder{<-1,0.91,+1><-1,0.8,+1>0.1 texture{pigment{Gray20}}}         //pin 1 mark 
        } 
union{    
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<-1.27,0,+0.25>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<-1.27,0,+0.75>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<-1.27,0,-0.25>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<-1.27,0,-0.75>}    
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<+1.27,0,+0.25>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<+1.27,0,+0.75>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<+1.27,0,-0.25>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> translate<+1.27,0,-0.75>}      
        
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<+0.25,0,-1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<+0.75,0,-1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<-0.25,0,-1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<-0.75,0,-1.27>}    
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<+0.25,0,+1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<+0.75,0,+1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<-0.25,0,+1.27>}  
        box{<-0.15,0,+0.226><+0.15,0.3,-0.226> rotate<0,90,0> translate<-0.75,0,+1.27>}  
texture{pigment{Silver}} 
} 
  
        text{ttf global_fontfile_eagle3d "h" 0.2,0
                scale<1,1,1> rotate<90,-90,0>
                translate<-0.3,1.01,-1.1> pigment{White}} 
        text{ttf global_fontfile_arial "HMC5883L" 0.15,0
                scale<0.75,0.75,0.75> rotate<90,-90,0>
                translate<+0.7,1.01,-1.1> pigment{White}}                                                                                     
}   
 
#end  

#macro HMC5883L() 
union{  
        object{LLC16()}
}
#end  

//****************************************************************************************
// ADXL345	LGA14 package
//****************************************************************************************      
#macro LGA14(value)   
union{  
        difference{
        box{<-1.5,0.1,-2.5><+1.5,1.0,+2.5> texture{pigment{Gray20}}}           //body
        cylinder{<-1,0.8,+2><-1,1.01,+2>0.1 texture{pigment{Gray20}}}          //pin 1 mark 
        } 
union{    
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> translate<0,0,-2.31>}    
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> translate<0,0,+2.31>} 
        
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,+2.0>} 
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<+1.15,0,-2.0>}   
        
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,+2.0>} 
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-0.4>}   
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-1.2>}
        box{<-0.25,0,+0.4><+0.25,0.3,-0.4> rotate<0,90,0> translate<-1.15,0,-2.0>}
texture{pigment{Silver}} 
} 
  
        text{ttf global_fontfile_eagle3d "3" 0.2,0
                scale<1,1,1> rotate<90,-90,0>
                translate<-0.3,1.01,-2> pigment{White}} 
        text{ttf global_fontfile_arial "ADXL345" 0.2,0
                scale<0.75,0.75,0.75> rotate<90,-90,0>
                translate<+0.7,1.01,-1.8> pigment{White}}                                                                                     
}   
 
#end  


#macro ADXL345(pins,value) 
union{  
        object{LGA14(value)}
}
#end  

//****************************************************************************************
// L3G4200D	LGA16L package
//****************************************************************************************      
#macro LGA16L(value)   
union{  
        difference{
        box{<-2.0,0.1,-2.0><+2.0,1.1,+2.0> texture{pigment{Gray20}}}           //body
        cylinder{<-1.5,1.0,+1.5><-1.5,1.11,+1.5>0.1 texture{pigment{Gray20}}}          //pin 1 mark    
        
//        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> texture{pigment{Silver}} translate<0.325,0,+3.81,0,+1.75> }
        } 
union{         
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<-0.325,0,+1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<-0.975,0,+1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<+0.325,0,+1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<+0.975,0,+1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<-0.325,0,-1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<-0.975,0,-1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<+0.325,0,-1.91>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> translate<+0.975,0,-1.91>}    
        
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<+1.91,0,-0.325>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<+1.91,0,-0.975>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<+1.91,0,+0.325>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<+1.91,0,+0.975>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<-1.91,0,-0.325>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<-1.91,0,-0.975>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<-1.91,0,+0.325>}   
        box{<-0.15,0,+0.2><+0.15,0.2,-0.2> rotate<0,90,0> translate<-1.91,0,+0.975>}  
texture{pigment{Silver}} 
}   
        text{ttf global_fontfile_eagle3d "s" 0.2,0
                scale<1,1,1> rotate<90,0,0>
                translate<-1,1.11,+0.5> pigment{White}} 
        text{ttf global_fontfile_arial "L3G4200D" 0.2,0
                scale<0.75,0.75,0.75> rotate<90,0,0>
                translate<-1.5,1.11,-1> pigment{White}}                                                                                     
}   
 
#end  


#macro L3G4200D(value) 
union{  
        object{LGA16L(value)}
}
#end

//MAGNETOMETER1	HMC5843	LPCC20  

//****************************************************************************************
// HMC5843	LPCC20 package
//****************************************************************************************      
#macro LPCC20(value)   
union{  
        difference{
        box{<-2.0,0.1,-2.0><+2.0,1.2,+2.0> texture{pigment{Gray20}}}           //body
        cylinder{<-1.5,1.1,+1.5><-1.5,1.21,+1.5>0.1 texture{pigment{Gray20}}}          //pin 1 mark 
        } 
union{         
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+0,0,+1.91>}   
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+0.5,0,+1.91>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+1.0,0,+1.91>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<-0.5,0,+1.91>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<-1.0,0,+1.91>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+0,0,-1.91>}   
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+0.5,0,-1.91>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<+1.0,0,-1.91>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<-0.5,0,-1.91>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> translate<-1.0,0,-1.91>}      
        
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<+1.91,0,0.0>}   
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<+1.91,0,+0.5>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<+1.91,0,+1.0>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<+1.91,0,-0.5>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<+1.91,0,-1.0>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<-1.91,0,0.00>}   
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<-1.91,0,+0.5>} 
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<-1.91,0,+1.0>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<-1.91,0,-0.5>}  
        box{<-0.125,0,+0.2><+0.125,0.3,-0.2> rotate<0,90,0> translate<-1.91,0,-1.0>} 
texture{pigment{Silver}} 
}
  
        text{ttf global_fontfile_eagle3d "h" 0.2,0
                scale<1,1,1> rotate<90,0,0>
                translate<-1,1.21,+0.5> pigment{White}} 
        text{ttf global_fontfile_arial "HMC5843" 0.2,0
                scale<0.75,0.75,0.75> rotate<90,0,0>
                translate<-1.5,1.21,-1> pigment{White}}                                                                                     
}   
 
#end  


#macro HMC5843(value) 
union{  
        object{LPCC20(value)}
}
#end


//L = length over everything (x axis) 
//B = width over everything (Z-axis) 
//H = height plastic (y axis) 
//pin_l = number of pin left 
//pin_r = number of pin right 
//pin_o = number of pin above 
//pin_u = number of pin down 
//pitch = distance of the individual pins 
//pin_br = width of a pin 
//pin_h = strength of the pin material 
//LK = length plastic (x axis) 
//BK = width plastic (Z-axis) 
//HKoP = height of the plastic over the plate (y axis) 
//KORW = correction angle 
//kp1ab = if not 0 is produced no chamfer at Pin1 
//logo = name OF the logo

#macro QFP_VQFP_64_050MM(value,logo)
object{QFP_GRND(12,12,1.0,16,16,16,16,0.5,0.22,0.15,10,10,0.1,90,0,logo)}
#end 
            
#macro QFP_VQFP_100_050MM(value,logo)
object{QFP_GRND(17,17,1.0,25,25,25,25,0.5,0.22,0.15,14,14,0.1,90,0,logo)}
#end    

#macro QFP_VQFP_128_050MM(value,logo)
object{QFP_GRND(16,16,1.0,32,32,32,32,0.4,0.18,0.15,14,14,0.1,90,0,logo)}
#end 
            
#macro QFP_TQFP_48_dnc(value,logo)
object{QFP_GRND(9,9,1.4,12,12,12,12,0.5,0.22,0.15,7,7,0.1,90,0,logo)}
#end         
            

//This creates some custom coloured IC for documentation 
//       Gray20
//QFP_VQFP_64_050MM 
#macro QFP_VQFP_64_050MMGreen(value,logo)
object{QFP_GRND_DNC(12,12,1.0,16,16,16,16,0.5,0.22,0.15,10,10,0.1,90,0,logo,Green*0.8)}
#end  

//QFP_VQFP_64_050MM 
#macro QFP_VQFP_64_050MMYellow(value,logo)
object{QFP_GRND_DNC(12,12,1.0,16,16,16,16,0.5,0.22,0.15,10,10,0.1,90,0,logo,Yellow*0.6)}
#end  

//QFP_TQFP_44_080MM
#macro QFP_TQFP_44_080MMYellow(value,logo)
object{QFP_GRND_DNC(12,12,1.17,11,11,11,11,0.8,0.37,0.15,10,10,0.1,90,0,logo,Yellow*0.6)}
#end 

//QFP_TQFP_44_080MM
#macro QFP_TQFP_44_080MMGreen(value,logo)
object{QFP_GRND_DNC(12,12,1.17,11,11,11,11,0.8,0.37,0.15,10,10,0.1,90,0,logo,Green*0.8)}
#end  

#macro RES_SMD_CHIP_2512(value)
object{RES_SMD_CHIP_GRND(3.2,6.401,0.60,0.60,value)}
#end  


#macro B25P(value)   
union{
difference{
 
	box{<-4.77,0,-4.77><+4.77,4.83,+4.77> texture{pigment{Blue*.9}}}      //body
	box{<-4.5,-0.01,-4.771><+4.5,4.84,-4.5> texture{pigment{Blue*.9}}}     //hollow body
	cylinder{<0,0,0><0,-1,0>3.15/2 translate<0,+4.84,0.87> texture{pigment{White*.9}}}}  
        cylinder{<0,0,0><0,-5.97,0>0.51/2  translate<-2.54,0,0> texture{col_silver}}   //pin 1
        cylinder{<0,0,0><0,-5.97,0>0.51/2  translate<+2.54,0,0> texture{col_silver}}    //pin 2
        cylinder{<0,0,0><0,-5.97,0>0.51/2  translate<0,0,+2.54> texture{col_silver}}    //pin 3 
        
 //       text{ttf besch_font "3M" 1,0 scale<1.5,1.5,1> rotate<90,0,0> texture{pigment{Grey*0.7}} translate<0,4.84,-2>}
        
        difference{   
        cylinder{<0,0,0><0,1,0>3.15/2  texture{pigment{White*.9}}} 
	box{<-3.15/2,1.01-0.76,-0.76/2><+3.15/2,1.01,+0.76/2> texture{pigment{White*.8}}}
	prism {linear_sweep 0.0, 1.01, 4,
               <0.5,-0.76>, <3.15/2,0>, <0.5,+0.76>, <0.5,-0.76>
               texture{pigment{White*.9}}}      	     		
        translate<0,4.84-1.25,0.87>} 
        
        object{Circle_Text("arial.ttf", "Bourns",
                1.5 , // Size
                0.025, // Spacing
                1.00, // Thickness
                2.0,   // Radius
                0,       // Inverted
                Align_Center,// od. Align_Right, Align_Center
                0)     // Angle
                texture{pigment{White*0.7}} 
                rotate<90,-90,0>
                translate<0,4.84,1>
        }// end of Circle_Text object          
} 
              
#end   

#macro trim_025(value)   
union{
difference{  
        union{
                box{<-3.3,0,-3.3><+3.3,4.7,+3.3> texture{pigment{Blue*0.7}}}                //body   
                box{<-3.3,0,-3.3><-3.1,+4.7,-3.84>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //left bump    
                box{<+3.3,0,-3.3><+3.1,+4.7,-3.84>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //left bump  
                box{<-1.9,4.7,-3.84><-1.27,0,-3.3>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //centerleft bump   
                box{<-0.64,0,-3.3><-1.27,+4.7,-3.554>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //centerleft bump    
                box{<+1.9,4.7,-3.84><+1.27,0,-3.3>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //centerleft bump   
                box{<+0.64,0,-3.3><+1.27,+4.7,-3.554>rotate<0,0,0> texture{pigment{Blue*0.9}}}              //centerleft bump  
        }
        box{<-2.54,-0.1,-5><+2.54,+0.33,+5> texture{pigment{Blue*0.7}}}                //bottom recess        
        box{<-5,-0.1,-2.54><+5,+0.33,+2.54> texture{pigment{Blue*0.7}}}                //bottom recess  
        cylinder{<0,4.7-2,0.15><0,4.71,0.15>1.4 texture{pigment{White*0.9}}}    //screw hole
        
        box{<-0.15,0,0><+0.15,0.9,2.8>rotate<0,0,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //long tick 
        box{<-0.15,0,0><+0.15,0.9,2.8>rotate<0,+120,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //long tick 
        box{<-0.15,0,0><+0.15,0.9,2.8>rotate<0,-120,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //long tick  
        
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,24,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick   
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,48,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick  
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,72,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick  
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,96,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick  
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,-24,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick   
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,-48,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick  
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,-72,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick  
        box{<-0.15,0,0><+0.15,0.9,2.2>rotate<0,-96,0> translate<0,4.66,0.15> texture{pigment{Blue*0.5}}}              //short tick 
        
        text{ttf besch_font "3362" 1,0 scale<1.5,1.5,1> rotate<90,0,0> texture{pigment{White*0.5}} translate<-1.5,4.72,-2.4>}
        text{ttf besch_font "1" 1,0 scale<1,1,1> rotate<90,0,0> texture{pigment{White*0.7}} translate<-2.7,4.72,-2.2>}
        text{ttf besch_font "8" 1,0 scale<1,1,1> rotate<90,0,0> texture{pigment{White*0.7}} translate<+2.5,4.72,-2.2>}   
        text{ttf besch_font "B" 1,0 scale<1.5,1.5,1> rotate<90,0,0> texture{pigment{White*0.7}} translate<+2,4.72,+2>}                                                      
}        
        difference{   
                cylinder{<0,4.7-2,0.15><0,4.71,0.15>1.2 texture{pigment{White*0.9}}}    //screw hole  
                box{<-1.2,4.71-0.89,-0.32+0.15><+1.2,4.72,+0.32+0.15>texture{pigment{White*0.9}}}
                box{<-0.32,4.71-0.89,-1.2+0.15><+0.32,4.72,+1.2+0.15>texture{pigment{White*0.9}}}   
        } 
        cylinder{<0,0,0><0,-5.46,0>0.46/2  translate<-2.54,0,0> texture{col_silver}}   //pin 1
        cylinder{<0,0,0><0,-5.46,0>0.46/2  translate<+2.54,0,0> texture{col_silver}}    //pin 2
        cylinder{<0,0,0><0,-5.46,0>0.46/2  translate<0,0,+2.54> texture{col_silver}}    //pin 3 
}
#end  


//-____________________________________________________________________________________
#macro WireSlot()    //Entry holes for wires     
difference{ 
        box{<-2.54,0,-2.54><+2.54,0.5,+2.54>  texture{pigment{Yellow*.4}} }   
        prism {linear_sweep 0.0, 5.082, 3,<-1.27,0.5>, <0,0>, <-1.27,0>
        texture{pigment{Green*.4}}rotate<+90,0,0>translate<-1.271,0.51,-2.541>}        

        prism {linear_sweep 0.0, 5.082, 3,<-1.27,0.5>, <0,0>, <-1.27,0>
        texture{pigment{Green*.4}}rotate<+90,-90,0>translate<+2.541,0.51,-1.271>}   
        
        prism {linear_sweep 0.0, 5.082, 3,<-1.27,0.5>, <0,0>, <-1.27,0>
        texture{pigment{Green*.4}}rotate<90,90,0>translate<-2.541,0.51,+1.271>}         
                                                         	      
        prism {linear_sweep 0.0, 5.082, 3,<-1.27,0.5>, <0,0>, <-1.27,0>
        texture{pigment{Green*.4}}rotate<+90,180,0>translate<+1.271,0.51,+2.541>}  
        scale<0.8,1,0.8>
}
#end   
      

#macro Phoenix(N)    
union{             
        difference{
                prism {linear_sweep 0.0, (3.0+5.08*(N-1)), 8,
                <-4.05,0>, <-4.05,+5>, <-3.85,+5>, <-1.85,+10>, <+1.85,10>, <+4.05,+3>, <+4.05,0>, <-4.05,0>
                texture{pigment{Green*.4}}rotate<-90,0,0>}            //body
                #local holes= 1 ;  
                #while (holes <= N)                                   //screw holes
                cylinder{<0,6,-(1.5+5.08*(holes-1))><0,10.51,-(1.5+5.08*(holes-1))>1.8/2  texture{pigment{White}}}   
                                                                      //entry wires
          //      object{WireSlot()rotate<0,0,-90>translate<-4.051,+2.54,-1.27-0.23-(holes-1)*5.08>}   
                 object{WireSlot()rotate<0,0,-90>translate<-4.051,+2.54,-2.54-(holes-1)*4.4>} 
                #local holes = holes+1;
                #end    
        }    
        #local screws= 1 ;  
        #while (screws <= N)                                          //screws
        difference{ 
                cylinder{<0,0,0><0,2,0>1.6/2  texture{pigment{Gold*.9}}}  
                box{<-1,1,+0.2><+1,2.01,-0.2> texture{pigment{Gold*.5}}} 
	        translate<0,10-2,-(1.5+5.08*(screws-1))> 
	}  
	#local screws = screws+1;
	#end      
	     
        #local pins= 1;  
        #while (pins <= N)                                          //pins 
        union{
        box{<-0.25,-3.5,-0.5><+0.25,0,+0.5> texture{pigment{Silver*.9}}} 
        translate<0,0,-(1.5+5.08*(pins-1))> 
        }
	#local pins = pins+1;
	#end 	
}  translate<0,0,(3.0+5.08*(N-1))/2>  
#end     
 
#macro Phoenix4(value)              
object{Phoenix(4)rotate<0,90,0>} 		 
#end     

#macro Phoenix2(value)              
object{Phoenix(2)rotate<0,90,0>} 		 
#end        


//_____________________________________________________________ 
//USB Connector type A female

#macro USBA_F_BODY()   
union{  
       union{ 
        union{
        difference{
                Round_Box(<-6.75,0,-3><+6.75,6.45,17.65>, 1, 0)         //Body 
                Round_Box(<-6.65,+0.1,-0.1><+6.65,+6.35,14.5>, 1, 0)    //Inner body
                box{<-7,-1,-3.1><+7,+7,0>}                              //clip front
                box{<-7,-1,14.65><+7,+7,17.75>}                         //clip back     
                box{<-6.751,0,2.4><-6.4,+5.45,+4.6>}                    //detent left    
                box{<+6.751,0,2.4><+6.4,+5.45,+4.6>}                    //detent right    
                box{<+6.751,2.0,14.651><+6.5,5,13.65>}                  //detent right back side   
                box{<-6.751,2.0,14.651><-6.5,5,13.65>}                  //detent left back side   
                object{USBA_DETENT_BACK() rotate<0,90,0>translate<+3.125,6.46-0.27,+13>}//right  back detent  
                object{USBA_DETENT_BACK() rotate<0,90,0>translate<-3.125,6.46-0.27,+13>}//left back detent     
                object{USBA_DETENT() rotate<0,180,0>translate<-3.125,6.46-0.27,+8>}     //left
                object{USBA_DETENT() rotate<0,180,0>translate<+3.125,6.46-0.27,+8>}     //right               
        }
        texture{
           //     pigment{ color rgb<1,0.85,0>} 
                pigment{Silver*0.9}
                finish { phong 1}
        } } 
        prism {linear_sweep 0.0, 10, 7,                                 //contacts
        <0,1.3>, <0.3,0>, <13,0>, <13,1.8>,
        <0.3,1.8>, <0,1.5>,  <0,1.2>
        texture{pigment{White*1.1}}rotate<-90,-90,0>translate<-5.0,2.06-1.8/2,0>} 
        texture{finish { phong 1} }  
       }     
             
   
        
        union{                                                          //0.6mm x 2.15mm pins        
        box{<-0.3,0,0><+0.3,0.1,2.15> rotate<0,0,0> translate <-3.5,0,14.64>}     //1
        box{<-0.3,0,0><+0.3,0.1,2.15> rotate<0,0,0> translate <-1.0,0,14.64>}     //2
        box{<-0.3,0,0><+0.3,0.1,2.15> rotate<0,0,0> translate <+1.0,0,14.64>}     //3
        box{<-0.3,0,0><+0.3,0.1,2.15> rotate<0,0,0> translate <+3.5,0,14.64>}     //4                
        texture{pigment{Gold*1.1}}
        finish {phong 1}
        }
}    
#end      

#macro USBA_PAD()   
union{  
        prism {linear_sweep 0.0, 2, 13,
               <-1.00,0.25>, <0.00,0.25>, <0.625,-0.35>, <2.625,-0.35>, 
               <3.25,0.25>, <3.25,1.95>, <3.5,1.95>                     //top line
               <3.50,0.25>, <2.625,-0.6>,  <0.625,-0.60>, <0.00,0.00>, 
               <-1.0,0.00> <-1.00,0.25>                                 //bottom line  
               texture{pigment{Silver*1.1}}rotate<-90,0,0>scale<0.5,0.5,1>} 
               texture{finish { phong 1}
        }            
}    
#end             

#macro USBA_CONTACT()   
union{  
        prism {linear_sweep 0.0, 0.8, 7,
               <0,0.3>, <2,0.6>, <4.5,0.3>, <4.5,0>, 
               <2,0.3>, <0,0>, <0,0.3>                      
               texture{pigment{Gold*1.1}}rotate<-90,-90,0>} 
               texture{finish { phong 1}
        }            
}    
#end   

#macro USBA_DETENT()            //front tabs
union{  
        prism {linear_sweep 0.0, 0.27, 9,
                <-1.625,0.00>, <-1.375,6.5>, <+1.375,6.5>, <1.625,0>, <1.375,0.00>, 
                <1.1,6.0>, <-1.1,6.0>, <-1.37,0.00>, <-1.625,0.00>   
                texture{pigment{White*.2}}}           
}    
#end   

#macro USBA_DETENT_BACK()       //back tabs
union{  
        prism {linear_sweep 0.0, 0.351, 7,
                <-1.00,+1.00>, <+1,+1>, <1.3,0.7>, <1.3,-0.7>,
                <+1,-1>, <-1,-1>, <-1,1>   
                texture{pigment{White*.2}}}           
}    
#end   

#macro USBA_BACK_TAB()          //back tabs
union{  
        prism {linear_sweep 0.0, 1.6, 9,
                <-1,0>, <0,0>, <0.8,-0.5>, <1,0>,
                <1.1,-0.2>, <0.8,-0.7>, <0,-0.25>,
                <-1,-0.25>,<-1,0>  
                texture{pigment{White*0.9}}}          
}    
#end                                          
                                            
                                            
#macro USBA_F()                 //device    
union{ 
        object{USBA_F_BODY()} 		 
        object{USBA_PAD()translate <+6.75,0,+4.5>texture{pigment{Red}}}
        object{USBA_PAD()translate <+6.75,0,+11.7>}    
        object{USBA_PAD()rotate<0,180,0> translate <-6.75,0,+2.5>}
        object{USBA_PAD()rotate<0,180,0> translate <-6.75,0,+9.7>}  
        object{USBA_CONTACT() rotate<0,0,0>translate<+1.0,2.06+.8,1>}     //contact  
        object{USBA_CONTACT() rotate<0,0,0>translate<+3.0,2.06+.8,1>}     //contact   
        object{USBA_CONTACT() rotate<0,0,0>translate<-1.0,2.06+.8,1>}     //contact  
        object{USBA_CONTACT() rotate<0,0,0>translate<-3.0,2.06+.8,1>}     //contact   
        object{USBA_BACK_TAB() rotate<0,90,+90>translate<+4,6.45,+13.5>}  //back tab   
        object{USBA_BACK_TAB() rotate<0,90,+90>translate<-2.3,6.45,+13.5>}//back tab     
}           
rotate<0,180,0>translate<0,0.36,+15.65>
#end          



//_____________________________________________________________ 
//D2PAK
#macro IC_SMD_D2PAK(value,logo)
object{IC_SMD_GRND(10.67,9.65,4.83,15.0,2,1,5.08,0,1.05,7.5,0.74,0.1,0,4,0,1.5,1.0,0,logo)}
#end
         
         
                                                
#macro SC70_6(value,logo)
object{IC_SMD_GRND(2.2,1.35,1,2.8,3,3,0.65,0.65,0.3,0.3,0.13,0.1,0,1,0,0.3,0.7,0,logo)}
#end                                                    
        
//_____________________________________________________________ 
//RJ45 Connector female

#macro RJ45_BODY()   
union{  
        union{
                difference{
                     Round_Box(<0,0,0><16,16.51,15.88>, 1, 0)         //Body 
                     Round_Box(<0.5,2,2.475><9.39,19,13.405>, 1, 0)   //Inner body  
                     Round_Box(<7.0,2,4.475><11.015,19,11.405>, 1, 0) //First tab  
                     Round_Box(<9,14,5.1><14,19,10.0>, 1, 0)          //Second tab            
                }
                texture{pigment{Grey*0.1}}
                finish { phong 1}
        } 
            
        union{
                cylinder{<0,0,0><0,-3.3,0>3.125/2  translate<9.39,0,2.225>}            
                cylinder{<0,0,0><0,-3.3,0>3.125/2  translate<9.39,0,13.655>} 
                texture{pigment{Grey*0.7}}
                finish {phong 1}
        }    
}    
#end        


#macro RJ45_PIN() 
intersection{                      
        box{<0,-3.3,-1><5,5,0>}
        // Wire_Box(A, B, WireRadius, Merge)
        Wire_Box(<0,-5,0>,<7,3.3,0>, 0.89/2, 0)
        texture{pigment{Gold*1.1}}
        finish {phong 1}
}
#end  
            
#macro RJ45_MOTOR()   
union{  
        object{RJ45_BODY() translate<0,0,0>  }       
        object{RJ45_PIN() translate<2.54-.89/2,0,3.495>  } 
        object{RJ45_PIN() translate<-.89/2,0,4.765>  }       
        object{RJ45_PIN() translate<2.54-.89/2,0,6.035>  } 
        object{RJ45_PIN() translate<-.89/2,0,7.505>  }  
        object{RJ45_PIN() translate<2.54-.89/2,0,8.575>  } 
        object{RJ45_PIN() translate<-.89/2,0,9.845>  } 
        object{RJ45_PIN() translate<2.54-.89/2,0,11.114>  } 
        object{RJ45_PIN() translate<-.89/2,0,12.385>  }   
   
}       
rotate<0,+90,0>  translate<-8,0,0.89/2+16.51/2>
#end                                                                   
                                                    
     
     
#macro CON_ACIN()   
union{    
        difference{
                box{<-4.5,0.0,0.0><+4.5,11,-11.1> texture{pigment{White*0.3}}}                  //body
                cylinder{<0,6.5,+0.1><0,6.5,-10>6.3/2}                                          //barrel   
                box{<-4.51,6.5,-4><-4.0,10,-13.6> texture{pigment{White*0.3}}}                  //detent
        }                                                                               
        cylinder{<0,6.5,+0.1><0,6.5,-10>2.0/2 texture{Chrome_Metal}}                            //main pin 
        cylinder{<0,6.5,-11.1><0,6.5,-13.5>8.0/2 texture{pigment{White*0.3}}}                   //body back round  
          
        cylinder{<0,6.5,-13.5><0,6.5,-14.0>6.3/2 texture{Chrome_Metal}}                         //round metal back    
        cylinder{<0,6.5,-14.0><0,6.5,-14.5>5.3/2 texture{Chrome_Metal}}                         //round metal back 
        box{<-4.0,0.0,-11.1><+4.0,6.5,-13.5>texture{pigment{White*0.3}}}                        //body back base         
        box{<-4.0,0.0,-13.5><+4.0,3.0,-14.0>texture{pigment{White*0.3}}}                        //body back base
        
        box{<-1.95,0,-3.1><1.95,0.1,+3.1>texture{Chrome_Metal} translate<-4.5-1.55,0,-6.8>}     //pin right  
        box{<-4.5,2.3,-3.8><-4.6,3.3,-11.1>texture{Chrome_Metal}}       
        box{<-4.5,0.0,-3.8><-4.6,2.3,-9.8>texture{Chrome_Metal}}   
        box{<-1.95,0,-3.1><1.95,0.1,+3.1>texture{Chrome_Metal} translate<+4.5+1.55,0,-6.8>}     //pin left   
        box{<-1.15,0,-2.2><1.15,0.1,+2.2>texture{Chrome_Metal} translate<0,0,-13.6-2.2>}        //pin back                                                                 
}                                                                                               
rotate<0,-90,0> 
#end 


#macro SINK_5X5()   
union{    
        box{<-20.0,0.0,0.0><+20.0,12.7,1.6>texture{Chrome_Metal}pigment{Red*1.2}}               //body base         
        box{<-20.0,0.0,0.0><+20.0,1.6,12.7>texture{Chrome_Metal}pigment{Red*1.2}}               //body side                                                          
}                                                                                               
rotate<0,-180,0>    
translate<0,0,+12.7>
#end   

#macro MOLEX_KK2()   
difference{ 
        union{
	        box{<-0.1,0,+0.125><+0.1,+0.125,-0.125> texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }  
	        box{<-0.075,0.322,+0.112><+0.075,+0.125,+0.125> texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }  
	        cylinder{<+0.075,0.25,+0.112><-0.075,+0.25,+0.112>0.015 texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }       
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-2.54/2,0,0>}   
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+2.54/2,0,0>}
	}             	  
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<-0.05,0,0> scale<25.4,25.4,25.4> }     
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<+0.05,0,0> scale<25.4,25.4,25.4> }      
	
}
#end    

#macro MOLEX_KK4()   
difference{ 
        union{
	        box{<-0.2,0,+0.125><+0.2,+0.125,-0.125> texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }  
	        box{<-0.15,0.322,+0.112><+0.15,+0.125,+0.125> texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }  
	        cylinder{<+0.15,0.25,+0.112><-0.15,+0.25,+0.112>0.015 texture{pigment{White*.9}}   scale<25.4,25.4,25.4> }       
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-2.54/2,0,0>}   
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+2.54/2,0,0>}
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-7.62/2,0,0>}   
	        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+7.62/2,0,0>}
	}             	  
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<-0.05,0,0> scale<25.4,25.4,25.4> }     
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<+0.05,0,0> scale<25.4,25.4,25.4> }  
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<-0.15,0,0> scale<25.4,25.4,25.4> }     
	box{<-0.0375,-0.01,+0.126><+0.03725,+0.035,-0.126> texture{pigment{White*.9}}  translate<+0.15,0,0> scale<25.4,25.4,25.4> }       
	
}
#end   

#macro SERVO4()   
union{
        box{<-0.2,0,+0.125><+0.2,+0.125,-0.125> texture{pigment{Black}}   scale<25.4,25.4,25.4> }   
	              
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-2.54/2,0,0>}   
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+2.54/2,0,0>}
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-7.62/2,0,0>}   
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+7.62/2,0,0>}       
	        
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-2.54/2,0,2.54>}   
        object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+2.54/2,0,2.54>}
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-7.62/2,0,2.54>}   
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+7.62/2,0,2.54>}   
	        
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-2.54/2,0,-2.54>}   
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+2.54/2,0,-2.54>}
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<-7.62/2,0,-2.54>}   
	object{PIN_STRAIGHT(0.7,8,3.5,col_gold) translate<+7.62/2,0,-2.54>}
}  rotate<0,90,0>           	  
#end 

#macro LPCXPRESSO()   
 union{
        union{
	        box{<-1.4*25.4,0,-0.05*25.4><+1.4*25.4,2.54,+0.05*25.4> texture{pigment{Black}}translate <-1.27,0,0>}                             
 
	        #local i=0;
	        #while(i<14)
		        object{PIN_STRAIGHT(1,4,8,col_gold) translate<i*-2.54-1.27,0,0>}   
	                object{PIN_STRAIGHT(1,4,8,col_gold) translate<i*+2.54-1.27,0,0>}  
	                #local i=i+1;
		#end
		translate <1.4*25.4-1.27,-0.1*25.4,0>
	}             	      
	
         union{
	        box{<-1.2*25.4,0,-0.05*25.4><+1.2*25.4,2.54,+0.05*25.4> texture{pigment{Black}}translate <-1.27,0,0>}                             
 
	        #local i=0;
	        #while(i<12)
		        object{PIN_STRAIGHT(1,4,8,col_gold) translate<i*-2.54-1.27,0,0>}   
	                object{PIN_STRAIGHT(1,4,8,col_gold) translate<i*+2.54-1.27,0,0>}  
	                #local i=i+1;
		#end
		translate <1.1*25.4-1.27+0.5*25.4,-0.1*25.4,0.9*25.4>
	}
}   
	
#end  


#macro KYSAN()   
union{    
        union{
                difference{
                        box{<-21.15,-21.15,0><+21.15,+21.15,34>}    //Body 
                        box{<-5.65/2,-10,-1><+5.65/2,+10,35> rotate<0,0,45> translate<-21.15,-21.15,0>}    //clip corners  
                        box{<-5.65/2,-10,-1><+5.65/2,+10,35> rotate<0,0,-45> translate<-21.15,+21.15,0>}    //clip corners   
                        box{<-5.65/2,-10,-1><+5.65/2,+10,35> rotate<0,0,45> translate<+21.15,+21.15,0>}    //clip corners  
                        box{<-5.65/2,-10,-1><+5.65/2,+10,35> rotate<0,0,-45> translate<+21.15,-21.15,0>}    //clip corners  
                        
                        box{<-5.65,-10,11.13><+5.65,+10,22.26> rotate<0,0,+45> translate<-21.15,-21.15,0>}    //clip corners    
                        box{<-5.65,-10,11.13><+5.65,+10,22.26> rotate<0,0,-45> translate<-21.15,+21.15,0>}    //clip corners 
                        box{<-5.65,-10,11.13><+5.65,+10,22.26> rotate<0,0,+45> translate<+21.15,+21.15,0>}    //clip corners 
                        box{<-5.65,-10,11.13><+5.65,+10,22.26> rotate<0,0,-45> translate<+21.15,-21.15,0>}    //clip corners 
                        
                        cylinder{<+15.5,+15.5,-1><+15.5,+15.5,35>3/2}  
                        cylinder{<-15.5,+15.5,-1><-15.5,+15.5,35>3/2} 
                        cylinder{<+15.5,-15.5,-1><+15.5,-15.5,35>3/2}
                        cylinder{<-15.5,-15.5,-1><-15.5,-15.5,35>3/2}  
                        
                        cylinder{<0,0,-0.01><0,0,+0.2>15.5 pigment{Gray*0.9}}   //motor round protrusion 
                                
                }             
                cylinder{<0,0,0><0,0,-2>11}   //motor round protrusion    
             //   cylinder{<0,0,-0.01><0,0,+0.2>15.5 pigment{Gray*0.9}}   //motor round protrusion 
                cylinder{<0,0,34.4><0,0,-24>4.78/2}   //shaft    
                texture{Chrome_Metal}
                finish { phong 1}     
                
        }     
  
                difference{      
                        union{
                                box{<-21.16,-21.16,11.13><+21.16,+21.16,22.26>texture{pigment{Black*0.9}} finish { phong 1}}  //Body black    
                                box{<-16,-21.16,9><+16,+21.16,25>texture{pigment{Black*0.9}} finish { phong 1}}  //Body black  
                                box{<-21.16,-16,9><+21.16,+16,25>texture{pigment{Black*0.9}} finish { phong 1}}  //Body black 
                        } 
                        box{<-5.65,-10,-1><+5.65,+10,35> rotate<0,0,45> translate<-21.16,-21.15,0>}    //clip corners  
                        box{<-5.65,-10,-1><+5.65,+10,35> rotate<0,0,-45> translate<-21.16,+21.15,0>}    //clip corners   
                        box{<-5.65,-10,-1><+5.65,+10,35> rotate<0,0,45> translate<+21.16,+21.16,0>}    //clip corners  
                        box{<-5.65,-10,-1><+5.65,+10,35> rotate<0,0,-45> translate<+21.16,-21.16,0>}    //clip corners 
               
                } 
        rotate<90,0,0>   
        translate<0,+40,0>              
            
}    
#end           
  
#macro RGB_LED()  
difference{ 
union{  
        union{
                box{<-0.8,0,-0.75><+0.8,0.12,+0.75>}
                texture{pigment{White*0.6}}
                finish { phong 1}
        } 
        union{
                box{<-0.55,0.12,-0.75><+0.55,0.35,+0.75>}
                texture{pigment{Red*0.6}}
                finish { phong 1}
        }      
        box{<-0.1,0.12,-0.25><0.2,0.121,+0.25>texture{pigment{Gold}} translate<+0.7,0,+0.35>}   
        box{<-0.1,0.12,-0.25><0.2,0.121,+0.25>texture{pigment{Gold}} translate<+0.7,0,-0.35>}
        box{<-0.1,0.12,-0.25><0.2,0.121,+0.25>texture{pigment{Gold}} translate<-0.7,0,+0.35>}
        box{<-0.1,0.12,-0.25><0.2,0.121,+0.25>texture{pigment{Gold}} translate<-0.7,0,-0.35>}
            
}    
        cylinder{<-0.8,-0.1,+0.35><-0.8,0.2,+0.35>0.125 texture{pigment{Gold}}}     
        cylinder{<-0.8,-0.1,-0.35><-0.8,0.2,-0.35>0.125 texture{pigment{Gold}}}  
        cylinder{<+0.8,-0.1,+0.35><+1,0.2,+0.35>0.125 texture{pigment{Gold}}}     
        cylinder{<+0.8,-0.1,-0.35><+1,0.2,-0.35>0.125 texture{pigment{Gold}}}
}
#end   

#macro RGB()  
difference{ 
union{  
        union{
                box{<-1.6,0,-1.35><+1.6,0.2,1.35>}
                texture{pigment{White*0.6}}
                finish { phong 1}
        } 
        union{
                box{<-1.0,0.2,-1.35><+1.0,0.35,+1.35>}
                texture{pigment{Red*0.6}}
                finish { phong 1}
        }      
        box{<-0.35,0.2,-0.55><0.35,0.201,+0.55>texture{pigment{Gold}} translate<+1.25,0,+0.75>}   
        box{<-0.35,0.2,-0.55><0.35,0.201,+0.55>texture{pigment{Gold}} translate<+1.25,0,-0.75>}
        box{<-0.35,0.2,-0.55><0.35,0.201,+0.55>texture{pigment{Gold}} translate<-1.25,0,+0.75>}
        box{<-0.35,0.2,-0.55><0.35,0.201,+0.55>texture{pigment{Gold}} translate<-1.25,0,-0.75>}
            
}    
        cylinder{<-1.6,-0.1,+0.75><-1.6,0.3,+0.75>0.25 texture{pigment{Gold}}}     
        cylinder{<-1.6,-0.1,-0.75><-1.6,0.3,-0.75>0.25 texture{pigment{Gold}}}  
        cylinder{<+1.6,-0.1,+0.75><+1.6,0.3,+0.75>0.25 texture{pigment{Gold}}}     
        cylinder{<+1.5,-0.1,-0.75><+1.6,0.3,-0.75>0.25 texture{pigment{Gold}}}
}
#end       


#macro IMU_CON_PIN()   
union{    
        difference{
                cylinder{<0,5.0,0><0,0.0,0>0.125/2*25.4 texture{pigment{Gold}}}        //pin    
                cylinder{<0,5.1,0><0,2.0,0>0.085/2*25.4 texture{pigment{Gold*0.8}}}  //barrel  
        }                                                                               
       cylinder{<0,-3.5,0><0,0,0>0.083/3*25.4  texture{pigment{Gold}}}               //pin                                                                  
}                                                                                               
#end  
   

#macro HEX_PIN(pin_color)  
union{  
        difference{
                prism {linear_sweep 0.0, 6.35, 7,
               <-1.8288,-3.175>, <+1.8288,-3.175>, <+3.6576,0>  //left side
               <+1.8288,+3.175>, <-1.8288,+3.175>, <-3.6576,0>, <-1.8288,-3.175>   //right side  
                texture{pigment{pin_color}}}    
               cylinder{<0,+2.55,0><0,+6.351,0>0.12*25.4/2 texture{pigment{Silver}}}
        } 
        cylinder{<0,0,0><0,-0.187*25.4,0>0.12*25.4/2 texture{pigment{Silver}}}
}
#end      

#macro IMU_CON()   
union{    
        object{HEX_PIN(Red) translate<8.89,0,8.89>}  
        object{HEX_PIN(Yellow) translate<8.89,0,-8.89>}   
        object{HEX_PIN(Blue) translate<-8.89,0,8.89>}   
        object{HEX_PIN(Black) translate<-8.89,0,-8.89>}                                                              
}                                                                                               
#end  

#macro ISNAP()   
union{    
        object{HEX_PIN(Red) translate<16.8275,0,16.8275>}  
        object{HEX_PIN(Yellow) translate<16.8275,0,-16.8275>}   
        object{HEX_PIN(Blue) translate<-16.8275,0,16.8275>}   
        object{HEX_PIN(Black) translate<-16.8275,0,-16.8275>}                                                              
}                                                                                               
#end     


 
#declare pcb_height = 1.500000;
#declare pcb_cuheight = 0.035000;
#declare pcb_x_size = 86.385600;
#declare pcb_y_size = 38.115400;
#declare pcb_layer1_used = 1;
#declare pcb_layer16_used = 1;
#declare inc_testmode = off;
#declare global_seed=seed(842);
#declare global_pcb_layer_dis = array[16]
{
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	0.000000,
	1.535000,
}
#declare global_pcb_real_hole = 2.000000;     

#declare col_brd = texture{pigment{DarkGreen}}                                  //Farbe der Platine
#declare col_wrs = texture{pigment{ForestGreen}}                                //Farbe der Leiterbahnen
#declare col_pds = texture{T_Silver_5A}                                         //Farbe der Pad's und SMD's
#declare col_hls = texture{pigment{Black}}                                      //Farbe der Pseudobohrungen 
#declare col_bgr = Gray50;                                                      //Hintergrundfarbe wenn keine Umgebung aktiviert  
#declare col_slk = texture{pigment{White}}                                      //Farbe des Bestckungsdruck  
#declare col_thl = texture{T_Silver_5A}                                         //Farbe der Durchkontaktierungen
#declare col_pol = col_wrs                                                      //Farbe der Polygone 
#declare global_solder = on;

#macro LPCXPRESSO_IMU1_0(mac_x_ver,mac_y_ver,mac_z_ver,mac_x_rot,mac_y_rot,mac_z_rot) 
union{
#if(pcb_board = on)
difference{
union{
//Board
prism{-1.500000,0.000000,8
<-0.012800,0.005000><86.372800,0.005000>
<86.372800,0.005000><86.372800,38.120400>
<86.372800,38.120400><-0.012800,38.120400>
<-0.012800,38.120400><-0.012800,0.005000>
texture{col_brd}}  
}//End union(Platine)
//Holes(real)/Parts
//Holes(real)/Board
//Holes(real)/Vias
}//End difference(reale Bohrungen/Durchbrche)
#end
#if(pcb_parts=on)//Parts
union{
#ifndef(pack__RST) #declare global_pack__RST=yes; object {SWITCH_PUSH_BUTTON_LSH43()translate<0,0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,0> translate<80.645000,0.000000,6.985000>translate<0,0.035000,0> }#end		//Switch Schurter Typ LSH 1301.9314 height 4.3 mm !RST 6MM_SMT_SWITCH 6MM_SMT_SWITCH
#ifndef(pack_ACCEL1) #declare global_pack_ACCEL1=yes; object {MMA7455L("MMA7455L","",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<36.195000,0.000000,23.495000>translate<0,0.035000,0> }#end		//    ACCEL1 MMA7455L LGA14
#ifndef(pack_AUX) #declare global_pack_AUX=yes; object {MOLEX_KK2()translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<73.660000,0.000000,5.715000>}#end		//    AUX AUX KK02
#ifndef(pack_C1) #declare global_pack_C1=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<42.545000,0.000000,23.495000>translate<0,0.035000,0> }#end		//SMD Capacitor 0805 C1 470nF C0805
#ifndef(pack_C2) #declare global_pack_C2=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<42.545000,0.000000,21.590000>translate<0,0.035000,0> }#end		//SMD Capacitor 0805 C2 10nF C0805
#ifndef(pack_C3) #declare global_pack_C3=yes; object {C1206P("4.7uF",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,180> translate<27.305000,-1.500000,16.510000>}#end		//SMD Tantalum C3 4.7uF C1206P
#ifndef(pack_C4) #declare global_pack_C4=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,180> translate<17.145000,-1.500000,15.240000>translate<0,-0.035000,0> }#end		//SMD Capacitor 0805 C4 0.1uF C0805
#ifndef(pack_C5) #declare global_pack_C5=yes; object {C1206P("10uF",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<6.350000,0.000000,26.670000>}#end		//SMD Tantalum C5 10uF C1206P
#ifndef(pack_C6) #declare global_pack_C6=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<67.945000,0.000000,10.795000>translate<0,0.035000,0> }#end		//SMD Capacitor 0805 C6 1.0uF C0805
#ifndef(pack_C7) #declare global_pack_C7=yes; object {C1206P("10uF",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,180> translate<62.230000,-1.500000,25.400000>}#end		//SMD Tantalum C7 10uF C1206P
#ifndef(pack_C11) #declare global_pack_C11=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<30.480000,0.000000,12.700000>translate<0,0.035000,0> }#end		//SMD Capacitor 0805 C11 0.22uF C0805
#ifndef(pack_C12) #declare global_pack_C12=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,180> translate<33.655000,-1.500000,16.510000>translate<0,-0.035000,0> }#end		//SMD Capacitor 0805 C12 0.1uF C0805
#ifndef(pack_C13) #declare global_pack_C13=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,180> translate<33.020000,-1.500000,22.225000>translate<0,-0.035000,0> }#end		//SMD Capacitor 0805 C13 0.1uF C0805
#ifndef(pack_C14) #declare global_pack_C14=yes; object {C1206P("10uF",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,180> translate<36.195000,-1.500000,23.495000>}#end		//SMD Tantalum C14 10uF C1206P
#ifndef(pack_C16) #declare global_pack_C16=yes; object {C1206P("10uF",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,180> translate<47.625000,-1.500000,16.510000>}#end		//SMD Tantalum C16 10uF C1206P
#ifndef(pack_C18) #declare global_pack_C18=yes; object {C1206P("10uF",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,180> translate<39.370000,-1.500000,22.225000>}#end		//SMD Tantalum C18 10uF C1206P
#ifndef(pack_C19) #declare global_pack_C19=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,180> translate<43.180000,-1.500000,16.510000>translate<0,-0.035000,0> }#end		//SMD Capacitor 0805 C19 0.1uF C0805
#ifndef(pack_C21) #declare global_pack_C21=yes; object {CAP_SMD_CHIP_0805(DarkWood)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,180> translate<33.020000,-1.500000,26.035000>translate<0,-0.035000,0> }#end		//SMD Capacitor 0805 C21 0.1uF C0805
#ifndef(pack_D1) #declare global_pack_D1=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,0> translate<20.955000,0.000000,22.860000>translate<0,0.035000,0> }#end		//SOT23 D1 BAT54C SOT23-BAT54C
#ifndef(pack_D2) #declare global_pack_D2=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,180> translate<68.580000,-1.500000,13.335000>translate<0,-0.035000,0> }#end		//SOT23 D2 BAT54C SOT23-BAT54C
#ifndef(pack_D3) #declare global_pack_D3=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,180> translate<68.580000,-1.500000,22.860000>translate<0,-0.035000,0> }#end		//SOT23 D3 BAT54C SOT23-BAT54C
#ifndef(pack_D4) #declare global_pack_D4=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,180> translate<64.770000,-1.500000,20.320000>translate<0,-0.035000,0> }#end		//SOT23 D4 BAT54C SOT23-BAT54C
#ifndef(pack_D5) #declare global_pack_D5=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,180> translate<68.580000,-1.500000,17.780000>translate<0,-0.035000,0> }#end		//SOT23 D5 BAT54C SOT23-BAT54C
#ifndef(pack_D6) #declare global_pack_D6=yes; object {IC_SMD_SOT23("BAT54C","",)translate<0,-0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,180> translate<64.770000,-1.500000,15.875000>translate<0,-0.035000,0> }#end		//SOT23 D6 BAT54C SOT23-BAT54C
#ifndef(pack_F1) #declare global_pack_F1=yes; object {RES_SMD_CHIP_1206("POLYFUSE",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<19.685000,0.000000,26.035000>}#end		//SMD Polyfuse      F1 POLYFUSE P1206
#ifndef(pack_GYRO1) #declare global_pack_GYRO1=yes; object {L3G4200D("",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,0> translate<43.180000,0.000000,16.510000>}#end		//     GYRO1 L3G4200D LGA16L
#ifndef(pack_J1) #declare global_pack_J1=yes; object {CON_USB_B_002()translate<0,0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,0> translate<0.000000,0.000000,19.050000>}#end		//USB-B mini J1 USB USB-MB-S
#ifndef(pack_J5) #declare global_pack_J5=yes; object {MOLEX_KK4()translate<0,0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,0> translate<59.055000,0.000000,21.590000>}#end		//    J5 MOLEX_KK4 KK04
#ifndef(pack_J6) #declare global_pack_J6=yes; object {MOLEX_KK4()translate<0,0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,0> translate<50.800000,0.000000,21.590000>}#end		//    J6 MOLEX_KK4 KK04
#ifndef(pack_MAGN1) #declare global_pack_MAGN1=yes; object {HMC5883L()translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<30.480000,0.000000,16.510000>}#end		//      MAGN1 HMC5883L LLC16
#ifndef(pack_MOTOR) #declare global_pack_MOTOR=yes; object {MOLEX_KK2()translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<7.620000,0.000000,32.385000>}#end		//    MOTOR V_Motor KK02
#ifndef(pack_PWR) #declare global_pack_PWR=yes; object {DIODE_SMD_LED_1206(Green,0.500000,0.000000,)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,0> translate<4.445000,0.000000,10.795000>translate<0,0.035000,0> }#end		//SMD-LED 1206 PWR green CHIPLED_1206
#ifndef(pack_R1) #declare global_pack_R1=yes; object {RES_SMD_CHIP_0805("105",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<64.135000,0.000000,13.335000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R1 1M R0805
#ifndef(pack_R2) #declare global_pack_R2=yes; object {RES_SMD_CHIP_0805("405",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<64.135000,0.000000,10.795000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R2 4M R0805
#ifndef(pack_R3) #declare global_pack_R3=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<52.070000,0.000000,13.335000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R3 1K R0805
#ifndef(pack_R4) #declare global_pack_R4=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<58.420000,0.000000,13.335000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R4 1K R0805
#ifndef(pack_R5) #declare global_pack_R5=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<71.755000,0.000000,15.240000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R5 1K R0805
#ifndef(pack_R7) #declare global_pack_R7=yes; object {RES_SMD_CHIP_0805("331",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<9.525000,0.000000,10.795000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R7 330 R0805
#ifndef(pack_R9) #declare global_pack_R9=yes; object {RES_SMD_CHIP_0805("203",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<24.765000,0.000000,26.670000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R9 20K R0805
#ifndef(pack_R10) #declare global_pack_R10=yes; object {RES_SMD_CHIP_0805("103",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<24.765000,0.000000,24.765000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R10 10K R0805
#ifndef(pack_R11) #declare global_pack_R11=yes; object {RES_SMD_CHIP_0805("222",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<36.830000,0.000000,18.415000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R11 2.2K R0805
#ifndef(pack_R12) #declare global_pack_R12=yes; object {RES_SMD_CHIP_0805("222",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<24.130000,0.000000,18.415000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R12 2.2K R0805
#ifndef(pack_R13) #declare global_pack_R13=yes; object {RES_SMD_CHIP_0805("103",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<37.465000,0.000000,14.605000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R13 10K R0805
#ifndef(pack_R14) #declare global_pack_R14=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<71.755000,0.000000,17.145000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R14 1K R0805
#ifndef(pack_R15) #declare global_pack_R15=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<71.755000,0.000000,19.685000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R15 1K R0805
#ifndef(pack_R16) #declare global_pack_R16=yes; object {RES_SMD_CHIP_0805("102",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-180.000000,0> rotate<0,0,0> translate<71.755000,0.000000,22.225000>translate<0,0.035000,0> }#end		//SMD Resistor 0805 R16 1K R0805
#ifndef(pack_U1) #declare global_pack_U1=yes; object {LPCXPRESSO()translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<2.540000,0.000000,7.620000>}#end		//LPCXPRESSO U1 LPCXPRESSO LPCXPRESSO
#ifndef(pack_U2) #declare global_pack_U2=yes; object {BMP085()translate<0,0,0> rotate<0,0.000000,0>rotate<0,0.000000,0> rotate<0,0,0> translate<17.145000,0.000000,15.240000>}#end		//     U2 BMP085 LCC8
#ifndef(pack_U3) #declare global_pack_U3=yes; object {SOT89("78LX33CU","",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-270.000000,0> rotate<0,0,0> translate<13.970000,0.000000,26.035000>translate<0,0.035000,0> }#end		//SOT89 U3 78LX33CU SOT89
#ifndef(pack_U4) #declare global_pack_U4=yes; object {SOT89("78L05","",)translate<0,0,0> rotate<0,0.000000,0>rotate<0,-90.000000,0> rotate<0,0,0> translate<67.310000,0.000000,25.400000>translate<0,0.035000,0> }#end		//SOT89 U4 78L05 SOT89
}//End union
#end
#if(pcb_pads_smds=on)
//Pads&SMD/Parts
object{TOOLS_PCB_SMD(2.100000,1.400000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<82.969500,0.000000,2.480500>}
object{TOOLS_PCB_SMD(2.100000,1.400000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<82.869500,0.000000,11.570500>}
object{TOOLS_PCB_SMD(2.100000,1.400000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<78.419500,0.000000,2.470500>}
object{TOOLS_PCB_SMD(2.100000,1.400000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<78.419500,0.000000,11.570500>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,25.395000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,24.645000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,23.895000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,23.145000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,22.395000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<34.595000,0.000000,21.645000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<36.195000,0.000000,20.895000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,21.645000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,22.395000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,23.145000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,23.895000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,24.645000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<37.895000,0.000000,25.395000>}
object{TOOLS_PCB_SMD(0.550000,2.145000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<36.195000,0.000000,26.095000>}
#ifndef(global_pack_AUX) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-0.000000,0>translate<74.930000,0,5.715000> texture{col_thl}}
#ifndef(global_pack_AUX) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-0.000000,0>translate<72.390000,0,5.715000> texture{col_thl}}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<41.695000,0.000000,23.495000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<43.395000,0.000000,23.495000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<43.395000,0.000000,21.590000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<41.695000,0.000000,21.590000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<27.305000,-1.537000,15.110000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<27.305000,-1.537000,17.910000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<17.145000,-1.537000,14.390000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<17.145000,-1.537000,16.090000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<4.950000,0.000000,26.670000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<7.750000,0.000000,26.670000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<67.095000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<68.795000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<62.230000,-1.537000,24.000000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<62.230000,-1.537000,26.800000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<29.630000,0.000000,12.700000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<31.330000,0.000000,12.700000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.655000,-1.537000,15.660000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.655000,-1.537000,17.360000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.020000,-1.537000,21.375000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.020000,-1.537000,23.075000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<36.195000,-1.537000,22.095000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<36.195000,-1.537000,24.895000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<47.625000,-1.537000,15.110000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<47.625000,-1.537000,17.910000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<39.370000,-1.537000,20.825000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<39.370000,-1.537000,23.625000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<43.180000,-1.537000,15.660000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<43.180000,-1.537000,17.360000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.020000,-1.537000,25.185000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<33.020000,-1.537000,26.885000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<22.055000,0.000000,22.860000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<19.855000,0.000000,23.810000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<19.855000,0.000000,21.910000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<68.580000,-1.537000,14.435000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<69.530000,-1.537000,12.235000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<67.630000,-1.537000,12.235000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<68.580000,-1.537000,23.960000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<69.530000,-1.537000,21.760000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<67.630000,-1.537000,21.760000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<64.770000,-1.537000,21.420000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<65.720000,-1.537000,19.220000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<63.820000,-1.537000,19.220000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<68.580000,-1.537000,18.880000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<69.530000,-1.537000,16.680000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<67.630000,-1.537000,16.680000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<64.770000,-1.537000,16.975000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<65.720000,-1.537000,14.775000>}
object{TOOLS_PCB_SMD(1.000000,1.400000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<63.820000,-1.537000,14.775000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<18.285000,0.000000,26.035000>}
object{TOOLS_PCB_SMD(1.600000,1.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<21.085000,0.000000,26.035000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<44.180000,0.000000,18.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<43.505000,0.000000,18.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<42.880000,0.000000,18.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<42.205000,0.000000,18.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<41.180000,0.000000,17.485000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<41.180000,0.000000,16.835000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<41.180000,0.000000,16.185000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<41.180000,0.000000,15.535000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<42.230000,0.000000,14.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<42.880000,0.000000,14.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<43.505000,0.000000,14.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<44.155000,0.000000,14.510000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<45.180000,0.000000,15.535000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<45.180000,0.000000,16.185000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<45.180000,0.000000,16.860000>}
object{TOOLS_PCB_SMD(0.300000,0.800000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<45.180000,0.000000,17.485000>}
object{TOOLS_PCB_SMD(2.500000,0.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<9.250000,0.000000,19.050000>}
object{TOOLS_PCB_SMD(2.500000,0.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<9.250000,0.000000,19.850000>}
object{TOOLS_PCB_SMD(2.500000,0.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<9.250000,0.000000,17.450000>}
object{TOOLS_PCB_SMD(2.500000,2.000000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<2.842000,0.000000,23.550000>}
object{TOOLS_PCB_SMD(2.500000,2.000000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<8.342000,0.000000,23.550000>}
object{TOOLS_PCB_SMD(2.500000,2.000000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<2.842000,0.000000,14.550000>}
object{TOOLS_PCB_SMD(2.500000,2.000000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<8.342000,0.000000,14.650000>}
object{TOOLS_PCB_SMD(2.500000,0.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<9.250000,0.000000,18.250000>}
object{TOOLS_PCB_SMD(2.500000,0.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<9.250000,0.000000,20.650000>}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,32.385000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,29.845000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,27.305000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,24.765000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,22.225000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,19.685000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,17.145000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<78.105000,0,14.605000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,32.385000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,29.845000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,27.305000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,24.765000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,22.225000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,19.685000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,17.145000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<80.645000,0,14.605000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,32.385000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,29.845000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,27.305000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,24.765000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,22.225000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,19.685000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,17.145000> texture{col_thl}}
#ifndef(global_pack_J2) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<83.185000,0,14.605000> texture{col_thl}}
#ifndef(global_pack_J5) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<59.055000,0,17.780000> texture{col_thl}}
#ifndef(global_pack_J5) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<59.055000,0,25.400000> texture{col_thl}}
#ifndef(global_pack_J5) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<59.055000,0,20.320000> texture{col_thl}}
#ifndef(global_pack_J5) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<59.055000,0,22.860000> texture{col_thl}}
#ifndef(global_pack_J6) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<50.800000,0,17.780000> texture{col_thl}}
#ifndef(global_pack_J6) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<50.800000,0,25.400000> texture{col_thl}}
#ifndef(global_pack_J6) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<50.800000,0,20.320000> texture{col_thl}}
#ifndef(global_pack_J6) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-270.000000,0>translate<50.800000,0,22.860000> texture{col_thl}}
object{TOOLS_PCB_SMD(1.200000,1.200000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<53.120000,0.000000,11.430000>}
object{TOOLS_PCB_SMD(1.200000,1.200000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<51.020000,0.000000,11.430000>}
object{TOOLS_PCB_SMD(1.200000,1.200000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<60.105000,0.000000,11.430000>}
object{TOOLS_PCB_SMD(1.200000,1.200000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<58.005000,0.000000,11.430000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<28.980000,0.000000,17.260000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<28.980000,0.000000,16.760000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<28.980000,0.000000,16.260000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<28.980000,0.000000,15.760000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<29.730000,0.000000,15.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<30.230000,0.000000,15.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<30.730000,0.000000,15.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<31.230000,0.000000,15.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<31.980000,0.000000,15.760000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<31.980000,0.000000,16.260000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<31.980000,0.000000,16.760000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<31.980000,0.000000,17.260000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<31.230000,0.000000,18.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<30.730000,0.000000,18.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<30.230000,0.000000,18.010000>}
object{TOOLS_PCB_SMD(0.300000,0.900000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<29.730000,0.000000,18.010000>}
#ifndef(global_pack_MOTOR) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<6.350000,0,32.385000> texture{col_thl}}
#ifndef(global_pack_MOTOR) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-180.000000,0>translate<8.890000,0,32.385000> texture{col_thl}}
object{TOOLS_PCB_SMD(1.500000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<6.195000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.500000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<2.695000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<64.985000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<63.285000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<63.285000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<64.985000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<52.920000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<51.220000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<59.270000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<57.570000,0.000000,13.335000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<72.605000,0.000000,15.240000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<70.905000,0.000000,15.240000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<8.675000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<10.375000,0.000000,10.795000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<25.615000,0.000000,26.670000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<23.915000,0.000000,26.670000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<23.915000,0.000000,24.765000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<25.615000,0.000000,24.765000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<35.980000,0.000000,18.415000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<37.680000,0.000000,18.415000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<24.980000,0.000000,18.415000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<23.280000,0.000000,18.415000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<38.315000,0.000000,14.605000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<36.615000,0.000000,14.605000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<70.905000,0.000000,17.145000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<72.605000,0.000000,17.145000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<72.605000,0.000000,19.685000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<70.905000,0.000000,19.685000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<72.605000,0.000000,22.225000>}
object{TOOLS_PCB_SMD(1.300000,1.500000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<70.905000,0.000000,22.225000>}
#ifndef(global_pack_TST1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-0.000000,0>translate<80.645000,0,36.195000> texture{col_thl}}
#ifndef(global_pack_TST1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.638400,1.092200,1,16,0+global_tmp,0) rotate<0,-0.000000,0>translate<83.185000,0,36.195000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<10.160000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<2.540000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<25.400000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<22.860000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<68.580000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<2.540000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<22.860000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<25.400000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<53.340000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<55.880000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<27.940000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<30.480000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<20.320000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<17.780000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<15.240000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<12.700000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<33.020000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<35.560000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<33.020000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<35.560000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<30.480000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<27.940000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<58.420000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<60.960000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<38.100000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<40.640000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<43.180000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<45.720000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<63.500000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<66.040000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<48.260000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<50.800000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<38.100000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<40.640000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<43.180000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<45.720000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<48.260000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<50.800000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<53.340000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<55.880000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<58.420000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<60.960000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<63.500000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<66.040000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<68.580000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<15.240000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<12.700000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<20.320000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<17.780000,0,30.480000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<7.620000,0,7.620000> texture{col_thl}}
#ifndef(global_pack_U1) #local global_tmp=0; #else #local global_tmp=100; #end object{TOOLS_PCB_VIA(1.524000,1.016000,1,16,3+global_tmp,100) rotate<0,-90.000000,0>translate<5.080000,0,7.620000> texture{col_thl}}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<14.605000,0.000000,16.510000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<14.605000,0.000000,15.240000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-0.000000,0> texture{col_pds} translate<14.605000,0.000000,13.970000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<17.145000,0.000000,12.700000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<19.685000,0.000000,13.970000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<19.685000,0.000000,15.240000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-180.000000,0> texture{col_pds} translate<19.685000,0.000000,16.510000>}
object{TOOLS_PCB_SMD(2.200000,0.650000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<17.145000,0.000000,17.780000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<12.220000,0.000000,27.535000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<12.220000,0.000000,26.035000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<12.220000,0.000000,24.535000>}
object{TOOLS_PCB_SMD(2.500000,3.000000,0.037000,0) rotate<0,-270.000000,0> texture{col_pds} translate<15.020000,0.000000,26.035000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<69.060000,0.000000,23.900000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<69.060000,0.000000,25.400000>}
object{TOOLS_PCB_SMD(0.800000,1.500000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<69.060000,0.000000,26.900000>}
object{TOOLS_PCB_SMD(2.500000,3.000000,0.037000,0) rotate<0,-90.000000,0> texture{col_pds} translate<66.260000,0.000000,25.400000>}
//Pads/Vias
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<17.907000,0,11.049000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<31.750000,0,24.130000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<24.511000,0,21.971000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<39.370000,0,15.875000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<64.516000,0,9.398000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<36.068000,0,16.002000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<11.176000,0,28.575000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<67.437000,0,23.241000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<62.103000,0,22.225000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<37.211000,0,20.574000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<35.179000,0,19.812000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<39.116000,0,10.287000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<13.716000,0,19.050000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<11.049000,0,22.352000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<57.277000,0,16.256000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<41.402000,0,18.542000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<32.258000,0,14.986000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<41.402000,0,14.732000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<11.938000,0,16.129000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.750000,0.500000,1,16,1,0) translate<52.578000,0,16.510000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<39.751000,0,12.446000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<40.513000,0,14.097000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<29.083000,0,14.097000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<38.989000,0,19.304000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<32.131000,0,19.050000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<30.226000,0,19.812000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<33.655000,0,19.812000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<61.849000,0,18.923000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<63.627000,0,20.701000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<15.494000,0,21.844000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<10.160000,0,21.590000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<76.835000,0,13.208000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<62.611000,0,14.732000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<41.783000,0,24.892000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<44.196000,0,24.892000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<13.716000,0,23.876000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<16.256000,0,24.130000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<30.099000,0,16.129000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<66.929000,0,19.685000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<66.929000,0,15.240000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<12.827000,0,13.589000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<26.543000,0,11.811000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<56.261000,0,12.827000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<43.688000,0,20.193000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<45.339000,0,21.844000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<45.339000,0,27.813000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<36.195000,0,27.813000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<28.575000,0,24.638000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<22.606000,0,21.717000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<18.288000,0,19.050000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<20.828000,0,17.653000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<29.337000,0,19.050000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<42.672000,0,19.558000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<40.132000,0,19.304000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<48.768000,0,13.716000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<47.244000,0,19.431000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<40.513000,0,25.019000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<41.783000,0,26.416000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<54.991000,0,21.463000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<42.672000,0,25.654000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<48.768000,0,16.510000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<52.959000,0,4.953000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<28.321000,0,12.446000> texture{col_thl}}
object{TOOLS_PCB_VIA(0.914400,0.609600,1,16,1,0) translate<37.592000,0,10.668000> texture{col_thl}}
#end
#if(pcb_wires=on)
union{
//Signals
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.540000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.540000,0.000000,10.668000>}
box{<0,0,-0.152400><3.048000,0.035000,0.152400> rotate<0,90.000000,0> translate<2.540000,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<2.540000,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<2.540000,0.000000,30.480000>}
box{<0,0,-0.088900><1.524000,0.035000,0.088900> rotate<0,90.000000,0> translate<2.540000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.540000,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,10.795000>}
box{<0,0,-0.152400><0.179605,0.035000,0.152400> rotate<0,-44.997030,0> translate<2.540000,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,14.351000>}
box{<0,0,-0.152400><3.429000,0.035000,0.152400> rotate<0,90.000000,0> translate<2.667000,0.000000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.695000,0.000000,10.795000>}
box{<0,0,-0.152400><0.028000,0.035000,0.152400> rotate<0,0.000000,0> translate<2.667000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.695000,0.000000,10.795000>}
box{<0,0,-0.152400><0.130050,0.035000,0.152400> rotate<0,77.561646,0> translate<2.667000,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.667000,0.000000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.794000,0.000000,14.478000>}
box{<0,0,-0.152400><0.179605,0.035000,0.152400> rotate<0,-44.997030,0> translate<2.667000,0.000000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.794000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.842000,0.000000,14.550000>}
box{<0,0,-0.152400><0.086533,0.035000,0.152400> rotate<0,-56.306216,0> translate<2.794000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.842000,0.000000,14.550000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.921000,0.000000,14.605000>}
box{<0,0,-0.152400><0.096260,0.035000,0.152400> rotate<0,-34.843434,0> translate<2.842000,0.000000,14.550000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.842000,0.000000,23.550000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.921000,0.000000,23.495000>}
box{<0,0,-0.152400><0.096260,0.035000,0.152400> rotate<0,34.843434,0> translate<2.842000,0.000000,23.550000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.921000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.921000,0.000000,23.495000>}
box{<0,0,-0.152400><8.890000,0.035000,0.152400> rotate<0,90.000000,0> translate<2.921000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<2.540000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.445000,-1.535000,28.575000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<2.540000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,8.001000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,11.938000>}
box{<0,0,-0.088900><3.937000,0.035000,0.088900> rotate<0,90.000000,0> translate<4.699000,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,26.543000>}
box{<0,0,-0.088900><14.605000,0.035000,0.088900> rotate<0,90.000000,0> translate<4.699000,0.000000,26.543000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<2.540000,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.826000,0.000000,26.670000>}
box{<0,0,-0.088900><3.232892,0.035000,0.088900> rotate<0,44.997030,0> translate<2.540000,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,26.543000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.826000,0.000000,26.670000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<4.699000,0.000000,26.543000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.826000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.950000,0.000000,26.670000>}
box{<0,0,-0.088900><0.124000,0.035000,0.088900> rotate<0,0.000000,0> translate<4.826000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,8.001000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<5.080000,0.000000,7.620000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<4.699000,0.000000,8.001000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<6.350000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<6.350000,0.000000,34.290000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,90.000000,0> translate<6.350000,0.000000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.750000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.874000,0.000000,26.670000>}
box{<0,0,-0.152400><0.124000,0.035000,0.152400> rotate<0,0.000000,0> translate<7.750000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.750000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.874000,0.000000,26.797000>}
box{<0,0,-0.152400><0.177496,0.035000,0.152400> rotate<0,-45.681762,0> translate<7.750000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.255000,0.000000,26.289000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.255000,0.000000,23.622000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,-90.000000,0> translate<8.255000,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.874000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.255000,0.000000,26.289000>}
box{<0,0,-0.152400><0.538815,0.035000,0.152400> rotate<0,44.997030,0> translate<7.874000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.255000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.342000,0.000000,23.550000>}
box{<0,0,-0.152400><0.112929,0.035000,0.152400> rotate<0,39.608074,0> translate<8.255000,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.342000,0.000000,14.650000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.382000,0.000000,14.732000>}
box{<0,0,-0.152400><0.091236,0.035000,0.152400> rotate<0,-63.992431,0> translate<8.342000,0.000000,14.650000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.750000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.382000,0.000000,25.908000>}
box{<0,0,-0.152400><0.989984,0.035000,0.152400> rotate<0,50.324491,0> translate<7.750000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<6.195000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<8.675000,0.000000,10.795000>}
box{<0,0,-0.088900><2.480000,0.035000,0.088900> rotate<0,0.000000,0> translate<6.195000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<7.874000,0.000000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.890000,0.000000,27.813000>}
box{<0,0,-0.152400><1.436841,0.035000,0.152400> rotate<0,-44.997030,0> translate<7.874000,0.000000,26.797000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.890000,0.000000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.890000,0.000000,32.385000>}
box{<0,0,-0.152400><4.572000,0.035000,0.152400> rotate<0,90.000000,0> translate<8.890000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.382000,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,15.621000>}
box{<0,0,-0.152400><1.257236,0.035000,0.152400> rotate<0,-44.997030,0> translate<8.382000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,15.621000>}
box{<0,0,-0.152400><0.889000,0.035000,0.152400> rotate<0,-90.000000,0> translate<9.271000,0.000000,15.621000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.250000,0.000000,17.450000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,17.399000>}
box{<0,0,-0.152400><0.055154,0.035000,0.152400> rotate<0,67.615402,0> translate<9.250000,0.000000,17.450000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,17.399000>}
box{<0,0,-0.152400><0.889000,0.035000,0.152400> rotate<0,90.000000,0> translate<9.271000,0.000000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.250000,0.000000,19.850000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.271000,0.000000,19.939000>}
box{<0,0,-0.088900><0.091444,0.035000,0.088900> rotate<0,-76.718540,0> translate<9.250000,0.000000,19.850000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.250000,0.000000,20.650000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.271000,0.000000,20.701000>}
box{<0,0,-0.088900><0.055154,0.035000,0.088900> rotate<0,-67.615402,0> translate<9.250000,0.000000,20.650000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.699000,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.398000,0.000000,11.938000>}
box{<0,0,-0.088900><4.699000,0.035000,0.088900> rotate<0,0.000000,0> translate<4.699000,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.652000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.652000,0.000000,11.430000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,-90.000000,0> translate<9.652000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.398000,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.652000,0.000000,11.684000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,44.997030,0> translate<9.398000,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.271000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.160000,0.000000,21.590000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,-44.997030,0> translate<9.271000,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.652000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.287000,0.000000,10.795000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<9.652000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.287000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.375000,0.000000,10.795000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<10.287000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<2.540000,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<10.922000,-1.535000,16.002000>}
box{<0,0,-0.152400><11.853938,0.035000,0.152400> rotate<0,-44.997030,0> translate<2.540000,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.271000,0.000000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.049000,0.000000,19.939000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<9.271000,0.000000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.049000,0.000000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.049000,0.000000,22.352000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,90.000000,0> translate<11.049000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<4.445000,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.176000,-1.535000,28.575000>}
box{<0,0,-0.088900><6.731000,0.035000,0.088900> rotate<0,0.000000,0> translate<4.445000,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<5.080000,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.811000,-1.535000,14.351000>}
box{<0,0,-0.088900><9.519071,0.035000,0.088900> rotate<0,-44.997030,0> translate<5.080000,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<10.922000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,-1.535000,16.002000>}
box{<0,0,-0.152400><1.016000,0.035000,0.152400> rotate<0,0.000000,0> translate<10.922000,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,-1.535000,16.129000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,90.000000,0> translate<11.938000,-1.535000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<9.271000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,0.000000,16.510000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,0.000000,0> translate<9.271000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,0.000000,16.129000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,0.000000,16.510000>}
box{<0,0,-0.152400><0.381000,0.035000,0.152400> rotate<0,90.000000,0> translate<11.938000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.160000,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.065000,-1.535000,5.715000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<10.160000,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.382000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<12.192000,0.000000,25.908000>}
box{<0,0,-0.152400><3.810000,0.035000,0.152400> rotate<0,0.000000,0> translate<8.382000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.176000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.192000,0.000000,27.559000>}
box{<0,0,-0.088900><1.436841,0.035000,0.088900> rotate<0,44.997030,0> translate<11.176000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<12.192000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<12.220000,0.000000,26.035000>}
box{<0,0,-0.152400><0.130050,0.035000,0.152400> rotate<0,-77.561646,0> translate<12.192000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.192000,0.000000,27.559000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.220000,0.000000,27.535000>}
box{<0,0,-0.088900><0.036878,0.035000,0.088900> rotate<0,40.598615,0> translate<12.192000,0.000000,27.559000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.220000,0.000000,24.535000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.319000,0.000000,24.511000>}
box{<0,0,-0.088900><0.101868,0.035000,0.088900> rotate<0,13.626096,0> translate<12.220000,0.000000,24.535000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.220000,0.000000,27.535000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.319000,0.000000,27.559000>}
box{<0,0,-0.088900><0.101868,0.035000,0.088900> rotate<0,-13.626096,0> translate<12.220000,0.000000,27.535000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.065000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,-1.535000,5.715000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,0.000000,0> translate<12.065000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,0.000000,13.589000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,0.000000,15.240000>}
box{<0,0,-0.088900><1.651000,0.035000,0.088900> rotate<0,90.000000,0> translate<12.827000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<8.890000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.208000,0.000000,32.385000>}
box{<0,0,-0.152400><4.318000,0.035000,0.152400> rotate<0,0.000000,0> translate<8.890000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<9.250000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,0.000000,19.050000>}
box{<0,0,-0.088900><4.466000,0.035000,0.088900> rotate<0,0.000000,0> translate<9.250000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,0.000000,24.511000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,0.000000,23.876000>}
box{<0,0,-0.088900><0.635000,0.035000,0.088900> rotate<0,-90.000000,0> translate<13.716000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.319000,0.000000,24.511000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,0.000000,24.511000>}
box{<0,0,-0.088900><1.397000,0.035000,0.088900> rotate<0,0.000000,0> translate<12.319000,0.000000,24.511000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.843000,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.843000,0.000000,28.575000>}
box{<0,0,-0.152400><3.175000,0.035000,0.152400> rotate<0,-90.000000,0> translate<13.843000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.208000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.843000,0.000000,31.750000>}
box{<0,0,-0.152400><0.898026,0.035000,0.152400> rotate<0,44.997030,0> translate<13.208000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.970000,-1.535000,24.130000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<13.716000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.375000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,10.795000>}
box{<0,0,-0.088900><4.230000,0.035000,0.088900> rotate<0,0.000000,0> translate<10.375000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,12.700000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,90.000000,0> translate<14.605000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,13.970000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,90.000000,0> translate<14.605000,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,15.240000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<12.827000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<14.605000,0.000000,16.510000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,0.000000,0> translate<11.938000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<14.605000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<14.605000,0.000000,25.908000>}
box{<0,0,-0.152400><9.398000,0.035000,0.152400> rotate<0,90.000000,0> translate<14.605000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.732000,-1.535000,3.810000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<12.827000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<12.220000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<15.020000,0.000000,26.035000>}
box{<0,0,-0.152400><2.800000,0.035000,0.152400> rotate<0,0.000000,0> translate<12.220000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<14.605000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<15.020000,0.000000,26.035000>}
box{<0,0,-0.152400><0.433998,0.035000,0.152400> rotate<0,-17.014250,0> translate<14.605000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<10.160000,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.240000,-1.535000,21.590000>}
box{<0,0,-0.088900><5.080000,0.035000,0.088900> rotate<0,0.000000,0> translate<10.160000,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.240000,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.494000,-1.535000,21.844000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<15.240000,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.716000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.748000,-1.535000,21.082000>}
box{<0,0,-0.088900><2.873682,0.035000,0.088900> rotate<0,-44.997030,0> translate<13.716000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.748000,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.002000,-1.535000,21.082000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,0.000000,0> translate<15.748000,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<13.970000,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.256000,-1.535000,24.130000>}
box{<0,0,-0.088900><2.286000,0.035000,0.088900> rotate<0,0.000000,0> translate<13.970000,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.827000,-1.535000,13.589000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.891000,-1.535000,9.525000>}
box{<0,0,-0.088900><5.747364,0.035000,0.088900> rotate<0,44.997030,0> translate<12.827000,-1.535000,13.589000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<11.938000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.018000,-1.535000,16.002000>}
box{<0,0,-0.152400><5.080000,0.035000,0.152400> rotate<0,0.000000,0> translate<11.938000,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.605000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.145000,0.000000,12.700000>}
box{<0,0,-0.088900><2.540000,0.035000,0.088900> rotate<0,0.000000,0> translate<14.605000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.811000,-1.535000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.145000,-1.535000,14.351000>}
box{<0,0,-0.088900><5.334000,0.035000,0.088900> rotate<0,0.000000,0> translate<11.811000,-1.535000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.145000,-1.535000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.145000,-1.535000,14.390000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,90.000000,0> translate<17.145000,-1.535000,14.390000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.018000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.145000,-1.535000,16.090000>}
box{<0,0,-0.152400><0.154509,0.035000,0.152400> rotate<0,-34.716315,0> translate<17.018000,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.145000,-1.535000,16.090000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.145000,-1.535000,16.129000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,90.000000,0> translate<17.145000,-1.535000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<11.049000,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.272000,-1.535000,28.575000>}
box{<0,0,-0.088900><8.800651,0.035000,0.088900> rotate<0,-44.997030,0> translate<11.049000,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.145000,-1.535000,16.129000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.780000,-1.535000,16.764000>}
box{<0,0,-0.152400><0.898026,0.035000,0.152400> rotate<0,-44.997030,0> translate<17.145000,-1.535000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.145000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.907000,0.000000,17.018000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,44.997030,0> translate<17.145000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.907000,0.000000,11.049000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.907000,0.000000,17.018000>}
box{<0,0,-0.088900><5.969000,0.035000,0.088900> rotate<0,90.000000,0> translate<17.907000,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.256000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.161000,0.000000,26.035000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<16.256000,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.161000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.285000,0.000000,26.035000>}
box{<0,0,-0.088900><0.124000,0.035000,0.088900> rotate<0,0.000000,0> translate<18.161000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.288000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.288000,0.000000,15.240000>}
box{<0,0,-0.088900><3.810000,0.035000,0.088900> rotate<0,-90.000000,0> translate<18.288000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<6.350000,0.000000,34.290000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.796000,0.000000,34.290000>}
box{<0,0,-0.088900><12.446000,0.035000,0.088900> rotate<0,0.000000,0> translate<6.350000,0.000000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.907000,-1.535000,11.049000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.050000,-1.535000,9.906000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<17.907000,-1.535000,11.049000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.288000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.685000,0.000000,15.240000>}
box{<0,0,-0.088900><1.397000,0.035000,0.088900> rotate<0,0.000000,0> translate<18.288000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<15.494000,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.812000,0.000000,21.844000>}
box{<0,0,-0.088900><4.318000,0.035000,0.088900> rotate<0,0.000000,0> translate<15.494000,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.812000,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.855000,0.000000,21.910000>}
box{<0,0,-0.088900><0.078772,0.035000,0.088900> rotate<0,-56.911391,0> translate<19.812000,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<19.855000,0.000000,23.810000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<19.939000,0.000000,23.749000>}
box{<0,0,-0.190500><0.103812,0.035000,0.190500> rotate<0,35.984421,0> translate<19.855000,0.000000,23.810000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.796000,0.000000,34.290000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.320000,0.000000,32.766000>}
box{<0,0,-0.088900><2.155261,0.035000,0.088900> rotate<0,44.997030,0> translate<18.796000,0.000000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.685000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.828000,0.000000,17.653000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<19.685000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<18.288000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.955000,-1.535000,21.717000>}
box{<0,0,-0.088900><3.771708,0.035000,0.088900> rotate<0,-44.997030,0> translate<18.288000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<19.939000,0.000000,23.749000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<20.955000,0.000000,22.733000>}
box{<0,0,-0.190500><1.436841,0.035000,0.190500> rotate<0,44.997030,0> translate<19.939000,0.000000,23.749000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<20.955000,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<20.955000,0.000000,22.733000>}
box{<0,0,-0.190500><3.937000,0.035000,0.190500> rotate<0,90.000000,0> translate<20.955000,0.000000,22.733000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<17.272000,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.955000,-1.535000,28.575000>}
box{<0,0,-0.088900><3.683000,0.035000,0.088900> rotate<0,0.000000,0> translate<17.272000,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.085000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.209000,0.000000,26.035000>}
box{<0,0,-0.088900><0.124000,0.035000,0.088900> rotate<0,0.000000,0> translate<21.085000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.209000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.209000,0.000000,26.035000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,90.000000,0> translate<21.209000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<13.843000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<21.336000,0.000000,28.575000>}
box{<0,0,-0.152400><7.493000,0.035000,0.152400> rotate<0,0.000000,0> translate<13.843000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.463000,0.000000,31.623000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.463000,0.000000,29.083000>}
box{<0,0,-0.088900><2.540000,0.035000,0.088900> rotate<0,-90.000000,0> translate<21.463000,0.000000,29.083000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.320000,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.463000,0.000000,31.623000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<20.320000,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<12.319000,0.000000,27.559000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.717000,0.000000,27.559000>}
box{<0,0,-0.088900><9.398000,0.035000,0.088900> rotate<0,0.000000,0> translate<12.319000,0.000000,27.559000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.209000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.971000,0.000000,22.860000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,44.997030,0> translate<21.209000,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.971000,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.055000,0.000000,22.860000>}
box{<0,0,-0.088900><0.084000,0.035000,0.088900> rotate<0,0.000000,0> translate<21.971000,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.828000,-1.535000,17.653000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,-1.535000,19.050000>}
box{<0,0,-0.088900><1.975656,0.035000,0.088900> rotate<0,-44.997030,0> translate<20.828000,-1.535000,17.653000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,0.000000,27.051000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,0.000000,24.638000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,-90.000000,0> translate<22.225000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.717000,0.000000,27.559000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,0.000000,27.051000>}
box{<0,0,-0.088900><0.718420,0.035000,0.088900> rotate<0,44.997030,0> translate<21.717000,0.000000,27.559000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.955000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,-1.535000,21.717000>}
box{<0,0,-0.088900><1.651000,0.035000,0.088900> rotate<0,0.000000,0> translate<20.955000,-1.535000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,0.000000,21.717000>}
box{<0,0,-0.088900><2.667000,0.035000,0.088900> rotate<0,90.000000,0> translate<22.606000,0.000000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,-1.535000,24.638000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,90.000000,0> translate<22.606000,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<22.733000,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<22.733000,0.000000,25.908000>}
box{<0,0,-0.152400><1.270000,0.035000,0.152400> rotate<0,-90.000000,0> translate<22.733000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<21.336000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<22.733000,0.000000,27.178000>}
box{<0,0,-0.152400><1.975656,0.035000,0.152400> rotate<0,44.997030,0> translate<21.336000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<20.955000,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<22.860000,0.000000,16.891000>}
box{<0,0,-0.190500><2.694077,0.035000,0.190500> rotate<0,44.997030,0> translate<20.955000,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<22.860000,0.000000,10.033000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<22.860000,0.000000,16.891000>}
box{<0,0,-0.190500><6.858000,0.035000,0.190500> rotate<0,90.000000,0> translate<22.860000,0.000000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.955000,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.860000,-1.535000,30.480000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<20.955000,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.241000,0.000000,18.415000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<22.606000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.241000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.280000,0.000000,18.415000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<23.241000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.280000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.368000,0.000000,18.415000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<23.280000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.368000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.368000,0.000000,18.415000>}
box{<0,0,-0.088900><2.159000,0.035000,0.088900> rotate<0,90.000000,0> translate<23.368000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<22.733000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<23.876000,0.000000,24.765000>}
box{<0,0,-0.152400><1.616446,0.035000,0.152400> rotate<0,44.997030,0> translate<22.733000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<21.463000,0.000000,29.083000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.876000,0.000000,26.670000>}
box{<0,0,-0.088900><3.412497,0.035000,0.088900> rotate<0,44.997030,0> translate<21.463000,0.000000,29.083000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<23.876000,0.000000,24.765000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<23.915000,0.000000,24.765000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,0.000000,0> translate<23.876000,0.000000,24.765000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.876000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.915000,0.000000,26.670000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<23.876000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<22.860000,0.000000,10.033000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<24.257000,0.000000,8.636000>}
box{<0,0,-0.190500><1.975656,0.035000,0.190500> rotate<0,44.997030,0> translate<22.860000,0.000000,10.033000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<24.257000,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<24.257000,0.000000,8.636000>}
box{<0,0,-0.190500><2.794000,0.035000,0.190500> rotate<0,90.000000,0> translate<24.257000,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,19.050000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,-90.000000,0> translate<24.257000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,21.971000>}
box{<0,0,-0.088900><0.635000,0.035000,0.088900> rotate<0,-90.000000,0> translate<24.257000,0.000000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,22.606000>}
box{<0,0,-0.088900><2.873682,0.035000,0.088900> rotate<0,44.997030,0> translate<22.225000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.511000,0.000000,21.971000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,0.000000,0> translate<24.257000,0.000000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.511000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.511000,-1.535000,23.368000>}
box{<0,0,-0.088900><1.397000,0.035000,0.088900> rotate<0,90.000000,0> translate<24.511000,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.257000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.892000,0.000000,18.415000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<24.257000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.892000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.980000,0.000000,18.415000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<24.892000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.511000,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.019000,-1.535000,23.876000>}
box{<0,0,-0.088900><0.718420,0.035000,0.088900> rotate<0,-44.997030,0> translate<24.511000,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.002000,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.400000,-1.535000,30.480000>}
box{<0,0,-0.088900><13.290779,0.035000,0.088900> rotate<0,-44.997030,0> translate<16.002000,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.860000,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.527000,-1.535000,4.953000>}
box{<0,0,-0.088900><3.771708,0.035000,0.088900> rotate<0,44.997030,0> translate<22.860000,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.615000,0.000000,24.765000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.654000,0.000000,24.765000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<25.615000,0.000000,24.765000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.615000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.654000,0.000000,26.670000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<25.615000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.654000,0.000000,24.765000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.654000,0.000000,26.670000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,90.000000,0> translate<25.654000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<17.780000,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<26.162000,-1.535000,16.764000>}
box{<0,0,-0.152400><8.382000,0.035000,0.152400> rotate<0,0.000000,0> translate<17.780000,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.400000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<26.543000,0.000000,8.763000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<25.400000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<26.543000,0.000000,8.763000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<26.543000,0.000000,11.811000>}
box{<0,0,-0.088900><3.048000,0.035000,0.088900> rotate<0,90.000000,0> translate<26.543000,0.000000,11.811000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.305000,-1.535000,15.110000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.305000,-1.535000,15.113000>}
box{<0,0,-0.088900><0.003000,0.035000,0.088900> rotate<0,90.000000,0> translate<27.305000,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<26.162000,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.305000,-1.535000,17.907000>}
box{<0,0,-0.152400><1.616446,0.035000,0.152400> rotate<0,-44.997030,0> translate<26.162000,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.305000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.305000,-1.535000,17.910000>}
box{<0,0,-0.152400><0.003000,0.035000,0.152400> rotate<0,90.000000,0> translate<27.305000,-1.535000,17.910000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.305000,-1.535000,17.910000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.432000,-1.535000,17.907000>}
box{<0,0,-0.152400><0.127035,0.035000,0.152400> rotate<0,1.353103,0> translate<27.305000,-1.535000,17.910000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.654000,0.000000,24.765000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.432000,0.000000,22.987000>}
box{<0,0,-0.088900><2.514472,0.035000,0.088900> rotate<0,44.997030,0> translate<25.654000,0.000000,24.765000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.432000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.432000,0.000000,22.987000>}
box{<0,0,-0.088900><9.652000,0.035000,0.088900> rotate<0,90.000000,0> translate<27.432000,0.000000,22.987000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.813000,0.000000,15.367000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.813000,0.000000,30.353000>}
box{<0,0,-0.088900><14.986000,0.035000,0.088900> rotate<0,90.000000,0> translate<27.813000,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<26.543000,-1.535000,11.811000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.940000,-1.535000,13.208000>}
box{<0,0,-0.088900><1.975656,0.035000,0.088900> rotate<0,-44.997030,0> translate<26.543000,-1.535000,11.811000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.813000,0.000000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.940000,0.000000,30.480000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<27.813000,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.194000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.194000,0.000000,15.748000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,-90.000000,0> translate<28.194000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.432000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.321000,0.000000,12.446000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,44.997030,0> translate<27.432000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.194000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.448000,0.000000,16.764000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<28.194000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.575000,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.575000,0.000000,17.653000>}
box{<0,0,-0.088900><6.985000,0.035000,0.088900> rotate<0,-90.000000,0> translate<28.575000,0.000000,17.653000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.606000,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.575000,-1.535000,24.638000>}
box{<0,0,-0.088900><5.969000,0.035000,0.088900> rotate<0,0.000000,0> translate<22.606000,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<24.257000,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<28.829000,0.000000,1.270000>}
box{<0,0,-0.190500><6.465784,0.035000,0.190500> rotate<0,44.997030,0> translate<24.257000,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.194000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,15.748000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,0.000000,0> translate<28.194000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.448000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,16.764000>}
box{<0,0,-0.088900><0.508000,0.035000,0.088900> rotate<0,0.000000,0> translate<28.448000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.575000,0.000000,17.653000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,17.272000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<28.575000,0.000000,17.653000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.980000,0.000000,15.760000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,-26.563298,0> translate<28.956000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.980000,0.000000,16.760000>}
box{<0,0,-0.088900><0.024331,0.035000,0.088900> rotate<0,9.461698,0> translate<28.956000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.956000,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.980000,0.000000,17.260000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,26.563298,0> translate<28.956000,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<23.368000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,10.541000>}
box{<0,0,-0.088900><8.082231,0.035000,0.088900> rotate<0,44.997030,0> translate<23.368000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,10.541000>}
box{<0,0,-0.088900><8.763000,0.035000,0.088900> rotate<0,90.000000,0> translate<29.083000,0.000000,10.541000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.813000,0.000000,15.367000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,14.097000>}
box{<0,0,-0.088900><1.796051,0.035000,0.088900> rotate<0,44.997030,0> translate<27.813000,0.000000,15.367000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.305000,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,-1.535000,15.113000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<27.305000,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.980000,0.000000,16.760000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,16.764000>}
box{<0,0,-0.088900><0.103078,0.035000,0.088900> rotate<0,-2.223814,0> translate<28.980000,0.000000,16.760000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,18.415000>}
box{<0,0,-0.088900><0.635000,0.035000,0.088900> rotate<0,-90.000000,0> translate<29.337000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<22.225000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,-1.535000,19.050000>}
box{<0,0,-0.088900><7.112000,0.035000,0.088900> rotate<0,0.000000,0> translate<22.225000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,31.623000>}
box{<0,0,-0.088900><12.573000,0.035000,0.088900> rotate<0,90.000000,0> translate<29.337000,0.000000,31.623000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.464000,0.000000,16.764000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,0.000000,0> translate<29.083000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.464000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.591000,0.000000,16.891000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<29.464000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.630000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,12.700000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<29.630000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,12.954000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<29.718000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,18.034000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<29.337000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.730000,0.000000,18.010000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,63.430762,0> translate<29.718000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.321000,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,-1.535000,10.668000>}
box{<0,0,-0.088900><2.514472,0.035000,0.088900> rotate<0,44.997030,0> translate<28.321000,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,-1.535000,16.129000>}
box{<0,0,-0.088900><1.436841,0.035000,0.088900> rotate<0,-44.997030,0> translate<29.083000,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,0.000000,16.129000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,0.000000,16.256000>}
box{<0,0,-0.088900><0.127000,0.035000,0.088900> rotate<0,90.000000,0> translate<30.099000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.337000,0.000000,31.623000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,0.000000,32.385000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,-44.997030,0> translate<29.337000,0.000000,31.623000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.226000,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.226000,0.000000,18.034000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,-90.000000,0> translate<30.226000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.226000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.230000,0.000000,18.010000>}
box{<0,0,-0.088900><0.024331,0.035000,0.088900> rotate<0,80.532363,0> translate<30.226000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.480000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.480000,0.000000,30.480000>}
box{<0,0,-0.088900><9.779000,0.035000,0.088900> rotate<0,90.000000,0> translate<30.480000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.591000,0.000000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.607000,0.000000,16.891000>}
box{<0,0,-0.088900><1.016000,0.035000,0.088900> rotate<0,0.000000,0> translate<29.591000,0.000000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.718000,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,14.478000>}
box{<0,0,-0.088900><2.155261,0.035000,0.088900> rotate<0,-44.997030,0> translate<29.718000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.230000,0.000000,15.010000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,14.986000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,63.430762,0> translate<31.230000,0.000000,15.010000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,14.986000>}
box{<0,0,-0.088900><0.508000,0.035000,0.088900> rotate<0,90.000000,0> translate<31.242000,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.607000,0.000000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,17.526000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<30.607000,0.000000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,17.526000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,-90.000000,0> translate<31.242000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.230000,0.000000,18.010000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,17.907000>}
box{<0,0,-0.088900><0.103697,0.035000,0.088900> rotate<0,83.349221,0> translate<31.230000,0.000000,18.010000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.230000,0.000000,18.010000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,18.034000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,-63.430762,0> translate<31.230000,0.000000,18.010000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.330000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.369000,0.000000,12.700000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<31.330000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<27.432000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<31.496000,-1.535000,17.907000>}
box{<0,0,-0.152400><4.064000,0.035000,0.152400> rotate<0,0.000000,0> translate<27.432000,-1.535000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.019000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,-1.535000,23.876000>}
box{<0,0,-0.088900><6.731000,0.035000,0.088900> rotate<0,0.000000,0> translate<25.019000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<28.575000,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,-1.535000,27.813000>}
box{<0,0,-0.088900><4.490128,0.035000,0.088900> rotate<0,-44.997030,0> translate<28.575000,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,6.477000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,8.763000>}
box{<0,0,-0.088900><2.286000,0.035000,0.088900> rotate<0,90.000000,0> translate<31.877000,0.000000,8.763000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,16.256000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<30.099000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,-1.535000,24.003000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<31.750000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,-1.535000,24.003000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,44.997030,0> translate<31.750000,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.980000,0.000000,16.260000>}
box{<0,0,-0.088900><0.103078,0.035000,0.088900> rotate<0,-2.223814,0> translate<31.877000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<31.980000,0.000000,15.760000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.004000,0.000000,15.748000>}
box{<0,0,-0.152400><0.026833,0.035000,0.152400> rotate<0,26.563298,0> translate<31.980000,0.000000,15.760000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<31.980000,0.000000,16.760000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.004000,0.000000,16.764000>}
box{<0,0,-0.152400><0.024331,0.035000,0.152400> rotate<0,-9.461698,0> translate<31.980000,0.000000,16.760000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.980000,0.000000,17.260000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.004000,0.000000,17.272000>}
box{<0,0,-0.088900><0.026833,0.035000,0.088900> rotate<0,-26.563298,0> translate<31.980000,0.000000,17.260000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<31.496000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.131000,-1.535000,17.272000>}
box{<0,0,-0.152400><0.898026,0.035000,0.152400> rotate<0,44.997030,0> translate<31.496000,-1.535000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.480000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.131000,0.000000,19.050000>}
box{<0,0,-0.088900><2.334867,0.035000,0.088900> rotate<0,44.997030,0> translate<30.480000,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,-1.535000,14.986000>}
box{<0,0,-0.152400><2.286000,0.035000,0.152400> rotate<0,-90.000000,0> translate<32.258000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<31.980000,0.000000,15.760000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,0.000000,15.621000>}
box{<0,0,-0.152400><0.310813,0.035000,0.152400> rotate<0,26.563298,0> translate<31.980000,0.000000,15.760000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,0.000000,15.621000>}
box{<0,0,-0.152400><0.635000,0.035000,0.152400> rotate<0,90.000000,0> translate<32.258000,0.000000,15.621000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.131000,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,-1.535000,17.272000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.131000,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.385000,-1.535000,14.986000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.258000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.004000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.639000,0.000000,16.764000>}
box{<0,0,-0.152400><0.635000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.004000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,22.606000>}
box{<0,0,-0.088900><1.524000,0.035000,0.088900> rotate<0,-90.000000,0> translate<32.639000,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,24.130000>}
box{<0,0,-0.088900><0.889000,0.035000,0.088900> rotate<0,0.000000,0> translate<31.750000,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,25.273000>}
box{<0,0,-0.088900><1.143000,0.035000,0.088900> rotate<0,90.000000,0> translate<32.639000,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.385000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,-1.535000,14.605000>}
box{<0,0,-0.152400><0.538815,0.035000,0.152400> rotate<0,44.997030,0> translate<32.385000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.004000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,0.000000,15.748000>}
box{<0,0,-0.152400><0.762000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.004000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.639000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,0.000000,16.637000>}
box{<0,0,-0.152400><0.179605,0.035000,0.152400> rotate<0,44.997030,0> translate<32.639000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,0.000000,16.637000>}
box{<0,0,-0.152400><0.889000,0.035000,0.152400> rotate<0,90.000000,0> translate<32.766000,0.000000,16.637000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.242000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.893000,0.000000,18.034000>}
box{<0,0,-0.088900><1.651000,0.035000,0.088900> rotate<0,0.000000,0> translate<31.242000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.893000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.893000,0.000000,18.034000>}
box{<0,0,-0.088900><4.318000,0.035000,0.088900> rotate<0,-90.000000,0> translate<32.893000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.893000,0.000000,22.352000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,44.997030,0> translate<32.639000,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,21.463000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,21.375000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,-90.000000,0> translate<33.020000,-1.535000,21.375000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,23.075000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,-90.000000,0> translate<33.020000,-1.535000,23.075000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,-1.535000,24.003000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,25.146000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<31.877000,-1.535000,24.003000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,25.185000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,90.000000,0> translate<33.020000,-1.535000,25.185000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,26.885000>}
box{<0,0,-0.152400><0.088000,0.035000,0.152400> rotate<0,90.000000,0> translate<33.020000,-1.535000,26.885000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.147000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.147000,0.000000,22.733000>}
box{<0,0,-0.152400><0.889000,0.035000,0.152400> rotate<0,-90.000000,0> translate<33.147000,0.000000,22.733000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.369000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.274000,0.000000,14.605000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<31.369000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.004000,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.274000,0.000000,17.272000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,0.000000,0> translate<32.004000,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.274000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.274000,0.000000,17.272000>}
box{<0,0,-0.088900><2.667000,0.035000,0.088900> rotate<0,90.000000,0> translate<33.274000,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.147000,0.000000,22.733000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.401000,0.000000,22.479000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,44.997030,0> translate<33.147000,0.000000,22.733000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.147000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.401000,0.000000,23.876000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,-44.997030,0> translate<33.147000,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.893000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,0.000000,21.717000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<32.893000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<24.511000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,-1.535000,21.971000>}
box{<0,0,-0.088900><9.017000,0.035000,0.088900> rotate<0,0.000000,0> translate<24.511000,-1.535000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,21.375000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,-1.535000,21.971000>}
box{<0,0,-0.088900><0.783122,0.035000,0.088900> rotate<0,-49.554148,0> translate<33.020000,-1.535000,21.375000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,-1.535000,21.463000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,-1.535000,21.971000>}
box{<0,0,-0.088900><0.718420,0.035000,0.088900> rotate<0,-44.997030,0> translate<33.020000,-1.535000,21.463000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.528000,-1.535000,26.289000>}
box{<0,0,-0.152400><0.718420,0.035000,0.152400> rotate<0,44.997030,0> translate<33.020000,-1.535000,26.797000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,8.763000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,0.000000,10.541000>}
box{<0,0,-0.088900><2.514472,0.035000,0.088900> rotate<0,-44.997030,0> translate<31.877000,0.000000,8.763000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,-1.535000,15.660000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,-90.000000,0> translate<33.655000,-1.535000,15.660000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.258000,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.655000,-1.535000,17.272000>}
box{<0,0,-0.152400><1.397000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.258000,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.655000,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.655000,-1.535000,17.360000>}
box{<0,0,-0.152400><0.088000,0.035000,0.152400> rotate<0,90.000000,0> translate<33.655000,-1.535000,17.360000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.226000,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,-1.535000,19.812000>}
box{<0,0,-0.088900><3.429000,0.035000,0.088900> rotate<0,0.000000,0> translate<30.226000,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,0.000000,10.541000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,0.000000,19.812000>}
box{<0,0,-0.088900><9.271000,0.035000,0.088900> rotate<0,90.000000,0> translate<33.655000,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.655000,-1.535000,17.360000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.782000,-1.535000,17.399000>}
box{<0,0,-0.152400><0.132853,0.035000,0.152400> rotate<0,-17.069895,0> translate<33.655000,-1.535000,17.360000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.528000,-1.535000,26.289000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.909000,-1.535000,26.289000>}
box{<0,0,-0.152400><0.381000,0.035000,0.152400> rotate<0,0.000000,0> translate<33.528000,-1.535000,26.289000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.877000,0.000000,6.477000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.163000,0.000000,4.191000>}
box{<0,0,-0.088900><3.232892,0.035000,0.088900> rotate<0,44.997030,0> translate<31.877000,0.000000,6.477000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<32.766000,-1.535000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,-1.535000,14.605000>}
box{<0,0,-0.152400><1.778000,0.035000,0.152400> rotate<0,0.000000,0> translate<32.766000,-1.535000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,0.000000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.544000,0.000000,21.717000>}
box{<0,0,-0.088900><1.016000,0.035000,0.088900> rotate<0,0.000000,0> translate<33.528000,0.000000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.401000,0.000000,22.479000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,22.479000>}
box{<0,0,-0.152400><1.143000,0.035000,0.152400> rotate<0,0.000000,0> translate<33.401000,0.000000,22.479000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.401000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,23.876000>}
box{<0,0,-0.152400><1.143000,0.035000,0.152400> rotate<0,0.000000,0> translate<33.401000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,24.003000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,24.638000>}
box{<0,0,-0.152400><0.635000,0.035000,0.152400> rotate<0,90.000000,0> translate<34.544000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.639000,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.544000,0.000000,25.273000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,0.000000,0> translate<32.639000,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.544000,0.000000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.595000,0.000000,21.645000>}
box{<0,0,-0.088900><0.088233,0.035000,0.088900> rotate<0,54.685177,0> translate<34.544000,0.000000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,22.479000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.595000,0.000000,22.395000>}
box{<0,0,-0.152400><0.098270,0.035000,0.152400> rotate<0,58.732392,0> translate<34.544000,0.000000,22.479000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.595000,0.000000,23.895000>}
box{<0,0,-0.152400><0.054424,0.035000,0.152400> rotate<0,-20.431480,0> translate<34.544000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,24.003000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.595000,0.000000,23.895000>}
box{<0,0,-0.152400><0.119436,0.035000,0.152400> rotate<0,64.718006,0> translate<34.544000,0.000000,24.003000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.595000,0.000000,24.645000>}
box{<0,0,-0.152400><0.051478,0.035000,0.152400> rotate<0,-7.814778,0> translate<34.544000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.544000,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.595000,0.000000,25.395000>}
box{<0,0,-0.088900><0.132231,0.035000,0.088900> rotate<0,-67.309031,0> translate<34.544000,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.595000,0.000000,21.645000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.671000,0.000000,21.590000>}
box{<0,0,-0.088900><0.093814,0.035000,0.088900> rotate<0,35.890297,0> translate<34.595000,0.000000,21.645000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.595000,0.000000,23.145000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.671000,0.000000,23.114000>}
box{<0,0,-0.088900><0.082079,0.035000,0.088900> rotate<0,22.188824,0> translate<34.595000,0.000000,23.145000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.595000,0.000000,23.895000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.671000,0.000000,23.876000>}
box{<0,0,-0.152400><0.078339,0.035000,0.152400> rotate<0,14.035317,0> translate<34.595000,0.000000,23.895000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.020000,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.798000,-1.535000,24.892000>}
box{<0,0,-0.152400><2.514472,0.035000,0.152400> rotate<0,-44.997030,0> translate<33.020000,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.544000,-1.535000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.925000,-1.535000,14.986000>}
box{<0,0,-0.152400><0.538815,0.035000,0.152400> rotate<0,-44.997030,0> translate<34.544000,-1.535000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.052000,0.000000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.052000,0.000000,19.685000>}
box{<0,0,-0.088900><5.334000,0.035000,0.088900> rotate<0,90.000000,0> translate<35.052000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.052000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.179000,0.000000,19.812000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<35.052000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.798000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<35.179000,-1.535000,24.892000>}
box{<0,0,-0.152400><0.381000,0.035000,0.152400> rotate<0,0.000000,0> translate<34.798000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.909000,-1.535000,26.289000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<35.179000,-1.535000,25.019000>}
box{<0,0,-0.152400><1.796051,0.035000,0.152400> rotate<0,44.997030,0> translate<33.909000,-1.535000,26.289000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<35.179000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<35.179000,-1.535000,25.019000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,90.000000,0> translate<35.179000,-1.535000,25.019000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.020000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.306000,0.000000,5.334000>}
box{<0,0,-0.088900><3.232892,0.035000,0.088900> rotate<0,44.997030,0> translate<33.020000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<16.891000,-1.535000,9.525000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,-1.535000,9.525000>}
box{<0,0,-0.088900><19.050000,0.035000,0.088900> rotate<0,0.000000,0> translate<16.891000,-1.535000,9.525000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.671000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,21.590000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,0.000000,0> translate<34.671000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.671000,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,23.114000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,0.000000,0> translate<34.671000,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,23.114000>}
box{<0,0,-0.088900><1.524000,0.035000,0.088900> rotate<0,90.000000,0> translate<35.941000,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.655000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,-1.535000,15.748000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,0.000000,0> translate<33.655000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,-1.535000,15.748000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.068000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,0.000000,16.002000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.068000,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.980000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,0.000000,18.415000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<35.980000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,18.542000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<36.068000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,20.895000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,18.542000>}
box{<0,0,-0.088900><2.353000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.195000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,20.895000>}
box{<0,0,-0.088900><0.739960,0.035000,0.088900> rotate<0,69.919664,0> translate<35.941000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,20.895000>}
box{<0,0,-0.088900><0.695000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.195000,0.000000,20.895000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,21.590000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,0.000000,0> translate<35.941000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<33.528000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,21.971000>}
box{<0,0,-0.088900><2.667000,0.035000,0.088900> rotate<0,0.000000,0> translate<33.528000,-1.535000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,22.095000>}
box{<0,0,-0.088900><0.124000,0.035000,0.088900> rotate<0,90.000000,0> translate<36.195000,-1.535000,22.095000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<35.179000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.195000,-1.535000,24.892000>}
box{<0,0,-0.152400><1.016000,0.035000,0.152400> rotate<0,0.000000,0> translate<35.179000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.195000,-1.535000,24.895000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.195000,-1.535000,24.892000>}
box{<0,0,-0.152400><0.003000,0.035000,0.152400> rotate<0,-90.000000,0> translate<36.195000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,0.000000,26.095000>}
box{<0,0,-0.088900><1.718000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.195000,0.000000,26.095000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<31.750000,-1.535000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,27.813000>}
box{<0,0,-0.088900><4.445000,0.035000,0.088900> rotate<0,0.000000,0> translate<31.750000,-1.535000,27.813000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.195000,-1.535000,24.895000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.322000,-1.535000,24.892000>}
box{<0,0,-0.152400><0.127035,0.035000,0.152400> rotate<0,1.353103,0> translate<36.195000,-1.535000,24.895000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.179000,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.449000,-1.535000,19.812000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,0.000000,0> translate<35.179000,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.615000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.703000,0.000000,14.605000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<36.615000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,-1.535000,8.509000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,-1.535000,5.715000>}
box{<0,0,-0.088900><2.794000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.957000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.941000,-1.535000,9.525000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,-1.535000,8.509000>}
box{<0,0,-0.088900><1.436841,0.035000,0.088900> rotate<0,44.997030,0> translate<35.941000,-1.535000,9.525000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,0.000000,26.289000>}
box{<0,0,-0.088900><6.096000,0.035000,0.088900> rotate<0,-90.000000,0> translate<36.957000,0.000000,26.289000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,0.000000,32.385000>}
box{<0,0,-0.088900><6.858000,0.035000,0.088900> rotate<0,0.000000,0> translate<30.099000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.449000,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.211000,-1.535000,20.574000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,-44.997030,0> translate<36.449000,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.211000,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.211000,0.000000,20.955000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,90.000000,0> translate<37.211000,0.000000,20.955000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.338000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.338000,0.000000,13.716000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,-90.000000,0> translate<37.338000,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.703000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.338000,0.000000,13.970000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<36.703000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.560000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.465000,0.000000,5.715000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<35.560000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<30.099000,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.592000,-1.535000,10.668000>}
box{<0,0,-0.088900><7.493000,0.035000,0.088900> rotate<0,0.000000,0> translate<30.099000,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.671000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.719000,0.000000,23.876000>}
box{<0,0,-0.152400><3.048000,0.035000,0.152400> rotate<0,0.000000,0> translate<34.671000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.211000,0.000000,20.955000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.846000,0.000000,21.590000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<37.211000,0.000000,20.955000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.846000,0.000000,23.241000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.846000,0.000000,23.876000>}
box{<0,0,-0.152400><0.635000,0.035000,0.152400> rotate<0,90.000000,0> translate<37.846000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,0.000000,26.289000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.846000,0.000000,25.400000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,44.997030,0> translate<36.957000,0.000000,26.289000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.846000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.895000,0.000000,21.645000>}
box{<0,0,-0.088900><0.073661,0.035000,0.088900> rotate<0,-48.298678,0> translate<37.846000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.846000,0.000000,23.241000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.895000,0.000000,23.145000>}
box{<0,0,-0.152400><0.107782,0.035000,0.152400> rotate<0,62.955321,0> translate<37.846000,0.000000,23.241000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.719000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.895000,0.000000,23.895000>}
box{<0,0,-0.152400><0.177023,0.035000,0.152400> rotate<0,-6.161071,0> translate<37.719000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.846000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.895000,0.000000,23.895000>}
box{<0,0,-0.152400><0.052555,0.035000,0.152400> rotate<0,-21.192658,0> translate<37.846000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.846000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.895000,0.000000,25.395000>}
box{<0,0,-0.088900><0.049254,0.035000,0.088900> rotate<0,5.825958,0> translate<37.846000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.895000,0.000000,22.395000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.973000,0.000000,22.352000>}
box{<0,0,-0.088900><0.089067,0.035000,0.088900> rotate<0,28.865254,0> translate<37.895000,0.000000,22.395000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.895000,0.000000,23.145000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.973000,0.000000,23.114000>}
box{<0,0,-0.152400><0.083934,0.035000,0.152400> rotate<0,21.673219,0> translate<37.895000,0.000000,23.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.895000,0.000000,25.395000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.973000,0.000000,25.273000>}
box{<0,0,-0.088900><0.144803,0.035000,0.088900> rotate<0,57.403630,0> translate<37.895000,0.000000,25.395000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.100000,0.000000,30.099000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.100000,0.000000,30.480000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,90.000000,0> translate<38.100000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.227000,-1.535000,21.971000>}
box{<0,0,-0.088900><2.032000,0.035000,0.088900> rotate<0,0.000000,0> translate<36.195000,-1.535000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<36.322000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.227000,-1.535000,24.892000>}
box{<0,0,-0.152400><1.905000,0.035000,0.152400> rotate<0,0.000000,0> translate<36.322000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<19.050000,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.354000,-1.535000,9.906000>}
box{<0,0,-0.088900><19.304000,0.035000,0.088900> rotate<0,0.000000,0> translate<19.050000,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.315000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.354000,0.000000,14.605000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,0.000000,0> translate<38.315000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.354000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.481000,0.000000,14.732000>}
box{<0,0,-0.152400><0.179605,0.035000,0.152400> rotate<0,-44.997030,0> translate<38.354000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.481000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.481000,0.000000,14.732000>}
box{<0,0,-0.152400><2.413000,0.035000,0.152400> rotate<0,-90.000000,0> translate<38.481000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.227000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.671500,-1.535000,24.447500>}
box{<0,0,-0.152400><0.628618,0.035000,0.152400> rotate<0,44.997030,0> translate<38.227000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.354000,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.735000,-1.535000,9.525000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<38.354000,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<32.131000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.735000,-1.535000,19.050000>}
box{<0,0,-0.088900><6.604000,0.035000,0.088900> rotate<0,0.000000,0> translate<32.131000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.735000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.989000,-1.535000,19.304000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<38.735000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.052000,0.000000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.116000,0.000000,10.287000>}
box{<0,0,-0.088900><5.747364,0.035000,0.088900> rotate<0,44.997030,0> translate<35.052000,0.000000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.481000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<39.243000,0.000000,17.907000>}
box{<0,0,-0.152400><1.077631,0.035000,0.152400> rotate<0,-44.997030,0> translate<38.481000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.680000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,18.415000>}
box{<0,0,-0.088900><1.563000,0.035000,0.088900> rotate<0,0.000000,0> translate<37.680000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.989000,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,19.558000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<38.989000,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.973000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,22.352000>}
box{<0,0,-0.088900><1.270000,0.035000,0.088900> rotate<0,0.000000,0> translate<37.973000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,22.352000>}
box{<0,0,-0.088900><2.794000,0.035000,0.088900> rotate<0,90.000000,0> translate<39.243000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.338000,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,0.000000,11.684000>}
box{<0,0,-0.088900><2.873682,0.035000,0.088900> rotate<0,44.997030,0> translate<37.338000,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.068000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,15.748000>}
box{<0,0,-0.088900><3.302000,0.035000,0.088900> rotate<0,0.000000,0> translate<36.068000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,15.875000>}
box{<0,0,-0.088900><0.127000,0.035000,0.088900> rotate<0,90.000000,0> translate<39.370000,-1.535000,15.875000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,0.000000,15.875000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,0.000000,17.399000>}
box{<0,0,-0.088900><1.524000,0.035000,0.088900> rotate<0,90.000000,0> translate<39.370000,0.000000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,20.825000>}
box{<0,0,-0.088900><0.003000,0.035000,0.088900> rotate<0,-90.000000,0> translate<39.370000,-1.535000,20.825000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.227000,-1.535000,21.971000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,20.828000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<38.227000,-1.535000,21.971000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<39.370000,-1.535000,23.749000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<39.370000,-1.535000,23.625000>}
box{<0,0,-0.152400><0.124000,0.035000,0.152400> rotate<0,-90.000000,0> translate<39.370000,-1.535000,23.625000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.671500,-1.535000,24.447500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<39.370000,-1.535000,23.749000>}
box{<0,0,-0.152400><0.987828,0.035000,0.152400> rotate<0,44.997030,0> translate<38.671500,-1.535000,24.447500> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.116000,-1.535000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.497000,-1.535000,9.906000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<39.116000,-1.535000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.751000,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.751000,0.000000,14.478000>}
box{<0,0,-0.088900><2.032000,0.035000,0.088900> rotate<0,90.000000,0> translate<39.751000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.751000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,0.000000,14.859000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<39.751000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,0.000000,14.859000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,0.000000,16.764000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,90.000000,0> translate<40.132000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<33.782000,-1.535000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.132000,-1.535000,17.399000>}
box{<0,0,-0.152400><6.350000,0.035000,0.152400> rotate<0,0.000000,0> translate<33.782000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.243000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,0.000000,19.304000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,-44.997030,0> translate<39.243000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,-1.535000,14.097000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,-1.535000,14.097000>}
box{<0,0,-0.088900><11.430000,0.035000,0.088900> rotate<0,0.000000,0> translate<29.083000,-1.535000,14.097000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,14.097000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,16.129000>}
box{<0,0,-0.088900><2.032000,0.035000,0.088900> rotate<0,90.000000,0> translate<40.513000,0.000000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<39.243000,0.000000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.513000,0.000000,17.907000>}
box{<0,0,-0.152400><1.270000,0.035000,0.152400> rotate<0,0.000000,0> translate<39.243000,0.000000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,-1.535000,25.019000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,-1.535000,24.638000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,-90.000000,0> translate<40.513000,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,25.019000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,-90.000000,0> translate<40.513000,0.000000,25.019000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.973000,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,25.273000>}
box{<0,0,-0.088900><2.540000,0.035000,0.088900> rotate<0,0.000000,0> translate<37.973000,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.592000,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,0.000000,7.620000>}
box{<0,0,-0.088900><4.310523,0.035000,0.088900> rotate<0,44.997030,0> translate<37.592000,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,-1.535000,19.304000>}
box{<0,0,-0.088900><0.508000,0.035000,0.088900> rotate<0,0.000000,0> translate<40.132000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,-1.535000,24.511000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,-1.535000,19.304000>}
box{<0,0,-0.088900><5.207000,0.035000,0.088900> rotate<0,-90.000000,0> translate<40.640000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<37.973000,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.640000,0.000000,23.114000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,0.000000,0> translate<37.973000,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.640000,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.640000,0.000000,23.114000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,90.000000,0> translate<40.640000,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,-1.535000,24.511000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,44.997030,0> translate<40.513000,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,0.000000,32.385000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,90.000000,0> translate<40.640000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<34.925000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.148000,-1.535000,14.986000>}
box{<0,0,-0.152400><6.223000,0.035000,0.152400> rotate<0,0.000000,0> translate<34.925000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.513000,0.000000,16.129000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,16.129000>}
box{<0,0,-0.088900><0.635000,0.035000,0.088900> rotate<0,0.000000,0> translate<40.513000,0.000000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.132000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,16.764000>}
box{<0,0,-0.088900><1.016000,0.035000,0.088900> rotate<0,0.000000,0> translate<40.132000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,0.000000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,17.399000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<39.370000,0.000000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,16.129000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.180000,0.000000,16.185000>}
box{<0,0,-0.088900><0.064498,0.035000,0.088900> rotate<0,-60.251142,0> translate<41.148000,0.000000,16.129000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.180000,0.000000,16.835000>}
box{<0,0,-0.088900><0.077878,0.035000,0.088900> rotate<0,-65.734371,0> translate<41.148000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.148000,0.000000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.180000,0.000000,17.485000>}
box{<0,0,-0.088900><0.091761,0.035000,0.088900> rotate<0,-69.585524,0> translate<41.148000,0.000000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.513000,0.000000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.211500,0.000000,18.605500>}
box{<0,0,-0.152400><0.987828,0.035000,0.152400> rotate<0,-44.997030,0> translate<40.513000,0.000000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.180000,0.000000,15.535000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,0.000000,15.494000>}
box{<0,0,-0.152400><0.103470,0.035000,0.152400> rotate<0,23.342470,0> translate<41.180000,0.000000,15.535000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.180000,0.000000,17.485000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.275000,0.000000,17.526000>}
box{<0,0,-0.088900><0.103470,0.035000,0.088900> rotate<0,-23.342470,0> translate<41.180000,0.000000,17.485000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.132000,-1.535000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,-1.535000,18.542000>}
box{<0,0,-0.152400><1.616446,0.035000,0.152400> rotate<0,-44.997030,0> translate<40.132000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.211500,0.000000,18.605500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,0.000000,18.542000>}
box{<0,0,-0.152400><0.089803,0.035000,0.152400> rotate<0,44.997030,0> translate<41.211500,0.000000,18.605500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.148000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.402000,-1.535000,14.732000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,44.997030,0> translate<41.148000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.402000,0.000000,18.542000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.275000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.402000,-1.535000,18.542000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.275000,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<38.671500,-1.535000,24.447500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.529000,-1.535000,27.305000>}
box{<0,0,-0.152400><4.041115,0.035000,0.152400> rotate<0,-44.997030,0> translate<38.671500,-1.535000,24.447500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.211500,0.000000,18.605500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.656000,0.000000,19.050000>}
box{<0,0,-0.152400><0.628618,0.035000,0.152400> rotate<0,-44.997030,0> translate<41.211500,0.000000,18.605500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<40.640000,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.656000,0.000000,21.590000>}
box{<0,0,-0.152400><1.436841,0.035000,0.152400> rotate<0,44.997030,0> translate<40.640000,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.656000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.695000,0.000000,21.590000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.656000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.275000,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.719500,0.000000,15.049500>}
box{<0,0,-0.152400><0.628618,0.035000,0.152400> rotate<0,44.997030,0> translate<41.275000,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.402000,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.719500,0.000000,15.049500>}
box{<0,0,-0.152400><0.449013,0.035000,0.152400> rotate<0,-44.997030,0> translate<41.402000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,18.923000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,-90.000000,0> translate<41.783000,0.000000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.656000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,19.050000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.656000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.695000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,21.590000>}
box{<0,0,-0.152400><0.088000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.695000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,21.590000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,90.000000,0> translate<41.783000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.695000,0.000000,23.495000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,0.000000,23.495000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<41.695000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,0.000000,23.495000>}
box{<0,0,-0.088900><1.397000,0.035000,0.088900> rotate<0,-90.000000,0> translate<41.783000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.100000,0.000000,30.099000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,0.000000,26.416000>}
box{<0,0,-0.088900><5.208549,0.035000,0.088900> rotate<0,44.997030,0> translate<38.100000,0.000000,30.099000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.751000,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.910000,-1.535000,10.287000>}
box{<0,0,-0.088900><3.053287,0.035000,0.088900> rotate<0,44.997030,0> translate<39.751000,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.719500,0.000000,15.049500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.164000,0.000000,14.605000>}
box{<0,0,-0.152400><0.628618,0.035000,0.152400> rotate<0,44.997030,0> translate<41.719500,0.000000,15.049500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.783000,0.000000,18.923000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.164000,0.000000,18.542000>}
box{<0,0,-0.152400><0.538815,0.035000,0.152400> rotate<0,44.997030,0> translate<41.783000,0.000000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.164000,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.205000,0.000000,18.510000>}
box{<0,0,-0.152400><0.052010,0.035000,0.152400> rotate<0,37.969098,0> translate<42.164000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.164000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.230000,0.000000,14.510000>}
box{<0,0,-0.152400><0.115676,0.035000,0.152400> rotate<0,55.207224,0> translate<42.164000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.230000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.291000,0.000000,14.478000>}
box{<0,0,-0.152400><0.068884,0.035000,0.152400> rotate<0,27.679235,0> translate<42.230000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.418000,-1.535000,19.304000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<40.640000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.402000,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.545000,-1.535000,17.399000>}
box{<0,0,-0.152400><1.616446,0.035000,0.152400> rotate<0,44.997030,0> translate<41.402000,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.418000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.545000,-1.535000,19.431000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<42.418000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,0.000000,18.669000>}
box{<0,0,-0.088900><0.889000,0.035000,0.088900> rotate<0,-90.000000,0> translate<42.672000,0.000000,18.669000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.545000,-1.535000,19.431000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,-1.535000,19.558000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<42.545000,-1.535000,19.431000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.291000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.799000,0.000000,14.478000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,0.000000,0> translate<42.291000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,0.000000,18.669000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.799000,0.000000,18.542000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,44.997030,0> translate<42.672000,0.000000,18.669000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.799000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.880000,0.000000,14.510000>}
box{<0,0,-0.152400><0.087092,0.035000,0.152400> rotate<0,-21.555657,0> translate<42.799000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.799000,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.880000,0.000000,18.510000>}
box{<0,0,-0.088900><0.087092,0.035000,0.088900> rotate<0,21.555657,0> translate<42.799000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.880000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.926000,0.000000,14.478000>}
box{<0,0,-0.152400><0.056036,0.035000,0.152400> rotate<0,34.822191,0> translate<42.880000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.545000,-1.535000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.053000,-1.535000,17.399000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,0.000000,0> translate<42.545000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.053000,0.000000,26.035000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<42.672000,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.053000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.053000,0.000000,30.353000>}
box{<0,0,-0.088900><4.318000,0.035000,0.088900> rotate<0,90.000000,0> translate<43.053000,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.660000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.621000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,-90.000000,0> translate<43.180000,-1.535000,15.621000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.660000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,-90.000000,0> translate<43.180000,-1.535000,15.660000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.748000>}
box{<0,0,-0.088900><3.810000,0.035000,0.088900> rotate<0,0.000000,0> translate<39.370000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.053000,-1.535000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.180000,-1.535000,17.360000>}
box{<0,0,-0.152400><0.132853,0.035000,0.152400> rotate<0,17.069895,0> translate<43.053000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.180000,-1.535000,17.360000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.180000,-1.535000,17.399000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,90.000000,0> translate<43.180000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.053000,0.000000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,0.000000,30.480000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<43.053000,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<42.926000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.434000,0.000000,14.478000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,0.000000,0> translate<42.926000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.395000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,21.590000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<43.395000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.395000,0.000000,23.495000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,23.495000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<43.395000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,23.495000>}
box{<0,0,-0.088900><5.080000,0.035000,0.088900> rotate<0,-90.000000,0> translate<43.434000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.434000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.505000,0.000000,14.510000>}
box{<0,0,-0.152400><0.077878,0.035000,0.152400> rotate<0,-24.259690,0> translate<43.434000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.505000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.561000,0.000000,14.478000>}
box{<0,0,-0.152400><0.064498,0.035000,0.152400> rotate<0,29.742918,0> translate<43.505000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.505000,0.000000,18.510000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.561000,0.000000,18.542000>}
box{<0,0,-0.088900><0.064498,0.035000,0.088900> rotate<0,-29.742918,0> translate<43.505000,0.000000,18.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.180000,-1.535000,15.621000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,-1.535000,15.113000>}
box{<0,0,-0.088900><0.718420,0.035000,0.088900> rotate<0,44.997030,0> translate<43.180000,-1.535000,15.621000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.180000,-1.535000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.688000,-1.535000,17.907000>}
box{<0,0,-0.152400><0.718420,0.035000,0.152400> rotate<0,-44.997030,0> translate<43.180000,-1.535000,17.399000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.561000,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,0.000000,18.669000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<43.561000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,0.000000,20.193000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,0.000000,18.669000>}
box{<0,0,-0.088900><1.524000,0.035000,0.088900> rotate<0,-90.000000,0> translate<43.688000,0.000000,18.669000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.561000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.069000,0.000000,14.478000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,0.000000,0> translate<43.561000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.275000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.069000,0.000000,17.526000>}
box{<0,0,-0.088900><2.794000,0.035000,0.088900> rotate<0,0.000000,0> translate<41.275000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.069000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.069000,0.000000,18.415000>}
box{<0,0,-0.088900><0.889000,0.035000,0.088900> rotate<0,90.000000,0> translate<44.069000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.069000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.155000,0.000000,14.510000>}
box{<0,0,-0.152400><0.091761,0.035000,0.152400> rotate<0,-20.408536,0> translate<44.069000,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.069000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.180000,0.000000,18.510000>}
box{<0,0,-0.088900><0.146103,0.035000,0.088900> rotate<0,-40.556082,0> translate<44.069000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.155000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.196000,0.000000,14.605000>}
box{<0,0,-0.152400><0.103470,0.035000,0.152400> rotate<0,-66.651590,0> translate<44.155000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.196000,-1.535000,24.892000>}
box{<0,0,-0.088900><2.413000,0.035000,0.088900> rotate<0,0.000000,0> translate<41.783000,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,0.000000,20.701000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,44.997030,0> translate<43.434000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.196000,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,0.000000,24.765000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,44.997030,0> translate<44.196000,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,0.000000,24.765000>}
box{<0,0,-0.088900><4.064000,0.035000,0.088900> rotate<0,90.000000,0> translate<44.323000,0.000000,24.765000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.783000,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,-1.535000,26.416000>}
box{<0,0,-0.088900><2.540000,0.035000,0.088900> rotate<0,0.000000,0> translate<41.783000,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.672000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.577000,-1.535000,25.654000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,0.000000,0> translate<42.672000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<41.529000,-1.535000,27.305000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.704000,-1.535000,27.305000>}
box{<0,0,-0.152400><3.175000,0.035000,0.152400> rotate<0,0.000000,0> translate<41.529000,-1.535000,27.305000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.196000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<45.085000,0.000000,15.494000>}
box{<0,0,-0.152400><1.257236,0.035000,0.152400> rotate<0,-44.997030,0> translate<44.196000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.069000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.085000,0.000000,17.526000>}
box{<0,0,-0.088900><1.016000,0.035000,0.088900> rotate<0,0.000000,0> translate<44.069000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<45.085000,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<45.180000,0.000000,15.535000>}
box{<0,0,-0.152400><0.103470,0.035000,0.152400> rotate<0,-23.342470,0> translate<45.085000,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.085000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.180000,0.000000,17.485000>}
box{<0,0,-0.088900><0.103470,0.035000,0.088900> rotate<0,23.342470,0> translate<45.085000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.180000,0.000000,16.185000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,16.256000>}
box{<0,0,-0.088900><0.077878,0.035000,0.088900> rotate<0,-65.734371,0> translate<45.180000,0.000000,16.185000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.180000,0.000000,16.860000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,16.891000>}
box{<0,0,-0.088900><0.044553,0.035000,0.088900> rotate<0,-44.087710,0> translate<45.180000,0.000000,16.860000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,17.399000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,16.891000>}
box{<0,0,-0.088900><0.508000,0.035000,0.088900> rotate<0,-90.000000,0> translate<45.212000,0.000000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.180000,0.000000,17.485000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,17.399000>}
box{<0,0,-0.088900><0.091761,0.035000,0.088900> rotate<0,69.585524,0> translate<45.180000,0.000000,17.485000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,-1.535000,20.193000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.339000,-1.535000,21.844000>}
box{<0,0,-0.088900><2.334867,0.035000,0.088900> rotate<0,-44.997030,0> translate<43.688000,-1.535000,20.193000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.339000,0.000000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.339000,0.000000,21.844000>}
box{<0,0,-0.088900><5.969000,0.035000,0.088900> rotate<0,-90.000000,0> translate<45.339000,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.195000,-1.535000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.339000,-1.535000,27.813000>}
box{<0,0,-0.088900><9.144000,0.035000,0.088900> rotate<0,0.000000,0> translate<36.195000,-1.535000,27.813000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.434000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.720000,0.000000,28.575000>}
box{<0,0,-0.088900><2.286000,0.035000,0.088900> rotate<0,0.000000,0> translate<43.434000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.212000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.847000,0.000000,16.256000>}
box{<0,0,-0.088900><0.635000,0.035000,0.088900> rotate<0,0.000000,0> translate<45.212000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.847000,0.000000,19.177000>}
box{<0,0,-0.088900><2.155261,0.035000,0.088900> rotate<0,44.997030,0> translate<44.323000,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.847000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.847000,0.000000,19.177000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,90.000000,0> translate<45.847000,0.000000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.370000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.228000,0.000000,11.684000>}
box{<0,0,-0.088900><6.858000,0.035000,0.088900> rotate<0,0.000000,0> translate<39.370000,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.720000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.228000,0.000000,28.067000>}
box{<0,0,-0.088900><0.718420,0.035000,0.088900> rotate<0,44.997030,0> translate<45.720000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.228000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.228000,0.000000,28.067000>}
box{<0,0,-0.088900><16.383000,0.035000,0.088900> rotate<0,90.000000,0> translate<46.228000,0.000000,28.067000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.323000,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.482000,-1.535000,24.257000>}
box{<0,0,-0.088900><3.053287,0.035000,0.088900> rotate<0,44.997030,0> translate<44.323000,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<44.704000,-1.535000,27.305000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<46.609000,-1.535000,25.400000>}
box{<0,0,-0.152400><2.694077,0.035000,0.152400> rotate<0,44.997030,0> translate<44.704000,-1.535000,27.305000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<37.465000,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.117000,0.000000,5.715000>}
box{<0,0,-0.088900><9.652000,0.035000,0.088900> rotate<0,0.000000,0> translate<37.465000,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.117000,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.117000,0.000000,10.922000>}
box{<0,0,-0.088900><5.207000,0.035000,0.088900> rotate<0,90.000000,0> translate<47.117000,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.244000,0.000000,19.431000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.244000,0.000000,15.240000>}
box{<0,0,-0.088900><4.191000,0.035000,0.088900> rotate<0,-90.000000,0> translate<47.244000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<42.545000,-1.535000,19.431000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.244000,-1.535000,19.431000>}
box{<0,0,-0.088900><4.699000,0.035000,0.088900> rotate<0,0.000000,0> translate<42.545000,-1.535000,19.431000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,15.110000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,14.986000>}
box{<0,0,-0.088900><0.124000,0.035000,0.088900> rotate<0,-90.000000,0> translate<47.625000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,15.110000>}
box{<0,0,-0.088900><0.003000,0.035000,0.088900> rotate<0,-90.000000,0> translate<47.625000,-1.535000,15.110000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<43.688000,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,15.113000>}
box{<0,0,-0.088900><3.937000,0.035000,0.088900> rotate<0,0.000000,0> translate<43.688000,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<43.688000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.625000,-1.535000,17.907000>}
box{<0,0,-0.152400><3.937000,0.035000,0.152400> rotate<0,0.000000,0> translate<43.688000,-1.535000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.625000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.625000,-1.535000,17.910000>}
box{<0,0,-0.152400><0.003000,0.035000,0.152400> rotate<0,90.000000,0> translate<47.625000,-1.535000,17.910000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.625000,-1.535000,17.910000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.752000,-1.535000,17.907000>}
box{<0,0,-0.152400><0.127035,0.035000,0.152400> rotate<0,1.353103,0> translate<47.625000,-1.535000,17.910000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<45.720000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.006000,0.000000,28.194000>}
box{<0,0,-0.088900><3.232892,0.035000,0.088900> rotate<0,44.997030,0> translate<45.720000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.006000,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.006000,0.000000,28.194000>}
box{<0,0,-0.088900><10.922000,0.035000,0.088900> rotate<0,90.000000,0> translate<48.006000,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<27.940000,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.133000,-1.535000,13.208000>}
box{<0,0,-0.088900><20.193000,0.035000,0.088900> rotate<0,0.000000,0> translate<27.940000,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.133000,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.514000,-1.535000,12.827000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,44.997030,0> translate<48.133000,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<47.752000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<48.514000,-1.535000,17.907000>}
box{<0,0,-0.152400><0.762000,0.035000,0.152400> rotate<0,0.000000,0> translate<47.752000,-1.535000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<44.577000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.514000,-1.535000,21.717000>}
box{<0,0,-0.088900><5.567759,0.035000,0.088900> rotate<0,44.997030,0> translate<44.577000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<40.640000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.641000,0.000000,32.385000>}
box{<0,0,-0.088900><8.001000,0.035000,0.088900> rotate<0,0.000000,0> translate<40.640000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.244000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.768000,0.000000,13.716000>}
box{<0,0,-0.088900><2.155261,0.035000,0.088900> rotate<0,44.997030,0> translate<47.244000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.006000,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.768000,0.000000,16.510000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,44.997030,0> translate<48.006000,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.403000,0.000000,31.623000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.403000,0.000000,29.591000>}
box{<0,0,-0.088900><2.032000,0.035000,0.088900> rotate<0,-90.000000,0> translate<49.403000,0.000000,29.591000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.641000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.403000,0.000000,31.623000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,44.997030,0> translate<48.641000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<35.306000,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,5.334000>}
box{<0,0,-0.088900><14.351000,0.035000,0.088900> rotate<0,0.000000,0> translate<35.306000,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,12.954000>}
box{<0,0,-0.088900><7.620000,0.035000,0.088900> rotate<0,90.000000,0> translate<49.657000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.117000,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,13.462000>}
box{<0,0,-0.088900><3.592102,0.035000,0.088900> rotate<0,-44.997030,0> translate<47.117000,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,19.177000>}
box{<0,0,-0.088900><5.715000,0.035000,0.088900> rotate<0,90.000000,0> translate<49.657000,0.000000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.768000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.784000,-1.535000,15.494000>}
box{<0,0,-0.088900><1.436841,0.035000,0.088900> rotate<0,44.997030,0> translate<48.768000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<48.514000,-1.535000,17.907000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<49.911000,-1.535000,16.510000>}
box{<0,0,-0.152400><1.975656,0.035000,0.152400> rotate<0,44.997030,0> translate<48.514000,-1.535000,17.907000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.292000,0.000000,13.589000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<49.657000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.292000,0.000000,13.589000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.292000,0.000000,15.240000>}
box{<0,0,-0.088900><1.651000,0.035000,0.088900> rotate<0,90.000000,0> translate<50.292000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.657000,0.000000,19.177000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.800000,0.000000,20.320000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<49.657000,0.000000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<46.609000,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<50.800000,-1.535000,25.400000>}
box{<0,0,-0.152400><4.191000,0.035000,0.152400> rotate<0,0.000000,0> translate<46.609000,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.020000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.054000,0.000000,11.430000>}
box{<0,0,-0.088900><0.034000,0.035000,0.088900> rotate<0,0.000000,0> translate<51.020000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.054000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.181000,0.000000,11.557000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,-44.997030,0> translate<51.054000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.181000,0.000000,11.557000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.181000,0.000000,13.335000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,90.000000,0> translate<51.181000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.181000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.220000,0.000000,13.335000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<51.181000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.260000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.308000,-1.535000,33.528000>}
box{<0,0,-0.088900><4.310523,0.035000,0.088900> rotate<0,-44.997030,0> translate<48.260000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<38.735000,-1.535000,9.525000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.435000,-1.535000,9.525000>}
box{<0,0,-0.088900><12.700000,0.035000,0.088900> rotate<0,0.000000,0> translate<38.735000,-1.535000,9.525000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.514000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.435000,-1.535000,21.717000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,0.000000,0> translate<48.514000,-1.535000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.292000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.943000,0.000000,16.891000>}
box{<0,0,-0.088900><2.334867,0.035000,0.088900> rotate<0,-44.997030,0> translate<50.292000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.800000,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.943000,0.000000,21.717000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<50.800000,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.943000,0.000000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.943000,0.000000,21.717000>}
box{<0,0,-0.088900><4.826000,0.035000,0.088900> rotate<0,90.000000,0> translate<51.943000,0.000000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,13.716000>}
box{<0,0,-0.152400><2.794000,0.035000,0.152400> rotate<0,-90.000000,0> translate<52.451000,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<50.800000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,23.749000>}
box{<0,0,-0.152400><2.334867,0.035000,0.152400> rotate<0,44.997030,0> translate<50.800000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,23.749000>}
box{<0,0,-0.152400><7.239000,0.035000,0.152400> rotate<0,90.000000,0> translate<52.451000,0.000000,23.749000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<49.911000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.578000,-1.535000,16.510000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,0.000000,0> translate<49.911000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.578000,0.000000,16.510000>}
box{<0,0,-0.152400><0.127000,0.035000,0.152400> rotate<0,0.000000,0> translate<52.451000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.451000,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.832000,0.000000,13.335000>}
box{<0,0,-0.152400><0.538815,0.035000,0.152400> rotate<0,44.997030,0> translate<52.451000,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.832000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.920000,0.000000,13.335000>}
box{<0,0,-0.152400><0.088000,0.035000,0.152400> rotate<0,0.000000,0> translate<52.832000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<25.527000,-1.535000,4.953000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,-1.535000,4.953000>}
box{<0,0,-0.088900><27.432000,0.035000,0.088900> rotate<0,0.000000,0> translate<25.527000,-1.535000,4.953000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,0.000000,23.495000>}
box{<0,0,-0.088900><2.540000,0.035000,0.088900> rotate<0,-90.000000,0> translate<52.959000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.403000,0.000000,29.591000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,0.000000,26.035000>}
box{<0,0,-0.088900><5.028943,0.035000,0.088900> rotate<0,44.997030,0> translate<49.403000,0.000000,29.591000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.120000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.213000,0.000000,11.430000>}
box{<0,0,-0.088900><0.093000,0.035000,0.088900> rotate<0,0.000000,0> translate<53.120000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.435000,-1.535000,9.525000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.340000,-1.535000,7.620000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<51.435000,-1.535000,9.525000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<50.800000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.467000,-1.535000,33.147000>}
box{<0,0,-0.088900><3.771708,0.035000,0.088900> rotate<0,-44.997030,0> translate<50.800000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<36.957000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.975000,-1.535000,5.715000>}
box{<0,0,-0.088900><17.018000,0.035000,0.088900> rotate<0,0.000000,0> translate<36.957000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.435000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.975000,-1.535000,19.177000>}
box{<0,0,-0.088900><3.592102,0.035000,0.088900> rotate<0,44.997030,0> translate<51.435000,-1.535000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,0.000000,4.953000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.737000,0.000000,6.731000>}
box{<0,0,-0.088900><2.514472,0.035000,0.088900> rotate<0,-44.997030,0> translate<52.959000,0.000000,4.953000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.737000,0.000000,6.731000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.737000,0.000000,12.446000>}
box{<0,0,-0.088900><5.715000,0.035000,0.088900> rotate<0,90.000000,0> translate<54.737000,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<52.959000,0.000000,23.495000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.991000,0.000000,21.463000>}
box{<0,0,-0.088900><2.873682,0.035000,0.088900> rotate<0,44.997030,0> translate<52.959000,0.000000,23.495000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.340000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.626000,-1.535000,32.766000>}
box{<0,0,-0.088900><3.232892,0.035000,0.088900> rotate<0,-44.997030,0> translate<53.340000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.213000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.753000,0.000000,13.970000>}
box{<0,0,-0.088900><3.592102,0.035000,0.088900> rotate<0,-44.997030,0> translate<53.213000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.753000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.753000,0.000000,25.527000>}
box{<0,0,-0.088900><11.557000,0.035000,0.088900> rotate<0,90.000000,0> translate<55.753000,0.000000,25.527000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.975000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.880000,-1.535000,7.620000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<53.975000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<39.497000,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.880000,-1.535000,9.906000>}
box{<0,0,-0.088900><16.383000,0.035000,0.088900> rotate<0,0.000000,0> translate<39.497000,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.737000,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.134000,0.000000,13.843000>}
box{<0,0,-0.088900><1.975656,0.035000,0.088900> rotate<0,-44.997030,0> translate<54.737000,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.134000,0.000000,13.843000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.134000,0.000000,19.939000>}
box{<0,0,-0.088900><6.096000,0.035000,0.088900> rotate<0,90.000000,0> translate<56.134000,0.000000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.514000,-1.535000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.261000,-1.535000,12.827000>}
box{<0,0,-0.088900><7.747000,0.035000,0.088900> rotate<0,0.000000,0> translate<48.514000,-1.535000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.261000,0.000000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.515000,0.000000,13.081000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<56.261000,0.000000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.515000,0.000000,13.081000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.515000,0.000000,17.780000>}
box{<0,0,-0.088900><4.699000,0.035000,0.088900> rotate<0,90.000000,0> translate<56.515000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<52.578000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<57.023000,-1.535000,16.510000>}
box{<0,0,-0.152400><4.445000,0.035000,0.152400> rotate<0,0.000000,0> translate<52.578000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.277000,-1.535000,8.509000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.277000,-1.535000,5.715000>}
box{<0,0,-0.088900><2.794000,0.035000,0.088900> rotate<0,-90.000000,0> translate<57.277000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.880000,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.277000,-1.535000,8.509000>}
box{<0,0,-0.088900><1.975656,0.035000,0.088900> rotate<0,44.997030,0> translate<55.880000,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<57.023000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<57.277000,-1.535000,16.256000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,44.997030,0> translate<57.023000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<48.768000,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.404000,-1.535000,13.716000>}
box{<0,0,-0.088900><8.636000,0.035000,0.088900> rotate<0,0.000000,0> translate<48.768000,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<49.784000,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.531000,-1.535000,15.494000>}
box{<0,0,-0.088900><7.747000,0.035000,0.088900> rotate<0,0.000000,0> translate<49.784000,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.570000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.658000,0.000000,13.335000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<57.570000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.658000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.658000,0.000000,13.335000>}
box{<0,0,-0.088900><1.651000,0.035000,0.088900> rotate<0,90.000000,0> translate<57.658000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.531000,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.785000,-1.535000,15.748000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<57.531000,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.880000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.785000,-1.535000,32.385000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<55.880000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.658000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.912000,0.000000,11.430000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,44.997030,0> translate<57.658000,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.912000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.005000,0.000000,11.430000>}
box{<0,0,-0.088900><0.093000,0.035000,0.088900> rotate<0,0.000000,0> translate<57.912000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<41.910000,-1.535000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.293000,-1.535000,10.287000>}
box{<0,0,-0.088900><16.383000,0.035000,0.088900> rotate<0,0.000000,0> translate<41.910000,-1.535000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<34.163000,0.000000,4.191000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.420000,0.000000,4.191000>}
box{<0,0,-0.088900><24.257000,0.035000,0.088900> rotate<0,0.000000,0> translate<34.163000,0.000000,4.191000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.420000,0.000000,4.191000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.420000,0.000000,7.620000>}
box{<0,0,-0.088900><3.429000,0.035000,0.088900> rotate<0,90.000000,0> translate<58.420000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<58.674000,0.000000,14.859000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<58.674000,0.000000,13.843000>}
box{<0,0,-0.152400><1.016000,0.035000,0.152400> rotate<0,-90.000000,0> translate<58.674000,0.000000,13.843000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<57.277000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<58.674000,0.000000,14.859000>}
box{<0,0,-0.152400><1.975656,0.035000,0.152400> rotate<0,44.997030,0> translate<57.277000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<47.625000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.928000,-1.535000,14.986000>}
box{<0,0,-0.088900><11.303000,0.035000,0.088900> rotate<0,0.000000,0> translate<47.625000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<50.800000,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<59.055000,-1.535000,17.780000>}
box{<0,0,-0.190500><8.255000,0.035000,0.190500> rotate<0,0.000000,0> translate<50.800000,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.515000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.055000,0.000000,20.320000>}
box{<0,0,-0.088900><3.592102,0.035000,0.088900> rotate<0,-44.997030,0> translate<56.515000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<56.134000,0.000000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.055000,0.000000,22.860000>}
box{<0,0,-0.088900><4.130918,0.035000,0.088900> rotate<0,-44.997030,0> translate<56.134000,0.000000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<50.800000,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.055000,-1.535000,25.400000>}
box{<0,0,-0.152400><8.255000,0.035000,0.152400> rotate<0,0.000000,0> translate<50.800000,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<58.674000,0.000000,13.843000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.182000,0.000000,13.335000>}
box{<0,0,-0.152400><0.718420,0.035000,0.152400> rotate<0,44.997030,0> translate<58.674000,0.000000,13.843000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.182000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.270000,0.000000,13.335000>}
box{<0,0,-0.152400><0.088000,0.035000,0.152400> rotate<0,0.000000,0> translate<59.182000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.055000,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.309000,-1.535000,25.654000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,-44.997030,0> translate<59.055000,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.975000,-1.535000,19.177000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.690000,-1.535000,19.177000>}
box{<0,0,-0.088900><5.715000,0.035000,0.088900> rotate<0,0.000000,0> translate<53.975000,-1.535000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.753000,0.000000,25.527000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.817000,0.000000,29.591000>}
box{<0,0,-0.088900><5.747364,0.035000,0.088900> rotate<0,-44.997030,0> translate<55.753000,0.000000,25.527000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.817000,0.000000,29.591000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.817000,0.000000,31.623000>}
box{<0,0,-0.088900><2.032000,0.035000,0.088900> rotate<0,90.000000,0> translate<59.817000,0.000000,31.623000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<46.482000,-1.535000,24.257000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.944000,-1.535000,24.257000>}
box{<0,0,-0.088900><13.462000,0.035000,0.088900> rotate<0,0.000000,0> translate<46.482000,-1.535000,24.257000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<29.083000,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.198000,0.000000,1.778000>}
box{<0,0,-0.088900><31.115000,0.035000,0.088900> rotate<0,0.000000,0> translate<29.083000,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.105000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.198000,0.000000,11.430000>}
box{<0,0,-0.088900><0.093000,0.035000,0.088900> rotate<0,0.000000,0> translate<60.105000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<59.055000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<60.325000,0.000000,19.050000>}
box{<0,0,-0.190500><1.796051,0.035000,0.190500> rotate<0,-44.997030,0> translate<59.055000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<60.325000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<60.325000,0.000000,20.447000>}
box{<0,0,-0.190500><1.397000,0.035000,0.190500> rotate<0,90.000000,0> translate<60.325000,0.000000,20.447000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.817000,0.000000,31.623000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.579000,0.000000,32.385000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,-44.997030,0> translate<59.817000,0.000000,31.623000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.690000,-1.535000,19.177000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.706000,-1.535000,18.161000>}
box{<0,0,-0.088900><1.436841,0.035000,0.088900> rotate<0,44.997030,0> translate<59.690000,-1.535000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<59.944000,-1.535000,24.257000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.833000,-1.535000,25.146000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,-44.997030,0> translate<59.944000,-1.535000,24.257000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.293000,-1.535000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.960000,-1.535000,7.620000>}
box{<0,0,-0.088900><3.771708,0.035000,0.088900> rotate<0,44.997030,0> translate<58.293000,-1.535000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<59.309000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<61.087000,-1.535000,25.654000>}
box{<0,0,-0.152400><1.778000,0.035000,0.152400> rotate<0,0.000000,0> translate<59.309000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.198000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<61.849000,0.000000,13.081000>}
box{<0,0,-0.088900><2.334867,0.035000,0.088900> rotate<0,-44.997030,0> translate<60.198000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<61.849000,0.000000,13.081000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<61.849000,0.000000,18.923000>}
box{<0,0,-0.088900><5.842000,0.035000,0.088900> rotate<0,90.000000,0> translate<61.849000,0.000000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<60.325000,0.000000,20.447000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.103000,0.000000,22.225000>}
box{<0,0,-0.190500><2.514472,0.035000,0.190500> rotate<0,-44.997030,0> translate<60.325000,0.000000,20.447000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.103000,-1.535000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.103000,-1.535000,23.749000>}
box{<0,0,-0.190500><1.524000,0.035000,0.190500> rotate<0,90.000000,0> translate<62.103000,-1.535000,23.749000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.230000,-1.535000,24.000000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.230000,-1.535000,23.876000>}
box{<0,0,-0.190500><0.124000,0.035000,0.190500> rotate<0,-90.000000,0> translate<62.230000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.103000,-1.535000,23.749000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.230000,-1.535000,24.000000>}
box{<0,0,-0.190500><0.281301,0.035000,0.190500> rotate<0,-63.157512,0> translate<62.103000,-1.535000,23.749000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<61.087000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.230000,-1.535000,26.797000>}
box{<0,0,-0.152400><1.616446,0.035000,0.152400> rotate<0,-44.997030,0> translate<61.087000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.230000,-1.535000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.230000,-1.535000,26.800000>}
box{<0,0,-0.152400><0.003000,0.035000,0.152400> rotate<0,90.000000,0> translate<62.230000,-1.535000,26.800000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.230000,-1.535000,26.800000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.357000,-1.535000,26.797000>}
box{<0,0,-0.152400><0.127035,0.035000,0.152400> rotate<0,1.353103,0> translate<62.230000,-1.535000,26.800000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.611000,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.611000,-1.535000,14.351000>}
box{<0,0,-0.088900><0.381000,0.035000,0.088900> rotate<0,-90.000000,0> translate<62.611000,-1.535000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.960000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.865000,0.000000,28.575000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,44.997030,0> translate<60.960000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.865000,0.000000,15.621000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.865000,0.000000,28.575000>}
box{<0,0,-0.088900><12.954000,0.035000,0.088900> rotate<0,90.000000,0> translate<62.865000,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.611000,-1.535000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,-1.535000,13.716000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<62.611000,-1.535000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.611000,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,0.000000,14.097000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<62.611000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,0.000000,14.097000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,90.000000,0> translate<63.246000,0.000000,14.097000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.285000,0.000000,13.335000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<63.246000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.285000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.373000,0.000000,10.795000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<63.285000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.404000,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.500000,-1.535000,7.620000>}
box{<0,0,-0.088900><8.621046,0.035000,0.088900> rotate<0,44.997030,0> translate<57.404000,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.500000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.500000,0.000000,30.480000>}
box{<0,0,-0.088900><1.905000,0.035000,0.088900> rotate<0,-90.000000,0> translate<63.500000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.579000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.500000,0.000000,32.385000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,0.000000,0> translate<60.579000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.785000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.627000,-1.535000,15.748000>}
box{<0,0,-0.088900><5.842000,0.035000,0.088900> rotate<0,0.000000,0> translate<57.785000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<61.849000,-1.535000,18.923000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.627000,-1.535000,20.701000>}
box{<0,0,-0.088900><2.514472,0.035000,0.088900> rotate<0,-44.997030,0> translate<61.849000,-1.535000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.820000,-1.535000,14.775000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.881000,-1.535000,14.732000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,35.178378,0> translate<63.820000,-1.535000,14.775000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.820000,-1.535000,19.220000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.881000,-1.535000,19.177000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,35.178378,0> translate<63.820000,-1.535000,19.220000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.373000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.008000,0.000000,11.430000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<63.373000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.008000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.008000,0.000000,12.192000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.008000,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.627000,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.389000,0.000000,21.463000>}
box{<0,0,-0.088900><1.077631,0.035000,0.088900> rotate<0,-44.997030,0> translate<63.627000,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.389000,0.000000,21.463000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.389000,0.000000,28.829000>}
box{<0,0,-0.088900><7.366000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.389000,0.000000,28.829000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<58.928000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.516000,-1.535000,9.398000>}
box{<0,0,-0.088900><7.902625,0.035000,0.088900> rotate<0,44.997030,0> translate<58.928000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.516000,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.516000,0.000000,10.414000>}
box{<0,0,-0.088900><1.016000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.516000,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.627000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,16.891000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<63.627000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,16.975000>}
box{<0,0,-0.088900><0.084000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.770000,-1.535000,16.975000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,21.463000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,21.420000>}
box{<0,0,-0.088900><0.043000,0.035000,0.088900> rotate<0,-90.000000,0> translate<64.770000,-1.535000,21.420000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<54.991000,-1.535000,21.463000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.770000,-1.535000,21.463000>}
box{<0,0,-0.088900><9.779000,0.035000,0.088900> rotate<0,0.000000,0> translate<54.991000,-1.535000,21.463000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.516000,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,10.795000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<64.516000,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.081000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,12.954000>}
box{<0,0,-0.088900><0.127000,0.035000,0.088900> rotate<0,-90.000000,0> translate<64.897000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.008000,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.081000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,-44.997030,0> translate<64.008000,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.081000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.335000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.897000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<62.865000,0.000000,15.621000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.589000>}
box{<0,0,-0.088900><2.873682,0.035000,0.088900> rotate<0,44.997030,0> translate<62.865000,0.000000,15.621000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.589000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<64.897000,0.000000,13.589000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<62.357000,-1.535000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<64.897000,-1.535000,26.797000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,0.000000,0> translate<62.357000,-1.535000,26.797000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.985000,0.000000,10.795000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<64.897000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.081000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.985000,0.000000,13.335000>}
box{<0,0,-0.088900><0.268812,0.035000,0.088900> rotate<0,-70.886336,0> translate<64.897000,0.000000,13.081000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.985000,0.000000,13.335000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<64.897000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.881000,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.659000,-1.535000,14.732000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<63.881000,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.881000,-1.535000,19.177000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.659000,-1.535000,19.177000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<63.881000,-1.535000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.659000,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.720000,-1.535000,14.775000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,-35.178378,0> translate<65.659000,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.659000,-1.535000,19.177000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.720000,-1.535000,19.220000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,-35.178378,0> translate<65.659000,-1.535000,19.177000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.720000,-1.535000,14.775000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.786000,-1.535000,14.859000>}
box{<0,0,-0.088900><0.106827,0.035000,0.088900> rotate<0,-51.839352,0> translate<65.720000,-1.535000,14.775000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.720000,-1.535000,19.220000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.786000,-1.535000,19.304000>}
box{<0,0,-0.088900><0.106827,0.035000,0.088900> rotate<0,-51.839352,0> translate<65.720000,-1.535000,19.220000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.198000,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.040000,0.000000,7.620000>}
box{<0,0,-0.088900><8.261836,0.035000,0.088900> rotate<0,-44.997030,0> translate<60.198000,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.389000,0.000000,28.829000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.040000,0.000000,30.480000>}
box{<0,0,-0.088900><2.334867,0.035000,0.088900> rotate<0,-44.997030,0> translate<64.389000,0.000000,28.829000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<63.246000,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.167000,-1.535000,13.716000>}
box{<0,0,-0.088900><2.921000,0.035000,0.088900> rotate<0,0.000000,0> translate<63.246000,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.786000,-1.535000,14.859000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.548000,-1.535000,14.859000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,0.000000,0> translate<65.786000,-1.535000,14.859000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<65.786000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.548000,-1.535000,19.304000>}
box{<0,0,-0.088900><0.762000,0.035000,0.088900> rotate<0,0.000000,0> translate<65.786000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.277000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.675000,-1.535000,5.715000>}
box{<0,0,-0.088900><9.398000,0.035000,0.088900> rotate<0,0.000000,0> translate<57.277000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<62.230000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<66.802000,-1.535000,23.876000>}
box{<0,0,-0.190500><4.572000,0.035000,0.190500> rotate<0,0.000000,0> translate<62.230000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.548000,-1.535000,14.859000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,-1.535000,15.240000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<66.548000,-1.535000,14.859000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.548000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,-1.535000,19.685000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<66.548000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<64.897000,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.056000,0.000000,10.795000>}
box{<0,0,-0.088900><3.053287,0.035000,0.088900> rotate<0,44.997030,0> translate<64.897000,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.056000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.095000,0.000000,10.795000>}
box{<0,0,-0.088900><0.039000,0.035000,0.088900> rotate<0,0.000000,0> translate<67.056000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.183000,-1.535000,15.494000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<66.929000,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,-1.535000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.183000,-1.535000,19.939000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<66.929000,-1.535000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<66.802000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<67.437000,-1.535000,23.241000>}
box{<0,0,-0.190500><0.898026,0.035000,0.190500> rotate<0,44.997030,0> translate<66.802000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.833000,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.437000,-1.535000,25.146000>}
box{<0,0,-0.088900><6.604000,0.035000,0.088900> rotate<0,0.000000,0> translate<60.833000,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.167000,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.564000,-1.535000,12.319000>}
box{<0,0,-0.088900><1.975656,0.035000,0.088900> rotate<0,44.997030,0> translate<66.167000,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.564000,-1.535000,12.319000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.630000,-1.535000,12.235000>}
box{<0,0,-0.088900><0.106827,0.035000,0.088900> rotate<0,51.839352,0> translate<67.564000,-1.535000,12.319000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.630000,-1.535000,16.680000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.691000,-1.535000,16.637000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,35.178378,0> translate<67.630000,-1.535000,16.680000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.630000,-1.535000,21.760000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.691000,-1.535000,21.717000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,35.178378,0> translate<67.630000,-1.535000,21.760000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<60.706000,-1.535000,18.161000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.945000,-1.535000,18.161000>}
box{<0,0,-0.088900><7.239000,0.035000,0.088900> rotate<0,0.000000,0> translate<60.706000,-1.535000,18.161000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<66.260000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<67.945000,0.000000,25.400000>}
box{<0,0,-0.152400><1.685000,0.035000,0.152400> rotate<0,0.000000,0> translate<66.260000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<67.945000,0.000000,29.845000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<67.945000,0.000000,25.400000>}
box{<0,0,-0.152400><4.445000,0.035000,0.152400> rotate<0,-90.000000,0> translate<67.945000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<67.437000,0.000000,23.241000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<68.072000,0.000000,23.876000>}
box{<0,0,-0.190500><0.898026,0.035000,0.190500> rotate<0,-44.997030,0> translate<67.437000,0.000000,23.241000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.675000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,7.620000>}
box{<0,0,-0.088900><2.694077,0.035000,0.088900> rotate<0,-44.997030,0> translate<66.675000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,14.435000>}
box{<0,0,-0.088900><0.084000,0.035000,0.088900> rotate<0,90.000000,0> translate<68.580000,-1.535000,14.435000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.945000,-1.535000,18.161000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,18.796000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<67.945000,-1.535000,18.161000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,18.880000>}
box{<0,0,-0.088900><0.084000,0.035000,0.088900> rotate<0,90.000000,0> translate<68.580000,-1.535000,18.880000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,24.003000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,23.960000>}
box{<0,0,-0.088900><0.043000,0.035000,0.088900> rotate<0,-90.000000,0> translate<68.580000,-1.535000,23.960000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.437000,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,24.003000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<67.437000,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<64.897000,-1.535000,26.797000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<68.580000,-1.535000,30.480000>}
box{<0,0,-0.152400><5.208549,0.035000,0.152400> rotate<0,-44.997030,0> translate<64.897000,-1.535000,26.797000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<67.945000,0.000000,29.845000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<68.580000,0.000000,30.480000>}
box{<0,0,-0.152400><0.898026,0.035000,0.152400> rotate<0,-44.997030,0> translate<67.945000,0.000000,29.845000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<20.320000,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,0.000000,32.766000>}
box{<0,0,-0.088900><48.260000,0.035000,0.088900> rotate<0,0.000000,0> translate<20.320000,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<68.795000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<68.834000,0.000000,10.795000>}
box{<0,0,-0.152400><0.039000,0.035000,0.152400> rotate<0,0.000000,0> translate<68.795000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<68.072000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<68.961000,0.000000,23.876000>}
box{<0,0,-0.190500><0.889000,0.035000,0.190500> rotate<0,0.000000,0> translate<68.072000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<68.961000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<69.060000,0.000000,23.900000>}
box{<0,0,-0.190500><0.101868,0.035000,0.190500> rotate<0,-13.626096,0> translate<68.961000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<67.945000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.060000,0.000000,25.400000>}
box{<0,0,-0.152400><1.115000,0.035000,0.152400> rotate<0,0.000000,0> translate<67.945000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.060000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.088000,0.000000,25.527000>}
box{<0,0,-0.152400><0.130050,0.035000,0.152400> rotate<0,-77.561646,0> translate<69.060000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.088000,0.000000,25.527000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.088000,0.000000,26.035000>}
box{<0,0,-0.152400><0.508000,0.035000,0.152400> rotate<0,90.000000,0> translate<69.088000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.060000,0.000000,26.900000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.088000,0.000000,26.924000>}
box{<0,0,-0.088900><0.036878,0.035000,0.088900> rotate<0,-40.598615,0> translate<69.060000,0.000000,26.900000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.691000,-1.535000,16.637000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.469000,-1.535000,16.637000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<67.691000,-1.535000,16.637000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.691000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.469000,-1.535000,21.717000>}
box{<0,0,-0.088900><1.778000,0.035000,0.088900> rotate<0,0.000000,0> translate<67.691000,-1.535000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.469000,-1.535000,16.637000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.530000,-1.535000,16.680000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,-35.178378,0> translate<69.469000,-1.535000,16.637000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.469000,-1.535000,21.717000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.530000,-1.535000,21.760000>}
box{<0,0,-0.088900><0.074632,0.035000,0.088900> rotate<0,-35.178378,0> translate<69.469000,-1.535000,21.717000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.530000,-1.535000,12.235000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,12.192000>}
box{<0,0,-0.088900><0.078772,0.035000,0.088900> rotate<0,33.082669,0> translate<69.530000,-1.535000,12.235000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,12.192000>}
box{<0,0,-0.088900><3.302000,0.035000,0.088900> rotate<0,90.000000,0> translate<69.596000,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.530000,-1.535000,16.680000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,16.764000>}
box{<0,0,-0.088900><0.106827,0.035000,0.088900> rotate<0,-51.839352,0> translate<69.530000,-1.535000,16.680000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.530000,-1.535000,21.760000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,21.844000>}
box{<0,0,-0.088900><0.106827,0.035000,0.088900> rotate<0,-51.839352,0> translate<69.530000,-1.535000,21.760000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<14.732000,-1.535000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,3.810000>}
box{<0,0,-0.088900><54.991000,0.035000,0.088900> rotate<0,0.000000,0> translate<14.732000,-1.535000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,8.763000>}
box{<0,0,-0.088900><0.179605,0.035000,0.088900> rotate<0,44.997030,0> translate<69.596000,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,8.763000>}
box{<0,0,-0.088900><4.953000,0.035000,0.088900> rotate<0,90.000000,0> translate<69.723000,-1.535000,8.763000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,-1.535000,14.351000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,13.208000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<68.580000,-1.535000,14.351000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.088000,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,0.000000,27.559000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<69.088000,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,0.000000,31.623000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,0.000000,27.559000>}
box{<0,0,-0.088900><4.064000,0.035000,0.088900> rotate<0,-90.000000,0> translate<69.723000,0.000000,27.559000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<68.580000,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,0.000000,31.623000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<68.580000,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.977000,-1.535000,17.145000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<69.596000,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.596000,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.977000,-1.535000,22.225000>}
box{<0,0,-0.088900><0.538815,0.035000,0.088900> rotate<0,-44.997030,0> translate<69.596000,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<57.785000,-1.535000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.485000,-1.535000,32.385000>}
box{<0,0,-0.088900><12.700000,0.035000,0.088900> rotate<0,0.000000,0> translate<57.785000,-1.535000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.905000,0.000000,15.240000>}
box{<0,0,-0.088900><3.976000,0.035000,0.088900> rotate<0,0.000000,0> translate<66.929000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<66.929000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.905000,0.000000,19.685000>}
box{<0,0,-0.088900><3.976000,0.035000,0.088900> rotate<0,0.000000,0> translate<66.929000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.905000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.993000,0.000000,17.145000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<70.905000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.905000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.993000,0.000000,22.225000>}
box{<0,0,-0.088900><0.088000,0.035000,0.088900> rotate<0,0.000000,0> translate<70.905000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.993000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,17.780000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,-44.997030,0> translate<70.993000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,18.034000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<71.628000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.993000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,21.590000>}
box{<0,0,-0.088900><0.898026,0.035000,0.088900> rotate<0,44.997030,0> translate<70.993000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,21.590000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<71.628000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.882000,0.000000,18.288000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<71.628000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.628000,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.882000,0.000000,21.082000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,44.997030,0> translate<71.628000,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<68.834000,0.000000,10.795000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<72.390000,0.000000,7.239000>}
box{<0,0,-0.152400><5.028943,0.035000,0.152400> rotate<0,44.997030,0> translate<68.834000,0.000000,10.795000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<72.390000,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<72.390000,0.000000,7.239000>}
box{<0,0,-0.152400><1.524000,0.035000,0.152400> rotate<0,90.000000,0> translate<72.390000,0.000000,7.239000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<55.626000,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.644000,-1.535000,32.766000>}
box{<0,0,-0.088900><17.018000,0.035000,0.088900> rotate<0,0.000000,0> translate<55.626000,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.605000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<74.168000,0.000000,22.225000>}
box{<0,0,-0.088900><1.563000,0.035000,0.088900> rotate<0,0.000000,0> translate<72.605000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<53.467000,-1.535000,33.147000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<74.803000,-1.535000,33.147000>}
box{<0,0,-0.088900><21.336000,0.035000,0.088900> rotate<0,0.000000,0> translate<53.467000,-1.535000,33.147000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<28.829000,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<74.930000,0.000000,1.270000>}
box{<0,0,-0.190500><46.101000,0.035000,0.190500> rotate<0,0.000000,0> translate<28.829000,0.000000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<74.930000,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.190500 translate<74.930000,0.000000,5.715000>}
box{<0,0,-0.190500><4.445000,0.035000,0.190500> rotate<0,90.000000,0> translate<74.930000,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<74.168000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<75.311000,0.000000,23.368000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<74.168000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.723000,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.835000,-1.535000,13.208000>}
box{<0,0,-0.088900><7.112000,0.035000,0.088900> rotate<0,0.000000,0> translate<69.723000,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.605000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,15.240000>}
box{<0,0,-0.088900><4.357000,0.035000,0.088900> rotate<0,0.000000,0> translate<72.605000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,15.494000>}
box{<0,0,-0.088900><0.254000,0.035000,0.088900> rotate<0,90.000000,0> translate<76.962000,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.605000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,19.685000>}
box{<0,0,-0.088900><4.357000,0.035000,0.088900> rotate<0,0.000000,0> translate<72.605000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,20.574000>}
box{<0,0,-0.088900><0.889000,0.035000,0.088900> rotate<0,90.000000,0> translate<76.962000,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.882000,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,21.082000>}
box{<0,0,-0.088900><5.080000,0.035000,0.088900> rotate<0,0.000000,0> translate<71.882000,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<51.308000,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,-1.535000,33.528000>}
box{<0,0,-0.088900><25.654000,0.035000,0.088900> rotate<0,0.000000,0> translate<51.308000,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.183000,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,-1.535000,15.494000>}
box{<0,0,-0.088900><10.033000,0.035000,0.088900> rotate<0,0.000000,0> translate<67.183000,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,0.000000,15.748000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<76.962000,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,0.000000,20.828000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,-44.997030,0> translate<76.962000,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<67.183000,-1.535000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.851000,-1.535000,19.939000>}
box{<0,0,-0.088900><10.668000,0.035000,0.088900> rotate<0,0.000000,0> translate<67.183000,-1.535000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,14.605000>}
box{<0,0,-0.088900><1.257236,0.035000,0.088900> rotate<0,44.997030,0> translate<77.216000,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.977000,-1.535000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,17.145000>}
box{<0,0,-0.088900><8.128000,0.035000,0.088900> rotate<0,0.000000,0> translate<69.977000,-1.535000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.605000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,0.000000,17.145000>}
box{<0,0,-0.088900><5.500000,0.035000,0.088900> rotate<0,0.000000,0> translate<72.605000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.851000,-1.535000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,19.685000>}
box{<0,0,-0.088900><0.359210,0.035000,0.088900> rotate<0,44.997030,0> translate<77.851000,-1.535000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<69.977000,-1.535000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,22.225000>}
box{<0,0,-0.088900><8.128000,0.035000,0.088900> rotate<0,0.000000,0> translate<69.977000,-1.535000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,0.000000,22.225000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,-44.997030,0> translate<76.962000,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<70.485000,-1.535000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,24.765000>}
box{<0,0,-0.088900><10.776307,0.035000,0.088900> rotate<0,44.997030,0> translate<70.485000,-1.535000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<72.644000,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,27.305000>}
box{<0,0,-0.088900><7.723020,0.035000,0.088900> rotate<0,44.997030,0> translate<72.644000,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<74.803000,-1.535000,33.147000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,29.845000>}
box{<0,0,-0.088900><4.669733,0.035000,0.088900> rotate<0,44.997030,0> translate<74.803000,-1.535000,33.147000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.962000,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.105000,-1.535000,32.385000>}
box{<0,0,-0.088900><1.616446,0.035000,0.088900> rotate<0,44.997030,0> translate<76.962000,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,11.557000>}
box{<0,0,-0.088900><9.017000,0.035000,0.088900> rotate<0,90.000000,0> translate<78.359000,0.000000,11.557000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<76.835000,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,11.684000>}
box{<0,0,-0.088900><2.155261,0.035000,0.088900> rotate<0,44.997030,0> translate<76.835000,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.419500,0.000000,2.470500>}
box{<0,0,-0.088900><0.092144,0.035000,0.088900> rotate<0,48.957081,0> translate<78.359000,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,11.557000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.419500,0.000000,11.570500>}
box{<0,0,-0.088900><0.061988,0.035000,0.088900> rotate<0,-12.578105,0> translate<78.359000,0.000000,11.557000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.359000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<78.419500,0.000000,11.570500>}
box{<0,0,-0.088900><0.128618,0.035000,0.088900> rotate<0,61.936527,0> translate<78.359000,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<72.390000,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<80.010000,-1.535000,13.335000>}
box{<0,0,-0.152400><10.776307,0.035000,0.152400> rotate<0,-44.997030,0> translate<72.390000,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,14.605000>}
box{<0,0,-0.088900><1.143000,0.035000,0.088900> rotate<0,-90.000000,0> translate<80.645000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,15.748000>}
box{<0,0,-0.088900><3.429000,0.035000,0.088900> rotate<0,0.000000,0> translate<77.216000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,17.145000>}
box{<0,0,-0.088900><1.143000,0.035000,0.088900> rotate<0,-90.000000,0> translate<80.645000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<71.882000,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,18.288000>}
box{<0,0,-0.088900><8.763000,0.035000,0.088900> rotate<0,0.000000,0> translate<71.882000,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,19.685000>}
box{<0,0,-0.088900><1.143000,0.035000,0.088900> rotate<0,-90.000000,0> translate<80.645000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<77.216000,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,20.828000>}
box{<0,0,-0.088900><3.429000,0.035000,0.088900> rotate<0,0.000000,0> translate<77.216000,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,22.225000>}
box{<0,0,-0.088900><1.143000,0.035000,0.088900> rotate<0,-90.000000,0> translate<80.645000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<75.311000,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.088900 translate<80.645000,0.000000,23.368000>}
box{<0,0,-0.088900><5.334000,0.035000,0.088900> rotate<0,0.000000,0> translate<75.311000,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<80.010000,-1.535000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<81.915000,-1.535000,13.335000>}
box{<0,0,-0.152400><1.905000,0.035000,0.152400> rotate<0,0.000000,0> translate<80.010000,-1.535000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,2.540000>}
box{<0,0,-0.152400><8.890000,0.035000,0.152400> rotate<0,-90.000000,0> translate<82.931000,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.869500,0.000000,11.570500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,11.430000>}
box{<0,0,-0.152400><0.153370,0.035000,0.152400> rotate<0,66.355547,0> translate<82.869500,0.000000,11.570500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.869500,0.000000,11.570500>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,11.684000>}
box{<0,0,-0.152400><0.129091,0.035000,0.152400> rotate<0,-61.544879,0> translate<82.869500,0.000000,11.570500> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.969500,0.000000,2.480500>}
box{<0,0,-0.152400><0.070870,0.035000,0.152400> rotate<0,57.090989,0> translate<82.931000,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<82.931000,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,11.938000>}
box{<0,0,-0.152400><0.359210,0.035000,0.152400> rotate<0,-44.997030,0> translate<82.931000,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,11.938000>}
box{<0,0,-0.152400><2.667000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<81.915000,-1.535000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,-1.535000,14.605000>}
box{<0,0,-0.152400><1.796051,0.035000,0.152400> rotate<0,-44.997030,0> translate<81.915000,-1.535000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,14.605000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,17.145000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,19.685000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,24.765000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,22.225000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,22.225000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,24.765000>}
box{<0,0,-0.152400><1.270000,0.035000,0.152400> rotate<0,-90.000000,0> translate<83.185000,0.000000,24.765000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<69.088000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,26.035000>}
box{<0,0,-0.152400><14.097000,0.035000,0.152400> rotate<0,0.000000,0> translate<69.088000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,27.305000>}
box{<0,0,-0.152400><1.270000,0.035000,0.152400> rotate<0,90.000000,0> translate<83.185000,0.000000,27.305000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,29.845000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,90.000000,0> translate<83.185000,0.000000,29.845000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,29.845000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,32.385000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,90.000000,0> translate<83.185000,0.000000,32.385000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<80.645000,0.000000,36.195000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,36.195000>}
box{<0,0,-0.152400><2.540000,0.035000,0.152400> rotate<0,0.000000,0> translate<80.645000,0.000000,36.195000> }
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,32.385000>}
cylinder{<0,0,0><0,0.035000,0>0.152400 translate<83.185000,0.000000,36.195000>}
box{<0,0,-0.152400><3.810000,0.035000,0.152400> rotate<0,90.000000,0> translate<83.185000,0.000000,36.195000> }
//Text
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.165100,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.334600,-1.535000,3.048800>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.165100,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.334600,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.673600,-1.535000,3.048800>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.334600,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.673600,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.843000,-1.535000,2.879300>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,45.013935,0> translate<13.673600,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.843000,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.843000,-1.535000,2.201400>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.843000,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.843000,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.673600,-1.535000,2.032000>}
box{<0,0,-0.127000><0.239568,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.673600,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.673600,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.334600,-1.535000,2.032000>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.334600,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.334600,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.165100,-1.535000,2.201400>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,44.980125,0> translate<13.165100,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.673700,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.673700,-1.535000,2.201400>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,90.000000,0> translate<12.673700,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.673700,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.504300,-1.535000,2.201400>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,0.000000,0> translate<12.504300,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.504300,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.504300,-1.535000,2.032000>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.504300,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.504300,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.673700,-1.535000,2.032000>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,0.000000,0> translate<12.504300,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.919800,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.919800,-1.535000,2.032000>}
box{<0,0,-0.127000><1.016800,0.035000,0.127000> rotate<0,-90.000000,0> translate<10.919800,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.919800,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.411400,-1.535000,2.032000>}
box{<0,0,-0.127000><0.508400,0.035000,0.127000> rotate<0,0.000000,0> translate<10.411400,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.411400,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.241900,-1.535000,2.201400>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,44.980125,0> translate<10.241900,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.241900,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.241900,-1.535000,2.879300>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,90.000000,0> translate<10.241900,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.241900,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.411400,-1.535000,3.048800>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.241900,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.411400,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.919800,-1.535000,3.048800>}
box{<0,0,-0.127000><0.508400,0.035000,0.127000> rotate<0,0.000000,0> translate<10.411400,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.750500,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.750500,-1.535000,3.048800>}
box{<0,0,-0.127000><1.016800,0.035000,0.127000> rotate<0,90.000000,0> translate<9.750500,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.750500,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.072600,-1.535000,2.032000>}
box{<0,0,-0.127000><1.222060,0.035000,0.127000> rotate<0,-56.304916,0> translate<9.072600,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.072600,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.072600,-1.535000,3.048800>}
box{<0,0,-0.127000><1.016800,0.035000,0.127000> rotate<0,90.000000,0> translate<9.072600,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.903300,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.072800,-1.535000,3.048800>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.903300,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.072800,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.411800,-1.535000,3.048800>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.072800,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.411800,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.581200,-1.535000,2.879300>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,45.013935,0> translate<8.411800,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.581200,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.581200,-1.535000,2.201400>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.581200,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.581200,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.411800,-1.535000,2.032000>}
box{<0,0,-0.127000><0.239568,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.411800,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.411800,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.072800,-1.535000,2.032000>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.072800,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.072800,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.903300,-1.535000,2.201400>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,44.980125,0> translate<7.903300,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.564700,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.242600,-1.535000,2.032000>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.564700,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.242600,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.564700,-1.535000,2.709900>}
box{<0,0,-0.127000><0.958695,0.035000,0.127000> rotate<0,44.997030,0> translate<5.564700,-1.535000,2.709900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.564700,-1.535000,2.709900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.564700,-1.535000,2.879300>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,90.000000,0> translate<5.564700,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.564700,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.734200,-1.535000,3.048800>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.564700,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.734200,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.073200,-1.535000,3.048800>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<5.734200,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.073200,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.242600,-1.535000,2.879300>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,45.013935,0> translate<6.073200,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.073300,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.073300,-1.535000,2.879300>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,90.000000,0> translate<5.073300,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.073300,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.903900,-1.535000,3.048800>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,45.013935,0> translate<4.903900,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.903900,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.564900,-1.535000,3.048800>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<4.564900,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.564900,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.395400,-1.535000,2.879300>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<4.395400,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.395400,-1.535000,2.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.395400,-1.535000,2.201400>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.395400,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.395400,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.564900,-1.535000,2.032000>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,44.980125,0> translate<4.395400,-1.535000,2.201400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.564900,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.903900,-1.535000,2.032000>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<4.564900,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.903900,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.073300,-1.535000,2.201400>}
box{<0,0,-0.127000><0.239568,0.035000,0.127000> rotate<0,-44.997030,0> translate<4.903900,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.073300,-1.535000,2.201400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.395400,-1.535000,2.879300>}
box{<0,0,-0.127000><0.958695,0.035000,0.127000> rotate<0,44.997030,0> translate<4.395400,-1.535000,2.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.904000,-1.535000,2.709900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.565100,-1.535000,3.048800>}
box{<0,0,-0.127000><0.479277,0.035000,0.127000> rotate<0,44.997030,0> translate<3.565100,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.565100,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.565100,-1.535000,2.032000>}
box{<0,0,-0.127000><1.016800,0.035000,0.127000> rotate<0,-90.000000,0> translate<3.565100,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.904000,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.226100,-1.535000,2.032000>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,0.000000,0> translate<3.226100,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.734700,-1.535000,2.709900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.395800,-1.535000,3.048800>}
box{<0,0,-0.127000><0.479277,0.035000,0.127000> rotate<0,44.997030,0> translate<2.395800,-1.535000,3.048800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.395800,-1.535000,3.048800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.395800,-1.535000,2.032000>}
box{<0,0,-0.127000><1.016800,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.395800,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.734700,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.056800,-1.535000,2.032000>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,0.000000,0> translate<2.056800,-1.535000,2.032000> }
//Rect
union{
texture{col_pds}
}
texture{col_wrs}
}
#end
#if(pcb_polygons=on)
union{
//Polygons
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.977400>}
box{<0,0,-0.127000><35.829500,0.035000,0.127000> rotate<0,90.000000,0> translate<1.130100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.977400>}
box{<0,0,-0.127000><35.829500,0.035000,0.127000> rotate<0,90.000000,0> translate<1.130100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.250700,0.000000,1.147900>}
box{<0,0,-0.127000><27.120600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,1.147900>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.128500,0.000000,1.270000>}
box{<0,0,-0.127000><26.998400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,1.270000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,1.524000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.874500,0.000000,1.524000>}
box{<0,0,-0.127000><26.744400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,1.524000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,1.524000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,1.524000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,1.524000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.700100,-1.535000,1.778000>}
box{<0,0,-0.127000><0.570000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.620500,0.000000,1.778000>}
box{<0,0,-0.127000><26.490400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.625000,-1.535000,2.032000>}
box{<0,0,-0.127000><0.494900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.366500,0.000000,2.032000>}
box{<0,0,-0.127000><26.236400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.700200,-1.535000,2.286000>}
box{<0,0,-0.127000><0.570100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.112500,0.000000,2.286000>}
box{<0,0,-0.127000><25.982400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,2.540000>}
box{<0,0,-0.127000><0.833900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.858500,0.000000,2.540000>}
box{<0,0,-0.127000><25.728400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,2.794000>}
box{<0,0,-0.127000><0.833900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.604500,0.000000,2.794000>}
box{<0,0,-0.127000><25.474400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,3.048000>}
box{<0,0,-0.127000><0.833900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.350500,0.000000,3.048000>}
box{<0,0,-0.127000><25.220400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.038400,-1.535000,3.302000>}
box{<0,0,-0.127000><0.908300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.096500,0.000000,3.302000>}
box{<0,0,-0.127000><24.966400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.429200,-1.535000,3.556000>}
box{<0,0,-0.127000><13.299100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.842500,0.000000,3.556000>}
box{<0,0,-0.127000><24.712400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.175200,-1.535000,3.810000>}
box{<0,0,-0.127000><13.045100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.588500,0.000000,3.810000>}
box{<0,0,-0.127000><24.458400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.921200,-1.535000,4.064000>}
box{<0,0,-0.127000><12.791100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.334500,0.000000,4.064000>}
box{<0,0,-0.127000><24.204400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.667200,-1.535000,4.318000>}
box{<0,0,-0.127000><12.537100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.080500,0.000000,4.318000>}
box{<0,0,-0.127000><23.950400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.413200,-1.535000,4.572000>}
box{<0,0,-0.127000><12.283100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.826500,0.000000,4.572000>}
box{<0,0,-0.127000><23.696400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.159200,-1.535000,4.826000>}
box{<0,0,-0.127000><12.029100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.572500,0.000000,4.826000>}
box{<0,0,-0.127000><23.442400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.905200,-1.535000,5.080000>}
box{<0,0,-0.127000><11.775100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.318500,0.000000,5.080000>}
box{<0,0,-0.127000><23.188400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.889200,-1.535000,5.334000>}
box{<0,0,-0.127000><10.759100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.064500,0.000000,5.334000>}
box{<0,0,-0.127000><22.934400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.635200,-1.535000,5.588000>}
box{<0,0,-0.127000><10.505100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.810500,0.000000,5.588000>}
box{<0,0,-0.127000><22.680400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.005900,0.000000,5.842000>}
box{<0,0,-0.127000><0.875800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.005900,-1.535000,5.842000>}
box{<0,0,-0.127000><0.875800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.685500,0.000000,6.096000>}
box{<0,0,-0.127000><0.555400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.685500,-1.535000,6.096000>}
box{<0,0,-0.127000><0.555400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.513200,0.000000,6.350000>}
box{<0,0,-0.127000><0.383100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.513200,-1.535000,6.350000>}
box{<0,0,-0.127000><0.383100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.408000,0.000000,6.604000>}
box{<0,0,-0.127000><0.277900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.408000,-1.535000,6.604000>}
box{<0,0,-0.127000><0.277900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,0.000000,6.858000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,-1.535000,6.858000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,0.000000,7.112000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,-1.535000,7.112000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,0.000000,7.366000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,-1.535000,7.366000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,0.000000,7.620000>}
box{<0,0,-0.127000><1.282400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,-1.535000,7.620000>}
box{<0,0,-0.127000><1.282400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,7.874000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,7.874000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,8.128000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,8.128000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,8.382000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,8.382000>}
box{<0,0,-0.127000><0.266900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.408100,0.000000,8.636000>}
box{<0,0,-0.127000><0.278000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.408100,-1.535000,8.636000>}
box{<0,0,-0.127000><0.278000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.513300,0.000000,8.890000>}
box{<0,0,-0.127000><0.383200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.513300,-1.535000,8.890000>}
box{<0,0,-0.127000><0.383200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.685600,0.000000,9.144000>}
box{<0,0,-0.127000><0.555500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.685600,-1.535000,9.144000>}
box{<0,0,-0.127000><0.555500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.006300,0.000000,9.398000>}
box{<0,0,-0.127000><0.876200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.006300,-1.535000,9.398000>}
box{<0,0,-0.127000><0.876200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.652000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.555400,-1.535000,9.652000>}
box{<0,0,-0.127000><5.425300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,9.906000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.809400,-1.535000,9.906000>}
box{<0,0,-0.127000><5.679300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.160000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.063400,-1.535000,10.160000>}
box{<0,0,-0.127000><5.933300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.414000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.317400,-1.535000,10.414000>}
box{<0,0,-0.127000><6.187300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.668000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.571400,-1.535000,10.668000>}
box{<0,0,-0.127000><6.441300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.922000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.825400,-1.535000,10.922000>}
box{<0,0,-0.127000><6.695300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,11.176000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.079400,-1.535000,11.176000>}
box{<0,0,-0.127000><6.949300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,11.430000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.333400,-1.535000,11.430000>}
box{<0,0,-0.127000><7.203300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,11.684000>}
box{<0,0,-0.127000><0.433900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.587400,-1.535000,11.684000>}
box{<0,0,-0.127000><7.457300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.938000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.841400,-1.535000,11.938000>}
box{<0,0,-0.127000><7.711300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,12.192000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.095400,-1.535000,12.192000>}
box{<0,0,-0.127000><7.965300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,12.446000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.349400,-1.535000,12.446000>}
box{<0,0,-0.127000><8.219300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,12.700000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.603400,-1.535000,12.700000>}
box{<0,0,-0.127000><8.473300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,12.954000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.857400,-1.535000,12.954000>}
box{<0,0,-0.127000><8.727300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.395100,0.000000,13.208000>}
box{<0,0,-0.127000><0.265000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.111400,-1.535000,13.208000>}
box{<0,0,-0.127000><8.981300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,13.462000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.365400,-1.535000,13.462000>}
box{<0,0,-0.127000><9.235300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,13.716000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.619400,-1.535000,13.716000>}
box{<0,0,-0.127000><9.489300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,13.970000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.873400,-1.535000,13.970000>}
box{<0,0,-0.127000><9.743300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.224000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.127400,-1.535000,14.224000>}
box{<0,0,-0.127000><9.997300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,14.478000>}
box{<0,0,-0.127000><1.584500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.381400,-1.535000,14.478000>}
box{<0,0,-0.127000><10.251300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.732000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.635400,-1.535000,14.732000>}
box{<0,0,-0.127000><10.505300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.986000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,14.986000>}
box{<0,0,-0.127000><14.960100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,15.240000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.056100,-1.535000,15.240000>}
box{<0,0,-0.127000><14.926000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,15.494000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.494000>}
box{<0,0,-0.127000><14.883900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.251200,0.000000,15.748000>}
box{<0,0,-0.127000><0.121100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.865600,-1.535000,15.748000>}
box{<0,0,-0.127000><4.735500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,16.002000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.381000,-1.535000,16.002000>}
box{<0,0,-0.127000><4.250900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,16.256000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.127000,-1.535000,16.256000>}
box{<0,0,-0.127000><3.996900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,16.510000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.953800,-1.535000,16.510000>}
box{<0,0,-0.127000><3.823700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,16.764000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.848600,-1.535000,16.764000>}
box{<0,0,-0.127000><3.718500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,17.018000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,17.018000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,17.272000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,17.272000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,17.526000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,17.526000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,17.780000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.825600,-1.535000,17.780000>}
box{<0,0,-0.127000><3.695500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,18.034000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.930800,-1.535000,18.034000>}
box{<0,0,-0.127000><3.800700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,18.288000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.071100,-1.535000,18.288000>}
box{<0,0,-0.127000><3.941000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,18.542000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.325100,-1.535000,18.542000>}
box{<0,0,-0.127000><4.195000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,18.796000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.730800,-1.535000,18.796000>}
box{<0,0,-0.127000><4.600700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,19.050000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,-1.535000,19.050000>}
box{<0,0,-0.127000><11.823900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,19.304000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.730400,-1.535000,19.304000>}
box{<0,0,-0.127000><4.600300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,19.558000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.325000,-1.535000,19.558000>}
box{<0,0,-0.127000><4.194900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,19.812000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.071000,-1.535000,19.812000>}
box{<0,0,-0.127000><3.940900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,20.066000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.930700,-1.535000,20.066000>}
box{<0,0,-0.127000><3.800600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,20.320000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.825400,-1.535000,20.320000>}
box{<0,0,-0.127000><3.695300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,20.574000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,20.574000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,20.828000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,20.828000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,21.082000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,21.082000>}
box{<0,0,-0.127000><3.631600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,21.336000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.848800,-1.535000,21.336000>}
box{<0,0,-0.127000><3.718700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,21.590000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.954000,-1.535000,21.590000>}
box{<0,0,-0.127000><3.823900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,21.844000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.127100,-1.535000,21.844000>}
box{<0,0,-0.127000><3.997000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,22.098000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.381100,-1.535000,22.098000>}
box{<0,0,-0.127000><4.251000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.251100,0.000000,22.352000>}
box{<0,0,-0.127000><0.121000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.865900,-1.535000,22.352000>}
box{<0,0,-0.127000><4.735800,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,22.606000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.329500,-1.535000,22.606000>}
box{<0,0,-0.127000><9.199400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,22.860000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.479400,-1.535000,22.860000>}
box{<0,0,-0.127000><9.349300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.114000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.254300,-1.535000,23.114000>}
box{<0,0,-0.127000><10.124200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.368000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.508300,-1.535000,23.368000>}
box{<0,0,-0.127000><10.378200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,23.622000>}
box{<0,0,-0.127000><1.584500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.762300,-1.535000,23.622000>}
box{<0,0,-0.127000><10.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.876000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.016300,-1.535000,23.876000>}
box{<0,0,-0.127000><10.886200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,24.130000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.270300,-1.535000,24.130000>}
box{<0,0,-0.127000><11.140200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,24.384000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.524300,-1.535000,24.384000>}
box{<0,0,-0.127000><11.394200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,24.638000>}
box{<0,0,-0.127000><0.080900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.778300,-1.535000,24.638000>}
box{<0,0,-0.127000><11.648200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.395200,0.000000,24.892000>}
box{<0,0,-0.127000><0.265100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.032300,-1.535000,24.892000>}
box{<0,0,-0.127000><11.902200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,25.146000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.286300,-1.535000,25.146000>}
box{<0,0,-0.127000><12.156200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,25.400000>}
box{<0,0,-0.127000><3.175200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.540300,-1.535000,25.400000>}
box{<0,0,-0.127000><12.410200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,25.654000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.794300,-1.535000,25.654000>}
box{<0,0,-0.127000><12.664200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,25.908000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.048300,-1.535000,25.908000>}
box{<0,0,-0.127000><12.918200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,26.162000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.302300,-1.535000,26.162000>}
box{<0,0,-0.127000><13.172200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,26.416000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.556300,-1.535000,26.416000>}
box{<0,0,-0.127000><13.426200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,26.670000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.810300,-1.535000,26.670000>}
box{<0,0,-0.127000><13.680200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,26.924000>}
box{<0,0,-0.127000><2.715100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.064300,-1.535000,26.924000>}
box{<0,0,-0.127000><13.934200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.761200,0.000000,27.178000>}
box{<0,0,-0.127000><2.631100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.318300,-1.535000,27.178000>}
box{<0,0,-0.127000><14.188200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.507200,0.000000,27.432000>}
box{<0,0,-0.127000><2.377100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.572300,-1.535000,27.432000>}
box{<0,0,-0.127000><14.442200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.253200,0.000000,27.686000>}
box{<0,0,-0.127000><2.123100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.826300,-1.535000,27.686000>}
box{<0,0,-0.127000><14.696200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.999200,0.000000,27.940000>}
box{<0,0,-0.127000><1.869100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.733300,-1.535000,27.940000>}
box{<0,0,-0.127000><9.603200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.745200,0.000000,28.194000>}
box{<0,0,-0.127000><1.615100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.269200,-1.535000,28.194000>}
box{<0,0,-0.127000><3.139100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.491200,0.000000,28.448000>}
box{<0,0,-0.127000><1.361100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.015200,-1.535000,28.448000>}
box{<0,0,-0.127000><2.885100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.205000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.074900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.205100,0.000000,28.702000>}
box{<0,0,-0.127000><1.075000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.793300,0.000000,28.956000>}
box{<0,0,-0.127000><0.663200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.793300,-1.535000,28.956000>}
box{<0,0,-0.127000><0.663200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.595700,0.000000,29.210000>}
box{<0,0,-0.127000><0.465600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.595700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.465600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.490400,0.000000,29.464000>}
box{<0,0,-0.127000><0.360300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.490400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.360300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,29.718000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,29.972000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,30.226000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,30.480000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,30.734000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,30.988000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,31.242000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.343100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.490600,0.000000,31.496000>}
box{<0,0,-0.127000><0.360500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.490600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.360500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.595800,0.000000,31.750000>}
box{<0,0,-0.127000><0.465700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.595800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.465700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.793400,0.000000,32.004000>}
box{<0,0,-0.127000><0.663300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.793400,-1.535000,32.004000>}
box{<0,0,-0.127000><0.663300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.205400,0.000000,32.258000>}
box{<0,0,-0.127000><1.075300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.205400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.075300,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,32.512000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,32.512000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,32.766000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,32.766000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,33.020000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,33.020000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,33.274000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,33.274000>}
box{<0,0,-0.127000><4.095900,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,33.528000>}
box{<0,0,-0.127000><4.826200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.855800,-1.535000,33.528000>}
box{<0,0,-0.127000><6.725700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,33.782000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,33.782000>}
box{<0,0,-0.127000><4.826200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,33.782000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,33.782000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.005300,-1.535000,33.782000>}
box{<0,0,-0.127000><49.875200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,33.782000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,34.036000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,34.036000>}
box{<0,0,-0.127000><4.826200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,34.036000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,34.036000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,34.036000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,34.036000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,34.290000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,34.290000>}
box{<0,0,-0.127000><4.826200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,34.290000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,34.290000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,34.544000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.047300,0.000000,34.544000>}
box{<0,0,-0.127000><4.917200,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,34.544000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,34.544000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,34.544000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,34.544000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,34.798000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,34.798000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,34.798000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,34.798000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,34.798000>}
box{<0,0,-0.127000><84.099700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,34.798000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.610700,0.000000,35.052000>}
box{<0,0,-0.127000><78.480600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.610700,-1.535000,35.052000>}
box{<0,0,-0.127000><78.480600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,35.306000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,35.306000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,35.560000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,35.560000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,35.814000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,35.814000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,0.000000,36.068000>}
box{<0,0,-0.127000><79.387400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,-1.535000,36.068000>}
box{<0,0,-0.127000><79.387400,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.322000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.322000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.576000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.576000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.830000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.830000>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.977400>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.130100,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.977400>}
box{<0,0,-0.127000><78.314700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.130100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,13.392100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,13.169000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<1.211000,0.000000,13.392100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,13.392100>}
box{<0,0,-0.127000><1.031000,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.211000,0.000000,13.392100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,14.423100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.211000,0.000000,14.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,14.676700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.211000,0.000000,14.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,15.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,14.676700>}
box{<0,0,-0.127000><1.031100,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.211000,0.000000,14.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,15.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,15.930900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.211000,0.000000,15.707800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,22.392100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,22.169000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<1.211000,0.000000,22.392100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,22.392100>}
box{<0,0,-0.127000><1.031000,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.211000,0.000000,22.392100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,23.423100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.211000,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,23.676700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.211000,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,24.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,23.676700>}
box{<0,0,-0.127000><1.031100,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.211000,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.211000,0.000000,24.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,24.930900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.211000,0.000000,24.707800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,0.000000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,6.630600>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,89.987417,0> translate<1.396900,0.000000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,-1.535000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,6.630600>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,89.987417,0> translate<1.396900,-1.535000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,0.000000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,0.000000,7.493000>}
box{<0,0,-0.127000><1.015600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.396900,0.000000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.396900,-1.535000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,-1.535000,7.493000>}
box{<0,0,-0.127000><1.015600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.396900,-1.535000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,6.630600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,0.000000,6.210500>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<1.397000,0.000000,6.630600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,6.630600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,-1.535000,6.210500>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<1.397000,-1.535000,6.630600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,0.000000,7.746800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.397000,0.000000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,-1.535000,7.746800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<1.397000,-1.535000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,8.609300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,7.746800>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.397000,0.000000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,8.609300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,7.746800>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.397000,-1.535000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,0.000000,8.609300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,0.000000,9.029400>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<1.397000,0.000000,8.609300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.397000,-1.535000,8.609300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,-1.535000,9.029400>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<1.397000,-1.535000,8.609300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,13.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.169000>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.434100,0.000000,13.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,15.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,15.930900>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.434100,0.000000,15.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,22.169000>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.434100,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.434100,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.930900>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.434100,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,0.000000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<1.473200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<1.473200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.473200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.473200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<1.473200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.473200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<1.473200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.563900,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,11.702800>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,-89.986726,0> translate<1.563900,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.563900,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.567600,0.000000,10.921700>}
box{<0,0,-0.127000><1.003700,0.035000,0.127000> rotate<0,0.000000,0> translate<1.563900,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,9.887100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.787100,0.000000,9.664000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<1.564000,0.000000,9.887100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,9.887100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.564000,0.000000,9.887100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.567600,0.000000,10.668100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.564000,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.564000,0.000000,11.702800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.787100,0.000000,11.925900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.564000,0.000000,11.702800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,0.000000,6.210500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,0.000000,5.889000>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<1.571000,0.000000,6.210500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,-1.535000,6.210500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,-1.535000,5.889000>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<1.571000,-1.535000,6.210500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,0.000000,9.029400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,0.000000,9.350900>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.571000,0.000000,9.029400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.571000,-1.535000,9.029400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,-1.535000,9.350900>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.571000,-1.535000,9.029400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.625000,-1.535000,1.853100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.877900,-1.535000,1.600200>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,44.997030,0> translate<1.625000,-1.535000,1.853100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.625000,-1.535000,2.210800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.625000,-1.535000,1.853100>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.625000,-1.535000,1.853100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.625000,-1.535000,2.210800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.877900,-1.535000,2.463700>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.625000,-1.535000,2.210800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<1.635600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<1.635600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.635600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.635600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.635600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.787100,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,9.664000>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.787100,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.787100,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,11.925900>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,0.000000,0> translate<1.787100,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.877900,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.913500,-1.535000,1.600200>}
box{<0,0,-0.127000><1.035600,0.035000,0.127000> rotate<0,0.000000,0> translate<1.877900,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.877900,-1.535000,2.463700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,2.463700>}
box{<0,0,-0.127000><0.086100,0.035000,0.127000> rotate<0,0.000000,0> translate<1.877900,-1.535000,2.463700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,0.000000,5.889000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,0.000000,5.715000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<1.892500,0.000000,5.889000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,-1.535000,5.889000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,-1.535000,5.715000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<1.892500,-1.535000,5.889000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,0.000000,9.350900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,0.000000,9.524900>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<1.892500,0.000000,9.350900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.892500,-1.535000,9.350900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,-1.535000,9.524900>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<1.892500,-1.535000,9.350900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.260000,0.000000,28.679300>}
box{<0,0,-0.127000><0.351009,0.035000,0.127000> rotate<0,22.494073,0> translate<1.935700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<1.935700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<1.935700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.935700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<1.935700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,2.463700>}
box{<0,0,-0.127000><0.763900,0.035000,0.127000> rotate<0,-90.000000,0> translate<1.964000,-1.535000,2.463700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<1.964000,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.216900,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<1.964000,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.216900,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.574600,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<2.216900,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.260000,0.000000,28.679300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.376900,0.000000,28.562300>}
box{<0,0,-0.127000><0.165392,0.035000,0.127000> rotate<0,45.021524,0> translate<2.260000,0.000000,28.679300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,5.714900>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.057064,0> translate<2.312600,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,5.714900>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.057064,0> translate<2.312600,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,0.000000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,9.524900>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.000000,0> translate<2.312600,0.000000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.312600,-1.535000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,9.524900>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.000000,0> translate<2.312600,-1.535000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.327700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,0.000000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.327700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.327700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.327700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.376900,0.000000,28.562300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,27.094000>}
box{<0,0,-0.127000><2.076490,0.035000,0.127000> rotate<0,44.997030,0> translate<2.376900,0.000000,28.562300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,0.000000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,0.000000,7.493000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.412500,0.000000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,-1.535000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.412500,-1.535000,7.493000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.412500,-1.535000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,5.714900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.492500>}
box{<0,0,-0.127000><1.777600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.413000,0.000000,7.492500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,5.714900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.492500>}
box{<0,0,-0.127000><1.777600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.413000,-1.535000,7.492500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,5.842000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,5.842000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,6.096000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,6.096000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,6.350000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,6.350000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,6.604000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,6.604000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,6.858000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,6.858000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.112000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.112000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.366000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.366000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.492500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.492500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,7.492500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.492500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.492500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,7.492500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.747400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,9.524900>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,90.000000,0> translate<2.413000,0.000000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.747400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,9.524900>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,90.000000,0> translate<2.413000,-1.535000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.747400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.747400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,7.747400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.747400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.747400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,7.747400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.874000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.874000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,8.128000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,8.128000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,8.382000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,8.382000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,8.636000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,8.636000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,8.890000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,9.144000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,9.144000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,9.398000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.413000,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,9.398000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.413000,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.567600,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.567600,0.000000,10.668100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.567600,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.667600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.568100,0.000000,10.667600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,9.906000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.160000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.414000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.667600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.667600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,10.667600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.922300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,11.925900>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.568100,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,10.922300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.922300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,10.922300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,11.176000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,11.430000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.568100,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,11.684000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.568100,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.574600,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.827500,-1.535000,3.227600>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,44.997030,0> translate<2.574600,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,0.000000,5.715000>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.666800,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,-1.535000,5.715000>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.666800,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.492500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,5.715000>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.666800,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.492500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,5.715000>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.666800,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,7.747400>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.666800,0.000000,7.747400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,7.747400>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.666800,-1.535000,7.747400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,0.000000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,0.000000,9.524900>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.666800,0.000000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.666800,-1.535000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,-1.535000,9.524900>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.666800,-1.535000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,0.000000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,0.000000,7.746800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<2.667400,0.000000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,-1.535000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,-1.535000,7.746800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<2.667400,-1.535000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,0.000000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.493000>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,0.000000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,-1.535000,7.493000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.493000>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,-1.535000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,7.620000>}
box{<0,0,-0.127000><1.345800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,7.620000>}
box{<0,0,-0.127000><1.345800,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,0.000000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.746800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,0.000000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.667400,-1.535000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.746800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<2.667400,-1.535000,7.746800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,14.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,14.423100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.714600,0.000000,14.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.714600,0.000000,23.423100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.714600,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.422600>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.715100,0.000000,14.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.208000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.462000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.716000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.970000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.224000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.422600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,14.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,15.930900>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.715100,0.000000,15.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.677300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,14.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.732000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.986000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,15.240000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,15.494000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,15.748000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.422600>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.715100,0.000000,23.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,22.352000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,22.606000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,22.860000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.114000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.368000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.422600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,23.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.930900>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.715100,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.677300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,23.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.715100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.892000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.715100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<2.752200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,0.000000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<2.752200,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.752200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<2.752200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.753100,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.207700,-1.535000,3.302000>}
box{<0,0,-0.127000><0.454600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.753100,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,0.000000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,0.000000,5.889000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<2.767300,0.000000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,-1.535000,5.715000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,-1.535000,5.889000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<2.767300,-1.535000,5.715000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,0.000000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,0.000000,9.350900>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<2.767300,0.000000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.767300,-1.535000,9.524900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,-1.535000,9.350900>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<2.767300,-1.535000,9.524900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.602800,0.000000,9.664000>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.821700,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.667600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,9.664000>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.821700,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,10.922300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.821700,0.000000,10.922300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.821700,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.602800,0.000000,11.925900>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.821700,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.822300,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.822300,0.000000,10.921700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<2.822300,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.822300,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.668100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.822300,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.822300,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.921700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<2.822300,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.827500,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.133300,-1.535000,2.921700>}
box{<0,0,-0.127000><0.432537,0.035000,0.127000> rotate<0,45.006396,0> translate<2.827500,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.874600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,32.258000>}
box{<0,0,-0.127000><2.351400,0.035000,0.127000> rotate<0,0.000000,0> translate<2.874600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.874600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,32.258000>}
box{<0,0,-0.127000><2.351400,0.035000,0.127000> rotate<0,0.000000,0> translate<2.874600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.874800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.761200,-1.535000,28.702000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<2.874800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.913500,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.980400,-1.535000,1.667100>}
box{<0,0,-0.127000><0.094611,0.035000,0.127000> rotate<0,-44.997030,0> translate<2.913500,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,13.169000>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.968700,0.000000,13.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,13.169000>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.968700,0.000000,13.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,15.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,14.677300>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.968700,0.000000,14.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,15.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,15.930900>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.968700,0.000000,15.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,22.169000>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.968700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,22.169000>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.968700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,23.677300>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<2.968700,0.000000,23.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.968700,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,24.930900>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<2.968700,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<2.980400,-1.535000,1.667100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.047200,-1.535000,1.600200>}
box{<0,0,-0.127000><0.094540,0.035000,0.127000> rotate<0,45.039881,0> translate<2.980400,-1.535000,1.667100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.007100,-1.535000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.133300,-1.535000,3.048000>}
box{<0,0,-0.127000><0.126200,0.035000,0.127000> rotate<0,0.000000,0> translate<3.007100,-1.535000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.047200,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.082800,-1.535000,1.600200>}
box{<0,0,-0.127000><1.035600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.047200,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.073700,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.398000>}
box{<0,0,-0.127000><1.231600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.073700,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.073700,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.745400,-1.535000,9.398000>}
box{<0,0,-0.127000><1.671700,0.035000,0.127000> rotate<0,0.000000,0> translate<3.073700,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.073900,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.745000,0.000000,5.842000>}
box{<0,0,-0.127000><1.671100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.073900,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.073900,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.745000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.671100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.073900,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.133300,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.133300,-1.535000,2.921700>}
box{<0,0,-0.127000><0.305900,0.035000,0.127000> rotate<0,-90.000000,0> translate<3.133300,-1.535000,2.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.133300,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.386200,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<3.133300,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.396900,-1.535000,29.066400>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,-45.008364,0> translate<3.144200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<3.144200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.144200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<3.144200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,0.000000,5.889000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,0.000000,6.210500>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<3.187400,0.000000,5.889000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,-1.535000,5.889000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,-1.535000,6.210500>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<3.187400,-1.535000,5.889000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,0.000000,9.350900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,0.000000,9.029400>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<3.187400,0.000000,9.350900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.187400,-1.535000,9.350900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,-1.535000,9.029400>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<3.187400,-1.535000,9.350900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.191500,0.000000,28.861000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,0.000000,29.113700>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,-44.985696,0> translate<3.191500,0.000000,28.861000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.191500,0.000000,28.861000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.177900,0.000000,27.874700>}
box{<0,0,-0.127000><1.394910,0.035000,0.127000> rotate<0,44.994126,0> translate<3.191500,0.000000,28.861000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.286500,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.507200,-1.535000,28.956000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<3.286500,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.286500,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.509100,0.000000,28.956000>}
box{<0,0,-0.127000><7.222600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.286500,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.286500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,32.004000>}
box{<0,0,-0.127000><1.939500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.286500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.286500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,32.004000>}
box{<0,0,-0.127000><1.939500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.286500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.350600,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.702000>}
box{<0,0,-0.127000><7.063400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.350600,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.386200,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.743900,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<3.386200,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.394300,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.144000>}
box{<0,0,-0.127000><0.911000,0.035000,0.127000> rotate<0,0.000000,0> translate<3.394300,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.394300,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.333400,-1.535000,9.144000>}
box{<0,0,-0.127000><0.939100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.394300,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.394400,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.333300,0.000000,6.096000>}
box{<0,0,-0.127000><0.938900,0.035000,0.127000> rotate<0,0.000000,0> translate<3.394400,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.394400,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.333300,-1.535000,6.096000>}
box{<0,0,-0.127000><0.938900,0.035000,0.127000> rotate<0,0.000000,0> translate<3.394400,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.396900,-1.535000,29.066400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.051300,-1.535000,28.411900>}
box{<0,0,-0.127000><0.925532,0.035000,0.127000> rotate<0,45.001407,0> translate<3.396900,-1.535000,29.066400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<3.444300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<3.444300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.444300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<3.444300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.484100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.733400,0.000000,29.210000>}
box{<0,0,-0.127000><7.249300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.484100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.484200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,31.750000>}
box{<0,0,-0.127000><1.741800,0.035000,0.127000> rotate<0,0.000000,0> translate<3.484200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.484200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,31.750000>}
box{<0,0,-0.127000><1.741800,0.035000,0.127000> rotate<0,0.000000,0> translate<3.484200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,0.000000,6.210500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,6.630600>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<3.508900,0.000000,6.210500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,-1.535000,6.210500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,6.630600>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<3.508900,-1.535000,6.210500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,0.000000,9.029400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,8.609300>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<3.508900,0.000000,9.029400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.508900,-1.535000,9.029400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,8.609300>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<3.508900,-1.535000,9.029400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.566600,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.135700,0.000000,6.350000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.566600,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.566600,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.135700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.566600,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.566700,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.135800,0.000000,8.890000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.566700,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.566700,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.135800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<3.566700,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.589400,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650400,0.000000,29.464000>}
box{<0,0,-0.127000><8.061000,0.035000,0.127000> rotate<0,0.000000,0> translate<3.589400,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.589400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,31.496000>}
box{<0,0,-0.127000><1.636600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.589400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.589400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,31.496000>}
box{<0,0,-0.127000><1.636600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.589400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.602800,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,9.887100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<3.602800,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.602800,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,11.702800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<3.602800,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.604600,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.448000>}
box{<0,0,-0.127000><6.809400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.604600,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<3.606700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,29.718000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,29.969900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,90.000000,0> translate<3.606700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,29.969900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.608000,-1.535000,28.968600>}
box{<0,0,-0.127000><1.416052,0.035000,0.127000> rotate<0,44.997030,0> translate<3.606700,-1.535000,29.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,29.972000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,29.972000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,30.226000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,30.226000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,30.480000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,30.480000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,30.734000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,30.734000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,30.988000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,30.988000>}
box{<0,0,-0.127000><8.026500,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.855700,0.000000,31.242000>}
box{<0,0,-0.127000><4.249000,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.606700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.855700,-1.535000,31.242000>}
box{<0,0,-0.127000><4.249000,0.035000,0.127000> rotate<0,0.000000,0> translate<3.606700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.671800,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.030400,0.000000,6.604000>}
box{<0,0,-0.127000><0.358600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.671800,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.671800,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.030400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.358600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.671800,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.671900,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.030600,0.000000,8.636000>}
box{<0,0,-0.127000><0.358700,0.035000,0.127000> rotate<0,0.000000,0> translate<3.671900,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.671900,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.030600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.358700,0.035000,0.127000> rotate<0,0.000000,0> translate<3.671900,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,6.630600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.493000>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,90.000000,0> translate<3.682900,0.000000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,6.630600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.493000>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,90.000000,0> translate<3.682900,-1.535000,7.493000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,6.858000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,7.112000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,7.366000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,8.609300>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,90.000000,0> translate<3.682900,0.000000,8.609300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.746800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,8.609300>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,90.000000,0> translate<3.682900,-1.535000,8.609300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,7.874000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,8.128000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,8.382000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.682900,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.682900,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.743900,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.996800,-1.535000,3.227600>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,44.997030,0> translate<3.743900,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,9.887100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.668100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,90.000000,0> translate<3.825900,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.906000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,10.160000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,10.414000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,10.668000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,11.702800>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,90.000000,0> translate<3.825900,0.000000,11.702800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,10.922000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.176000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.430000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.825900,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.684000>}
box{<0,0,-0.127000><0.479400,0.035000,0.127000> rotate<0,0.000000,0> translate<3.825900,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,25.643700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.023700,0.000000,25.465200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<3.845200,0.000000,25.643700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,27.094000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.845200,0.000000,25.643700>}
box{<0,0,-0.127000><1.450300,0.035000,0.127000> rotate<0,-90.000000,0> translate<3.845200,0.000000,25.643700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.858600,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.508900,0.000000,28.194000>}
box{<0,0,-0.127000><6.650300,0.035000,0.127000> rotate<0,0.000000,0> translate<3.858600,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.858600,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,29.718000>}
box{<0,0,-0.127000><7.774600,0.035000,0.127000> rotate<0,0.000000,0> translate<3.858600,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.922400,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.207600,-1.535000,3.302000>}
box{<0,0,-0.127000><0.285200,0.035000,0.127000> rotate<0,0.000000,0> translate<3.922400,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<3.996800,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.065000,-1.535000,3.159400>}
box{<0,0,-0.127000><0.096449,0.035000,0.127000> rotate<0,44.997030,0> translate<3.996800,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<4.013200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<4.013200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.013200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.013200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<4.013200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.013200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<4.013200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.023700,0.000000,25.465200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,25.465200>}
box{<0,0,-0.127000><0.281600,0.035000,0.127000> rotate<0,0.000000,0> translate<4.023700,0.000000,25.465200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.051300,-1.535000,28.411900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.281900,-1.535000,28.181300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<4.051300,-1.535000,28.411900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.065000,-1.535000,3.159400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.216500,-1.535000,3.311000>}
box{<0,0,-0.127000><0.214324,0.035000,0.127000> rotate<0,-45.015932,0> translate<4.065000,-1.535000,3.159400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.082800,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.234400,-1.535000,1.751900>}
box{<0,0,-0.127000><0.214465,0.035000,0.127000> rotate<0,-45.015920,0> translate<4.082800,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.112600,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.781200,0.000000,27.940000>}
box{<0,0,-0.127000><2.668600,0.035000,0.127000> rotate<0,0.000000,0> translate<4.112600,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.112600,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650400,-1.535000,29.464000>}
box{<0,0,-0.127000><7.537800,0.035000,0.127000> rotate<0,0.000000,0> translate<4.112600,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<4.175600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<4.175600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.115800>}
box{<0,0,-0.127000><0.183353,0.035000,0.127000> rotate<0,-44.974935,0> translate<4.175600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.175600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<4.175600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.177900,0.000000,27.874700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.876200,0.000000,27.874700>}
box{<0,0,-0.127000><1.698300,0.035000,0.127000> rotate<0,0.000000,0> translate<4.177900,0.000000,27.874700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.216500,-1.535000,3.311000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.216600,-1.535000,3.311000>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,0.000000,0> translate<4.216500,-1.535000,3.311000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.216600,-1.535000,3.311000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386000,-1.535000,3.480500>}
box{<0,0,-0.127000><0.239638,0.035000,0.127000> rotate<0,-45.013935,0> translate<4.216600,-1.535000,3.311000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.234400,-1.535000,1.751900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.380000,-1.535000,1.606300>}
box{<0,0,-0.127000><0.205909,0.035000,0.127000> rotate<0,44.997030,0> translate<4.234400,-1.535000,1.751900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,13.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,13.224600>}
box{<0,0,-0.127000><0.078560,0.035000,0.127000> rotate<0,-45.048598,0> translate<4.249800,0.000000,13.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,15.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,15.875300>}
box{<0,0,-0.127000><0.078560,0.035000,0.127000> rotate<0,45.048598,0> translate<4.249800,0.000000,15.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,22.224600>}
box{<0,0,-0.127000><0.078560,0.035000,0.127000> rotate<0,-45.048598,0> translate<4.249800,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.249800,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,24.875300>}
box{<0,0,-0.127000><0.078560,0.035000,0.127000> rotate<0,45.048598,0> translate<4.249800,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.281900,-1.535000,28.181300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.514300,-1.535000,28.181300>}
box{<0,0,-0.127000><6.232400,0.035000,0.127000> rotate<0,0.000000,0> translate<4.281900,-1.535000,28.181300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.288700,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,13.208000>}
box{<0,0,-0.127000><0.016600,0.035000,0.127000> rotate<0,0.000000,0> translate<4.288700,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.288700,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,24.892000>}
box{<0,0,-0.127000><0.016600,0.035000,0.127000> rotate<0,0.000000,0> translate<4.288700,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.774900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,9.115800>}
box{<0,0,-0.127000><2.659100,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.305300,0.000000,9.115800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,13.224600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,11.774900>}
box{<0,0,-0.127000><1.449700,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.305300,0.000000,11.774900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,22.224600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,15.875300>}
box{<0,0,-0.127000><6.349300,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.305300,0.000000,15.875300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,25.465200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.305300,0.000000,24.875300>}
box{<0,0,-0.127000><0.589900,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.305300,0.000000,24.875300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.366600,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.733400,-1.535000,29.210000>}
box{<0,0,-0.127000><6.366800,0.035000,0.127000> rotate<0,0.000000,0> translate<4.366600,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.380000,-1.535000,1.606300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386000,-1.535000,1.600200>}
box{<0,0,-0.127000><0.008556,0.035000,0.127000> rotate<0,45.470507,0> translate<4.380000,-1.535000,1.606300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386000,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386100,-1.535000,1.600100>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,44.997030,0> translate<4.386000,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386000,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725100,-1.535000,3.480500>}
box{<0,0,-0.127000><0.339100,0.035000,0.127000> rotate<0,0.000000,0> translate<4.386000,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.386100,-1.535000,1.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.563100,-1.535000,1.600200>}
box{<0,0,-0.127000><0.177000,0.035000,0.127000> rotate<0,-0.032368,0> translate<4.386100,-1.535000,1.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<4.475700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<4.475700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.475700,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<4.475700,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.563100,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725000,-1.535000,1.600200>}
box{<0,0,-0.127000><0.161900,0.035000,0.127000> rotate<0,0.000000,0> translate<4.563100,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.608000,-1.535000,28.968600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.514300,-1.535000,28.968600>}
box{<0,0,-0.127000><5.906300,0.035000,0.127000> rotate<0,0.000000,0> translate<4.608000,-1.535000,28.968600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725000,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.082700,-1.535000,1.600200>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<4.725000,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725100,-1.535000,3.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725100,-1.535000,3.480500>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.725100,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.725100,-1.535000,3.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.902100,-1.535000,3.480500>}
box{<0,0,-0.127000><0.177000,0.035000,0.127000> rotate<0,0.032368,0> translate<4.725100,-1.535000,3.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,16.974000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,16.371900>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,67.495382,0> translate<4.761700,-1.535000,16.974000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,17.625900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,16.974000>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.761700,-1.535000,16.974000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,17.625900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,18.228000>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-67.495382,0> translate<4.761700,-1.535000,17.625900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,20.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,19.871900>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,67.495382,0> translate<4.761700,-1.535000,20.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,21.125900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,20.474000>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,-90.000000,0> translate<4.761700,-1.535000,20.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.761700,-1.535000,21.125900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,21.728000>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-67.495382,0> translate<4.761700,-1.535000,21.125900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<4.867700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<4.867700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.867700,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<4.867700,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<4.902100,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.082700,-1.535000,3.480500>}
box{<0,0,-0.127000><0.180600,0.035000,0.127000> rotate<0,0.000000,0> translate<4.902100,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,16.371900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,15.911100>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,44.997030,0> translate<5.011100,-1.535000,16.371900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,18.228000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,18.688800>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.011100,-1.535000,18.228000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,19.871900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,19.411100>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,44.997030,0> translate<5.011100,-1.535000,19.871900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.011100,-1.535000,21.728000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,22.188800>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.011100,-1.535000,21.728000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.082700,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.234200,-1.535000,1.751800>}
box{<0,0,-0.127000><0.214324,0.035000,0.127000> rotate<0,-45.015932,0> translate<5.082700,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.082700,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.319000,-1.535000,3.244100>}
box{<0,0,-0.127000><0.334249,0.035000,0.127000> rotate<0,45.009150,0> translate<5.082700,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,11.544300>}
box{<0,0,-0.127000><2.095600,0.035000,0.127000> rotate<0,90.000000,0> translate<5.092600,0.000000,11.544300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,0.000000,9.448700>}
box{<0,0,-0.127000><0.199600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.540500,0.000000,9.652000>}
box{<0,0,-0.127000><17.447900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.152900,0.000000,9.906000>}
box{<0,0,-0.127000><0.060300,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,10.160000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,10.414000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,10.668000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,10.922000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,11.176000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,11.430000>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,11.544300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,11.544300>}
box{<0,0,-0.127000><0.047600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,11.544300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,12.331600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,16.290500>}
box{<0,0,-0.127000><3.958900,0.035000,0.127000> rotate<0,90.000000,0> translate<5.092600,0.000000,16.290500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,12.331600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.234900,0.000000,12.331600>}
box{<0,0,-0.127000><4.142300,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,12.331600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.446000>}
box{<0,0,-0.127000><9.118700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.700000>}
box{<0,0,-0.127000><9.118700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.384300,0.000000,12.954000>}
box{<0,0,-0.127000><7.291700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.159900,0.000000,13.208000>}
box{<0,0,-0.127000><7.067300,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.741100,0.000000,13.462000>}
box{<0,0,-0.127000><1.648500,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,13.716000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,13.970000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.224000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.478000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,14.732000>}
box{<0,0,-0.127000><3.122000,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.986000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,15.240000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,15.494000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.865600,0.000000,15.748000>}
box{<0,0,-0.127000><0.773000,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.381000,0.000000,16.002000>}
box{<0,0,-0.127000><0.288400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.127000,0.000000,16.256000>}
box{<0,0,-0.127000><0.034400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,16.290500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,0.000000,15.911100>}
box{<0,0,-0.127000><0.536482,0.035000,0.127000> rotate<0,45.004582,0> translate<5.092600,0.000000,16.290500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,21.809400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,25.465200>}
box{<0,0,-0.127000><3.655800,0.035000,0.127000> rotate<0,90.000000,0> translate<5.092600,0.000000,25.465200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,21.809400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,0.000000,22.188800>}
box{<0,0,-0.127000><0.536482,0.035000,0.127000> rotate<0,-45.004582,0> translate<5.092600,0.000000,21.809400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.127200,0.000000,21.844000>}
box{<0,0,-0.127000><0.034600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.381200,0.000000,22.098000>}
box{<0,0,-0.127000><0.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.865900,0.000000,22.352000>}
box{<0,0,-0.127000><0.773300,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,22.606000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,22.860000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.114000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.368000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,23.622000>}
box{<0,0,-0.127000><3.122000,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.876000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,24.130000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,24.384000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,24.638000>}
box{<0,0,-0.127000><1.618400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.895200,0.000000,24.892000>}
box{<0,0,-0.127000><1.802600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.250000,0.000000,25.146000>}
box{<0,0,-0.127000><6.157400,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.781100,0.000000,25.400000>}
box{<0,0,-0.127000><1.688500,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.092600,0.000000,25.465200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.876200,0.000000,25.465200>}
box{<0,0,-0.127000><0.783600,0.035000,0.127000> rotate<0,0.000000,0> translate<5.092600,0.000000,25.465200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.318700,0.000000,9.740200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<5.140200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,11.544300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.140200,0.000000,9.918700>}
box{<0,0,-0.127000><1.625600,0.035000,0.127000> rotate<0,-90.000000,0> translate<5.140200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,0.000000,31.261000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<5.226000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,-1.535000,31.261000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<5.226000,-1.535000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,31.439500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<5.226000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,31.439500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<5.226000,-1.535000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,0.000000,33.508900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.226000,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.226000,-1.535000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,-1.535000,33.508900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.226000,-1.535000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.234200,-1.535000,1.751800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.385800,-1.535000,1.600200>}
box{<0,0,-0.127000><0.214395,0.035000,0.127000> rotate<0,44.997030,0> translate<5.234200,-1.535000,1.751800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.261200,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.376900,-1.535000,3.302000>}
box{<0,0,-0.127000><0.115700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.261200,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<5.292200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<5.292200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<5.292200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.292200,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<5.292200,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.318700,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.071200,0.000000,9.740200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<5.318700,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.319000,-1.535000,3.244100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.555300,-1.535000,3.480500>}
box{<0,0,-0.127000><0.334249,0.035000,0.127000> rotate<0,-45.009150,0> translate<5.319000,-1.535000,3.244100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.385800,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.063700,-1.535000,1.600200>}
box{<0,0,-0.127000><0.677900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.385800,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,0.000000,31.261000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.404500,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,-1.535000,31.261000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.404500,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,33.508900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<5.404500,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.404500,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,-1.535000,33.508900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.404500,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.414600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.301400,-1.535000,9.398000>}
box{<0,0,-0.127000><0.886800,0.035000,0.127000> rotate<0,0.000000,0> translate<5.414600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.414600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.285400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<5.414600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.414800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.285000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<5.414800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.414800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.285000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<5.414800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,0.000000,15.911100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,0.000000,15.661700>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,22.498679,0> translate<5.471900,0.000000,15.911100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,15.911100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,15.661700>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,22.498679,0> translate<5.471900,-1.535000,15.911100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,18.688800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,18.938200>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-22.498679,0> translate<5.471900,-1.535000,18.688800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,19.411100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,19.161700>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,22.498679,0> translate<5.471900,-1.535000,19.411100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,0.000000,22.188800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,0.000000,22.438200>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-22.498679,0> translate<5.471900,0.000000,22.188800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.471900,-1.535000,22.188800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,22.438200>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-22.498679,0> translate<5.471900,-1.535000,22.188800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.555300,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.894300,-1.535000,3.480500>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<5.555300,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.684200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.684200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.936900,-1.535000,9.033500>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,45.008364,0> translate<5.684200,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.684200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<5.684200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.826500,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.047400,-1.535000,9.144000>}
box{<0,0,-0.127000><0.220900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.826500,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.826500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.873400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<5.826500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.826600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.873300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.826600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.826600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.873300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<5.826600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.876200,0.000000,25.465200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,25.643700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.876200,0.000000,25.465200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.876200,0.000000,27.874700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,27.696200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<5.876200,0.000000,27.874700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.894300,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.894400,-1.535000,3.480600>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.894300,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.894400,-1.535000,3.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.075100,-1.535000,3.480500>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,0.031706,0> translate<5.894400,-1.535000,3.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.936900,-1.535000,9.033500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.647900,-1.535000,14.744600>}
box{<0,0,-0.127000><8.076644,0.035000,0.127000> rotate<0,-44.997532,0> translate<5.936900,-1.535000,9.033500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,34.453000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,33.508900>}
box{<0,0,-0.127000><0.944100,0.035000,0.127000> rotate<0,-90.000000,0> translate<5.956300,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.956300,0.000000,34.453000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.186900,0.000000,34.683600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<5.956300,0.000000,34.453000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<5.984300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<5.984300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<5.984300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<5.984300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.024100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.675700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.024100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.024100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.675700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.024100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.024200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.675800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.024200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,25.643700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,27.696200>}
box{<0,0,-0.127000><2.052500,0.035000,0.127000> rotate<0,90.000000,0> translate<6.054700,0.000000,27.696200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,25.654000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,25.908000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.162000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.416000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.622600,0.000000,26.670000>}
box{<0,0,-0.127000><1.567900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.924000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,27.178000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,27.432000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.054700,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,27.686000>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.054700,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.063700,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.421400,-1.535000,1.600200>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<6.063700,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,0.000000,15.661700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,15.661700>}
box{<0,0,-0.127000><0.637000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,0.000000,15.661700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,15.661700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,15.661700>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,-1.535000,15.661700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,18.938200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,18.938200>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,-1.535000,18.938200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,19.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,19.161700>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,-1.535000,19.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,0.000000,22.438200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,22.438200>}
box{<0,0,-0.127000><0.637000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,0.000000,22.438200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.074000,-1.535000,22.438200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,22.438200>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.074000,-1.535000,22.438200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.075100,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.252000,-1.535000,3.480500>}
box{<0,0,-0.127000><0.176900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.075100,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.129400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.570400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.129400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.129400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.570400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.129400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.129400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.570600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<6.129400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,8.130000>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,90.000000,0> translate<6.146700,-1.535000,8.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<6.146700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,-1.535000,8.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,8.536600>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<6.146700,-1.535000,8.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.146700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<6.146700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.186900,0.000000,34.683600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.513000,0.000000,34.683600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<6.186900,0.000000,34.683600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.252000,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.252100,-1.535000,3.480400>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,44.997030,0> translate<6.252000,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.252100,-1.535000,3.480400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.258200,-1.535000,3.474200>}
box{<0,0,-0.127000><0.008698,0.035000,0.127000> rotate<0,45.462809,0> translate<6.252100,-1.535000,3.480400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.258200,-1.535000,3.474200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.504900,-1.535000,3.227600>}
box{<0,0,-0.127000><0.348816,0.035000,0.127000> rotate<0,44.985416,0> translate<6.258200,-1.535000,3.474200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.398600,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.154600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.398600,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.421400,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,1.853100>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<6.421400,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.429400,-1.535000,2.455600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674200,-1.535000,2.700300>}
box{<0,0,-0.127000><0.346129,0.035000,0.127000> rotate<0,-44.985326,0> translate<6.429400,-1.535000,2.455600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.429400,-1.535000,2.455600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,2.210800>}
box{<0,0,-0.127000><0.346270,0.035000,0.127000> rotate<0,44.985331,0> translate<6.429400,-1.535000,2.455600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.430500,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.715400,-1.535000,3.302000>}
box{<0,0,-0.127000><1.284900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.430500,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.504900,-1.535000,3.227500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.504900,-1.535000,3.227600>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,90.000000,0> translate<6.504900,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.504900,-1.535000,3.227500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674400,-1.535000,3.058000>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,44.997030,0> translate<6.504900,-1.535000,3.227500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.513000,0.000000,34.683600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.959000,0.000000,34.683600>}
box{<0,0,-0.127000><12.446000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.513000,0.000000,34.683600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.513800,-1.535000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.631400,-1.535000,2.540000>}
box{<0,0,-0.127000><1.117600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.513800,-1.535000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<6.553200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<6.553200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,8.536600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.553200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.553200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.553200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<6.553200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,25.612100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.792100,0.000000,25.389000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<6.569000,0.000000,25.612100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.543100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,25.612100>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.569000,0.000000,25.612100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.543100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.622600,0.000000,26.543100>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.569000,0.000000,26.543100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.796700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.622600,0.000000,26.796700>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.569000,0.000000,26.796700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,27.727800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,26.796700>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.569000,0.000000,26.796700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.569000,0.000000,27.727800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.792100,0.000000,27.950900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<6.569000,0.000000,27.727800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.599100,-1.535000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471400,-1.535000,2.286000>}
box{<0,0,-0.127000><0.872300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.599100,-1.535000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.599200,-1.535000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.716000,-1.535000,1.778000>}
box{<0,0,-0.127000><1.116800,0.035000,0.127000> rotate<0,0.000000,0> translate<6.599200,-1.535000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674200,-1.535000,2.700300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674400,-1.535000,3.058000>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,-89.962027,0> translate<6.674200,-1.535000,2.700300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674200,-1.535000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,2.794000>}
box{<0,0,-0.127000><0.797300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.674200,-1.535000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,1.853100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,2.210800>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,90.000000,0> translate<6.674300,-1.535000,2.210800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,2.032000>}
box{<0,0,-0.127000><0.797200,0.035000,0.127000> rotate<0,0.000000,0> translate<6.674300,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.674300,-1.535000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,3.048000>}
box{<0,0,-0.127000><0.797200,0.035000,0.127000> rotate<0,0.000000,0> translate<6.674300,-1.535000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,13.492100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934100,0.000000,13.269000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<6.711000,0.000000,13.492100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.523100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,13.492100>}
box{<0,0,-0.127000><1.031000,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.711000,0.000000,13.492100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.523100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,14.523100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.711000,0.000000,14.523100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.776700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,14.776700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.711000,0.000000,14.776700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,15.661700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,14.776700>}
box{<0,0,-0.127000><0.885000,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.711000,0.000000,14.776700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,22.438200>}
box{<0,0,-0.127000><0.984900,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.711000,0.000000,22.438200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,23.423100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.711000,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,23.676700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.711000,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,24.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,23.676700>}
box{<0,0,-0.127000><1.031100,0.035000,0.127000> rotate<0,-90.000000,0> translate<6.711000,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.711000,0.000000,24.707800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934100,0.000000,24.930900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<6.711000,0.000000,24.707800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<6.715600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<6.715600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.715600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<6.715600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,15.661700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,15.911100>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-22.498679,0> translate<6.725900,-1.535000,15.661700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,18.938200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,18.688800>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,22.498679,0> translate<6.725900,-1.535000,18.938200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,19.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,19.411100>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-22.498679,0> translate<6.725900,-1.535000,19.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.725900,-1.535000,22.438200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,22.188800>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,22.498679,0> translate<6.725900,-1.535000,22.438200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.896300>}
box{<0,0,-0.127000><0.387400,0.035000,0.127000> rotate<0,90.000000,0> translate<6.743600,0.000000,33.896300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,0.000000,33.508900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<6.743600,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.855800,0.000000,33.528000>}
box{<0,0,-0.127000><1.112200,0.035000,0.127000> rotate<0,0.000000,0> translate<6.743600,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.782000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.747200,0.000000,33.782000>}
box{<0,0,-0.127000><12.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<6.743600,0.000000,33.782000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.743600,0.000000,33.896300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.632900,0.000000,33.896300>}
box{<0,0,-0.127000><11.889300,0.035000,0.127000> rotate<0,0.000000,0> translate<6.743600,0.000000,33.896300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.792100,0.000000,25.389000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,25.389000>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.792100,0.000000,25.389000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.792100,0.000000,27.950900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.950900>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.792100,0.000000,27.950900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934100,0.000000,13.269000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,13.269000>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.934100,0.000000,13.269000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934100,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,-1.535000,22.352000>}
box{<0,0,-0.127000><3.352900,0.035000,0.127000> rotate<0,0.000000,0> translate<6.934100,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934100,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.930900>}
box{<0,0,-0.127000><1.281000,0.035000,0.127000> rotate<0,0.000000,0> translate<6.934100,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<6.934200,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.748000>}
box{<0,0,-0.127000><9.079800,0.035000,0.127000> rotate<0,0.000000,0> translate<6.934200,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<7.015700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<7.015700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.015700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<7.015700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.069200,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.996300,-1.535000,18.796000>}
box{<0,0,-0.127000><5.927100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.069200,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.069400,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.996500,-1.535000,19.304000>}
box{<0,0,-0.127000><5.927100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.069400,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.071200,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.249700,0.000000,9.918700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.071200,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.237000,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.732900,0.000000,9.906000>}
box{<0,0,-0.127000><0.495900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.237000,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.249700,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.249700,0.000000,10.401300>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<7.249700,0.000000,10.401300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.249700,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.720200,0.000000,10.160000>}
box{<0,0,-0.127000><0.470500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.249700,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.249700,0.000000,10.401300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.720200,0.000000,10.401300>}
box{<0,0,-0.127000><0.470500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.249700,0.000000,10.401300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.295400,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.295400,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<7.295400,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.295400,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<7.295400,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,15.911100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,16.371900>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.328000,-1.535000,15.911100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,18.688800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,18.228000>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,44.997030,0> translate<7.328000,-1.535000,18.688800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,19.411100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,19.871900>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.328000,-1.535000,19.411100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.328000,-1.535000,22.188800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,21.728000>}
box{<0,0,-0.127000><0.651670,0.035000,0.127000> rotate<0,44.997030,0> translate<7.328000,-1.535000,22.188800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.347700,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,0.000000,21.728000>}
box{<0,0,-0.127000><0.623739,0.035000,0.127000> rotate<0,44.990535,0> translate<7.347700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.347700,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,22.169000>}
box{<0,0,-0.127000><0.867400,0.035000,0.127000> rotate<0,0.000000,0> translate<7.347700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.407700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.407700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.407700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.407700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.418800,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.590400,-1.535000,22.098000>}
box{<0,0,-0.127000><2.171600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.418800,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.418800,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.590500,0.000000,22.098000>}
box{<0,0,-0.127000><2.171700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.418800,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.418900,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017600,-1.535000,16.002000>}
box{<0,0,-0.127000><9.598700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.418900,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.447700,0.000000,16.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,0.000000,16.371900>}
box{<0,0,-0.127000><0.482318,0.035000,0.127000> rotate<0,-44.988631,0> translate<7.447700,0.000000,16.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.447700,0.000000,16.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,16.030900>}
box{<0,0,-0.127000><0.767400,0.035000,0.127000> rotate<0,0.000000,0> translate<7.447700,0.000000,16.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.465300,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,-1.535000,9.448700>}
box{<0,0,-0.127000><0.366900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.465300,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.465300,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.974000,-1.535000,13.957300>}
box{<0,0,-0.127000><6.376194,0.035000,0.127000> rotate<0,-44.996395,0> translate<7.465300,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471400,-1.535000,2.380100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471600,-1.535000,2.022400>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,89.962027,0> translate<7.471400,-1.535000,2.380100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471400,-1.535000,2.380100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.631700,-1.535000,2.540300>}
box{<0,0,-0.127000><0.226628,0.035000,0.127000> rotate<0,-44.979154,0> translate<7.471400,-1.535000,2.380100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,2.700400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.631700,-1.535000,2.540300>}
box{<0,0,-0.127000><0.226486,0.035000,0.127000> rotate<0,44.979143,0> translate<7.471500,-1.535000,2.700400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,3.058100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,2.700400>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.471500,-1.535000,2.700400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471500,-1.535000,3.058100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.641000,-1.535000,3.227600>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.471500,-1.535000,3.058100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.471600,-1.535000,2.022400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.894000,-1.535000,1.600100>}
box{<0,0,-0.127000><0.597293,0.035000,0.127000> rotate<0,44.990248,0> translate<7.471600,-1.535000,2.022400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<7.473900,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<7.473900,-1.535000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,31.496000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,31.496000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,31.750000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.004000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.004000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,0.000000,32.258000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,-1.535000,32.258000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.512000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.512000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.766000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.766000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,33.020000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,33.020000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,33.274000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.473900,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,33.274000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.473900,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.474800,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.146300,-1.535000,18.542000>}
box{<0,0,-0.127000><5.671500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.474800,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.474900,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.146400,-1.535000,19.558000>}
box{<0,0,-0.127000><5.671500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.474900,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.622600,0.000000,26.796700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.622600,0.000000,26.543100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.622600,0.000000,26.543100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,25.389000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.542600>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,90.000000,0> translate<7.623100,0.000000,26.542600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,25.400000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,25.654000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,25.908000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.162000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.416000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.542600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.542600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,26.542600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.797300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.950900>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,90.000000,0> translate<7.623100,0.000000,27.950900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.797300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.797300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,26.797300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.924000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.178000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.432000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.686000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.623100,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.940000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.623100,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.641000,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.893900,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.641000,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.668600,-1.535000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.207200,-1.535000,9.652000>}
box{<0,0,-0.127000><8.538600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.668600,-1.535000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.672800,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.256000>}
box{<0,0,-0.127000><5.451200,0.035000,0.127000> rotate<0,0.000000,0> translate<7.672800,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.672800,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.440500,0.000000,21.844000>}
box{<0,0,-0.127000><1.767700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.672800,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.672800,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.440500,-1.535000,21.844000>}
box{<0,0,-0.127000><1.767700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.672800,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.672900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.256000>}
box{<0,0,-0.127000><8.341100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.672900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,0.000000,31.184800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<7.689800,0.000000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,-1.535000,31.184800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<7.689800,-1.535000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,31.407900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.689800,0.000000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,31.407900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.689800,-1.535000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,0.000000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.689800,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,-1.535000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.689800,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,0.000000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.689800,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,-1.535000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<7.689800,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,32.511800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.689800,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,32.511800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.689800,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,0.000000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,0.000000,33.585100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.689800,0.000000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.689800,-1.535000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,-1.535000,33.585100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<7.689800,-1.535000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.720200,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.898700,0.000000,9.740200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<7.720200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.720200,0.000000,10.401300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.720200,0.000000,9.918700>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.720200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.728800,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,-1.535000,18.288000>}
box{<0,0,-0.127000><5.835500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.728800,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.728900,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.921400,-1.535000,19.812000>}
box{<0,0,-0.127000><6.192500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.728900,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,0.000000,16.371900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.974000,0.000000,16.819000>}
box{<0,0,-0.127000><0.483940,0.035000,0.127000> rotate<0,-67.494986,0> translate<7.788800,0.000000,16.371900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,16.371900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,16.974000>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-67.495382,0> translate<7.788800,-1.535000,16.371900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,18.228000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,17.625900>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,67.495382,0> translate<7.788800,-1.535000,18.228000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,19.871900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,20.474000>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,-67.495382,0> translate<7.788800,-1.535000,19.871900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,0.000000,21.728000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.005500,0.000000,21.204700>}
box{<0,0,-0.127000><0.566394,0.035000,0.127000> rotate<0,67.500962,0> translate<7.788800,0.000000,21.728000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.788800,-1.535000,21.728000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,21.125900>}
box{<0,0,-0.127000><0.651709,0.035000,0.127000> rotate<0,67.495382,0> translate<7.788800,-1.535000,21.728000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<7.832200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<7.832200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<7.832200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.832200,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<7.832200,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.846000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568800,0.000000,16.510000>}
box{<0,0,-0.127000><6.722800,0.035000,0.127000> rotate<0,0.000000,0> translate<7.846000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.846000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.510000>}
box{<0,0,-0.127000><8.168000,0.035000,0.127000> rotate<0,0.000000,0> translate<7.846000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.846000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,0.000000,21.590000>}
box{<0,0,-0.127000><1.552000,0.035000,0.127000> rotate<0,0.000000,0> translate<7.846000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.846000,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,-1.535000,21.590000>}
box{<0,0,-0.127000><1.552000,0.035000,0.127000> rotate<0,0.000000,0> translate<7.846000,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.869100,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.175400,-1.535000,20.066000>}
box{<0,0,-0.127000><6.306300,0.035000,0.127000> rotate<0,0.000000,0> translate<7.869100,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.869200,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.161100,-1.535000,18.034000>}
box{<0,0,-0.127000><12.291900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.869200,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,25.389000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.707800,0.000000,25.389000>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.876700,0.000000,25.389000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.542600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,25.389000>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.876700,0.000000,25.389000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.950900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,26.797300>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,-90.000000,0> translate<7.876700,0.000000,26.797300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.876700,0.000000,27.950900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.707800,0.000000,27.950900>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.876700,0.000000,27.950900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.877300,0.000000,26.543100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.877300,0.000000,26.796700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<7.877300,0.000000,26.796700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.877300,0.000000,26.543100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.543100>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.877300,0.000000,26.543100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.877300,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.166200,0.000000,26.670000>}
box{<0,0,-0.127000><3.288900,0.035000,0.127000> rotate<0,0.000000,0> translate<7.877300,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.877300,0.000000,26.796700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.796700>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.877300,0.000000,26.796700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.893900,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.232900,-1.535000,3.480500>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<7.893900,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.894000,-1.535000,1.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.074700,-1.535000,1.600200>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,-0.031706,0> translate<7.894000,-1.535000,1.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.898700,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.451200,0.000000,9.740200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<7.898700,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,31.184800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.912900,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,31.184800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.912900,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,33.585100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.912900,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.912900,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,33.585100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.912900,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.922600,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.953200,-1.535000,9.906000>}
box{<0,0,-0.127000><8.030600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.922600,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.951200,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.764000>}
box{<0,0,-0.127000><5.172800,0.035000,0.127000> rotate<0,0.000000,0> translate<7.951200,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.951200,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.764000>}
box{<0,0,-0.127000><8.062800,0.035000,0.127000> rotate<0,0.000000,0> translate<7.951200,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.951200,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.349400,0.000000,21.336000>}
box{<0,0,-0.127000><1.398200,0.035000,0.127000> rotate<0,0.000000,0> translate<7.951200,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.951200,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.440300,-1.535000,21.336000>}
box{<0,0,-0.127000><1.489100,0.035000,0.127000> rotate<0,0.000000,0> translate<7.951200,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.954600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.825400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<7.954600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.954600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.825400,-1.535000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<7.954600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.954800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.825000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<7.954800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.954800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.825000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<7.954800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.974000,0.000000,16.819000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,16.819000>}
box{<0,0,-0.127000><1.275400,0.035000,0.127000> rotate<0,0.000000,0> translate<7.974000,0.000000,16.819000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.974400,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.780000>}
box{<0,0,-0.127000><12.091600,0.035000,0.127000> rotate<0,0.000000,0> translate<7.974400,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<7.974400,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.429400,-1.535000,20.320000>}
box{<0,0,-0.127000><6.455000,0.035000,0.127000> rotate<0,0.000000,0> translate<7.974400,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.005500,0.000000,21.204700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.218100,0.000000,21.204700>}
box{<0,0,-0.127000><1.212600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.005500,0.000000,21.204700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,16.974000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,17.625900>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,90.000000,0> translate<8.038200,-1.535000,17.625900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.134200,-1.535000,17.018000>}
box{<0,0,-0.127000><8.096000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.160900,-1.535000,17.272000>}
box{<0,0,-0.127000><12.122700,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.526000>}
box{<0,0,-0.127000><12.027800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,20.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,21.125900>}
box{<0,0,-0.127000><0.651900,0.035000,0.127000> rotate<0,90.000000,0> translate<8.038200,-1.535000,21.125900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.683400,-1.535000,20.574000>}
box{<0,0,-0.127000><6.645200,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,-1.535000,20.828000>}
box{<0,0,-0.127000><1.970100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.038200,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.590300,-1.535000,21.082000>}
box{<0,0,-0.127000><1.552100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.038200,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.074700,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590600,-1.535000,1.600200>}
box{<0,0,-0.127000><0.515900,0.035000,0.127000> rotate<0,0.000000,0> translate<8.074700,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.176600,-1.535000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.699200,-1.535000,10.160000>}
box{<0,0,-0.127000><7.522600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.176600,-1.535000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,14.776700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,14.523100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.214600,0.000000,14.523100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.214600,0.000000,23.423100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.214600,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,13.269000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.522600>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.215100,0.000000,14.522600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,13.462000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,13.716000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,13.970000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.224000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.478000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.522600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.522600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,14.522600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.777300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,16.030900>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.215100,0.000000,16.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.777300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.777300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,14.777300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.986000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,15.240000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,15.494000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,15.748000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,16.002000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.422600>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.215100,0.000000,23.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,22.352000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,22.606000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,22.860000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.114000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.368000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.422600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,23.422600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.930900>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.215100,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.677300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.677300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,23.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.215100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.892000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.215100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.224200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.224200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<8.224200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.224200,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<8.224200,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.232900,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.233000,-1.535000,3.480600>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.232900,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.233000,-1.535000,3.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.413700,-1.535000,3.480500>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,0.031706,0> translate<8.233000,-1.535000,3.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.366500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<8.366500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.366500,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413400,-1.535000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<8.366500,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.366600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<8.366600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.366600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<8.366600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.413700,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590600,-1.535000,3.480500>}
box{<0,0,-0.127000><0.176900,0.035000,0.127000> rotate<0,0.000000,0> translate<8.413700,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.430600,-1.535000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.445200,-1.535000,10.414000>}
box{<0,0,-0.127000><7.014600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.430600,-1.535000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,13.269000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,13.269000>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.468700,0.000000,13.269000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.522600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,13.269000>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.468700,0.000000,13.269000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,16.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,14.777300>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.468700,0.000000,14.777300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,16.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,16.030900>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.468700,0.000000,16.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,22.169000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.661500,0.000000,22.169000>}
box{<0,0,-0.127000><1.192800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.468700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.422600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,22.169000>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.468700,0.000000,22.169000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,23.677300>}
box{<0,0,-0.127000><1.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.468700,0.000000,23.677300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.468700,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,24.930900>}
box{<0,0,-0.127000><1.281100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.468700,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,14.523100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,14.776700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.469300,0.000000,14.776700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,14.523100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.523100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,14.523100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,14.732000>}
box{<0,0,-0.127000><3.964000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,14.776700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.776700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,14.776700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,23.676700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<8.469300,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,23.423100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.423100>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.996300,0.000000,23.622000>}
box{<0,0,-0.127000><4.527000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.469300,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.676700>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.469300,0.000000,23.676700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<8.524300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<8.524300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<8.524300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.524300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<8.524300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.564100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.215700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.564100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.564100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.215700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.564100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.564200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.215800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.564200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.564200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.215800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.564200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590600,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.731100,-1.535000,1.740700>}
box{<0,0,-0.127000><0.198697,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.590600,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590600,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590700,-1.535000,3.480400>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,44.997030,0> translate<8.590600,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.590700,-1.535000,3.480400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.596800,-1.535000,3.474200>}
box{<0,0,-0.127000><0.008698,0.035000,0.127000> rotate<0,45.462809,0> translate<8.590700,-1.535000,3.480400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.596800,-1.535000,3.474200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.742200,-1.535000,3.328900>}
box{<0,0,-0.127000><0.205556,0.035000,0.127000> rotate<0,44.977322,0> translate<8.596800,-1.535000,3.474200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.669400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.110400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.669400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.669400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.110400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.669400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.669400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.110600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<8.669400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.669400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.110600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<8.669400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.684600,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.191200,-1.535000,10.668000>}
box{<0,0,-0.127000><6.506600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.684600,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<8.686700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<8.686700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.686700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<8.686700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.707800,0.000000,25.389000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,25.612100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<8.707800,0.000000,25.389000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.707800,0.000000,27.950900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,27.727800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<8.707800,0.000000,27.950900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.718700,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.733300,0.000000,27.940000>}
box{<0,0,-0.127000><2.014600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.718700,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.718800,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.166100,0.000000,25.400000>}
box{<0,0,-0.127000><2.447300,0.035000,0.127000> rotate<0,0.000000,0> translate<8.718800,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.731100,-1.535000,1.740700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.797600,-1.535000,1.696300>}
box{<0,0,-0.127000><0.079960,0.035000,0.127000> rotate<0,33.727589,0> translate<8.731100,-1.535000,1.740700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.742200,-1.535000,3.328900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.893700,-1.535000,3.480500>}
box{<0,0,-0.127000><0.214324,0.035000,0.127000> rotate<0,-45.015932,0> translate<8.742200,-1.535000,3.328900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,0.000000,32.258000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.762500,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.762500,-1.535000,32.258000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<8.762500,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.257500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<8.763000,0.000000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.257500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<8.763000,-1.535000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,31.242000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,31.242000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,31.496000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,31.496000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,31.750000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.004000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.004000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.257500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.257500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,33.585100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<8.763000,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,33.585100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<8.763000,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.512400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.512400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.766000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.766000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,33.020000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,33.020000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,33.274000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,33.274000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,33.528000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.763000,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,33.528000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<8.763000,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.797600,-1.535000,1.696300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.893700,-1.535000,1.600200>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<8.797600,-1.535000,1.696300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.893700,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.941800,-1.535000,1.600200>}
box{<0,0,-0.127000><0.048100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.893700,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.893700,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251400,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<8.893700,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,25.612100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.543100>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,90.000000,0> translate<8.930900,0.000000,26.543100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.654000>}
box{<0,0,-0.127000><2.158100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.908000>}
box{<0,0,-0.127000><2.158100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.162000>}
box{<0,0,-0.127000><2.158100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.416000>}
box{<0,0,-0.127000><2.158100,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.796700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,27.727800>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,90.000000,0> translate<8.930900,0.000000,27.727800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.249900,0.000000,26.924000>}
box{<0,0,-0.127000><2.319000,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.178000>}
box{<0,0,-0.127000><2.234300,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.432000>}
box{<0,0,-0.127000><2.234300,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.930900,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.686000>}
box{<0,0,-0.127000><2.234300,0.035000,0.127000> rotate<0,0.000000,0> translate<8.930900,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.938600,-1.535000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.937200,-1.535000,10.922000>}
box{<0,0,-0.127000><5.998600,0.035000,0.127000> rotate<0,0.000000,0> translate<8.938600,-1.535000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.941800,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.981800,-1.535000,1.573500>}
box{<0,0,-0.127000><0.048093,0.035000,0.127000> rotate<0,33.720884,0> translate<8.941800,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<8.981800,-1.535000,1.573500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.115400,-1.535000,1.600200>}
box{<0,0,-0.127000><0.136242,0.035000,0.127000> rotate<0,-11.300939,0> translate<8.981800,-1.535000,1.573500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,0.000000,31.184800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.016800,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,-1.535000,31.184800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.016800,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,31.184800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.016800,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,31.184800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.016800,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,32.512400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.016800,0.000000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,32.512400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.016800,-1.535000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,0.000000,33.585100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.016800,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.016800,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,-1.535000,33.585100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.016800,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,0.000000,32.511800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<9.017400,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,-1.535000,32.511800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<9.017400,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365400,0.000000,32.258000>}
box{<0,0,-0.127000><3.348000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365400,-1.535000,32.258000>}
box{<0,0,-0.127000><3.348000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.017400,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.017400,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<9.093200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<9.093200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.093200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.093200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<9.093200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.093200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<9.093200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.115400,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251400,-1.535000,1.600200>}
box{<0,0,-0.127000><0.136000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.115400,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.192600,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.683200,-1.535000,11.176000>}
box{<0,0,-0.127000><5.490600,0.035000,0.127000> rotate<0,0.000000,0> translate<9.192600,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.218100,0.000000,21.204700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413800,0.000000,21.400400>}
box{<0,0,-0.127000><0.276762,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.218100,0.000000,21.204700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.234900,0.000000,12.331600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.561000,0.000000,12.331600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<9.234900,0.000000,12.331600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,16.819000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,17.448900>}
box{<0,0,-0.127000><0.629900,0.035000,0.127000> rotate<0,90.000000,0> translate<9.249400,0.000000,17.448900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,17.018000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.249400,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,17.272000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.249400,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.249400,0.000000,17.448900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,17.448900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.249400,0.000000,17.448900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,16.819000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.657800,0.000000,16.819000>}
box{<0,0,-0.127000><1.407400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.250400,0.000000,16.819000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,17.448900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.250400,0.000000,16.819000>}
box{<0,0,-0.127000><0.629900,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.250400,0.000000,16.819000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251000,0.000000,17.449400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251000,0.000000,17.450400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<9.251000,0.000000,17.450400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251000,0.000000,17.449400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.449400>}
box{<0,0,-0.127000><1.629900,0.035000,0.127000> rotate<0,0.000000,0> translate<9.251000,0.000000,17.449400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251000,0.000000,17.450400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.450400>}
box{<0,0,-0.127000><1.629900,0.035000,0.127000> rotate<0,0.000000,0> translate<9.251000,0.000000,17.450400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251400,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.285300,-1.535000,1.634200>}
box{<0,0,-0.127000><0.048013,0.035000,0.127000> rotate<0,-45.081407,0> translate<9.251400,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.251400,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.411500,-1.535000,3.320300>}
box{<0,0,-0.127000><0.226486,0.035000,0.127000> rotate<0,45.014917,0> translate<9.251400,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<9.255600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<9.255600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.255600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.255600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.255600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.285300,-1.535000,1.634200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.332600,-1.535000,1.643600>}
box{<0,0,-0.127000><0.048225,0.035000,0.127000> rotate<0,-11.239289,0> translate<9.285300,-1.535000,1.634200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.332600,-1.535000,1.643600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.408200,-1.535000,1.757000>}
box{<0,0,-0.127000><0.136290,0.035000,0.127000> rotate<0,-56.306216,0> translate<9.332600,-1.535000,1.643600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,0.000000,21.438300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.413800,0.000000,21.400400>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<9.398000,0.000000,21.438300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,-1.535000,21.438300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,-1.535000,21.158300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<9.398000,-1.535000,21.438300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,0.000000,21.741600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,0.000000,21.438300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.398000,0.000000,21.438300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,-1.535000,21.741600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,-1.535000,21.438300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<9.398000,-1.535000,21.438300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,0.000000,21.741600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,0.000000,22.021600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<9.398000,0.000000,21.741600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.398000,-1.535000,21.741600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,-1.535000,22.021600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<9.398000,-1.535000,21.741600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.408200,-1.535000,1.757000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.411500,-1.535000,1.760400>}
box{<0,0,-0.127000><0.004738,0.035000,0.127000> rotate<0,-45.852071,0> translate<9.408200,-1.535000,1.757000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.411500,-1.535000,1.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.571600,-1.535000,1.600200>}
box{<0,0,-0.127000><0.226486,0.035000,0.127000> rotate<0,45.014917,0> translate<9.411500,-1.535000,1.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.411500,-1.535000,3.320300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.414800,-1.535000,3.323700>}
box{<0,0,-0.127000><0.004738,0.035000,0.127000> rotate<0,-45.852071,0> translate<9.411500,-1.535000,3.320300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.414800,-1.535000,3.323700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.490400,-1.535000,3.437100>}
box{<0,0,-0.127000><0.136290,0.035000,0.127000> rotate<0,-56.306216,0> translate<9.414800,-1.535000,3.323700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.446600,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.429200,-1.535000,11.430000>}
box{<0,0,-0.127000><4.982600,0.035000,0.127000> rotate<0,0.000000,0> translate<9.446600,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.451200,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.524900,0.000000,9.814000>}
box{<0,0,-0.127000><0.104298,0.035000,0.127000> rotate<0,-45.035872,0> translate<9.451200,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.490400,-1.535000,3.437100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.537700,-1.535000,3.446500>}
box{<0,0,-0.127000><0.048225,0.035000,0.127000> rotate<0,-11.239289,0> translate<9.490400,-1.535000,3.437100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,-1.535000,21.158300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.728300,-1.535000,20.944000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<9.514000,-1.535000,21.158300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,0.000000,22.021600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.661500,0.000000,22.169000>}
box{<0,0,-0.127000><0.208526,0.035000,0.127000> rotate<0,-44.977603,0> translate<9.514000,0.000000,22.021600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.514000,-1.535000,22.021600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.728300,-1.535000,22.235900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.514000,-1.535000,22.021600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.524900,0.000000,9.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.598700,0.000000,9.740200>}
box{<0,0,-0.127000><0.104369,0.035000,0.127000> rotate<0,44.997030,0> translate<9.524900,0.000000,9.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.537700,-1.535000,3.446500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.571600,-1.535000,3.480500>}
box{<0,0,-0.127000><0.048013,0.035000,0.127000> rotate<0,-45.081407,0> translate<9.537700,-1.535000,3.446500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<9.555700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<9.555700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<9.555700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.555700,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<9.555700,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.561000,0.000000,12.331600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.042900,0.000000,11.849700>}
box{<0,0,-0.127000><0.681510,0.035000,0.127000> rotate<0,44.997030,0> translate<9.561000,0.000000,12.331600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.571600,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.929300,-1.535000,1.600200>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.571600,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.571600,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.707600,-1.535000,3.480500>}
box{<0,0,-0.127000><0.136000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.571600,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.598700,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.151200,0.000000,9.740200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.598700,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.700600,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.175200,-1.535000,11.684000>}
box{<0,0,-0.127000><4.474600,0.035000,0.127000> rotate<0,0.000000,0> translate<9.700600,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.700600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.192000>}
box{<0,0,-0.127000><4.510700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.700600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.707600,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.841200,-1.535000,3.507200>}
box{<0,0,-0.127000><0.136242,0.035000,0.127000> rotate<0,-11.300939,0> translate<9.707600,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.728300,-1.535000,20.944000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,-1.535000,20.828000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<9.728300,-1.535000,20.944000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.728300,-1.535000,22.235900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,-1.535000,22.351900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<9.728300,-1.535000,22.235900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,13.269000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,13.492100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.749800,0.000000,13.269000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,16.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,15.807800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<9.749800,0.000000,16.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.749800,0.000000,24.930900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,24.707800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<9.749800,0.000000,24.930900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.778700,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.149100,0.000000,16.002000>}
box{<0,0,-0.127000><3.370400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.778700,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.788700,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.892000>}
box{<0,0,-0.127000><1.376500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.788700,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.841200,-1.535000,3.507200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.881200,-1.535000,3.480500>}
box{<0,0,-0.127000><0.048093,0.035000,0.127000> rotate<0,33.720884,0> translate<9.841200,-1.535000,3.507200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,31.407900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.867000,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,31.407900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<9.867000,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,33.362000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<9.867000,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.867000,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,33.362000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<9.867000,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.879000,0.000000,22.298300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,22.392100>}
box{<0,0,-0.127000><0.132724,0.035000,0.127000> rotate<0,-44.966507,0> translate<9.879000,0.000000,22.298300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.879000,0.000000,22.298300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,0.000000,22.351900>}
box{<0,0,-0.127000><0.139969,0.035000,0.127000> rotate<0,-22.514468,0> translate<9.879000,0.000000,22.298300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.881200,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.929300,-1.535000,3.480500>}
box{<0,0,-0.127000><0.048100,0.035000,0.127000> rotate<0,0.000000,0> translate<9.881200,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.924100,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.001200,0.000000,33.528000>}
box{<0,0,-0.127000><9.077100,0.035000,0.127000> rotate<0,0.000000,0> translate<9.924100,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.924100,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.751400,-1.535000,33.528000>}
box{<0,0,-0.127000><40.827300,0.035000,0.127000> rotate<0,0.000000,0> translate<9.924100,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.924200,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,31.242000>}
box{<0,0,-0.127000><1.709000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.924200,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.924200,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,31.242000>}
box{<0,0,-0.127000><1.709000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.924200,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.929300,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.080900,-1.535000,1.751900>}
box{<0,0,-0.127000><0.214465,0.035000,0.127000> rotate<0,-45.015920,0> translate<9.929300,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.929300,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.025400,-1.535000,3.384400>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<9.929300,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.932700,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,0.000000,22.352000>}
box{<0,0,-0.127000><0.354300,0.035000,0.127000> rotate<0,0.000000,0> translate<9.932700,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.942800,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.462000>}
box{<0,0,-0.127000><2.122200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.942800,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.947700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.947700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.947700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.947700,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.947700,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.954600,-1.535000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.921200,-1.535000,11.938000>}
box{<0,0,-0.127000><3.966600,0.035000,0.127000> rotate<0,0.000000,0> translate<9.954600,-1.535000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.954600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,11.938000>}
box{<0,0,-0.127000><4.256700,0.035000,0.127000> rotate<0,0.000000,0> translate<9.954600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,13.492100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.523100>}
box{<0,0,-0.127000><1.031000,0.035000,0.127000> rotate<0,90.000000,0> translate<9.972900,0.000000,14.523100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.716000>}
box{<0,0,-0.127000><2.092100,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.160100,0.000000,13.970000>}
box{<0,0,-0.127000><2.187200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.384400,0.000000,14.224000>}
box{<0,0,-0.127000><2.411500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,14.478000>}
box{<0,0,-0.127000><2.460400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.776700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,15.807800>}
box{<0,0,-0.127000><1.031100,0.035000,0.127000> rotate<0,90.000000,0> translate<9.972900,0.000000,15.807800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,14.986000>}
box{<0,0,-0.127000><2.460400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,15.240000>}
box{<0,0,-0.127000><2.460400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.524300,0.000000,15.494000>}
box{<0,0,-0.127000><2.551400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.257100,0.000000,15.748000>}
box{<0,0,-0.127000><3.284200,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,22.392100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.423100>}
box{<0,0,-0.127000><1.031000,0.035000,0.127000> rotate<0,90.000000,0> translate<9.972900,0.000000,23.423100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.329500,0.000000,22.606000>}
box{<0,0,-0.127000><0.356600,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.479400,0.000000,22.860000>}
box{<0,0,-0.127000><0.506500,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,23.114000>}
box{<0,0,-0.127000><3.591400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.146300,0.000000,23.368000>}
box{<0,0,-0.127000><3.173400,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.676700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,24.707800>}
box{<0,0,-0.127000><1.031100,0.035000,0.127000> rotate<0,90.000000,0> translate<9.972900,0.000000,24.707800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.297900,0.000000,23.876000>}
box{<0,0,-0.127000><1.325000,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.130000>}
box{<0,0,-0.127000><1.192300,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.384000>}
box{<0,0,-0.127000><1.192300,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<9.972900,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.638000>}
box{<0,0,-0.127000><1.192300,0.035000,0.127000> rotate<0,0.000000,0> translate<9.972900,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.311600,-1.535000,20.828000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.008300,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,0.000000,22.351900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,0.000000,22.351900>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.008300,0.000000,22.351900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.008300,-1.535000,22.351900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,-1.535000,22.351900>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.008300,-1.535000,22.351900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.025400,-1.535000,3.384400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.092000,-1.535000,3.339900>}
box{<0,0,-0.127000><0.080099,0.035000,0.127000> rotate<0,33.747358,0> translate<10.025400,-1.535000,3.384400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.042900,0.000000,11.849700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.151200,0.000000,11.849700>}
box{<0,0,-0.127000><1.108300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.042900,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.080900,-1.535000,1.751900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.232600,-1.535000,1.600100>}
box{<0,0,-0.127000><0.214607,0.035000,0.127000> rotate<0,45.015907,0> translate<10.080900,-1.535000,1.751900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.258000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<10.090100,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.258000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<10.090100,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650600,0.000000,31.496000>}
box{<0,0,-0.127000><1.560500,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650600,-1.535000,31.496000>}
box{<0,0,-0.127000><1.560500,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755800,0.000000,31.750000>}
box{<0,0,-0.127000><1.665700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755800,-1.535000,31.750000>}
box{<0,0,-0.127000><1.665700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953400,0.000000,32.004000>}
box{<0,0,-0.127000><1.863300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.863300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,33.362000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<10.090100,0.000000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,33.362000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<10.090100,-1.535000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.017200,0.000000,32.512000>}
box{<0,0,-0.127000><9.927100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.735400,-1.535000,32.512000>}
box{<0,0,-0.127000><39.645300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.763200,0.000000,32.766000>}
box{<0,0,-0.127000><9.673100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.989400,-1.535000,32.766000>}
box{<0,0,-0.127000><39.899300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.509200,0.000000,33.020000>}
box{<0,0,-0.127000><9.419100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.243400,-1.535000,33.020000>}
box{<0,0,-0.127000><40.153300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.255200,0.000000,33.274000>}
box{<0,0,-0.127000><9.165100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.090100,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.497400,-1.535000,33.274000>}
box{<0,0,-0.127000><40.407300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.090100,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.092000,-1.535000,3.339900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.232500,-1.535000,3.480500>}
box{<0,0,-0.127000><0.198768,0.035000,0.127000> rotate<0,-45.017412,0> translate<10.092000,-1.535000,3.339900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.208600,-1.535000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.667200,-1.535000,12.192000>}
box{<0,0,-0.127000><3.458600,0.035000,0.127000> rotate<0,0.000000,0> translate<10.208600,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.232500,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.098600,-1.535000,3.480500>}
box{<0,0,-0.127000><0.866100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.232500,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.232600,-1.535000,1.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.413300,-1.535000,1.600200>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,-0.031706,0> translate<10.232600,-1.535000,1.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,0.000000,22.503600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,0.000000,22.351900>}
box{<0,0,-0.127000><0.151700,0.035000,0.127000> rotate<0,-90.000000,0> translate<10.287000,0.000000,22.351900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,-1.535000,22.503600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,-1.535000,22.351900>}
box{<0,0,-0.127000><0.151700,0.035000,0.127000> rotate<0,-90.000000,0> translate<10.287000,-1.535000,22.351900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,0.000000,22.503600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.403000,0.000000,22.783600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<10.287000,0.000000,22.503600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.287000,-1.535000,22.503600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.403000,-1.535000,22.783600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<10.287000,-1.535000,22.503600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.311600,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.591600,-1.535000,20.944000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.311600,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.311600,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.937400,-1.535000,20.828000>}
box{<0,0,-0.127000><4.625800,0.035000,0.127000> rotate<0,0.000000,0> translate<10.311600,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.372200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.372200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<10.372200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.372200,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<10.372200,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.403000,0.000000,22.783600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.617300,0.000000,22.997900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.403000,0.000000,22.783600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.403000,-1.535000,22.783600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.617300,-1.535000,22.997900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.403000,-1.535000,22.783600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.413300,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.098600,-1.535000,1.600200>}
box{<0,0,-0.127000><0.685300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.413300,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.423300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,0.000000,28.143300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<10.414000,0.000000,28.423300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.726600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.423300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<10.414000,0.000000,28.423300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.414000,0.000000,28.726600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,0.000000,29.006600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<10.414000,0.000000,28.726600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.462600,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.413200,-1.535000,12.446000>}
box{<0,0,-0.127000><2.950600,0.035000,0.127000> rotate<0,0.000000,0> translate<10.462600,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.494600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<10.494600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.494600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365400,-1.535000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<10.494600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.494800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.381200,-1.535000,5.842000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<10.494800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.494800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<10.494800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.514300,-1.535000,28.181300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,-1.535000,28.143300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<10.514300,-1.535000,28.181300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.514300,-1.535000,28.968600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,-1.535000,29.006600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<10.514300,-1.535000,28.968600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,0.000000,28.143300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,0.000000,27.929000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<10.530000,0.000000,28.143300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,-1.535000,28.143300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,-1.535000,27.929000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<10.530000,-1.535000,28.143300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,0.000000,29.006600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,0.000000,29.220900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.530000,0.000000,29.006600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.530000,-1.535000,29.006600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,-1.535000,29.220900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.530000,-1.535000,29.006600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.591600,-1.535000,20.944000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.805900,-1.535000,21.158300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.591600,-1.535000,20.944000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.617300,0.000000,22.997900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.897300,0.000000,23.113900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.617300,0.000000,22.997900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.617300,-1.535000,22.997900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.897300,-1.535000,23.113900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.617300,-1.535000,22.997900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.657800,0.000000,16.819000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.042100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.657800,0.000000,16.819000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.716600,-1.535000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.159200,-1.535000,12.700000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<10.716600,-1.535000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.729600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.191400,-1.535000,21.082000>}
box{<0,0,-0.127000><4.461800,0.035000,0.127000> rotate<0,0.000000,0> translate<10.729600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,0.000000,27.929000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,0.000000,27.813000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<10.744300,0.000000,27.929000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,-1.535000,27.929000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,-1.535000,27.813000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<10.744300,-1.535000,27.929000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,0.000000,29.220900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,0.000000,29.336900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.744300,0.000000,29.220900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.744300,-1.535000,29.220900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,-1.535000,29.336900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<10.744300,-1.535000,29.220900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.016900,-1.535000,6.206400>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,-45.008364,0> translate<10.764200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.764200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<10.764200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.764200,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<10.764200,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.780900,0.000000,18.650000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.787300,0.000000,18.656300>}
box{<0,0,-0.127000><0.008981,0.035000,0.127000> rotate<0,-44.545921,0> translate<10.780900,0.000000,18.650000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.780900,0.000000,18.650000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,18.626200>}
box{<0,0,-0.127000><0.033658,0.035000,0.127000> rotate<0,44.997030,0> translate<10.780900,0.000000,18.650000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.780900,0.000000,19.449900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.787300,0.000000,19.443600>}
box{<0,0,-0.127000><0.008981,0.035000,0.127000> rotate<0,44.545921,0> translate<10.780900,0.000000,19.449900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.780900,0.000000,19.449900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,19.473700>}
box{<0,0,-0.127000><0.033658,0.035000,0.127000> rotate<0,-44.997030,0> translate<10.780900,0.000000,19.449900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.787300,0.000000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.054300,0.000000,18.656300>}
box{<0,0,-0.127000><2.267000,0.035000,0.127000> rotate<0,0.000000,0> translate<10.787300,0.000000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.787300,0.000000,19.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.054300,0.000000,19.443600>}
box{<0,0,-0.127000><2.267000,0.035000,0.127000> rotate<0,0.000000,0> translate<10.787300,0.000000,19.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,17.934000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,18.626200>}
box{<0,0,-0.127000><0.692200,0.035000,0.127000> rotate<0,90.000000,0> translate<10.804700,0.000000,18.626200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,17.934000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.857800>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,44.997030,0> translate<10.804700,0.000000,17.934000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,18.034000>}
box{<0,0,-0.127000><5.710500,0.035000,0.127000> rotate<0,0.000000,0> translate<10.804700,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,18.288000>}
box{<0,0,-0.127000><2.759600,0.035000,0.127000> rotate<0,0.000000,0> translate<10.804700,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.146300,0.000000,18.542000>}
box{<0,0,-0.127000><2.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<10.804700,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,19.473700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,19.545300>}
box{<0,0,-0.127000><0.071600,0.035000,0.127000> rotate<0,90.000000,0> translate<10.804700,0.000000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.804700,0.000000,19.545300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.885900,0.000000,19.545300>}
box{<0,0,-0.127000><0.081200,0.035000,0.127000> rotate<0,0.000000,0> translate<10.804700,0.000000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.805900,-1.535000,21.158300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.821600,-1.535000,21.196300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<10.805900,-1.535000,21.158300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.821600,-1.535000,21.196300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.066400,-1.535000,21.196300>}
box{<0,0,-0.127000><4.244800,0.035000,0.127000> rotate<0,0.000000,0> translate<10.821600,-1.535000,21.196300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.856800,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.149200,0.000000,17.018000>}
box{<0,0,-0.127000><2.292400,0.035000,0.127000> rotate<0,0.000000,0> translate<10.856800,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.042100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.449400>}
box{<0,0,-0.127000><0.407300,0.035000,0.127000> rotate<0,90.000000,0> translate<10.880900,0.000000,17.449400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,17.272000>}
box{<0,0,-0.127000><5.634300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.880900,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.450400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.857800>}
box{<0,0,-0.127000><0.407400,0.035000,0.127000> rotate<0,90.000000,0> translate<10.880900,0.000000,17.857800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,17.526000>}
box{<0,0,-0.127000><5.634300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.880900,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.880900,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,17.780000>}
box{<0,0,-0.127000><5.634300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.880900,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.885900,0.000000,19.545300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.212000,0.000000,19.545300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<10.885900,0.000000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.897300,0.000000,23.113900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.200600,0.000000,23.113900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.897300,0.000000,23.113900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.897300,-1.535000,23.113900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.200600,-1.535000,23.113900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<10.897300,-1.535000,23.113900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.906500,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.127200,-1.535000,6.096000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.906500,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.906500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<10.906500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.906500,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953400,-1.535000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<10.906500,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.906600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.906600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<10.970600,-1.535000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.384300,-1.535000,12.954000>}
box{<0,0,-0.127000><1.413700,0.035000,0.127000> rotate<0,0.000000,0> translate<10.970600,-1.535000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.016900,-1.535000,6.206400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.901900,-1.535000,5.321300>}
box{<0,0,-0.127000><1.251650,0.035000,0.127000> rotate<0,45.000267,0> translate<11.016900,-1.535000,6.206400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,0.000000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.813000>}
box{<0,0,-0.127000><0.140900,0.035000,0.127000> rotate<0,0.000000,0> translate<11.024300,0.000000,27.813000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,-1.535000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,-1.535000,27.813000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.024300,-1.535000,27.813000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,0.000000,29.336900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,0.000000,29.336900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.024300,0.000000,29.336900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.024300,-1.535000,29.336900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,-1.535000,29.336900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.024300,-1.535000,29.336900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.064300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<11.064300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.064300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<11.064300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.477100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.312100,0.000000,25.254000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<11.089000,0.000000,25.477100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.961800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.477100>}
box{<0,0,-0.127000><0.484700,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.089000,0.000000,25.477100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,25.961800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146300,0.000000,25.961800>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.089000,0.000000,25.961800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.108000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146300,0.000000,26.108000>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.089000,0.000000,26.108000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.592800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.108000>}
box{<0,0,-0.127000><0.484800,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.089000,0.000000,26.108000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.089000,0.000000,26.592800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.312100,0.000000,26.815900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.089000,0.000000,26.592800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.098600,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,1.853100>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.098600,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.098600,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,3.227600>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,44.997030,0> translate<11.098600,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.104100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<11.104100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.104200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<11.104200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.104200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<11.104200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.151200,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,9.918700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.151200,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.151200,0.000000,11.849700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,11.671200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<11.151200,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.008700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,23.830200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<11.165200,0.000000,24.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,25.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,24.008700>}
box{<0,0,-0.127000><1.052500,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.165200,0.000000,24.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,25.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,25.239700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.165200,0.000000,25.061200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.008700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,26.830200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<11.165200,0.000000,27.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.165200,0.000000,27.008700>}
box{<0,0,-0.127000><0.804300,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.165200,0.000000,27.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.200600,-1.535000,23.113900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.238500,-1.535000,23.098200>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,22.500200,0> translate<11.200600,-1.535000,23.113900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.200600,0.000000,23.113900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.480600,0.000000,22.997900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<11.200600,0.000000,23.113900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.209400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.209400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.209400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.209400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.209400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.650600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.209400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.212000,0.000000,19.545300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,19.775900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.212000,0.000000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.224600,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.159900,-1.535000,13.208000>}
box{<0,0,-0.127000><0.935300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.224600,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.224700,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.146400,0.000000,19.558000>}
box{<0,0,-0.127000><1.921700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.224700,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<11.226700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.109800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.484400,0.035000,0.127000> rotate<0,90.000000,0> translate<11.226700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.109800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,6.703300>}
box{<0,0,-0.127000><0.574878,0.035000,0.127000> rotate<0,44.997030,0> translate<11.226700,-1.535000,7.109800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.226700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.226700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.238500,-1.535000,23.098200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.878300,-1.535000,28.738000>}
box{<0,0,-0.127000><7.975882,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.238500,-1.535000,23.098200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.276400,-1.535000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.147600,-1.535000,1.778000>}
box{<0,0,-0.127000><0.871200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.276400,-1.535000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.277100,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.977200,-1.535000,3.302000>}
box{<0,0,-0.127000><1.700100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.277100,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.312100,0.000000,25.254000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.254000>}
box{<0,0,-0.127000><0.834700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.312100,0.000000,25.254000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.312100,0.000000,26.815900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.815900>}
box{<0,0,-0.127000><0.834700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.312100,0.000000,26.815900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.316900,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,11.684000>}
box{<0,0,-0.127000><2.894400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.316900,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.317000,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,9.906000>}
box{<0,0,-0.127000><11.047700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.317000,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,-1.535000,27.813000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,-1.535000,27.929000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<11.327600,-1.535000,27.813000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,0.000000,29.336900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,0.000000,29.220900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<11.327600,0.000000,29.336900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.327600,-1.535000,29.336900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,-1.535000,29.220900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<11.327600,-1.535000,29.336900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,10.401300>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<11.329700,0.000000,10.401300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.160000>}
box{<0,0,-0.127000><11.035000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.329700,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,10.401300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.768000,0.000000,10.401300>}
box{<0,0,-0.127000><3.438300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.329700,0.000000,10.401300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,11.188600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,11.671200>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<11.329700,0.000000,11.671200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,11.188600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,11.188600>}
box{<0,0,-0.127000><2.881600,0.035000,0.127000> rotate<0,0.000000,0> translate<11.329700,0.000000,11.188600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.329700,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,11.430000>}
box{<0,0,-0.127000><2.881600,0.035000,0.127000> rotate<0,0.000000,0> translate<11.329700,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,23.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,0.000000,23.830200>}
box{<0,0,-0.127000><1.610300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.343700,0.000000,23.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,25.239700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,25.239700>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.343700,0.000000,25.239700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.343700,0.000000,26.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,26.830200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.343700,0.000000,26.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,1.853100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.210800>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,90.000000,0> translate<11.351500,-1.535000,2.210800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.032000>}
box{<0,0,-0.127000><0.721000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.351500,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.210800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.869900>}
box{<0,0,-0.127000><0.659100,0.035000,0.127000> rotate<0,90.000000,0> translate<11.351500,-1.535000,2.869900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.286000>}
box{<0,0,-0.127000><0.721000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.351500,-1.535000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.232300,-1.535000,2.540000>}
box{<0,0,-0.127000><0.880800,0.035000,0.127000> rotate<0,0.000000,0> translate<11.351500,-1.535000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,2.794000>}
box{<0,0,-0.127000><1.381800,0.035000,0.127000> rotate<0,0.000000,0> translate<11.351500,-1.535000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,2.869900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,3.227600>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,90.000000,0> translate<11.351500,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.351500,-1.535000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,3.048000>}
box{<0,0,-0.127000><1.381800,0.035000,0.127000> rotate<0,0.000000,0> translate<11.351500,-1.535000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,19.775900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,21.690300>}
box{<0,0,-0.127000><1.914400,0.035000,0.127000> rotate<0,90.000000,0> translate<11.442600,0.000000,21.690300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.812000>}
box{<0,0,-0.127000><9.017100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,20.066000>}
box{<0,0,-0.127000><9.017100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,20.320000>}
box{<0,0,-0.127000><9.017100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,20.574000>}
box{<0,0,-0.127000><9.017100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,20.828000>}
box{<0,0,-0.127000><9.017100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.342300,0.000000,21.082000>}
box{<0,0,-0.127000><3.899700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.924300,0.000000,21.336000>}
box{<0,0,-0.127000><3.481700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.774300,0.000000,21.590000>}
box{<0,0,-0.127000><3.331700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.442600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.442600,0.000000,21.690300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.480600,0.000000,21.706000>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<11.442600,0.000000,21.690300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.478500,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.154700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.478500,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.478600,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.462000>}
box{<0,0,-0.127000><0.586400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.478600,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.480600,0.000000,21.706000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.694900,0.000000,21.920300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.480600,0.000000,21.706000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.480600,0.000000,22.997900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.694900,0.000000,22.783600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<11.480600,0.000000,22.997900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,-1.535000,27.929000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,-1.535000,28.143300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.607600,-1.535000,27.929000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,0.000000,29.220900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,0.000000,29.006600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<11.607600,0.000000,29.220900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.607600,-1.535000,29.220900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,-1.535000,29.006600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<11.607600,-1.535000,29.220900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.618500,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.127500,0.000000,22.860000>}
box{<0,0,-0.127000><8.509000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.618500,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.618500,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755700,0.000000,29.210000>}
box{<0,0,-0.127000><0.137200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.618500,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.618500,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.755700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.137200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.618500,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.618600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.732000,0.000000,21.844000>}
box{<0,0,-0.127000><3.113400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.618600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.618600,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.080300,-1.535000,27.940000>}
box{<0,0,-0.127000><4.461700,0.035000,0.127000> rotate<0,0.000000,0> translate<11.618600,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<11.633200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.633200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,6.703300>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.633200,-1.535000,6.703300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.633200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.633200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<11.633200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<11.633200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.633200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<11.633200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.633200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.633200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.633200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.647900,-1.535000,14.744600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.974000,-1.535000,14.744600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.647900,-1.535000,14.744600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.694900,0.000000,21.920300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.810900,0.000000,22.200300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.694900,0.000000,21.920300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.694900,0.000000,22.783600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.810900,0.000000,22.503600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<11.694900,0.000000,22.783600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.732600,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.716000>}
box{<0,0,-0.127000><0.332400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.732600,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.768500,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.774500,0.000000,22.098000>}
box{<0,0,-0.127000><3.006000,0.035000,0.127000> rotate<0,0.000000,0> translate<11.768500,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.768500,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.920000,0.000000,22.606000>}
box{<0,0,-0.127000><7.151500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.768500,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<11.795600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.795600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.795600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<11.795600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<11.795600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.795600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.795600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<11.795600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.810900,0.000000,22.200300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.810900,0.000000,22.503600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<11.810900,0.000000,22.503600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.810900,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.924400,0.000000,22.352000>}
box{<0,0,-0.127000><3.113500,0.035000,0.127000> rotate<0,0.000000,0> translate<11.810900,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,-1.535000,28.143300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.423300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<11.821900,-1.535000,28.143300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,0.000000,29.006600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.726600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<11.821900,0.000000,29.006600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.821900,-1.535000,29.006600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.726600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<11.821900,-1.535000,29.006600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.842900,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.334300,-1.535000,28.194000>}
box{<0,0,-0.127000><4.491400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.842900,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.842900,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953300,0.000000,28.956000>}
box{<0,0,-0.127000><0.110400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.842900,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.842900,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.953300,-1.535000,28.956000>}
box{<0,0,-0.127000><0.110400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.842900,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.901900,-1.535000,5.321300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.228000,-1.535000,5.321300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.901900,-1.535000,5.321300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.922200,0.000000,28.385400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.423300>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-67.493860,0> translate<11.922200,0.000000,28.385400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.922200,0.000000,28.385400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.067900,0.000000,28.239700>}
box{<0,0,-0.127000><0.206051,0.035000,0.127000> rotate<0,44.997030,0> translate<11.922200,0.000000,28.385400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.423300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.726600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<11.937900,0.000000,28.726600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.423300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.726600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<11.937900,-1.535000,28.726600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.588300,-1.535000,28.448000>}
box{<0,0,-0.127000><4.650400,0.035000,0.127000> rotate<0,0.000000,0> translate<11.937900,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.541200,0.000000,28.448000>}
box{<0,0,-0.127000><9.603300,0.035000,0.127000> rotate<0,0.000000,0> translate<11.937900,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365000,0.000000,28.702000>}
box{<0,0,-0.127000><0.427100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.937900,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.937900,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.365000,-1.535000,28.702000>}
box{<0,0,-0.127000><0.427100,0.035000,0.127000> rotate<0,0.000000,0> translate<11.937900,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.974000,-1.535000,13.957300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.154800,-1.535000,13.957300>}
box{<0,0,-0.127000><0.180800,0.035000,0.127000> rotate<0,0.000000,0> translate<11.974000,-1.535000,13.957300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<11.974000,-1.535000,14.744600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,14.744600>}
box{<0,0,-0.127000><4.116200,0.035000,0.127000> rotate<0,0.000000,0> translate<11.974000,-1.535000,14.744600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.437300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,0.000000,13.157300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<12.065000,0.000000,13.437300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.437300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,-1.535000,13.157300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<12.065000,-1.535000,13.437300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.740600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.437300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.065000,0.000000,13.437300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.740600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.437300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.065000,-1.535000,13.437300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,-1.535000,13.740600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.154800,-1.535000,13.957300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<12.065000,-1.535000,13.740600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.065000,0.000000,13.740600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,0.000000,14.020600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<12.065000,0.000000,13.740600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.067900,0.000000,28.239700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,28.239700>}
box{<0,0,-0.127000><1.028300,0.035000,0.127000> rotate<0,0.000000,0> translate<12.067900,0.000000,28.239700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,1.853100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.325400,-1.535000,1.600200>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,44.997030,0> translate<12.072500,-1.535000,1.853100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.210800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,1.853100>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.072500,-1.535000,1.853100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.380200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.210800>}
box{<0,0,-0.127000><0.169400,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.072500,-1.535000,2.210800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.072500,-1.535000,2.380200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.325400,-1.535000,2.633100>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<12.072500,-1.535000,2.380200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.095700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.095700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.095700,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.095700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.095700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.095700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.095700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.095700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146300,0.000000,26.108000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146300,0.000000,25.961800>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.146300,0.000000,25.961800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.254000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.961300>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,90.000000,0> translate<12.146800,0.000000,25.961300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.400000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.654000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.908000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,25.961300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.961300>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,25.961300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.108600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.815900>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,90.000000,0> translate<12.146800,0.000000,26.815900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.108600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.108600>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,26.108600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.162000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.416000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.146800,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.670000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.146800,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,0.000000,13.157300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,0.000000,12.943000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<12.181000,0.000000,13.157300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,-1.535000,13.157300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,-1.535000,12.943000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<12.181000,-1.535000,13.157300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.181000,0.000000,14.020600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,0.000000,14.234900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<12.181000,0.000000,14.020600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.228000,-1.535000,5.321300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.663900,-1.535000,5.321300>}
box{<0,0,-0.127000><0.435900,0.035000,0.127000> rotate<0,0.000000,0> translate<12.228000,-1.535000,5.321300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.254000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.127800,0.000000,25.254000>}
box{<0,0,-0.127000><0.834800,0.035000,0.127000> rotate<0,0.000000,0> translate<12.293000,0.000000,25.254000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.961300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,25.254000>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.293000,0.000000,25.254000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.815900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.108600>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.293000,0.000000,26.108600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293000,0.000000,26.815900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.127800,0.000000,26.815900>}
box{<0,0,-0.127000><0.834800,0.035000,0.127000> rotate<0,0.000000,0> translate<12.293000,0.000000,26.815900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293600,0.000000,25.961800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293600,0.000000,26.108000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,90.000000,0> translate<12.293600,0.000000,26.108000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293600,0.000000,25.961800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,25.961800>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<12.293600,0.000000,25.961800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.293600,0.000000,26.108000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,26.108000>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<12.293600,0.000000,26.108000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.325400,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.852500,-1.535000,1.600200>}
box{<0,0,-0.127000><0.527100,0.035000,0.127000> rotate<0,0.000000,0> translate<12.325400,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.325400,-1.535000,2.633100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.683100,-1.535000,2.633100>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,0.000000,0> translate<12.325400,-1.535000,2.633100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,0.000000,12.943000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.675300,0.000000,12.827000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<12.395300,0.000000,12.943000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,-1.535000,12.943000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.675300,-1.535000,12.827000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<12.395300,-1.535000,12.943000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.395300,0.000000,14.234900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,14.250600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<12.395300,0.000000,14.234900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,15.403000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,14.250600>}
box{<0,0,-0.127000><1.152400,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.433300,0.000000,14.250600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.433300,0.000000,15.403000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.663900,0.000000,15.633600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<12.433300,0.000000,15.403000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.487700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<12.487700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.663900,-1.535000,5.321300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568900,-1.535000,3.416300>}
box{<0,0,-0.127000><2.694077,0.035000,0.127000> rotate<0,44.997030,0> translate<12.663900,-1.535000,5.321300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.663900,0.000000,15.633600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.990000,0.000000,15.633600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<12.663900,0.000000,15.633600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.675300,0.000000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.978600,0.000000,12.827000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<12.675300,0.000000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.675300,-1.535000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.978600,-1.535000,12.827000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<12.675300,-1.535000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.683100,-1.535000,2.633100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.800700,-1.535000,2.633100>}
box{<0,0,-0.127000><0.117600,0.035000,0.127000> rotate<0,0.000000,0> translate<12.683100,-1.535000,2.633100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,2.700400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.800700,-1.535000,2.633100>}
box{<0,0,-0.127000><0.095247,0.035000,0.127000> rotate<0,44.954497,0> translate<12.733300,-1.535000,2.700400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,3.058100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,2.700400>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.733300,-1.535000,2.700400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.733300,-1.535000,3.058100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.902800,-1.535000,3.227600>}
box{<0,0,-0.127000><0.239709,0.035000,0.127000> rotate<0,-44.997030,0> translate<12.733300,-1.535000,3.058100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.852500,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.004100,-1.535000,1.751900>}
box{<0,0,-0.127000><0.214465,0.035000,0.127000> rotate<0,-45.015920,0> translate<12.852500,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.902800,-1.535000,3.227600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.155700,-1.535000,3.480500>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<12.902800,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.912200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.912200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.912200,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.912200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.912200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.912200,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.912200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<12.912200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<12.954000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.954000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,-1.535000,19.481600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<12.954000,-1.535000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,0.000000,23.724300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,23.444300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<12.954000,0.000000,23.724300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,0.000000,23.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.954000,0.000000,23.724300>}
box{<0,0,-0.127000><0.105900,0.035000,0.127000> rotate<0,-90.000000,0> translate<12.954000,0.000000,23.724300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.978600,-1.535000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.016500,-1.535000,12.842800>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,-22.629105,0> translate<12.978600,-1.535000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.978600,0.000000,12.827000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.258600,0.000000,12.943000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<12.978600,0.000000,12.827000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<12.990000,0.000000,15.633600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.200200,0.000000,15.633600>}
box{<0,0,-0.127000><0.210200,0.035000,0.127000> rotate<0,0.000000,0> translate<12.990000,0.000000,15.633600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.004100,-1.535000,1.751900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.155800,-1.535000,1.600100>}
box{<0,0,-0.127000><0.214607,0.035000,0.127000> rotate<0,45.015907,0> translate<13.004100,-1.535000,1.751900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.016500,-1.535000,12.842800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.497300,-1.535000,9.361900>}
box{<0,0,-0.127000><4.922665,0.035000,0.127000> rotate<0,44.997853,0> translate<13.016500,-1.535000,12.842800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905400,-1.535000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905400,0.000000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905000,0.000000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.034800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.034800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.054300,0.000000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,18.618300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<13.054300,0.000000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.054300,0.000000,19.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,19.481600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<13.054300,0.000000,19.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,18.404000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<13.070000,0.000000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<13.070000,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,19.695900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.070000,0.000000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,-1.535000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,-1.535000,19.695900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.070000,-1.535000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.070000,0.000000,23.444300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,23.230000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<13.070000,0.000000,23.444300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,25.239700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,25.196800>}
box{<0,0,-0.127000><0.060599,0.035000,0.127000> rotate<0,45.063882,0> translate<13.096200,0.000000,25.239700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,26.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,26.873100>}
box{<0,0,-0.127000><0.060599,0.035000,0.127000> rotate<0,-45.063882,0> translate<13.096200,0.000000,26.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.096200,0.000000,28.239700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.274700,0.000000,28.061200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<13.096200,0.000000,28.239700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.027100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.330100,0.000000,15.821000>}
box{<0,0,-0.127000><0.291469,0.035000,0.127000> rotate<0,44.997030,0> translate<13.124000,0.000000,16.027100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.474300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.027100>}
box{<0,0,-0.127000><0.447200,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.124000,0.000000,16.027100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.474300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568800,0.000000,16.474300>}
box{<0,0,-0.127000><1.444800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.124000,0.000000,16.474300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.545500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568800,0.000000,16.545500>}
box{<0,0,-0.127000><1.444800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.124000,0.000000,16.545500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.992800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.545500>}
box{<0,0,-0.127000><0.447300,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.124000,0.000000,16.545500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.124000,0.000000,16.992800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.347100,0.000000,17.215900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.124000,0.000000,16.992800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.127800,0.000000,25.254000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,25.265300>}
box{<0,0,-0.127000><0.015910,0.035000,0.127000> rotate<0,-45.251660,0> translate<13.127800,0.000000,25.254000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.127800,0.000000,26.815900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,26.804600>}
box{<0,0,-0.127000><0.015910,0.035000,0.127000> rotate<0,45.251660,0> translate<13.127800,0.000000,26.815900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,25.265300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,25.196800>}
box{<0,0,-0.127000><0.068500,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.139000,0.000000,25.196800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,26.873100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.139000,0.000000,26.804600>}
box{<0,0,-0.127000><0.068500,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.139000,0.000000,26.804600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.141900,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.795200,0.000000,28.194000>}
box{<0,0,-0.127000><8.653300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.141900,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.155700,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.494700,-1.535000,3.480500>}
box{<0,0,-0.127000><0.339000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.155700,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.155800,-1.535000,1.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.336500,-1.535000,1.600200>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,-0.031706,0> translate<13.155800,-1.535000,1.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.191600,-1.535000,5.907000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,-1.535000,5.878000>}
box{<0,0,-0.127000><0.041012,0.035000,0.127000> rotate<0,44.997030,0> translate<13.191600,-1.535000,5.907000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.191600,-1.535000,5.907000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.121862,0.035000,0.127000> rotate<0,-22.480947,0> translate<13.191600,-1.535000,5.907000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.200200,0.000000,15.691200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.200200,0.000000,15.633600>}
box{<0,0,-0.127000><0.057600,0.035000,0.127000> rotate<0,-90.000000,0> translate<13.200200,0.000000,15.633600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.200200,0.000000,15.691200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.330100,0.000000,15.821000>}
box{<0,0,-0.127000><0.183636,0.035000,0.127000> rotate<0,-44.974969,0> translate<13.200200,0.000000,15.691200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,-1.535000,5.878000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.895000,-1.535000,4.203600>}
box{<0,0,-0.127000><2.367959,0.035000,0.127000> rotate<0,44.997030,0> translate<13.220600,-1.535000,5.878000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.441500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.768400>}
box{<0,0,-0.127000><0.326900,0.035000,0.127000> rotate<0,90.000000,0> translate<13.220600,0.000000,14.768400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.441500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.378700,0.000000,14.599700>}
box{<0,0,-0.127000><0.223658,0.035000,0.127000> rotate<0,-45.015143,0> translate<13.220600,0.000000,14.441500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.257100,0.000000,14.478000>}
box{<0,0,-0.127000><0.036500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.220600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.256900,0.000000,14.732000>}
box{<0,0,-0.127000><0.036300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.220600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.220600,0.000000,14.768400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.378700,0.000000,14.610200>}
box{<0,0,-0.127000><0.223658,0.035000,0.127000> rotate<0,45.015143,0> translate<13.220600,0.000000,14.768400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.256600,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.905000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.648400,0.035000,0.127000> rotate<0,0.000000,0> translate<13.256600,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.258600,0.000000,12.943000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.472900,0.000000,13.157300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.258600,0.000000,12.943000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.269600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.954000>}
box{<0,0,-0.127000><0.941700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.269600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.274700,0.000000,27.952600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.274700,0.000000,28.061200>}
box{<0,0,-0.127000><0.108600,0.035000,0.127000> rotate<0,90.000000,0> translate<13.274700,0.000000,28.061200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.274700,0.000000,27.952600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.880000,0.000000,27.952600>}
box{<0,0,-0.127000><8.605300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.274700,0.000000,27.952600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,18.288000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<13.284300,0.000000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<13.284300,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,19.811900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<13.284300,0.000000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,-1.535000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,-1.535000,19.811900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<13.284300,-1.535000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.284300,0.000000,23.230000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,23.114000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<13.284300,0.000000,23.230000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.304200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.304200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<13.304200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<13.304200,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.304200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.304200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<13.304200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.304200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<13.304200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.336500,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852400,-1.535000,1.600200>}
box{<0,0,-0.127000><0.515900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.336500,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.347100,0.000000,17.215900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,17.215900>}
box{<0,0,-0.127000><1.222200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.347100,0.000000,17.215900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,25.908100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,25.961800>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,90.000000,0> translate<13.350900,0.000000,25.961800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,25.908100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.892600,0.000000,25.908100>}
box{<0,0,-0.127000><1.541700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.350900,0.000000,25.908100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,26.108000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,26.161700>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,90.000000,0> translate<13.350900,0.000000,26.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.350900,0.000000,26.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.892600,0.000000,26.161700>}
box{<0,0,-0.127000><1.541700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.350900,0.000000,26.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.378700,0.000000,14.599700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,14.599700>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.378700,0.000000,14.599700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.378700,0.000000,14.610200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,14.610200>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.378700,0.000000,14.610200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446500,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493400,-1.535000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446500,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493400,0.000000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493300,0.000000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.446600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.493300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.446600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.472900,0.000000,13.157300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.548600,0.000000,13.340200>}
box{<0,0,-0.127000><0.197947,0.035000,0.127000> rotate<0,-67.511498,0> translate<13.472900,0.000000,13.157300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.493800,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,13.208000>}
box{<0,0,-0.127000><0.717500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.493800,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.494700,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.494800,-1.535000,3.480600>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.494700,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.494800,-1.535000,3.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.675500,-1.535000,3.480500>}
box{<0,0,-0.127000><0.180700,0.035000,0.127000> rotate<0,0.031706,0> translate<13.494800,-1.535000,3.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.499100,-1.535000,13.957300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.740600>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,67.486537,0> translate<13.499100,-1.535000,13.957300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.499100,-1.535000,13.957300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,13.957300>}
box{<0,0,-0.127000><2.591100,0.035000,0.127000> rotate<0,0.000000,0> translate<13.499100,-1.535000,13.957300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.510600,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.335200,-1.535000,5.588000>}
box{<0,0,-0.127000><10.824600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.510600,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.548600,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,13.340200>}
box{<0,0,-0.127000><0.662700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.548600,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,18.288000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.564300,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.564300,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,19.811900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.564300,0.000000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,-1.535000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,-1.535000,19.811900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.564300,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.564300,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,23.114000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.564300,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.573100,-1.535000,13.399400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.437300>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,-67.364955,0> translate<13.573100,-1.535000,13.399400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.573100,-1.535000,13.399400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.054000,-1.535000,9.918600>}
box{<0,0,-0.127000><4.922665,0.035000,0.127000> rotate<0,44.996207,0> translate<13.573100,-1.535000,13.399400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.437300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.740600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<13.588900,-1.535000,13.740600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.241900,-1.535000,13.462000>}
box{<0,0,-0.127000><2.653000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.588900,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.588900,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,13.716000>}
box{<0,0,-0.127000><2.501300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.588900,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<13.604300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<13.604300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<13.604300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<13.604300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<13.604300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<13.604300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<13.604300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.604300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<13.604300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295700,0.000000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295800,0.000000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.644200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.295800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.644200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.675500,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852400,-1.535000,3.480500>}
box{<0,0,-0.127000><0.176900,0.035000,0.127000> rotate<0,0.000000,0> translate<13.675500,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190400,0.000000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190600,0.000000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.749400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.190600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<13.749400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.764600,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.589200,-1.535000,5.334000>}
box{<0,0,-0.127000><10.824600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.764600,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.764600,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.383400,-1.535000,13.208000>}
box{<0,0,-0.127000><13.618800,0.035000,0.127000> rotate<0,0.000000,0> translate<13.764600,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<13.766700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<13.766700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<13.766700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<13.766700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.766700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<13.766700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852400,-1.535000,1.600200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,1.853100>}
box{<0,0,-0.127000><0.357655,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.852400,-1.535000,1.600200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852400,-1.535000,3.480500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852500,-1.535000,3.480400>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,44.997030,0> translate<13.852400,-1.535000,3.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.852500,-1.535000,3.480400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.858600,-1.535000,3.474200>}
box{<0,0,-0.127000><0.008698,0.035000,0.127000> rotate<0,45.462809,0> translate<13.852500,-1.535000,3.480400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.858600,-1.535000,3.474200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,3.227600>}
box{<0,0,-0.127000><0.348816,0.035000,0.127000> rotate<0,44.985416,0> translate<13.858600,-1.535000,3.474200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,18.404000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<13.867600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<13.867600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,18.288000>}
box{<0,0,-0.127000><2.647600,0.035000,0.127000> rotate<0,0.000000,0> translate<13.867600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,-1.535000,18.288000>}
box{<0,0,-0.127000><4.268700,0.035000,0.127000> rotate<0,0.000000,0> translate<13.867600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,-1.535000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.905500,-1.535000,19.796100>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<13.867600,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,19.695900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<13.867600,0.000000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,23.230000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<13.867600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.867600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.919900,0.000000,23.114000>}
box{<0,0,-0.127000><5.052300,0.035000,0.127000> rotate<0,0.000000,0> translate<13.867600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<13.905500,-1.535000,19.796100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.235600,-1.535000,21.126200>}
box{<0,0,-0.127000><1.881045,0.035000,0.127000> rotate<0,-44.997030,0> translate<13.905500,-1.535000,19.796100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.018600,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.843200,-1.535000,5.080000>}
box{<0,0,-0.127000><10.824600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.018600,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.018600,-1.535000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.129400,-1.535000,12.954000>}
box{<0,0,-0.127000><13.110800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.018600,-1.535000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.030200,-1.535000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,1.778000>}
box{<0,0,-0.127000><71.199600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.030200,-1.535000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.030900,-1.535000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,3.302000>}
box{<0,0,-0.127000><71.198900,0.035000,0.127000> rotate<0,0.000000,0> translate<14.030900,-1.535000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,1.853100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.022500>}
box{<0,0,-0.127000><0.239568,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.105300,-1.535000,1.853100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,3.227500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,3.227600>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,90.000000,0> translate<14.105300,-1.535000,3.227600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.105300,-1.535000,3.227500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.268600,-1.535000,3.064100>}
box{<0,0,-0.127000><0.231012,0.035000,0.127000> rotate<0,45.014567,0> translate<14.105300,-1.535000,3.227500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.147600,0.000000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.147600,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,19.481600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<14.147600,0.000000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.147600,0.000000,23.230000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,23.444300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.147600,0.000000,23.230000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<14.173200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<14.173200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.173200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.173200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.173200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.173200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<14.173200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<14.173200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.173200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.173200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.173200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.173200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.173200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.536900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,11.188600>}
box{<0,0,-0.127000><1.348300,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.211300,0.000000,11.188600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.863000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.536900>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.211300,0.000000,12.536900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.211300,0.000000,12.863000>}
box{<0,0,-0.127000><0.477200,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.211300,0.000000,12.863000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.265400,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,24.307600>}
box{<0,0,-0.127000><0.136401,0.035000,0.127000> rotate<0,44.967330,0> translate<14.265400,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.265400,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,24.404000>}
box{<0,0,-0.127000><0.627700,0.035000,0.127000> rotate<0,0.000000,0> translate<14.265400,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.268600,-1.535000,3.064100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,3.058100>}
box{<0,0,-0.127000><0.008556,0.035000,0.127000> rotate<0,44.523553,0> translate<14.268600,-1.535000,3.064100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.272600,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.097200,-1.535000,4.826000>}
box{<0,0,-0.127000><10.824600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.272600,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.272600,-1.535000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.875400,-1.535000,12.700000>}
box{<0,0,-0.127000><12.602800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.272600,-1.535000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.022500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.380200>}
box{<0,0,-0.127000><0.357700,0.035000,0.127000> rotate<0,90.000000,0> translate<14.274700,-1.535000,2.380200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,2.032000>}
box{<0,0,-0.127000><70.955100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.274700,-1.535000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,2.286000>}
box{<0,0,-0.127000><70.955100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.274700,-1.535000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.380200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.881000>}
box{<0,0,-0.127000><0.500800,0.035000,0.127000> rotate<0,90.000000,0> translate<14.274700,-1.535000,2.881000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,2.540000>}
box{<0,0,-0.127000><70.955100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.274700,-1.535000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,2.794000>}
box{<0,0,-0.127000><70.955100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.274700,-1.535000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,2.881000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274800,-1.535000,3.058000>}
box{<0,0,-0.127000><0.177000,0.035000,0.127000> rotate<0,-89.961692,0> translate<14.274700,-1.535000,2.881000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,3.048000>}
box{<0,0,-0.127000><70.955100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.274700,-1.535000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274700,-1.535000,3.058100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.274800,-1.535000,3.058000>}
box{<0,0,-0.127000><0.000141,0.035000,0.127000> rotate<0,44.997030,0> translate<14.274700,-1.535000,3.058100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.285500,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.718400,0.000000,19.558000>}
box{<0,0,-0.127000><3.432900,0.035000,0.127000> rotate<0,0.000000,0> translate<14.285500,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.285500,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.536500,0.000000,24.384000>}
box{<0,0,-0.127000><1.251000,0.035000,0.127000> rotate<0,0.000000,0> translate<14.285500,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.285600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,18.542000>}
box{<0,0,-0.127000><2.229600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.285600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.285600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.718300,-1.535000,18.542000>}
box{<0,0,-0.127000><3.432700,0.035000,0.127000> rotate<0,0.000000,0> translate<14.285600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.285600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.104300,0.000000,23.368000>}
box{<0,0,-0.127000><1.818700,0.035000,0.127000> rotate<0,0.000000,0> translate<14.285600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<14.335600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<14.335600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.335600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.335600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<14.335600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<14.335600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.335600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.335600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.335600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,18.898300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.361900,0.000000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.361900,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,19.201600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<14.361900,0.000000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,23.444300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,23.724300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.361900,0.000000,23.444300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.361900,0.000000,24.307600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,24.027600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<14.361900,0.000000,24.307600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.435500,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,18.796000>}
box{<0,0,-0.127000><2.079700,0.035000,0.127000> rotate<0,0.000000,0> translate<14.435500,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.435500,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.568300,-1.535000,18.796000>}
box{<0,0,-0.127000><3.132800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.435500,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.435500,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.568500,0.000000,19.304000>}
box{<0,0,-0.127000><3.133000,0.035000,0.127000> rotate<0,0.000000,0> translate<14.435500,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.435500,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.686300,0.000000,23.622000>}
box{<0,0,-0.127000><1.250800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.435500,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.435500,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.494000,0.000000,24.130000>}
box{<0,0,-0.127000><1.058500,0.035000,0.127000> rotate<0,0.000000,0> translate<14.435500,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.462100,-1.535000,19.239500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,-1.535000,19.201600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<14.462100,-1.535000,19.239500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.462100,-1.535000,19.239500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.911000,-1.535000,20.688300>}
box{<0,0,-0.127000><2.048983,0.035000,0.127000> rotate<0,-44.995053,0> translate<14.462100,-1.535000,19.239500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,19.201600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<14.477900,0.000000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,-1.535000,19.201600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<14.477900,-1.535000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.559000,0.000000,19.050000>}
box{<0,0,-0.127000><2.081100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.477900,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,-1.535000,19.050000>}
box{<0,0,-0.127000><3.048100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.477900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,23.724300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,24.027600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<14.477900,0.000000,24.027600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.477900,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.536300,0.000000,23.876000>}
box{<0,0,-0.127000><1.058400,0.035000,0.127000> rotate<0,0.000000,0> translate<14.477900,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.526600,-1.535000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.351200,-1.535000,4.572000>}
box{<0,0,-0.127000><10.824600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.526600,-1.535000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.526600,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100400,-1.535000,12.446000>}
box{<0,0,-0.127000><11.573800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.526600,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.526600,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.568500,-1.535000,19.304000>}
box{<0,0,-0.127000><3.041900,0.035000,0.127000> rotate<0,0.000000,0> translate<14.526600,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568800,0.000000,16.545500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568800,0.000000,16.474300>}
box{<0,0,-0.127000><0.071200,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.568800,0.000000,16.474300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.568900,-1.535000,3.416300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.895000,-1.535000,3.416300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.568900,-1.535000,3.416300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,16.546100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,17.215900>}
box{<0,0,-0.127000><0.669800,0.035000,0.127000> rotate<0,90.000000,0> translate<14.569300,0.000000,17.215900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,16.546100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,16.546100>}
box{<0,0,-0.127000><0.071200,0.035000,0.127000> rotate<0,0.000000,0> translate<14.569300,0.000000,16.546100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,16.764000>}
box{<0,0,-0.127000><0.071200,0.035000,0.127000> rotate<0,0.000000,0> translate<14.569300,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.569300,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,17.018000>}
box{<0,0,-0.127000><0.071200,0.035000,0.127000> rotate<0,0.000000,0> translate<14.569300,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<14.635700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<14.635700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<14.635700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<14.635700,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<14.635700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<14.635700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<14.635700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.635700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<14.635700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,17.215900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,16.546100>}
box{<0,0,-0.127000><0.669800,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.640500,0.000000,16.546100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.640500,0.000000,17.215900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.862800,0.000000,17.215900>}
box{<0,0,-0.127000><1.222300,0.035000,0.127000> rotate<0,0.000000,0> translate<14.640500,0.000000,17.215900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.641100,0.000000,16.474300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.641100,0.000000,16.545500>}
box{<0,0,-0.127000><0.071200,0.035000,0.127000> rotate<0,90.000000,0> translate<14.641100,0.000000,16.545500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.641100,0.000000,16.474300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.474300>}
box{<0,0,-0.127000><1.444800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.641100,0.000000,16.474300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.641100,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.558900,0.000000,16.510000>}
box{<0,0,-0.127000><1.917800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.641100,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.641100,0.000000,16.545500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.545500>}
box{<0,0,-0.127000><1.444800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.641100,0.000000,16.545500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.732000,0.000000,21.692300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.848000,0.000000,21.412300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<14.732000,0.000000,21.692300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.732000,0.000000,21.995600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.732000,0.000000,21.692300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.732000,0.000000,21.692300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.732000,0.000000,21.995600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.848000,0.000000,22.275600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<14.732000,0.000000,21.995600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.768000,0.000000,10.401300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.631900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.768000,0.000000,10.401300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.780600,-1.535000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.516300,-1.535000,4.318000>}
box{<0,0,-0.127000><37.735700,0.035000,0.127000> rotate<0,0.000000,0> translate<14.780600,-1.535000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.780600,-1.535000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.876100,-1.535000,12.192000>}
box{<0,0,-0.127000><11.095500,0.035000,0.127000> rotate<0,0.000000,0> translate<14.780600,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.780600,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.718400,-1.535000,19.558000>}
box{<0,0,-0.127000><2.937800,0.035000,0.127000> rotate<0,0.000000,0> translate<14.780600,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.780700,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.464300,0.000000,10.414000>}
box{<0,0,-0.127000><2.683600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.780700,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.848000,0.000000,21.412300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.062300,0.000000,21.198000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<14.848000,0.000000,21.412300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.848000,0.000000,22.275600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.062300,0.000000,22.489900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<14.848000,0.000000,22.275600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.892600,0.000000,26.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.892600,0.000000,25.908100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<14.892600,0.000000,25.908100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,25.907600>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,90.000000,0> translate<14.893100,0.000000,25.907600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,24.892000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,25.146000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,25.400000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,25.654000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.893100,0.000000,25.907600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,25.907600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.893100,0.000000,25.907600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.895000,-1.535000,3.416300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.886000,-1.535000,3.416300>}
box{<0,0,-0.127000><54.991000,0.035000,0.127000> rotate<0,0.000000,0> translate<14.895000,-1.535000,3.416300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.895000,-1.535000,4.203600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.777100,-1.535000,4.203600>}
box{<0,0,-0.127000><37.882100,0.035000,0.127000> rotate<0,0.000000,0> translate<14.895000,-1.535000,4.203600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.631900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.958000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<14.998600,0.000000,10.958000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.239900,0.000000,10.668000>}
box{<0,0,-0.127000><2.241300,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,10.922000>}
box{<0,0,-0.127000><2.146400,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,10.958000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,12.306300>}
box{<0,0,-0.127000><1.348300,0.035000,0.127000> rotate<0,90.000000,0> translate<14.998600,0.000000,12.306300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,11.176000>}
box{<0,0,-0.127000><2.146400,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.558900,0.000000,11.430000>}
box{<0,0,-0.127000><1.560300,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,11.684000>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,11.938000>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,12.192000>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,12.306300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,12.306300>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,12.306300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,13.093600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,13.340200>}
box{<0,0,-0.127000><0.246600,0.035000,0.127000> rotate<0,90.000000,0> translate<14.998600,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,13.093600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.093600>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,13.093600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.208000>}
box{<0,0,-0.127000><1.516600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<14.998600,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,13.340200>}
box{<0,0,-0.127000><0.832600,0.035000,0.127000> rotate<0,0.000000,0> translate<14.998600,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.027700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.027700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.034600,-1.535000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.938000>}
box{<0,0,-0.127000><10.746400,0.035000,0.127000> rotate<0,0.000000,0> translate<15.034600,-1.535000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.034600,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.493400,-1.535000,19.812000>}
box{<0,0,-0.127000><3.458800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.034600,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.062300,0.000000,21.198000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.342300,0.000000,21.082000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<15.062300,0.000000,21.198000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.062300,0.000000,22.489900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.342300,0.000000,22.605900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.062300,0.000000,22.489900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.066400,-1.535000,21.196300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.235600,-1.535000,21.126200>}
box{<0,0,-0.127000><0.183147,0.035000,0.127000> rotate<0,22.502869,0> translate<15.066400,-1.535000,21.196300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.544800,0.000000,24.404000>}
box{<0,0,-0.127000><0.398100,0.035000,0.127000> rotate<0,0.000000,0> translate<15.146700,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,25.907600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.146700,0.000000,24.404000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,-90.000000,0> translate<15.146700,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.147300,0.000000,25.908100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.147300,0.000000,26.161700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<15.147300,0.000000,26.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.147300,0.000000,25.908100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.908100>}
box{<0,0,-0.127000><1.753600,0.035000,0.127000> rotate<0,0.000000,0> translate<15.147300,0.000000,25.908100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.147300,0.000000,26.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.161700>}
box{<0,0,-0.127000><1.753600,0.035000,0.127000> rotate<0,0.000000,0> translate<15.147300,0.000000,26.161700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.288600,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.464400,-1.535000,11.684000>}
box{<0,0,-0.127000><2.175800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.288600,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.288600,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.747400,-1.535000,20.066000>}
box{<0,0,-0.127000><3.458800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.288600,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.342300,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.645600,0.000000,21.082000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<15.342300,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.342300,0.000000,22.605900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.645600,0.000000,22.605900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<15.342300,0.000000,22.605900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.452200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.452200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<15.452200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<15.452200,-1.535000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.452200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.452200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<15.452200,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.452200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<15.452200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.494000,0.000000,23.978300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.610000,0.000000,23.698300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<15.494000,0.000000,23.978300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.494000,0.000000,24.281600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.494000,0.000000,23.978300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<15.494000,0.000000,23.978300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.494000,0.000000,24.281600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.544800,0.000000,24.404000>}
box{<0,0,-0.127000><0.132523,0.035000,0.127000> rotate<0,-67.455501,0> translate<15.494000,0.000000,24.281600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.542600,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.240100,-1.535000,11.430000>}
box{<0,0,-0.127000><1.697500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.542600,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.542600,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.001400,-1.535000,20.320000>}
box{<0,0,-0.127000><3.458800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.542600,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.461200,-1.535000,9.398000>}
box{<0,0,-0.127000><0.886600,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445400,0.000000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.842300,-1.535000,28.702000>}
box{<0,0,-0.127000><1.267500,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.574800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.445000,0.000000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<15.574800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.610000,0.000000,23.698300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.824300,0.000000,23.484000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<15.610000,0.000000,23.698300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.645600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.925600,0.000000,21.198000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<15.645600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.645600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,21.082000>}
box{<0,0,-0.127000><4.814100,0.035000,0.127000> rotate<0,0.000000,0> translate<15.645600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.645600,0.000000,22.605900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.925600,0.000000,22.489900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<15.645600,0.000000,22.605900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.796600,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,11.176000>}
box{<0,0,-0.127000><1.348400,0.035000,0.127000> rotate<0,0.000000,0> translate<15.796600,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.796600,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.255400,-1.535000,20.574000>}
box{<0,0,-0.127000><3.458800,0.035000,0.127000> rotate<0,0.000000,0> translate<15.796600,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.824300,0.000000,23.484000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.104300,0.000000,23.368000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<15.824300,0.000000,23.484000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,13.518700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.831200,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,14.599700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.421200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<15.831200,0.000000,14.599700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.831200,0.000000,14.610200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.788700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.831200,0.000000,14.610200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.844200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.844200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<15.844200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<15.844200,-1.535000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.844200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.844200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<15.844200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.844200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<15.844200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.862800,0.000000,17.215900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.992800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<15.862800,0.000000,17.215900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.879800,0.000000,15.821000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,15.691200>}
box{<0,0,-0.127000><0.183636,0.035000,0.127000> rotate<0,44.974969,0> translate<15.879800,0.000000,15.821000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.879800,0.000000,15.821000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.027100>}
box{<0,0,-0.127000><0.291469,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.879800,0.000000,15.821000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.911000,-1.535000,20.688300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.165000,-1.535000,20.688300>}
box{<0,0,-0.127000><0.254000,0.035000,0.127000> rotate<0,0.000000,0> translate<15.911000,-1.535000,20.688300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.925600,0.000000,21.198000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.139900,0.000000,21.412300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<15.925600,0.000000,21.198000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.925600,0.000000,22.489900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.139900,0.000000,22.275600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<15.925600,0.000000,22.489900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.952900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.478000>}
box{<0,0,-0.127000><1.560400,0.035000,0.127000> rotate<0,0.000000,0> translate<15.952900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.952900,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,15.748000>}
box{<0,0,-0.127000><1.560400,0.035000,0.127000> rotate<0,0.000000,0> translate<15.952900,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.953000,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.462000>}
box{<0,0,-0.127000><0.562200,0.035000,0.127000> rotate<0,0.000000,0> translate<15.953000,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.953000,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.732000>}
box{<0,0,-0.127000><1.560300,0.035000,0.127000> rotate<0,0.000000,0> translate<15.953000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986500,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.715200,-1.535000,9.144000>}
box{<0,0,-0.127000><0.728700,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986500,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033400,0.000000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033300,0.000000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<15.986600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.033300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<15.986600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,13.518700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.421200>}
box{<0,0,-0.127000><0.902500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.009700,0.000000,14.421200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.716000>}
box{<0,0,-0.127000><0.505500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.559000,0.000000,13.970000>}
box{<0,0,-0.127000><0.549300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.224000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.788700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,15.691200>}
box{<0,0,-0.127000><0.902500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.009700,0.000000,15.691200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.986000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,15.240000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.009700,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,15.494000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.009700,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.282100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.110100,-1.535000,15.186000>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<16.014000,-1.535000,15.282100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.963100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.282100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.014000,-1.535000,15.282100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,15.963100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017600,-1.535000,15.963100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.014000,-1.535000,15.963100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.216700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017600,-1.535000,16.216700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.014000,-1.535000,16.216700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.897800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.216700>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.014000,-1.535000,16.216700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.014000,-1.535000,16.897800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.237100,-1.535000,17.120900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.014000,-1.535000,16.897800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.050600,-1.535000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,10.922000>}
box{<0,0,-0.127000><1.094400,0.035000,0.127000> rotate<0,0.000000,0> translate<16.050600,-1.535000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.060700,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,17.018000>}
box{<0,0,-0.127000><0.454500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.060700,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.060800,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,16.002000>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.060800,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.063500,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,22.352000>}
box{<0,0,-0.127000><2.786700,0.035000,0.127000> rotate<0,0.000000,0> translate<16.063500,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.063600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,21.336000>}
box{<0,0,-0.127000><2.786600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.063600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.027100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.474300>}
box{<0,0,-0.127000><0.447200,0.035000,0.127000> rotate<0,90.000000,0> translate<16.085900,0.000000,16.474300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,16.256000>}
box{<0,0,-0.127000><1.427400,0.035000,0.127000> rotate<0,0.000000,0> translate<16.085900,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.545500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.992800>}
box{<0,0,-0.127000><0.447300,0.035000,0.127000> rotate<0,90.000000,0> translate<16.085900,0.000000,16.992800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.085900,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,16.764000>}
box{<0,0,-0.127000><0.429300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.085900,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,13.613700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.268700,-1.535000,13.435200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<16.090200,-1.535000,13.613700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,13.957300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,13.613700>}
box{<0,0,-0.127000><0.343600,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.090200,-1.535000,13.613700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,15.166200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,14.744600>}
box{<0,0,-0.127000><0.421600,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.090200,-1.535000,14.744600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.090200,-1.535000,15.166200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.110100,-1.535000,15.186000>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,-44.852718,0> translate<16.090200,-1.535000,15.166200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.104300,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.407600,0.000000,23.368000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.104300,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.139900,0.000000,21.412300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.155600,0.000000,21.450300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<16.139900,0.000000,21.412300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.139900,0.000000,22.275600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.155600,0.000000,22.237600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<16.139900,0.000000,22.275600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.144300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.144300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.144300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.144300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.144300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.144300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.144300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.144300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.144300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.155600,0.000000,21.450300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,21.450300>}
box{<0,0,-0.127000><2.694600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.155600,0.000000,21.450300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.155600,0.000000,22.237600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,22.237600>}
box{<0,0,-0.127000><2.694600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.155600,0.000000,22.237600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.165000,-1.535000,20.688300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.543000,-1.535000,29.066400>}
box{<0,0,-0.127000><11.848352,0.035000,0.127000> rotate<0,-44.997372,0> translate<16.165000,-1.535000,20.688300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835700,0.000000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835800,0.000000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.184200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.835800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.184200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.237100,-1.535000,17.120900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,17.120900>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,0.000000,0> translate<16.237100,-1.535000,17.120900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.268700,-1.535000,13.435200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.021200,-1.535000,13.435200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.268700,-1.535000,13.435200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730400,0.000000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730600,0.000000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.289400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.730600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<16.289400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.304600,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.239900,-1.535000,10.668000>}
box{<0,0,-0.127000><0.935300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.304600,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.304600,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.509400,-1.535000,20.828000>}
box{<0,0,-0.127000><3.204800,0.035000,0.127000> rotate<0,0.000000,0> translate<16.304600,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.306700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.306700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.306700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<16.306700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.306700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.306700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.407600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.687600,0.000000,23.484000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<16.407600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.407600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,23.368000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.407600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.497300,-1.535000,9.361900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.727900,-1.535000,9.131300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<16.497300,-1.535000,9.361900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,11.473700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,11.295200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<16.515200,0.000000,11.473700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,12.306300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,11.473700>}
box{<0,0,-0.127000><0.832600,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.515200,0.000000,11.473700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.926200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.093600>}
box{<0,0,-0.127000><0.832600,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.515200,0.000000,13.093600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,13.926200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,14.104700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.515200,0.000000,13.926200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,16.553700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,16.375200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<16.515200,0.000000,16.553700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,19.006200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,16.553700>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.515200,0.000000,16.553700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.515200,0.000000,19.006200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,19.184700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.515200,0.000000,19.006200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.558600,-1.535000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.464300,-1.535000,10.414000>}
box{<0,0,-0.127000><0.905700,0.035000,0.127000> rotate<0,0.000000,0> translate<16.558600,-1.535000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.558600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.763400,-1.535000,21.082000>}
box{<0,0,-0.127000><3.204800,0.035000,0.127000> rotate<0,0.000000,0> translate<16.558600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.687600,0.000000,23.484000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.901900,0.000000,23.698300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.687600,0.000000,23.484000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,11.295200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.184300,0.000000,11.295200>}
box{<0,0,-0.127000><0.490600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.693700,0.000000,11.295200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,14.104700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.104700>}
box{<0,0,-0.127000><0.819600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.693700,0.000000,14.104700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,16.375200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,16.375200>}
box{<0,0,-0.127000><0.819600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.693700,0.000000,16.375200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.693700,0.000000,19.184700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,0.000000,19.184700>}
box{<0,0,-0.127000><0.832300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.693700,0.000000,19.184700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.713200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.713200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.713200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.713200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.713200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.713200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.713200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<16.713200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.713200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<16.713200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.713200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.713200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.713200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.727900,-1.535000,9.131300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.020800,-1.535000,9.131300>}
box{<0,0,-0.127000><0.292900,0.035000,0.127000> rotate<0,0.000000,0> translate<16.727900,-1.535000,9.131300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.812600,-1.535000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.239200,-1.535000,10.160000>}
box{<0,0,-0.127000><1.426600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.812600,-1.535000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.812600,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.017400,-1.535000,21.336000>}
box{<0,0,-0.127000><3.204800,0.035000,0.127000> rotate<0,0.000000,0> translate<16.812600,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.825600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,23.622000>}
box{<0,0,-0.127000><2.024600,0.035000,0.127000> rotate<0,0.000000,0> translate<16.825600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<16.875600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<16.875600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.020800,-1.535000,9.131300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<16.875600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.875600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.064900,-1.535000,28.924500>}
box{<0,0,-0.127000><0.267640,0.035000,0.127000> rotate<0,44.981894,0> translate<16.875600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<16.875600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.875600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.875600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.875600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.878300,-1.535000,28.738000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.064900,-1.535000,28.924500>}
box{<0,0,-0.127000><0.263822,0.035000,0.127000> rotate<0,-44.981675,0> translate<16.878300,-1.535000,28.738000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.331500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.908100>}
box{<0,0,-0.127000><0.576600,0.035000,0.127000> rotate<0,90.000000,0> translate<16.900900,0.000000,25.908100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.331500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,25.610800>}
box{<0,0,-0.127000><0.394990,0.035000,0.127000> rotate<0,-44.997030,0> translate<16.900900,0.000000,25.331500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.969400,0.000000,25.400000>}
box{<0,0,-0.127000><0.068500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,25.654000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,25.908000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.161700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,27.165300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<16.900900,0.000000,27.165300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,26.162000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,26.416000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,26.670000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,26.924000>}
box{<0,0,-0.127000><0.279300,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.900900,0.000000,27.165300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.284400,0.000000,27.165300>}
box{<0,0,-0.127000><0.383500,0.035000,0.127000> rotate<0,0.000000,0> translate<16.900900,0.000000,27.165300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.901900,0.000000,23.698300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017900,0.000000,23.978300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<16.901900,0.000000,23.698300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<16.975500,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,23.876000>}
box{<0,0,-0.127000><1.874700,0.035000,0.127000> rotate<0,0.000000,0> translate<16.975500,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.002100,0.000000,24.319500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017900,0.000000,24.281600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<17.002100,0.000000,24.319500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.002100,0.000000,24.319500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.512800,0.000000,24.830200>}
box{<0,0,-0.127000><0.722239,0.035000,0.127000> rotate<0,-44.997030,0> translate<17.002100,0.000000,24.319500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017600,-1.535000,16.216700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017600,-1.535000,15.963100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.017600,-1.535000,15.963100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017900,0.000000,23.978300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017900,0.000000,24.281600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<17.017900,0.000000,24.281600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.017900,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,24.130000>}
box{<0,0,-0.127000><1.832300,0.035000,0.127000> rotate<0,0.000000,0> translate<17.017900,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,16.217300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,17.120900>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,90.000000,0> translate<17.018100,-1.535000,17.120900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,16.217300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,16.217300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.018100,-1.535000,16.217300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,16.256000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.018100,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,16.510000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.018100,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,16.764000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.018100,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.018100,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,17.018000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.018100,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.054000,-1.535000,9.918600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.480700,-1.535000,9.918600>}
box{<0,0,-0.127000><1.426700,0.035000,0.127000> rotate<0,0.000000,0> translate<17.054000,-1.535000,9.918600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.066600,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.271400,-1.535000,21.590000>}
box{<0,0,-0.127000><3.204800,0.035000,0.127000> rotate<0,0.000000,0> translate<17.066600,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.066600,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,24.384000>}
box{<0,0,-0.127000><1.783600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.066600,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,10.897300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,0.000000,10.617300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<17.145000,0.000000,10.897300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,10.897300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,-1.535000,10.617300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<17.145000,-1.535000,10.897300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,11.200600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,10.897300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.145000,0.000000,10.897300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,11.200600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,10.897300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.145000,-1.535000,10.897300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,0.000000,11.200600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.184300,0.000000,11.295200>}
box{<0,0,-0.127000><0.102439,0.035000,0.127000> rotate<0,-67.435919,0> translate<17.145000,0.000000,11.200600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.145000,-1.535000,11.200600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,-1.535000,11.480600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<17.145000,-1.535000,11.200600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.175700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.175700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.175700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.175700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.175700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.175700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.175700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,27.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,25.610800>}
box{<0,0,-0.127000><1.450400,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.180200,0.000000,25.610800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.180200,0.000000,27.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.284400,0.000000,27.165300>}
box{<0,0,-0.127000><0.147290,0.035000,0.127000> rotate<0,-44.969526,0> translate<17.180200,0.000000,27.061200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,0.000000,10.617300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,0.000000,10.403000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<17.261000,0.000000,10.617300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,-1.535000,10.617300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,-1.535000,10.403000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<17.261000,-1.535000,10.617300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.261000,-1.535000,11.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,-1.535000,11.694900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<17.261000,-1.535000,11.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,17.120900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,16.217300>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.271700,-1.535000,16.217300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.271700,-1.535000,17.120900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.052800,-1.535000,17.120900>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<17.271700,-1.535000,17.120900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.272300,-1.535000,15.963100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.272300,-1.535000,16.216700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<17.272300,-1.535000,16.216700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.272300,-1.535000,15.963100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.963100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.272300,-1.535000,15.963100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.272300,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,16.002000>}
box{<0,0,-0.127000><8.827900,0.035000,0.127000> rotate<0,0.000000,0> translate<17.272300,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.272300,-1.535000,16.216700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.216700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<17.272300,-1.535000,16.216700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.320600,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.525400,-1.535000,21.844000>}
box{<0,0,-0.127000><3.204800,0.035000,0.127000> rotate<0,0.000000,0> translate<17.320600,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.320600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.815300,0.000000,24.638000>}
box{<0,0,-0.127000><3.494700,0.035000,0.127000> rotate<0,0.000000,0> translate<17.320600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,0.000000,10.403000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,0.000000,10.287000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<17.475300,0.000000,10.403000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,-1.535000,10.403000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,-1.535000,10.287000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<17.475300,-1.535000,10.403000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.475300,-1.535000,11.694900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,-1.535000,11.810900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.475300,-1.535000,11.694900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.512800,0.000000,24.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.211200,0.000000,24.830200>}
box{<0,0,-0.127000><1.698400,0.035000,0.127000> rotate<0,0.000000,0> translate<17.512800,0.000000,24.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,16.375200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.513300,0.000000,14.104700>}
box{<0,0,-0.127000><2.270500,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.513300,0.000000,14.104700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<17.526000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.526000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,0.000000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,0.000000,19.184700>}
box{<0,0,-0.127000><0.016900,0.035000,0.127000> rotate<0,-90.000000,0> translate<17.526000,0.000000,19.184700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,0.000000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,0.000000,19.481600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<17.526000,0.000000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.526000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,-1.535000,19.481600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<17.526000,-1.535000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.567700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<17.567700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.574600,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.779300,-1.535000,22.098000>}
box{<0,0,-0.127000><3.204700,0.035000,0.127000> rotate<0,0.000000,0> translate<17.574600,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<17.642000,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,0.000000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,0.000000,19.695900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<17.642000,0.000000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.642000,-1.535000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,-1.535000,19.695900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<17.642000,-1.535000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,0.000000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,0.000000,10.287000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<17.755300,0.000000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,-1.535000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,-1.535000,10.287000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<17.755300,-1.535000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.755300,-1.535000,11.810900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,-1.535000,11.810900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<17.755300,-1.535000,11.810900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.828600,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.163400,-1.535000,22.352000>}
box{<0,0,-0.127000><4.334800,0.035000,0.127000> rotate<0,0.000000,0> translate<17.828600,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<17.856300,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,0.000000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,0.000000,19.811900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.856300,0.000000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.856300,-1.535000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,-1.535000,19.811900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.856300,-1.535000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.992200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.992200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.992200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<17.992200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.992200,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<17.992200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<17.992200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.021200,-1.535000,13.435200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,13.613700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.021200,-1.535000,13.435200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.048000,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.637300,-1.535000,13.462000>}
box{<0,0,-0.127000><9.589300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.048000,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.052800,-1.535000,17.120900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.897800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<18.052800,-1.535000,17.120900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,-1.535000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.096500,-1.535000,10.302700>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-22.500200,0> translate<18.058600,-1.535000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,0.000000,10.287000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,0.000000,10.403000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<18.058600,0.000000,10.287000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.058600,-1.535000,11.810900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,-1.535000,11.694900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<18.058600,-1.535000,11.810900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.082600,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,22.606000>}
box{<0,0,-0.127000><4.129700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.082600,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.096500,-1.535000,10.302700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.480700,-1.535000,9.918600>}
box{<0,0,-0.127000><0.543270,0.035000,0.127000> rotate<0,44.989573,0> translate<18.096500,-1.535000,10.302700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985400,0.000000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.114800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.985000,0.000000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.114800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.136300,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,0.000000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,0.000000,19.811900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.136300,0.000000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.136300,-1.535000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,-1.535000,19.811900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.136300,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.155700,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.385300,-1.535000,17.018000>}
box{<0,0,-0.127000><2.229600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.155700,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.179800,-1.535000,15.186000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,15.166200>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,44.852718,0> translate<18.179800,-1.535000,15.186000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.179800,-1.535000,15.186000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.282100>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.179800,-1.535000,15.186000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,13.613700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,15.166200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.199700,-1.535000,15.166200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.415900,-1.535000,13.716000>}
box{<0,0,-0.127000><10.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.321000,-1.535000,13.970000>}
box{<0,0,-0.127000><10.121300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.224000>}
box{<0,0,-0.127000><7.900500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.478000>}
box{<0,0,-0.127000><7.900500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.732000>}
box{<0,0,-0.127000><7.900500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.199700,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.986000>}
box{<0,0,-0.127000><7.900500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.199700,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.233800,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,15.240000>}
box{<0,0,-0.127000><7.866400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.233800,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.282100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.963100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,90.000000,0> translate<18.275900,-1.535000,15.963100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,15.494000>}
box{<0,0,-0.127000><7.824300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.275900,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,15.748000>}
box{<0,0,-0.127000><7.824300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.275900,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.216700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.897800>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,90.000000,0> translate<18.275900,-1.535000,16.897800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,16.256000>}
box{<0,0,-0.127000><11.061100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.275900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.432100,-1.535000,16.510000>}
box{<0,0,-0.127000><11.156200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.275900,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.275900,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.212100,-1.535000,16.764000>}
box{<0,0,-0.127000><7.936200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.275900,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,11.710600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,13.498400>}
box{<0,0,-0.127000><1.787800,0.035000,0.127000> rotate<0,90.000000,0> translate<18.300600,0.000000,13.498400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,11.710600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,0.000000,11.694900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<18.300600,0.000000,11.710600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,11.938000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,12.192000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,12.446000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,12.700000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,12.954000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,13.208000>}
box{<0,0,-0.127000><4.064100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.336900,0.000000,13.462000>}
box{<0,0,-0.127000><0.036300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,13.498400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,13.340200>}
box{<0,0,-0.127000><0.223658,0.035000,0.127000> rotate<0,45.015143,0> translate<18.300600,0.000000,13.498400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.441500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.768400>}
box{<0,0,-0.127000><0.326900,0.035000,0.127000> rotate<0,90.000000,0> translate<18.300600,0.000000,14.768400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.441500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,14.599700>}
box{<0,0,-0.127000><0.223658,0.035000,0.127000> rotate<0,-45.015143,0> translate<18.300600,0.000000,14.441500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.337100,0.000000,14.478000>}
box{<0,0,-0.127000><0.036500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.336900,0.000000,14.732000>}
box{<0,0,-0.127000><0.036300,0.035000,0.127000> rotate<0,0.000000,0> translate<18.300600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.300600,0.000000,14.768400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,14.610200>}
box{<0,0,-0.127000><0.223658,0.035000,0.127000> rotate<0,45.015143,0> translate<18.300600,0.000000,14.768400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.336600,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,22.860000>}
box{<0,0,-0.127000><3.875700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.336600,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,0.000000,10.403000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,0.000000,10.617300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.338600,0.000000,10.403000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,0.000000,11.694900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,0.000000,11.480600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<18.338600,0.000000,11.694900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.338600,-1.535000,11.694900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,-1.535000,11.480600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<18.338600,-1.535000,11.694900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.349500,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,11.684000>}
box{<0,0,-0.127000><4.015200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.349500,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.349500,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.684000>}
box{<0,0,-0.127000><7.431500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.349500,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.349600,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.414000>}
box{<0,0,-0.127000><4.015100,0.035000,0.127000> rotate<0,0.000000,0> translate<18.349600,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.384200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.384200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<18.384200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.384200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<18.384200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.384200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<18.384200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<18.439600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.385400,-1.535000,18.288000>}
box{<0,0,-0.127000><1.945800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.439600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,-1.535000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.477500,-1.535000,19.796100>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<18.439600,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.439600,0.000000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,0.000000,19.695900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<18.439600,0.000000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,13.340200>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.458700,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,14.599700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,14.599700>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.458700,0.000000,14.599700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.458700,0.000000,14.610200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,14.610200>}
box{<0,0,-0.127000><2.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.458700,0.000000,14.610200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.477500,-1.535000,19.796100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.561300,-1.535000,21.880000>}
box{<0,0,-0.127000><2.947009,0.035000,0.127000> rotate<0,-44.998405,0> translate<18.477500,-1.535000,19.796100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573400,0.000000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.526600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.573300,0.000000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.526600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.539100,-1.535000,9.131300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<18.539100,-1.535000,9.131300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.539100,-1.535000,9.131300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.560800,-1.535000,9.131300>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.539100,-1.535000,9.131300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.539100,-1.535000,28.968600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<18.539100,-1.535000,28.968600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.539100,-1.535000,28.968600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.560800,-1.535000,28.968600>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.539100,-1.535000,28.968600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,0.000000,10.617300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,10.897300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.552900,0.000000,10.617300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,0.000000,11.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,11.200600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<18.552900,0.000000,11.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.552900,-1.535000,11.480600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,11.200600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<18.552900,-1.535000,11.480600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.573900,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.668000>}
box{<0,0,-0.127000><3.790800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.573900,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.573900,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,11.430000>}
box{<0,0,-0.127000><3.790800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.573900,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.573900,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.875900,-1.535000,11.430000>}
box{<0,0,-0.127000><7.302000,0.035000,0.127000> rotate<0,0.000000,0> translate<18.573900,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.590600,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,23.114000>}
box{<0,0,-0.127000><3.621700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.590600,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.632900,0.000000,33.896300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.926300,0.000000,32.602900>}
box{<0,0,-0.127000><1.829144,0.035000,0.127000> rotate<0,44.997030,0> translate<18.632900,0.000000,33.896300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.653200,-1.535000,10.859400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,10.897300>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-67.493860,0> translate<18.653200,-1.535000,10.859400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.653200,-1.535000,10.859400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.213000,-1.535000,10.299600>}
box{<0,0,-0.127000><0.791677,0.035000,0.127000> rotate<0,44.997030,0> translate<18.653200,-1.535000,10.859400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,10.897300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,11.200600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<18.668900,0.000000,11.200600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,10.897300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,11.200600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<18.668900,-1.535000,11.200600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.922000>}
box{<0,0,-0.127000><3.695800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.668900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.288300,-1.535000,10.922000>}
box{<0,0,-0.127000><10.619400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.668900,-1.535000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,11.176000>}
box{<0,0,-0.127000><3.695800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.668900,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.668900,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100300,-1.535000,11.176000>}
box{<0,0,-0.127000><7.431400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.668900,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,15.869700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,15.880200>}
box{<0,0,-0.127000><0.010500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.681600,0.000000,15.880200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,15.869700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,15.869700>}
box{<0,0,-0.127000><2.229600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,15.869700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,15.880200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,15.880200>}
box{<0,0,-0.127000><2.229600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,15.880200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,17.139700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,18.388300>}
box{<0,0,-0.127000><1.248600,0.035000,0.127000> rotate<0,90.000000,0> translate<18.681600,0.000000,18.388300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,17.139700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.758000,0.000000,17.139700>}
box{<0,0,-0.127000><1.076400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,17.139700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.890300,0.000000,17.272000>}
box{<0,0,-0.127000><1.208700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.526000>}
box{<0,0,-0.127000><1.384400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.780000>}
box{<0,0,-0.127000><1.384400,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.161100,0.000000,18.034000>}
box{<0,0,-0.127000><1.479500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.385400,0.000000,18.288000>}
box{<0,0,-0.127000><1.703800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.681600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.681600,0.000000,18.388300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,0.000000,18.404000>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<18.681600,0.000000,18.388300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.684300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.684300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<18.684300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<18.684300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.684300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.684300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<18.684300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.684300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<18.684300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,0.000000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,0.000000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.719600,0.000000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.719600,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.719600,0.000000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,0.000000,19.481600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<18.719600,0.000000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375700,0.000000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375800,0.000000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.724200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.375800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<18.724200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270400,0.000000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270600,0.000000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.829400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.270600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.829400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.844600,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.542300,-1.535000,10.668000>}
box{<0,0,-0.127000><10.697700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.844600,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.844600,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,23.368000>}
box{<0,0,-0.127000><3.367700,0.035000,0.127000> rotate<0,0.000000,0> translate<18.844600,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.846700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.846700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.846700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<18.846700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.846700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<18.846700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,21.283700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,21.105200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<18.850200,0.000000,21.283700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,21.450300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,21.283700>}
box{<0,0,-0.127000><0.166600,0.035000,0.127000> rotate<0,-90.000000,0> translate<18.850200,0.000000,21.283700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,22.536200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,22.237600>}
box{<0,0,-0.127000><0.298600,0.035000,0.127000> rotate<0,-90.000000,0> translate<18.850200,0.000000,22.237600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,22.536200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,22.714700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.850200,0.000000,22.536200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,23.183700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,23.005200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<18.850200,0.000000,23.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,24.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,23.183700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,-90.000000,0> translate<18.850200,0.000000,23.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.850200,0.000000,24.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,24.614700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<18.850200,0.000000,24.436200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.857500,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.558000>}
box{<0,0,-0.127000><1.602200,0.035000,0.127000> rotate<0,0.000000,0> translate<18.857500,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.857600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.508500,0.000000,18.542000>}
box{<0,0,-0.127000><1.650900,0.035000,0.127000> rotate<0,0.000000,0> translate<18.857600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.857600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.160400,-1.535000,18.542000>}
box{<0,0,-0.127000><2.302800,0.035000,0.127000> rotate<0,0.000000,0> translate<18.857600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,0.000000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,0.000000,18.898300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.933900,0.000000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<18.933900,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.933900,0.000000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,0.000000,19.201600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<18.933900,0.000000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<18.959000,0.000000,34.683600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.189600,0.000000,34.453000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<18.959000,0.000000,34.683600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.007500,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,18.796000>}
box{<0,0,-0.127000><1.452200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.007500,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.007500,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.414400,-1.535000,18.796000>}
box{<0,0,-0.127000><2.406900,0.035000,0.127000> rotate<0,0.000000,0> translate<19.007500,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.007500,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.304000>}
box{<0,0,-0.127000><1.452200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.007500,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,21.105200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,21.105200>}
box{<0,0,-0.127000><1.431000,0.035000,0.127000> rotate<0,0.000000,0> translate<19.028700,0.000000,21.105200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,22.714700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.272900,0.000000,22.714700>}
box{<0,0,-0.127000><1.244200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.028700,0.000000,22.714700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,23.005200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.982300,0.000000,23.005200>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<19.028700,0.000000,23.005200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.028700,0.000000,24.614700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.681200,0.000000,24.614700>}
box{<0,0,-0.127000><1.652500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.028700,0.000000,24.614700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.034100,-1.535000,19.239500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,-1.535000,19.201600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<19.034100,-1.535000,19.239500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.034100,-1.535000,19.239500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.118000,-1.535000,21.323300>}
box{<0,0,-0.127000><2.947009,0.035000,0.127000> rotate<0,-44.995656,0> translate<19.034100,-1.535000,19.239500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,0.000000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,0.000000,19.201600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<19.049900,0.000000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,-1.535000,19.201600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<19.049900,-1.535000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.050000>}
box{<0,0,-0.127000><1.409800,0.035000,0.127000> rotate<0,0.000000,0> translate<19.049900,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.049900,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.668400,-1.535000,19.050000>}
box{<0,0,-0.127000><2.618500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.049900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.098600,-1.535000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.796200,-1.535000,10.414000>}
box{<0,0,-0.127000><10.697600,0.035000,0.127000> rotate<0,0.000000,0> translate<19.098600,-1.535000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.098600,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.922300,-1.535000,19.304000>}
box{<0,0,-0.127000><2.823700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.098600,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.098600,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,23.622000>}
box{<0,0,-0.127000><3.113700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.098600,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.098600,0.000000,34.544000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,34.544000>}
box{<0,0,-0.127000><66.131200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.098600,0.000000,34.544000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.189600,0.000000,34.453000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.483000,0.000000,33.159600>}
box{<0,0,-0.127000><1.829144,0.035000,0.127000> rotate<0,44.997030,0> translate<19.189600,0.000000,34.453000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.211200,0.000000,24.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.008700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<19.211200,0.000000,24.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.213000,-1.535000,10.299600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.910700,-1.535000,10.299600>}
box{<0,0,-0.127000><10.697700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.213000,-1.535000,10.299600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<19.253200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<19.253200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<19.253200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<19.253200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<19.253200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<19.253200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<19.253200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<19.253200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<19.253200,0.000000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<19.253200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<19.253200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.253200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<19.253200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.273000,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.096900,0.000000,24.892000>}
box{<0,0,-0.127000><0.823900,0.035000,0.127000> rotate<0,0.000000,0> translate<19.273000,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.285500,0.000000,27.165300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,27.061200>}
box{<0,0,-0.127000><0.147290,0.035000,0.127000> rotate<0,44.969526,0> translate<19.285500,0.000000,27.165300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.285500,0.000000,27.165300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.084400,0.000000,27.165300>}
box{<0,0,-0.127000><0.798900,0.035000,0.127000> rotate<0,0.000000,0> translate<19.285500,0.000000,27.165300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.352600,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.767400,-1.535000,19.558000>}
box{<0,0,-0.127000><9.414800,0.035000,0.127000> rotate<0,0.000000,0> translate<19.352600,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.352600,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,23.876000>}
box{<0,0,-0.127000><2.859700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.352600,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.352600,0.000000,34.290000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,34.290000>}
box{<0,0,-0.127000><65.877200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.352600,0.000000,34.290000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.008700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,27.061200>}
box{<0,0,-0.127000><2.052500,0.035000,0.127000> rotate<0,90.000000,0> translate<19.389700,0.000000,27.061200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.146000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.400000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.654000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.908000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,26.162000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,26.416000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,26.670000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.389700,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,26.924000>}
box{<0,0,-0.127000><0.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<19.389700,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<19.415600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<19.415600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.560800,-1.535000,9.131300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<19.415600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<19.415600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.560800,-1.535000,28.968600>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<19.415600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<19.415600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<19.415600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.415600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<19.415600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.606600,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.464000,-1.535000,19.812000>}
box{<0,0,-0.127000><9.857400,0.035000,0.127000> rotate<0,0.000000,0> translate<19.606600,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.606600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.130000>}
box{<0,0,-0.127000><2.605700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.606600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.606600,0.000000,34.036000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,34.036000>}
box{<0,0,-0.127000><65.623200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.606600,0.000000,34.036000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<19.715700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<19.715700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<19.715700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<19.715700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<19.715700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.715700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<19.715700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.758000,0.000000,17.139700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.081700,0.000000,17.463400>}
box{<0,0,-0.127000><0.457781,0.035000,0.127000> rotate<0,-44.997030,0> translate<19.758000,0.000000,17.139700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.860600,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.506500,-1.535000,20.066000>}
box{<0,0,-0.127000><9.645900,0.035000,0.127000> rotate<0,0.000000,0> translate<19.860600,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.860600,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.384000>}
box{<0,0,-0.127000><2.351700,0.035000,0.127000> rotate<0,0.000000,0> translate<19.860600,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.860600,0.000000,33.782000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,33.782000>}
box{<0,0,-0.127000><65.369200,0.035000,0.127000> rotate<0,0.000000,0> translate<19.860600,0.000000,33.782000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.926300,0.000000,32.602900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.156900,0.000000,32.372300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<19.926300,0.000000,32.602900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.008700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.158700,0.000000,24.830200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<19.980200,0.000000,25.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,27.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,25.008700>}
box{<0,0,-0.127000><2.052500,0.035000,0.127000> rotate<0,-90.000000,0> translate<19.980200,0.000000,25.008700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.980200,0.000000,27.061200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.084400,0.000000,27.165300>}
box{<0,0,-0.127000><0.147290,0.035000,0.127000> rotate<0,-44.969526,0> translate<19.980200,0.000000,27.061200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<19.982300,0.000000,23.005200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.272900,0.000000,22.714700>}
box{<0,0,-0.127000><0.410900,0.035000,0.127000> rotate<0,44.987171,0> translate<19.982300,0.000000,23.005200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.501300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.081700,0.000000,17.463400>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,67.493860,0> translate<20.066000,0.000000,17.501300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.501300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,-1.535000,17.221300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<20.066000,-1.535000,17.501300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.804600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.501300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<20.066000,0.000000,17.501300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.804600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.501300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<20.066000,-1.535000,17.501300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,0.000000,17.804600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,0.000000,18.084600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<20.066000,0.000000,17.804600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.066000,-1.535000,17.804600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,-1.535000,18.084600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<20.066000,-1.535000,17.804600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.220600,0.000000,32.308700>}
box{<0,0,-0.127000><0.112900,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.107700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<20.107700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.114600,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.656400,-1.535000,20.320000>}
box{<0,0,-0.127000><9.541800,0.035000,0.127000> rotate<0,0.000000,0> translate<20.114600,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.114600,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.638000>}
box{<0,0,-0.127000><2.097700,0.035000,0.127000> rotate<0,0.000000,0> translate<20.114600,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.114600,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,33.528000>}
box{<0,0,-0.127000><62.036200,0.035000,0.127000> rotate<0,0.000000,0> translate<20.114600,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.156900,0.000000,32.372300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.220600,0.000000,32.308700>}
box{<0,0,-0.127000><0.090015,0.035000,0.127000> rotate<0,44.952025,0> translate<20.156900,0.000000,32.372300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.158700,0.000000,24.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.815300,0.000000,24.830200>}
box{<0,0,-0.127000><0.656600,0.035000,0.127000> rotate<0,0.000000,0> translate<20.158700,0.000000,24.830200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,-1.535000,17.221300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,-1.535000,17.007000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<20.182000,-1.535000,17.221300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,0.000000,18.084600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,0.000000,18.298900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.182000,0.000000,18.084600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.182000,-1.535000,18.084600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,-1.535000,18.298900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.182000,-1.535000,18.084600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.368600,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.989900,-1.535000,20.574000>}
box{<0,0,-0.127000><11.621300,0.035000,0.127000> rotate<0,0.000000,0> translate<20.368600,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.368600,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.303300,-1.535000,24.892000>}
box{<0,0,-0.127000><1.934700,0.035000,0.127000> rotate<0,0.000000,0> translate<20.368600,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.368600,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,33.274000>}
box{<0,0,-0.127000><56.612400,0.035000,0.127000> rotate<0,0.000000,0> translate<20.368600,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,-1.535000,17.007000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.676300,-1.535000,16.891000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<20.396300,-1.535000,17.007000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,0.000000,18.298900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.647600,0.000000,18.403000>}
box{<0,0,-0.127000><0.272008,0.035000,0.127000> rotate<0,-22.500097,0> translate<20.396300,0.000000,18.298900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.396300,-1.535000,18.298900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.676300,-1.535000,18.414900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<20.396300,-1.535000,18.298900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,18.590800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.647600,0.000000,18.403000>}
box{<0,0,-0.127000><0.265660,0.035000,0.127000> rotate<0,44.981781,0> translate<20.459700,0.000000,18.590800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.001100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,18.590800>}
box{<0,0,-0.127000><0.410300,0.035000,0.127000> rotate<0,-90.000000,0> translate<20.459700,0.000000,18.590800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,21.105200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.459700,0.000000,19.001100>}
box{<0,0,-0.127000><2.104100,0.035000,0.127000> rotate<0,-90.000000,0> translate<20.459700,0.000000,19.001100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.483000,0.000000,33.159600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.743000,0.000000,33.159600>}
box{<0,0,-0.127000><48.260000,0.035000,0.127000> rotate<0,0.000000,0> translate<20.483000,0.000000,33.159600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<20.532200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<20.532200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<20.532200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<20.532200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.532200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<20.532200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.561300,-1.535000,21.880000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.791900,-1.535000,22.110600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.561300,-1.535000,21.880000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.622600,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,20.828000>}
box{<0,0,-0.127000><11.342600,0.035000,0.127000> rotate<0,0.000000,0> translate<20.622600,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.622600,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.005400,-1.535000,25.146000>}
box{<0,0,-0.127000><7.382800,0.035000,0.127000> rotate<0,0.000000,0> translate<20.622600,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.654600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.525400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<20.654600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.654600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.525400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<20.654600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.654800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.525000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<20.654800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.654800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.525000,-1.535000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<20.654800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.654800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.287200,0.000000,28.702000>}
box{<0,0,-0.127000><0.632400,0.035000,0.127000> rotate<0,0.000000,0> translate<20.654800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.676300,-1.535000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.979600,-1.535000,16.891000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<20.676300,-1.535000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.676300,-1.535000,18.414900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.979600,-1.535000,18.414900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<20.676300,-1.535000,18.414900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.681200,0.000000,24.614700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.815300,0.000000,24.480500>}
box{<0,0,-0.127000><0.189717,0.035000,0.127000> rotate<0,45.018384,0> translate<20.681200,0.000000,24.614700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.791900,-1.535000,22.110600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.944300,-1.535000,22.110600>}
box{<0,0,-0.127000><1.152400,0.035000,0.127000> rotate<0,0.000000,0> translate<20.791900,-1.535000,22.110600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.815300,0.000000,24.830200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.815300,0.000000,24.480500>}
box{<0,0,-0.127000><0.349700,0.035000,0.127000> rotate<0,-90.000000,0> translate<20.815300,0.000000,24.480500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.876600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.163300,-1.535000,21.082000>}
box{<0,0,-0.127000><1.286700,0.035000,0.127000> rotate<0,0.000000,0> translate<20.876600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.876600,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.780300,-1.535000,25.400000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<20.876600,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,13.340200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,13.518700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.911200,0.000000,13.340200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,14.599700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.421200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<20.911200,0.000000,14.599700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,14.610200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.788700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.911200,0.000000,14.610200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,15.869700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,15.691200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<20.911200,0.000000,15.869700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.911200,0.000000,15.880200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.058700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.911200,0.000000,15.880200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.924200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<20.924200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<20.924200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.069300,0.000000,28.958800>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-45.016766,0> translate<20.924200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.924200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<20.924200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.979600,-1.535000,16.891000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.259600,-1.535000,17.007000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<20.979600,-1.535000,16.891000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<20.979600,-1.535000,18.414900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.017500,-1.535000,18.399100>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<20.979600,-1.535000,18.414900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.017500,-1.535000,18.399100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.831300,-1.535000,19.213000>}
box{<0,0,-0.127000><1.150958,0.035000,0.127000> rotate<0,-45.000550,0> translate<21.017500,-1.535000,18.399100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.032900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,14.478000>}
box{<0,0,-0.127000><1.331800,0.035000,0.127000> rotate<0,0.000000,0> translate<21.032900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.032900,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,15.748000>}
box{<0,0,-0.127000><1.331800,0.035000,0.127000> rotate<0,0.000000,0> translate<21.032900,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.033000,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,13.462000>}
box{<0,0,-0.127000><1.331700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.033000,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.033000,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,14.732000>}
box{<0,0,-0.127000><1.331700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.033000,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.033000,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,16.002000>}
box{<0,0,-0.127000><1.331700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.033000,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.066500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.113400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<21.066500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.066500,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.069300,0.000000,28.956000>}
box{<0,0,-0.127000><0.002800,0.035000,0.127000> rotate<0,0.000000,0> translate<21.066500,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.066500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.113400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<21.066500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.066600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.113300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.066600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.066600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.113300,-1.535000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.066600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.069300,0.000000,28.919900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.299900,0.000000,28.689300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<21.069300,0.000000,28.919900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.069300,0.000000,28.958800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.069300,0.000000,28.919900>}
box{<0,0,-0.127000><0.038900,0.035000,0.127000> rotate<0,-90.000000,0> translate<21.069300,0.000000,28.919900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.079100,-1.535000,9.131300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,8.986200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<21.079100,-1.535000,9.131300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.079100,-1.535000,9.131300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.100800,-1.535000,9.131300>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.079100,-1.535000,9.131300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,13.518700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.421200>}
box{<0,0,-0.127000><0.902500,0.035000,0.127000> rotate<0,90.000000,0> translate<21.089700,0.000000,14.421200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,13.716000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,13.970000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,14.224000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.788700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,15.691200>}
box{<0,0,-0.127000><0.902500,0.035000,0.127000> rotate<0,90.000000,0> translate<21.089700,0.000000,15.691200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,14.986000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,15.240000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,15.494000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.058700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.936600>}
box{<0,0,-0.127000><0.877900,0.035000,0.127000> rotate<0,90.000000,0> translate<21.089700,0.000000,16.936600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,16.256000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,16.510000>}
box{<0,0,-0.127000><1.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.286500,0.000000,16.764000>}
box{<0,0,-0.127000><1.196800,0.035000,0.127000> rotate<0,0.000000,0> translate<21.089700,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.089700,0.000000,16.936600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.259600,0.000000,17.007000>}
box{<0,0,-0.127000><0.183908,0.035000,0.127000> rotate<0,-22.505744,0> translate<21.089700,0.000000,16.936600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.118000,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.944300,-1.535000,21.323300>}
box{<0,0,-0.127000><0.826300,0.035000,0.127000> rotate<0,0.000000,0> translate<21.118000,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.130600,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.034300,-1.535000,25.654000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.130600,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.224300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.224300,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<21.224300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<21.224300,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.224300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<21.224300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.259600,0.000000,17.007000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.473900,0.000000,17.221300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.259600,0.000000,17.007000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.259600,-1.535000,17.007000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.473900,-1.535000,17.221300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.259600,-1.535000,17.007000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.264100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.915700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.264100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.264100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.915700,-1.535000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.264100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.264200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.915800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.264200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.264200,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.915800,-1.535000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.264200,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.264200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.915800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.264200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.270600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.032500,0.000000,17.018000>}
box{<0,0,-0.127000><0.761900,0.035000,0.127000> rotate<0,0.000000,0> translate<21.270600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.270600,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.018000>}
box{<0,0,-0.127000><4.753400,0.035000,0.127000> rotate<0,0.000000,0> translate<21.270600,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.299900,0.000000,28.689300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,27.029000>}
box{<0,0,-0.127000><2.348019,0.035000,0.127000> rotate<0,44.997030,0> translate<21.299900,0.000000,28.689300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.369400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.810400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.369400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.369400,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.810400,-1.535000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.369400,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.369400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.810600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<21.369400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.369400,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.810600,-1.535000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<21.369400,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.369400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.810600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<21.369400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.384600,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.288300,-1.535000,25.908000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.384600,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<21.386700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<21.386700,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<21.386700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,29.969900>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<21.386700,-1.535000,29.563300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.541400,-1.535000,29.718000>}
box{<0,0,-0.127000><0.154700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.386700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<21.386700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.473900,0.000000,17.221300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.578000,0.000000,17.472600>}
box{<0,0,-0.127000><0.272008,0.035000,0.127000> rotate<0,-67.493963,0> translate<21.473900,0.000000,17.221300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.473900,-1.535000,17.221300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.501300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.473900,-1.535000,17.221300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.494900,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.778500,0.000000,17.272000>}
box{<0,0,-0.127000><0.283600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.494900,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.494900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.272000>}
box{<0,0,-0.127000><4.529100,0.035000,0.127000> rotate<0,0.000000,0> translate<21.494900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.574100,-1.535000,17.842500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.804600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<21.574100,-1.535000,17.842500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.574100,-1.535000,17.842500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.388000,-1.535000,18.656300>}
box{<0,0,-0.127000><1.150958,0.035000,0.127000> rotate<0,-44.993510,0> translate<21.574100,-1.535000,17.842500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.578000,0.000000,17.472600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,16.685800>}
box{<0,0,-0.127000><1.112633,0.035000,0.127000> rotate<0,45.000671,0> translate<21.578000,0.000000,17.472600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.501300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.804600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<21.589900,-1.535000,17.804600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.526000>}
box{<0,0,-0.127000><4.434100,0.035000,0.127000> rotate<0,0.000000,0> translate<21.589900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.589900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.780000>}
box{<0,0,-0.127000><4.434100,0.035000,0.127000> rotate<0,0.000000,0> translate<21.589900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.638600,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.542300,-1.535000,26.162000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.638600,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.765600,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.177600,-1.535000,18.034000>}
box{<0,0,-0.127000><5.412000,0.035000,0.127000> rotate<0,0.000000,0> translate<21.765600,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<21.793200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<21.793200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<21.793200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<21.793200,-1.535000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.793200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.793200,-1.535000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,29.969900>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,-90.000000,0> translate<21.793200,-1.535000,29.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.793200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<21.793200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.831300,-1.535000,19.213000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.061900,-1.535000,19.443600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.831300,-1.535000,19.213000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.880000,0.000000,27.952600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.110600,0.000000,27.722000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<21.880000,0.000000,27.952600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.892600,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.796300,-1.535000,26.416000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<21.892600,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.892600,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.049200,0.000000,27.940000>}
box{<0,0,-0.127000><0.156600,0.035000,0.127000> rotate<0,0.000000,0> translate<21.892600,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.944300,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.960000,-1.535000,21.285300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<21.944300,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.944300,-1.535000,22.110600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.960000,-1.535000,22.148600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<21.944300,-1.535000,22.110600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<21.955600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<21.955600,-1.535000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.100800,-1.535000,9.131300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<21.955600,-1.535000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.955600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.955600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.955600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.960000,-1.535000,21.285300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.174300,-1.535000,21.071000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<21.960000,-1.535000,21.285300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<21.960000,-1.535000,22.148600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.174300,-1.535000,22.362900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<21.960000,-1.535000,22.148600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.019600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.288000>}
box{<0,0,-0.127000><4.004400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.019600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.061900,-1.535000,19.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.675300,-1.535000,19.443600>}
box{<0,0,-0.127000><6.613400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.061900,-1.535000,19.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.110600,0.000000,27.722000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,27.214000>}
box{<0,0,-0.127000><0.718420,0.035000,0.127000> rotate<0,44.997030,0> translate<22.110600,0.000000,27.722000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.146600,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.050300,-1.535000,26.670000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.146600,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.146600,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.303200,0.000000,27.686000>}
box{<0,0,-0.127000><0.156600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.146600,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.174300,-1.535000,21.071000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.454300,-1.535000,20.955000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<22.174300,-1.535000,21.071000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.174300,-1.535000,22.362900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,22.378600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<22.174300,-1.535000,22.362900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.474900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,22.378600>}
box{<0,0,-0.127000><2.096300,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.212300,-1.535000,22.378600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.801000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.474900>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.212300,-1.535000,24.474900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.212300,-1.535000,24.801000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.442900,-1.535000,25.031600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<22.212300,-1.535000,24.801000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<22.255700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<22.255700,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<22.255700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.255700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<22.255700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.273600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.542000>}
box{<0,0,-0.127000><3.750400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.273600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,9.827800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.743900,0.000000,9.448700>}
box{<0,0,-0.127000><0.536199,0.035000,0.127000> rotate<0,44.989475,0> translate<22.364700,0.000000,9.827800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.238100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,9.827800>}
box{<0,0,-0.127000><0.410300,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.364700,0.000000,9.827800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,16.685800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.364700,0.000000,10.238100>}
box{<0,0,-0.127000><6.447700,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.364700,0.000000,10.238100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.388000,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.656300>}
box{<0,0,-0.127000><3.636000,0.035000,0.127000> rotate<0,0.000000,0> translate<22.388000,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.400600,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.304300,-1.535000,26.924000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.400600,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.400600,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.557200,0.000000,27.432000>}
box{<0,0,-0.127000><0.156600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.400600,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.442900,-1.535000,25.031600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.913300,-1.535000,25.031600>}
box{<0,0,-0.127000><5.470400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.442900,-1.535000,25.031600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.454300,-1.535000,20.955000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.757600,-1.535000,20.955000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<22.454300,-1.535000,20.955000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,24.801000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.887900>}
box{<0,0,-0.127000><2.086900,0.035000,0.127000> rotate<0,90.000000,0> translate<22.618600,0.000000,26.887900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,24.801000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.535500>}
box{<0,0,-0.127000><0.375403,0.035000,0.127000> rotate<0,45.007822,0> translate<22.618600,0.000000,24.801000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.892000>}
box{<0,0,-0.127000><0.265400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,25.146000>}
box{<0,0,-0.127000><0.265400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,25.400000>}
box{<0,0,-0.127000><0.265400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,25.654000>}
box{<0,0,-0.127000><0.265400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,25.908000>}
box{<0,0,-0.127000><0.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,26.162000>}
box{<0,0,-0.127000><0.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,26.416000>}
box{<0,0,-0.127000><0.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,26.670000>}
box{<0,0,-0.127000><0.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.887900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,27.214000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<22.618600,0.000000,27.214000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,26.924000>}
box{<0,0,-0.127000><0.341600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.618600,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.811200,0.000000,27.178000>}
box{<0,0,-0.127000><0.192600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.618600,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<22.647700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,-1.535000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<22.647700,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.743900,0.000000,9.448700>}
box{<0,0,-0.127000><0.096200,0.035000,0.127000> rotate<0,0.000000,0> translate<22.647700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.647700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<22.647700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.654600,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.558300,-1.535000,27.178000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.654600,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.757600,-1.535000,20.955000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.037600,-1.535000,21.071000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<22.757600,-1.535000,20.955000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.781600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.638000>}
box{<0,0,-0.127000><0.102400,0.035000,0.127000> rotate<0,0.000000,0> translate<22.781600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.638100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.535500>}
box{<0,0,-0.127000><0.102600,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.884000,0.000000,24.535500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.638100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.787600,0.000000,24.638100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.884000,0.000000,24.638100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.891700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.787600,0.000000,24.891700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<22.884000,0.000000,24.891700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,25.672800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,24.891700>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.884000,0.000000,24.891700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.884000,0.000000,25.672800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.982600,0.000000,25.771400>}
box{<0,0,-0.127000><0.139441,0.035000,0.127000> rotate<0,-44.997030,0> translate<22.884000,0.000000,25.672800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.908600,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.812300,-1.535000,27.432000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.908600,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,25.793700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.982600,0.000000,25.771400>}
box{<0,0,-0.127000><0.031608,0.035000,0.127000> rotate<0,44.868860,0> translate<22.960200,0.000000,25.793700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,27.029000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.960200,0.000000,25.793700>}
box{<0,0,-0.127000><1.235300,0.035000,0.127000> rotate<0,-90.000000,0> translate<22.960200,0.000000,25.793700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,22.378600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,24.244300>}
box{<0,0,-0.127000><1.865700,0.035000,0.127000> rotate<0,90.000000,0> translate<22.999600,-1.535000,24.244300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,22.378600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.037600,-1.535000,22.362900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<22.999600,-1.535000,22.378600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.068400,-1.535000,22.606000>}
box{<0,0,-0.127000><1.068800,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,22.860000>}
box{<0,0,-0.127000><1.117700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,23.114000>}
box{<0,0,-0.127000><1.117700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,23.368000>}
box{<0,0,-0.127000><1.117700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.208300,-1.535000,23.622000>}
box{<0,0,-0.127000><1.208700,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.462400,-1.535000,23.876000>}
box{<0,0,-0.127000><1.462800,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.716400,-1.535000,24.130000>}
box{<0,0,-0.127000><1.716800,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<22.999600,-1.535000,24.244300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.830700,-1.535000,24.244300>}
box{<0,0,-0.127000><1.831100,0.035000,0.127000> rotate<0,0.000000,0> translate<22.999600,-1.535000,24.244300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.037600,-1.535000,21.071000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.251900,-1.535000,21.285300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<23.037600,-1.535000,21.071000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.037600,-1.535000,22.362900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.251900,-1.535000,22.148600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<23.037600,-1.535000,22.362900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.048500,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.844100,-1.535000,22.352000>}
box{<0,0,-0.127000><0.795600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.048500,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.048600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,21.082000>}
box{<0,0,-0.127000><8.916600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.048600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<23.072200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,-1.535000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,-1.535000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<23.072200,-1.535000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.072200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<23.072200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.162600,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.066300,-1.535000,27.686000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.162600,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.194600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.065400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<23.194600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.194800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,5.842000>}
box{<0,0,-0.127000><0.566900,0.035000,0.127000> rotate<0,0.000000,0> translate<23.194800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.194800,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.081200,-1.535000,5.842000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<23.194800,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.251900,-1.535000,21.285300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.565300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<23.251900,-1.535000,21.285300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.251900,-1.535000,22.148600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.868600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<23.251900,-1.535000,22.148600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.272900,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.068300,-1.535000,21.336000>}
box{<0,0,-0.127000><0.795400,0.035000,0.127000> rotate<0,0.000000,0> translate<23.272900,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.272900,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,22.098000>}
box{<0,0,-0.127000><0.476100,0.035000,0.127000> rotate<0,0.000000,0> translate<23.272900,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.565300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.868600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<23.367900,-1.535000,21.868600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.843900,-1.535000,21.590000>}
box{<0,0,-0.127000><0.476000,0.035000,0.127000> rotate<0,0.000000,0> translate<23.367900,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.367900,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,21.844000>}
box{<0,0,-0.127000><0.381100,0.035000,0.127000> rotate<0,0.000000,0> translate<23.367900,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.416600,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.320300,-1.535000,27.940000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.416600,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,-1.535000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.716900,-1.535000,6.206400>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,-45.008364,0> translate<23.464200,-1.535000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,6.251200>}
box{<0,0,-0.127000><0.420799,0.035000,0.127000> rotate<0,-45.006657,0> translate<23.464200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.464200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.764300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<23.464200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.606500,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,6.096000>}
box{<0,0,-0.127000><0.155200,0.035000,0.127000> rotate<0,0.000000,0> translate<23.606500,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.606500,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.827200,-1.535000,6.096000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.606500,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.606500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.653400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<23.606500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.670600,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.574300,-1.535000,28.194000>}
box{<0,0,-0.127000><7.903700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.670600,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.716900,-1.535000,6.206400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.133300,-1.535000,4.789900>}
box{<0,0,-0.127000><2.003163,0.035000,0.127000> rotate<0,44.999053,0> translate<23.716900,-1.535000,6.206400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,21.819300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.865000,-1.535000,21.539300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<23.749000,-1.535000,21.819300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,22.122600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,21.819300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<23.749000,-1.535000,21.819300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.749000,-1.535000,22.122600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.865000,-1.535000,22.402600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<23.749000,-1.535000,22.122600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,16.419000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,17.360200>}
box{<0,0,-0.127000><0.941200,0.035000,0.127000> rotate<0,90.000000,0> translate<23.761600,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,16.419000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.566000,0.000000,12.614500>}
box{<0,0,-0.127000><5.380305,0.035000,0.127000> rotate<0,44.997783,0> translate<23.761600,0.000000,16.419000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,16.510000>}
box{<0,0,-0.127000><3.276700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.761600,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,16.764000>}
box{<0,0,-0.127000><3.276700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.761600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,17.018000>}
box{<0,0,-0.127000><3.276700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.761600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,17.272000>}
box{<0,0,-0.127000><3.276700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.761600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761600,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.056200,0.000000,17.360200>}
box{<0,0,-0.127000><0.294600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.761600,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,5.636800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.250700,0.000000,1.147900>}
box{<0,0,-0.127000><6.348334,0.035000,0.127000> rotate<0,44.996392,0> translate<23.761700,0.000000,5.636800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,6.047100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,5.636800>}
box{<0,0,-0.127000><0.410300,0.035000,0.127000> rotate<0,-90.000000,0> translate<23.761700,0.000000,5.636800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,6.251200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.761700,0.000000,6.047100>}
box{<0,0,-0.127000><0.204100,0.035000,0.127000> rotate<0,-90.000000,0> translate<23.761700,0.000000,6.047100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.764300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<23.764300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.785500,0.000000,23.634000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,23.634000>}
box{<0,0,-0.127000><0.002600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.785500,0.000000,23.634000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.785500,0.000000,23.634000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,22.769000>}
box{<0,0,-0.127000><1.223365,0.035000,0.127000> rotate<0,44.993719,0> translate<23.785500,0.000000,23.634000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.787600,0.000000,24.891700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.787600,0.000000,24.638100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<23.787600,0.000000,24.638100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,23.634000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,24.637600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<23.788100,0.000000,24.637600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.788100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.788100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.788100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.788100,0.000000,24.637600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,24.637600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.788100,0.000000,24.637600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.797600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.240200,0.000000,23.622000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.797600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.804200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.455800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<23.804200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.865000,-1.535000,21.539300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.079300,-1.535000,21.325000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<23.865000,-1.535000,21.539300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.865000,-1.535000,22.402600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.079300,-1.535000,22.616900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<23.865000,-1.535000,22.402600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.909400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.350600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<23.909400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.924600,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,16.256000>}
box{<0,0,-0.127000><3.113700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.924600,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.924600,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.752400,-1.535000,28.448000>}
box{<0,0,-0.127000><11.827800,0.035000,0.127000> rotate<0,0.000000,0> translate<23.924600,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<23.926700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,29.969900>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<23.926700,-1.535000,29.563300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.081400,-1.535000,29.718000>}
box{<0,0,-0.127000><0.154700,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<23.926700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<23.926700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,23.634000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.722800,0.000000,23.634000>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<24.041700,0.000000,23.634000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,24.637600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.041700,0.000000,23.634000>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<24.041700,0.000000,23.634000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.051600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.494200,0.000000,23.368000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<24.051600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.056200,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.130000,0.000000,17.434000>}
box{<0,0,-0.127000><0.104369,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.056200,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.079300,-1.535000,21.325000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.359300,-1.535000,21.209000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<24.079300,-1.535000,21.325000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.079300,-1.535000,22.616900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,22.632600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<24.079300,-1.535000,22.616900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,23.531000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,22.632600>}
box{<0,0,-0.127000><0.898400,0.035000,0.127000> rotate<0,-90.000000,0> translate<24.117300,-1.535000,22.632600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.117300,-1.535000,23.531000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.347900,-1.535000,23.761600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.117300,-1.535000,23.531000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.130000,0.000000,17.434000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.203700,0.000000,17.360200>}
box{<0,0,-0.127000><0.104298,0.035000,0.127000> rotate<0,45.035872,0> translate<24.130000,0.000000,17.434000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.178600,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,16.002000>}
box{<0,0,-0.127000><2.859700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.178600,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.178600,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.065000,-1.535000,28.702000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<24.178600,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.203700,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.756200,0.000000,17.360200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<24.203700,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.305600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.748200,0.000000,23.114000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<24.305600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,29.969900>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,-90.000000,0> translate<24.333200,-1.535000,29.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.333200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.495600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<24.333200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.347900,-1.535000,23.761600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.830700,-1.535000,24.244300>}
box{<0,0,-0.127000><0.682712,0.035000,0.127000> rotate<0,-44.991096,0> translate<24.347900,-1.535000,23.761600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.359300,-1.535000,21.209000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,-1.535000,21.209000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<24.359300,-1.535000,21.209000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.432600,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,15.748000>}
box{<0,0,-0.127000><2.605700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.432600,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.432600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.653300,-1.535000,28.956000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.432600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.495600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.795700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.495600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.543000,-1.535000,29.066400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.795700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,45.008364,0> translate<24.543000,-1.535000,29.066400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.559600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.002200,0.000000,22.860000>}
box{<0,0,-0.127000><2.442600,0.035000,0.127000> rotate<0,0.000000,0> translate<24.559600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,19.469700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,21.209000>}
box{<0,0,-0.127000><1.739300,0.035000,0.127000> rotate<0,90.000000,0> translate<24.650600,0.000000,21.209000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,19.469700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.756200,0.000000,19.469700>}
box{<0,0,-0.127000><1.105600,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,19.469700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,19.558000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,19.812000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,20.066000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,20.320000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,20.574000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,20.828000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,21.082000>}
box{<0,0,-0.127000><2.387700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,21.209000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,0.000000,21.209000>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,21.209000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,22.732900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,22.769000>}
box{<0,0,-0.127000><0.036100,0.035000,0.127000> rotate<0,90.000000,0> translate<24.650600,0.000000,22.769000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.650600,0.000000,22.732900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,0.000000,22.732900>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,0.000000,0> translate<24.650600,0.000000,22.732900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,0.000000,21.209000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,0.000000,21.325000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<24.662600,0.000000,21.209000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,-1.535000,21.209000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,-1.535000,21.325000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<24.662600,-1.535000,21.209000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.662600,0.000000,22.732900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,0.000000,22.616900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<24.662600,0.000000,22.732900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.686600,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,15.494000>}
box{<0,0,-0.127000><2.351700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.686600,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.722800,0.000000,23.634000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.818800,0.000000,23.730100>}
box{<0,0,-0.127000><0.135835,0.035000,0.127000> rotate<0,-45.026854,0> translate<24.722800,0.000000,23.634000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.795700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.187700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<24.795700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.795700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.187700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<24.795700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.818800,0.000000,23.730100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.838700,0.000000,23.710200>}
box{<0,0,-0.127000><0.028143,0.035000,0.127000> rotate<0,44.997030,0> translate<24.818800,0.000000,23.730100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.838700,0.000000,23.710200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.152100,0.000000,23.710200>}
box{<0,0,-0.127000><1.313400,0.035000,0.127000> rotate<0,0.000000,0> translate<24.838700,0.000000,23.710200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,22.632600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,23.204900>}
box{<0,0,-0.127000><0.572300,0.035000,0.127000> rotate<0,90.000000,0> translate<24.904600,-1.535000,23.204900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,22.632600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,-1.535000,22.616900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<24.904600,-1.535000,22.632600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.860000>}
box{<0,0,-0.127000><6.984400,0.035000,0.127000> rotate<0,0.000000,0> translate<24.904600,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,23.114000>}
box{<0,0,-0.127000><7.988000,0.035000,0.127000> rotate<0,0.000000,0> translate<24.904600,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.904600,-1.535000,23.204900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.182000,-1.535000,23.482300>}
box{<0,0,-0.127000><0.392303,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.904600,-1.535000,23.204900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.940600,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,15.240000>}
box{<0,0,-0.127000><2.097700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.940600,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,0.000000,21.325000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,0.000000,21.539300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.942600,0.000000,21.325000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,-1.535000,21.325000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,-1.535000,21.539300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<24.942600,-1.535000,21.325000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,0.000000,22.616900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,0.000000,22.402600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<24.942600,0.000000,22.616900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.942600,-1.535000,22.616900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,-1.535000,22.402600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<24.942600,-1.535000,22.616900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.953500,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,22.606000>}
box{<0,0,-0.127000><2.084800,0.035000,0.127000> rotate<0,0.000000,0> translate<24.953500,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.953500,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.606000>}
box{<0,0,-0.127000><6.935500,0.035000,0.127000> rotate<0,0.000000,0> translate<24.953500,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.953600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,21.336000>}
box{<0,0,-0.127000><2.084700,0.035000,0.127000> rotate<0,0.000000,0> translate<24.953600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<24.953600,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,21.336000>}
box{<0,0,-0.127000><7.011600,0.035000,0.127000> rotate<0,0.000000,0> translate<24.953600,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.067700,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.598300,-1.535000,23.368000>}
box{<0,0,-0.127000><6.530600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.067700,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.133300,-1.535000,4.789900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.363900,-1.535000,4.559300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<25.133300,-1.535000,4.789900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,-1.535000,21.539300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.172600,-1.535000,21.577300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<25.156900,-1.535000,21.539300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,0.000000,21.539300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,21.819300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<25.156900,0.000000,21.539300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,-1.535000,22.402600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.172600,-1.535000,22.364600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<25.156900,-1.535000,22.402600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.156900,0.000000,22.402600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,22.122600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<25.156900,0.000000,22.402600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.172600,-1.535000,21.577300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,21.577300>}
box{<0,0,-0.127000><6.792600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.172600,-1.535000,21.577300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.172600,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.364600>}
box{<0,0,-0.127000><6.716400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.172600,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.177900,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,21.590000>}
box{<0,0,-0.127000><1.860400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.177900,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.177900,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,22.352000>}
box{<0,0,-0.127000><1.860400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.177900,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.182000,-1.535000,23.482300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.322400,-1.535000,23.482300>}
box{<0,0,-0.127000><6.140400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.182000,-1.535000,23.482300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.187700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.612200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<25.187700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.187700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.612200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<25.187700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.194600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,14.986000>}
box{<0,0,-0.127000><1.843700,0.035000,0.127000> rotate<0,0.000000,0> translate<25.194600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,21.819300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,22.122600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<25.272900,0.000000,22.122600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,21.844000>}
box{<0,0,-0.127000><1.765400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.272900,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.272900,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,22.098000>}
box{<0,0,-0.127000><1.765400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.272900,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.363900,-1.535000,4.559300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.297300,-1.535000,4.559300>}
box{<0,0,-0.127000><26.933400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.363900,-1.535000,4.559300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.448600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,14.732000>}
box{<0,0,-0.127000><1.589700,0.035000,0.127000> rotate<0,0.000000,0> translate<25.448600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.612200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.004200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<25.612200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.612200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.004200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<25.612200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.702600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,14.478000>}
box{<0,0,-0.127000><1.335700,0.035000,0.127000> rotate<0,0.000000,0> translate<25.702600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.734600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.605400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<25.734600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.734800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.605000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<25.734800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.756200,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,17.538700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<25.756200,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.756200,0.000000,19.469700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,19.291200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<25.756200,0.000000,19.469700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.659300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.897000,-1.535000,11.379300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<25.781000,-1.535000,11.659300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.962600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.659300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<25.781000,-1.535000,11.659300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.781000,-1.535000,11.962600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.897000,-1.535000,12.242600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<25.781000,-1.535000,11.962600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.897000,-1.535000,11.379300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.111300,-1.535000,11.165000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<25.897000,-1.535000,11.379300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.897000,-1.535000,12.242600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.111300,-1.535000,12.456900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<25.897000,-1.535000,12.242600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.921900,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,19.304000>}
box{<0,0,-0.127000><1.116400,0.035000,0.127000> rotate<0,0.000000,0> translate<25.921900,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.922000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,17.526000>}
box{<0,0,-0.127000><1.116300,0.035000,0.127000> rotate<0,0.000000,0> translate<25.922000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,17.538700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,19.291200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,90.000000,0> translate<25.934700,0.000000,19.291200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,17.780000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,18.034000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,18.288000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,18.542000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,18.796000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.934700,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,19.050000>}
box{<0,0,-0.127000><1.103600,0.035000,0.127000> rotate<0,0.000000,0> translate<25.934700,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<25.956600,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,14.224000>}
box{<0,0,-0.127000><1.081700,0.035000,0.127000> rotate<0,0.000000,0> translate<25.956600,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.004200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.304300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<26.004200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.004200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.304300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<26.004200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,16.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.247100,-1.535000,16.729000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<26.024000,-1.535000,16.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,16.952100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,-90.000000,0> translate<26.024000,-1.535000,16.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.177600,-1.535000,17.783100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<26.024000,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.177600,-1.535000,18.036700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<26.024000,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.024000,-1.535000,18.036700>}
box{<0,0,-0.127000><0.619600,0.035000,0.127000> rotate<0,-90.000000,0> translate<26.024000,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.183700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.278700,-1.535000,14.005200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<26.100200,-1.535000,14.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,16.036200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,14.183700>}
box{<0,0,-0.127000><1.852500,0.035000,0.127000> rotate<0,-90.000000,0> translate<26.100200,-1.535000,14.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.100200,-1.535000,16.036200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.278700,-1.535000,16.214700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<26.100200,-1.535000,16.036200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.111300,-1.535000,11.165000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.391300,-1.535000,11.049000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<26.111300,-1.535000,11.165000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.111300,-1.535000,12.456900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.391300,-1.535000,12.572900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<26.111300,-1.535000,12.456900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.146500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.193400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<26.146500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.146600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.193300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.146600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.152100,0.000000,23.710200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,22.823900>}
box{<0,0,-0.127000><1.253347,0.035000,0.127000> rotate<0,45.000262,0> translate<26.152100,0.000000,23.710200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.210600,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.970000>}
box{<0,0,-0.127000><0.827700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.210600,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.247100,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,16.729000>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<26.247100,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.278700,-1.535000,14.005200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.321000,-1.535000,14.005200>}
box{<0,0,-0.127000><2.042300,0.035000,0.127000> rotate<0,0.000000,0> translate<26.278700,-1.535000,14.005200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.278700,-1.535000,16.214700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.331200,-1.535000,16.214700>}
box{<0,0,-0.127000><2.052500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.278700,-1.535000,16.214700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.304300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<26.304300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.304300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<26.304300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.344100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.995700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<26.344100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.344200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.995800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<26.344200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.391300,-1.535000,11.049000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.694600,-1.535000,11.049000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<26.391300,-1.535000,11.049000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.391300,-1.535000,12.572900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.694600,-1.535000,12.572900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<26.391300,-1.535000,12.572900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.449400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.890400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<26.449400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.449400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.890600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<26.449400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.464600,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.716000>}
box{<0,0,-0.127000><0.573700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.464600,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<26.466700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.466700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<26.466700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.694600,-1.535000,11.049000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.974600,-1.535000,11.165000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<26.694600,-1.535000,11.049000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.694600,-1.535000,12.572900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.732500,-1.535000,12.557100>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<26.694600,-1.535000,12.572900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.718600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.462000>}
box{<0,0,-0.127000><0.319700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.718600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.732500,-1.535000,12.557100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.546300,-1.535000,13.371000>}
box{<0,0,-0.127000><1.150958,0.035000,0.127000> rotate<0,-45.000550,0> translate<26.732500,-1.535000,12.557100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.035600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<26.873200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<26.873200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.873200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.035600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<26.873200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.972600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.208000>}
box{<0,0,-0.127000><0.065700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.972600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.974600,-1.535000,11.165000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.188900,-1.535000,11.379300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<26.974600,-1.535000,11.165000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<26.985600,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.034300,-1.535000,11.176000>}
box{<0,0,-0.127000><2.048700,0.035000,0.127000> rotate<0,0.000000,0> translate<26.985600,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.035600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.335700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<27.035600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.035600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.335700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<27.035600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.171900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.574800,0.000000,12.635500>}
box{<0,0,-0.127000><0.758655,0.035000,0.127000> rotate<0,44.991690,0> translate<27.038300,0.000000,13.171900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.498000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.171900>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,-90.000000,0> translate<27.038300,0.000000,13.171900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,22.823900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.038300,0.000000,13.498000>}
box{<0,0,-0.127000><9.325900,0.035000,0.127000> rotate<0,-90.000000,0> translate<27.038300,0.000000,13.498000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.177600,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.177600,-1.535000,17.783100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<27.177600,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.782600>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<27.178100,-1.535000,17.782600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,16.764000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.018000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.272000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.526000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.780000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.178100,-1.535000,17.782600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.782600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.178100,-1.535000,17.782600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.188900,-1.535000,11.379300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.659300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<27.188900,-1.535000,11.379300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.209900,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.780300,-1.535000,11.430000>}
box{<0,0,-0.127000><1.570400,0.035000,0.127000> rotate<0,0.000000,0> translate<27.209900,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.226600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.256200,0.000000,12.954000>}
box{<0,0,-0.127000><0.029600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.226600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.289100,-1.535000,12.000500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.962600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<27.289100,-1.535000,12.000500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.289100,-1.535000,12.000500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.566100,-1.535000,12.277400>}
box{<0,0,-0.127000><0.391666,0.035000,0.127000> rotate<0,-44.986687,0> translate<27.289100,-1.535000,12.000500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.659300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.962600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<27.304900,-1.535000,11.962600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.169300,-1.535000,11.684000>}
box{<0,0,-0.127000><0.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<27.304900,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.304900,-1.535000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.751300,-1.535000,11.938000>}
box{<0,0,-0.127000><0.446400,0.035000,0.127000> rotate<0,0.000000,0> translate<27.304900,-1.535000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.335700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.727700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<27.335700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.335700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.727700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<27.335700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.362800,-1.535000,16.729000>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,0.000000,0> translate<27.431700,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,17.782600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.431700,-1.535000,16.729000>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<27.431700,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.432300,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.432300,-1.535000,18.036700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<27.432300,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.432300,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.783100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.432300,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.432300,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,18.034000>}
box{<0,0,-0.127000><5.091700,0.035000,0.127000> rotate<0,0.000000,0> translate<27.432300,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.432300,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.036700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.432300,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.480600,-1.535000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.601400,-1.535000,12.192000>}
box{<0,0,-0.127000><0.120800,0.035000,0.127000> rotate<0,0.000000,0> translate<27.480600,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.480600,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.510200,0.000000,12.700000>}
box{<0,0,-0.127000><0.029600,0.035000,0.127000> rotate<0,0.000000,0> translate<27.480600,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.546300,-1.535000,13.371000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.776900,-1.535000,13.601600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<27.546300,-1.535000,13.371000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.566000,0.000000,12.614500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.574800,0.000000,12.635500>}
box{<0,0,-0.127000><0.022769,0.035000,0.127000> rotate<0,-67.259556,0> translate<27.566000,0.000000,12.614500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.566100,-1.535000,12.277400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.675000,-1.535000,12.014300>}
box{<0,0,-0.127000><0.284747,0.035000,0.127000> rotate<0,67.510340,0> translate<27.566100,-1.535000,12.277400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.675000,-1.535000,12.014300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.889300,-1.535000,11.800000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<27.675000,-1.535000,12.014300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.727700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.152200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<27.727700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.727700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.152200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<27.727700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.776900,-1.535000,13.601600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.500800,-1.535000,13.601600>}
box{<0,0,-0.127000><0.723900,0.035000,0.127000> rotate<0,0.000000,0> translate<27.776900,-1.535000,13.601600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.889300,-1.535000,11.800000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.169300,-1.535000,11.684000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<27.889300,-1.535000,11.800000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.913300,-1.535000,25.031600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.929000,-1.535000,25.069600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<27.913300,-1.535000,25.031600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<27.929000,-1.535000,25.069600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.143300,-1.535000,25.283900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<27.929000,-1.535000,25.069600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.143300,-1.535000,25.283900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.423300,-1.535000,25.399900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<28.143300,-1.535000,25.283900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.152200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.544200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<28.152200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.152200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.544200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<28.152200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.169300,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.472600,-1.535000,11.684000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<28.169300,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.274600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.145400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<28.274600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.274800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.145000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<28.274800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.321000,-1.535000,13.945300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.437000,-1.535000,13.665300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<28.321000,-1.535000,13.945300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.321000,-1.535000,14.005200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.321000,-1.535000,13.945300>}
box{<0,0,-0.127000><0.059900,0.035000,0.127000> rotate<0,-90.000000,0> translate<28.321000,-1.535000,13.945300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.331200,-1.535000,16.214700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,16.036200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<28.331200,-1.535000,16.214700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.362800,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,16.952100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<28.362800,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.397800,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.656400,-1.535000,16.764000>}
box{<0,0,-0.127000><1.258600,0.035000,0.127000> rotate<0,0.000000,0> translate<28.397800,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.423300,-1.535000,25.399900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.726600,-1.535000,25.399900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<28.423300,-1.535000,25.399900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.437000,-1.535000,13.665300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.500800,-1.535000,13.601600>}
box{<0,0,-0.127000><0.090156,0.035000,0.127000> rotate<0,44.952095,0> translate<28.437000,-1.535000,13.665300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.472600,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.510500,-1.535000,11.699800>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,-22.629105,0> translate<28.472600,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.472600,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.526300,-1.535000,11.684000>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,0.000000,0> translate<28.472600,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,15.506600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,16.036200>}
box{<0,0,-0.127000><0.529600,0.035000,0.127000> rotate<0,90.000000,0> translate<28.509700,-1.535000,16.036200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,15.506600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.919900,-1.535000,15.506600>}
box{<0,0,-0.127000><0.410200,0.035000,0.127000> rotate<0,0.000000,0> translate<28.509700,-1.535000,15.506600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.161400,-1.535000,15.748000>}
box{<0,0,-0.127000><0.651700,0.035000,0.127000> rotate<0,0.000000,0> translate<28.509700,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.509700,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,16.002000>}
box{<0,0,-0.127000><0.827300,0.035000,0.127000> rotate<0,0.000000,0> translate<28.509700,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.510500,-1.535000,11.699800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.705300,-1.535000,10.505000>}
box{<0,0,-0.127000><1.689702,0.035000,0.127000> rotate<0,44.997030,0> translate<28.510500,-1.535000,11.699800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.544200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.844300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<28.544200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.544200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.844300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<28.544200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,16.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.783100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,90.000000,0> translate<28.585900,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.018000>}
box{<0,0,-0.127000><3.938100,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.527600,-1.535000,17.272000>}
box{<0,0,-0.127000><4.941700,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.526000>}
box{<0,0,-0.127000><3.938100,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.780000>}
box{<0,0,-0.127000><3.938100,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.656300>}
box{<0,0,-0.127000><0.619600,0.035000,0.127000> rotate<0,90.000000,0> translate<28.585900,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.185300,-1.535000,18.288000>}
box{<0,0,-0.127000><0.599400,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.767300,-1.535000,18.542000>}
box{<0,0,-0.127000><0.181400,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.585900,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.675300,-1.535000,18.656300>}
box{<0,0,-0.127000><0.089400,0.035000,0.127000> rotate<0,0.000000,0> translate<28.585900,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.675300,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.691000,-1.535000,18.618300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<28.675300,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.675300,-1.535000,19.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.691000,-1.535000,19.481600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<28.675300,-1.535000,19.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.686500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.733400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<28.686500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.686600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.733300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<28.686600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.691000,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.905300,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<28.691000,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.691000,-1.535000,19.481600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.905300,-1.535000,19.695900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<28.691000,-1.535000,19.481600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.726600,-1.535000,25.399900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.764500,-1.535000,25.384200>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,22.500200,0> translate<28.726600,-1.535000,25.399900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.764500,-1.535000,25.384200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.356300,-1.535000,27.976000>}
box{<0,0,-0.127000><3.665359,0.035000,0.127000> rotate<0,-44.997030,0> translate<28.764500,-1.535000,25.384200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.844300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<28.844300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.844300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<28.844300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.884100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.535700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<28.884100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.884200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.535800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<28.884200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.905300,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.185300,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<28.905300,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.905300,-1.535000,19.695900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.185300,-1.535000,19.811900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<28.905300,-1.535000,19.695900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.919900,-1.535000,15.506600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.352800,-1.535000,15.939400>}
box{<0,0,-0.127000><0.612142,0.035000,0.127000> rotate<0,-44.990412,0> translate<28.919900,-1.535000,15.506600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.989400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.430400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<28.989400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<28.989400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.430600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<28.989400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<29.006700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.006700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.006700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.185300,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.488600,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<29.185300,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.185300,-1.535000,19.811900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.464000,-1.535000,19.811900>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<29.185300,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.247100,-1.535000,24.269600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.336900,-1.535000,24.486300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<29.247100,-1.535000,24.269600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.247100,-1.535000,24.269600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.988000,-1.535000,24.269600>}
box{<0,0,-0.127000><1.740900,0.035000,0.127000> rotate<0,0.000000,0> translate<29.247100,-1.535000,24.269600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.294500,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.030500,-1.535000,24.384000>}
box{<0,0,-0.127000><1.736000,0.035000,0.127000> rotate<0,0.000000,0> translate<29.294500,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.321200,-1.535000,24.827500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.336900,-1.535000,24.789600>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,67.493860,0> translate<29.321200,-1.535000,24.827500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.321200,-1.535000,24.827500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,27.395400>}
box{<0,0,-0.127000><3.631488,0.035000,0.127000> rotate<0,-44.998146,0> translate<29.321200,-1.535000,24.827500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.336900,-1.535000,24.486300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.336900,-1.535000,24.789600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<29.336900,-1.535000,24.789600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.336900,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.180400,-1.535000,24.638000>}
box{<0,0,-0.127000><1.843500,0.035000,0.127000> rotate<0,0.000000,0> translate<29.336900,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,15.977300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.352800,-1.535000,15.939400>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<29.337000,-1.535000,15.977300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,16.280600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,15.977300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<29.337000,-1.535000,15.977300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.337000,-1.535000,16.280600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.453000,-1.535000,16.560600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<29.337000,-1.535000,16.280600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.341300,-1.535000,14.814600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,-1.535000,14.949900>}
box{<0,0,-0.127000><0.191343,0.035000,0.127000> rotate<0,-44.997030,0> translate<29.341300,-1.535000,14.814600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.341300,-1.535000,14.814600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.514600,-1.535000,14.742900>}
box{<0,0,-0.127000><0.187547,0.035000,0.127000> rotate<0,22.475031,0> translate<29.341300,-1.535000,14.814600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.385600,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,24.892000>}
box{<0,0,-0.127000><2.579600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.385600,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<29.413200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<29.413200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.413200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<29.413200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.453000,-1.535000,16.560600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.667300,-1.535000,16.774900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<29.453000,-1.535000,16.560600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.464000,-1.535000,19.963600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.464000,-1.535000,19.811900>}
box{<0,0,-0.127000><0.151700,0.035000,0.127000> rotate<0,-90.000000,0> translate<29.464000,-1.535000,19.811900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.464000,-1.535000,19.963600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.580000,-1.535000,20.243600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<29.464000,-1.535000,19.963600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,2.171600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,6.492800>}
box{<0,0,-0.127000><4.321200,0.035000,0.127000> rotate<0,90.000000,0> translate<29.476600,0.000000,6.492800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,2.171600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.034900,0.000000,2.171600>}
box{<0,0,-0.127000><30.558300,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,2.171600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.149400,0.000000,2.286000>}
box{<0,0,-0.127000><30.672800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.403400,0.000000,2.540000>}
box{<0,0,-0.127000><30.926800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.657400,0.000000,2.794000>}
box{<0,0,-0.127000><31.180800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.911400,0.000000,3.048000>}
box{<0,0,-0.127000><31.434800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.165400,0.000000,3.302000>}
box{<0,0,-0.127000><31.688800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.419400,0.000000,3.556000>}
box{<0,0,-0.127000><31.942800,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.987200,0.000000,3.810000>}
box{<0,0,-0.127000><4.510600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.733200,0.000000,4.064000>}
box{<0,0,-0.127000><4.256600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.479200,0.000000,4.318000>}
box{<0,0,-0.127000><4.002600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.225200,0.000000,4.572000>}
box{<0,0,-0.127000><3.748600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.971200,0.000000,4.826000>}
box{<0,0,-0.127000><3.494600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.717200,0.000000,5.080000>}
box{<0,0,-0.127000><3.240600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.463200,0.000000,5.334000>}
box{<0,0,-0.127000><2.986600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.209200,0.000000,5.588000>}
box{<0,0,-0.127000><2.732600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.145000,0.000000,5.842000>}
box{<0,0,-0.127000><0.668400,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.733300,0.000000,6.096000>}
box{<0,0,-0.127000><0.256700,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.535700,0.000000,6.350000>}
box{<0,0,-0.127000><0.059100,0.035000,0.127000> rotate<0,0.000000,0> translate<29.476600,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,0.000000,6.492800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,0.000000,6.253700>}
box{<0,0,-0.127000><0.258785,0.035000,0.127000> rotate<0,67.503412,0> translate<29.476600,0.000000,6.492800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.476600,-1.535000,14.949900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.909400,-1.535000,15.382800>}
box{<0,0,-0.127000><0.612142,0.035000,0.127000> rotate<0,-45.003648,0> translate<29.476600,-1.535000,14.949900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.488600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.768600,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<29.488600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.488600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979300,-1.535000,18.288000>}
box{<0,0,-0.127000><2.490700,0.035000,0.127000> rotate<0,0.000000,0> translate<29.488600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.512600,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,14.986000>}
box{<0,0,-0.127000><3.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.512600,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.514600,-1.535000,14.742900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.728900,-1.535000,14.528600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<29.514600,-1.535000,14.742900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.525500,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.751900,-1.535000,14.732000>}
box{<0,0,-0.127000><3.226400,0.035000,0.127000> rotate<0,0.000000,0> translate<29.525500,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<29.575600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<29.575600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.575600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<29.575600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.580000,-1.535000,20.243600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.794300,-1.535000,20.457900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<29.580000,-1.535000,20.243600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.639600,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.146000>}
box{<0,0,-0.127000><2.325600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.639600,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.667300,-1.535000,16.774900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.947300,-1.535000,16.890900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<29.667300,-1.535000,16.774900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.705300,-1.535000,10.504900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.910700,-1.535000,10.299600>}
box{<0,0,-0.127000><0.290409,0.035000,0.127000> rotate<0,44.983080,0> translate<29.705300,-1.535000,10.504900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.705300,-1.535000,10.505000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.705300,-1.535000,10.504900>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,-90.000000,0> translate<29.705300,-1.535000,10.504900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.728900,-1.535000,14.528600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.744600,-1.535000,14.490600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<29.728900,-1.535000,14.528600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.744600,-1.535000,14.490600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.851300,-1.535000,14.490600>}
box{<0,0,-0.127000><10.106700,0.035000,0.127000> rotate<0,0.000000,0> translate<29.744600,-1.535000,14.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.766600,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,15.240000>}
box{<0,0,-0.127000><2.833600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.766600,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.768600,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.982900,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<29.768600,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.794300,-1.535000,20.457900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.074300,-1.535000,20.573900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<29.794300,-1.535000,20.457900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<29.875700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<29.875700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.875700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<29.875700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.893600,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.400000>}
box{<0,0,-0.127000><2.071600,0.035000,0.127000> rotate<0,0.000000,0> translate<29.893600,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.906600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.561300,-1.535000,18.542000>}
box{<0,0,-0.127000><1.654700,0.035000,0.127000> rotate<0,0.000000,0> translate<29.906600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.909400,-1.535000,15.382800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.947300,-1.535000,15.367000>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<29.909400,-1.535000,15.382800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.947300,-1.535000,15.367000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.250600,-1.535000,15.367000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<29.947300,-1.535000,15.367000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.947300,-1.535000,16.890900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.250600,-1.535000,16.890900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<29.947300,-1.535000,16.890900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<29.982900,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.098900,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<29.982900,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.056500,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.411300,-1.535000,18.796000>}
box{<0,0,-0.127000><1.354800,0.035000,0.127000> rotate<0,0.000000,0> translate<30.056500,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.074300,-1.535000,20.573900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.377600,-1.535000,20.573900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<30.074300,-1.535000,20.573900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.098900,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.098900,-1.535000,19.050000>}
box{<0,0,-0.127000><0.151700,0.035000,0.127000> rotate<0,90.000000,0> translate<30.098900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.098900,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.377600,-1.535000,19.050000>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<30.098900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.147600,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.654000>}
box{<0,0,-0.127000><1.817600,0.035000,0.127000> rotate<0,0.000000,0> translate<30.147600,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.250600,-1.535000,15.367000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.530600,-1.535000,15.483000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<30.250600,-1.535000,15.367000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.250600,-1.535000,16.890900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.530600,-1.535000,16.774900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<30.250600,-1.535000,16.890900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<30.267700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<30.267700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.267700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<30.267700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.377600,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.657600,-1.535000,19.166000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<30.377600,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.377600,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.369000,-1.535000,19.050000>}
box{<0,0,-0.127000><0.991400,0.035000,0.127000> rotate<0,0.000000,0> translate<30.377600,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.377600,-1.535000,20.573900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.657600,-1.535000,20.457900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<30.377600,-1.535000,20.573900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.401600,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.908000>}
box{<0,0,-0.127000><1.563600,0.035000,0.127000> rotate<0,0.000000,0> translate<30.401600,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.530600,-1.535000,15.483000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.744900,-1.535000,15.697300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<30.530600,-1.535000,15.483000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.530600,-1.535000,16.774900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.744900,-1.535000,16.560600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<30.530600,-1.535000,16.774900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.541500,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,16.764000>}
box{<0,0,-0.127000><1.982500,0.035000,0.127000> rotate<0,0.000000,0> translate<30.541500,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.541600,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,15.494000>}
box{<0,0,-0.127000><2.058600,0.035000,0.127000> rotate<0,0.000000,0> translate<30.541600,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.655600,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.162000>}
box{<0,0,-0.127000><1.233400,0.035000,0.127000> rotate<0,0.000000,0> translate<30.655600,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.657600,-1.535000,19.166000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.871900,-1.535000,19.380300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<30.657600,-1.535000,19.166000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.657600,-1.535000,20.457900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.871900,-1.535000,20.243600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<30.657600,-1.535000,20.457900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<30.692200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<30.692200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.692200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<30.692200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.744900,-1.535000,15.697300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,15.977300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<30.744900,-1.535000,15.697300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.744900,-1.535000,16.560600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,16.280600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<30.744900,-1.535000,16.560600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.765900,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,15.748000>}
box{<0,0,-0.127000><1.834300,0.035000,0.127000> rotate<0,0.000000,0> translate<30.765900,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.765900,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.566100,-1.535000,16.510000>}
box{<0,0,-0.127000><1.800200,0.035000,0.127000> rotate<0,0.000000,0> translate<30.765900,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.795500,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.085500,-1.535000,20.320000>}
box{<0,0,-0.127000><2.290000,0.035000,0.127000> rotate<0,0.000000,0> translate<30.795500,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.795600,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.411500,-1.535000,19.304000>}
box{<0,0,-0.127000><0.615900,0.035000,0.127000> rotate<0,0.000000,0> translate<30.795600,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.814600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.685400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<30.814600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.814800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.955200,0.000000,5.842000>}
box{<0,0,-0.127000><1.140400,0.035000,0.127000> rotate<0,0.000000,0> translate<30.814800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.814800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.685000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<30.814800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,15.977300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,16.280600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<30.860900,-1.535000,16.280600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,16.002000>}
box{<0,0,-0.127000><1.739300,0.035000,0.127000> rotate<0,0.000000,0> translate<30.860900,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.860900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,16.256000>}
box{<0,0,-0.127000><1.739300,0.035000,0.127000> rotate<0,0.000000,0> translate<30.860900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.871900,-1.535000,19.380300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.887600,-1.535000,19.418300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<30.871900,-1.535000,19.380300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.871900,-1.535000,20.243600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.887600,-1.535000,20.205600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<30.871900,-1.535000,20.243600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.887600,-1.535000,19.418300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.458800,-1.535000,19.418300>}
box{<0,0,-0.127000><0.571200,0.035000,0.127000> rotate<0,0.000000,0> translate<30.887600,-1.535000,19.418300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.887600,-1.535000,20.205600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.993300,-1.535000,20.205600>}
box{<0,0,-0.127000><2.105700,0.035000,0.127000> rotate<0,0.000000,0> translate<30.887600,-1.535000,20.205600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.909600,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.416000>}
box{<0,0,-0.127000><0.979400,0.035000,0.127000> rotate<0,0.000000,0> translate<30.909600,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.922200,0.000000,16.649600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.000600,0.000000,16.727900>}
box{<0,0,-0.127000><0.110804,0.035000,0.127000> rotate<0,-44.960469,0> translate<30.922200,0.000000,16.649600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.922200,0.000000,16.649600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.649600>}
box{<0,0,-0.127000><0.226800,0.035000,0.127000> rotate<0,0.000000,0> translate<30.922200,0.000000,16.649600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.988000,-1.535000,24.281600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.988000,-1.535000,24.269600>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,-90.000000,0> translate<30.988000,-1.535000,24.269600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<30.988000,-1.535000,24.281600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.104000,-1.535000,24.561600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<30.988000,-1.535000,24.281600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.000600,0.000000,16.727900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.876400>}
box{<0,0,-0.127000><0.209940,0.035000,0.127000> rotate<0,-45.016327,0> translate<31.000600,0.000000,16.727900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.036600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.764000>}
box{<0,0,-0.127000><0.112400,0.035000,0.127000> rotate<0,0.000000,0> translate<31.036600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.075300,0.000000,13.754700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.635600,0.000000,14.314900>}
box{<0,0,-0.127000><0.792313,0.035000,0.127000> rotate<0,-44.991917,0> translate<31.075300,0.000000,13.754700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.075300,0.000000,13.754700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.867100,0.000000,13.754700>}
box{<0,0,-0.127000><0.791800,0.035000,0.127000> rotate<0,0.000000,0> translate<31.075300,0.000000,13.754700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<31.084200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<31.084200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.084200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<31.084200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.104000,-1.535000,24.561600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.318300,-1.535000,24.775900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<31.104000,-1.535000,24.561600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.649600>}
box{<0,0,-0.127000><0.109800,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.149000,0.000000,16.649600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.978900,0.000000,16.759400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.149000,0.000000,16.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.978900,0.000000,16.760400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.149000,0.000000,16.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.876400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.149000,0.000000,16.760400>}
box{<0,0,-0.127000><0.116000,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.149000,0.000000,16.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.163600,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.670000>}
box{<0,0,-0.127000><0.725400,0.035000,0.127000> rotate<0,0.000000,0> translate<31.163600,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.226500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.273400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.226500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.226600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.701200,0.000000,6.096000>}
box{<0,0,-0.127000><0.474600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.226600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.226600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.273300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<31.226600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.290600,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.082400,0.000000,13.970000>}
box{<0,0,-0.127000><0.791800,0.035000,0.127000> rotate<0,0.000000,0> translate<31.290600,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.318300,-1.535000,24.775900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.598300,-1.535000,24.891900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<31.318300,-1.535000,24.775900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.322400,-1.535000,23.482300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.598300,-1.535000,23.368000>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,22.501790,0> translate<31.322400,-1.535000,23.482300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.356300,-1.535000,27.976000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.586900,-1.535000,28.206600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<31.356300,-1.535000,27.976000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.369000,-1.535000,18.898300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.485000,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<31.369000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.369000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.369000,-1.535000,18.898300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.369000,-1.535000,18.898300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.369000,-1.535000,19.201600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.458800,-1.535000,19.418300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<31.369000,-1.535000,19.201600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.483300,0.000000,6.492900>}
box{<0,0,-0.127000><0.258878,0.035000,0.127000> rotate<0,-67.511879,0> translate<31.384300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<31.384300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.384300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<31.384300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.417600,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,26.924000>}
box{<0,0,-0.127000><1.475000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.417600,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.424100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.483300,0.000000,6.350000>}
box{<0,0,-0.127000><0.059200,0.035000,0.127000> rotate<0,0.000000,0> translate<31.424100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.424100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.075700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.424100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.424200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.075800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.424200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.483300,0.000000,6.313900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.769300,0.000000,4.027900>}
box{<0,0,-0.127000><3.232892,0.035000,0.127000> rotate<0,44.997030,0> translate<31.483300,0.000000,6.313900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.483300,0.000000,6.492900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.483300,0.000000,6.313900>}
box{<0,0,-0.127000><0.179000,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.483300,0.000000,6.313900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.485000,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.699300,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<31.485000,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.529400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.970400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.529400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.529400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.970600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<31.529400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.544600,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.336400,0.000000,14.224000>}
box{<0,0,-0.127000><0.791800,0.035000,0.127000> rotate<0,0.000000,0> translate<31.544600,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<31.546700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.546700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<31.546700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.586900,-1.535000,28.206600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.533300,-1.535000,28.206600>}
box{<0,0,-0.127000><3.946400,0.035000,0.127000> rotate<0,0.000000,0> translate<31.586900,-1.535000,28.206600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.598300,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,23.368000>}
box{<0,0,-0.127000><0.290700,0.035000,0.127000> rotate<0,0.000000,0> translate<31.598300,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.598300,-1.535000,24.891900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.901600,-1.535000,24.891900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<31.598300,-1.535000,24.891900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.635600,0.000000,14.314900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.635600,0.000000,14.384600>}
box{<0,0,-0.127000><0.069700,0.035000,0.127000> rotate<0,90.000000,0> translate<31.635600,0.000000,14.384600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.635600,0.000000,14.384600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,14.433700>}
box{<0,0,-0.127000><0.069438,0.035000,0.127000> rotate<0,-44.997030,0> translate<31.635600,0.000000,14.384600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.671600,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,27.178000>}
box{<0,0,-0.127000><0.217400,0.035000,0.127000> rotate<0,0.000000,0> translate<31.671600,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,14.433700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,15.229000>}
box{<0,0,-0.127000><0.795300,0.035000,0.127000> rotate<0,90.000000,0> translate<31.684700,0.000000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.590400,0.000000,14.478000>}
box{<0,0,-0.127000><0.905700,0.035000,0.127000> rotate<0,0.000000,0> translate<31.684700,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.844400,0.000000,14.732000>}
box{<0,0,-0.127000><1.159700,0.035000,0.127000> rotate<0,0.000000,0> translate<31.684700,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,14.986000>}
box{<0,0,-0.127000><1.195600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.684700,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.684700,0.000000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.229000>}
box{<0,0,-0.127000><0.294700,0.035000,0.127000> rotate<0,0.000000,0> translate<31.684700,0.000000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.699300,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979300,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<31.699300,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.867100,0.000000,13.754700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,14.768000>}
box{<0,0,-0.127000><1.432952,0.035000,0.127000> rotate<0,-44.999857,0> translate<31.867100,0.000000,13.754700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.948100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.364600>}
box{<0,0,-0.127000><0.583500,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.889000,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,22.948100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,22.948100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.889000,-1.535000,22.948100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,23.201700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,23.201700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.889000,-1.535000,23.201700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,23.201700>}
box{<0,0,-0.127000><0.166300,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.889000,-1.535000,23.201700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.077100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.985100,-1.535000,25.981000>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<31.889000,-1.535000,26.077100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.758100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.077100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.889000,-1.535000,26.077100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,26.758100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,26.758100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.889000,-1.535000,26.758100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,27.011700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,27.011700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<31.889000,-1.535000,27.011700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,27.395400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.889000,-1.535000,27.011700>}
box{<0,0,-0.127000><0.383700,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.889000,-1.535000,27.011700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.901600,-1.535000,24.891900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,24.865500>}
box{<0,0,-0.127000><0.068862,0.035000,0.127000> rotate<0,22.541573,0> translate<31.901600,-1.535000,24.891900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.115600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<31.953200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.953200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.953200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.115600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<31.953200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,20.598700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.143700,-1.535000,20.420200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<31.965200,-1.535000,20.598700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,21.577300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,20.598700>}
box{<0,0,-0.127000><0.978600,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.965200,-1.535000,20.598700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.961200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,24.865500>}
box{<0,0,-0.127000><1.095700,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.965200,-1.535000,24.865500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.965200,-1.535000,25.961200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.985100,-1.535000,25.981000>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,-44.852718,0> translate<31.965200,-1.535000,25.961200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.978900,0.000000,16.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.978900,0.000000,16.759400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.978900,0.000000,16.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979300,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.282600,-1.535000,18.288000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<31.979300,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.758900>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,90.000000,0> translate<31.979400,0.000000,15.758900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.979400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.494000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.979400,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.748000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.979400,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.979400,0.000000,15.758900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.758900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<31.979400,0.000000,15.758900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.587800,0.000000,15.229000>}
box{<0,0,-0.127000><0.607400,0.035000,0.127000> rotate<0,0.000000,0> translate<31.980400,0.000000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.758900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.980400,0.000000,15.229000>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,-90.000000,0> translate<31.980400,0.000000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,15.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,15.760400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<31.981000,0.000000,15.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,15.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.759400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.981000,0.000000,15.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,15.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.760400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.981000,0.000000,15.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,16.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,16.760400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<31.981000,0.000000,16.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,16.759400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.759400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.981000,0.000000,16.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<31.981000,0.000000,16.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.760400>}
box{<0,0,-0.127000><0.829900,0.035000,0.127000> rotate<0,0.000000,0> translate<31.981000,0.000000,16.760400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.115600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.415700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<32.115600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.115600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.415700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.115600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.143700,-1.535000,20.420200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.185700,-1.535000,20.420200>}
box{<0,0,-0.127000><1.042000,0.035000,0.127000> rotate<0,0.000000,0> translate<32.143700,-1.535000,20.420200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.282600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.562600,-1.535000,18.404000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<32.282600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.282600,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.644200,-1.535000,18.288000>}
box{<0,0,-0.127000><0.361600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.282600,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.415700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.807700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<32.415700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.415700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.807700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<32.415700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,16.552100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.620100,-1.535000,16.456000>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<32.524000,-1.535000,16.552100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,16.552100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.524000,-1.535000,16.552100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.527600,-1.535000,17.233100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.524000,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.527600,-1.535000,17.486700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.524000,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,18.167800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,17.486700>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.524000,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.524000,-1.535000,18.167800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.747100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.524000,-1.535000,18.167800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.536500,-1.535000,24.105900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.660800,-1.535000,24.230200>}
box{<0,0,-0.127000><0.175787,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.536500,-1.535000,24.105900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.536500,-1.535000,24.105900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,24.105900>}
box{<0,0,-0.127000><0.356600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.536500,-1.535000,24.105900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.560600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,24.130000>}
box{<0,0,-0.127000><2.353400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.560600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.562600,-1.535000,18.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.776900,-1.535000,18.618300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.562600,-1.535000,18.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.587800,0.000000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.452100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.587800,0.000000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.598800,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,15.240000>}
box{<0,0,-0.127000><0.281500,0.035000,0.127000> rotate<0,0.000000,0> translate<32.598800,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,14.883700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.778700,-1.535000,14.705200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<32.600200,-1.535000,14.883700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,16.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,14.883700>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.600200,-1.535000,14.883700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.600200,-1.535000,16.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.620100,-1.535000,16.456000>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,-44.852718,0> translate<32.600200,-1.535000,16.436200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.660800,-1.535000,24.230200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.896200,-1.535000,24.230200>}
box{<0,0,-0.127000><1.235400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.660800,-1.535000,24.230200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.700600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.837300,-1.535000,18.542000>}
box{<0,0,-0.127000><6.136700,0.035000,0.127000> rotate<0,0.000000,0> translate<32.700600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.734700,0.000000,16.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.734700,0.000000,16.375900>}
box{<0,0,-0.127000><0.231900,0.035000,0.127000> rotate<0,90.000000,0> translate<32.734700,0.000000,16.375900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.734700,0.000000,16.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.067800>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,44.997030,0> translate<32.734700,0.000000,16.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.734700,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.256000>}
box{<0,0,-0.127000><0.145600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.734700,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.734700,0.000000,16.375900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.452100>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,-44.997030,0> translate<32.734700,0.000000,16.375900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.747100,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,0.000000,0> translate<32.747100,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.776900,-1.535000,18.618300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.792600,-1.535000,18.656300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<32.776900,-1.535000,18.618300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.778700,-1.535000,14.705200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.531200,-1.535000,14.705200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<32.778700,-1.535000,14.705200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.792600,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.561400,-1.535000,18.656300>}
box{<0,0,-0.127000><5.768800,0.035000,0.127000> rotate<0,0.000000,0> translate<32.792600,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.807700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.232200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<32.807700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.807700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.232200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<32.807700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.452100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.759400>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,90.000000,0> translate<32.810900,0.000000,15.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,15.494000>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,15.748000>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,15.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.067800>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,90.000000,0> translate<32.810900,0.000000,16.067800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.002000>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.452100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.759400>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,90.000000,0> translate<32.810900,0.000000,16.759400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.510000>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.760400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.878300>}
box{<0,0,-0.127000><0.117900,0.035000,0.127000> rotate<0,90.000000,0> translate<32.810900,0.000000,16.878300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.764000>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.810900,0.000000,16.878300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.878300>}
box{<0,0,-0.127000><0.069400,0.035000,0.127000> rotate<0,0.000000,0> translate<32.810900,0.000000,16.878300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,16.878300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.880300,0.000000,14.768000>}
box{<0,0,-0.127000><2.110300,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.880300,0.000000,14.768000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,23.201700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,22.948100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.892600,-1.535000,22.948100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,27.011700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.892600,-1.535000,26.758100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<32.892600,-1.535000,26.758100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,23.202300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,24.105900>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,90.000000,0> translate<32.893100,-1.535000,24.105900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,23.202300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,23.202300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.893100,-1.535000,23.202300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,23.368000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.893100,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,23.622000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.893100,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.893100,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<32.893100,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<32.993300,-1.535000,20.205600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.009000,-1.535000,20.243600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<32.993300,-1.535000,20.205600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.009000,-1.535000,20.243600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.185700,-1.535000,20.420200>}
box{<0,0,-0.127000><0.249821,0.035000,0.127000> rotate<0,-44.980814,0> translate<33.009000,-1.535000,20.243600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,22.768900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.293000>}
box{<0,0,-0.127000><1.524100,0.035000,0.127000> rotate<0,90.000000,0> translate<33.032600,0.000000,24.293000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,22.768900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.055900,0.000000,22.745600>}
box{<0,0,-0.127000><0.032951,0.035000,0.127000> rotate<0,44.997030,0> translate<33.032600,0.000000,22.768900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.173800,0.000000,22.860000>}
box{<0,0,-0.127000><0.141200,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,23.114000>}
box{<0,0,-0.127000><0.185100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,23.368000>}
box{<0,0,-0.127000><0.185100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.622000>}
box{<0,0,-0.127000><0.108900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.876000>}
box{<0,0,-0.127000><0.108900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.130000>}
box{<0,0,-0.127000><0.108900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.293000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.879300>}
box{<0,0,-0.127000><0.586300,0.035000,0.127000> rotate<0,90.000000,0> translate<33.032600,0.000000,24.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.384000>}
box{<0,0,-0.127000><0.108900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,24.638000>}
box{<0,0,-0.127000><1.551200,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.032600,0.000000,24.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.879300>}
box{<0,0,-0.127000><0.108900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.032600,0.000000,24.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.055900,0.000000,22.745600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.056000,0.000000,22.745600>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.055900,0.000000,22.745600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.056000,0.000000,22.745600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,22.660000>}
box{<0,0,-0.127000><0.120986,0.035000,0.127000> rotate<0,45.030515,0> translate<33.056000,0.000000,22.745600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,22.827800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,22.660000>}
box{<0,0,-0.127000><0.167800,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.141500,0.000000,22.660000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,22.827800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,22.903900>}
box{<0,0,-0.127000><0.107692,0.035000,0.127000> rotate<0,-44.959412,0> translate<33.141500,0.000000,22.827800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.462100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,23.385900>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,44.997030,0> translate<33.141500,0.000000,23.462100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.462100>}
box{<0,0,-0.127000><0.422200,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.141500,0.000000,23.462100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,23.884300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<33.141500,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,23.905500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<33.141500,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.327800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,23.905500>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.141500,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.634300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.327800>}
box{<0,0,-0.127000><0.306500,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.141500,0.000000,24.327800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.634300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,24.634300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<33.141500,0.000000,24.634300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.655500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,24.655500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<33.141500,0.000000,24.655500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.141500,0.000000,24.655500>}
box{<0,0,-0.127000><0.223800,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.141500,0.000000,24.655500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,24.105900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,23.202300>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.146700,-1.535000,23.202300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.146700,-1.535000,24.105900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.927800,-1.535000,24.105900>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.146700,-1.535000,24.105900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,22.948100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,23.201700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<33.147300,-1.535000,23.201700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,22.948100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.948100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,22.948100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.083000,-1.535000,23.114000>}
box{<0,0,-0.127000><1.935700,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,23.201700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.201700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,23.201700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,26.758100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,27.011700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<33.147300,-1.535000,27.011700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,26.758100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.758100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,26.758100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.213400,-1.535000,26.924000>}
box{<0,0,-0.127000><8.066100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.147300,-1.535000,27.011700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,27.011700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.147300,-1.535000,27.011700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,23.385900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.217700,0.000000,22.903900>}
box{<0,0,-0.127000><0.482000,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.217700,0.000000,22.903900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.232200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.624200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<33.232200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.232200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.624200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<33.232200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.354600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.225400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<33.354600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.354800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.225000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<33.354800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.527600,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.527600,-1.535000,17.233100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.527600,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,17.487300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,90.000000,0> translate<33.528100,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,17.487300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,17.487300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.528100,-1.535000,17.487300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,17.526000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.528100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,17.780000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.528100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,18.034000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.528100,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.528100,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,18.288000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.528100,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.624200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.924300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<33.624200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.624200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.924300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<33.624200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.766500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.813400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<33.766500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.766600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.813300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<33.766600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.769300,0.000000,4.027900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.999900,0.000000,3.797300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<33.769300,0.000000,4.027900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,17.487300>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,-90.000000,0> translate<33.781700,-1.535000,17.487300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.781700,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.562800,-1.535000,18.390900>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<33.781700,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.782300,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.782300,-1.535000,17.486700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<33.782300,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.782300,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.233100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.782300,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.782300,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.052600,-1.535000,17.272000>}
box{<0,0,-0.127000><9.270300,0.035000,0.127000> rotate<0,0.000000,0> translate<33.782300,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.782300,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.486700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.782300,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.896200,-1.535000,24.230200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,24.408700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<33.896200,-1.535000,24.230200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.924300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<33.924300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.924300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<33.924300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.927800,-1.535000,24.105900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.882800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<33.927800,-1.535000,24.105900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.964100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.615700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.964100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.964200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.615800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<33.964200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<33.999900,0.000000,3.797300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.256900,0.000000,3.797300>}
box{<0,0,-0.127000><24.257000,0.035000,0.127000> rotate<0,0.000000,0> translate<33.999900,0.000000,3.797300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.050000,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,24.384000>}
box{<0,0,-0.127000><0.864000,0.035000,0.127000> rotate<0,0.000000,0> translate<34.050000,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.054800,-1.535000,25.981000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.961200>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,44.852718,0> translate<34.054800,-1.535000,25.981000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.054800,-1.535000,25.981000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.077100>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.054800,-1.535000,25.981000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.069400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.510400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<34.069400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.069400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.510600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.069400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,24.408700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.961200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,90.000000,0> translate<34.074700,-1.535000,25.961200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,24.638000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.067600,-1.535000,24.892000>}
box{<0,0,-0.127000><1.992900,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.146000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.400000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.654000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.074700,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.969200,-1.535000,25.908000>}
box{<0,0,-0.127000><0.894500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.074700,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<34.086700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.086700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.086700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.948100>}
box{<0,0,-0.127000><0.583500,0.035000,0.127000> rotate<0,90.000000,0> translate<34.150900,-1.535000,22.948100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,22.364600>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,22.606000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,22.860000>}
box{<0,0,-0.127000><0.839300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.201700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.882800>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,90.000000,0> translate<34.150900,-1.535000,23.882800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.368000>}
box{<0,0,-0.127000><3.938100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.242600,-1.535000,23.622000>}
box{<0,0,-0.127000><5.091700,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.975100,-1.535000,23.876000>}
box{<0,0,-0.127000><0.824200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.077100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.758100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,90.000000,0> translate<34.150900,-1.535000,26.758100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.063300,-1.535000,26.162000>}
box{<0,0,-0.127000><6.912400,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.021000,-1.535000,26.416000>}
box{<0,0,-0.127000><6.870100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.063500,-1.535000,26.670000>}
box{<0,0,-0.127000><6.912600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,27.011700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,27.419300>}
box{<0,0,-0.127000><0.407600,0.035000,0.127000> rotate<0,90.000000,0> translate<34.150900,-1.535000,27.419300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.752300,-1.535000,27.178000>}
box{<0,0,-0.127000><1.601400,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.150900,-1.535000,27.419300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.533300,-1.535000,27.419300>}
box{<0,0,-0.127000><1.382400,0.035000,0.127000> rotate<0,0.000000,0> translate<34.150900,-1.535000,27.419300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.655600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<34.493200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.493200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.493200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.655600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<34.493200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.531200,-1.535000,14.705200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,14.883700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.531200,-1.535000,14.705200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.558000,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.070400,-1.535000,14.732000>}
box{<0,0,-0.127000><5.512400,0.035000,0.127000> rotate<0,0.000000,0> translate<34.558000,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.562800,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,18.167800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<34.562800,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,23.884300>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.583800,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,24.655500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.583800,0.000000,24.634300>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.583800,0.000000,24.634300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,23.906100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.550900>}
box{<0,0,-0.127000><0.644800,0.035000,0.127000> rotate<0,90.000000,0> translate<34.584300,0.000000,24.550900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,23.906100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,23.906100>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.584300,0.000000,23.906100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.130000>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.584300,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.384000>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.584300,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.550900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.633800>}
box{<0,0,-0.127000><0.082900,0.035000,0.127000> rotate<0,90.000000,0> translate<34.584300,0.000000,24.633800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.584300,0.000000,24.633800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.633800>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<34.584300,0.000000,24.633800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.550900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,23.906100>}
box{<0,0,-0.127000><0.644800,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.605500,0.000000,23.906100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.633800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.605500,0.000000,24.550900>}
box{<0,0,-0.127000><0.082900,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.605500,0.000000,24.550900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,23.905500>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,90.000000,0> translate<34.606100,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.884300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.606100,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.905500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.606100,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,24.634300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,24.655500>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,90.000000,0> translate<34.606100,0.000000,24.655500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,24.634300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.634300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.606100,0.000000,24.634300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,24.638000>}
box{<0,0,-0.127000><1.911600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.606100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.606100,0.000000,24.655500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.655500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.606100,0.000000,24.655500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.655600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.955700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<34.655600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.655600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.955700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.655600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.665700,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.169200,-1.535000,18.288000>}
box{<0,0,-0.127000><7.503500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.665700,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.689800,-1.535000,16.456000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,16.436200>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,44.852718,0> translate<34.689800,-1.535000,16.456000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.689800,-1.535000,16.456000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,16.552100>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.689800,-1.535000,16.456000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,14.883700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,15.354300>}
box{<0,0,-0.127000><0.470600,0.035000,0.127000> rotate<0,90.000000,0> translate<34.709700,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,14.986000>}
box{<0,0,-0.127000><7.415500,0.035000,0.127000> rotate<0,0.000000,0> translate<34.709700,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.916300,-1.535000,15.240000>}
box{<0,0,-0.127000><1.206600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.709700,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.640400,-1.535000,15.354300>}
box{<0,0,-0.127000><0.930700,0.035000,0.127000> rotate<0,0.000000,0> translate<34.709700,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,16.436200>}
box{<0,0,-0.127000><0.294600,0.035000,0.127000> rotate<0,90.000000,0> translate<34.709700,-1.535000,16.436200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.306000,-1.535000,16.141600>}
box{<0,0,-0.127000><0.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<34.709700,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.709700,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.348500,-1.535000,16.256000>}
box{<0,0,-0.127000><0.638800,0.035000,0.127000> rotate<0,0.000000,0> translate<34.709700,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.743800,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.498400,-1.535000,16.510000>}
box{<0,0,-0.127000><0.754600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.743800,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,16.552100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.233100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,90.000000,0> translate<34.785900,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,16.764000>}
box{<0,0,-0.127000><7.263100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.785900,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.018000>}
box{<0,0,-0.127000><7.263100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.785900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,18.167800>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,90.000000,0> translate<34.785900,-1.535000,18.167800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.526000>}
box{<0,0,-0.127000><7.263100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.785900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.780000>}
box{<0,0,-0.127000><7.263100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.785900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.785900,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,18.034000>}
box{<0,0,-0.127000><7.263100,0.035000,0.127000> rotate<0,0.000000,0> translate<34.785900,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,23.937100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.137100,-1.535000,23.714000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<34.914000,-1.535000,23.937100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,24.768100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,23.937100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.914000,-1.535000,23.937100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,24.768100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.067600,-1.535000,24.768100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.914000,-1.535000,24.768100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.021700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.067600,-1.535000,25.021700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<34.914000,-1.535000,25.021700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.852800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.021700>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.914000,-1.535000,25.021700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.914000,-1.535000,25.852800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.137100,-1.535000,26.075900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.914000,-1.535000,25.852800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.955700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.347700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<34.955700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.955700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.347700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<34.955700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,23.021200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,22.364600>}
box{<0,0,-0.127000><0.656600,0.035000,0.127000> rotate<0,-90.000000,0> translate<34.990200,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<34.990200,-1.535000,23.021200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.168700,-1.535000,23.199700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<34.990200,-1.535000,23.021200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.137100,-1.535000,23.714000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,23.714000>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<35.137100,-1.535000,23.714000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.137100,-1.535000,26.075900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,26.075900>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<35.137100,-1.535000,26.075900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.168700,-1.535000,23.199700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.221200,-1.535000,23.199700>}
box{<0,0,-0.127000><2.052500,0.035000,0.127000> rotate<0,0.000000,0> translate<35.168700,-1.535000,23.199700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.306000,-1.535000,16.153600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.306000,-1.535000,16.141600>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,-90.000000,0> translate<35.306000,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.306000,-1.535000,16.153600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.422000,-1.535000,16.433600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<35.306000,-1.535000,16.153600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.347700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.772200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<35.347700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.347700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.772200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<35.347700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.422000,-1.535000,16.433600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.636300,-1.535000,16.647900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<35.422000,-1.535000,16.433600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.533300,-1.535000,27.419300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.549000,-1.535000,27.381300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<35.533300,-1.535000,27.419300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.533300,-1.535000,28.206600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.549000,-1.535000,28.244600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<35.533300,-1.535000,28.206600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.549000,-1.535000,27.381300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.763300,-1.535000,27.167000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<35.549000,-1.535000,27.381300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.549000,-1.535000,28.244600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.763300,-1.535000,28.458900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<35.549000,-1.535000,28.244600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.636300,-1.535000,16.647900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.916300,-1.535000,16.763900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<35.636300,-1.535000,16.647900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.640400,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.916300,-1.535000,15.240000>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,22.501790,0> translate<35.640400,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.763300,-1.535000,27.167000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.043300,-1.535000,27.051000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<35.763300,-1.535000,27.167000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.763300,-1.535000,28.458900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.043300,-1.535000,28.574900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<35.763300,-1.535000,28.458900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.772200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.164200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<35.772200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.772200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.164200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<35.772200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.894600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.765400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<35.894600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.894800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.765000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<35.894800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.916300,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.219600,-1.535000,15.240000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<35.916300,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<35.916300,-1.535000,16.763900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.219600,-1.535000,16.763900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<35.916300,-1.535000,16.763900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.043300,-1.535000,27.051000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.346600,-1.535000,27.051000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.043300,-1.535000,27.051000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.043300,-1.535000,28.574900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.346600,-1.535000,28.574900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.043300,-1.535000,28.574900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.507600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.884300>}
box{<0,0,-0.127000><0.376700,0.035000,0.127000> rotate<0,90.000000,0> translate<36.048400,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.507600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.104000,0.000000,23.507600>}
box{<0,0,-0.127000><0.055600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,23.507600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.622000>}
box{<0,0,-0.127000><0.393100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.876000>}
box{<0,0,-0.127000><0.393100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.327800>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,90.000000,0> translate<36.048400,0.000000,24.327800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,24.130000>}
box{<0,0,-0.127000><0.393100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.327800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.634300>}
box{<0,0,-0.127000><0.306500,0.035000,0.127000> rotate<0,90.000000,0> translate<36.048400,0.000000,24.634300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.497700,0.000000,24.384000>}
box{<0,0,-0.127000><0.449300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.655500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.717700>}
box{<0,0,-0.127000><0.062200,0.035000,0.127000> rotate<0,90.000000,0> translate<36.048400,0.000000,24.717700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.048400,0.000000,24.717700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,24.717700>}
box{<0,0,-0.127000><0.469300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.048400,0.000000,24.717700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.067600,-1.535000,25.021700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.067600,-1.535000,24.768100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.067600,-1.535000,24.768100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,23.714000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,24.767600>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<36.068100,-1.535000,24.767600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,24.767600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,24.767600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,24.767600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.022300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,26.075900>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<36.068100,-1.535000,26.075900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.022300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.022300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,25.022300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.146000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.400000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.654000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.068100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.908000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.068100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.104000,0.000000,23.507600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,23.277000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<36.104000,0.000000,23.507600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.164200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.464300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<36.164200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.164200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.464300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<36.164200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.219600,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.495500,-1.535000,15.354300>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,-22.501790,0> translate<36.219600,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.219600,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.927300,-1.535000,15.240000>}
box{<0,0,-0.127000><2.707700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.219600,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.219600,-1.535000,16.763900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.499600,-1.535000,16.647900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<36.219600,-1.535000,16.763900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.243600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.368000>}
box{<0,0,-0.127000><0.197900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.243600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.306500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.353400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.306500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.306600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.353300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.306600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,23.714000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.252800,-1.535000,23.714000>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.321700,-1.535000,23.714000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,24.767600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,23.714000>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.321700,-1.535000,23.714000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,26.075900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,25.022300>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.321700,-1.535000,25.022300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.321700,-1.535000,26.075900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.252800,-1.535000,26.075900>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.321700,-1.535000,26.075900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.322300,-1.535000,24.768100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.322300,-1.535000,25.021700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<36.322300,-1.535000,25.021700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.322300,-1.535000,24.768100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,24.768100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.322300,-1.535000,24.768100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.322300,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,24.892000>}
box{<0,0,-0.127000><3.428700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.322300,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.322300,-1.535000,25.021700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.021700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.322300,-1.535000,25.021700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,22.272200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,23.277000>}
box{<0,0,-0.127000><1.004800,0.035000,0.127000> rotate<0,90.000000,0> translate<36.334600,0.000000,23.277000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,22.272200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.272200>}
box{<0,0,-0.127000><0.183100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.334600,0.000000,22.272200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.352000>}
box{<0,0,-0.127000><0.183100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.334600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.606000>}
box{<0,0,-0.127000><0.183100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.334600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,22.860000>}
box{<0,0,-0.127000><0.106900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.334600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.334600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.114000>}
box{<0,0,-0.127000><0.106900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.334600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.346600,-1.535000,27.051000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626600,-1.535000,27.167000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<36.346600,-1.535000,27.051000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.346600,-1.535000,28.574900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626600,-1.535000,28.458900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<36.346600,-1.535000,28.574900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,22.712100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.635900>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,44.997030,0> translate<36.441500,0.000000,22.712100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.134300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,22.712100>}
box{<0,0,-0.127000><0.422200,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.441500,0.000000,22.712100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.134300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.134300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.441500,0.000000,23.134300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.155500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.155500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.441500,0.000000,23.155500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.577800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.155500>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.441500,0.000000,23.155500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.577800>}
box{<0,0,-0.127000><0.306500,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.441500,0.000000,23.577800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.884300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.441500,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.905500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.441500,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,24.327800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,23.905500>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.441500,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.441500,0.000000,24.327800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,24.404000>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,-44.997030,0> translate<36.441500,0.000000,24.327800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,16.663600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,17.360200>}
box{<0,0,-0.127000><0.696600,0.035000,0.127000> rotate<0,90.000000,0> translate<36.461600,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,16.663600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.499600,0.000000,16.647900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<36.461600,0.000000,16.663600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,16.764000>}
box{<0,0,-0.127000><2.514700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.461600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,17.018000>}
box{<0,0,-0.127000><2.514700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.461600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,17.272000>}
box{<0,0,-0.127000><2.514700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.461600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.461600,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.756200,0.000000,17.360200>}
box{<0,0,-0.127000><0.294600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.461600,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.464300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<36.464300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.464300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<36.464300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.495500,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.813000,-1.535000,15.354300>}
box{<0,0,-0.127000><2.317500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.495500,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.499600,0.000000,16.647900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.713900,0.000000,16.433600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<36.499600,0.000000,16.647900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.499600,-1.535000,16.647900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.713900,-1.535000,16.433600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<36.499600,-1.535000,16.647900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.504100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.155700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.504100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.504200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.155800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.504200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.635900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,22.272200>}
box{<0,0,-0.127000><0.363700,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.517700,0.000000,22.272200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,24.717700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.517700,0.000000,24.404000>}
box{<0,0,-0.127000><0.313700,0.035000,0.127000> rotate<0,-90.000000,0> translate<36.517700,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.609400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.050400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<36.609400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.609400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.050600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<36.609400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626600,-1.535000,27.167000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.840900,-1.535000,27.381300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<36.626600,-1.535000,27.167000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626600,-1.535000,28.458900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.840900,-1.535000,28.244600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<36.626600,-1.535000,28.458900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<36.626700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.626700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.626700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.637500,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.927400,0.000000,16.510000>}
box{<0,0,-0.127000><2.289900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.637500,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.637500,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.927400,-1.535000,16.510000>}
box{<0,0,-0.127000><2.289900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.637500,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.637500,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.896400,-1.535000,28.448000>}
box{<0,0,-0.127000><8.258900,0.035000,0.127000> rotate<0,0.000000,0> translate<36.637500,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.637600,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.896300,-1.535000,27.178000>}
box{<0,0,-0.127000><8.258700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.637600,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.713900,0.000000,16.433600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,16.153600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<36.713900,0.000000,16.433600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.713900,-1.535000,16.433600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,-1.535000,16.153600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<36.713900,-1.535000,16.433600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.750900,0.000000,15.659700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,15.850300>}
box{<0,0,-0.127000><0.206323,0.035000,0.127000> rotate<0,-67.482488,0> translate<36.750900,0.000000,15.659700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.750900,0.000000,15.659700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.391200,0.000000,15.659700>}
box{<0,0,-0.127000><0.640300,0.035000,0.127000> rotate<0,0.000000,0> translate<36.750900,0.000000,15.659700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.756200,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,17.434000>}
box{<0,0,-0.127000><0.104298,0.035000,0.127000> rotate<0,-45.035872,0> translate<36.756200,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.787400,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,15.748000>}
box{<0,0,-0.127000><1.820600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.787400,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.787500,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.703100,0.000000,16.256000>}
box{<0,0,-0.127000><1.915600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.787500,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.787500,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.703100,-1.535000,16.256000>}
box{<0,0,-0.127000><1.915600,0.035000,0.127000> rotate<0,0.000000,0> translate<36.787500,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,15.850300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,16.153600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<36.829900,0.000000,16.153600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,16.002000>}
box{<0,0,-0.127000><1.778100,0.035000,0.127000> rotate<0,0.000000,0> translate<36.829900,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,-1.535000,16.153600>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,90.000000,0> translate<36.829900,-1.535000,16.153600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.655700,-1.535000,16.141600>}
box{<0,0,-0.127000><1.825800,0.035000,0.127000> rotate<0,0.000000,0> translate<36.829900,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.829900,0.000000,17.434000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.903700,0.000000,17.360200>}
box{<0,0,-0.127000><0.104369,0.035000,0.127000> rotate<0,44.997030,0> translate<36.829900,0.000000,17.434000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.840900,-1.535000,27.381300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.856600,-1.535000,27.419300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<36.840900,-1.535000,27.381300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.840900,-1.535000,28.244600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.856600,-1.535000,28.206600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<36.840900,-1.535000,28.244600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.856600,-1.535000,27.419300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.677300,-1.535000,27.419300>}
box{<0,0,-0.127000><7.820700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.856600,-1.535000,27.419300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.856600,-1.535000,28.206600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.677300,-1.535000,28.206600>}
box{<0,0,-0.127000><7.820700,0.035000,0.127000> rotate<0,0.000000,0> translate<36.856600,-1.535000,28.206600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<36.903700,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.456200,0.000000,17.360200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<36.903700,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.195600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<37.033200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<37.033200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.033200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.195600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<37.033200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.195600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.495700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<37.195600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.195600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.495700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<37.195600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.221200,-1.535000,23.199700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,23.021200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<37.221200,-1.535000,23.199700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.252800,-1.535000,23.714000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,23.937100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<37.252800,-1.535000,23.714000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.252800,-1.535000,26.075900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.852800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<37.252800,-1.535000,26.075900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.306900,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.114000>}
box{<0,0,-0.127000><0.782100,0.035000,0.127000> rotate<0,0.000000,0> translate<37.306900,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.391200,0.000000,15.659700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.411100,0.000000,15.639800>}
box{<0,0,-0.127000><0.028143,0.035000,0.127000> rotate<0,44.997030,0> translate<37.391200,0.000000,15.659700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,23.021200>}
box{<0,0,-0.127000><0.656600,0.035000,0.127000> rotate<0,90.000000,0> translate<37.399700,-1.535000,23.021200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.390000,-1.535000,22.364600>}
box{<0,0,-0.127000><0.990300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.399700,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.150100,-1.535000,22.606000>}
box{<0,0,-0.127000><0.750400,0.035000,0.127000> rotate<0,0.000000,0> translate<37.399700,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.399700,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,22.860000>}
box{<0,0,-0.127000><0.689300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.399700,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.411100,0.000000,15.639800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.507100,0.000000,15.735900>}
box{<0,0,-0.127000><0.135835,0.035000,0.127000> rotate<0,-45.026854,0> translate<37.411100,0.000000,15.639800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.414800,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.876000>}
box{<0,0,-0.127000><0.674200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.414800,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.420700,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.213300,-1.535000,25.908000>}
box{<0,0,-0.127000><3.792600,0.035000,0.127000> rotate<0,0.000000,0> translate<37.420700,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,23.937100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,24.768100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,90.000000,0> translate<37.475900,-1.535000,24.768100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,24.130000>}
box{<0,0,-0.127000><0.613100,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,24.384000>}
box{<0,0,-0.127000><0.613100,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.144200,-1.535000,24.638000>}
box{<0,0,-0.127000><0.668300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.021700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.852800>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,90.000000,0> translate<37.475900,-1.535000,25.852800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,25.146000>}
box{<0,0,-0.127000><2.275100,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.846100,-1.535000,25.400000>}
box{<0,0,-0.127000><2.370200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.475900,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.070400,-1.535000,25.654000>}
box{<0,0,-0.127000><2.594500,0.035000,0.127000> rotate<0,0.000000,0> translate<37.475900,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.495700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.887700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<37.495700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.495700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.887700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<37.495700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.507100,0.000000,15.735900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,15.735900>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<37.507100,0.000000,15.735900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.155500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.134300>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,-90.000000,0> translate<37.883800,0.000000,23.134300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.883800,0.000000,23.884300>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,-90.000000,0> translate<37.883800,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.156100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.800900>}
box{<0,0,-0.127000><0.644800,0.035000,0.127000> rotate<0,90.000000,0> translate<37.884300,0.000000,23.800900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.156100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.156100>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.884300,0.000000,23.156100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.368000>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.884300,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.622000>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.884300,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.800900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.883800>}
box{<0,0,-0.127000><0.082900,0.035000,0.127000> rotate<0,90.000000,0> translate<37.884300,0.000000,23.883800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.876000>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.884300,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.884300,0.000000,23.883800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.883800>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,0.000000,0> translate<37.884300,0.000000,23.883800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.887700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<37.887700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.887700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<37.887700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.800900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.156100>}
box{<0,0,-0.127000><0.644800,0.035000,0.127000> rotate<0,-90.000000,0> translate<37.905500,0.000000,23.156100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.883800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.905500,0.000000,23.800900>}
box{<0,0,-0.127000><0.082900,0.035000,0.127000> rotate<0,-90.000000,0> translate<37.905500,0.000000,23.800900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.134300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.155500>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,90.000000,0> translate<37.906100,0.000000,23.155500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.134300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.134300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.906100,0.000000,23.134300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.155500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.155500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.906100,0.000000,23.155500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.905500>}
box{<0,0,-0.127000><0.021200,0.035000,0.127000> rotate<0,90.000000,0> translate<37.906100,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.884300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.884300>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.906100,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<37.906100,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.905500>}
box{<0,0,-0.127000><1.442300,0.035000,0.127000> rotate<0,0.000000,0> translate<37.906100,0.000000,23.905500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,22.667100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312100,-1.535000,22.444000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<38.089000,-1.535000,22.667100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.498100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,22.667100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.089000,-1.535000,22.667100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.498100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.242600,-1.535000,23.498100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.089000,-1.535000,23.498100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.751700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.242600,-1.535000,23.751700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.089000,-1.535000,23.751700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,24.582800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,23.751700>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.089000,-1.535000,23.751700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.089000,-1.535000,24.582800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312100,-1.535000,24.805900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.089000,-1.535000,24.582800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.136500,0.000000,13.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,13.474000>}
box{<0,0,-0.127000><0.051600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.136500,0.000000,13.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.136500,0.000000,13.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.996100,0.000000,12.614500>}
box{<0,0,-0.127000><1.215587,0.035000,0.127000> rotate<0,44.993698,0> translate<38.136500,0.000000,13.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.148600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.462000>}
box{<0,0,-0.127000><1.208700,0.035000,0.127000> rotate<0,0.000000,0> translate<38.148600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,13.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.477600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<38.188100,0.000000,14.477600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,13.716000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,13.970000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.224000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.477600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.477600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,14.477600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.732300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,15.735900>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<38.188100,0.000000,15.735900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.732300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.732300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,14.732300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.986000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,15.240000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.188100,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,15.494000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.188100,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312100,-1.535000,22.444000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,22.444000>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<38.312100,-1.535000,22.444000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312100,-1.535000,24.805900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,24.805900>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<38.312100,-1.535000,24.805900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.704200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<38.312200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.312200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.704200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<38.312200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.390000,-1.535000,22.364600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.620600,-1.535000,22.134000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<38.390000,-1.535000,22.364600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.402600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.208000>}
box{<0,0,-0.127000><0.954700,0.035000,0.127000> rotate<0,0.000000,0> translate<38.402600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.402600,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,22.352000>}
box{<0,0,-0.127000><1.843700,0.035000,0.127000> rotate<0,0.000000,0> translate<38.402600,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.434600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.305400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<38.434600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.434800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.305000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<38.434800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,13.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.122800,0.000000,13.474000>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<38.441700,0.000000,13.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.477600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,13.474000>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.441700,0.000000,13.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,15.735900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,14.732300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.441700,0.000000,14.732300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.441700,0.000000,15.735900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,15.735900>}
box{<0,0,-0.127000><0.166300,0.035000,0.127000> rotate<0,0.000000,0> translate<38.441700,0.000000,15.735900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.442300,0.000000,14.478100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.442300,0.000000,14.731700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<38.442300,0.000000,14.731700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.442300,0.000000,14.478100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.478100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.442300,0.000000,14.478100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.442300,0.000000,14.731700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.731700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.442300,0.000000,14.731700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.456200,0.000000,17.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.634700,0.000000,17.538700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.456200,0.000000,17.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.561400,-1.535000,18.656300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.837300,-1.535000,18.542000>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,22.501790,0> translate<38.561400,-1.535000,18.656300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,16.026600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,15.735900>}
box{<0,0,-0.127000><0.290700,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,15.735900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.608000,0.000000,16.026600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.724000,0.000000,16.306600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<38.608000,0.000000,16.026600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.620600,-1.535000,22.134000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.824900,-1.535000,21.929700>}
box{<0,0,-0.127000><0.288924,0.035000,0.127000> rotate<0,44.997030,0> translate<38.620600,-1.535000,22.134000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.622000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,17.526000>}
box{<0,0,-0.127000><0.354300,0.035000,0.127000> rotate<0,0.000000,0> translate<38.622000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.634700,0.000000,17.538700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.634700,0.000000,18.021300>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<38.634700,0.000000,18.021300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.634700,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.194300,0.000000,17.780000>}
box{<0,0,-0.127000><0.559600,0.035000,0.127000> rotate<0,0.000000,0> translate<38.634700,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.634700,0.000000,18.021300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.406000,0.000000,18.021300>}
box{<0,0,-0.127000><0.771300,0.035000,0.127000> rotate<0,0.000000,0> translate<38.634700,0.000000,18.021300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.655700,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.724000,-1.535000,16.306600>}
box{<0,0,-0.127000><0.178577,0.035000,0.127000> rotate<0,-67.508954,0> translate<38.655700,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.656600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.181400,0.000000,12.954000>}
box{<0,0,-0.127000><0.524800,0.035000,0.127000> rotate<0,0.000000,0> translate<38.656600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.656600,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,22.098000>}
box{<0,0,-0.127000><1.589700,0.035000,0.127000> rotate<0,0.000000,0> translate<38.656600,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.704200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.004300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.704200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.704200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.004300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<38.704200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.724000,0.000000,16.306600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,0.000000,16.520900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.724000,0.000000,16.306600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.724000,-1.535000,16.306600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,-1.535000,16.520900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.724000,-1.535000,16.306600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.813000,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,-1.535000,15.229000>}
box{<0,0,-0.127000><0.177201,0.035000,0.127000> rotate<0,44.997030,0> translate<38.813000,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.824900,-1.535000,21.929700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,21.929700>}
box{<0,0,-0.127000><1.421400,0.035000,0.127000> rotate<0,0.000000,0> translate<38.824900,-1.535000,21.929700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.837300,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.140600,-1.535000,18.542000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<38.837300,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.846500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.893400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<38.846500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.846600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.893300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<38.846600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.910600,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.031500,0.000000,12.700000>}
box{<0,0,-0.127000><0.120900,0.035000,0.127000> rotate<0,0.000000,0> translate<38.910600,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,-1.535000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.218300,-1.535000,15.113000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<38.938300,-1.535000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,0.000000,16.520900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,16.536600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<38.938300,0.000000,16.520900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.938300,-1.535000,16.520900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.218300,-1.535000,16.636900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<38.938300,-1.535000,16.520900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,17.562000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,16.536600>}
box{<0,0,-0.127000><1.025400,0.035000,0.127000> rotate<0,-90.000000,0> translate<38.976300,0.000000,16.536600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.976300,0.000000,17.562000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.206900,0.000000,17.792600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<38.976300,0.000000,17.562000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<38.996100,0.000000,12.614500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.105000,0.000000,12.877600>}
box{<0,0,-0.127000><0.284747,0.035000,0.127000> rotate<0,-67.510340,0> translate<38.996100,0.000000,12.614500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.004300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<39.004300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.004300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<39.004300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.044100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.695700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.044100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.044200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.695800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.044200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.105000,0.000000,12.877600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.319300,0.000000,13.091900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.105000,0.000000,12.877600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.122800,0.000000,13.474000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,13.697100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.122800,0.000000,13.474000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.140600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.420600,-1.535000,18.658000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<39.140600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.140600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,-1.535000,18.542000>}
box{<0,0,-0.127000><0.839700,0.035000,0.127000> rotate<0,0.000000,0> translate<39.140600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.149400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.590400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<39.149400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.149400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.590600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<39.149400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<39.166700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.166700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.166700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.206900,0.000000,17.792600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.533000,0.000000,17.792600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<39.206900,0.000000,17.792600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.218300,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,-1.535000,15.113000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.218300,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.218300,-1.535000,16.636900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,-1.535000,16.636900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.218300,-1.535000,16.636900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.242600,-1.535000,23.751700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.242600,-1.535000,23.498100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.242600,-1.535000,23.498100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,22.444000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.497600>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<39.243100,-1.535000,23.497600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,22.606000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,22.860000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.114000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.368000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.497600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.497600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,23.497600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.752300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,24.805900>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<39.243100,-1.535000,24.805900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.752300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.752300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,23.752300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.243100,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.243100,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.272200,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.272200,0.000000,24.879300>}
box{<0,0,-0.127000><0.475300,0.035000,0.127000> rotate<0,90.000000,0> translate<39.272200,0.000000,24.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.272200,0.000000,24.404000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,24.327800>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,44.997030,0> translate<39.272200,0.000000,24.404000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.272200,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.845900,0.000000,24.638000>}
box{<0,0,-0.127000><0.573700,0.035000,0.127000> rotate<0,0.000000,0> translate<39.272200,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.272200,0.000000,24.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,0.000000,24.879300>}
box{<0,0,-0.127000><0.478800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.272200,0.000000,24.879300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.292200,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.070300,0.000000,24.384000>}
box{<0,0,-0.127000><0.778100,0.035000,0.127000> rotate<0,0.000000,0> translate<39.292200,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.319300,0.000000,13.091900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.107600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-22.446872,0> translate<39.319300,0.000000,13.091900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,13.697100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.478100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,90.000000,0> translate<39.345900,0.000000,14.478100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.716000>}
box{<0,0,-0.127000><0.011400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.970000>}
box{<0,0,-0.127000><0.011400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,14.224000>}
box{<0,0,-0.127000><0.011400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,14.478000>}
box{<0,0,-0.127000><0.011400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.731700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,15.113000>}
box{<0,0,-0.127000><0.381300,0.035000,0.127000> rotate<0,90.000000,0> translate<39.345900,0.000000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.448300,0.000000,14.732000>}
box{<0,0,-0.127000><0.102400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.702300,0.000000,14.986000>}
box{<0,0,-0.127000><0.356400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.345900,0.000000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,0.000000,15.113000>}
box{<0,0,-0.127000><0.175700,0.035000,0.127000> rotate<0,0.000000,0> translate<39.345900,0.000000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,22.745600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.134300>}
box{<0,0,-0.127000><0.388700,0.035000,0.127000> rotate<0,90.000000,0> translate<39.348400,0.000000,23.134300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,22.745600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.406000,0.000000,22.745600>}
box{<0,0,-0.127000><0.057600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,22.745600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,22.860000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,23.114000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.155500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.577800>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,90.000000,0> translate<39.348400,0.000000,23.577800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,23.368000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.577800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.884300>}
box{<0,0,-0.127000><0.306500,0.035000,0.127000> rotate<0,90.000000,0> translate<39.348400,0.000000,23.884300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,23.622000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,23.876000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,23.905500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,24.327800>}
box{<0,0,-0.127000><0.422300,0.035000,0.127000> rotate<0,90.000000,0> translate<39.348400,0.000000,24.327800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.348400,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,24.130000>}
box{<0,0,-0.127000><1.391800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.348400,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,14.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,13.107600>}
box{<0,0,-0.127000><1.533400,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.357300,0.000000,13.107600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.357300,0.000000,14.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.587900,0.000000,14.871600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.357300,0.000000,14.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.406000,0.000000,18.021300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,18.251900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.406000,0.000000,18.021300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.406000,0.000000,22.745600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.515000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<39.406000,0.000000,22.745600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.418700,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.034000>}
box{<0,0,-0.127000><2.255300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.418700,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.420600,-1.535000,18.658000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.560500,-1.535000,18.797900>}
box{<0,0,-0.127000><0.197848,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.420600,-1.535000,18.658000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,22.444000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,22.444000>}
box{<0,0,-0.127000><0.749600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.496700,-1.535000,22.444000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.497600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,22.444000>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.496700,-1.535000,22.444000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,24.805900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,23.752300>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.496700,-1.535000,23.752300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.496700,-1.535000,24.805900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.776500,-1.535000,24.805900>}
box{<0,0,-0.127000><0.279800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.496700,-1.535000,24.805900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,0.000000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.738300,0.000000,15.202800>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-22.507523,0> translate<39.521600,0.000000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,-1.535000,15.113000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.801600,-1.535000,15.229000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<39.521600,-1.535000,15.113000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.521600,-1.535000,16.636900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.801600,-1.535000,16.520900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<39.521600,-1.535000,16.636900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.533000,0.000000,17.792600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.506600,0.000000,17.792600>}
box{<0,0,-0.127000><0.973600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.533000,0.000000,17.792600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.545600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.752900,0.000000,22.606000>}
box{<0,0,-0.127000><1.207300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.545600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.558600,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.562300,-1.535000,18.796000>}
box{<0,0,-0.127000><0.003700,0.035000,0.127000> rotate<0,0.000000,0> translate<39.558600,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.560500,-1.535000,18.797900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.700300,-1.535000,18.658000>}
box{<0,0,-0.127000><0.197778,0.035000,0.127000> rotate<0,45.017514,0> translate<39.560500,-1.535000,18.797900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.735600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<39.573200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.573200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.573200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.735600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<39.573200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.587900,0.000000,14.871600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.738300,0.000000,15.022000>}
box{<0,0,-0.127000><0.212698,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.587900,0.000000,14.871600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,18.251900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.942400,0.000000,18.557800>}
box{<0,0,-0.127000><0.432537,0.035000,0.127000> rotate<0,-45.006396,0> translate<39.636600,0.000000,18.251900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,19.886100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.188900>}
box{<0,0,-0.127000><2.302800,0.035000,0.127000> rotate<0,90.000000,0> translate<39.636600,0.000000,22.188900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,19.886100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.700300,0.000000,19.949900>}
box{<0,0,-0.127000><0.090156,0.035000,0.127000> rotate<0,-45.041965,0> translate<39.636600,0.000000,19.886100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.102400,0.000000,20.066000>}
box{<0,0,-0.127000><2.465800,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,0.000000,20.320000>}
box{<0,0,-0.127000><3.289400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.772100,0.000000,20.574000>}
box{<0,0,-0.127000><1.135500,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,20.828000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.082000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.336000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.567600,0.000000,21.590000>}
box{<0,0,-0.127000><1.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.844000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,22.098000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.188900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.515000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<39.636600,0.000000,22.515000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.636600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,22.352000>}
box{<0,0,-0.127000><1.027400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.636600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.672600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.288000>}
box{<0,0,-0.127000><2.001400,0.035000,0.127000> rotate<0,0.000000,0> translate<39.672600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.700300,-1.535000,18.658000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,-1.535000,18.542000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<39.700300,-1.535000,18.658000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.700300,0.000000,19.949900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,0.000000,20.065900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<39.700300,0.000000,19.949900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.735600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.035700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<39.735600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.735600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.035700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.735600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.738300,0.000000,15.202800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.738300,0.000000,15.022000>}
box{<0,0,-0.127000><0.180800,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.738300,0.000000,15.022000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,24.867300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.776500,-1.535000,24.805900>}
box{<0,0,-0.127000><0.066485,0.035000,0.127000> rotate<0,67.441975,0> translate<39.751000,-1.535000,24.867300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,0.000000,24.867300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,0.000000,24.587300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<39.751000,0.000000,24.867300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,0.000000,24.879300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,0.000000,24.867300>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.751000,0.000000,24.867300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,25.170600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,24.867300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<39.751000,-1.535000,24.867300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.751000,-1.535000,25.170600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,-1.535000,25.450600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<39.751000,-1.535000,25.170600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.801600,-1.535000,15.229000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.926900,-1.535000,15.354300>}
box{<0,0,-0.127000><0.177201,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.801600,-1.535000,15.229000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.801600,-1.535000,16.520900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.015900,-1.535000,16.306600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<39.801600,-1.535000,16.520900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.812500,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.091100,-1.535000,16.510000>}
box{<0,0,-0.127000><2.278600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.812500,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.812600,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,15.240000>}
box{<0,0,-0.127000><2.312600,0.035000,0.127000> rotate<0,0.000000,0> translate<39.812600,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.851300,-1.535000,14.490600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,-1.535000,14.528600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<39.851300,-1.535000,14.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,-1.535000,14.528600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,-1.535000,14.742900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.867000,-1.535000,14.528600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,0.000000,24.587300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,0.000000,24.373000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<39.867000,0.000000,24.587300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.867000,-1.535000,25.450600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,-1.535000,25.664900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<39.867000,-1.535000,25.450600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.926600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,0.000000,18.542000>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,0.000000,0> translate<39.926600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.926900,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,15.354300>}
box{<0,0,-0.127000><2.198300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.926900,-1.535000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.942400,0.000000,18.557800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,0.000000,18.542000>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,22.629105,0> translate<39.942400,0.000000,18.557800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,0.000000,18.542000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.980300,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,-1.535000,18.542000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.980300,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<39.980300,0.000000,20.065900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,0.000000,20.065900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<39.980300,0.000000,20.065900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.015900,-1.535000,16.306600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.084200,-1.535000,16.141600>}
box{<0,0,-0.127000><0.178577,0.035000,0.127000> rotate<0,67.508954,0> translate<40.015900,-1.535000,16.306600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.035700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.427700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<40.035700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.035700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.427700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.035700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.036900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,16.256000>}
box{<0,0,-0.127000><2.088300,0.035000,0.127000> rotate<0,0.000000,0> translate<40.036900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,-1.535000,14.742900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,-1.535000,14.858900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.081300,-1.535000,14.742900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,0.000000,24.373000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,0.000000,24.257000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<40.081300,0.000000,24.373000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.081300,-1.535000,25.664900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,-1.535000,25.780900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.081300,-1.535000,25.664900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.084200,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,16.141600>}
box{<0,0,-0.127000><2.041000,0.035000,0.127000> rotate<0,0.000000,0> translate<40.084200,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.144600,0.000000,13.107600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.144600,0.000000,13.424800>}
box{<0,0,-0.127000><0.317200,0.035000,0.127000> rotate<0,90.000000,0> translate<40.144600,0.000000,13.424800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.144600,0.000000,13.107600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.182600,0.000000,13.091900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<40.144600,0.000000,13.107600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.144600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,13.208000>}
box{<0,0,-0.127000><5.689700,0.035000,0.127000> rotate<0,0.000000,0> translate<40.144600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.144600,0.000000,13.424800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,0.000000,13.335000>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,22.507523,0> translate<40.144600,0.000000,13.424800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.182600,0.000000,13.091900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.396900,0.000000,12.877600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<40.182600,0.000000,13.091900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,22.444000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.246300,-1.535000,21.929700>}
box{<0,0,-0.127000><0.514300,0.035000,0.127000> rotate<0,-90.000000,0> translate<40.246300,-1.535000,21.929700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,0.000000,18.658000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.283600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,-1.535000,18.658000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.283600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.542000>}
box{<0,0,-0.127000><1.390400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.283600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.542000>}
box{<0,0,-0.127000><6.060400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.283600,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.283600,0.000000,20.065900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,0.000000,19.949900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<40.283600,0.000000,20.065900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.320500,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.954000>}
box{<0,0,-0.127000><5.513800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.320500,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,0.000000,13.335000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<40.361300,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,-1.535000,14.858900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,-1.535000,14.858900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<40.361300,-1.535000,14.858900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,0.000000,24.257000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,0.000000,24.257000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<40.361300,0.000000,24.257000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.361300,-1.535000,25.780900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,-1.535000,25.780900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<40.361300,-1.535000,25.780900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.396900,0.000000,12.877600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.512900,0.000000,12.597600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<40.396900,0.000000,12.877600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.423100,0.000000,12.077600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.512900,0.000000,12.294300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<40.423100,0.000000,12.077600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.423100,0.000000,12.077600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.077600>}
box{<0,0,-0.127000><5.411200,0.035000,0.127000> rotate<0,0.000000,0> translate<40.423100,0.000000,12.077600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.427700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.852200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.427700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.427700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.852200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.427700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.470500,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.192000>}
box{<0,0,-0.127000><5.363800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.470500,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.470500,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.700000>}
box{<0,0,-0.127000><5.363800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.470500,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.506600,0.000000,17.792600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.653700,0.000000,17.939700>}
box{<0,0,-0.127000><0.208031,0.035000,0.127000> rotate<0,-44.997030,0> translate<40.506600,0.000000,17.792600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.512900,0.000000,12.294300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.512900,0.000000,12.597600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<40.512900,0.000000,12.597600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.512900,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.446000>}
box{<0,0,-0.127000><5.321400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.512900,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,0.000000,18.658000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,0.000000,18.872300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<40.563600,0.000000,18.658000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,-1.535000,18.658000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,-1.535000,18.872300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<40.563600,-1.535000,18.658000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.563600,0.000000,19.949900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,0.000000,19.735600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<40.563600,0.000000,19.949900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.653700,0.000000,17.939700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.240200,0.000000,17.939700>}
box{<0,0,-0.127000><0.586500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.653700,0.000000,17.939700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,20.682100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.887100,0.000000,20.459000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<40.664000,0.000000,20.682100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.463100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,20.682100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,-90.000000,0> translate<40.664000,0.000000,20.682100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.463100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.567600,0.000000,21.463100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<40.664000,0.000000,21.463100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.716700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.567600,0.000000,21.716700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<40.664000,0.000000,21.716700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,22.497800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,21.716700>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,-90.000000,0> translate<40.664000,0.000000,21.716700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664000,0.000000,22.497800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.762600,0.000000,22.596400>}
box{<0,0,-0.127000><0.139441,0.035000,0.127000> rotate<0,-44.997030,0> translate<40.664000,0.000000,22.497800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,0.000000,13.335000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,0.000000,13.451000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.664600,0.000000,13.335000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,-1.535000,14.858900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,-1.535000,14.742900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<40.664600,-1.535000,14.858900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,0.000000,24.257000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,24.288400>}
box{<0,0,-0.127000><0.081862,0.035000,0.127000> rotate<0,-22.553769,0> translate<40.664600,0.000000,24.257000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.664600,-1.535000,25.780900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,-1.535000,25.664900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<40.664600,-1.535000,25.780900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.701500,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.952500,0.000000,19.812000>}
box{<0,0,-0.127000><1.251000,0.035000,0.127000> rotate<0,0.000000,0> translate<40.701500,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.701600,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.796000>}
box{<0,0,-0.127000><0.972400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.701600,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.701600,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,-1.535000,18.796000>}
box{<0,0,-0.127000><1.818700,0.035000,0.127000> rotate<0,0.000000,0> translate<40.701600,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,22.618700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.762600,0.000000,22.596400>}
box{<0,0,-0.127000><0.031608,0.035000,0.127000> rotate<0,44.868860,0> translate<40.740200,0.000000,22.618700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,24.288400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.740200,0.000000,22.618700>}
box{<0,0,-0.127000><1.669700,0.035000,0.127000> rotate<0,-90.000000,0> translate<40.740200,0.000000,22.618700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,-1.535000,18.872300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.793600,-1.535000,18.910300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<40.777900,-1.535000,18.872300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,0.000000,18.872300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.893900,0.000000,19.152300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<40.777900,0.000000,18.872300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.777900,0.000000,19.735600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.893900,0.000000,19.455600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<40.777900,0.000000,19.735600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.793600,-1.535000,18.910300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.803000,-1.535000,18.910300>}
box{<0,0,-0.127000><0.009400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.793600,-1.535000,18.910300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.803000,-1.535000,18.910300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.244400,-1.535000,18.910300>}
box{<0,0,-0.127000><1.441400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.803000,-1.535000,18.910300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.851500,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,19.050000>}
box{<0,0,-0.127000><0.822500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.851500,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.851500,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,0.000000,19.558000>}
box{<0,0,-0.127000><1.058500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.851500,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.852200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.244200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<40.852200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.852200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.244200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<40.852200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.887100,0.000000,20.459000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,20.459000>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<40.887100,0.000000,20.459000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.893900,0.000000,19.152300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.893900,0.000000,19.455600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<40.893900,0.000000,19.455600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.893900,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.952400,0.000000,19.304000>}
box{<0,0,-0.127000><1.058500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.893900,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.906600,0.000000,14.758600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.906600,0.000000,15.004000>}
box{<0,0,-0.127000><0.245400,0.035000,0.127000> rotate<0,90.000000,0> translate<40.906600,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.906600,0.000000,14.758600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,0.000000,14.742900>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<40.906600,0.000000,14.758600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.906600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.986000>}
box{<0,0,-0.127000><0.792400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.906600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.906600,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.004000>}
box{<0,0,-0.127000><0.272800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.906600,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,0.000000,13.451000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,0.000000,13.665300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<40.944600,0.000000,13.451000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,0.000000,14.742900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,0.000000,14.528600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<40.944600,0.000000,14.742900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,-1.535000,14.742900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,14.528600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<40.944600,-1.535000,14.742900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.944600,-1.535000,25.664900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,25.450600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<40.944600,-1.535000,25.664900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.955500,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.732000>}
box{<0,0,-0.127000><0.743500,0.035000,0.127000> rotate<0,0.000000,0> translate<40.955500,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.955500,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.276900,-1.535000,14.732000>}
box{<0,0,-0.127000><1.321400,0.035000,0.127000> rotate<0,0.000000,0> translate<40.955500,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.955500,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,25.654000>}
box{<0,0,-0.127000><0.675800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.955500,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.955600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,13.462000>}
box{<0,0,-0.127000><4.878700,0.035000,0.127000> rotate<0,0.000000,0> translate<40.955600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.974600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.845400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<40.974600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<40.974800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.845000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<40.974800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.021000,-1.535000,26.264300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,25.984300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<41.021000,-1.535000,26.264300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.021000,-1.535000,26.567600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.021000,-1.535000,26.264300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.021000,-1.535000,26.264300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.021000,-1.535000,26.567600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,26.847600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.021000,-1.535000,26.567600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,19.697600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,24.462000>}
box{<0,0,-0.127000><4.764400,0.035000,0.127000> rotate<0,90.000000,0> translate<41.033600,-1.535000,24.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,19.697600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,19.697600>}
box{<0,0,-0.127000><0.876400,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,19.697600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.952500,-1.535000,19.812000>}
box{<0,0,-0.127000><0.918900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.102400,-1.535000,20.066000>}
box{<0,0,-0.127000><1.068800,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,-1.535000,20.320000>}
box{<0,0,-0.127000><1.892400,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.021100,-1.535000,20.574000>}
box{<0,0,-0.127000><1.987500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.245400,-1.535000,20.828000>}
box{<0,0,-0.127000><2.211800,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.020300,-1.535000,21.082000>}
box{<0,0,-0.127000><2.986700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.274300,-1.535000,21.336000>}
box{<0,0,-0.127000><3.240700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.528300,-1.535000,21.590000>}
box{<0,0,-0.127000><3.494700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.577000,-1.535000,21.844000>}
box{<0,0,-0.127000><3.543400,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.619500,-1.535000,22.098000>}
box{<0,0,-0.127000><3.585900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.769400,-1.535000,22.352000>}
box{<0,0,-0.127000><3.735800,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.068200,-1.535000,22.606000>}
box{<0,0,-0.127000><6.034600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.814200,-1.535000,22.860000>}
box{<0,0,-0.127000><5.780600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.560200,-1.535000,23.114000>}
box{<0,0,-0.127000><5.526600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.306200,-1.535000,23.368000>}
box{<0,0,-0.127000><5.272600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.052200,-1.535000,23.622000>}
box{<0,0,-0.127000><5.018600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.798200,-1.535000,23.876000>}
box{<0,0,-0.127000><4.764600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,24.130000>}
box{<0,0,-0.127000><0.597700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.213300,-1.535000,24.384000>}
box{<0,0,-0.127000><0.179700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.033600,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.033600,-1.535000,24.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.106200,-1.535000,24.534700>}
box{<0,0,-0.127000><0.102743,0.035000,0.127000> rotate<0,-45.036460,0> translate<41.033600,-1.535000,24.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.095100,-1.535000,13.601600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,13.665300>}
box{<0,0,-0.127000><0.090156,0.035000,0.127000> rotate<0,-44.952095,0> translate<41.095100,-1.535000,13.601600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.095100,-1.535000,13.601600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.969900,-1.535000,13.601600>}
box{<0,0,-0.127000><6.874800,0.035000,0.127000> rotate<0,0.000000,0> translate<41.095100,-1.535000,13.601600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.106200,-1.535000,24.534700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,24.460300>}
box{<0,0,-0.127000><0.080523,0.035000,0.127000> rotate<0,67.507041,0> translate<41.106200,-1.535000,24.534700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,24.460300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,24.246000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<41.137000,-1.535000,24.460300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,25.984300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,25.770000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<41.137000,-1.535000,25.984300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.137000,-1.535000,26.847600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,27.061900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<41.137000,-1.535000,26.847600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,0.000000,13.665300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,13.945300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.158900,0.000000,13.665300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,13.665300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,13.945300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.158900,-1.535000,13.665300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,0.000000,14.528600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,14.248600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<41.158900,0.000000,14.528600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,14.528600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,14.248600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<41.158900,-1.535000,14.528600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.158900,-1.535000,25.450600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.189700,-1.535000,25.376200>}
box{<0,0,-0.127000><0.080523,0.035000,0.127000> rotate<0,67.507041,0> translate<41.158900,-1.535000,25.450600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.533900>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,90.000000,0> translate<41.179400,0.000000,15.533900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.494000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179400,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179400,0.000000,15.533900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.533900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179400,0.000000,15.533900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,13.716000>}
box{<0,0,-0.127000><4.654400,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179900,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,13.716000>}
box{<0,0,-0.127000><6.826100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179900,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.478000>}
box{<0,0,-0.127000><0.519100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179900,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.478000>}
box{<0,0,-0.127000><5.240300,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179900,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.179900,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.213500,-1.535000,25.400000>}
box{<0,0,-0.127000><0.033600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.179900,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,15.004000>}
box{<0,0,-0.127000><0.518600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.180400,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.533900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.180400,0.000000,15.004000>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.180400,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.181000,0.000000,15.534400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.181000,0.000000,15.535400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<41.181000,0.000000,15.535400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.181000,0.000000,15.534400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.534400>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.181000,0.000000,15.534400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.181000,0.000000,15.535400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.535400>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.181000,0.000000,15.535400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.189700,-1.535000,25.376200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,25.537900>}
box{<0,0,-0.127000><0.228608,0.035000,0.127000> rotate<0,-45.014751,0> translate<41.189700,-1.535000,25.376200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.240200,0.000000,17.939700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.268600,0.000000,17.952000>}
box{<0,0,-0.127000><0.030949,0.035000,0.127000> rotate<0,-23.415823,0> translate<41.240200,0.000000,17.939700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.244200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.544300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<41.244200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.244200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.544300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<41.244200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.268600,0.000000,17.952000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.299600,0.000000,17.939700>}
box{<0,0,-0.127000><0.033351,0.035000,0.127000> rotate<0,21.640472,0> translate<41.268600,0.000000,17.952000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,13.945300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,14.248600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<41.274900,0.000000,14.248600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,13.945300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,14.248600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<41.274900,-1.535000,14.248600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,13.970000>}
box{<0,0,-0.127000><0.424100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.274900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.048500,-1.535000,13.970000>}
box{<0,0,-0.127000><6.773600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.274900,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.224000>}
box{<0,0,-0.127000><0.424100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.274900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.274900,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.224000>}
box{<0,0,-0.127000><5.145300,0.035000,0.127000> rotate<0,0.000000,0> translate<41.274900,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.299600,0.000000,17.939700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.686500,0.000000,17.939700>}
box{<0,0,-0.127000><0.386900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.299600,0.000000,17.939700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,24.246000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,24.130000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<41.351300,-1.535000,24.246000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,25.537900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,25.653900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<41.351300,-1.535000,25.537900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,25.770000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,25.654000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<41.351300,-1.535000,25.770000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.351300,-1.535000,27.061900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,27.177900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<41.351300,-1.535000,27.061900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.386500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.433400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.386500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.386600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.433300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.386600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.544300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.544300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.544300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<41.544300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.567600,0.000000,21.716700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.567600,0.000000,21.463100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.567600,0.000000,21.463100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,20.459000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,21.462600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<41.568100,0.000000,21.462600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,20.574000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.568100,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,20.828000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.568100,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,21.082000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.568100,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,21.336000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.568100,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.568100,0.000000,21.462600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,21.462600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.568100,0.000000,21.462600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.584100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.235700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.584100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.584200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.235800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<41.584200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.934600,-1.535000,24.130000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<41.631300,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,25.653900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,25.653900>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.631300,-1.535000,25.653900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,25.654000>}
box{<0,0,-0.127000><0.278700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.631300,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.631300,-1.535000,27.177900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.934600,-1.535000,27.177900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<41.631300,-1.535000,27.177900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,17.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.686500,0.000000,17.939700>}
box{<0,0,-0.127000><0.017607,0.035000,0.127000> rotate<0,44.766943,0> translate<41.674000,0.000000,17.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,17.952100>}
box{<0,0,-0.127000><0.557300,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.674000,0.000000,17.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.203900,0.000000,18.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.674000,0.000000,18.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.203900,0.000000,18.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.674000,0.000000,18.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,19.067800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,18.510400>}
box{<0,0,-0.127000><0.557400,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.674000,0.000000,18.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.674000,0.000000,19.067800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.897100,0.000000,19.290900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<41.674000,0.000000,19.067800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.689400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.130400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<41.689400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.689400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.130600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<41.689400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,13.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.922100,0.000000,13.729000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<41.699000,0.000000,13.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,13.952100>}
box{<0,0,-0.127000><0.557300,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.699000,0.000000,13.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.228900,0.000000,14.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.699000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.228900,0.000000,14.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<41.699000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.699000,0.000000,14.510400>}
box{<0,0,-0.127000><0.493600,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.699000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<41.706700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.706700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.706700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,20.459000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.502800,0.000000,20.459000>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.821700,0.000000,20.459000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,21.462600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.821700,0.000000,20.459000>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.821700,0.000000,20.459000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.835900,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.461200>}
box{<0,0,-0.127000><0.069014,0.035000,0.127000> rotate<0,44.997030,0> translate<41.835900,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.835900,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.558700>}
box{<0,0,-0.127000><0.068943,0.035000,0.127000> rotate<0,-44.938269,0> translate<41.835900,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.835900,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.524100,0.000000,16.510000>}
box{<0,0,-0.127000><2.688200,0.035000,0.127000> rotate<0,0.000000,0> translate<41.835900,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.863500,0.000000,17.132300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,17.111200>}
box{<0,0,-0.127000><0.029911,0.035000,0.127000> rotate<0,44.861588,0> translate<41.863500,0.000000,17.132300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.863500,0.000000,17.132300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.905900,0.000000,17.132300>}
box{<0,0,-0.127000><2.042400,0.035000,0.127000> rotate<0,0.000000,0> translate<41.863500,0.000000,17.132300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,15.918900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.461200>}
box{<0,0,-0.127000><0.542300,0.035000,0.127000> rotate<0,90.000000,0> translate<41.884700,0.000000,16.461200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,15.918900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.842800>}
box{<0,0,-0.127000><0.107692,0.035000,0.127000> rotate<0,44.959412,0> translate<41.884700,0.000000,15.918900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.002000>}
box{<0,0,-0.127000><2.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.884700,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.256000>}
box{<0,0,-0.127000><2.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.884700,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.558700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,17.111200>}
box{<0,0,-0.127000><0.552500,0.035000,0.127000> rotate<0,90.000000,0> translate<41.884700,0.000000,17.111200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.764000>}
box{<0,0,-0.127000><2.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.884700,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.884700,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,17.018000>}
box{<0,0,-0.127000><2.590500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.884700,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.897100,0.000000,19.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.957900,0.000000,19.290900>}
box{<0,0,-0.127000><0.060800,0.035000,0.127000> rotate<0,0.000000,0> translate<41.897100,0.000000,19.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,0.000000,19.406300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.957900,0.000000,19.290900>}
box{<0,0,-0.127000><0.124946,0.035000,0.127000> rotate<0,67.453286,0> translate<41.910000,0.000000,19.406300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,0.000000,19.709600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,0.000000,19.406300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.910000,0.000000,19.406300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,19.709600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,19.697600>}
box{<0,0,-0.127000><0.012000,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.910000,-1.535000,19.697600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,0.000000,19.709600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.026000,0.000000,19.989600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.910000,0.000000,19.709600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,19.709600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.026000,-1.535000,19.989600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<41.910000,-1.535000,19.709600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.910000,-1.535000,25.653900>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,-90.000000,0> translate<41.910000,-1.535000,25.653900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.922100,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,13.729000>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<41.922100,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.934600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.214600,-1.535000,24.246000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<41.934600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.934600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.044300,-1.535000,24.130000>}
box{<0,0,-0.127000><2.109700,0.035000,0.127000> rotate<0,0.000000,0> translate<41.934600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.934600,-1.535000,27.177900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.214600,-1.535000,27.061900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<41.934600,-1.535000,27.177900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.534400>}
box{<0,0,-0.127000><0.243500,0.035000,0.127000> rotate<0,90.000000,0> translate<41.960900,0.000000,15.534400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,15.290900>}
box{<0,0,-0.127000><0.268500,0.035000,0.127000> rotate<0,0.000000,0> translate<41.960900,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.494000>}
box{<0,0,-0.127000><2.438100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.960900,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.535400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.842800>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,90.000000,0> translate<41.960900,0.000000,15.842800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<41.960900,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.748000>}
box{<0,0,-0.127000><2.438100,0.035000,0.127000> rotate<0,0.000000,0> translate<41.960900,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.026000,0.000000,19.989600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.240300,0.000000,20.203900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.026000,0.000000,19.989600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.026000,-1.535000,19.989600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.240300,-1.535000,20.203900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.026000,-1.535000,19.989600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,16.552100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.145100,-1.535000,16.456000>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<42.049000,-1.535000,16.552100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,16.552100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.049000,-1.535000,16.552100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.052600,-1.535000,17.233100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<42.049000,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.052600,-1.535000,17.486700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<42.049000,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,18.167800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,17.486700>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.049000,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.049000,-1.535000,18.167800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.272100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.049000,-1.535000,18.167800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.275600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<42.113200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.113200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.113200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.275600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<42.113200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,14.883700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.303700,-1.535000,14.705200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<42.125200,-1.535000,14.883700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,14.883700>}
box{<0,0,-0.127000><0.470600,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.125200,-1.535000,14.883700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,16.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,16.141600>}
box{<0,0,-0.127000><0.294600,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.125200,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.125200,-1.535000,16.436200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.145100,-1.535000,16.456000>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,-44.852718,0> translate<42.125200,-1.535000,16.436200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.203900,0.000000,18.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.203900,0.000000,18.509400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.203900,0.000000,18.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.214600,-1.535000,24.246000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.428900,-1.535000,24.460300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.214600,-1.535000,24.246000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.214600,-1.535000,27.061900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.428900,-1.535000,26.847600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<42.214600,-1.535000,27.061900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.228900,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.228900,0.000000,14.509400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.228900,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.508900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<42.229400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,13.970000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.224000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.478000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.508900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,15.290900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<42.229400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.511000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.732000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.986000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.229400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.229400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.537800,0.000000,13.729000>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.230400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,13.729000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.230400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,14.511000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.230400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.230400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.537800,0.000000,15.290900>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.230400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.231000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.231000,0.000000,14.510400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<42.231000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.231000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.349000,0.000000,14.509400>}
box{<0,0,-0.127000><0.118000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.231000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.231000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.349000,0.000000,14.510400>}
box{<0,0,-0.127000><0.118000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.231000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.240300,0.000000,20.203900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,0.000000,20.319900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<42.240300,0.000000,20.203900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.240300,-1.535000,20.203900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,-1.535000,20.319900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<42.240300,-1.535000,20.203900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.244400,-1.535000,18.910300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,-1.535000,18.796000>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,22.501790,0> translate<42.244400,-1.535000,18.910300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.272100,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.272100,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.275600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.575700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<42.275600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.275600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.575700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.275600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.303700,-1.535000,14.705200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.056200,-1.535000,14.705200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<42.303700,-1.535000,14.705200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.349000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.878900,0.000000,14.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<42.349000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.349000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.878900,0.000000,14.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<42.349000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.352500,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.102600,-1.535000,26.924000>}
box{<0,0,-0.127000><19.750100,0.035000,0.127000> rotate<0,0.000000,0> translate<42.352500,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.352600,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.626300,-1.535000,24.384000>}
box{<0,0,-0.127000><1.273700,0.035000,0.127000> rotate<0,0.000000,0> translate<42.352600,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.428900,-1.535000,24.460300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.444600,-1.535000,24.498300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<42.428900,-1.535000,24.460300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.428900,-1.535000,26.847600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.444600,-1.535000,26.809600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<42.428900,-1.535000,26.847600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.444600,-1.535000,24.498300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.534300,-1.535000,24.498300>}
box{<0,0,-0.127000><1.089700,0.035000,0.127000> rotate<0,0.000000,0> translate<42.444600,-1.535000,24.498300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.444600,-1.535000,26.809600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.486000,-1.535000,26.809600>}
box{<0,0,-0.127000><2.041400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.444600,-1.535000,26.809600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.502800,0.000000,20.459000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.598900,0.000000,20.555100>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.502800,0.000000,20.459000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,-1.535000,18.796000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.520300,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,0.000000,20.319900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,0.000000,20.319900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.520300,0.000000,20.319900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.520300,-1.535000,20.319900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,-1.535000,20.319900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.520300,-1.535000,20.319900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.537800,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.554900,0.000000,13.746200>}
box{<0,0,-0.127000><0.024254,0.035000,0.127000> rotate<0,-45.164062,0> translate<42.537800,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.537800,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.554900,0.000000,15.273700>}
box{<0,0,-0.127000><0.024254,0.035000,0.127000> rotate<0,45.164062,0> translate<42.537800,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.554900,0.000000,13.746200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.572100,0.000000,13.729000>}
box{<0,0,-0.127000><0.024324,0.035000,0.127000> rotate<0,44.997030,0> translate<42.554900,0.000000,13.746200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.554900,0.000000,15.273700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.572100,0.000000,15.290900>}
box{<0,0,-0.127000><0.024324,0.035000,0.127000> rotate<0,-44.997030,0> translate<42.554900,0.000000,15.273700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.572100,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,13.729000>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.572100,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.572100,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,15.290900>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.572100,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.575700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.967700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<42.575700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.575700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.967700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<42.575700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.598900,0.000000,20.555100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.618700,0.000000,20.535200>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,45.141342,0> translate<42.598900,0.000000,20.555100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.618700,0.000000,20.535200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.005000,0.000000,20.535200>}
box{<0,0,-0.127000><0.386300,0.035000,0.127000> rotate<0,0.000000,0> translate<42.618700,0.000000,20.535200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.103600,-1.535000,18.912000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<42.823600,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.796000>}
box{<0,0,-0.127000><3.520400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.823600,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,0.000000,20.319900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,0.000000,20.277400>}
box{<0,0,-0.127000><0.110869,0.035000,0.127000> rotate<0,22.538872,0> translate<42.823600,0.000000,20.319900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.823600,-1.535000,20.319900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,-1.535000,20.277400>}
box{<0,0,-0.127000><0.110869,0.035000,0.127000> rotate<0,22.538872,0> translate<42.823600,-1.535000,20.319900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.878900,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.878900,0.000000,14.509400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.878900,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.508900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<42.879400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,13.970000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.224000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.478000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.508900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,15.290900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<42.879400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.511000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.732000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.986000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.879400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.879400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.187800,0.000000,13.729000>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.880400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,13.729000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.880400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,14.511000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.880400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.880400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.187800,0.000000,15.290900>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<42.880400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.881000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.881000,0.000000,14.510400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<42.881000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.881000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.974000,0.000000,14.509400>}
box{<0,0,-0.127000><0.093000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.881000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.881000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.974000,0.000000,14.510400>}
box{<0,0,-0.127000><0.093000,0.035000,0.127000> rotate<0,0.000000,0> translate<42.881000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,0.000000,20.344600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,0.000000,20.277400>}
box{<0,0,-0.127000><0.067200,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.926000,0.000000,20.277400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,-1.535000,20.344600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,-1.535000,20.277400>}
box{<0,0,-0.127000><0.067200,0.035000,0.127000> rotate<0,-90.000000,0> translate<42.926000,-1.535000,20.277400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,0.000000,20.344600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.005000,0.000000,20.535200>}
box{<0,0,-0.127000><0.206323,0.035000,0.127000> rotate<0,-67.482488,0> translate<42.926000,0.000000,20.344600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.926000,-1.535000,20.344600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.042000,-1.535000,20.624600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<42.926000,-1.535000,20.344600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.967700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.392200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<42.967700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.967700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.392200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<42.967700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.974000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.503900,0.000000,14.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<42.974000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<42.974000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.503900,0.000000,14.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<42.974000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.042000,-1.535000,20.624600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.256300,-1.535000,20.838900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.042000,-1.535000,20.624600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.052600,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.052600,-1.535000,17.233100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<43.052600,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,17.487300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,18.390900>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,90.000000,0> translate<43.053100,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,17.487300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,17.487300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.053100,-1.535000,17.487300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,17.526000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.053100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,17.780000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.053100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,18.034000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.053100,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.053100,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,18.288000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.053100,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.103600,-1.535000,18.912000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.228900,-1.535000,19.037300>}
box{<0,0,-0.127000><0.177201,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.103600,-1.535000,18.912000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.187800,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.192400,0.000000,13.733700>}
box{<0,0,-0.127000><0.006576,0.035000,0.127000> rotate<0,-45.613049,0> translate<43.187800,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.187800,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.192400,0.000000,15.286200>}
box{<0,0,-0.127000><0.006576,0.035000,0.127000> rotate<0,45.613049,0> translate<43.187800,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.192400,0.000000,13.733700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.197100,0.000000,13.729000>}
box{<0,0,-0.127000><0.006647,0.035000,0.127000> rotate<0,44.997030,0> translate<43.192400,0.000000,13.733700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.192400,0.000000,15.286200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.197100,0.000000,15.290900>}
box{<0,0,-0.127000><0.006647,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.192400,0.000000,15.286200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.197100,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,13.729000>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.197100,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.197100,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,15.290900>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.197100,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.228900,-1.535000,19.037300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.513600,-1.535000,19.037300>}
box{<0,0,-0.127000><3.284700,0.035000,0.127000> rotate<0,0.000000,0> translate<43.228900,-1.535000,19.037300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.256300,-1.535000,20.838900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.536300,-1.535000,20.954900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<43.256300,-1.535000,20.838900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,17.487300>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,-90.000000,0> translate<43.306700,-1.535000,17.487300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.306700,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.087800,-1.535000,18.390900>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,0.000000,0> translate<43.306700,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.307300,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.307300,-1.535000,17.486700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<43.307300,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.307300,-1.535000,17.233100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.233100>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.307300,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.307300,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.272000>}
box{<0,0,-0.127000><3.036700,0.035000,0.127000> rotate<0,0.000000,0> translate<43.307300,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.307300,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.486700>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,0.000000,0> translate<43.307300,-1.535000,17.486700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.392200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.784200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<43.392200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.392200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.784200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<43.392200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.503900,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.503900,0.000000,14.509400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<43.503900,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.508900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<43.504400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,13.970000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.224000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.478000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.508900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,15.290900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<43.504400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.511000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.732000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.986000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.504400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.504400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.812800,0.000000,13.729000>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<43.505400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,13.729000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<43.505400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,14.511000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<43.505400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.505400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.812800,0.000000,15.290900>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<43.505400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.506000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.506000,0.000000,14.510400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<43.506000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.506000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.624000,0.000000,14.509400>}
box{<0,0,-0.127000><0.118000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.506000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.506000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.624000,0.000000,14.510400>}
box{<0,0,-0.127000><0.118000,0.035000,0.127000> rotate<0,0.000000,0> translate<43.506000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.514600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.385400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<43.514600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.514800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.385000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<43.514800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.534300,-1.535000,24.498300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.550000,-1.535000,24.460300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<43.534300,-1.535000,24.498300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.536300,-1.535000,20.954900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.839600,-1.535000,20.954900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.536300,-1.535000,20.954900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.550000,-1.535000,24.460300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.764300,-1.535000,24.246000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<43.550000,-1.535000,24.460300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.624000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.153900,0.000000,14.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<43.624000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.624000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.153900,0.000000,14.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<43.624000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.764300,-1.535000,24.246000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.044300,-1.535000,24.130000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<43.764300,-1.535000,24.246000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.784200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.084300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.784200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.784200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.084300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<43.784200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.812800,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.829900,0.000000,13.746200>}
box{<0,0,-0.127000><0.024254,0.035000,0.127000> rotate<0,-45.164062,0> translate<43.812800,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.812800,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.829900,0.000000,15.273700>}
box{<0,0,-0.127000><0.024254,0.035000,0.127000> rotate<0,45.164062,0> translate<43.812800,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.829900,0.000000,13.746200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.847100,0.000000,13.729000>}
box{<0,0,-0.127000><0.024324,0.035000,0.127000> rotate<0,44.997030,0> translate<43.829900,0.000000,13.746200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.829900,0.000000,15.273700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.847100,0.000000,15.290900>}
box{<0,0,-0.127000><0.024324,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.829900,0.000000,15.273700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.839600,-1.535000,20.954900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.877500,-1.535000,20.939200>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,22.500200,0> translate<43.839600,-1.535000,20.954900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.847100,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,13.729000>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.847100,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.847100,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,15.290900>}
box{<0,0,-0.127000><0.307300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.847100,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.877500,-1.535000,20.939200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.592700,-1.535000,21.654400>}
box{<0,0,-0.127000><1.011446,0.035000,0.127000> rotate<0,-44.997030,0> translate<43.877500,-1.535000,20.939200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.905900,0.000000,17.132300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,17.132300>}
box{<0,0,-0.127000><0.569300,0.035000,0.127000> rotate<0,0.000000,0> translate<43.905900,0.000000,17.132300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.926500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.973400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<43.926500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<43.926600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.973300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<43.926600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.044300,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.347600,-1.535000,24.130000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<44.044300,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.056200,-1.535000,14.705200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.070200,-1.535000,14.719300>}
box{<0,0,-0.127000><0.019870,0.035000,0.127000> rotate<0,-45.200915,0> translate<44.056200,-1.535000,14.705200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.070200,-1.535000,14.719300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.719300>}
box{<0,0,-0.127000><2.350000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.070200,-1.535000,14.719300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.084300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<44.084300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.084300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<44.084300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.087800,-1.535000,18.390900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,18.167800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<44.087800,-1.535000,18.390900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.124100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.775700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<44.124100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.124200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.775800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<44.124200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.153900,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.153900,0.000000,14.509400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.153900,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.508900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<44.154400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,13.970000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.224000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.478000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.508900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,15.290900>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,90.000000,0> translate<44.154400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.511000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.511000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.732000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.986000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.154400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.154400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.462800,0.000000,13.729000>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.155400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,13.729000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.155400,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,14.511000>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.155400,0.000000,14.511000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.155400,0.000000,15.290900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.290900>}
box{<0,0,-0.127000><0.243600,0.035000,0.127000> rotate<0,0.000000,0> translate<44.155400,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.156000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.156000,0.000000,14.510400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,90.000000,0> translate<44.156000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.156000,0.000000,14.509400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.509400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<44.156000,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.156000,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.510400>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,0.000000,0> translate<44.156000,0.000000,14.510400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.190700,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.288000>}
box{<0,0,-0.127000><2.153300,0.035000,0.127000> rotate<0,0.000000,0> translate<44.190700,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.214800,-1.535000,16.456000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,16.436200>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,44.852718,0> translate<44.214800,-1.535000,16.456000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.214800,-1.535000,16.456000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,16.552100>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.214800,-1.535000,16.456000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.229400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.670400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<44.229400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.229400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.670600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<44.229400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,15.506600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,16.436200>}
box{<0,0,-0.127000><0.929600,0.035000,0.127000> rotate<0,90.000000,0> translate<44.234700,-1.535000,16.436200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,15.506600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,15.506600>}
box{<0,0,-0.127000><2.185500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.234700,-1.535000,15.506600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,15.748000>}
box{<0,0,-0.127000><2.185500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.234700,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,16.002000>}
box{<0,0,-0.127000><2.185500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.234700,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.234700,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.048400,-1.535000,16.256000>}
box{<0,0,-0.127000><3.813700,0.035000,0.127000> rotate<0,0.000000,0> translate<44.234700,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<44.246700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.246700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.246700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.268800,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,16.510000>}
box{<0,0,-0.127000><3.737200,0.035000,0.127000> rotate<0,0.000000,0> translate<44.268800,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,16.552100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.233100>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,90.000000,0> translate<44.310900,-1.535000,17.233100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.532100,-1.535000,16.764000>}
box{<0,0,-0.127000><2.221200,0.035000,0.127000> rotate<0,0.000000,0> translate<44.310900,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.018000>}
box{<0,0,-0.127000><2.033100,0.035000,0.127000> rotate<0,0.000000,0> translate<44.310900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.486700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,18.167800>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,90.000000,0> translate<44.310900,-1.535000,18.167800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.526000>}
box{<0,0,-0.127000><2.033100,0.035000,0.127000> rotate<0,0.000000,0> translate<44.310900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.780000>}
box{<0,0,-0.127000><2.033100,0.035000,0.127000> rotate<0,0.000000,0> translate<44.310900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.310900,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.497600,-1.535000,18.034000>}
box{<0,0,-0.127000><3.186700,0.035000,0.127000> rotate<0,0.000000,0> translate<44.310900,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.347600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.627600,-1.535000,24.246000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<44.347600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.347600,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.544200,-1.535000,24.130000>}
box{<0,0,-0.127000><1.196600,0.035000,0.127000> rotate<0,0.000000,0> translate<44.347600,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.360100,-1.535000,19.824600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.041300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<44.360100,-1.535000,19.824600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.360100,-1.535000,19.824600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.582300,-1.535000,19.824600>}
box{<0,0,-0.127000><2.222200,0.035000,0.127000> rotate<0,0.000000,0> translate<44.360100,-1.535000,19.824600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.534400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.290900>}
box{<0,0,-0.127000><0.243500,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.399000,0.000000,15.290900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.534400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.178900,0.000000,15.534400>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,0.000000,0> translate<44.399000,0.000000,15.534400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.535400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.178900,0.000000,15.535400>}
box{<0,0,-0.127000><0.779900,0.035000,0.127000> rotate<0,0.000000,0> translate<44.399000,0.000000,15.535400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.842800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.535400>}
box{<0,0,-0.127000><0.307400,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.399000,0.000000,15.535400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.399000,0.000000,15.842800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,15.919000>}
box{<0,0,-0.127000><0.107763,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.399000,0.000000,15.842800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.434200,-1.535000,20.382500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.344600>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,67.493860,0> translate<44.434200,-1.535000,20.382500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.434200,-1.535000,20.382500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.149400,-1.535000,21.097700>}
box{<0,0,-0.127000><1.011446,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.434200,-1.535000,20.382500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.041300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.344600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<44.449900,-1.535000,20.344600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.801400,-1.535000,20.066000>}
box{<0,0,-0.127000><2.351500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.449900,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.449900,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,20.320000>}
box{<0,0,-0.127000><5.226100,0.035000,0.127000> rotate<0,0.000000,0> translate<44.449900,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.462800,0.000000,13.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,13.952100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.462800,0.000000,13.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.461200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,15.919000>}
box{<0,0,-0.127000><0.542200,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.475200,0.000000,15.919000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.461200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.536500,0.000000,16.522400>}
box{<0,0,-0.127000><0.086621,0.035000,0.127000> rotate<0,-44.950261,0> translate<44.475200,0.000000,16.461200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.583700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.536500,0.000000,16.522400>}
box{<0,0,-0.127000><0.086691,0.035000,0.127000> rotate<0,44.997030,0> translate<44.475200,0.000000,16.583700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,17.132300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.475200,0.000000,16.583700>}
box{<0,0,-0.127000><0.548600,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.475200,0.000000,16.583700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.486000,-1.535000,26.809600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.716600,-1.535000,26.579000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<44.486000,-1.535000,26.809600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.577000,-1.535000,21.692300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.592700,-1.535000,21.654400>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,67.493860,0> translate<44.577000,-1.535000,21.692300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.577000,-1.535000,21.995600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.577000,-1.535000,21.692300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.577000,-1.535000,21.692300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.577000,-1.535000,21.995600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,22.275600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<44.577000,-1.535000,21.995600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.625600,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.670000>}
box{<0,0,-0.127000><16.323400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.625600,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.625700,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,20.574000>}
box{<0,0,-0.127000><5.050300,0.035000,0.127000> rotate<0,0.000000,0> translate<44.625700,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.627600,-1.535000,24.246000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.841900,-1.535000,24.460300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.627600,-1.535000,24.246000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.815600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<44.653200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<44.653200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.653200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.815600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<44.653200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.677300,-1.535000,27.419300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,27.381300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<44.677300,-1.535000,27.419300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.677300,-1.535000,28.206600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,28.244600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<44.677300,-1.535000,28.206600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,13.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.509400>}
box{<0,0,-0.127000><0.557300,0.035000,0.127000> rotate<0,90.000000,0> translate<44.685900,0.000000,14.509400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,13.970000>}
box{<0,0,-0.127000><1.148400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,14.224000>}
box{<0,0,-0.127000><1.148400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,14.478000>}
box{<0,0,-0.127000><1.148400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.510400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,15.004000>}
box{<0,0,-0.127000><0.493600,0.035000,0.127000> rotate<0,90.000000,0> translate<44.685900,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,14.732000>}
box{<0,0,-0.127000><1.148400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,14.986000>}
box{<0,0,-0.127000><1.148400,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.685900,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.004000>}
box{<0,0,-0.127000><0.493500,0.035000,0.127000> rotate<0,0.000000,0> translate<44.685900,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,22.275600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,22.489900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.693000,-1.535000,22.275600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,27.381300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,27.167000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<44.693000,-1.535000,27.381300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.693000,-1.535000,28.244600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,28.458900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.693000,-1.535000,28.244600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.716600,-1.535000,26.578900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.716600,-1.535000,26.579000>}
box{<0,0,-0.127000><0.000100,0.035000,0.127000> rotate<0,90.000000,0> translate<44.716600,-1.535000,26.579000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.716600,-1.535000,26.578900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.644900,-1.535000,24.650600>}
box{<0,0,-0.127000><2.727028,0.035000,0.127000> rotate<0,44.997030,0> translate<44.716600,-1.535000,26.578900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.765600,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.290200,-1.535000,24.384000>}
box{<0,0,-0.127000><0.524600,0.035000,0.127000> rotate<0,0.000000,0> translate<44.765600,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.815600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.115700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<44.815600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.815600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.115700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<44.815600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.841900,-1.535000,24.460300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.950800,-1.535000,24.723400>}
box{<0,0,-0.127000><0.284747,0.035000,0.127000> rotate<0,-67.510340,0> translate<44.841900,-1.535000,24.460300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.879500,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.638800,-1.535000,26.416000>}
box{<0,0,-0.127000><4.759300,0.035000,0.127000> rotate<0,0.000000,0> translate<44.879500,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.879700,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,20.828000>}
box{<0,0,-0.127000><4.796300,0.035000,0.127000> rotate<0,0.000000,0> translate<44.879700,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,22.489900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,22.605900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<44.907300,-1.535000,22.489900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,27.167000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,27.051000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<44.907300,-1.535000,27.167000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.907300,-1.535000,28.458900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,28.574900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<44.907300,-1.535000,28.458900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.915400,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.036200,-1.535000,24.638000>}
box{<0,0,-0.127000><0.120800,0.035000,0.127000> rotate<0,0.000000,0> translate<44.915400,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<44.950800,-1.535000,24.723400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.350900,-1.535000,21.323300>}
box{<0,0,-0.127000><4.808468,0.035000,0.127000> rotate<0,44.997030,0> translate<44.950800,-1.535000,24.723400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.115700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.507700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<45.115700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.115700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.507700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<45.115700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.133500,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,26.162000>}
box{<0,0,-0.127000><4.466300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.133500,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.133700,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,21.082000>}
box{<0,0,-0.127000><0.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<45.133700,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.149400,-1.535000,21.097700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,21.082000>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,22.500200,0> translate<45.149400,-1.535000,21.097700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.178900,0.000000,15.535400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.178900,0.000000,15.534400>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,-90.000000,0> translate<45.178900,0.000000,15.534400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.533900>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,90.000000,0> translate<45.179400,0.000000,15.533900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.240000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<45.179400,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.494000>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<45.179400,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.179400,0.000000,15.533900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.533900>}
box{<0,0,-0.127000><0.001000,0.035000,0.127000> rotate<0,0.000000,0> translate<45.179400,0.000000,15.533900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.737800,0.000000,15.004000>}
box{<0,0,-0.127000><0.557400,0.035000,0.127000> rotate<0,0.000000,0> translate<45.180400,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.533900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.180400,0.000000,15.004000>}
box{<0,0,-0.127000><0.529900,0.035000,0.127000> rotate<0,-90.000000,0> translate<45.180400,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,21.082000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.187300,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,22.605900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,22.605900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.187300,-1.535000,22.605900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,27.051000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,27.051000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.187300,-1.535000,27.051000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.187300,-1.535000,28.574900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,28.574900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.187300,-1.535000,28.574900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.387500,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.908000>}
box{<0,0,-0.127000><4.212300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.387500,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,21.198000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<45.490600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,21.082000>}
box{<0,0,-0.127000><4.185400,0.035000,0.127000> rotate<0,0.000000,0> translate<45.490600,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,22.605900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,22.489900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<45.490600,-1.535000,22.605900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,27.051000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,27.167000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<45.490600,-1.535000,27.051000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.490600,-1.535000,28.574900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,28.458900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<45.490600,-1.535000,28.574900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.507700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.932200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<45.507700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.507700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.932200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<45.507700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.641500,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.654000>}
box{<0,0,-0.127000><3.958300,0.035000,0.127000> rotate<0,0.000000,0> translate<45.641500,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.737800,0.000000,15.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,15.100600>}
box{<0,0,-0.127000><0.136542,0.035000,0.127000> rotate<0,-45.026700,0> translate<45.737800,0.000000,15.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,21.198000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,21.412300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<45.770600,-1.535000,21.198000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,22.489900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,22.275600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<45.770600,-1.535000,22.489900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,27.167000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,27.381300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<45.770600,-1.535000,27.167000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.770600,-1.535000,28.458900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,28.244600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<45.770600,-1.535000,28.458900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.781500,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.865200,-1.535000,28.448000>}
box{<0,0,-0.127000><28.083700,0.035000,0.127000> rotate<0,0.000000,0> translate<45.781500,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.781600,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,27.178000>}
box{<0,0,-0.127000><15.167400,0.035000,0.127000> rotate<0,0.000000,0> translate<45.781600,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,15.100600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.834300,0.000000,12.077600>}
box{<0,0,-0.127000><3.023000,0.035000,0.127000> rotate<0,-90.000000,0> translate<45.834300,0.000000,12.077600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.895500,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,-1.535000,25.400000>}
box{<0,0,-0.127000><4.777000,0.035000,0.127000> rotate<0,0.000000,0> translate<45.895500,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.908500,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.322200,-1.535000,22.352000>}
box{<0,0,-0.127000><1.413700,0.035000,0.127000> rotate<0,0.000000,0> translate<45.908500,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.908600,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.338200,-1.535000,21.336000>}
box{<0,0,-0.127000><2.429600,0.035000,0.127000> rotate<0,0.000000,0> translate<45.908600,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.932200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.324200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<45.932200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.932200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.324200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<45.932200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,21.412300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,21.692300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<45.984900,-1.535000,21.412300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,22.275600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,21.995600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<45.984900,-1.535000,22.275600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,27.381300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.661300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<45.984900,-1.535000,27.381300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<45.984900,-1.535000,28.244600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.964600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<45.984900,-1.535000,28.244600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.005900,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,27.432000>}
box{<0,0,-0.127000><14.943100,0.035000,0.127000> rotate<0,0.000000,0> translate<46.005900,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.005900,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.119200,-1.535000,28.194000>}
box{<0,0,-0.127000><28.113300,0.035000,0.127000> rotate<0,0.000000,0> translate<46.005900,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.054600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.925400,-1.535000,32.258000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<46.054600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.054800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.925000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<46.054800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.058500,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.084200,-1.535000,21.590000>}
box{<0,0,-0.127000><2.025700,0.035000,0.127000> rotate<0,0.000000,0> translate<46.058500,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.058500,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.576200,-1.535000,22.098000>}
box{<0,0,-0.127000><1.517700,0.035000,0.127000> rotate<0,0.000000,0> translate<46.058500,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,21.692300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,21.995600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<46.100900,-1.535000,21.995600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.830200,-1.535000,21.844000>}
box{<0,0,-0.127000><1.729300,0.035000,0.127000> rotate<0,0.000000,0> translate<46.100900,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.661300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.964600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<46.100900,-1.535000,27.964600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,27.686000>}
box{<0,0,-0.127000><14.848100,0.035000,0.127000> rotate<0,0.000000,0> translate<46.100900,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.100900,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.131200,-1.535000,27.940000>}
box{<0,0,-0.127000><15.030300,0.035000,0.127000> rotate<0,0.000000,0> translate<46.100900,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.149500,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.146000>}
box{<0,0,-0.127000><3.450300,0.035000,0.127000> rotate<0,0.000000,0> translate<46.149500,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.324200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.624300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<46.324200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.324200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.624300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<46.324200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,16.952100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.567100,-1.535000,16.729000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<46.344000,-1.535000,16.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,16.952100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,-90.000000,0> translate<46.344000,-1.535000,16.952100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.497600,-1.535000,17.783100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<46.344000,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.497600,-1.535000,18.036700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<46.344000,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.867800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.036700>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,-90.000000,0> translate<46.344000,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.344000,-1.535000,18.867800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.513600,-1.535000,19.037300>}
box{<0,0,-0.127000><0.239780,0.035000,0.127000> rotate<0,-44.980135,0> translate<46.344000,-1.535000,18.867800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.403500,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,24.892000>}
box{<0,0,-0.127000><3.196300,0.035000,0.127000> rotate<0,0.000000,0> translate<46.403500,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.183700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598700,-1.535000,14.005200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<46.420200,-1.535000,14.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.719300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,14.183700>}
box{<0,0,-0.127000><0.535600,0.035000,0.127000> rotate<0,-90.000000,0> translate<46.420200,-1.535000,14.183700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,16.036200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,15.506600>}
box{<0,0,-0.127000><0.529600,0.035000,0.127000> rotate<0,-90.000000,0> translate<46.420200,-1.535000,15.506600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.420200,-1.535000,16.036200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598700,-1.535000,16.214700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<46.420200,-1.535000,16.036200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.466500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.513400,-1.535000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<46.466500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.466600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.513300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<46.466600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.567100,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,16.729000>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<46.567100,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.582300,-1.535000,19.824600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598000,-1.535000,19.862600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<46.582300,-1.535000,19.824600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598000,-1.535000,19.862600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.812300,-1.535000,20.076900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<46.598000,-1.535000,19.862600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598700,-1.535000,14.005200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.063100,-1.535000,14.005200>}
box{<0,0,-0.127000><1.464400,0.035000,0.127000> rotate<0,0.000000,0> translate<46.598700,-1.535000,14.005200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.598700,-1.535000,16.214700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.065600,-1.535000,16.214700>}
box{<0,0,-0.127000><1.466900,0.035000,0.127000> rotate<0,0.000000,0> translate<46.598700,-1.535000,16.214700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.624300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<46.624300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.624300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<46.624300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.644900,-1.535000,24.650600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,24.650600>}
box{<0,0,-0.127000><2.954900,0.035000,0.127000> rotate<0,0.000000,0> translate<46.644900,-1.535000,24.650600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.664100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.315700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<46.664100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.664200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.315800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<46.664200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.769400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.210400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<46.769400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.769400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.210600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<46.769400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<46.786700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.786700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<46.786700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<46.812300,-1.535000,20.076900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.092300,-1.535000,20.192900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<46.812300,-1.535000,20.076900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.092300,-1.535000,20.192900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.395600,-1.535000,20.192900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<47.092300,-1.535000,20.192900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.355600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<47.193200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<47.193200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.193200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.355600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<47.193200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.355600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.655700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<47.355600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.355600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.655700,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<47.355600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.395600,-1.535000,20.192900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.675600,-1.535000,20.076900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<47.395600,-1.535000,20.192900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.497600,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.497600,-1.535000,17.783100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<47.497600,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.782600>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<47.498100,-1.535000,17.782600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,16.764000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.018000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.272000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.526000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.780000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.498100,-1.535000,17.782600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.782600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.498100,-1.535000,17.782600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.655700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.047700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<47.655700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.655700,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.047700,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<47.655700,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.675600,-1.535000,20.076900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.889900,-1.535000,19.862600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<47.675600,-1.535000,20.076900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.686500,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,20.066000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<47.686500,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,16.729000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.034000,-1.535000,16.729000>}
box{<0,0,-0.127000><0.282300,0.035000,0.127000> rotate<0,0.000000,0> translate<47.751700,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,17.782600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.751700,-1.535000,16.729000>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<47.751700,-1.535000,16.729000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.752300,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.752300,-1.535000,18.036700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<47.752300,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.752300,-1.535000,17.783100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.783100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.752300,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.752300,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,18.034000>}
box{<0,0,-0.127000><1.923700,0.035000,0.127000> rotate<0,0.000000,0> translate<47.752300,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.752300,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.036700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<47.752300,-1.535000,18.036700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.889900,-1.535000,19.862600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.582600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<47.889900,-1.535000,19.862600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.910900,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,19.812000>}
box{<0,0,-0.127000><1.765100,0.035000,0.127000> rotate<0,0.000000,0> translate<47.910900,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.927800,-1.535000,19.090900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.279300>}
box{<0,0,-0.127000><0.203946,0.035000,0.127000> rotate<0,-67.479411,0> translate<47.927800,-1.535000,19.090900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.927800,-1.535000,19.090900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.682800,-1.535000,19.090900>}
box{<0,0,-0.127000><0.755000,0.035000,0.127000> rotate<0,0.000000,0> translate<47.927800,-1.535000,19.090900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<47.969900,-1.535000,13.601600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,13.601600>}
box{<0,0,-0.127000><0.036100,0.035000,0.127000> rotate<0,0.000000,0> translate<47.969900,-1.535000,13.601600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.279300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.582600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<48.005900,-1.535000,19.582600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746500,-1.535000,19.304000>}
box{<0,0,-0.127000><1.740600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.005900,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.005900,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,19.558000>}
box{<0,0,-0.127000><1.670100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.005900,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,13.867600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,13.601600>}
box{<0,0,-0.127000><0.266000,0.035000,0.127000> rotate<0,-90.000000,0> translate<48.006000,-1.535000,13.601600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,13.867600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.063100,-1.535000,14.005200>}
box{<0,0,-0.127000><0.148977,0.035000,0.127000> rotate<0,-67.458519,0> translate<48.006000,-1.535000,13.867600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,16.358300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.065600,-1.535000,16.214700>}
box{<0,0,-0.127000><0.155477,0.035000,0.127000> rotate<0,67.455056,0> translate<48.006000,-1.535000,16.358300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,16.661600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,16.358300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<48.006000,-1.535000,16.358300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.006000,-1.535000,16.661600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.034000,-1.535000,16.729000>}
box{<0,0,-0.127000><0.072985,0.035000,0.127000> rotate<0,-67.436072,0> translate<48.006000,-1.535000,16.661600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.047700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<48.047700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.047700,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,-1.535000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<48.047700,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.105300,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,28.357000>}
box{<0,0,-0.127000><0.416132,0.035000,0.127000> rotate<0,44.987295,0> translate<48.105300,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.105300,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,0.000000,28.651200>}
box{<0,0,-0.127000><0.366900,0.035000,0.127000> rotate<0,0.000000,0> translate<48.105300,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.308600,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.989200,0.000000,28.448000>}
box{<0,0,-0.127000><1.680600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.308600,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.350900,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.677000,-1.535000,21.323300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.350900,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,17.435000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,28.030900>}
box{<0,0,-0.127000><10.595900,0.035000,0.127000> rotate<0,90.000000,0> translate<48.399600,0.000000,28.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,17.435000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.578400,0.000000,17.256100>}
box{<0,0,-0.127000><0.252932,0.035000,0.127000> rotate<0,45.013047,0> translate<48.399600,0.000000,17.435000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,17.526000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,17.780000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,18.034000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,18.288000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,18.542000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,18.796000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.050000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.304000>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.481300,0.000000,19.558000>}
box{<0,0,-0.127000><1.081700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,19.812000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,20.066000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,20.320000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,20.574000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,20.828000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,21.082000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746600,0.000000,21.336000>}
box{<0,0,-0.127000><1.347000,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.513200,0.000000,21.590000>}
box{<0,0,-0.127000><3.113600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746500,0.000000,21.844000>}
box{<0,0,-0.127000><1.346900,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,22.098000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,22.352000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,22.606000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,22.860000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,23.114000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,23.368000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,23.622000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746600,0.000000,23.876000>}
box{<0,0,-0.127000><1.347000,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,24.130000>}
box{<0,0,-0.127000><4.165700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.638700,0.000000,24.384000>}
box{<0,0,-0.127000><1.239100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,24.638000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,24.892000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.146000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,0.000000,25.400000>}
box{<0,0,-0.127000><2.272900,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.654000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.908000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,26.162000>}
box{<0,0,-0.127000><1.200200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.638800,0.000000,26.416000>}
box{<0,0,-0.127000><1.239200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.767200,0.000000,26.670000>}
box{<0,0,-0.127000><3.367600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.513200,0.000000,26.924000>}
box{<0,0,-0.127000><3.113600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.259200,0.000000,27.178000>}
box{<0,0,-0.127000><2.859600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.005200,0.000000,27.432000>}
box{<0,0,-0.127000><2.605600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.751200,0.000000,27.686000>}
box{<0,0,-0.127000><2.351600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.497200,0.000000,27.940000>}
box{<0,0,-0.127000><2.097600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,28.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,28.357000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<48.399600,0.000000,28.357000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.399600,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.243200,0.000000,28.194000>}
box{<0,0,-0.127000><1.843600,0.035000,0.127000> rotate<0,0.000000,0> translate<48.399600,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<48.472200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<48.472200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.472200,-1.535000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,-1.535000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<48.472200,-1.535000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.562600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,17.272000>}
box{<0,0,-0.127000><0.700700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.562600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.578400,0.000000,17.256100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.616300,0.000000,17.271900>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,-22.629105,0> translate<48.578400,0.000000,17.256100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.594600,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.481400,-1.535000,32.258000>}
box{<0,0,-0.127000><0.886800,0.035000,0.127000> rotate<0,0.000000,0> translate<48.594600,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.594800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.735200,0.000000,28.702000>}
box{<0,0,-0.127000><1.140400,0.035000,0.127000> rotate<0,0.000000,0> translate<48.594800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.594800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.465000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<48.594800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.616300,0.000000,17.271900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.919600,0.000000,17.271900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<48.616300,0.000000,17.271900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.677000,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.734000,-1.535000,21.323300>}
box{<0,0,-0.127000><1.057000,0.035000,0.127000> rotate<0,0.000000,0> translate<48.677000,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.682800,-1.535000,19.090900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.867800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<48.682800,-1.535000,19.090900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.723700,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.545200,-1.535000,19.050000>}
box{<0,0,-0.127000><4.821500,0.035000,0.127000> rotate<0,0.000000,0> translate<48.723700,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.164300,0.000000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<48.864200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.164300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<48.864200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.864200,-1.535000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.116900,-1.535000,31.893500>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,45.008364,0> translate<48.864200,-1.535000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.271900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.783100>}
box{<0,0,-0.127000><0.511200,0.035000,0.127000> rotate<0,90.000000,0> translate<48.905900,-1.535000,17.783100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.271900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.919600,-1.535000,17.271900>}
box{<0,0,-0.127000><0.013700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,17.271900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,17.272000>}
box{<0,0,-0.127000><0.770100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,17.526000>}
box{<0,0,-0.127000><0.770100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,17.780000>}
box{<0,0,-0.127000><0.770100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.036700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.867800>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,90.000000,0> translate<48.905900,-1.535000,18.867800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,18.288000>}
box{<0,0,-0.127000><0.770100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,18.542000>}
box{<0,0,-0.127000><0.770100,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.905900,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746600,-1.535000,18.796000>}
box{<0,0,-0.127000><0.840700,0.035000,0.127000> rotate<0,0.000000,0> translate<48.905900,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.919600,0.000000,17.271900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.199600,0.000000,17.155900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<48.919600,0.000000,17.271900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<48.919600,-1.535000,17.271900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.199600,-1.535000,17.155900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<48.919600,-1.535000,17.271900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.006500,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.227400,-1.535000,32.004000>}
box{<0,0,-0.127000><0.220900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.006500,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.006600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.481200,0.000000,28.956000>}
box{<0,0,-0.127000><0.474600,0.035000,0.127000> rotate<0,0.000000,0> translate<49.006600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.006600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.053300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.006600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.116900,-1.535000,31.893500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.914300,-1.535000,33.691000>}
box{<0,0,-0.127000><2.541978,0.035000,0.127000> rotate<0,-44.998624,0> translate<49.116900,-1.535000,31.893500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.164300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.210900,0.000000,29.226300>}
box{<0,0,-0.127000><0.121862,0.035000,0.127000> rotate<0,-67.513114,0> translate<49.164300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.164300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<49.164300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.199600,0.000000,17.155900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,17.092100>}
box{<0,0,-0.127000><0.090156,0.035000,0.127000> rotate<0,45.041965,0> translate<49.199600,0.000000,17.155900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.199600,-1.535000,17.155900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.413900,-1.535000,16.941600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<49.199600,-1.535000,17.155900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.204100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.227200,0.000000,29.210000>}
box{<0,0,-0.127000><0.023100,0.035000,0.127000> rotate<0,0.000000,0> translate<49.204100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.204100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.855700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<49.204100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.210900,0.000000,29.226300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.239900,0.000000,29.197300>}
box{<0,0,-0.127000><0.041012,0.035000,0.127000> rotate<0,44.997030,0> translate<49.210900,0.000000,29.226300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.239900,0.000000,29.197300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,25.871900>}
box{<0,0,-0.127000><4.702826,0.035000,0.127000> rotate<0,44.997030,0> translate<49.239900,0.000000,29.197300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.013900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,17.092100>}
box{<0,0,-0.127000><1.921800,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.263300,0.000000,17.092100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.340000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.013900>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.263300,0.000000,19.013900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.263300,0.000000,19.340000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,19.752700>}
box{<0,0,-0.127000><0.583646,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.263300,0.000000,19.340000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.309400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.750400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<49.309400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.990100>}
box{<0,0,-0.127000><1.484400,0.035000,0.127000> rotate<0,90.000000,0> translate<49.326700,-1.535000,30.990100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.326700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.326700,-1.535000,30.990100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,31.396600>}
box{<0,0,-0.127000><0.574878,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.326700,-1.535000,30.990100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.337500,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,17.018000>}
box{<0,0,-0.127000><0.338500,0.035000,0.127000> rotate<0,0.000000,0> translate<49.337500,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.413900,-1.535000,16.941600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.529900,-1.535000,16.661600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<49.413900,-1.535000,16.941600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.487500,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.746500,-1.535000,16.764000>}
box{<0,0,-0.127000><0.259000,0.035000,0.127000> rotate<0,0.000000,0> translate<49.487500,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.514100,-1.535000,16.320400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.529900,-1.535000,16.358300>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,-67.364955,0> translate<49.514100,-1.535000,16.320400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.514100,-1.535000,16.320400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.947000,-1.535000,15.887600>}
box{<0,0,-0.127000><0.612142,0.035000,0.127000> rotate<0,44.990412,0> translate<49.514100,-1.535000,16.320400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.529900,-1.535000,16.358300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.529900,-1.535000,16.661600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<49.529900,-1.535000,16.661600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.529900,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.832300,-1.535000,16.510000>}
box{<0,0,-0.127000><14.302400,0.035000,0.127000> rotate<0,0.000000,0> translate<49.529900,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.578600,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.578300,-1.535000,16.256000>}
box{<0,0,-0.127000><13.999700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.578600,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.578600,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.154600,0.035000,0.127000> rotate<0,0.000000,0> translate<49.578600,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,24.422900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,0.000000,24.199800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<49.599800,0.000000,24.422900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,24.422900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.599800,0.000000,24.422900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,24.650600>}
box{<0,0,-0.127000><0.622400,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.599800,-1.535000,24.650600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,0.000000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.599800,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,-1.535000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.599800,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,0.000000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.599800,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,-1.535000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.599800,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,25.526800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.599800,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,25.526800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.599800,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,0.000000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,0.000000,26.600100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.599800,0.000000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.599800,-1.535000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,-1.535000,26.600100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.599800,-1.535000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,16.656000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<49.676000,-1.535000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,18.725400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,16.834500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.676000,-1.535000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,18.725400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,18.903900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.676000,-1.535000,18.725400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,19.374500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,19.196000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<49.676000,-1.535000,19.374500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,21.265400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,19.374500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.676000,-1.535000,19.374500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,21.265400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,19.752700>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.676000,0.000000,19.752700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,-1.535000,21.265400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.734000,-1.535000,21.323300>}
box{<0,0,-0.127000><0.081954,0.035000,0.127000> rotate<0,-44.947598,0> translate<49.676000,-1.535000,21.265400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,21.265400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,21.443900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.676000,0.000000,21.265400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,21.914500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,21.736000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<49.676000,0.000000,21.914500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,23.805400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,21.914500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.676000,0.000000,21.914500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.676000,0.000000,23.805400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,23.983900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<49.676000,0.000000,23.805400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.895600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<49.733200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,31.396600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.733200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<49.733200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,24.199800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<49.822900,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,26.600100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<49.822900,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.822900,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,26.600100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<49.822900,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.832600,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.482300,-1.535000,16.002000>}
box{<0,0,-0.127000><7.649700,0.035000,0.127000> rotate<0,0.000000,0> translate<49.832600,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,16.656000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,-1.535000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,18.903900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,18.903900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,-1.535000,18.903900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,-1.535000,19.196000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,19.196000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,-1.535000,19.196000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,21.443900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.549300,0.000000,21.443900>}
box{<0,0,-0.127000><1.694800,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,0.000000,21.443900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,21.736000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.367300,0.000000,21.736000>}
box{<0,0,-0.127000><1.512800,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,0.000000,21.736000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.854500,0.000000,23.983900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,0.000000,23.983900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.854500,0.000000,23.983900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.895600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.195700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<49.895600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<49.947000,-1.535000,15.887600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.367900,-1.535000,15.887600>}
box{<0,0,-0.127000><7.420900,0.035000,0.127000> rotate<0,0.000000,0> translate<49.947000,-1.535000,15.887600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.195700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.587700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<50.195700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.587700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.012200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<50.587700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,0.000000,25.273000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<50.672500,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.672500,-1.535000,25.273000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<50.672500,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.272500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<50.673000,0.000000,25.272500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,24.384000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,24.638000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,24.892000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.146000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.272500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.272500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,25.272500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,26.600100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<50.673000,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,26.600100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<50.673000,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.527400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,25.527400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,-1.535000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.673000,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<50.673000,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,15.076900>}
box{<0,0,-0.127000><0.687200,0.035000,0.127000> rotate<0,90.000000,0> translate<50.685600,0.000000,15.076900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.996200,0.000000,14.389700>}
box{<0,0,-0.127000><1.310600,0.035000,0.127000> rotate<0,0.000000,0> translate<50.685600,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.478000>}
box{<0,0,-0.127000><4.673700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.685600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.732000>}
box{<0,0,-0.127000><4.673700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.685600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.986000>}
box{<0,0,-0.127000><4.673700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.685600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.685600,0.000000,15.076900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.106000,0.000000,16.497300>}
box{<0,0,-0.127000><2.008749,0.035000,0.127000> rotate<0,-44.997030,0> translate<50.685600,0.000000,15.076900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.848700,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,15.240000>}
box{<0,0,-0.127000><4.510600,0.035000,0.127000> rotate<0,0.000000,0> translate<50.848700,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.914300,-1.535000,33.691000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.144900,-1.535000,33.921600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<50.914300,-1.535000,33.691000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,0.000000,24.199800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<50.926800,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.272500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,24.199800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<50.926800,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,25.527400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<50.926800,0.000000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,25.527400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<50.926800,-1.535000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,0.000000,26.600100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<50.926800,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.926800,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,-1.535000,26.600100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<50.926800,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,0.000000,25.526800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<50.927400,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,-1.535000,25.526800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<50.927400,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,25.400000>}
box{<0,0,-0.127000><1.637900,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,-1.535000,25.400000>}
box{<0,0,-0.127000><8.000100,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<50.927400,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<50.927400,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.012200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.404200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<51.012200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.102700,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,15.494000>}
box{<0,0,-0.127000><4.256600,0.035000,0.127000> rotate<0,0.000000,0> translate<51.102700,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.134800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.005000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<51.134800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.144900,-1.535000,33.921600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.798900,-1.535000,33.921600>}
box{<0,0,-0.127000><25.654000,0.035000,0.127000> rotate<0,0.000000,0> translate<51.144900,-1.535000,33.921600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.356700,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,15.748000>}
box{<0,0,-0.127000><4.002600,0.035000,0.127000> rotate<0,0.000000,0> translate<51.356700,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.367300,0.000000,21.736000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.549300,0.000000,21.553900>}
box{<0,0,-0.127000><0.257458,0.035000,0.127000> rotate<0,45.012765,0> translate<51.367300,0.000000,21.736000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.404200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.704300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<51.404200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.546600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.593300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<51.546600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.549300,0.000000,21.553900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.549300,0.000000,21.443900>}
box{<0,0,-0.127000><0.110000,0.035000,0.127000> rotate<0,-90.000000,0> translate<51.549300,0.000000,21.443900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.610700,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,16.002000>}
box{<0,0,-0.127000><3.748600,0.035000,0.127000> rotate<0,0.000000,0> translate<51.610700,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.704300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<51.704300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.744100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.395700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<51.744100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,16.834500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<51.745400,-1.535000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,18.903900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.725400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<51.745400,-1.535000,18.903900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,-1.535000,19.196000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,19.374500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<51.745400,-1.535000,19.196000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.745400,0.000000,23.983900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,23.805400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<51.745400,0.000000,23.983900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,24.422900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<51.777000,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,26.377000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<51.777000,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.777000,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,26.377000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<51.777000,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.849400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.290400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<51.849400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.853300,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.799200,-1.535000,18.796000>}
box{<0,0,-0.127000><1.945900,0.035000,0.127000> rotate<0,0.000000,0> translate<51.853300,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.853300,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,23.876000>}
box{<0,0,-0.127000><0.712000,0.035000,0.127000> rotate<0,0.000000,0> translate<51.853300,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.853400,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.001500,-1.535000,16.764000>}
box{<0,0,-0.127000><6.148100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.853400,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.853400,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.291200,-1.535000,19.304000>}
box{<0,0,-0.127000><1.437800,0.035000,0.127000> rotate<0,0.000000,0> translate<51.853400,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.864700,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,16.256000>}
box{<0,0,-0.127000><3.494600,0.035000,0.127000> rotate<0,0.000000,0> translate<51.864700,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.990000>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,90.000000,0> translate<51.866700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<51.866700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.866700,-1.535000,30.990000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,31.396600>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<51.866700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,17.284700>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,90.000000,0> translate<51.923900,-1.535000,17.284700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,17.018000>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,17.272000>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,17.284700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,17.284700>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,17.284700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.275200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.725400>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,90.000000,0> translate<51.923900,-1.535000,18.725400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.275200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.275200>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,18.275200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.288000>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.542000>}
box{<0,0,-0.127000><6.007100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,19.374500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,20.671400>}
box{<0,0,-0.127000><1.296900,0.035000,0.127000> rotate<0,90.000000,0> translate<51.923900,-1.535000,20.671400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.037200,-1.535000,19.558000>}
box{<0,0,-0.127000><1.113300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.783200,-1.535000,19.812000>}
box{<0,0,-0.127000><0.859300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.529200,-1.535000,20.066000>}
box{<0,0,-0.127000><0.605300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.275200,-1.535000,20.320000>}
box{<0,0,-0.127000><0.351300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.021200,-1.535000,20.574000>}
box{<0,0,-0.127000><0.097300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,-1.535000,20.671400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.811900,-1.535000,18.783300>}
box{<0,0,-0.127000><2.670106,0.035000,0.127000> rotate<0,44.998547,0> translate<51.923900,-1.535000,20.671400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,22.292600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,23.805400>}
box{<0,0,-0.127000><1.512800,0.035000,0.127000> rotate<0,90.000000,0> translate<51.923900,0.000000,23.805400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,22.292600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.880000>}
box{<0,0,-0.127000><0.583575,0.035000,0.127000> rotate<0,44.990088,0> translate<51.923900,0.000000,22.292600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.545200,0.000000,22.352000>}
box{<0,0,-0.127000><1.621300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.291200,0.000000,22.606000>}
box{<0,0,-0.127000><1.367300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.037200,0.000000,22.860000>}
box{<0,0,-0.127000><1.113300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.783200,0.000000,23.114000>}
box{<0,0,-0.127000><0.859300,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,23.368000>}
box{<0,0,-0.127000><0.641400,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.923900,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,23.622000>}
box{<0,0,-0.127000><0.641400,0.035000,0.127000> rotate<0,0.000000,0> translate<51.923900,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.961100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.021200,0.000000,26.416000>}
box{<0,0,-0.127000><0.060100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.961100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.961100,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.893800,-1.535000,26.416000>}
box{<0,0,-0.127000><5.932700,0.035000,0.127000> rotate<0,0.000000,0> translate<51.961100,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.961200,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,24.384000>}
box{<0,0,-0.127000><0.604100,0.035000,0.127000> rotate<0,0.000000,0> translate<51.961200,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<51.996200,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.016100,0.000000,14.369800>}
box{<0,0,-0.127000><0.028143,0.035000,0.127000> rotate<0,44.997030,0> translate<51.996200,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,24.422900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.273000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<52.000100,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,24.638000>}
box{<0,0,-0.127000><0.565200,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,24.650600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.273000>}
box{<0,0,-0.127000><0.622400,0.035000,0.127000> rotate<0,90.000000,0> translate<52.000100,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,24.650600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,24.650600>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,24.650600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,24.892000>}
box{<0,0,-0.127000><0.565200,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,24.892000>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,25.146000>}
box{<0,0,-0.127000><0.565200,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.146000>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,26.377000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<52.000100,0.000000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,26.377000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<52.000100,-1.535000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,25.654000>}
box{<0,0,-0.127000><0.565200,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.654000>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.529200,0.000000,25.908000>}
box{<0,0,-0.127000><0.529100,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.908000>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.275200,0.000000,26.162000>}
box{<0,0,-0.127000><0.275100,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.000100,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,26.162000>}
box{<0,0,-0.127000><5.854700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.000100,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.016100,0.000000,14.369800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.112100,0.000000,14.465900>}
box{<0,0,-0.127000><0.135835,0.035000,0.127000> rotate<0,-45.026854,0> translate<52.016100,0.000000,14.369800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.106000,0.000000,16.497300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,16.727900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<52.106000,0.000000,16.497300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.112100,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,14.465900>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<52.112100,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.118600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.799200,0.000000,22.098000>}
box{<0,0,-0.127000><1.680600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.118600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.118600,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.154600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.118600,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.118700,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,16.510000>}
box{<0,0,-0.127000><3.240600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.118700,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.435600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<52.273200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,31.396600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.273200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<52.273200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.297300,-1.535000,4.559300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.313000,-1.535000,4.521300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<52.297300,-1.535000,4.559300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.313000,-1.535000,4.521300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.527300,-1.535000,4.307000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<52.313000,-1.535000,4.521300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,16.727900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.553900>}
box{<0,0,-0.127000><4.826000,0.035000,0.127000> rotate<0,90.000000,0> translate<52.336600,0.000000,21.553900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,16.764000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,17.018000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,17.272000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,17.526000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,17.780000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,18.034000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,18.288000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,18.542000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,18.796000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,19.050000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,19.304000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,19.558000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,19.812000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,20.066000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,20.320000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,20.574000>}
box{<0,0,-0.127000><3.022700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.548300,0.000000,20.828000>}
box{<0,0,-0.127000><2.211700,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.323900,0.000000,21.082000>}
box{<0,0,-0.127000><1.987300,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.336000>}
box{<0,0,-0.127000><1.892400,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.553900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.880000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<52.336600,0.000000,21.880000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.590000>}
box{<0,0,-0.127000><1.892400,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.336600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.053200,0.000000,21.844000>}
box{<0,0,-0.127000><1.716600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.336600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.435600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.735700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<52.435600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.527300,-1.535000,4.307000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.777100,-1.535000,4.203600>}
box{<0,0,-0.127000><0.270355,0.035000,0.127000> rotate<0,22.484703,0> translate<52.527300,-1.535000,4.307000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,23.331900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.795900,0.000000,23.101300>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<52.565300,0.000000,23.331900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,25.871900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.565300,0.000000,23.331900>}
box{<0,0,-0.127000><2.540000,0.035000,0.127000> rotate<0,-90.000000,0> translate<52.565300,0.000000,23.331900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.735700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.127700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<52.735700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,13.462300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,14.465900>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<52.793100,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,13.462300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,13.462300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.793100,0.000000,13.462300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,13.716000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.793100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,13.970000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.793100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.793100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,14.224000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<52.793100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<52.795900,0.000000,23.101300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.244700,0.000000,21.652500>}
box{<0,0,-0.127000><2.048913,0.035000,0.127000> rotate<0,44.997030,0> translate<52.795900,0.000000,23.101300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,13.462300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<53.046700,0.000000,13.462300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.046700,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.727800,0.000000,14.465900>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<53.046700,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.047300,0.000000,13.208100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.047300,0.000000,13.461700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<53.047300,0.000000,13.461700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.047300,0.000000,13.208100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.208100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<53.047300,0.000000,13.208100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.047300,0.000000,13.461700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.461700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<53.047300,0.000000,13.461700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.127700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.552200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.127700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.552200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.944200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<53.552200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.631100,0.000000,4.584600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,4.801300>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-67.486537,0> translate<53.631100,0.000000,4.584600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.631100,0.000000,4.584600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,4.584600>}
box{<0,0,-0.127000><4.395200,0.035000,0.127000> rotate<0,0.000000,0> translate<53.631100,0.000000,4.584600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.674800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.545000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<53.674800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.705100,0.000000,5.142500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,5.104600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<53.705100,0.000000,5.142500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.705100,0.000000,5.142500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.900000,0.000000,6.337300>}
box{<0,0,-0.127000><1.689773,0.035000,0.127000> rotate<0,-44.994633,0> translate<53.705100,0.000000,5.142500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,4.801300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,5.104600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<53.720900,0.000000,5.104600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,4.826000>}
box{<0,0,-0.127000><4.305400,0.035000,0.127000> rotate<0,0.000000,0> translate<53.720900,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.720900,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.080000>}
box{<0,0,-0.127000><4.305400,0.035000,0.127000> rotate<0,0.000000,0> translate<53.720900,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.727800,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,14.242800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<53.727800,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.811900,-1.535000,18.783300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.138000,-1.535000,18.783300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<53.811900,-1.535000,18.783300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.896600,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.334000>}
box{<0,0,-0.127000><4.129700,0.035000,0.127000> rotate<0,0.000000,0> translate<53.896600,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.944200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.244300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<53.944200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,12.724500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.208100>}
box{<0,0,-0.127000><0.483600,0.035000,0.127000> rotate<0,90.000000,0> translate<53.950900,0.000000,13.208100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,12.724500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.133000>}
box{<0,0,-0.127000><1.991849,0.035000,0.127000> rotate<0,-44.999064,0> translate<53.950900,0.000000,12.724500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.180400,0.000000,12.954000>}
box{<0,0,-0.127000><0.229500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.434400,0.000000,13.208000>}
box{<0,0,-0.127000><0.483500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.461700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,14.242800>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,90.000000,0> translate<53.950900,0.000000,14.242800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.688400,0.000000,13.462000>}
box{<0,0,-0.127000><0.737500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.942400,0.000000,13.716000>}
box{<0,0,-0.127000><0.991500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.196400,0.000000,13.970000>}
box{<0,0,-0.127000><1.245500,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<53.950900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.224000>}
box{<0,0,-0.127000><1.408400,0.035000,0.127000> rotate<0,0.000000,0> translate<53.950900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.086600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.133300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<54.086600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.138000,-1.535000,18.783300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.989000,-1.535000,18.783300>}
box{<0,0,-0.127000><3.851000,0.035000,0.127000> rotate<0,0.000000,0> translate<54.138000,-1.535000,18.783300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.150600,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.588000>}
box{<0,0,-0.127000><3.875700,0.035000,0.127000> rotate<0,0.000000,0> translate<54.150600,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.311300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.345000,0.000000,21.031300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<54.229000,0.000000,21.311300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.614600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.311300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<54.229000,0.000000,21.311300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.229000,0.000000,21.614600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.244700,0.000000,21.652500>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-67.493860,0> translate<54.229000,0.000000,21.614600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.244300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<54.244300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.284100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.935700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<54.284100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.345000,0.000000,21.031300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.559300,0.000000,20.817000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<54.345000,0.000000,21.031300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.389400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.830400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<54.389400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.404600,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.545000,0.000000,5.842000>}
box{<0,0,-0.127000><1.140400,0.035000,0.127000> rotate<0,0.000000,0> translate<54.404600,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.990000>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,90.000000,0> translate<54.406700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<54.406700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.406700,-1.535000,30.990000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,31.396600>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<54.406700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.559300,0.000000,20.817000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.839300,0.000000,20.701000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<54.559300,0.000000,20.817000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.658600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.133300,0.000000,6.096000>}
box{<0,0,-0.127000><0.474700,0.035000,0.127000> rotate<0,0.000000,0> translate<54.658600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.658600,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.154600,0.035000,0.127000> rotate<0,0.000000,0> translate<54.658600,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.975600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<54.813200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,31.396600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.813200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<54.813200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.839300,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.142600,0.000000,20.701000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<54.839300,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.900000,0.000000,6.337300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.929000,0.000000,6.366300>}
box{<0,0,-0.127000><0.041012,0.035000,0.127000> rotate<0,-44.997030,0> translate<54.900000,0.000000,6.337300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.912700,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.935700,0.000000,6.350000>}
box{<0,0,-0.127000><0.023000,0.035000,0.127000> rotate<0,0.000000,0> translate<54.912700,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.929000,0.000000,6.366300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.975600,0.000000,6.253700>}
box{<0,0,-0.127000><0.121862,0.035000,0.127000> rotate<0,67.513114,0> translate<54.929000,0.000000,6.366300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.975600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<54.975600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<54.975600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<54.975600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.141100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,12.282900>}
box{<0,0,-0.127000><3.141800,0.035000,0.127000> rotate<0,90.000000,0> translate<55.130600,0.000000,12.282900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.141100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,0.000000,9.286300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-45.016766,0> translate<55.130600,0.000000,9.141100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.133500,0.000000,9.144000>}
box{<0,0,-0.127000><0.002900,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.545400,0.000000,9.398000>}
box{<0,0,-0.127000><0.414800,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.796500,0.000000,9.652000>}
box{<0,0,-0.127000><8.665900,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.342900,0.000000,9.906000>}
box{<0,0,-0.127000><7.212300,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,10.160000>}
box{<0,0,-0.127000><7.199600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,10.414000>}
box{<0,0,-0.127000><7.199600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.135900,0.000000,10.668000>}
box{<0,0,-0.127000><2.005300,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,10.922000>}
box{<0,0,-0.127000><1.969600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,11.176000>}
box{<0,0,-0.127000><1.969600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,11.430000>}
box{<0,0,-0.127000><1.969600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,11.684000>}
box{<0,0,-0.127000><1.969600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,11.938000>}
box{<0,0,-0.127000><1.969600,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.818300,0.000000,12.192000>}
box{<0,0,-0.127000><0.687700,0.035000,0.127000> rotate<0,0.000000,0> translate<55.130600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.130600,0.000000,12.282900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.506000,0.000000,12.658400>}
box{<0,0,-0.127000><0.530966,0.035000,0.127000> rotate<0,-45.004660,0> translate<55.130600,0.000000,12.282900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.142600,0.000000,20.701000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,20.790800>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,-22.507523,0> translate<55.142600,0.000000,20.701000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<55.275700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<55.275700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.275700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<55.275700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.293600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.593900,0.000000,12.446000>}
box{<0,0,-0.127000><0.300300,0.035000,0.127000> rotate<0,0.000000,0> translate<55.293600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,20.790800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.359300,0.000000,14.133000>}
box{<0,0,-0.127000><6.657800,0.035000,0.127000> rotate<0,-90.000000,0> translate<55.359300,0.000000,14.133000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.506000,0.000000,12.658400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.615000,0.000000,12.395300>}
box{<0,0,-0.127000><0.284785,0.035000,0.127000> rotate<0,67.491751,0> translate<55.506000,0.000000,12.658400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.615000,0.000000,12.395300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.829300,0.000000,12.181000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<55.615000,0.000000,12.395300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<55.667700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<55.667700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.667700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<55.667700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<55.829300,0.000000,12.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.109300,0.000000,12.065000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<55.829300,0.000000,12.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<56.092200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<56.092200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.092200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<56.092200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.109300,0.000000,12.065000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.412600,0.000000,12.065000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<56.109300,0.000000,12.065000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,20.508200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,25.363900>}
box{<0,0,-0.127000><4.855700,0.035000,0.127000> rotate<0,90.000000,0> translate<56.146600,0.000000,25.363900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,20.508200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,22.292700>}
box{<0,0,-0.127000><2.523593,0.035000,0.127000> rotate<0,-44.998635,0> translate<56.146600,0.000000,20.508200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.212400,0.000000,20.574000>}
box{<0,0,-0.127000><0.065800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.466400,0.000000,20.828000>}
box{<0,0,-0.127000><0.319800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.720400,0.000000,21.082000>}
box{<0,0,-0.127000><0.573800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.974400,0.000000,21.336000>}
box{<0,0,-0.127000><0.827800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.228400,0.000000,21.590000>}
box{<0,0,-0.127000><1.081800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.482400,0.000000,21.844000>}
box{<0,0,-0.127000><1.335800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.736400,0.000000,22.098000>}
box{<0,0,-0.127000><1.589800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,22.352000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,22.606000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,22.860000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,23.114000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,23.368000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,23.622000>}
box{<0,0,-0.127000><1.784400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.001600,0.000000,23.876000>}
box{<0,0,-0.127000><1.855000,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,24.130000>}
box{<0,0,-0.127000><6.324700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.893700,0.000000,24.384000>}
box{<0,0,-0.127000><1.747100,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,24.638000>}
box{<0,0,-0.127000><1.708200,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,24.892000>}
box{<0,0,-0.127000><1.708200,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.146000>}
box{<0,0,-0.127000><1.708200,0.035000,0.127000> rotate<0,0.000000,0> translate<56.146600,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.146600,0.000000,25.363900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.980000,0.000000,29.197300>}
box{<0,0,-0.127000><5.421246,0.035000,0.127000> rotate<0,-44.997030,0> translate<56.146600,0.000000,25.363900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.182700,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,0.000000,25.400000>}
box{<0,0,-0.127000><2.744800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.182700,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.214600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.085400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<56.214600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.214800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.842000>}
box{<0,0,-0.127000><1.811500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.214800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.214800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.085000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<56.214800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.412600,0.000000,12.065000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.692600,0.000000,12.181000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<56.412600,0.000000,12.065000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.436700,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.654000>}
box{<0,0,-0.127000><1.418100,0.035000,0.127000> rotate<0,0.000000,0> translate<56.436700,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<56.484200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<56.484200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.484200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<56.484200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.626500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.673400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<56.626500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.626600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.673300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.626600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.626600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.673300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.626600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.690700,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.908000>}
box{<0,0,-0.127000><1.164100,0.035000,0.127000> rotate<0,0.000000,0> translate<56.690700,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.692600,0.000000,12.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.792700,0.000000,12.281200>}
box{<0,0,-0.127000><0.141634,0.035000,0.127000> rotate<0,-45.025633,0> translate<56.692600,0.000000,12.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.703500,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.136100,0.000000,12.192000>}
box{<0,0,-0.127000><0.432600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.703500,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<56.784300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<56.784300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.784300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<56.784300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.792700,0.000000,12.281200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.793700,0.000000,12.280200>}
box{<0,0,-0.127000><0.001414,0.035000,0.127000> rotate<0,44.997030,0> translate<56.792700,0.000000,12.281200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.793700,0.000000,12.280200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.224300,0.000000,12.280200>}
box{<0,0,-0.127000><0.430600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.793700,0.000000,12.280200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.824100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.475700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.824100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.824100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.475700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.824100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.824200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.475800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.824200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,17.616900>}
box{<0,0,-0.127000><3.227200,0.035000,0.127000> rotate<0,90.000000,0> translate<56.908600,0.000000,17.616900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.346200,0.000000,14.389700>}
box{<0,0,-0.127000><1.437600,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,14.478000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,14.732000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,14.986000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,15.240000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,15.494000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,15.748000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,16.002000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,16.256000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,16.510000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.001500,0.000000,16.764000>}
box{<0,0,-0.127000><1.092900,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,17.018000>}
box{<0,0,-0.127000><1.022400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,17.272000>}
box{<0,0,-0.127000><1.022400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,17.526000>}
box{<0,0,-0.127000><1.022400,0.035000,0.127000> rotate<0,0.000000,0> translate<56.908600,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.908600,0.000000,17.616900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,18.639400>}
box{<0,0,-0.127000><1.445963,0.035000,0.127000> rotate<0,-44.999832,0> translate<56.908600,0.000000,17.616900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.929400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.370400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<56.929400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.929400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.370600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<56.929400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.929400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.370400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<56.929400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.944700,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,26.162000>}
box{<0,0,-0.127000><0.910100,0.035000,0.127000> rotate<0,0.000000,0> translate<56.944700,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<56.946700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.990000>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,90.000000,0> translate<56.946700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<56.946700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<56.946700,-1.535000,30.990000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,31.396600>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<56.946700,-1.535000,30.990000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.071600,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,17.780000>}
box{<0,0,-0.127000><0.859400,0.035000,0.127000> rotate<0,0.000000,0> translate<57.071600,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,10.703700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.278700,0.000000,10.525200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<57.100200,0.000000,10.703700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,12.156200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,10.703700>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.100200,0.000000,10.703700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.100200,0.000000,12.156200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.224300,0.000000,12.280200>}
box{<0,0,-0.127000><0.175433,0.035000,0.127000> rotate<0,-44.973938,0> translate<57.100200,0.000000,12.156200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.198600,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.154600,0.035000,0.127000> rotate<0,0.000000,0> translate<57.198600,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.198700,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.893800,0.000000,26.416000>}
box{<0,0,-0.127000><0.695100,0.035000,0.127000> rotate<0,0.000000,0> translate<57.198700,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.278700,0.000000,10.525200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.731200,0.000000,10.525200>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<57.278700,0.000000,10.525200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.325600,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,18.034000>}
box{<0,0,-0.127000><0.605400,0.035000,0.127000> rotate<0,0.000000,0> translate<57.325600,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<57.353200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.353200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<57.353200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<57.353200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,31.396600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.353200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.353200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.367900,-1.535000,15.887600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.621900,-1.535000,16.141600>}
box{<0,0,-0.127000><0.359210,0.035000,0.127000> rotate<0,-44.997030,0> translate<57.367900,-1.535000,15.887600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.452700,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,26.670000>}
box{<0,0,-0.127000><5.018600,0.035000,0.127000> rotate<0,0.000000,0> translate<57.452700,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<57.515600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<57.515600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.515600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<57.515600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.579600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,18.288000>}
box{<0,0,-0.127000><0.351400,0.035000,0.127000> rotate<0,0.000000,0> translate<57.579600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.621900,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.948000,-1.535000,16.141600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<57.621900,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.706700,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,26.924000>}
box{<0,0,-0.127000><4.764600,0.035000,0.127000> rotate<0,0.000000,0> translate<57.706700,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.866400>}
box{<0,0,-0.127000><0.227939,0.035000,0.127000> rotate<0,22.490765,0> translate<57.815700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.207700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<57.815700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.815700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.207700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<57.815700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.833600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,18.542000>}
box{<0,0,-0.127000><0.097400,0.035000,0.127000> rotate<0,0.000000,0> translate<57.833600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,24.422900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,0.000000,24.199800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<57.854800,0.000000,24.422900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,24.422900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.854800,0.000000,24.422900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,24.650600>}
box{<0,0,-0.127000><0.622400,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.854800,-1.535000,24.650600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,0.000000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<57.854800,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,-1.535000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<57.854800,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,0.000000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<57.854800,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,-1.535000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<57.854800,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,25.526800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.854800,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,25.526800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.854800,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,0.000000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,0.000000,26.600100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<57.854800,0.000000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.854800,-1.535000,26.377000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,-1.535000,26.600100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<57.854800,-1.535000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,0.000000,16.656000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<57.931000,0.000000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,-1.535000,16.656000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<57.931000,-1.535000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,17.284700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,16.834500>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.931000,-1.535000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,18.639400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,16.834500>}
box{<0,0,-0.127000><1.804900,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.931000,0.000000,16.834500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.725400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.275200>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.931000,-1.535000,18.275200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,-1.535000,18.725400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.989000,-1.535000,18.783300>}
box{<0,0,-0.127000><0.081954,0.035000,0.127000> rotate<0,-44.947598,0> translate<57.931000,-1.535000,18.725400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,23.805400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,22.292700>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,-90.000000,0> translate<57.931000,0.000000,22.292700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.931000,0.000000,23.805400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,0.000000,23.983900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<57.931000,0.000000,23.805400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.948000,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.463900,-1.535000,16.141600>}
box{<0,0,-0.127000><5.515900,0.035000,0.127000> rotate<0,0.000000,0> translate<57.948000,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<57.960700,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,27.178000>}
box{<0,0,-0.127000><4.510600,0.035000,0.127000> rotate<0,0.000000,0> translate<57.960700,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,5.866400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.026300,0.000000,4.584600>}
box{<0,0,-0.127000><1.281800,0.035000,0.127000> rotate<0,-90.000000,0> translate<58.026300,0.000000,4.584600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,24.199800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.077900,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,26.600100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.077900,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.077900,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,26.600100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.077900,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,0.000000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,16.656000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<58.109500,0.000000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,-1.535000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,-1.535000,16.656000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<58.109500,-1.535000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.109500,0.000000,23.983900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,23.983900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<58.109500,0.000000,23.983900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.195500,0.000000,21.443900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.487700,0.000000,21.736000>}
box{<0,0,-0.127000><0.413162,0.035000,0.127000> rotate<0,-44.987225,0> translate<58.195500,0.000000,21.443900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.195500,0.000000,21.443900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,21.443900>}
box{<0,0,-0.127000><1.804900,0.035000,0.127000> rotate<0,0.000000,0> translate<58.195500,0.000000,21.443900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.207700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.632200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.207700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.207700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.632200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.207700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.214700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,27.432000>}
box{<0,0,-0.127000><4.256600,0.035000,0.127000> rotate<0,0.000000,0> translate<58.214700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.256900,0.000000,3.797300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.583000,0.000000,3.797300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.256900,0.000000,3.797300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.341600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.767700,0.000000,21.590000>}
box{<0,0,-0.127000><2.426100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.341600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.346200,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.366100,0.000000,14.369800>}
box{<0,0,-0.127000><0.028143,0.035000,0.127000> rotate<0,44.997030,0> translate<58.346200,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.366100,0.000000,14.369800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.462100,0.000000,14.465900>}
box{<0,0,-0.127000><0.135835,0.035000,0.127000> rotate<0,-45.026854,0> translate<58.366100,0.000000,14.369800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.462100,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,14.465900>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<58.462100,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.468700,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,27.686000>}
box{<0,0,-0.127000><4.002600,0.035000,0.127000> rotate<0,0.000000,0> translate<58.468700,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.487700,0.000000,21.736000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,21.736000>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<58.487700,0.000000,21.736000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.583000,0.000000,3.797300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.027900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<58.583000,0.000000,3.797300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.595700,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.673400,0.000000,3.810000>}
box{<0,0,-0.127000><3.077700,0.035000,0.127000> rotate<0,0.000000,0> translate<58.595700,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.632200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<58.632200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.632200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<58.632200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.722700,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,27.940000>}
box{<0,0,-0.127000><3.748600,0.035000,0.127000> rotate<0,0.000000,0> translate<58.722700,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.731200,0.000000,10.525200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,10.703700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<58.731200,0.000000,10.525200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.754600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.625400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.754600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.754800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.625000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<58.754800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.027900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.866400>}
box{<0,0,-0.127000><1.838500,0.035000,0.127000> rotate<0,90.000000,0> translate<58.813600,0.000000,5.866400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.927400,0.000000,4.064000>}
box{<0,0,-0.127000><3.113800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.181400,0.000000,4.318000>}
box{<0,0,-0.127000><3.367800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.435400,0.000000,4.572000>}
box{<0,0,-0.127000><3.621800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.689400,0.000000,4.826000>}
box{<0,0,-0.127000><3.875800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.943400,0.000000,5.080000>}
box{<0,0,-0.127000><4.129800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.197400,0.000000,5.334000>}
box{<0,0,-0.127000><4.383800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.451400,0.000000,5.588000>}
box{<0,0,-0.127000><4.637800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.625000,0.000000,5.842000>}
box{<0,0,-0.127000><1.811400,0.035000,0.127000> rotate<0,0.000000,0> translate<58.813600,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.813600,0.000000,5.866400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,0.000000,5.953600>}
box{<0,0,-0.127000><0.227939,0.035000,0.127000> rotate<0,-22.490765,0> translate<58.813600,0.000000,5.866400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.861800,0.000000,12.204000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,12.156200>}
box{<0,0,-0.127000><0.067670,0.035000,0.127000> rotate<0,44.937164,0> translate<58.861800,0.000000,12.204000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.861800,0.000000,12.204000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,12.204000>}
box{<0,0,-0.127000><0.281300,0.035000,0.127000> rotate<0,0.000000,0> translate<58.861800,0.000000,12.204000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.873900,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.236000,0.000000,12.192000>}
box{<0,0,-0.127000><0.362100,0.035000,0.127000> rotate<0,0.000000,0> translate<58.873900,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.874000,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.235900,0.000000,10.668000>}
box{<0,0,-0.127000><0.361900,0.035000,0.127000> rotate<0,0.000000,0> translate<58.874000,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,10.703700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,12.156200>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,90.000000,0> translate<58.909700,0.000000,12.156200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,10.922000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.909700,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,11.176000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.909700,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,11.430000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.909700,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,11.684000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.909700,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.909700,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,11.938000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<58.909700,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,0.000000,25.273000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<58.927500,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.927500,-1.535000,25.273000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<58.927500,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.272500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<58.928000,0.000000,25.272500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,24.384000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,24.638000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,24.892000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.146000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.272500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.272500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,25.272500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,26.600100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<58.928000,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,26.600100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<58.928000,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.527400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,25.527400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,25.527400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,-1.535000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.928000,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<58.928000,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<58.976700,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,28.194000>}
box{<0,0,-0.127000><3.494600,0.035000,0.127000> rotate<0,0.000000,0> translate<58.976700,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<59.024200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<59.024200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.024200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<59.024200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,12.204000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.207600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<59.143100,0.000000,13.207600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,12.446000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,12.700000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,12.954000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.207600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.207600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,13.207600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.462300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,14.465900>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<59.143100,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.462300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.462300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,13.462300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.716000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.970000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.143100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,14.224000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.143100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.166500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.213400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<59.166500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.166600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.213300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.166600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.166600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.213300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.166600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.179100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<59.179100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.179100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.200800,-1.535000,31.991300>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.179100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,0.000000,24.199800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<59.181800,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.272500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,24.199800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.181800,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,25.527400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.181800,0.000000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,25.527400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.181800,-1.535000,25.527400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,0.000000,26.600100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<59.181800,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.181800,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,-1.535000,26.600100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<59.181800,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,0.000000,25.526800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<59.182400,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,-1.535000,25.526800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<59.182400,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,0.000000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,-1.535000,25.273000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.273000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.530400,-1.535000,25.400000>}
box{<0,0,-0.127000><1.348000,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,25.400000>}
box{<0,0,-0.127000><3.288900,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,0.000000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.182400,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.526800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<59.182400,-1.535000,25.526800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,10.703700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.378700,0.000000,10.525200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<59.200200,0.000000,10.703700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,12.156200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,10.703700>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.200200,0.000000,10.703700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.200200,0.000000,12.156200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.378700,0.000000,12.334700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<59.200200,0.000000,12.156200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.230700,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.435200,0.000000,28.448000>}
box{<0,0,-0.127000><3.204500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.230700,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<59.324300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<59.324300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<59.324300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.324300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<59.324300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.364100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.015700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.364100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.364100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.015700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.364100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.364200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.015800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.364200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.364200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.015800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.364200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.378700,0.000000,10.525200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.831200,0.000000,10.525200>}
box{<0,0,-0.127000><1.452500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.378700,0.000000,10.525200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.378700,0.000000,12.334700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,12.334700>}
box{<0,0,-0.127000><0.018000,0.035000,0.127000> rotate<0,0.000000,0> translate<59.378700,0.000000,12.334700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.207600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,12.334700>}
box{<0,0,-0.127000><0.872900,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.396700,0.000000,12.334700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,13.462300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.396700,0.000000,13.462300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.396700,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.077800,0.000000,14.465900>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<59.396700,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.397300,0.000000,13.208100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.397300,0.000000,13.461700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<59.397300,0.000000,13.461700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.397300,0.000000,13.208100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.208100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.397300,0.000000,13.208100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.397300,0.000000,13.461700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.461700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.397300,0.000000,13.461700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.469400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.910400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<59.469400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.469400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.910600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<59.469400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.469400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.910400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<59.469400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.469400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.910600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<59.469400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.484700,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.625000,0.000000,28.702000>}
box{<0,0,-0.127000><1.140300,0.035000,0.127000> rotate<0,0.000000,0> translate<59.484700,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<59.486700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<59.486700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.486700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<59.486700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.738700,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.213300,0.000000,28.956000>}
box{<0,0,-0.127000><0.474600,0.035000,0.127000> rotate<0,0.000000,0> translate<59.738700,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<59.893200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.893200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<59.893200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<59.893200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<59.893200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.893200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<59.893200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.980000,0.000000,29.197300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.009000,0.000000,29.226300>}
box{<0,0,-0.127000><0.041012,0.035000,0.127000> rotate<0,-44.997030,0> translate<59.980000,0.000000,29.197300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<59.992700,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.015700,0.000000,29.210000>}
box{<0,0,-0.127000><0.023000,0.035000,0.127000> rotate<0,0.000000,0> translate<59.992700,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,16.834500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.000400,0.000000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,-1.535000,16.656000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,16.834500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.000400,-1.535000,16.656000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,21.443900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.265400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<60.000400,0.000000,21.443900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,21.736000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.914500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.000400,0.000000,21.736000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.000400,0.000000,23.983900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,23.805400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<60.000400,0.000000,23.983900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.009000,0.000000,29.226300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,29.113700>}
box{<0,0,-0.127000><0.121862,0.035000,0.127000> rotate<0,67.513114,0> translate<60.009000,0.000000,29.226300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,0.000000,24.199800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,24.422900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.032000,0.000000,24.199800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,0.000000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,26.377000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<60.032000,0.000000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.032000,-1.535000,26.600100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,26.377000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<60.032000,-1.535000,26.600100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.034900,0.000000,2.171600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.654600,0.000000,5.791200>}
box{<0,0,-0.127000><5.118958,0.035000,0.127000> rotate<0,-44.996239,0> translate<60.034900,0.000000,2.171600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<60.055600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.055600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<60.055600,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<60.055600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.055600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.200800,-1.535000,31.991300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<60.055600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.077800,0.000000,14.465900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,14.242800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<60.077800,0.000000,14.465900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.108300,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.513700,0.000000,21.336000>}
box{<0,0,-0.127000><0.405400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.108300,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.108300,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,23.876000>}
box{<0,0,-0.127000><2.363000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.108300,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.108400,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,16.764000>}
box{<0,0,-0.127000><1.346900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.108400,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.108400,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,16.764000>}
box{<0,0,-0.127000><3.856800,0.035000,0.127000> rotate<0,0.000000,0> translate<60.108400,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.108400,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.021700,0.000000,21.844000>}
box{<0,0,-0.127000><0.913300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.108400,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,18.131400>}
box{<0,0,-0.127000><1.296900,0.035000,0.127000> rotate<0,90.000000,0> translate<60.178900,-1.535000,18.131400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,16.834500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,18.203600>}
box{<0,0,-0.127000><1.369100,0.035000,0.127000> rotate<0,90.000000,0> translate<60.178900,0.000000,18.203600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,17.018000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,17.018000>}
box{<0,0,-0.127000><3.786300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,17.272000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,17.272000>}
box{<0,0,-0.127000><3.786300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,17.526000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,17.526000>}
box{<0,0,-0.127000><3.786300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.530200,-1.535000,17.780000>}
box{<0,0,-0.127000><0.351300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,17.780000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.276200,-1.535000,18.034000>}
box{<0,0,-0.127000><0.097300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,18.034000>}
box{<0,0,-0.127000><1.276400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,-1.535000,18.131400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.542900,-1.535000,17.767300>}
box{<0,0,-0.127000><0.514844,0.035000,0.127000> rotate<0,45.004899,0> translate<60.178900,-1.535000,18.131400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,18.203600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,18.844800>}
box{<0,0,-0.127000><0.906864,0.035000,0.127000> rotate<0,-44.992563,0> translate<60.178900,0.000000,18.203600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.001200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.265400>}
box{<0,0,-0.127000><0.264200,0.035000,0.127000> rotate<0,90.000000,0> translate<60.178900,0.000000,21.265400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.001200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.423200,0.000000,22.245500>}
box{<0,0,-0.127000><1.759706,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.178900,0.000000,21.001200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.259700,0.000000,21.082000>}
box{<0,0,-0.127000><0.080800,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,21.914500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,23.805400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<60.178900,0.000000,23.805400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.275700,0.000000,22.098000>}
box{<0,0,-0.127000><1.096800,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.423200,0.000000,22.352000>}
box{<0,0,-0.127000><1.244300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.525100,0.000000,22.606000>}
box{<0,0,-0.127000><1.346200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.859900,0.000000,22.860000>}
box{<0,0,-0.127000><1.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,23.114000>}
box{<0,0,-0.127000><2.292400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,23.368000>}
box{<0,0,-0.127000><2.292400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.178900,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,23.622000>}
box{<0,0,-0.127000><2.292400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.178900,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.208400,0.000000,12.334700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,12.427100>}
box{<0,0,-0.127000><0.130744,0.035000,0.127000> rotate<0,-44.966045,0> translate<60.208400,0.000000,12.334700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.208400,0.000000,12.334700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.546100,0.000000,12.334700>}
box{<0,0,-0.127000><0.337700,0.035000,0.127000> rotate<0,0.000000,0> translate<60.208400,0.000000,12.334700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.216100,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.416000>}
box{<0,0,-0.127000><0.732900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.216100,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.216100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,26.416000>}
box{<0,0,-0.127000><2.255200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.216100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.216200,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,24.384000>}
box{<0,0,-0.127000><2.255100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.216200,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,24.422900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.273000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<60.255100,0.000000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,24.638000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,24.892000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.124700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.273000>}
box{<0,0,-0.127000><0.148300,0.035000,0.127000> rotate<0,90.000000,0> translate<60.255100,-1.535000,25.273000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.124700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.669900,-1.535000,25.539600>}
box{<0,0,-0.127000><0.586687,0.035000,0.127000> rotate<0,-45.003935,0> translate<60.255100,-1.535000,25.124700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.276400,-1.535000,25.146000>}
box{<0,0,-0.127000><0.021300,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,25.146000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,26.377000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<60.255100,0.000000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.526800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,26.377000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<60.255100,-1.535000,26.377000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.137100,-1.535000,25.654000>}
box{<0,0,-0.127000><0.882000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,25.654000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,25.908000>}
box{<0,0,-0.127000><0.693900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,25.908000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.162000>}
box{<0,0,-0.127000><0.693900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.255100,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,26.162000>}
box{<0,0,-0.127000><2.216200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.255100,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.263300,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.406300,0.000000,18.288000>}
box{<0,0,-0.127000><1.143000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.263300,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,12.427100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.208100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,90.000000,0> translate<60.300900,0.000000,13.208100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.657400,0.000000,12.446000>}
box{<0,0,-0.127000><0.356500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.911400,0.000000,12.700000>}
box{<0,0,-0.127000><0.610500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.165400,0.000000,12.954000>}
box{<0,0,-0.127000><0.864500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.419400,0.000000,13.208000>}
box{<0,0,-0.127000><1.118500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.461700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,14.242800>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,90.000000,0> translate<60.300900,0.000000,14.242800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,13.462000>}
box{<0,0,-0.127000><1.154400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,13.716000>}
box{<0,0,-0.127000><1.154400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,13.970000>}
box{<0,0,-0.127000><1.154400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.300900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,14.224000>}
box{<0,0,-0.127000><1.154400,0.035000,0.127000> rotate<0,0.000000,0> translate<60.300900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<60.355700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<60.355700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<60.355700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.355700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<60.355700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.517300,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.181900,0.000000,18.542000>}
box{<0,0,-0.127000><0.664600,0.035000,0.127000> rotate<0,0.000000,0> translate<60.517300,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.542900,-1.535000,17.767300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.869000,-1.535000,17.767300>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.542900,-1.535000,17.767300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.546100,0.000000,12.334700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,13.244000>}
box{<0,0,-0.127000><1.285874,0.035000,0.127000> rotate<0,-45.000181,0> translate<60.546100,0.000000,12.334700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.669900,-1.535000,25.539600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.996000,-1.535000,25.539600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.669900,-1.535000,25.539600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.741800,0.000000,1.765200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.183000,0.000000,6.206400>}
box{<0,0,-0.127000><6.280805,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.741800,0.000000,1.765200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.741800,0.000000,1.765200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,1.765200>}
box{<0,0,-0.127000><13.692900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.741800,0.000000,1.765200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.747700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.747700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.747700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.747700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<60.747700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.754600,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,1.778000>}
box{<0,0,-0.127000><13.680100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.754600,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.771300,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,18.796000>}
box{<0,0,-0.127000><0.315700,0.035000,0.127000> rotate<0,0.000000,0> translate<60.771300,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,18.844800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.255100>}
box{<0,0,-0.127000><0.410300,0.035000,0.127000> rotate<0,90.000000,0> translate<60.820200,0.000000,19.255100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,19.050000>}
box{<0,0,-0.127000><0.266800,0.035000,0.127000> rotate<0,0.000000,0> translate<60.820200,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.255100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,20.241800>}
box{<0,0,-0.127000><0.986700,0.035000,0.127000> rotate<0,90.000000,0> translate<60.820200,0.000000,20.241800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.182100,0.000000,19.304000>}
box{<0,0,-0.127000><0.361900,0.035000,0.127000> rotate<0,0.000000,0> translate<60.820200,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.406400,0.000000,19.558000>}
box{<0,0,-0.127000><0.586200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.820200,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,19.812000>}
box{<0,0,-0.127000><1.651100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.820200,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,20.066000>}
box{<0,0,-0.127000><1.651100,0.035000,0.127000> rotate<0,0.000000,0> translate<60.820200,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.820200,0.000000,20.241800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.123500,0.000000,21.545200>}
box{<0,0,-0.127000><1.843215,0.035000,0.127000> rotate<0,-44.999228,0> translate<60.820200,0.000000,20.241800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.831200,0.000000,10.525200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,10.703700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.831200,0.000000,10.525200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.869000,-1.535000,17.767300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,17.767300>}
box{<0,0,-0.127000><3.096200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.869000,-1.535000,17.767300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.898300,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,20.320000>}
box{<0,0,-0.127000><1.573000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.898300,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,25.842100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172100,-1.535000,25.619000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<60.949000,-1.535000,25.842100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.673100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,25.842100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,-90.000000,0> translate<60.949000,-1.535000,25.842100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.673100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.102600,-1.535000,26.673100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<60.949000,-1.535000,26.673100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.926700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.102600,-1.535000,26.926700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<60.949000,-1.535000,26.926700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,27.757800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,26.926700>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,-90.000000,0> translate<60.949000,-1.535000,26.926700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.949000,-1.535000,27.757800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172100,-1.535000,27.980900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<60.949000,-1.535000,27.757800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.974000,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,10.668000>}
box{<0,0,-0.127000><1.356200,0.035000,0.127000> rotate<0,0.000000,0> translate<60.974000,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<60.996000,-1.535000,25.539600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.600000,-1.535000,25.539600>}
box{<0,0,-0.127000><6.604000,0.035000,0.127000> rotate<0,0.000000,0> translate<60.996000,-1.535000,25.539600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.008600,0.000000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,2.032000>}
box{<0,0,-0.127000><13.426100,0.035000,0.127000> rotate<0,0.000000,0> translate<61.008600,0.000000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,10.703700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,11.685100>}
box{<0,0,-0.127000><0.981400,0.035000,0.127000> rotate<0,90.000000,0> translate<61.009700,0.000000,11.685100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,10.922000>}
box{<0,0,-0.127000><1.320500,0.035000,0.127000> rotate<0,0.000000,0> translate<61.009700,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,11.176000>}
box{<0,0,-0.127000><1.320500,0.035000,0.127000> rotate<0,0.000000,0> translate<61.009700,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,11.430000>}
box{<0,0,-0.127000><1.320500,0.035000,0.127000> rotate<0,0.000000,0> translate<61.009700,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.343000,0.000000,11.684000>}
box{<0,0,-0.127000><1.333300,0.035000,0.127000> rotate<0,0.000000,0> translate<61.009700,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.009700,0.000000,11.685100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.012000,0.000000,12.687300>}
box{<0,0,-0.127000><1.417396,0.035000,0.127000> rotate<0,-44.994172,0> translate<61.009700,0.000000,11.685100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,18.771300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.203000,0.000000,18.491300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<61.087000,0.000000,18.771300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,19.074600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,18.771300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<61.087000,0.000000,18.771300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.087000,0.000000,19.074600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.203000,0.000000,19.354600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<61.087000,0.000000,19.074600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.152300,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,20.574000>}
box{<0,0,-0.127000><1.319000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.152300,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172100,-1.535000,25.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,25.619000>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.172100,-1.535000,25.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172100,-1.535000,27.980900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.980900>}
box{<0,0,-0.127000><0.931000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.172100,-1.535000,27.980900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<61.172200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<61.172200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<61.172200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.172200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<61.172200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.203000,0.000000,18.491300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.417300,0.000000,18.277000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<61.203000,0.000000,18.491300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.203000,0.000000,19.354600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.417300,0.000000,19.568900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<61.203000,0.000000,19.354600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.262600,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,2.286000>}
box{<0,0,-0.127000><13.172100,0.035000,0.127000> rotate<0,0.000000,0> translate<61.262600,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.262600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,11.938000>}
box{<0,0,-0.127000><2.351700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.262600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.294600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.165400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<61.294600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.294800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.165000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<61.294800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.294800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.181200,0.000000,28.702000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<61.294800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.294800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.165000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<61.294800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.406300,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,20.828000>}
box{<0,0,-0.127000><1.065000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.406300,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.417300,0.000000,18.277000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,18.261300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,22.446872,0> translate<61.417300,0.000000,18.277000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.417300,0.000000,19.568900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.697300,0.000000,19.684900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<61.417300,0.000000,19.568900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.423200,0.000000,22.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.423200,0.000000,22.245500>}
box{<0,0,-0.127000><0.114700,0.035000,0.127000> rotate<0,-90.000000,0> translate<61.423200,0.000000,22.245500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.423200,0.000000,22.360200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.526700,0.000000,22.610000>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,-67.489780,0> translate<61.423200,0.000000,22.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,18.261300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.455300,0.000000,13.244000>}
box{<0,0,-0.127000><5.017300,0.035000,0.127000> rotate<0,-90.000000,0> translate<61.455300,0.000000,13.244000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.516600,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,2.540000>}
box{<0,0,-0.127000><12.918100,0.035000,0.127000> rotate<0,0.000000,0> translate<61.516600,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.516600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,12.192000>}
box{<0,0,-0.127000><2.097700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.516600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.526700,0.000000,22.610000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.717900,0.000000,22.801200>}
box{<0,0,-0.127000><0.270398,0.035000,0.127000> rotate<0,-44.997030,0> translate<61.526700,0.000000,22.610000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<61.564200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<61.564200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.816900,0.000000,29.066400>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,-45.008364,0> translate<61.564200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.564200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<61.564200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.660300,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,21.082000>}
box{<0,0,-0.127000><0.811000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.660300,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.697300,0.000000,19.684900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.000600,0.000000,19.684900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<61.697300,0.000000,19.684900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.706500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.753400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<61.706500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.706500,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.927200,0.000000,28.956000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.706500,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.706600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.753300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.706600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.706600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.753300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.706600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.717900,0.000000,22.801200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.967700,0.000000,22.904700>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,-22.504281,0> translate<61.717900,0.000000,22.801200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.719100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<61.719100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.719100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.740800,-1.535000,31.991300>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<61.719100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.770600,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,2.794000>}
box{<0,0,-0.127000><12.664100,0.035000,0.127000> rotate<0,0.000000,0> translate<61.770600,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.770600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.342900,0.000000,12.446000>}
box{<0,0,-0.127000><0.572300,0.035000,0.127000> rotate<0,0.000000,0> translate<61.770600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.816900,0.000000,29.066400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,28.411900>}
box{<0,0,-0.127000><0.925532,0.035000,0.127000> rotate<0,45.001407,0> translate<61.816900,0.000000,29.066400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<61.864300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<61.864300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<61.864300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.864300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<61.864300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.904100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.555700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<61.904100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.904100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.555700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<61.904100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.904200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.555800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<61.904200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.904200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.555800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<61.904200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.914300,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,21.336000>}
box{<0,0,-0.127000><0.557000,0.035000,0.127000> rotate<0,0.000000,0> translate<61.914300,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<61.967700,0.000000,22.904700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.238200,0.000000,22.904700>}
box{<0,0,-0.127000><0.270500,0.035000,0.127000> rotate<0,0.000000,0> translate<61.967700,0.000000,22.904700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.000600,0.000000,19.684900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.280600,0.000000,19.568900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<62.000600,0.000000,19.684900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.009400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.450400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<62.009400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.009400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.450600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<62.009400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.009400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.450400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<62.009400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.009400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.450600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<62.009400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.012000,0.000000,12.687300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,12.917900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<62.012000,0.000000,12.687300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.024600,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,3.048000>}
box{<0,0,-0.127000><12.410100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.024600,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.024700,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,12.700000>}
box{<0,0,-0.127000><0.305500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.024700,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<62.026700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<62.026700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.026700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.026700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.102600,-1.535000,26.926700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.102600,-1.535000,26.673100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.102600,-1.535000,26.673100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,25.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.672600>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<62.103100,-1.535000,26.672600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,25.654000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,25.908000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.162000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.416000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.670000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.672600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.672600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,26.672600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.927300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.980900>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,90.000000,0> translate<62.103100,-1.535000,27.980900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,26.927300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.927300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,26.927300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.178000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.432000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.686000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.103100,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.940000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.103100,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.123500,0.000000,21.545200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.238200,0.000000,21.545200>}
box{<0,0,-0.127000><0.114700,0.035000,0.127000> rotate<0,0.000000,0> translate<62.123500,0.000000,21.545200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.238200,0.000000,21.545200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,21.641900>}
box{<0,0,-0.127000><0.252362,0.035000,0.127000> rotate<0,-22.529309,0> translate<62.238200,0.000000,21.545200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.238200,0.000000,22.904700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,22.808000>}
box{<0,0,-0.127000><0.252362,0.035000,0.127000> rotate<0,22.529309,0> translate<62.238200,0.000000,22.904700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,12.917900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,14.059800>}
box{<0,0,-0.127000><1.141900,0.035000,0.127000> rotate<0,90.000000,0> translate<62.242600,0.000000,14.059800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,12.954000>}
box{<0,0,-0.127000><0.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.242600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,13.208000>}
box{<0,0,-0.127000><0.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.242600,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,13.462000>}
box{<0,0,-0.127000><0.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.242600,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,13.716000>}
box{<0,0,-0.127000><0.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.242600,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,13.970000>}
box{<0,0,-0.127000><0.087600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.242600,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.242600,0.000000,14.059800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,14.023500>}
box{<0,0,-0.127000><0.094823,0.035000,0.127000> rotate<0,22.506828,0> translate<62.242600,0.000000,14.059800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.278600,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,3.302000>}
box{<0,0,-0.127000><12.156100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.278600,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.280600,0.000000,19.568900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,19.378100>}
box{<0,0,-0.127000><0.269761,0.035000,0.127000> rotate<0,45.012048,0> translate<62.280600,0.000000,19.568900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.291500,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,19.558000>}
box{<0,0,-0.127000><0.179800,0.035000,0.127000> rotate<0,0.000000,0> translate<62.291500,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,9.740200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<62.330200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,11.671200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,9.918700>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.330200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,11.671200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,11.849700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<62.330200,0.000000,11.671200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,12.458700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,12.280200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<62.330200,0.000000,12.458700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,14.023500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.330200,0.000000,12.458700>}
box{<0,0,-0.127000><1.564800,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.330200,0.000000,12.458700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.346000,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,22.860000>}
box{<0,0,-0.127000><0.125300,0.035000,0.127000> rotate<0,0.000000,0> translate<62.346000,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.346100,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,21.590000>}
box{<0,0,-0.127000><0.125200,0.035000,0.127000> rotate<0,0.000000,0> translate<62.346100,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,25.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287800,-1.535000,25.619000>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.356700,-1.535000,25.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.672600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,25.619000>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.356700,-1.535000,25.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.980900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,26.927300>}
box{<0,0,-0.127000><1.053600,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.356700,-1.535000,26.927300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.356700,-1.535000,27.980900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287800,-1.535000,27.980900>}
box{<0,0,-0.127000><0.931100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.356700,-1.535000,27.980900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.357300,-1.535000,26.673100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.357300,-1.535000,26.926700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<62.357300,-1.535000,26.926700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.357300,-1.535000,26.673100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.673100>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.357300,-1.535000,26.673100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.357300,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.389200,-1.535000,26.924000>}
box{<0,0,-0.127000><13.031900,0.035000,0.127000> rotate<0,0.000000,0> translate<62.357300,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.357300,-1.535000,26.926700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.926700>}
box{<0,0,-0.127000><1.153600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.357300,-1.535000,26.926700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<62.433200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.433200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<62.433200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<62.433200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.433200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.433200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<62.433200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,21.641900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,19.378100>}
box{<0,0,-0.127000><2.263800,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.471300,0.000000,19.378100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,28.411900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.471300,0.000000,22.808000>}
box{<0,0,-0.127000><5.603900,0.035000,0.127000> rotate<0,-90.000000,0> translate<62.471300,0.000000,22.808000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.833000,0.000000,9.740200>}
box{<0,0,-0.127000><1.324300,0.035000,0.127000> rotate<0,0.000000,0> translate<62.508700,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,11.849700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,11.849700>}
box{<0,0,-0.127000><1.105600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.508700,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.508700,0.000000,12.280200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,12.280200>}
box{<0,0,-0.127000><1.105600,0.035000,0.127000> rotate<0,0.000000,0> translate<62.508700,0.000000,12.280200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.532600,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,3.556000>}
box{<0,0,-0.127000><11.902100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.532600,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<62.595600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<62.595600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<62.595600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.595600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.740800,-1.535000,31.991300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<62.595600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.598200,-1.535000,22.691000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.598200,-1.535000,22.895200>}
box{<0,0,-0.127000><0.204200,0.035000,0.127000> rotate<0,90.000000,0> translate<62.598200,-1.535000,22.895200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.598200,-1.535000,22.691000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.679200,-1.535000,22.610000>}
box{<0,0,-0.127000><0.114551,0.035000,0.127000> rotate<0,44.997030,0> translate<62.598200,-1.535000,22.691000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.598200,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.859000,-1.535000,22.860000>}
box{<0,0,-0.127000><4.260800,0.035000,0.127000> rotate<0,0.000000,0> translate<62.598200,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.598200,-1.535000,22.895200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.256200,-1.535000,22.895200>}
box{<0,0,-0.127000><0.658000,0.035000,0.127000> rotate<0,0.000000,0> translate<62.598200,-1.535000,22.895200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.679200,-1.535000,22.610000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.360200>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,67.489780,0> translate<62.679200,-1.535000,22.610000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.680900,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.845100,-1.535000,22.606000>}
box{<0,0,-0.127000><4.164200,0.035000,0.127000> rotate<0,0.000000,0> translate<62.680900,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.686000,-1.535000,21.856600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.089700>}
box{<0,0,-0.127000><0.252362,0.035000,0.127000> rotate<0,-67.464751,0> translate<62.686000,-1.535000,21.856600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.686000,-1.535000,21.856600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,21.856600>}
box{<0,0,-0.127000><1.279200,0.035000,0.127000> rotate<0,0.000000,0> translate<62.686000,-1.535000,21.856600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.089700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.360200>}
box{<0,0,-0.127000><0.270500,0.035000,0.127000> rotate<0,90.000000,0> translate<62.782700,-1.535000,22.360200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,22.098000>}
box{<0,0,-0.127000><1.182500,0.035000,0.127000> rotate<0,0.000000,0> translate<62.782700,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.782700,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.071000,-1.535000,22.352000>}
box{<0,0,-0.127000><1.288300,0.035000,0.127000> rotate<0,0.000000,0> translate<62.782700,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.786600,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,3.810000>}
box{<0,0,-0.127000><11.648100,0.035000,0.127000> rotate<0,0.000000,0> translate<62.786600,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<62.895700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<62.895700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<62.895700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<62.895700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.040600,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,4.064000>}
box{<0,0,-0.127000><11.394100,0.035000,0.127000> rotate<0,0.000000,0> translate<63.040600,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.256200,-1.535000,22.895200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.073700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<63.256200,-1.535000,22.895200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,15.784000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,20.028800>}
box{<0,0,-0.127000><4.244800,0.035000,0.127000> rotate<0,90.000000,0> translate<63.258600,0.000000,20.028800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,15.784000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.652800,0.000000,14.389700>}
box{<0,0,-0.127000><1.971767,0.035000,0.127000> rotate<0,44.999085,0> translate<63.258600,0.000000,15.784000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.002000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.962900,0.000000,16.256000>}
box{<0,0,-0.127000><6.704300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.510000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.764000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,17.018000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,17.272000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,17.526000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,17.780000>}
box{<0,0,-0.127000><6.691600,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.963000,0.000000,18.034000>}
box{<0,0,-0.127000><6.704400,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.325400,0.000000,18.288000>}
box{<0,0,-0.127000><8.066800,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.579400,0.000000,18.542000>}
box{<0,0,-0.127000><8.320800,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.962900,0.000000,18.796000>}
box{<0,0,-0.127000><6.704300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.486300,0.000000,19.050000>}
box{<0,0,-0.127000><3.227700,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.261900,0.000000,19.304000>}
box{<0,0,-0.127000><3.003300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.558000>}
box{<0,0,-0.127000><2.908400,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.812000>}
box{<0,0,-0.127000><2.908400,0.035000,0.127000> rotate<0,0.000000,0> translate<63.258600,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.258600,0.000000,20.028800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.475300,0.000000,19.939000>}
box{<0,0,-0.127000><0.234570,0.035000,0.127000> rotate<0,22.507523,0> translate<63.258600,0.000000,20.028800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.654600,0.000000,5.791200>}
box{<0,0,-0.127000><0.366900,0.035000,0.127000> rotate<0,0.000000,0> translate<63.287700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.712200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<63.287700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.712200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<63.287700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287800,-1.535000,25.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,25.842100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<63.287800,-1.535000,25.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.287800,-1.535000,27.980900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,27.757800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<63.287800,-1.535000,27.980900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.294600,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,4.318000>}
box{<0,0,-0.127000><11.140100,0.035000,0.127000> rotate<0,0.000000,0> translate<63.294600,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.294600,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.359400,0.000000,15.748000>}
box{<0,0,-0.127000><3.064800,0.035000,0.127000> rotate<0,0.000000,0> translate<63.294600,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.322800,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.659200,-1.535000,25.654000>}
box{<0,0,-0.127000><13.336400,0.035000,0.127000> rotate<0,0.000000,0> translate<63.322800,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.328700,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.373200,-1.535000,27.940000>}
box{<0,0,-0.127000><11.044500,0.035000,0.127000> rotate<0,0.000000,0> translate<63.328700,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.073700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.380700>}
box{<0,0,-0.127000><0.307000,0.035000,0.127000> rotate<0,90.000000,0> translate<63.434700,-1.535000,23.380700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,-1.535000,23.114000>}
box{<0,0,-0.127000><3.322500,0.035000,0.127000> rotate<0,0.000000,0> translate<63.434700,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.609500,-1.535000,23.368000>}
box{<0,0,-0.127000><3.174800,0.035000,0.127000> rotate<0,0.000000,0> translate<63.434700,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.434700,-1.535000,23.380700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.596800,-1.535000,23.380700>}
box{<0,0,-0.127000><3.162100,0.035000,0.127000> rotate<0,0.000000,0> translate<63.434700,-1.535000,23.380700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.463900,-1.535000,16.141600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,16.642900>}
box{<0,0,-0.127000><0.708945,0.035000,0.127000> rotate<0,-44.997030,0> translate<63.463900,-1.535000,16.141600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.475300,0.000000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.778600,0.000000,19.939000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.475300,0.000000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,25.842100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.673100>}
box{<0,0,-0.127000><0.831000,0.035000,0.127000> rotate<0,90.000000,0> translate<63.510900,-1.535000,26.673100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.405200,-1.535000,25.908000>}
box{<0,0,-0.127000><12.894300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.151200,-1.535000,26.162000>}
box{<0,0,-0.127000><12.640300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.897200,-1.535000,26.416000>}
box{<0,0,-0.127000><12.386300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.643200,-1.535000,26.670000>}
box{<0,0,-0.127000><12.132300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,26.926700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,27.757800>}
box{<0,0,-0.127000><0.831100,0.035000,0.127000> rotate<0,90.000000,0> translate<63.510900,-1.535000,27.757800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.135200,-1.535000,27.178000>}
box{<0,0,-0.127000><11.624300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.881200,-1.535000,27.432000>}
box{<0,0,-0.127000><11.370300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.510900,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.627200,-1.535000,27.686000>}
box{<0,0,-0.127000><11.116300,0.035000,0.127000> rotate<0,0.000000,0> translate<63.510900,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.548600,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.355700,0.000000,4.572000>}
box{<0,0,-0.127000><7.807100,0.035000,0.127000> rotate<0,0.000000,0> translate<63.548600,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.548600,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.209500,0.000000,15.494000>}
box{<0,0,-0.127000><2.660900,0.035000,0.127000> rotate<0,0.000000,0> translate<63.548600,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,12.028900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,11.849700>}
box{<0,0,-0.127000><0.179200,0.035000,0.127000> rotate<0,-90.000000,0> translate<63.614300,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,12.280200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.614300,0.000000,12.028900>}
box{<0,0,-0.127000><0.251300,0.035000,0.127000> rotate<0,-90.000000,0> translate<63.614300,0.000000,12.028900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.712200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.754000,0.000000,9.431300>}
box{<0,0,-0.127000><0.045277,0.035000,0.127000> rotate<0,22.598905,0> translate<63.712200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.712200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.104200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<63.712200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.754000,0.000000,9.549600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.754000,0.000000,9.431300>}
box{<0,0,-0.127000><0.118300,0.035000,0.127000> rotate<0,-90.000000,0> translate<63.754000,0.000000,9.431300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.754000,0.000000,9.549600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.833000,0.000000,9.740200>}
box{<0,0,-0.127000><0.206323,0.035000,0.127000> rotate<0,-67.482488,0> translate<63.754000,0.000000,9.549600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.778600,0.000000,19.939000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.058600,0.000000,20.055000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<63.778600,0.000000,19.939000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.802600,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,4.826000>}
box{<0,0,-0.127000><7.387200,0.035000,0.127000> rotate<0,0.000000,0> translate<63.802600,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.802600,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,15.240000>}
box{<0,0,-0.127000><2.364400,0.035000,0.127000> rotate<0,0.000000,0> translate<63.802600,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.834800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.705000,-1.535000,28.702000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<63.834800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.893600,0.000000,32.233500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.893600,0.000000,32.372300>}
box{<0,0,-0.127000><0.138800,0.035000,0.127000> rotate<0,90.000000,0> translate<63.893600,0.000000,32.372300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.893600,0.000000,32.233500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.104200,0.000000,32.146300>}
box{<0,0,-0.127000><0.227939,0.035000,0.127000> rotate<0,22.490765,0> translate<63.893600,0.000000,32.233500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.893600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.705400,0.000000,32.258000>}
box{<0,0,-0.127000><1.811800,0.035000,0.127000> rotate<0,0.000000,0> translate<63.893600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.893600,0.000000,32.372300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.322300,0.000000,32.372300>}
box{<0,0,-0.127000><4.428700,0.035000,0.127000> rotate<0,0.000000,0> translate<63.893600,0.000000,32.372300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,17.767300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,16.642900>}
box{<0,0,-0.127000><1.124400,0.035000,0.127000> rotate<0,-90.000000,0> translate<63.965200,-1.535000,16.642900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,22.246200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,21.856600>}
box{<0,0,-0.127000><0.389600,0.035000,0.127000> rotate<0,-90.000000,0> translate<63.965200,-1.535000,21.856600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<63.965200,-1.535000,22.246200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.143700,-1.535000,22.424700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<63.965200,-1.535000,22.246200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.056600,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.080000>}
box{<0,0,-0.127000><7.133200,0.035000,0.127000> rotate<0,0.000000,0> translate<64.056600,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.056600,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.209300,0.000000,14.986000>}
box{<0,0,-0.127000><2.152700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.056600,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.058600,0.000000,20.055000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.272900,0.000000,20.269300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<64.058600,0.000000,20.055000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.069600,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.262100,0.000000,20.066000>}
box{<0,0,-0.127000><2.192500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.069600,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.104200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<64.104200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.104200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<64.104200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.143700,-1.535000,22.424700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,22.424700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.143700,-1.535000,22.424700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.215300,-1.535000,15.779700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.405900,-1.535000,15.970200>}
box{<0,0,-0.127000><0.269478,0.035000,0.127000> rotate<0,-44.981997,0> translate<64.215300,-1.535000,15.779700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.215300,-1.535000,15.779700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.446200,-1.535000,15.779700>}
box{<0,0,-0.127000><0.230900,0.035000,0.127000> rotate<0,0.000000,0> translate<64.215300,-1.535000,15.779700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.228200,-1.535000,20.224700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.272900,-1.535000,20.269300>}
box{<0,0,-0.127000><0.063145,0.035000,0.127000> rotate<0,-44.932873,0> translate<64.228200,-1.535000,20.224700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.228200,-1.535000,20.224700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.446200,-1.535000,20.224700>}
box{<0,0,-0.127000><0.218000,0.035000,0.127000> rotate<0,0.000000,0> translate<64.228200,-1.535000,20.224700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.246500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.293400,0.000000,32.004000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<64.246500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.246600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.293300,-1.535000,28.956000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.246600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.259100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<64.259100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.259100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.280800,-1.535000,31.991300>}
box{<0,0,-0.127000><1.021700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.259100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.272900,-1.535000,20.269300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.333300,-1.535000,20.415200>}
box{<0,0,-0.127000><0.157908,0.035000,0.127000> rotate<0,-67.506861,0> translate<64.272900,-1.535000,20.269300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.272900,0.000000,20.269300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.549300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<64.272900,0.000000,20.269300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.293800,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.486400,-1.535000,20.320000>}
box{<0,0,-0.127000><2.192600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.293800,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.293900,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.486400,0.000000,20.320000>}
box{<0,0,-0.127000><2.192500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.293900,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.310600,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.334000>}
box{<0,0,-0.127000><6.879200,0.035000,0.127000> rotate<0,0.000000,0> translate<64.310600,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.310600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.359300,0.000000,14.732000>}
box{<0,0,-0.127000><2.048700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.310600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.333300,-1.535000,20.415200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,20.415200>}
box{<0,0,-0.127000><1.062900,0.035000,0.127000> rotate<0,0.000000,0> translate<64.333300,-1.535000,20.415200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.373100,0.000000,20.890500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.852600>}
box{<0,0,-0.127000><0.041062,0.035000,0.127000> rotate<0,67.364955,0> translate<64.373100,0.000000,20.890500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.373100,0.000000,20.890500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.552000,0.000000,21.069300>}
box{<0,0,-0.127000><0.252932,0.035000,0.127000> rotate<0,-44.981013,0> translate<64.373100,0.000000,20.890500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.549300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.852600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<64.388900,0.000000,20.852600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.963000,0.000000,20.574000>}
box{<0,0,-0.127000><5.574100,0.035000,0.127000> rotate<0,0.000000,0> translate<64.388900,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.388900,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.579200,0.000000,20.828000>}
box{<0,0,-0.127000><7.190300,0.035000,0.127000> rotate<0,0.000000,0> translate<64.388900,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<64.404300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<64.404300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.404300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<64.404300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.405900,-1.535000,15.970200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,15.970200>}
box{<0,0,-0.127000><0.990300,0.035000,0.127000> rotate<0,0.000000,0> translate<64.405900,-1.535000,15.970200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.444100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.095700,-1.535000,29.210000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.444100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.444200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.095800,0.000000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.444200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.444200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.095800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.444200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.446200,-1.535000,15.779700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.601200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<64.446200,-1.535000,15.779700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.446200,-1.535000,20.224700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,20.046200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<64.446200,-1.535000,20.224700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.477900,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.062000,-1.535000,15.748000>}
box{<0,0,-0.127000><0.584100,0.035000,0.127000> rotate<0,0.000000,0> translate<64.477900,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.549400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.990400,-1.535000,29.464000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<64.549400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.549400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.990600,0.000000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<64.549400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.549400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.990600,-1.535000,31.496000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<64.549400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.552000,0.000000,21.069300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,21.299900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<64.552000,0.000000,21.069300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.564600,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,0.000000,5.588000>}
box{<0,0,-0.127000><7.697900,0.035000,0.127000> rotate<0,0.000000,0> translate<64.564600,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.564600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,14.478000>}
box{<0,0,-0.127000><2.212700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.564600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.564700,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.325200,0.000000,21.082000>}
box{<0,0,-0.127000><6.760500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.564700,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<64.566700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,31.454200>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<64.566700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,29.563300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,29.969900>}
box{<0,0,-0.127000><0.574949,0.035000,0.127000> rotate<0,-45.004076,0> translate<64.566700,0.000000,29.563300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.721400,0.000000,29.718000>}
box{<0,0,-0.127000><0.154700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,29.718000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,29.972000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,30.226000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,30.480000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,30.734000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,30.988000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.566700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,31.242000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.566700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.604900,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.935000,-1.535000,20.066000>}
box{<0,0,-0.127000><0.330100,0.035000,0.127000> rotate<0,0.000000,0> translate<64.604900,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.125600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.601200>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,90.000000,0> translate<64.624700,-1.535000,15.601200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.125600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.125600>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.624700,-1.535000,15.125600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.240000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.624700,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.494000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.624700,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,19.570600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,20.046200>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,90.000000,0> translate<64.624700,-1.535000,20.046200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,19.570600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,19.570600>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.624700,-1.535000,19.570600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.624700,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,19.812000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.624700,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.652800,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.761200,0.000000,14.389700>}
box{<0,0,-0.127000><1.108400,0.035000,0.127000> rotate<0,0.000000,0> translate<64.652800,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,21.299900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,23.769000>}
box{<0,0,-0.127000><2.469100,0.035000,0.127000> rotate<0,90.000000,0> translate<64.782600,0.000000,23.769000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.962900,0.000000,21.336000>}
box{<0,0,-0.127000><5.180300,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,21.590000>}
box{<0,0,-0.127000><5.167600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,21.844000>}
box{<0,0,-0.127000><5.167600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,22.098000>}
box{<0,0,-0.127000><5.167600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,22.352000>}
box{<0,0,-0.127000><5.167600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.193500,0.000000,22.606000>}
box{<0,0,-0.127000><2.410900,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.859000,0.000000,22.860000>}
box{<0,0,-0.127000><2.076400,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.114000>}
box{<0,0,-0.127000><1.974600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.368000>}
box{<0,0,-0.127000><1.974600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.859100,0.000000,23.622000>}
box{<0,0,-0.127000><2.076500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,23.769000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,23.769000>}
box{<0,0,-0.127000><1.350500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,23.769000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,28.665900>}
box{<0,0,-0.127000><1.635000,0.035000,0.127000> rotate<0,90.000000,0> translate<64.782600,0.000000,28.665900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,27.030900>}
box{<0,0,-0.127000><1.350500,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,27.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.005200,0.000000,27.178000>}
box{<0,0,-0.127000><3.222600,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.011000,0.000000,27.432000>}
box{<0,0,-0.127000><3.228400,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.293300,0.000000,27.686000>}
box{<0,0,-0.127000><4.510700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,27.940000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,28.194000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,28.448000>}
box{<0,0,-0.127000><4.546700,0.035000,0.127000> rotate<0,0.000000,0> translate<64.782600,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.782600,0.000000,28.665900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.183000,0.000000,29.066400>}
box{<0,0,-0.127000><0.566322,0.035000,0.127000> rotate<0,-45.004184,0> translate<64.782600,0.000000,28.665900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.818600,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.705000,0.000000,5.842000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<64.818600,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.818600,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.705000,0.000000,28.702000>}
box{<0,0,-0.127000><0.886400,0.035000,0.127000> rotate<0,0.000000,0> translate<64.818600,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.601200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.125600>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,-90.000000,0> translate<64.915200,-1.535000,15.125600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,15.601200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.093700,-1.535000,15.779700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<64.915200,-1.535000,15.601200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,20.046200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,19.570600>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,-90.000000,0> translate<64.915200,-1.535000,19.570600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.915200,-1.535000,20.046200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.093700,-1.535000,20.224700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<64.915200,-1.535000,20.046200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<64.973200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,29.505700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<64.973200,-1.535000,29.505700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,29.969900>}
box{<0,0,-0.127000><1.484300,0.035000,0.127000> rotate<0,-90.000000,0> translate<64.973200,0.000000,29.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,0.000000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,0.000000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<64.973200,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<64.973200,-1.535000,31.454200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,-1.535000,31.846200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<64.973200,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.072600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.293300,0.000000,6.096000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<65.072600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.072600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.293300,0.000000,28.956000>}
box{<0,0,-0.127000><0.220700,0.035000,0.127000> rotate<0,0.000000,0> translate<65.072600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.093700,-1.535000,15.779700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.346200,-1.535000,15.779700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.093700,-1.535000,15.779700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.093700,-1.535000,20.224700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.346200,-1.535000,20.224700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.093700,-1.535000,20.224700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<65.135600,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.280800,-1.535000,31.991300>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,-44.977295,0> translate<65.135600,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.135600,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,32.146300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<65.135600,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.183000,0.000000,6.206400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,5.953600>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,45.008364,0> translate<65.183000,0.000000,6.206400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.183000,0.000000,29.066400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,28.813600>}
box{<0,0,-0.127000><0.357442,0.035000,0.127000> rotate<0,45.008364,0> translate<65.183000,0.000000,29.066400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.194500,0.000000,9.045000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.277900,0.000000,9.246300>}
box{<0,0,-0.127000><0.217893,0.035000,0.127000> rotate<0,-67.490976,0> translate<65.194500,0.000000,9.045000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.194500,0.000000,9.045000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,9.286300>}
box{<0,0,-0.127000><0.341179,0.035000,0.127000> rotate<0,-45.008904,0> translate<65.194500,0.000000,9.045000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.198900,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.277900,0.000000,9.549600>}
box{<0,0,-0.127000><0.206323,0.035000,0.127000> rotate<0,67.482488,0> translate<65.198900,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.198900,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.761200,0.000000,9.740200>}
box{<0,0,-0.127000><0.562300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.198900,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.235500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.293500,0.000000,9.144000>}
box{<0,0,-0.127000><0.058000,0.035000,0.127000> rotate<0,0.000000,0> translate<65.235500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.235500,0.000000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,9.652000>}
box{<0,0,-0.127000><12.729800,0.035000,0.127000> rotate<0,0.000000,0> translate<65.235500,0.000000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.277900,0.000000,9.246300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.277900,0.000000,9.549600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<65.277900,0.000000,9.549600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.277900,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.705400,0.000000,9.398000>}
box{<0,0,-0.127000><0.427500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.277900,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,15.970200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,16.148700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<65.396200,-1.535000,15.970200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,20.415200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,20.593700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<65.396200,-1.535000,20.415200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.396200,-1.535000,22.424700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,22.246200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<65.396200,-1.535000,22.424700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.428000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.002000>}
box{<0,0,-0.127000><1.397200,0.035000,0.127000> rotate<0,0.000000,0> translate<65.428000,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<65.435700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<65.435700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<65.435700,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<65.435700,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.435700,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,32.308700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<65.435700,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.468900,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,22.352000>}
box{<0,0,-0.127000><1.356300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.468900,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.555000,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,20.574000>}
box{<0,0,-0.127000><11.426000,0.035000,0.127000> rotate<0,0.000000,0> translate<65.555000,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,16.148700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,17.767300>}
box{<0,0,-0.127000><1.618600,0.035000,0.127000> rotate<0,90.000000,0> translate<65.574700,-1.535000,17.767300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.256000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.510000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.764000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,17.018000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,17.272000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.845000,-1.535000,17.526000>}
box{<0,0,-0.127000><1.270300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,17.767300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.108000,-1.535000,17.767300>}
box{<0,0,-0.127000><2.533300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,17.767300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,20.593700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,22.246200>}
box{<0,0,-0.127000><1.652500,0.035000,0.127000> rotate<0,90.000000,0> translate<65.574700,-1.535000,22.246200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.930900,-1.535000,20.828000>}
box{<0,0,-0.127000><1.356200,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,21.082000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,21.336000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,21.590000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,21.844000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.574700,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,22.098000>}
box{<0,0,-0.127000><1.250500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.574700,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.761200,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,9.918700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<65.761200,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.761200,0.000000,14.389700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,14.211200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<65.761200,0.000000,14.389700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.827700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.827700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.827700,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,-1.535000,28.651200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.827700,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.827700,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,32.308700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.827700,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.926900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.089900,0.000000,14.224000>}
box{<0,0,-0.127000><4.163000,0.035000,0.127000> rotate<0,0.000000,0> translate<65.926900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.927000,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.152900,0.000000,9.906000>}
box{<0,0,-0.127000><0.225900,0.035000,0.127000> rotate<0,0.000000,0> translate<65.927000,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,11.354600>}
box{<0,0,-0.127000><1.435900,0.035000,0.127000> rotate<0,90.000000,0> translate<65.939700,0.000000,11.354600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,10.160000>}
box{<0,0,-0.127000><0.200500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,10.414000>}
box{<0,0,-0.127000><0.200500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,10.668000>}
box{<0,0,-0.127000><0.200500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,10.922000>}
box{<0,0,-0.127000><0.200500,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.118300,0.000000,11.176000>}
box{<0,0,-0.127000><0.178600,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,11.354600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,11.154100>}
box{<0,0,-0.127000><0.283550,0.035000,0.127000> rotate<0,44.997030,0> translate<65.939700,0.000000,11.354600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,12.467800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,14.211200>}
box{<0,0,-0.127000><1.743400,0.035000,0.127000> rotate<0,90.000000,0> translate<65.939700,0.000000,14.211200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,12.467800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.557800,0.000000,11.849700>}
box{<0,0,-0.127000><0.874125,0.035000,0.127000> rotate<0,44.997030,0> translate<65.939700,0.000000,12.467800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.265300,0.000000,12.700000>}
box{<0,0,-0.127000><10.325600,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.115300,0.000000,12.954000>}
box{<0,0,-0.127000><10.175600,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.073000,0.000000,13.208000>}
box{<0,0,-0.127000><10.133300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.115500,0.000000,13.462000>}
box{<0,0,-0.127000><10.175800,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.265400,0.000000,13.716000>}
box{<0,0,-0.127000><10.325700,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.939700,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,13.970000>}
box{<0,0,-0.127000><11.041300,0.035000,0.127000> rotate<0,0.000000,0> translate<65.939700,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<65.961500,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,0.000000,12.446000>}
box{<0,0,-0.127000><10.721800,0.035000,0.127000> rotate<0,0.000000,0> translate<65.961500,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,23.769000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.272600>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,90.000000,0> translate<66.133100,0.000000,25.272600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,23.876000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,24.130000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,24.384000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,24.638000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,24.892000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.146000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.272600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.272600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,25.272600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.527300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,27.030900>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,90.000000,0> translate<66.133100,0.000000,27.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.527300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.527300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,25.527300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.654000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.908000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,26.162000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,26.416000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,26.670000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.133100,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,26.924000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.133100,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,9.918700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.318700,0.000000,9.740200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<66.140200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,11.154100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.140200,0.000000,9.918700>}
box{<0,0,-0.127000><1.235400,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.140200,0.000000,9.918700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,15.088300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,14.808300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<66.167000,0.000000,15.088300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,15.391600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,15.088300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.167000,0.000000,15.088300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,15.391600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,15.671600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<66.167000,0.000000,15.391600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.533300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,19.253300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<66.167000,0.000000,19.533300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.836600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.533300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.167000,0.000000,19.533300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.167000,0.000000,19.836600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,20.116600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<66.167000,0.000000,19.836600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.215500,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.294200,0.000000,12.192000>}
box{<0,0,-0.127000><11.078700,0.035000,0.127000> rotate<0,0.000000,0> translate<66.215500,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.252200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<66.252200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.252200,0.000000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,-1.535000,28.651200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,-1.535000,28.813600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.252200,-1.535000,28.651200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.252200,0.000000,32.308700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,32.146300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<66.252200,0.000000,32.308700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,14.808300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,14.594000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<66.283000,0.000000,14.808300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,15.671600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,15.885900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.283000,0.000000,15.671600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,19.253300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,19.039000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<66.283000,0.000000,19.253300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.283000,0.000000,20.116600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,20.330900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.283000,0.000000,20.116600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.318700,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.871200,0.000000,9.740200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<66.318700,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.346200,-1.535000,15.779700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.368600,-1.535000,15.757200>}
box{<0,0,-0.127000><0.031749,0.035000,0.127000> rotate<0,45.124629,0> translate<66.346200,-1.535000,15.779700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.346200,-1.535000,20.224700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.368600,-1.535000,20.202200>}
box{<0,0,-0.127000><0.031749,0.035000,0.127000> rotate<0,45.124629,0> translate<66.346200,-1.535000,20.224700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.368600,-1.535000,15.757200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,-1.535000,15.885900>}
box{<0,0,-0.127000><0.182009,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.368600,-1.535000,15.757200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.368600,-1.535000,20.202200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,-1.535000,20.330900>}
box{<0,0,-0.127000><0.182009,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.368600,-1.535000,20.202200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.374600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.245400,0.000000,9.398000>}
box{<0,0,-0.127000><1.870800,0.035000,0.127000> rotate<0,0.000000,0> translate<66.374600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.374600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.046300,0.000000,32.258000>}
box{<0,0,-0.127000><1.671700,0.035000,0.127000> rotate<0,0.000000,0> translate<66.374600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.374800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.245000,0.000000,5.842000>}
box{<0,0,-0.127000><1.870200,0.035000,0.127000> rotate<0,0.000000,0> translate<66.374800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.374800,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.045900,0.000000,28.702000>}
box{<0,0,-0.127000><1.671100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.374800,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.374800,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.045900,-1.535000,28.702000>}
box{<0,0,-0.127000><1.671100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.374800,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,23.769000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003800,0.000000,23.769000>}
box{<0,0,-0.127000><0.617100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.386700,0.000000,23.769000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.272600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,23.769000>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.386700,0.000000,23.769000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,27.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,25.527300>}
box{<0,0,-0.127000><1.503600,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.386700,0.000000,25.527300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.386700,0.000000,27.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.917800,0.000000,27.030900>}
box{<0,0,-0.127000><1.531100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.386700,0.000000,27.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.387300,0.000000,25.273100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.387300,0.000000,25.526700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<66.387300,0.000000,25.526700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.387300,0.000000,25.273100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.273100>}
box{<0,0,-0.127000><1.541700,0.035000,0.127000> rotate<0,0.000000,0> translate<66.387300,0.000000,25.273100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.387300,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986300,0.000000,25.400000>}
box{<0,0,-0.127000><2.599000,0.035000,0.127000> rotate<0,0.000000,0> translate<66.387300,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.387300,0.000000,25.526700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.526700>}
box{<0,0,-0.127000><1.541700,0.035000,0.127000> rotate<0,0.000000,0> translate<66.387300,0.000000,25.526700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.469500,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,11.938000>}
box{<0,0,-0.127000><10.945200,0.035000,0.127000> rotate<0,0.000000,0> translate<66.469500,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,14.594000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,14.478000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<66.497300,0.000000,14.594000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,15.885900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,16.001900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.497300,0.000000,15.885900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,-1.535000,15.885900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,-1.535000,16.001900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.497300,-1.535000,15.885900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,19.039000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,18.923000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<66.497300,0.000000,19.039000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,0.000000,20.330900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,20.446900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.497300,0.000000,20.330900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.497300,-1.535000,20.330900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,-1.535000,20.446900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<66.497300,-1.535000,20.330900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.557800,0.000000,11.849700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.871200,0.000000,11.849700>}
box{<0,0,-0.127000><1.313400,0.035000,0.127000> rotate<0,0.000000,0> translate<66.557800,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.596800,-1.535000,23.380700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,-1.535000,23.220300>}
box{<0,0,-0.127000><0.226840,0.035000,0.127000> rotate<0,44.997030,0> translate<66.596800,-1.535000,23.380700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.644200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<66.644200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.644200,0.000000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,-1.535000,28.813600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,-1.535000,29.113700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.644200,-1.535000,28.813600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.644200,0.000000,32.146300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,31.846200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<66.644200,0.000000,32.146300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.105700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,0.000000,22.855900>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,67.489780,0> translate<66.757200,0.000000,23.105700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,-1.535000,23.105700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,-1.535000,22.855900>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,67.489780,0> translate<66.757200,-1.535000,23.105700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,-1.535000,23.220300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,-1.535000,23.105700>}
box{<0,0,-0.127000><0.114600,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.757200,-1.535000,23.105700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.376200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.105700>}
box{<0,0,-0.127000><0.270500,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.757200,0.000000,23.105700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.757200,0.000000,23.376200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,0.000000,23.626000>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,-67.489780,0> translate<66.757200,0.000000,23.376200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,14.478000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,-1.535000,16.001900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.001900>}
box{<0,0,-0.127000><0.047900,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,-1.535000,16.001900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,16.001900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,16.001900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,0.000000,16.001900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,18.923000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,18.923000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,0.000000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,0.000000,20.446900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,20.446900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,0.000000,20.446900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.777300,-1.535000,20.446900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,-1.535000,20.446900>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<66.777300,-1.535000,20.446900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.786500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.833400,0.000000,9.144000>}
box{<0,0,-0.127000><1.046900,0.035000,0.127000> rotate<0,0.000000,0> translate<66.786500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.786500,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.725600,0.000000,32.004000>}
box{<0,0,-0.127000><0.939100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.786500,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.786600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.833300,0.000000,6.096000>}
box{<0,0,-0.127000><1.046700,0.035000,0.127000> rotate<0,0.000000,0> translate<66.786600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.786600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.725500,0.000000,28.956000>}
box{<0,0,-0.127000><0.938900,0.035000,0.127000> rotate<0,0.000000,0> translate<66.786600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.786600,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.725500,-1.535000,28.956000>}
box{<0,0,-0.127000><0.938900,0.035000,0.127000> rotate<0,0.000000,0> translate<66.786600,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.799100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,-1.535000,31.846200>}
box{<0,0,-0.127000><0.205273,0.035000,0.127000> rotate<0,44.977295,0> translate<66.799100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.799100,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.713000,-1.535000,31.991300>}
box{<0,0,-0.127000><0.913900,0.035000,0.127000> rotate<0,0.000000,0> translate<66.799100,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,17.506200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,16.001900>}
box{<0,0,-0.127000><1.504300,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.825200,-1.535000,16.001900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,17.506200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003700,-1.535000,17.684700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<66.825200,-1.535000,17.506200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,20.933700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003700,-1.535000,20.755200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<66.825200,-1.535000,20.933700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,22.586200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,20.933700>}
box{<0,0,-0.127000><1.652500,0.035000,0.127000> rotate<0,-90.000000,0> translate<66.825200,-1.535000,20.933700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.825200,-1.535000,22.586200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.977900,-1.535000,22.738800>}
box{<0,0,-0.127000><0.215880,0.035000,0.127000> rotate<0,-44.978264,0> translate<66.825200,-1.535000,22.586200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,-1.535000,22.855900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.977900,-1.535000,22.738800>}
box{<0,0,-0.127000><0.165675,0.035000,0.127000> rotate<0,44.972578,0> translate<66.860700,-1.535000,22.855900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,0.000000,22.855900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.051900,0.000000,22.664700>}
box{<0,0,-0.127000><0.270398,0.035000,0.127000> rotate<0,44.997030,0> translate<66.860700,0.000000,22.855900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.860700,0.000000,23.626000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003800,0.000000,23.769000>}
box{<0,0,-0.127000><0.202303,0.035000,0.127000> rotate<0,-44.977005,0> translate<66.860700,0.000000,23.626000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<66.944300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<66.944300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<66.944300,0.000000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,-1.535000,29.113700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,29.505700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<66.944300,-1.535000,29.113700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,0.000000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<66.944300,0.000000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.944300,-1.535000,31.846200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,31.454200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<66.944300,-1.535000,31.846200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.635700,0.000000,6.350000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.553200,0.000000,29.210000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.553200,-1.535000,29.210000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.635800,0.000000,8.890000>}
box{<0,0,-0.127000><0.651600,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984200,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.553300,0.000000,31.750000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984200,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<66.984200,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.553300,-1.535000,31.750000>}
box{<0,0,-0.127000><0.569100,0.035000,0.127000> rotate<0,0.000000,0> translate<66.984200,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003700,-1.535000,17.684700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,17.684700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.003700,-1.535000,17.684700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.003700,-1.535000,20.755200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,20.755200>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.003700,-1.535000,20.755200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.051900,0.000000,22.664700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.301700,0.000000,22.561200>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,22.504281,0> translate<67.051900,0.000000,22.664700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,14.594000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<67.080600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.478000>}
box{<0,0,-0.127000><2.869600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.080600,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,16.001900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,15.885900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<67.080600,0.000000,16.001900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,18.923000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,19.039000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<67.080600,0.000000,18.923000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,-1.535000,20.446900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.356500,-1.535000,20.332600>}
box{<0,0,-0.127000><0.298639,0.035000,0.127000> rotate<0,22.501790,0> translate<67.080600,-1.535000,20.446900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.080600,0.000000,20.446900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,20.330900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<67.080600,0.000000,20.446900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.530400,0.000000,6.604000>}
box{<0,0,-0.127000><0.441000,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.530600,0.000000,8.636000>}
box{<0,0,-0.127000><0.441200,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.448000,0.000000,29.464000>}
box{<0,0,-0.127000><0.358600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.448000,-1.535000,29.464000>}
box{<0,0,-0.127000><0.358600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.448100,0.000000,31.496000>}
box{<0,0,-0.127000><0.358700,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.089400,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.448100,-1.535000,31.496000>}
box{<0,0,-0.127000><0.358700,0.035000,0.127000> rotate<0,0.000000,0> translate<67.089400,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<67.106700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,6.858000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,7.112000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,7.366000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,7.620000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,7.874000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,8.128000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,8.382000>}
box{<0,0,-0.127000><0.406500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<67.106700,0.000000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,29.505700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,31.454200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<67.106700,-1.535000,31.454200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,29.718000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,29.718000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,29.972000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,29.972000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.226000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.226000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,0.000000,30.480000>}
box{<0,0,-0.127000><1.345800,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,-1.535000,30.480000>}
box{<0,0,-0.127000><1.345800,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.734000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.734000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.988000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.988000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,31.242000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.106700,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,31.242000>}
box{<0,0,-0.127000><0.330300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.106700,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.301700,0.000000,22.561200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.572200,0.000000,22.561200>}
box{<0,0,-0.127000><0.270500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.301700,0.000000,22.561200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.356500,-1.535000,20.332600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,20.332600>}
box{<0,0,-0.127000><9.624500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.356500,-1.535000,20.332600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,14.594000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,14.808300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.360600,0.000000,14.594000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,15.885900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,15.671600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<67.360600,0.000000,15.885900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,19.039000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,19.253300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.360600,0.000000,19.039000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.360600,0.000000,20.330900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,20.116600>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<67.360600,0.000000,20.330900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.371500,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,20.320000>}
box{<0,0,-0.127000><2.578700,0.035000,0.127000> rotate<0,0.000000,0> translate<67.371500,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.371600,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,19.050000>}
box{<0,0,-0.127000><2.578600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.371600,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,29.490600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,0.000000,29.070500>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<67.437000,0.000000,29.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,29.490600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,-1.535000,29.070500>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<67.437000,-1.535000,29.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,29.490600>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.437000,0.000000,29.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,29.490600>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.437000,-1.535000,29.490600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,0.000000,30.353000>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.437000,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,-1.535000,30.353000>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.437000,-1.535000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,0.000000,30.606800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.437000,0.000000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,-1.535000,30.606800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<67.437000,-1.535000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,31.469300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,30.606800>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.437000,0.000000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,31.469300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,30.606800>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.437000,-1.535000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,0.000000,31.469300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,0.000000,31.889400>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<67.437000,0.000000,31.469300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.437000,-1.535000,31.469300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,-1.535000,31.889400>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<67.437000,-1.535000,31.469300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.498500,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,15.748000>}
box{<0,0,-0.127000><2.451700,0.035000,0.127000> rotate<0,0.000000,0> translate<67.498500,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.498600,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.732000>}
box{<0,0,-0.127000><2.451600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.498600,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.675600,0.000000,6.253700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<67.513200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,6.645700>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.513200,0.000000,6.645700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.513200,0.000000,8.594200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.675600,0.000000,8.986200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<67.513200,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.572200,0.000000,22.561200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.822000,0.000000,22.664700>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,-22.504281,0> translate<67.572200,0.000000,22.561200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,14.808300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,14.846300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<67.574900,0.000000,14.808300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,15.671600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,15.633600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<67.574900,0.000000,15.671600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,19.253300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,19.291300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,-67.547189,0> translate<67.574900,0.000000,19.253300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.574900,0.000000,20.116600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,20.078600>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<67.574900,0.000000,20.116600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,14.846300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.846300>}
box{<0,0,-0.127000><2.359600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.590600,0.000000,14.846300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,15.633600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,15.633600>}
box{<0,0,-0.127000><2.359600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.590600,0.000000,15.633600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,19.291300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,19.291300>}
box{<0,0,-0.127000><2.359600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.590600,0.000000,19.291300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.590600,0.000000,20.078600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,20.078600>}
box{<0,0,-0.127000><2.359600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.590600,0.000000,20.078600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.600000,-1.535000,25.539600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.830600,-1.535000,25.309000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<67.600000,-1.535000,25.539600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,0.000000,29.070500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,0.000000,28.749000>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<67.611000,0.000000,29.070500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,-1.535000,29.070500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,-1.535000,28.749000>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,44.997030,0> translate<67.611000,-1.535000,29.070500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,-1.535000,31.889400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.713000,-1.535000,31.991300>}
box{<0,0,-0.127000><0.144179,0.035000,0.127000> rotate<0,-44.968932,0> translate<67.611000,-1.535000,31.889400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.611000,0.000000,31.889400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,0.000000,32.210900>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.611000,0.000000,31.889400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.675600,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.975700,0.000000,5.953600>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<67.675600,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.675600,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.975700,0.000000,9.286300>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.675600,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.680300,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,22.606000>}
box{<0,0,-0.127000><2.269900,0.035000,0.127000> rotate<0,0.000000,0> translate<67.680300,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.739600,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.913200,-1.535000,25.400000>}
box{<0,0,-0.127000><9.173600,0.035000,0.127000> rotate<0,0.000000,0> translate<67.739600,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.822000,0.000000,22.664700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.013200,0.000000,22.855900>}
box{<0,0,-0.127000><0.270398,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.822000,0.000000,22.664700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.830600,-1.535000,25.309000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.174900,-1.535000,24.964700>}
box{<0,0,-0.127000><0.486914,0.035000,0.127000> rotate<0,44.997030,0> translate<67.830600,-1.535000,25.309000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.871200,0.000000,9.740200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.891000,0.000000,9.760100>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,-45.141342,0> translate<67.871200,0.000000,9.740200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.871200,0.000000,11.849700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.891000,0.000000,11.829800>}
box{<0,0,-0.127000><0.028072,0.035000,0.127000> rotate<0,45.141342,0> translate<67.871200,0.000000,11.849700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.891000,0.000000,9.760100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.987100,0.000000,9.664000>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,44.997030,0> translate<67.891000,0.000000,9.760100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.891000,0.000000,11.829800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.987100,0.000000,11.925900>}
box{<0,0,-0.127000><0.135906,0.035000,0.127000> rotate<0,-44.997030,0> translate<67.891000,0.000000,11.829800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.917800,0.000000,27.030900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.005200,0.000000,26.943400>}
box{<0,0,-0.127000><0.123673,0.035000,0.127000> rotate<0,45.029787,0> translate<67.917800,0.000000,27.030900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.921900,-1.535000,22.764700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.013200,-1.535000,22.855900>}
box{<0,0,-0.127000><0.129047,0.035000,0.127000> rotate<0,-44.965637,0> translate<67.921900,-1.535000,22.764700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.921900,-1.535000,22.764700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,22.764700>}
box{<0,0,-0.127000><0.334300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.921900,-1.535000,22.764700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.326800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.273100>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.929000,0.000000,25.273100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.326800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986300,0.000000,25.326800>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.929000,0.000000,25.326800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.473000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986300,0.000000,25.473000>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<67.929000,0.000000,25.473000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.526700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.929000,0.000000,25.473000>}
box{<0,0,-0.127000><0.053700,0.035000,0.127000> rotate<0,-90.000000,0> translate<67.929000,0.000000,25.473000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,0.000000,28.749000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.352600,0.000000,28.575000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<67.932500,0.000000,28.749000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,-1.535000,28.749000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.352600,-1.535000,28.575000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,22.497221,0> translate<67.932500,-1.535000,28.749000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.932500,0.000000,32.210900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.322300,0.000000,32.372300>}
box{<0,0,-0.127000><0.421893,0.035000,0.127000> rotate<0,-22.490931,0> translate<67.932500,0.000000,32.210900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.975700,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.367700,0.000000,5.791200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<67.975700,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.975700,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.367700,0.000000,9.448700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<67.975700,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.987100,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,9.664000>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<67.987100,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.987100,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,11.925900>}
box{<0,0,-0.127000><0.681000,0.035000,0.127000> rotate<0,0.000000,0> translate<67.987100,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<67.993600,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,25.146000>}
box{<0,0,-0.127000><8.987400,0.035000,0.127000> rotate<0,0.000000,0> translate<67.993600,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.005200,0.000000,27.426200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.005200,0.000000,26.943400>}
box{<0,0,-0.127000><0.482800,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.005200,0.000000,26.943400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.005200,0.000000,27.426200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,27.604700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.005200,0.000000,27.426200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.013200,-1.535000,22.855900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.054300,-1.535000,22.955200>}
box{<0,0,-0.127000><0.107470,0.035000,0.127000> rotate<0,-67.511014,0> translate<68.013200,-1.535000,22.855900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.013200,0.000000,22.855900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.116700,0.000000,23.105700>}
box{<0,0,-0.127000><0.270393,0.035000,0.127000> rotate<0,-67.489780,0> translate<68.013200,0.000000,22.855900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.014800,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,22.860000>}
box{<0,0,-0.127000><1.935400,0.035000,0.127000> rotate<0,0.000000,0> translate<68.014800,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.014800,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,22.860000>}
box{<0,0,-0.127000><8.966200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.014800,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.054300,-1.535000,22.955200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,22.955200>}
box{<0,0,-0.127000><1.151900,0.035000,0.127000> rotate<0,0.000000,0> translate<68.054300,-1.535000,22.955200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.108000,-1.535000,17.767300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.215900,-1.535000,17.875200>}
box{<0,0,-0.127000><0.152594,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.108000,-1.535000,17.767300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.116700,0.000000,23.105700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.116700,0.000000,23.220400>}
box{<0,0,-0.127000><0.114700,0.035000,0.127000> rotate<0,90.000000,0> translate<68.116700,0.000000,23.220400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.116700,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.963000,0.000000,23.114000>}
box{<0,0,-0.127000><1.846300,0.035000,0.127000> rotate<0,0.000000,0> translate<68.116700,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.116700,0.000000,23.220400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.137600,0.000000,23.241300>}
box{<0,0,-0.127000><0.029557,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.116700,0.000000,23.220400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.120700,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,17.780000>}
box{<0,0,-0.127000><8.860300,0.035000,0.127000> rotate<0,0.000000,0> translate<68.120700,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.137600,0.000000,23.241300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,23.195200>}
box{<0,0,-0.127000><0.065195,0.035000,0.127000> rotate<0,44.997030,0> translate<68.137600,0.000000,23.241300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,24.561800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,24.630300>}
box{<0,0,-0.127000><0.068500,0.035000,0.127000> rotate<0,90.000000,0> translate<68.140900,0.000000,24.630300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,24.561800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,24.604700>}
box{<0,0,-0.127000><0.060599,0.035000,0.127000> rotate<0,-45.063882,0> translate<68.140900,0.000000,24.561800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,24.630300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.152100,0.000000,24.619000>}
box{<0,0,-0.127000><0.015910,0.035000,0.127000> rotate<0,45.251660,0> translate<68.140900,0.000000,24.630300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,26.169600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,26.238100>}
box{<0,0,-0.127000><0.068500,0.035000,0.127000> rotate<0,90.000000,0> translate<68.140900,0.000000,26.238100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,26.169600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.152100,0.000000,26.180900>}
box{<0,0,-0.127000><0.015910,0.035000,0.127000> rotate<0,-45.251660,0> translate<68.140900,0.000000,26.169600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.140900,0.000000,26.238100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,26.195200>}
box{<0,0,-0.127000><0.060599,0.035000,0.127000> rotate<0,45.063882,0> translate<68.140900,0.000000,26.238100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.152100,0.000000,24.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,24.619000>}
box{<0,0,-0.127000><0.834700,0.035000,0.127000> rotate<0,0.000000,0> translate<68.152100,0.000000,24.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.152100,0.000000,26.180900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,26.180900>}
box{<0,0,-0.127000><0.834700,0.035000,0.127000> rotate<0,0.000000,0> translate<68.152100,0.000000,26.180900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.174900,-1.535000,24.964700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,24.964700>}
box{<0,0,-0.127000><1.031300,0.035000,0.127000> rotate<0,0.000000,0> translate<68.174900,-1.535000,24.964700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,23.195200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,23.195200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.183700,0.000000,23.195200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,24.604700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,24.604700>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.183700,0.000000,24.604700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,26.195200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,26.195200>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.183700,0.000000,26.195200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.183700,0.000000,27.604700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.212000,0.000000,27.604700>}
box{<0,0,-0.127000><1.028300,0.035000,0.127000> rotate<0,0.000000,0> translate<68.183700,0.000000,27.604700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.215900,-1.535000,17.875200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,17.875200>}
box{<0,0,-0.127000><0.990300,0.035000,0.127000> rotate<0,0.000000,0> translate<68.215900,-1.535000,17.875200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,17.684700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,17.506200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<68.256200,-1.535000,17.684700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,20.755200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,20.933700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.256200,-1.535000,20.755200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.256200,-1.535000,22.764700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,22.586200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<68.256200,-1.535000,22.764700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.329000,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.830900,-1.535000,20.828000>}
box{<0,0,-0.127000><0.501900,0.035000,0.127000> rotate<0,0.000000,0> translate<68.329000,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.352600,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,28.575000>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.000000,0> translate<68.352600,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.352600,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,28.575000>}
box{<0,0,-0.127000><0.100400,0.035000,0.127000> rotate<0,0.000000,0> translate<68.352600,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.367700,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.792200,0.000000,5.791200>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.367700,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.367700,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.792200,0.000000,9.448700>}
box{<0,0,-0.127000><0.424500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.367700,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.414900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.745000,-1.535000,17.526000>}
box{<0,0,-0.127000><0.330100,0.035000,0.127000> rotate<0,0.000000,0> translate<68.414900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.414900,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.745000,-1.535000,22.606000>}
box{<0,0,-0.127000><0.330100,0.035000,0.127000> rotate<0,0.000000,0> translate<68.414900,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,17.030600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,17.506200>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.434700,-1.535000,17.506200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,17.030600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,17.030600>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,17.030600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,17.272000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,20.933700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,21.323300>}
box{<0,0,-0.127000><0.389600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.434700,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,21.082000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,21.323300>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,21.323300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,22.110600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,22.586200>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.434700,-1.535000,22.586200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,22.110600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,22.110600>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,22.110600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.434700,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,22.352000>}
box{<0,0,-0.127000><0.290500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.434700,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,0.000000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,0.000000,30.353000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.452500,0.000000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,-1.535000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.452500,-1.535000,30.353000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.452500,-1.535000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,30.352500>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,90.000000,0> translate<68.453000,0.000000,30.352500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,30.352500>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,90.000000,0> translate<68.453000,-1.535000,30.352500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,28.702000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,28.702000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,28.956000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,28.956000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,29.210000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,29.210000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,29.464000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,29.464000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,29.718000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,29.718000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,29.972000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,29.972000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,30.226000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,30.226000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,0.000000,30.352500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,30.352500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,0.000000,30.352500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.453000,-1.535000,30.352500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,30.352500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.453000,-1.535000,30.352500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.667600>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.668100,0.000000,10.667600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,9.906000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.160000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.414000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.667600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.667600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,10.667600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.922300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,11.925900>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.668100,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,10.922300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.922300>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,10.922300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,11.176000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,11.430000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.668100,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,11.684000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.668100,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.807300,0.000000,28.575000>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.706800,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.807300,-1.535000,28.575000>}
box{<0,0,-0.127000><0.100500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.706800,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,30.352500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,0.000000,28.575000>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.706800,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,30.352500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.706800,-1.535000,28.575000>}
box{<0,0,-0.127000><1.777500,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.706800,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.707400,-1.535000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.707400,-1.535000,30.606800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<68.707400,-1.535000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.707400,-1.535000,30.353000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.353000>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.707400,-1.535000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.707400,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.833200,-1.535000,30.480000>}
box{<0,0,-0.127000><3.125800,0.035000,0.127000> rotate<0,0.000000,0> translate<68.707400,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.707400,-1.535000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.606800>}
box{<0,0,-0.127000><1.015500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.707400,-1.535000,30.606800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,17.506200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,17.030600>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.725200,-1.535000,17.030600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,17.506200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,17.684700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.725200,-1.535000,17.506200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,20.933700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,20.755200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<68.725200,-1.535000,20.933700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,21.323300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,20.933700>}
box{<0,0,-0.127000><0.389600,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.725200,-1.535000,20.933700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,22.586200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,22.110600>}
box{<0,0,-0.127000><0.475600,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.725200,-1.535000,22.110600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.725200,-1.535000,22.586200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,22.764700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<68.725200,-1.535000,22.586200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.743000,0.000000,33.159600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.973600,0.000000,32.929000>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,44.997030,0> translate<68.743000,0.000000,33.159600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.792200,0.000000,5.791200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.184200,0.000000,5.953600>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-22.502043,0> translate<68.792200,0.000000,5.791200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.792200,0.000000,9.448700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.184200,0.000000,9.286300>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,22.502043,0> translate<68.792200,0.000000,9.448700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.807300,0.000000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.227400,0.000000,28.749000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<68.807300,0.000000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.807300,-1.535000,28.575000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.227400,-1.535000,28.749000>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-22.497221,0> translate<68.807300,-1.535000,28.575000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.882600,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,33.020000>}
box{<0,0,-0.127000><8.098400,0.035000,0.127000> rotate<0,0.000000,0> translate<68.882600,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,17.684700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,17.684700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.903700,-1.535000,17.684700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,20.755200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,20.755200>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.903700,-1.535000,20.755200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.903700,-1.535000,22.764700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,22.764700>}
box{<0,0,-0.127000><1.252500,0.035000,0.127000> rotate<0,0.000000,0> translate<68.903700,-1.535000,22.764700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.914600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,9.398000>}
box{<0,0,-0.127000><9.050700,0.035000,0.127000> rotate<0,0.000000,0> translate<68.914600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.914800,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.842000>}
box{<0,0,-0.127000><2.275000,0.035000,0.127000> rotate<0,0.000000,0> translate<68.914800,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.602800,0.000000,9.664000>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<68.921700,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.667600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,9.664000>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.921700,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,10.922300>}
box{<0,0,-0.127000><1.003600,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.921700,0.000000,10.922300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.921700,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.602800,0.000000,11.925900>}
box{<0,0,-0.127000><0.681100,0.035000,0.127000> rotate<0,0.000000,0> translate<68.921700,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.922300,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.922300,0.000000,10.921700>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<68.922300,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.922300,0.000000,10.668100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.668100>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.922300,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.922300,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.921700>}
box{<0,0,-0.127000><0.903600,0.035000,0.127000> rotate<0,0.000000,0> translate<68.922300,0.000000,10.921700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.973600,0.000000,32.929000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.786000>}
box{<0,0,-0.127000><1.616446,0.035000,0.127000> rotate<0,44.997030,0> translate<68.973600,0.000000,32.929000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986300,0.000000,25.473000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986300,0.000000,25.326800>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,-90.000000,0> translate<68.986300,0.000000,25.326800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,24.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.326300>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,90.000000,0> translate<68.986800,0.000000,25.326300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,24.638000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,24.892000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.146000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.326300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.326300>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,25.326300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.473600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,26.180900>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,90.000000,0> translate<68.986800,0.000000,26.180900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.473600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.473600>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,25.473600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.654000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.908000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<68.986800,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,26.162000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,0.000000,0> translate<68.986800,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.113900,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,28.702000>}
box{<0,0,-0.127000><0.215400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.113900,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.113900,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.611200,-1.535000,28.702000>}
box{<0,0,-0.127000><4.497300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.113900,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,24.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.967800,0.000000,24.619000>}
box{<0,0,-0.127000><0.834800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.133000,0.000000,24.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.326300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,24.619000>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.133000,0.000000,24.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,26.180900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,25.473600>}
box{<0,0,-0.127000><0.707300,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.133000,0.000000,25.473600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133000,0.000000,26.180900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.967800,0.000000,26.180900>}
box{<0,0,-0.127000><0.834800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.133000,0.000000,26.180900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133600,0.000000,25.326800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133600,0.000000,25.473000>}
box{<0,0,-0.127000><0.146200,0.035000,0.127000> rotate<0,90.000000,0> translate<69.133600,0.000000,25.473000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133600,0.000000,25.326800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.326800>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.133600,0.000000,25.326800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133600,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,25.400000>}
box{<0,0,-0.127000><7.847400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.133600,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.133600,0.000000,25.473000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.473000>}
box{<0,0,-0.127000><1.057300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.133600,0.000000,25.473000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.136600,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,32.766000>}
box{<0,0,-0.127000><7.844400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.136600,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.184200,0.000000,5.953600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.484300,0.000000,6.253700>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.184200,0.000000,5.953600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.184200,0.000000,9.286300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.484300,0.000000,8.986200>}
box{<0,0,-0.127000><0.424405,0.035000,0.127000> rotate<0,44.997030,0> translate<69.184200,0.000000,9.286300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,17.875200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,18.053700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.206200,-1.535000,17.875200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,22.955200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,23.133700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.206200,-1.535000,22.955200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.206200,-1.535000,24.964700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,24.786200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<69.206200,-1.535000,24.964700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.212000,0.000000,27.604700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,27.722000>}
box{<0,0,-0.127000><0.165887,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.212000,0.000000,27.604700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.227400,0.000000,28.749000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,28.851000>}
box{<0,0,-0.127000><0.144179,0.035000,0.127000> rotate<0,-45.025128,0> translate<69.227400,0.000000,28.749000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.227400,-1.535000,28.749000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.548900,-1.535000,29.070500>}
box{<0,0,-0.127000><0.454670,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.227400,-1.535000,28.749000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.278900,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,24.892000>}
box{<0,0,-0.127000><7.702100,0.035000,0.127000> rotate<0,0.000000,0> translate<69.278900,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.326500,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,9.144000>}
box{<0,0,-0.127000><8.638800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.326500,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.326600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,6.096000>}
box{<0,0,-0.127000><1.863200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.326600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,28.851000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.329300,0.000000,27.722000>}
box{<0,0,-0.127000><1.129000,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.329300,0.000000,27.722000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.365000,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.034000>}
box{<0,0,-0.127000><7.616000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.365000,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.365000,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.114000>}
box{<0,0,-0.127000><7.616000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.365000,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,18.053700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,19.545300>}
box{<0,0,-0.127000><1.491600,0.035000,0.127000> rotate<0,90.000000,0> translate<69.384700,-1.535000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,18.288000>}
box{<0,0,-0.127000><12.766100,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,18.542000>}
box{<0,0,-0.127000><12.766000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.796000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,19.050000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,19.304000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,19.545300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,19.545300>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,19.545300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,23.133700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,24.786200>}
box{<0,0,-0.127000><1.652500,0.035000,0.127000> rotate<0,90.000000,0> translate<69.384700,-1.535000,24.786200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,23.368000>}
box{<0,0,-0.127000><12.766100,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,23.622000>}
box{<0,0,-0.127000><12.766000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.876000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,24.130000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,24.384000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.384700,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,24.638000>}
box{<0,0,-0.127000><7.596300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.384700,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.390600,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,32.512000>}
box{<0,0,-0.127000><7.590400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.390600,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.434400,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.357200,-1.535000,28.956000>}
box{<0,0,-0.127000><3.922800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.434400,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.446900,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.548900,-1.535000,31.889400>}
box{<0,0,-0.127000><0.144179,0.035000,0.127000> rotate<0,44.968932,0> translate<69.446900,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.446900,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.321900,-1.535000,31.991300>}
box{<0,0,-0.127000><0.875000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.446900,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.484300,0.000000,6.253700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,6.645700>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,-67.492017,0> translate<69.484300,0.000000,6.253700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.484300,0.000000,8.986200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,8.594200>}
box{<0,0,-0.127000><0.424309,0.035000,0.127000> rotate<0,67.492017,0> translate<69.484300,0.000000,8.986200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.524100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,6.350000>}
box{<0,0,-0.127000><1.665700,0.035000,0.127000> rotate<0,0.000000,0> translate<69.524100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.524200,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,8.890000>}
box{<0,0,-0.127000><8.441100,0.035000,0.127000> rotate<0,0.000000,0> translate<69.524200,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.548900,-1.535000,29.070500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,29.490600>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,-67.496839,0> translate<69.548900,-1.535000,29.070500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.548900,-1.535000,31.889400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,31.469300>}
box{<0,0,-0.127000><0.454709,0.035000,0.127000> rotate<0,67.496839,0> translate<69.548900,-1.535000,31.889400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.602800,0.000000,9.664000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,9.887100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.602800,0.000000,9.664000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.602800,0.000000,11.925900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,11.702800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<69.602800,0.000000,11.925900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.606600,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.103200,-1.535000,29.210000>}
box{<0,0,-0.127000><3.496600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.606600,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.606700,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.563200,-1.535000,31.750000>}
box{<0,0,-0.127000><0.956500,0.035000,0.127000> rotate<0,0.000000,0> translate<69.606700,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.629400,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,6.604000>}
box{<0,0,-0.127000><1.560400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.629400,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.629400,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,8.636000>}
box{<0,0,-0.127000><8.335900,0.035000,0.127000> rotate<0,0.000000,0> translate<69.629400,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.644600,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,32.258000>}
box{<0,0,-0.127000><7.336400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.644600,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,6.645700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,8.594200>}
box{<0,0,-0.127000><1.948500,0.035000,0.127000> rotate<0,90.000000,0> translate<69.646700,0.000000,8.594200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.355800,0.000000,6.858000>}
box{<0,0,-0.127000><1.709100,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,7.112000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,7.366000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,7.620000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,7.874000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,8.128000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.646700,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,8.382000>}
box{<0,0,-0.127000><8.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.646700,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.711800,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.849200,-1.535000,29.464000>}
box{<0,0,-0.127000><3.137400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.711800,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.711900,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.817200,-1.535000,31.496000>}
box{<0,0,-0.127000><1.105300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.711900,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,29.490600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.353000>}
box{<0,0,-0.127000><0.862400,0.035000,0.127000> rotate<0,90.000000,0> translate<69.722900,-1.535000,30.353000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.595200,-1.535000,29.718000>}
box{<0,0,-0.127000><2.872300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.341200,-1.535000,29.972000>}
box{<0,0,-0.127000><2.618300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.087200,-1.535000,30.226000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.606800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,31.469300>}
box{<0,0,-0.127000><0.862500,0.035000,0.127000> rotate<0,90.000000,0> translate<69.722900,-1.535000,31.469300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.579200,-1.535000,30.734000>}
box{<0,0,-0.127000><1.856300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.325200,-1.535000,30.988000>}
box{<0,0,-0.127000><1.602300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.722900,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.071200,-1.535000,31.242000>}
box{<0,0,-0.127000><1.348300,0.035000,0.127000> rotate<0,0.000000,0> translate<69.722900,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,9.887100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.668100>}
box{<0,0,-0.127000><0.781000,0.035000,0.127000> rotate<0,90.000000,0> translate<69.825900,0.000000,10.668100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,9.906000>}
box{<0,0,-0.127000><8.139400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,10.160000>}
box{<0,0,-0.127000><8.139400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,10.414000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,10.668000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.921700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,11.702800>}
box{<0,0,-0.127000><0.781100,0.035000,0.127000> rotate<0,90.000000,0> translate<69.825900,0.000000,11.702800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,10.922000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,11.176000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,11.430000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.825900,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,11.684000>}
box{<0,0,-0.127000><7.588800,0.035000,0.127000> rotate<0,0.000000,0> translate<69.825900,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.886000,-1.535000,3.416300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,3.646900>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.886000,-1.535000,3.416300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.898600,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,32.004000>}
box{<0,0,-0.127000><7.082400,0.035000,0.127000> rotate<0,0.000000,0> translate<69.898600,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,23.195200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,23.373700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.936200,0.000000,23.195200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,24.604700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,24.426200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<69.936200,0.000000,24.604700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.936200,0.000000,26.195200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,26.373700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.936200,0.000000,26.195200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.363700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,14.185200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<69.950200,0.000000,14.363700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.846300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,14.363700>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,14.363700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.116200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,15.633600>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,15.633600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.116200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.026500,0.000000,16.192400>}
box{<0,0,-0.127000><0.107834,0.035000,0.127000> rotate<0,-44.959462,0> translate<69.950200,0.000000,16.116200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.268700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.026500,0.000000,16.192400>}
box{<0,0,-0.127000><0.107904,0.035000,0.127000> rotate<0,44.997030,0> translate<69.950200,0.000000,16.268700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,18.021200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,16.268700>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,16.268700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,18.021200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,18.199700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.950200,0.000000,18.021200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,18.808700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,18.630200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<69.950200,0.000000,18.808700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,19.291300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,18.808700>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,18.808700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,20.561200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,20.078600>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,20.078600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,20.561200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,20.739700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.950200,0.000000,20.561200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,21.348700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,21.170200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<69.950200,0.000000,21.348700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,23.101200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,21.348700>}
box{<0,0,-0.127000><1.752500,0.035000,0.127000> rotate<0,-90.000000,0> translate<69.950200,0.000000,21.348700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.950200,0.000000,23.101200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,23.279700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.950200,0.000000,23.101200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.967800,0.000000,24.619000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,24.842100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<69.967800,0.000000,24.619000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.967800,0.000000,26.180900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.957800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<69.967800,0.000000,26.180900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.986700,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,26.162000>}
box{<0,0,-0.127000><12.164000,0.035000,0.127000> rotate<0,0.000000,0> translate<69.986700,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.986800,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,24.638000>}
box{<0,0,-0.127000><6.994200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.986800,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.053000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,11.230200>}
box{<0,0,-0.127000><2.177200,0.035000,0.127000> rotate<0,90.000000,0> translate<69.989600,-1.535000,11.230200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.053000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.926000>}
box{<0,0,-0.127000><0.179605,0.035000,0.127000> rotate<0,44.997030,0> translate<69.989600,-1.535000,9.053000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,9.144000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,9.398000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,9.652000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,9.906000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,10.160000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,10.414000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,10.668000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,10.922000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,11.176000>}
box{<0,0,-0.127000><15.240200,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<69.989600,-1.535000,11.230200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,11.230200>}
box{<0,0,-0.127000><0.166600,0.035000,0.127000> rotate<0,0.000000,0> translate<69.989600,-1.535000,11.230200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.025700,-1.535000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,3.556000>}
box{<0,0,-0.127000><15.204100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.025700,-1.535000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.109000,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.754400,0.000000,23.368000>}
box{<0,0,-0.127000><4.645400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.109000,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,23.373700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,24.426200>}
box{<0,0,-0.127000><1.052500,0.035000,0.127000> rotate<0,90.000000,0> translate<70.114700,0.000000,24.426200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.008300,0.000000,23.622000>}
box{<0,0,-0.127000><4.893600,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,23.876000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,24.130000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,24.384000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,26.373700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,27.394000>}
box{<0,0,-0.127000><1.020300,0.035000,0.127000> rotate<0,90.000000,0> translate<70.114700,0.000000,27.394000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,26.416000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,26.670000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,26.924000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,27.178000>}
box{<0,0,-0.127000><6.866300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.114700,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.114700,0.000000,27.394000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,27.395900>}
box{<0,0,-0.127000><0.002687,0.035000,0.127000> rotate<0,-44.997030,0> translate<70.114700,0.000000,27.394000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,3.646900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,3.973000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<70.116600,-1.535000,3.973000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,3.810000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,3.973000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.926000>}
box{<0,0,-0.127000><4.953000,0.035000,0.127000> rotate<0,90.000000,0> translate<70.116600,-1.535000,8.926000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,4.064000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,4.318000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.355700,-1.535000,4.572000>}
box{<0,0,-0.127000><1.239100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,4.826000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.080000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.334000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,-1.535000,5.588000>}
box{<0,0,-0.127000><2.145900,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.842000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,6.096000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,6.350000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,6.604000>}
box{<0,0,-0.127000><1.073200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.355800,-1.535000,6.858000>}
box{<0,0,-0.127000><1.239200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,7.112000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,7.366000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,7.620000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,7.874000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,8.128000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,8.382000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,8.636000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,-1.535000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,8.890000>}
box{<0,0,-0.127000><15.113200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,-1.535000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,27.395900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.459900>}
box{<0,0,-0.127000><4.064000,0.035000,0.127000> rotate<0,90.000000,0> translate<70.116600,0.000000,31.459900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,27.432000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,27.686000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,27.940000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.194000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,28.448000>}
box{<0,0,-0.127000><12.034200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,28.702000>}
box{<0,0,-0.127000><12.034100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.956000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,29.210000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,29.464000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,29.718000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,29.972000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,30.226000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,30.480000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,30.734000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,30.988000>}
box{<0,0,-0.127000><12.034200,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,31.242000>}
box{<0,0,-0.127000><12.034100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.459900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.786000>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,90.000000,0> translate<70.116600,0.000000,31.786000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,31.496000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.116600,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,31.750000>}
box{<0,0,-0.127000><6.864400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.116600,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,14.185200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.681200,0.000000,14.185200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,14.185200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,18.199700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.237100,0.000000,18.199700>}
box{<0,0,-0.127000><1.108400,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,18.199700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,18.630200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.667600,0.000000,18.630200>}
box{<0,0,-0.127000><1.538900,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,18.630200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,20.739700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.667600,0.000000,20.739700>}
box{<0,0,-0.127000><1.538900,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,20.739700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,21.170200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.237000,0.000000,21.170200>}
box{<0,0,-0.127000><1.108300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,21.170200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.128700,0.000000,23.279700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.681200,0.000000,23.279700>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<70.128700,0.000000,23.279700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,11.230200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,11.408700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<70.156200,-1.535000,11.230200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,17.684700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.302300,-1.535000,17.538600>}
box{<0,0,-0.127000><0.206617,0.035000,0.127000> rotate<0,44.997030,0> translate<70.156200,-1.535000,17.684700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,20.755200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,20.933700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<70.156200,-1.535000,20.755200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.156200,-1.535000,22.764700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.302300,-1.535000,22.618600>}
box{<0,0,-0.127000><0.206617,0.035000,0.127000> rotate<0,44.997030,0> translate<70.156200,-1.535000,22.764700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,24.842100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.326800>}
box{<0,0,-0.127000><0.484700,0.035000,0.127000> rotate<0,90.000000,0> translate<70.190900,0.000000,25.326800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,24.892000>}
box{<0,0,-0.127000><6.790100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.190900,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,25.146000>}
box{<0,0,-0.127000><6.790100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.190900,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.473000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.957800>}
box{<0,0,-0.127000><0.484800,0.035000,0.127000> rotate<0,90.000000,0> translate<70.190900,0.000000,25.957800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,25.654000>}
box{<0,0,-0.127000><6.790100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.190900,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.190900,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,25.908000>}
box{<0,0,-0.127000><11.959900,0.035000,0.127000> rotate<0,0.000000,0> translate<70.190900,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.229000,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,20.828000>}
box{<0,0,-0.127000><11.921800,0.035000,0.127000> rotate<0,0.000000,0> translate<70.229000,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.302300,-1.535000,17.538600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,17.538600>}
box{<0,0,-0.127000><6.678700,0.035000,0.127000> rotate<0,0.000000,0> translate<70.302300,-1.535000,17.538600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.302300,-1.535000,22.618600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,22.618600>}
box{<0,0,-0.127000><6.678700,0.035000,0.127000> rotate<0,0.000000,0> translate<70.302300,-1.535000,22.618600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.321900,-1.535000,31.991300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,25.332200>}
box{<0,0,-0.127000><9.417390,0.035000,0.127000> rotate<0,44.997030,0> translate<70.321900,-1.535000,31.991300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,11.408700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,12.814300>}
box{<0,0,-0.127000><1.405600,0.035000,0.127000> rotate<0,90.000000,0> translate<70.334700,-1.535000,12.814300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,11.430000>}
box{<0,0,-0.127000><14.895100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,11.684000>}
box{<0,0,-0.127000><14.895100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,11.938000>}
box{<0,0,-0.127000><14.895100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,12.192000>}
box{<0,0,-0.127000><14.895100,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,-1.535000,12.446000>}
box{<0,0,-0.127000><6.348600,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.265300,-1.535000,12.700000>}
box{<0,0,-0.127000><5.930600,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,12.814300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.173300,-1.535000,12.814300>}
box{<0,0,-0.127000><5.838600,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,12.814300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,15.887600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,16.751300>}
box{<0,0,-0.127000><0.863700,0.035000,0.127000> rotate<0,90.000000,0> translate<70.334700,-1.535000,16.751300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,15.887600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.379000,-1.535000,15.887600>}
box{<0,0,-0.127000><7.044300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,15.887600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,16.002000>}
box{<0,0,-0.127000><11.816000,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.256000>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.510000>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,16.751300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.751300>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,16.751300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,20.933700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,21.831300>}
box{<0,0,-0.127000><0.897600,0.035000,0.127000> rotate<0,90.000000,0> translate<70.334700,-1.535000,21.831300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,21.082000>}
box{<0,0,-0.127000><11.816000,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.336000>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.590000>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<70.334700,-1.535000,21.831300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.831300>}
box{<0,0,-0.127000><6.646300,0.035000,0.127000> rotate<0,0.000000,0> translate<70.334700,-1.535000,21.831300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,4.737900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,0.000000,4.514800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<71.189800,0.000000,4.737900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,4.737900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,-1.535000,4.514800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<71.189800,-1.535000,4.737900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,4.737900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<71.189800,0.000000,4.737900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,4.737900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<71.189800,-1.535000,4.737900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,0.000000,5.588000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<71.189800,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,-1.535000,5.588000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<71.189800,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,0.000000,5.841800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<71.189800,0.000000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,-1.535000,5.841800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<71.189800,-1.535000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,6.692000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,5.841800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<71.189800,0.000000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,6.692000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,5.841800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<71.189800,-1.535000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,0.000000,6.692000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,0.000000,6.915100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<71.189800,0.000000,6.692000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.189800,-1.535000,6.692000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,-1.535000,6.915100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<71.189800,-1.535000,6.692000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.237000,0.000000,21.170200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.488300,0.000000,20.918900>}
box{<0,0,-0.127000><0.355392,0.035000,0.127000> rotate<0,44.997030,0> translate<71.237000,0.000000,21.170200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.237100,0.000000,18.199700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.488300,0.000000,18.451000>}
box{<0,0,-0.127000><0.355321,0.035000,0.127000> rotate<0,-45.008432,0> translate<71.237100,0.000000,18.199700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,0.000000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,4.514800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<71.412900,0.000000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,-1.535000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,4.514800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<71.412900,-1.535000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,0.000000,6.915100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.915100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<71.412900,0.000000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.412900,-1.535000,6.915100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.915100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<71.412900,-1.535000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.488300,0.000000,18.451000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.667600,0.000000,18.630200>}
box{<0,0,-0.127000><0.253498,0.035000,0.127000> rotate<0,-44.981049,0> translate<71.488300,0.000000,18.451000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.488300,0.000000,20.918900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.667600,0.000000,20.739700>}
box{<0,0,-0.127000><0.253498,0.035000,0.127000> rotate<0,44.981049,0> translate<71.488300,0.000000,20.918900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.681200,0.000000,14.185200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.755000,0.000000,14.259000>}
box{<0,0,-0.127000><0.104369,0.035000,0.127000> rotate<0,-44.997030,0> translate<71.681200,0.000000,14.185200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.681200,0.000000,23.279700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.755000,0.000000,23.205900>}
box{<0,0,-0.127000><0.104369,0.035000,0.127000> rotate<0,44.997030,0> translate<71.681200,0.000000,23.279700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.720000,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.789900,0.000000,14.224000>}
box{<0,0,-0.127000><0.069900,0.035000,0.127000> rotate<0,0.000000,0> translate<71.720000,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.755000,0.000000,14.259000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.828700,0.000000,14.185200>}
box{<0,0,-0.127000><0.104298,0.035000,0.127000> rotate<0,45.035872,0> translate<71.755000,0.000000,14.259000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.755000,0.000000,23.205900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.828700,0.000000,23.279700>}
box{<0,0,-0.127000><0.104298,0.035000,0.127000> rotate<0,-45.035872,0> translate<71.755000,0.000000,23.205900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.828700,0.000000,14.185200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.381200,0.000000,14.185200>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<71.828700,0.000000,14.185200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<71.828700,0.000000,23.279700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.381200,0.000000,23.279700>}
box{<0,0,-0.127000><1.552500,0.035000,0.127000> rotate<0,0.000000,0> translate<71.828700,0.000000,23.279700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,0.000000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,0.000000,5.588000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.262500,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,-1.535000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.262500,-1.535000,5.588000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.262500,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.587500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<72.263000,0.000000,5.587500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.587500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<72.263000,-1.535000,5.587500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,4.572000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,4.572000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,4.826000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,4.826000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.080000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.080000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.334000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.334000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.587500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.587500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,5.587500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.587500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.587500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,5.587500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.842400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.915100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<72.263000,0.000000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.842400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.915100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<72.263000,-1.535000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,5.842400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.842400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,5.842400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,5.842400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.842400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,5.842400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.096000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.096000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.350000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.350000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.604000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.604000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.858000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.263000,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.858000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<72.263000,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,0.000000,4.514800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<72.516800,0.000000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,-1.535000,4.514800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<72.516800,-1.535000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.587500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,4.514800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.516800,0.000000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.587500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,4.514800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.516800,-1.535000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.915000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,5.842400>}
box{<0,0,-0.127000><1.072600,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.516800,0.000000,5.842400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.915000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,5.842400>}
box{<0,0,-0.127000><1.072600,0.035000,0.127000> rotate<0,-90.000000,0> translate<72.516800,-1.535000,5.842400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,0.000000,6.915000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,0.000000,6.915100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-0.006739,0> translate<72.516800,0.000000,6.915000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.516800,-1.535000,6.915000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,-1.535000,6.915100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-0.006739,0> translate<72.516800,-1.535000,6.915000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,0.000000,5.841800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<72.517400,0.000000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,-1.535000,5.841800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<72.517400,-1.535000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.588000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.588000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,5.588000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,5.588000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,0.000000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.841800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,0.000000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<72.517400,-1.535000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.841800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<72.517400,-1.535000,5.841800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,0.000000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,4.737900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<73.367000,0.000000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,-1.535000,4.514800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,4.737900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<73.367000,-1.535000,4.514800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,0.000000,6.915100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,6.692000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<73.367000,0.000000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.367000,-1.535000,6.915100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,6.692000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<73.367000,-1.535000,6.915100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.381200,0.000000,14.185200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.363700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<73.381200,0.000000,14.185200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.381200,0.000000,23.279700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,23.101200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<73.381200,0.000000,23.279700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.420000,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,14.224000>}
box{<0,0,-0.127000><3.561000,0.035000,0.127000> rotate<0,0.000000,0> translate<73.420000,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.424100,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,6.858000>}
box{<0,0,-0.127000><4.541200,0.035000,0.127000> rotate<0,0.000000,0> translate<73.424100,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.424100,-1.535000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,6.858000>}
box{<0,0,-0.127000><11.805700,0.035000,0.127000> rotate<0,0.000000,0> translate<73.424100,-1.535000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.424200,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,4.572000>}
box{<0,0,-0.127000><1.010500,0.035000,0.127000> rotate<0,0.000000,0> translate<73.424200,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.424200,-1.535000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,4.572000>}
box{<0,0,-0.127000><11.805600,0.035000,0.127000> rotate<0,0.000000,0> translate<73.424200,-1.535000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.546900,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.500400,0.000000,23.114000>}
box{<0,0,-0.127000><0.953500,0.035000,0.127000> rotate<0,0.000000,0> translate<73.546900,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.363700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.846300>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<73.559700,0.000000,14.846300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,14.478000>}
box{<0,0,-0.127000><3.421300,0.035000,0.127000> rotate<0,0.000000,0> translate<73.559700,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,14.732000>}
box{<0,0,-0.127000><3.421300,0.035000,0.127000> rotate<0,0.000000,0> translate<73.559700,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,14.846300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,14.846300>}
box{<0,0,-0.127000><3.421300,0.035000,0.127000> rotate<0,0.000000,0> translate<73.559700,0.000000,14.846300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,22.618600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,23.101200>}
box{<0,0,-0.127000><0.482600,0.035000,0.127000> rotate<0,90.000000,0> translate<73.559700,0.000000,23.101200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,22.618600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.005000,0.000000,22.618600>}
box{<0,0,-0.127000><0.445300,0.035000,0.127000> rotate<0,0.000000,0> translate<73.559700,0.000000,22.618600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.559700,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.246400,0.000000,22.860000>}
box{<0,0,-0.127000><0.686700,0.035000,0.127000> rotate<0,0.000000,0> translate<73.559700,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,4.737900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.588000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<73.590100,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,4.737900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.588000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<73.590100,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,4.826000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,4.826000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,5.080000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,5.080000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,5.334000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,5.334000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,6.692000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<73.590100,0.000000,6.692000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.841800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,6.692000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<73.590100,-1.535000,6.692000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,5.842000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,5.842000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,6.096000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,6.096000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,6.350000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,6.350000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,6.604000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.590100,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,6.604000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.590100,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,4.769500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,0.000000,4.591000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<73.806000,0.000000,4.769500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,4.769500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,-1.535000,4.591000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<73.806000,-1.535000,4.769500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,6.660400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,4.769500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<73.806000,0.000000,4.769500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,6.660400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,4.769500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<73.806000,-1.535000,4.769500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,0.000000,6.660400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,0.000000,6.838900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<73.806000,0.000000,6.660400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.806000,-1.535000,6.660400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,-1.535000,6.838900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<73.806000,-1.535000,6.660400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,0.000000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,4.591000>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,0.000000,0> translate<73.984500,0.000000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,-1.535000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,-1.535000,4.591000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.984500,-1.535000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,0.000000,6.838900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,0.000000,6.838900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.984500,0.000000,6.838900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<73.984500,-1.535000,6.838900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,-1.535000,6.838900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<73.984500,-1.535000,6.838900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.005000,0.000000,22.618600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.917300,0.000000,23.531000>}
box{<0,0,-0.127000><1.290258,0.035000,0.127000> rotate<0,-45.000170,0> translate<74.005000,0.000000,22.618600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.434700,0.000000,1.765200>}
box{<0,0,-0.127000><2.825800,0.035000,0.127000> rotate<0,-90.000000,0> translate<74.434700,0.000000,1.765200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<74.917300,0.000000,23.531000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.147900,0.000000,23.761600>}
box{<0,0,-0.127000><0.326118,0.035000,0.127000> rotate<0,-44.997030,0> translate<74.917300,0.000000,23.531000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.147900,0.000000,23.761600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.039000,0.000000,23.761600>}
box{<0,0,-0.127000><1.891100,0.035000,0.127000> rotate<0,0.000000,0> translate<75.147900,0.000000,23.761600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,4.591000>}
box{<0,0,-0.127000><3.443100,0.035000,0.127000> rotate<0,90.000000,0> translate<75.425200,0.000000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.561100,0.000000,1.147900>}
box{<0,0,-0.127000><2.135900,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.438900,0.000000,1.270000>}
box{<0,0,-0.127000><2.013700,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,1.524000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,1.524000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,1.524000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,1.778000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,2.032000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,2.286000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,2.540000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,2.794000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,3.048000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,3.302000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,3.556000>}
box{<0,0,-0.127000><1.989500,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.578000,0.000000,3.810000>}
box{<0,0,-0.127000><2.152800,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,4.064000>}
box{<0,0,-0.127000><2.540100,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,4.318000>}
box{<0,0,-0.127000><2.540100,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,4.572000>}
box{<0,0,-0.127000><2.540100,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.425200,0.000000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,0.000000,4.591000>}
box{<0,0,-0.127000><0.450200,0.035000,0.127000> rotate<0,0.000000,0> translate<75.425200,0.000000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,0.000000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,4.769500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<75.875400,0.000000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,-1.535000,4.591000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,4.769500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<75.875400,-1.535000,4.591000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,0.000000,6.838900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,6.660400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<75.875400,0.000000,6.838900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<75.875400,-1.535000,6.838900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,6.660400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<75.875400,-1.535000,6.838900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,4.769500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,6.660400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<76.053900,0.000000,6.660400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,4.769500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,6.660400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<76.053900,-1.535000,6.660400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,4.826000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,4.826000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,5.080000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,5.080000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,5.334000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,5.334000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,5.588000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,5.588000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,5.842000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,5.842000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,6.096000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,6.096000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,6.350000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,6.350000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,6.604000>}
box{<0,0,-0.127000><1.911400,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.053900,-1.535000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,6.604000>}
box{<0,0,-0.127000><9.175900,0.035000,0.127000> rotate<0,0.000000,0> translate<76.053900,-1.535000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.073000,0.000000,13.056300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,0.000000,12.776300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,67.492017,0> translate<76.073000,0.000000,13.056300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.073000,0.000000,13.359600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.073000,0.000000,13.056300>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.073000,0.000000,13.056300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.073000,0.000000,13.359600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,0.000000,13.639600>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<76.073000,0.000000,13.359600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.173300,-1.535000,12.814300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,-1.535000,12.776300>}
box{<0,0,-0.127000><0.041116,0.035000,0.127000> rotate<0,67.547189,0> translate<76.173300,-1.535000,12.814300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,0.000000,12.776300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,0.000000,12.562000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<76.189000,0.000000,12.776300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,-1.535000,12.776300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,-1.535000,12.562000>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,44.997030,0> translate<76.189000,-1.535000,12.776300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.189000,0.000000,13.639600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,0.000000,13.853900>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.189000,0.000000,13.639600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,0.000000,12.562000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,0.000000,12.446000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<76.403300,0.000000,12.562000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,-1.535000,12.562000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,-1.535000,12.446000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,22.502043,0> translate<76.403300,-1.535000,12.562000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.403300,0.000000,13.853900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,0.000000,13.969900>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<76.403300,0.000000,13.853900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,0.000000,12.446000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<76.683300,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,-1.535000,12.446000>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,0.000000,0> translate<76.683300,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.683300,0.000000,13.969900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,13.969900>}
box{<0,0,-0.127000><0.297700,0.035000,0.127000> rotate<0,0.000000,0> translate<76.683300,0.000000,13.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.798900,-1.535000,33.921600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.125000,-1.535000,33.921600>}
box{<0,0,-0.127000><0.326100,0.035000,0.127000> rotate<0,0.000000,0> translate<76.798900,-1.535000,33.921600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,14.846300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,13.969900>}
box{<0,0,-0.127000><0.876400,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,0.000000,13.969900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.199500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,16.021000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,-1.535000,16.199500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.751300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,16.199500>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,16.199500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.090400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,17.538600>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,17.538600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.090400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,18.268900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,-1.535000,18.090400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.739500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,18.561000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,-1.535000,18.739500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,19.545300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,18.739500>}
box{<0,0,-0.127000><0.805800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,18.739500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,20.630400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,20.332600>}
box{<0,0,-0.127000><0.297800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,20.332600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,20.630400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,20.808900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,-1.535000,20.630400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.279500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,21.101000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,-1.535000,21.279500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.831300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,21.279500>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,21.279500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.170400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,22.618600>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,22.618600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.170400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,23.348900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,-1.535000,23.170400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.039000,0.000000,23.761600>}
box{<0,0,-0.127000><0.081954,0.035000,0.127000> rotate<0,44.947598,0> translate<76.981000,0.000000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,23.641000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,-1.535000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,25.332200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,-1.535000,23.819500>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,-1.535000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,23.819500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,0.000000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,25.888900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,0.000000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,26.181000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,0.000000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,26.359500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,0.000000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,28.428900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,0.000000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,28.721000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,0.000000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,28.899500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,0.000000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,30.968900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,0.000000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,31.261000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<76.981000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,31.439500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<76.981000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.981000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,33.508900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<76.981000,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.024500,0.000000,12.461700>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-22.500200,0> translate<76.986600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.040200,0.000000,12.446000>}
box{<0,0,-0.127000><0.053600,0.035000,0.127000> rotate<0,0.000000,0> translate<76.986600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.266600,-1.535000,12.562000>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-22.502043,0> translate<76.986600,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<76.986600,-1.535000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,12.446000>}
box{<0,0,-0.127000><8.243200,0.035000,0.127000> rotate<0,0.000000,0> translate<76.986600,-1.535000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.024500,0.000000,12.461700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,12.071500>}
box{<0,0,-0.127000><0.551826,0.035000,0.127000> rotate<0,44.997030,0> translate<77.024500,0.000000,12.461700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.125000,-1.535000,33.921600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,33.508900>}
box{<0,0,-0.127000><0.583646,0.035000,0.127000> rotate<0,44.997030,0> translate<77.125000,-1.535000,33.921600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,16.021000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,18.268900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,18.561000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,20.808900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,21.101000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,23.348900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,-1.535000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,23.641000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,-1.535000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,25.888900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,26.181000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,28.428900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,28.721000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,30.968900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,31.261000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.159500,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,33.508900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.159500,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,25.888900>}
box{<0,0,-0.127000><0.413162,0.035000,0.127000> rotate<0,44.987225,0> translate<77.245500,-1.535000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,26.181000>}
box{<0,0,-0.127000><1.804900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.245500,-1.535000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,28.428900>}
box{<0,0,-0.127000><0.413162,0.035000,0.127000> rotate<0,44.987225,0> translate<77.245500,-1.535000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,28.721000>}
box{<0,0,-0.127000><1.804900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.245500,-1.535000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,30.968900>}
box{<0,0,-0.127000><0.413162,0.035000,0.127000> rotate<0,44.987225,0> translate<77.245500,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.245500,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,31.261000>}
box{<0,0,-0.127000><1.804900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.245500,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.264600,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,26.162000>}
box{<0,0,-0.127000><4.886100,0.035000,0.127000> rotate<0,0.000000,0> translate<77.264600,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.264600,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,28.702000>}
box{<0,0,-0.127000><4.886100,0.035000,0.127000> rotate<0,0.000000,0> translate<77.264600,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.264600,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,31.242000>}
box{<0,0,-0.127000><4.886100,0.035000,0.127000> rotate<0,0.000000,0> translate<77.264600,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.264600,-1.535000,33.782000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,33.782000>}
box{<0,0,-0.127000><7.965200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.264600,-1.535000,33.782000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.266600,-1.535000,12.562000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.480900,-1.535000,12.776300>}
box{<0,0,-0.127000><0.303066,0.035000,0.127000> rotate<0,-44.997030,0> translate<77.266600,-1.535000,12.562000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.379000,-1.535000,15.887600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,15.728900>}
box{<0,0,-0.127000><0.224436,0.035000,0.127000> rotate<0,44.997030,0> translate<77.379000,-1.535000,15.887600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.404600,-1.535000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,12.700000>}
box{<0,0,-0.127000><7.825200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.404600,-1.535000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,1.294200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.561100,0.000000,1.147900>}
box{<0,0,-0.127000><0.206970,0.035000,0.127000> rotate<0,44.977457,0> translate<77.414700,0.000000,1.294200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,3.646700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,1.294200>}
box{<0,0,-0.127000><2.352500,0.035000,0.127000> rotate<0,-90.000000,0> translate<77.414700,0.000000,1.294200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,3.646700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.593200,0.000000,3.825200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<77.414700,0.000000,3.646700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,10.394200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.593200,0.000000,10.215700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<77.414700,0.000000,10.394200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,12.071500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.414700,0.000000,10.394200>}
box{<0,0,-0.127000><1.677300,0.035000,0.127000> rotate<0,-90.000000,0> translate<77.414700,0.000000,10.394200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.480900,-1.535000,12.776300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,-1.535000,13.056300>}
box{<0,0,-0.127000><0.303078,0.035000,0.127000> rotate<0,-67.492017,0> translate<77.480900,-1.535000,12.776300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.518600,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,15.748000>}
box{<0,0,-0.127000><4.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.518600,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.518600,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,25.908000>}
box{<0,0,-0.127000><4.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.518600,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.518600,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,28.448000>}
box{<0,0,-0.127000><4.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.518600,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.518600,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,30.988000>}
box{<0,0,-0.127000><4.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.518600,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.518600,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,-1.535000,33.528000>}
box{<0,0,-0.127000><4.632200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.518600,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,15.728900>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<77.537700,-1.535000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,25.888900>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<77.537700,-1.535000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,28.428900>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<77.537700,-1.535000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,30.968900>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<77.537700,-1.535000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.537700,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,33.508900>}
box{<0,0,-0.127000><1.512700,0.035000,0.127000> rotate<0,0.000000,0> translate<77.537700,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.546600,0.000000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,0.000000,13.359600>}
box{<0,0,-0.127000><0.131408,0.035000,0.127000> rotate<0,67.489715,0> translate<77.546600,0.000000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.546600,-1.535000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,-1.535000,13.359600>}
box{<0,0,-0.127000><0.131408,0.035000,0.127000> rotate<0,67.489715,0> translate<77.546600,-1.535000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.546600,0.000000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,13.481000>}
box{<0,0,-0.127000><1.503800,0.035000,0.127000> rotate<0,0.000000,0> translate<77.546600,0.000000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.546600,-1.535000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,13.481000>}
box{<0,0,-0.127000><1.503800,0.035000,0.127000> rotate<0,0.000000,0> translate<77.546600,-1.535000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.554500,-1.535000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,12.954000>}
box{<0,0,-0.127000><7.675300,0.035000,0.127000> rotate<0,0.000000,0> translate<77.554500,-1.535000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.554500,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,13.462000>}
box{<0,0,-0.127000><4.596200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.554500,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.554500,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,13.462000>}
box{<0,0,-0.127000><4.596200,0.035000,0.127000> rotate<0,0.000000,0> translate<77.554500,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.581200,0.000000,13.018400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,0.000000,13.056300>}
box{<0,0,-0.127000><0.041023,0.035000,0.127000> rotate<0,-67.493860,0> translate<77.581200,0.000000,13.018400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.581200,0.000000,13.018400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.674400,0.000000,12.925200>}
box{<0,0,-0.127000><0.131805,0.035000,0.127000> rotate<0,44.997030,0> translate<77.581200,0.000000,13.018400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.593200,0.000000,3.825200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,3.825200>}
box{<0,0,-0.127000><0.372100,0.035000,0.127000> rotate<0,0.000000,0> translate<77.593200,0.000000,3.825200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.593200,0.000000,10.215700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,10.215700>}
box{<0,0,-0.127000><0.372100,0.035000,0.127000> rotate<0,0.000000,0> translate<77.593200,0.000000,10.215700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,0.000000,13.056300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,0.000000,13.359600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<77.596900,0.000000,13.359600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,-1.535000,13.056300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,-1.535000,13.359600>}
box{<0,0,-0.127000><0.303300,0.035000,0.127000> rotate<0,90.000000,0> translate<77.596900,-1.535000,13.359600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,0.000000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,13.208000>}
box{<0,0,-0.127000><7.632900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.596900,0.000000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.596900,-1.535000,13.208000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,13.208000>}
box{<0,0,-0.127000><7.632900,0.035000,0.127000> rotate<0,0.000000,0> translate<77.596900,-1.535000,13.208000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.645600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.964200,0.000000,12.954000>}
box{<0,0,-0.127000><4.318600,0.035000,0.127000> rotate<0,0.000000,0> translate<77.645600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.674400,0.000000,12.925200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,12.925200>}
box{<0,0,-0.127000><1.571300,0.035000,0.127000> rotate<0,0.000000,0> translate<77.674400,0.000000,12.925200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,10.215700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<77.965300,0.000000,3.825200>}
box{<0,0,-0.127000><6.390500,0.035000,0.127000> rotate<0,-90.000000,0> translate<77.965300,0.000000,3.825200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,3.825200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,10.215700>}
box{<0,0,-0.127000><6.390500,0.035000,0.127000> rotate<0,90.000000,0> translate<78.752600,0.000000,10.215700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,3.825200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,3.825200>}
box{<0,0,-0.127000><0.493100,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,3.825200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,4.064000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,4.064000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,4.064000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,4.318000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,4.318000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,4.318000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,4.572000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,4.572000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,4.572000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,4.826000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,4.826000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,4.826000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,5.080000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,5.080000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,5.080000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,5.334000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,5.334000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,5.334000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,5.588000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,5.588000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,5.588000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,5.842000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,5.842000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,5.842000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,6.096000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,6.096000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,6.096000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,6.350000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,6.350000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,6.350000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,6.604000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,6.604000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,6.604000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,6.858000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,6.858000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,6.858000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,7.112000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,7.112000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,7.112000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,7.366000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,7.366000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,7.366000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,7.620000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,7.620000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,7.620000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,7.874000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,7.874000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,7.874000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,8.128000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,8.128000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,8.128000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,8.382000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,8.382000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,8.382000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,8.636000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,8.636000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,8.636000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,8.890000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,8.890000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,8.890000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,9.144000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,9.144000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,9.144000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,9.398000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,9.398000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,9.652000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,9.652000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,9.652000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,9.906000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,9.906000>}
box{<0,0,-0.127000><6.477200,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,9.906000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.991100,0.000000,10.160000>}
box{<0,0,-0.127000><3.238500,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<78.752600,0.000000,10.215700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,10.215700>}
box{<0,0,-0.127000><0.493100,0.035000,0.127000> rotate<0,0.000000,0> translate<78.752600,0.000000,10.215700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,13.659500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,0.000000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,13.659500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,15.550400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,16.199500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.090400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.739500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,20.630400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,21.279500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.170400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.819500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,25.710400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,0.000000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,25.710400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,26.359500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,0.000000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,26.359500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.250400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,0.000000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.250400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.899500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,0.000000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.899500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,30.790400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,0.000000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,30.790400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.050400,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.050400,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.050400,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.170900,0.000000,23.761600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,23.819500>}
box{<0,0,-0.127000><0.081954,0.035000,0.127000> rotate<0,-44.947598,0> translate<79.170900,0.000000,23.761600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.170900,0.000000,23.761600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.579000,0.000000,23.761600>}
box{<0,0,-0.127000><0.408100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.170900,0.000000,23.761600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,15.354300>}
box{<0,0,-0.127000><1.694800,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,0.000000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,15.550400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,15.550400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,13.716000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,13.716000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,13.970000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,13.970000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,14.224000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,14.224000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,14.478000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,14.478000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,14.732000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,14.732000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,14.986000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,14.986000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,15.240000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,15.240000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,15.354300>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,15.354300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,15.494000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,16.199500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.090400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,18.090400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,16.256000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,16.510000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,16.764000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,17.018000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,17.272000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,17.526000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,17.780000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.034000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.739500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,20.630400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,20.630400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.796000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,19.050000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,19.304000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,19.558000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,19.812000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,20.066000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,20.320000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,20.574000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,21.279500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.170400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,23.170400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,21.336000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,21.590000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,21.844000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,22.098000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,22.352000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,22.606000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,22.860000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.114000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,25.710400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,0.000000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,25.710400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,23.876000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.876000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,24.130000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,24.130000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,24.384000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,24.384000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,24.638000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,24.638000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,24.892000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,24.892000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,25.146000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,25.146000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,25.400000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,25.400000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,25.654000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,25.654000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.250400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,0.000000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.250400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,26.416000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,26.416000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,26.670000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,26.670000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,26.924000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,26.924000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,27.178000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,27.178000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,27.432000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,27.432000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,27.686000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,27.686000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,27.940000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,27.940000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.194000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.194000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,30.790400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,0.000000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,30.790400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.956000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.956000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,29.210000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,29.210000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,29.464000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,29.464000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,29.718000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,29.718000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,29.972000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,29.972000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,30.226000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,30.226000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,30.480000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,30.480000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,30.734000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,30.734000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<79.228900,-1.535000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,31.496000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,31.496000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,31.750000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,31.750000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,32.004000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,32.004000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,32.258000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,32.258000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,32.512000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,32.512000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,32.766000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,32.766000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,33.020000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,33.020000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,33.274000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.228900,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,33.274000>}
box{<0,0,-0.127000><0.292100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.228900,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,3.825200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,3.646700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.245700,0.000000,3.825200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,10.215700>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,10.394200>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.245700,0.000000,10.215700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.245700,0.000000,12.925200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,12.746700>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.245700,0.000000,12.925200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.260900,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.010200,0.000000,3.810000>}
box{<0,0,-0.127000><2.749300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.260900,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.277800,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,1.294200>}
box{<0,0,-0.127000><0.206970,0.035000,0.127000> rotate<0,-44.977457,0> translate<79.277800,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.277800,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.013300,0.000000,1.147900>}
box{<0,0,-0.127000><2.735500,0.035000,0.127000> rotate<0,0.000000,0> translate<79.277800,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.399900,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.891100,0.000000,1.270000>}
box{<0,0,-0.127000><2.491200,0.035000,0.127000> rotate<0,0.000000,0> translate<79.399900,0.000000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,1.294200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,3.646700>}
box{<0,0,-0.127000><2.352500,0.035000,0.127000> rotate<0,90.000000,0> translate<79.424200,0.000000,3.646700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,1.524000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,1.524000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,1.524000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,1.778000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.032000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.286000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842100,0.000000,2.540000>}
box{<0,0,-0.127000><3.417900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.794000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,3.048000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,3.302000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,3.556000>}
box{<0,0,-0.127000><2.464300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,10.394200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,12.746700>}
box{<0,0,-0.127000><2.352500,0.035000,0.127000> rotate<0,90.000000,0> translate<79.424200,0.000000,12.746700> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,10.414000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,10.668000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,10.922000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.176000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.430000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742100,0.000000,11.684000>}
box{<0,0,-0.127000><3.317900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.938000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,12.192000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,12.446000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.424200,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,12.700000>}
box{<0,0,-0.127000><2.364300,0.035000,0.127000> rotate<0,0.000000,0> translate<79.424200,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.667900,0.000000,34.994800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<79.444800,0.000000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.667900,-1.535000,34.994800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<79.444800,-1.535000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,35.217900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.444800,0.000000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,35.217900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.444800,-1.535000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,0.000000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<79.444800,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,-1.535000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<79.444800,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,0.000000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<79.444800,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,-1.535000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<79.444800,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,0.000000,36.321800>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.444800,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.444800,-1.535000,36.321800>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.444800,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,13.481000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,0.000000,13.659500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,13.481000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,13.659500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,15.354300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,13.659500>}
box{<0,0,-0.127000><1.694800,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,0.000000,13.659500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,15.550400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,13.659500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,13.659500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,15.550400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,15.728900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,15.550400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,16.199500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,16.021000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,16.199500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.090400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,16.199500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,16.199500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.090400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,18.268900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,18.090400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.739500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,18.561000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,18.739500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,20.630400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,18.739500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,18.739500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,20.630400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,20.808900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,20.630400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,21.279500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,21.101000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,21.279500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.170400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,21.279500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,21.279500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.170400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,23.348900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,23.170400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.579000,0.000000,23.761600>}
box{<0,0,-0.127000><0.081954,0.035000,0.127000> rotate<0,44.947598,0> translate<79.521000,0.000000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,23.641000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,23.819500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,0.000000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,23.819500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,23.819500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,25.888900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,0.000000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,25.710400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,25.888900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,26.181000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,0.000000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,26.181000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,26.359500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,0.000000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,26.359500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,26.359500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,28.428900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,0.000000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.250400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,28.428900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,28.721000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,0.000000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,28.721000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,28.899500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,0.000000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,28.899500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,28.899500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,30.968900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,0.000000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,30.790400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,30.968900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,31.261000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,31.261000>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<79.521000,-1.535000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,31.439500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,0.000000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,31.439500>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,-90.000000,0> translate<79.521000,-1.535000,31.439500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,0.000000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,33.508900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.521000,-1.535000,33.330400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,33.508900>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<79.521000,-1.535000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.667900,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,34.994800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.667900,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.667900,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,34.994800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<79.667900,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,13.481000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,13.481000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,15.728900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,16.021000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,18.268900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,18.561000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,20.808900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,21.101000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,23.348900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,23.641000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,25.888900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,25.888900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,26.181000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,26.181000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,28.428900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,28.428900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,28.721000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,28.721000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,30.968900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,30.968900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,31.261000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,31.261000>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,33.508900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<79.699500,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,33.508900>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,0.000000,0> translate<79.699500,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,0.000000,36.068000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<80.517500,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.517500,-1.535000,36.068000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<80.517500,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,36.067500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<80.518000,0.000000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,36.067500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<80.518000,-1.535000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,35.052000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,0.000000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,35.052000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,-1.535000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,35.306000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,0.000000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,35.306000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,-1.535000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,35.560000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,0.000000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,35.560000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,-1.535000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,35.814000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,0.000000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,35.814000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,-1.535000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,0.000000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,36.067500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,0.000000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.518000,-1.535000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,36.067500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<80.518000,-1.535000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.622000,0.000000,34.994800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<80.771800,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.622000,-1.535000,34.994800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<80.771800,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,0.000000,34.994800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<80.771800,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.771800,-1.535000,34.994800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<80.771800,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,0.000000,36.321800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<80.772400,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,-1.535000,36.321800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<80.772400,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,36.068000>}
box{<0,0,-0.127000><2.285100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,36.068000>}
box{<0,0,-0.127000><2.285100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.772400,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<80.772400,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,15.911000>}
box{<0,0,-0.127000><0.155634,0.035000,0.127000> rotate<0,44.971000,0> translate<80.928500,0.000000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,16.021000>}
box{<0,0,-0.127000><0.661900,0.035000,0.127000> rotate<0,0.000000,0> translate<80.928500,0.000000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,18.451000>}
box{<0,0,-0.127000><0.155634,0.035000,0.127000> rotate<0,44.971000,0> translate<80.928500,0.000000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,18.561000>}
box{<0,0,-0.127000><0.661900,0.035000,0.127000> rotate<0,0.000000,0> translate<80.928500,0.000000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,20.991000>}
box{<0,0,-0.127000><0.155634,0.035000,0.127000> rotate<0,44.971000,0> translate<80.928500,0.000000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,21.101000>}
box{<0,0,-0.127000><0.661900,0.035000,0.127000> rotate<0,0.000000,0> translate<80.928500,0.000000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,23.531000>}
box{<0,0,-0.127000><0.155634,0.035000,0.127000> rotate<0,44.971000,0> translate<80.928500,0.000000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.928500,0.000000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,23.641000>}
box{<0,0,-0.127000><0.661900,0.035000,0.127000> rotate<0,0.000000,0> translate<80.928500,0.000000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.947600,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,16.002000>}
box{<0,0,-0.127000><1.203100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.947600,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.947600,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,18.542000>}
box{<0,0,-0.127000><1.203100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.947600,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.947600,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,21.082000>}
box{<0,0,-0.127000><1.203100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.947600,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<80.947600,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,23.622000>}
box{<0,0,-0.127000><1.203100,0.035000,0.127000> rotate<0,0.000000,0> translate<80.947600,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,15.911000>}
box{<0,0,-0.127000><0.182100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.038600,0.000000,15.911000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,15.728900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,15.748000>}
box{<0,0,-0.127000><1.112200,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,18.451000>}
box{<0,0,-0.127000><0.182100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.038600,0.000000,18.451000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,18.268900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,18.288000>}
box{<0,0,-0.127000><1.112200,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,20.991000>}
box{<0,0,-0.127000><0.182100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.038600,0.000000,20.991000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,20.808900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,20.828000>}
box{<0,0,-0.127000><1.112200,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,23.531000>}
box{<0,0,-0.127000><0.182100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.038600,0.000000,23.531000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,23.348900>}
box{<0,0,-0.127000><0.551800,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.038600,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150800,0.000000,23.368000>}
box{<0,0,-0.127000><1.112200,0.035000,0.127000> rotate<0,0.000000,0> translate<81.038600,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,13.659500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,13.481000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,13.659500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,13.481000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,15.550400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,15.728900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,15.550400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,15.728900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,16.199500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,16.021000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,16.199500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,16.021000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.090400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,18.268900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.090400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,18.268900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.739500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,18.561000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.739500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,18.561000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,20.630400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,20.808900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,20.630400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,20.808900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,21.279500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,21.101000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,21.279500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,21.101000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.170400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,23.348900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.170400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,23.348900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.819500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,23.641000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.819500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,23.641000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,25.710400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,25.888900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,25.710400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,25.888900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,26.359500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,26.181000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,26.359500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,26.181000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.250400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,28.428900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.250400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,28.428900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.899500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,28.721000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.899500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,28.721000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,30.790400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,30.968900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,30.790400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,30.968900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,0.000000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,31.261000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,31.439500>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.590400,-1.535000,31.261000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,0.000000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,0.000000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.590400,-1.535000,33.508900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,33.330400>}
box{<0,0,-0.127000><0.252437,0.035000,0.127000> rotate<0,44.997030,0> translate<81.590400,-1.535000,33.508900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.622000,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,35.217900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.622000,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.622000,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,35.217900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.622000,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.679200,0.000000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,0.000000,35.052000>}
box{<0,0,-0.127000><0.471500,0.035000,0.127000> rotate<0,0.000000,0> translate<81.679200,0.000000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.679200,-1.535000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.150700,-1.535000,35.052000>}
box{<0,0,-0.127000><0.471500,0.035000,0.127000> rotate<0,0.000000,0> translate<81.679200,-1.535000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,15.550400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,15.550400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,13.659500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,15.550400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,15.550400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,13.716000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,13.716000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,13.970000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,13.970000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.224000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.224000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,14.478000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,14.478000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.732000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.732000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.986000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.986000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,15.240000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,15.240000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,15.494000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,15.494000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,16.199500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.090400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,18.090400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,16.199500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.090400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,18.090400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,16.256000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,16.256000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,16.510000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,16.510000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,16.764000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,16.764000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,17.018000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,17.018000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.272000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.272000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.526000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.526000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.780000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.780000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.034000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.034000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.739500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,20.630400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,20.630400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.739500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,20.630400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,20.630400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.796000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.796000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.050000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.050000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.304000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.304000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,19.558000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,19.558000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.812000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.812000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,20.066000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,20.066000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,20.320000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,20.320000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,20.574000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,20.574000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,21.279500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.170400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,23.170400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,21.279500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.170400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,23.170400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,21.336000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,21.336000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,21.590000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,21.590000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,21.844000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,21.844000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,22.098000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,22.098000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.352000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.352000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.606000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.606000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.860000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.860000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.114000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.114000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,25.710400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.819500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,25.710400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,25.710400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.876000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.876000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.130000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.130000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.384000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.384000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,24.638000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,24.638000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.892000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.892000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,25.146000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,25.146000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,25.400000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,25.400000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,25.654000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,25.654000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.250400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,26.359500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.250400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,28.250400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,26.416000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,26.416000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,26.670000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,26.670000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,26.924000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,26.924000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,27.178000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,27.178000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.432000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.432000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.686000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.686000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.940000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.940000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.194000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.194000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,30.790400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.899500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,30.790400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,30.790400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.956000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.956000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.210000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.210000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.464000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.464000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,29.718000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,29.718000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.972000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.972000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,30.226000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,30.226000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,30.480000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,30.480000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,30.734000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,30.734000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,0.000000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,31.439500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,33.330400>}
box{<0,0,-0.127000><1.890900,0.035000,0.127000> rotate<0,90.000000,0> translate<81.768900,-1.535000,33.330400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,31.496000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,31.496000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,31.750000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.004000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.004000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,32.258000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,32.258000>}
box{<0,0,-0.127000><1.288600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.512000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.512000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.766000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.766000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,33.020000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,33.020000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,33.274000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.768900,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,33.274000>}
box{<0,0,-0.127000><0.215900,0.035000,0.127000> rotate<0,0.000000,0> translate<81.768900,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,10.362600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.011600,0.000000,10.139500>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.788500,0.000000,10.362600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,10.362600>}
box{<0,0,-0.127000><1.081000,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.788500,0.000000,10.362600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742100,0.000000,11.443600>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.788500,0.000000,11.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.697200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742100,0.000000,11.697200>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.788500,0.000000,11.697200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,12.778300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,11.697200>}
box{<0,0,-0.127000><1.081100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.788500,0.000000,11.697200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.788500,0.000000,12.778300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.011600,0.000000,13.001400>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.788500,0.000000,12.778300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.068000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.845100,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.068000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<81.845100,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,35.306000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,35.306000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,35.560000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,35.560000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,35.814000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,35.814000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.977400>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,90.000000,0> translate<81.845100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.977400>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,90.000000,0> translate<81.845100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.322000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.322000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.576000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.576000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.830000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.830000>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.977400>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.845100,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.977400>}
box{<0,0,-0.127000><0.139700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.845100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,1.272600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.013300,0.000000,1.147900>}
box{<0,0,-0.127000><0.176423,0.035000,0.127000> rotate<0,44.974067,0> translate<81.888500,0.000000,1.272600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.353600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,1.272600>}
box{<0,0,-0.127000><1.081000,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.888500,0.000000,1.272600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.353600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842100,0.000000,2.353600>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.888500,0.000000,2.353600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.607200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842100,0.000000,2.607200>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<81.888500,0.000000,2.607200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,3.688300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,2.607200>}
box{<0,0,-0.127000><1.081100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.888500,0.000000,2.607200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.888500,0.000000,3.688300>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.111600,0.000000,3.911400>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.888500,0.000000,3.688300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,13.627900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,13.404800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,13.627900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,13.627900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,13.404800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,13.627900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,13.627900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,13.627900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,13.627900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,13.627900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,14.478000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,14.478000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,14.731800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,14.731800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,15.582000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,14.731800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,15.582000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,14.731800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,15.582000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,15.805100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,15.582000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,15.582000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,15.805100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,15.582000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,16.167900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,15.944800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,16.167900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,16.167900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,15.944800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,16.167900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,16.167900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,16.167900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,16.167900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,16.167900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,17.018000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,17.018000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,17.271800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,17.271800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.122000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,17.271800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.122000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,17.271800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.122000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,18.345100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,18.122000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.122000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,18.345100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,18.122000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.707900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,18.484800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,18.707900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.707900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,18.484800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,18.707900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,18.707900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,18.707900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,18.707900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,18.707900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,19.558000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,19.558000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,19.811800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,19.811800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,20.662000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,19.811800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,20.662000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,19.811800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,20.662000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,20.885100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,20.662000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,20.662000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,20.885100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,20.662000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,21.247900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,21.024800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,21.247900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,21.247900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,21.024800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,21.247900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,21.247900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,21.247900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,21.247900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,21.247900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,22.098000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,22.098000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,22.351800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,22.351800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.202000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,22.351800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.202000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,22.351800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.202000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,23.425100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,23.202000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.202000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,23.425100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,23.202000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.787900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,23.564800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,23.787900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.787900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,23.564800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,23.787900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,23.787900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,23.787900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,23.787900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,23.787900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,24.638000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,24.638000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,24.891800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,24.891800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,25.742000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,24.891800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,25.742000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,24.891800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,25.742000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,25.965100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,25.742000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,25.742000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,25.965100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,25.742000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,26.327900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,26.104800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,26.327900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,26.327900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,26.104800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,26.327900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,26.327900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,26.327900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,26.327900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,26.327900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,27.178000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,27.178000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,27.431800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,27.431800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.282000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,27.431800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.282000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,27.431800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.282000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,28.505100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,28.282000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.282000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,28.505100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,28.282000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.867900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,28.644800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,28.867900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.867900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,28.644800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,28.867900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,28.867900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,28.867900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,28.867900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,28.867900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,29.718000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,29.718000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,29.971800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,29.971800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,30.822000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,29.971800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,30.822000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,29.971800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,30.822000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,31.045100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,30.822000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,30.822000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,31.045100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,30.822000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,31.184800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,31.184800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,31.407900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,31.407900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,31.407900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,32.511800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,32.511800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,33.585100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,0.000000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,33.362000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,33.585100>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<81.984800,-1.535000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,34.994800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,0.000000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,34.994800>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<81.984800,-1.535000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,35.217900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,35.217900>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,35.217900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<81.984800,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,0.000000,36.321800>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<81.984800,-1.535000,36.321800>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,-90.000000,0> translate<81.984800,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.011600,0.000000,10.139500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.139500>}
box{<0,0,-0.127000><0.731000,0.035000,0.127000> rotate<0,0.000000,0> translate<82.011600,0.000000,10.139500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.011600,0.000000,13.001400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,13.001400>}
box{<0,0,-0.127000><0.731000,0.035000,0.127000> rotate<0,0.000000,0> translate<82.011600,0.000000,13.001400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.111600,0.000000,3.911400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.911400>}
box{<0,0,-0.127000><0.731000,0.035000,0.127000> rotate<0,0.000000,0> translate<82.111600,0.000000,3.911400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,13.404800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,13.404800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.805100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.805100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.944800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.944800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.345100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.345100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.484800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.484800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.885100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.885100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.024800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.024800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.425100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.425100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.564800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.564800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.965100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.965100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.104800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.104800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.505100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.505100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.644800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.644800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.045100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.045100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.184800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.184800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,33.585100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,33.585100>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,34.994800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.207900,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,34.994800>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.207900,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742100,0.000000,11.697200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742100,0.000000,11.443600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<82.742100,0.000000,11.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.139500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.443100>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,90.000000,0> translate<82.742600,0.000000,11.443100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.160000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.414000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.668000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.922000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.176000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.430000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.443100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.443100>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,11.443100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.697800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,13.001400>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,90.000000,0> translate<82.742600,0.000000,13.001400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.697800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.697800>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,11.697800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.938000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,12.192000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,12.446000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,12.700000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.742600,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,12.954000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.742600,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842100,0.000000,2.607200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842100,0.000000,2.353600>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,-90.000000,0> translate<82.842100,0.000000,2.353600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,2.607800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.911400>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,90.000000,0> translate<82.842600,0.000000,3.911400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,2.607800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,2.607800>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,2.607800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,2.794000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.048000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.302000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.556000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.842600,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.810000>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.842600,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.139500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.727300,0.000000,10.139500>}
box{<0,0,-0.127000><0.731100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.996200,0.000000,10.139500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.443100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,10.139500>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,-90.000000,0> translate<82.996200,0.000000,10.139500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,13.001400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,11.697800>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,-90.000000,0> translate<82.996200,0.000000,11.697800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996200,0.000000,13.001400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.727300,0.000000,13.001400>}
box{<0,0,-0.127000><0.731100,0.035000,0.127000> rotate<0,0.000000,0> translate<82.996200,0.000000,13.001400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996800,0.000000,11.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996800,0.000000,11.697200>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<82.996800,0.000000,11.697200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996800,0.000000,11.443600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.443600>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.996800,0.000000,11.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996800,0.000000,11.684000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,11.684000>}
box{<0,0,-0.127000><2.233000,0.035000,0.127000> rotate<0,0.000000,0> translate<82.996800,0.000000,11.684000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<82.996800,0.000000,11.697200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.697200>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<82.996800,0.000000,11.697200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,14.478000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,14.478000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,17.018000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,17.018000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,19.558000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,19.558000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,22.098000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,22.098000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,24.638000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,24.638000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,27.178000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,27.178000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,29.718000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,29.718000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,32.258000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,32.258000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,0.000000,36.068000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.057500,-1.535000,36.068000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.057500,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.477500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,14.477500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.477500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,14.477500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,13.462000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,13.462000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,13.716000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,13.716000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,13.970000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,13.970000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.224000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.224000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.477500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.477500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,14.477500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.477500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.477500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,14.477500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.732400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.805100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.732400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.805100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.732400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.732400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,14.732400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.732400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.732400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,14.732400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.986000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.986000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.240000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.240000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.494000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.494000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.748000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.748000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.017500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,17.017500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.017500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,17.017500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,16.002000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,16.002000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,16.256000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,16.256000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,16.510000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,16.510000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,16.764000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,16.764000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.017500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.017500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,17.017500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.017500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.017500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,17.017500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.272400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.345100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.272400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.345100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.272400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.272400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,17.272400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.272400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.272400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,17.272400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.526000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.526000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.780000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.780000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.034000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.034000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.288000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.288000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.557500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,19.557500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.557500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,19.557500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.542000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.542000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.796000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.796000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.050000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.050000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.304000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.304000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.557500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.557500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,19.557500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.557500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.557500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,19.557500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.812400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.885100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.812400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.885100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,19.812400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.812400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,19.812400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,19.812400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.812400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,19.812400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.066000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.066000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.320000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.320000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.574000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.574000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.828000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.828000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.097500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,22.097500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.097500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,22.097500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.082000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.082000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.336000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.336000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.590000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.590000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.844000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.844000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.097500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.097500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,22.097500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.097500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.097500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,22.097500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.352400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.425100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.352400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.425100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.352400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.352400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,22.352400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.352400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.352400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,22.352400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.606000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.606000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.860000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.860000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.114000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.114000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.368000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.368000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.637500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,24.637500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.637500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,24.637500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.622000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.622000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.876000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.876000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.130000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.130000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.384000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.384000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.637500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.637500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,24.637500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.637500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.637500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,24.637500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.892400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.965100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.892400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.965100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,24.892400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.892400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,24.892400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,24.892400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.892400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,24.892400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.146000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.146000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.400000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.400000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.654000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.908000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.177500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,27.177500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.177500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,27.177500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.162000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.416000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.670000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.670000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.924000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.924000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.177500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.177500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,27.177500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.177500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.177500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,27.177500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.432400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.505100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.432400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.505100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.432400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.432400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,27.432400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.432400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.432400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,27.432400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.686000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.686000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.940000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.940000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.194000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.194000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.448000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.448000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.717500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,29.717500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.717500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,29.717500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.702000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.702000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.956000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.956000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.210000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.210000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.464000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.464000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.717500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.717500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,29.717500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.717500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.717500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,29.717500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.972400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.045100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.972400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.045100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,29.972400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.972400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,29.972400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,29.972400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.972400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,29.972400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,30.226000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,30.226000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,30.480000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,30.480000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,30.734000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,30.734000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,30.988000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,30.988000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.257500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.257500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.242000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.242000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.496000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.496000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.750000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.004000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.004000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.257500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.257500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,32.257500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,33.585100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,33.585100>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.512400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.512400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.512400>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.766000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.766000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,33.020000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,33.020000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,33.274000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,33.274000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,33.528000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,33.528000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,36.067500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,0.000000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,36.067500>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,90.000000,0> translate<83.058000,-1.535000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,35.052000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,35.052000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,35.306000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,35.306000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,35.560000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,35.560000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,35.814000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,35.814000>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,0.000000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,36.067500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,0.000000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.058000,-1.535000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,36.067500>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,0.000000,0> translate<83.058000,-1.535000,36.067500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.911400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,2.607800>}
box{<0,0,-0.127000><1.303600,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.096200,0.000000,2.607800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096200,0.000000,3.911400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.827300,0.000000,3.911400>}
box{<0,0,-0.127000><0.731100,0.035000,0.127000> rotate<0,0.000000,0> translate<83.096200,0.000000,3.911400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096800,0.000000,2.353600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096800,0.000000,2.607200>}
box{<0,0,-0.127000><0.253600,0.035000,0.127000> rotate<0,90.000000,0> translate<83.096800,0.000000,2.607200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096800,0.000000,2.353600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.353600>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<83.096800,0.000000,2.353600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096800,0.000000,2.540000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,2.540000>}
box{<0,0,-0.127000><2.133000,0.035000,0.127000> rotate<0,0.000000,0> translate<83.096800,0.000000,2.540000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.096800,0.000000,2.607200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.607200>}
box{<0,0,-0.127000><0.953600,0.035000,0.127000> rotate<0,0.000000,0> translate<83.096800,0.000000,2.607200> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,13.404800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,13.404800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.477500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,13.404800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.477500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,13.404800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,14.732400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,14.732400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,14.732400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,14.732400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,15.805100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,15.805100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,15.944800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,15.944800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.017500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,15.944800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.017500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,15.944800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,17.272400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,17.272400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,17.272400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,17.272400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,18.345100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,18.345100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,18.484800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,18.484800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.557500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,18.484800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.557500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,18.484800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,19.812400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,19.812400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,19.812400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,19.812400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,20.885100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,20.885100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,21.024800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,21.024800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.097500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,21.024800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.097500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,21.024800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,22.352400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,22.352400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,22.352400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,22.352400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,23.425100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,23.425100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,23.564800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,23.564800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.637500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,23.564800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.637500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,23.564800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,24.892400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,24.892400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,24.892400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,24.892400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,25.965100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,25.965100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,26.104800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,26.104800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.177500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,26.104800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.177500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,26.104800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,27.432400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,27.432400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,27.432400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,27.432400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,28.505100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,28.505100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,28.644800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,28.644800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.717500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,28.644800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.717500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,28.644800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,29.972400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,29.972400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,29.972400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,29.972400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,31.045100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,31.045100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,31.184800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,31.184800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,31.184800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.257500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,31.184800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,32.512400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,32.512400>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,32.512400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,33.585100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,33.585100>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,34.994800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,34.994800>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.311800,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,0.000000,34.994800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,36.067500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.311800,-1.535000,34.994800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,-90.000000,0> translate<83.311800,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,14.731800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,14.731800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.478000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.478000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,14.478000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,14.478000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,14.478000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.731800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.731800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,14.731800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,17.271800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,17.271800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.018000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.018000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,17.018000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,17.018000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,17.018000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.271800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.271800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,17.271800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,19.811800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,19.811800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.558000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.558000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,19.558000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,19.558000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,19.558000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.811800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.811800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,19.811800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,22.351800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,22.351800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.098000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.098000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,22.098000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,22.098000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,22.098000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.351800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.351800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,22.351800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,24.891800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,24.891800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.638000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.638000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,24.638000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,24.638000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,24.638000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.891800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.891800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,24.891800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,27.431800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,27.431800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.178000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.178000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,27.178000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,27.178000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,27.178000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.431800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.431800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,27.431800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,29.971800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,29.971800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.718000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.718000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,29.718000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,29.718000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,29.718000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.971800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.971800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,29.971800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,32.511800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,32.511800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.258000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,32.258000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,32.258000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,32.258000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.511800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,32.511800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,36.321800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,36.321800>}
box{<0,0,-0.127000><0.253800,0.035000,0.127000> rotate<0,90.000000,0> translate<83.312400,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.068000>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.068000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,36.068000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.068000>}
box{<0,0,-0.127000><1.917400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,0.000000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.312400,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.321800>}
box{<0,0,-0.127000><1.072700,0.035000,0.127000> rotate<0,0.000000,0> translate<83.312400,-1.535000,36.321800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.727300,0.000000,10.139500>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,10.362600>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<83.727300,0.000000,10.139500> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.727300,0.000000,13.001400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,12.778300>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<83.727300,0.000000,13.001400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.747800,0.000000,10.160000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,10.160000>}
box{<0,0,-0.127000><1.482000,0.035000,0.127000> rotate<0,0.000000,0> translate<83.747800,0.000000,10.160000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.774700,0.000000,12.954000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,12.954000>}
box{<0,0,-0.127000><1.455100,0.035000,0.127000> rotate<0,0.000000,0> translate<83.774700,0.000000,12.954000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.827300,0.000000,3.911400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,3.688300>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<83.827300,0.000000,3.911400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.925600,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,1.272600>}
box{<0,0,-0.127000><0.176423,0.035000,0.127000> rotate<0,-44.974067,0> translate<83.925600,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.925600,0.000000,1.147900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,1.147900>}
box{<0,0,-0.127000><1.304200,0.035000,0.127000> rotate<0,0.000000,0> translate<83.925600,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.928700,0.000000,3.810000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,3.810000>}
box{<0,0,-0.127000><1.301100,0.035000,0.127000> rotate<0,0.000000,0> translate<83.928700,0.000000,3.810000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,10.362600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.443600>}
box{<0,0,-0.127000><1.081000,0.035000,0.127000> rotate<0,90.000000,0> translate<83.950400,0.000000,11.443600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,10.414000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,10.414000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,10.414000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,10.668000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,10.668000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,10.668000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,10.922000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,10.922000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,10.922000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.176000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,11.176000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,11.176000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.430000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,11.430000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,11.430000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.697200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,12.778300>}
box{<0,0,-0.127000><1.081100,0.035000,0.127000> rotate<0,90.000000,0> translate<83.950400,0.000000,12.778300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,11.938000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,11.938000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,11.938000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,12.192000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,12.192000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,12.192000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,12.446000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,12.446000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,12.446000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<83.950400,0.000000,12.700000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,12.700000>}
box{<0,0,-0.127000><1.279400,0.035000,0.127000> rotate<0,0.000000,0> translate<83.950400,0.000000,12.700000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.047700,0.000000,1.270000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,1.270000>}
box{<0,0,-0.127000><1.182100,0.035000,0.127000> rotate<0,0.000000,0> translate<84.047700,0.000000,1.270000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,1.272600>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.353600>}
box{<0,0,-0.127000><1.081000,0.035000,0.127000> rotate<0,90.000000,0> translate<84.050400,0.000000,2.353600> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,1.524000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,1.524000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,1.524000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,1.778000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,1.778000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,1.778000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.032000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,2.032000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,2.032000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.286000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,2.286000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,2.286000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.607200>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,3.688300>}
box{<0,0,-0.127000><1.081100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.050400,0.000000,3.688300> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,2.794000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,2.794000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,2.794000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,3.048000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,3.048000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,3.048000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,3.302000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,3.302000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,3.302000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.050400,0.000000,3.556000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,3.556000>}
box{<0,0,-0.127000><1.179400,0.035000,0.127000> rotate<0,0.000000,0> translate<84.050400,0.000000,3.556000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,13.627900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,13.404800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,13.627900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,13.404800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,15.582000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,15.805100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,15.582000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,15.805100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,16.167900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,15.944800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,16.167900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,15.944800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.122000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,18.345100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.122000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,18.345100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.707900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,18.484800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.707900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,18.484800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,20.662000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,20.885100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,20.662000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,20.885100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,21.247900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,21.024800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,21.247900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,21.024800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.202000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,23.425100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.202000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,23.425100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.787900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,23.564800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.787900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,23.564800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,25.742000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,25.965100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,25.742000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,25.965100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,26.327900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,26.104800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,26.327900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,26.104800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.282000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,28.505100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.282000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,28.505100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.867900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,28.644800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.867900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,28.644800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,30.822000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,31.045100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,30.822000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,31.045100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,31.407900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,31.184800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,31.407900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,31.184800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,33.362000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,0.000000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,33.585100>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,33.362000>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,44.997030,0> translate<84.162000,-1.535000,33.585100> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,0.000000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,35.217900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,0.000000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.162000,-1.535000,34.994800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,35.217900>}
box{<0,0,-0.127000><0.315511,0.035000,0.127000> rotate<0,-44.997030,0> translate<84.162000,-1.535000,34.994800> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,15.748000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,15.748000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,15.748000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,15.748000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,18.288000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,18.288000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,18.288000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,18.288000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,20.828000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,20.828000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,20.828000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,20.828000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,23.368000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,23.368000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,23.368000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,23.368000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,25.908000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,25.908000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,25.908000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,25.908000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,28.448000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,28.448000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,28.448000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,28.448000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,30.988000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,30.988000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,30.988000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,30.988000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,0.000000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,33.528000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,0.000000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219100,-1.535000,33.528000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,33.528000>}
box{<0,0,-0.127000><1.010700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219100,-1.535000,33.528000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,13.462000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,13.462000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,13.462000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,13.462000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,16.002000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,16.002000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,16.002000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,16.002000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,18.542000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,18.542000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,18.542000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,18.542000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,21.082000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,21.082000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,21.082000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,21.082000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,23.622000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,23.622000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,23.622000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,23.622000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,26.162000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,26.162000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,26.162000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,26.162000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,28.702000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,28.702000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,28.702000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,28.702000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,31.242000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,31.242000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,31.242000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,31.242000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,0.000000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,35.052000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,0.000000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.219200,-1.535000,35.052000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,35.052000>}
box{<0,0,-0.127000><1.010600,0.035000,0.127000> rotate<0,0.000000,0> translate<84.219200,-1.535000,35.052000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,13.627900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.478000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,13.627900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.478000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,14.478000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,13.716000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,13.716000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,13.716000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,13.716000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,13.970000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,13.970000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,13.970000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,13.970000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,14.224000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.224000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,14.224000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,14.224000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,15.582000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,15.582000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.731800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,15.582000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,15.582000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,14.732000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.732000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,14.732000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,14.732000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,14.986000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,14.986000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,14.986000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,14.986000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,15.240000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,15.240000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,15.240000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,15.240000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,15.494000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,15.494000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,15.494000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,15.494000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,16.167900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.018000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,16.167900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.018000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,17.018000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,16.256000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,16.256000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,16.256000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,16.256000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,16.510000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,16.510000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,16.510000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,16.510000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,16.764000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,16.764000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,16.764000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,16.764000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.122000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,18.122000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.271800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.122000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,18.122000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,17.272000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.272000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,17.272000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,17.272000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,17.526000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.526000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,17.526000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,17.526000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,17.780000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,17.780000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,17.780000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,17.780000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,18.034000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.034000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,18.034000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,18.034000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.707900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.558000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.707900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.558000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,19.558000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,18.796000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,18.796000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,18.796000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,18.796000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,19.050000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.050000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,19.050000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,19.050000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,19.304000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.304000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,19.304000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,19.304000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,20.662000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,20.662000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.811800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,20.662000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,20.662000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,19.812000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,19.812000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,19.812000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,19.812000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,20.066000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,20.066000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,20.066000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,20.066000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,20.320000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,20.320000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,20.320000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,20.320000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,20.574000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,20.574000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,20.574000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,20.574000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,21.247900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.098000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,21.247900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.098000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,22.098000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,21.336000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,21.336000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,21.336000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,21.336000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,21.590000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,21.590000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,21.590000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,21.590000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,21.844000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,21.844000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,21.844000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,21.844000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.202000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,23.202000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.351800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.202000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,23.202000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,22.352000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.352000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,22.352000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,22.352000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,22.606000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.606000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,22.606000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,22.606000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,22.860000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,22.860000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,22.860000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,22.860000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,23.114000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.114000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,23.114000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,23.114000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.787900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.638000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.787900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.638000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,24.638000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,23.876000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,23.876000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,23.876000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,23.876000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,24.130000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.130000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,24.130000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,24.130000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,24.384000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.384000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,24.384000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,24.384000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,25.742000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,25.742000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.891800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,25.742000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,25.742000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,24.892000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,24.892000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,24.892000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,24.892000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,25.146000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,25.146000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,25.146000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,25.146000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,25.400000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,25.400000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,25.400000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,25.400000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,25.654000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,25.654000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,25.654000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,25.654000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,26.327900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.178000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,26.327900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.178000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,27.178000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,26.416000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,26.416000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,26.416000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,26.416000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,26.670000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,26.670000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,26.670000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,26.670000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,26.924000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,26.924000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,26.924000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,26.924000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.282000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,28.282000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.431800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.282000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,28.282000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,27.432000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.432000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,27.432000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,27.432000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,27.686000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.686000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,27.686000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,27.686000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,27.940000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,27.940000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,27.940000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,27.940000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,28.194000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.194000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,28.194000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,28.194000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.867900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.718000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.867900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.718000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,29.718000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,28.956000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,28.956000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,28.956000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,28.956000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,29.210000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.210000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,29.210000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,29.210000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,29.464000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.464000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,29.464000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,29.464000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,30.822000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,30.822000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.971800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,30.822000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,30.822000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,29.972000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,29.972000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,29.972000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,29.972000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,30.226000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,30.226000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,30.226000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,30.226000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,30.480000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,30.480000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,30.480000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,30.480000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,30.734000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,30.734000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,30.734000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,30.734000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.258000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,31.407900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.258000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,32.258000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,31.496000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,31.496000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,31.496000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,31.496000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,31.750000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,31.750000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,31.750000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,31.750000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,32.004000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.004000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,32.004000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,32.004000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,33.362000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.511800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,33.362000>}
box{<0,0,-0.127000><0.850200,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,33.362000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,32.512000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.512000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,32.512000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,32.512000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,32.766000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,32.766000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,32.766000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,32.766000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,33.020000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,33.020000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,33.020000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,33.020000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,33.274000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,33.274000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,33.274000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,33.274000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.068000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,35.217900>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.068000>}
box{<0,0,-0.127000><0.850100,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,36.068000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,35.306000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,35.306000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,35.306000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,35.306000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,35.560000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,35.560000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,35.560000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,35.560000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,35.814000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,35.814000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,35.814000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,35.814000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.977400>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.321800>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.977400>}
box{<0,0,-0.127000><0.655600,0.035000,0.127000> rotate<0,90.000000,0> translate<84.385100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.322000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.322000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.322000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,36.322000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.576000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.576000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.576000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,36.576000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.830000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.830000>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.830000>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,36.830000> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.977400>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,0.000000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<84.385100,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.977400>}
box{<0,0,-0.127000><0.844700,0.035000,0.127000> rotate<0,0.000000,0> translate<84.385100,-1.535000,36.977400> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,0.000000,1.147900>}
box{<0,0,-0.127000><35.829500,0.035000,0.127000> rotate<0,-90.000000,0> translate<85.229800,0.000000,1.147900> }
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,36.977400>}
cylinder{<0,0,0><0,0.035000,0>0.127000 translate<85.229800,-1.535000,1.147900>}
box{<0,0,-0.127000><35.829500,0.035000,0.127000> rotate<0,-90.000000,0> translate<85.229800,-1.535000,1.147900> }
texture{col_pol}
}
#end
union{
cylinder{<74.930000,0.038000,5.715000><74.930000,-1.538000,5.715000>0.546100}
cylinder{<72.390000,0.038000,5.715000><72.390000,-1.538000,5.715000>0.546100}
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<6.400000,0.038000,17.300000><6.400000,-1.538000,17.300000>0.495300 }
cylinder{<6.400000,0.038000,20.800000><6.400000,-1.538000,20.800000>0.495300 }
cylinder{<78.105000,0.038000,32.385000><78.105000,-1.538000,32.385000>0.546100}
cylinder{<78.105000,0.038000,29.845000><78.105000,-1.538000,29.845000>0.546100}
cylinder{<78.105000,0.038000,27.305000><78.105000,-1.538000,27.305000>0.546100}
cylinder{<78.105000,0.038000,24.765000><78.105000,-1.538000,24.765000>0.546100}
cylinder{<78.105000,0.038000,22.225000><78.105000,-1.538000,22.225000>0.546100}
cylinder{<78.105000,0.038000,19.685000><78.105000,-1.538000,19.685000>0.546100}
cylinder{<78.105000,0.038000,17.145000><78.105000,-1.538000,17.145000>0.546100}
cylinder{<78.105000,0.038000,14.605000><78.105000,-1.538000,14.605000>0.546100}
cylinder{<80.645000,0.038000,32.385000><80.645000,-1.538000,32.385000>0.546100}
cylinder{<80.645000,0.038000,29.845000><80.645000,-1.538000,29.845000>0.546100}
cylinder{<80.645000,0.038000,27.305000><80.645000,-1.538000,27.305000>0.546100}
cylinder{<80.645000,0.038000,24.765000><80.645000,-1.538000,24.765000>0.546100}
cylinder{<80.645000,0.038000,22.225000><80.645000,-1.538000,22.225000>0.546100}
cylinder{<80.645000,0.038000,19.685000><80.645000,-1.538000,19.685000>0.546100}
cylinder{<80.645000,0.038000,17.145000><80.645000,-1.538000,17.145000>0.546100}
cylinder{<80.645000,0.038000,14.605000><80.645000,-1.538000,14.605000>0.546100}
cylinder{<83.185000,0.038000,32.385000><83.185000,-1.538000,32.385000>0.546100}
cylinder{<83.185000,0.038000,29.845000><83.185000,-1.538000,29.845000>0.546100}
cylinder{<83.185000,0.038000,27.305000><83.185000,-1.538000,27.305000>0.546100}
cylinder{<83.185000,0.038000,24.765000><83.185000,-1.538000,24.765000>0.546100}
cylinder{<83.185000,0.038000,22.225000><83.185000,-1.538000,22.225000>0.546100}
cylinder{<83.185000,0.038000,19.685000><83.185000,-1.538000,19.685000>0.546100}
cylinder{<83.185000,0.038000,17.145000><83.185000,-1.538000,17.145000>0.546100}
cylinder{<83.185000,0.038000,14.605000><83.185000,-1.538000,14.605000>0.546100}
cylinder{<59.055000,0.038000,17.780000><59.055000,-1.538000,17.780000>0.546100}
cylinder{<59.055000,0.038000,25.400000><59.055000,-1.538000,25.400000>0.546100}
cylinder{<59.055000,0.038000,20.320000><59.055000,-1.538000,20.320000>0.546100}
cylinder{<59.055000,0.038000,22.860000><59.055000,-1.538000,22.860000>0.546100}
cylinder{<50.800000,0.038000,17.780000><50.800000,-1.538000,17.780000>0.546100}
cylinder{<50.800000,0.038000,25.400000><50.800000,-1.538000,25.400000>0.546100}
cylinder{<50.800000,0.038000,20.320000><50.800000,-1.538000,20.320000>0.546100}
cylinder{<50.800000,0.038000,22.860000><50.800000,-1.538000,22.860000>0.546100}
cylinder{<6.350000,0.038000,32.385000><6.350000,-1.538000,32.385000>0.546100}
cylinder{<8.890000,0.038000,32.385000><8.890000,-1.538000,32.385000>0.546100}
cylinder{<80.645000,0.038000,36.195000><80.645000,-1.538000,36.195000>0.546100}
cylinder{<83.185000,0.038000,36.195000><83.185000,-1.538000,36.195000>0.546100}
cylinder{<10.160000,0.038000,7.620000><10.160000,-1.538000,7.620000>0.508000}
cylinder{<2.540000,0.038000,30.480000><2.540000,-1.538000,30.480000>0.508000}
cylinder{<25.400000,0.038000,30.480000><25.400000,-1.538000,30.480000>0.508000}
cylinder{<22.860000,0.038000,30.480000><22.860000,-1.538000,30.480000>0.508000}
cylinder{<68.580000,0.038000,30.480000><68.580000,-1.538000,30.480000>0.508000}
cylinder{<2.540000,0.038000,7.620000><2.540000,-1.538000,7.620000>0.508000}
cylinder{<22.860000,0.038000,7.620000><22.860000,-1.538000,7.620000>0.508000}
cylinder{<25.400000,0.038000,7.620000><25.400000,-1.538000,7.620000>0.508000}
cylinder{<53.340000,0.038000,7.620000><53.340000,-1.538000,7.620000>0.508000}
cylinder{<55.880000,0.038000,7.620000><55.880000,-1.538000,7.620000>0.508000}
cylinder{<27.940000,0.038000,30.480000><27.940000,-1.538000,30.480000>0.508000}
cylinder{<30.480000,0.038000,30.480000><30.480000,-1.538000,30.480000>0.508000}
cylinder{<20.320000,0.038000,7.620000><20.320000,-1.538000,7.620000>0.508000}
cylinder{<17.780000,0.038000,7.620000><17.780000,-1.538000,7.620000>0.508000}
cylinder{<15.240000,0.038000,7.620000><15.240000,-1.538000,7.620000>0.508000}
cylinder{<12.700000,0.038000,7.620000><12.700000,-1.538000,7.620000>0.508000}
cylinder{<33.020000,0.038000,30.480000><33.020000,-1.538000,30.480000>0.508000}
cylinder{<35.560000,0.038000,30.480000><35.560000,-1.538000,30.480000>0.508000}
cylinder{<33.020000,0.038000,7.620000><33.020000,-1.538000,7.620000>0.508000}
cylinder{<35.560000,0.038000,7.620000><35.560000,-1.538000,7.620000>0.508000}
cylinder{<30.480000,0.038000,7.620000><30.480000,-1.538000,7.620000>0.508000}
cylinder{<27.940000,0.038000,7.620000><27.940000,-1.538000,7.620000>0.508000}
cylinder{<58.420000,0.038000,7.620000><58.420000,-1.538000,7.620000>0.508000}
cylinder{<60.960000,0.038000,7.620000><60.960000,-1.538000,7.620000>0.508000}
cylinder{<38.100000,0.038000,7.620000><38.100000,-1.538000,7.620000>0.508000}
cylinder{<40.640000,0.038000,7.620000><40.640000,-1.538000,7.620000>0.508000}
cylinder{<43.180000,0.038000,7.620000><43.180000,-1.538000,7.620000>0.508000}
cylinder{<45.720000,0.038000,7.620000><45.720000,-1.538000,7.620000>0.508000}
cylinder{<63.500000,0.038000,7.620000><63.500000,-1.538000,7.620000>0.508000}
cylinder{<66.040000,0.038000,7.620000><66.040000,-1.538000,7.620000>0.508000}
cylinder{<48.260000,0.038000,7.620000><48.260000,-1.538000,7.620000>0.508000}
cylinder{<50.800000,0.038000,7.620000><50.800000,-1.538000,7.620000>0.508000}
cylinder{<38.100000,0.038000,30.480000><38.100000,-1.538000,30.480000>0.508000}
cylinder{<40.640000,0.038000,30.480000><40.640000,-1.538000,30.480000>0.508000}
cylinder{<43.180000,0.038000,30.480000><43.180000,-1.538000,30.480000>0.508000}
cylinder{<45.720000,0.038000,30.480000><45.720000,-1.538000,30.480000>0.508000}
cylinder{<48.260000,0.038000,30.480000><48.260000,-1.538000,30.480000>0.508000}
cylinder{<50.800000,0.038000,30.480000><50.800000,-1.538000,30.480000>0.508000}
cylinder{<53.340000,0.038000,30.480000><53.340000,-1.538000,30.480000>0.508000}
cylinder{<55.880000,0.038000,30.480000><55.880000,-1.538000,30.480000>0.508000}
cylinder{<58.420000,0.038000,30.480000><58.420000,-1.538000,30.480000>0.508000}
cylinder{<60.960000,0.038000,30.480000><60.960000,-1.538000,30.480000>0.508000}
cylinder{<63.500000,0.038000,30.480000><63.500000,-1.538000,30.480000>0.508000}
cylinder{<66.040000,0.038000,30.480000><66.040000,-1.538000,30.480000>0.508000}
cylinder{<68.580000,0.038000,7.620000><68.580000,-1.538000,7.620000>0.508000}
cylinder{<15.240000,0.038000,30.480000><15.240000,-1.538000,30.480000>0.508000}
cylinder{<12.700000,0.038000,30.480000><12.700000,-1.538000,30.480000>0.508000}
cylinder{<20.320000,0.038000,30.480000><20.320000,-1.538000,30.480000>0.508000}
cylinder{<17.780000,0.038000,30.480000><17.780000,-1.538000,30.480000>0.508000}
cylinder{<7.620000,0.038000,7.620000><7.620000,-1.538000,7.620000>0.508000}
cylinder{<5.080000,0.038000,7.620000><5.080000,-1.538000,7.620000>0.508000}
//Holes(fast)/Vias
cylinder{<17.907000,0.038000,11.049000><17.907000,-1.538000,11.049000>0.304800 }
cylinder{<31.750000,0.038000,24.130000><31.750000,-1.538000,24.130000>0.304800 }
cylinder{<24.511000,0.038000,21.971000><24.511000,-1.538000,21.971000>0.304800 }
cylinder{<39.370000,0.038000,15.875000><39.370000,-1.538000,15.875000>0.304800 }
cylinder{<64.516000,0.038000,9.398000><64.516000,-1.538000,9.398000>0.304800 }
cylinder{<36.068000,0.038000,16.002000><36.068000,-1.538000,16.002000>0.304800 }
cylinder{<11.176000,0.038000,28.575000><11.176000,-1.538000,28.575000>0.304800 }
cylinder{<67.437000,0.038000,23.241000><67.437000,-1.538000,23.241000>0.250000 }
cylinder{<62.103000,0.038000,22.225000><62.103000,-1.538000,22.225000>0.250000 }
cylinder{<37.211000,0.038000,20.574000><37.211000,-1.538000,20.574000>0.304800 }
cylinder{<35.179000,0.038000,19.812000><35.179000,-1.538000,19.812000>0.304800 }
cylinder{<39.116000,0.038000,10.287000><39.116000,-1.538000,10.287000>0.304800 }
cylinder{<13.716000,0.038000,19.050000><13.716000,-1.538000,19.050000>0.304800 }
cylinder{<11.049000,0.038000,22.352000><11.049000,-1.538000,22.352000>0.304800 }
cylinder{<57.277000,0.038000,16.256000><57.277000,-1.538000,16.256000>0.250000 }
cylinder{<41.402000,0.038000,18.542000><41.402000,-1.538000,18.542000>0.250000 }
cylinder{<32.258000,0.038000,14.986000><32.258000,-1.538000,14.986000>0.250000 }
cylinder{<41.402000,0.038000,14.732000><41.402000,-1.538000,14.732000>0.250000 }
cylinder{<11.938000,0.038000,16.129000><11.938000,-1.538000,16.129000>0.250000 }
cylinder{<52.578000,0.038000,16.510000><52.578000,-1.538000,16.510000>0.250000 }
cylinder{<39.751000,0.038000,12.446000><39.751000,-1.538000,12.446000>0.304800 }
cylinder{<40.513000,0.038000,14.097000><40.513000,-1.538000,14.097000>0.304800 }
cylinder{<29.083000,0.038000,14.097000><29.083000,-1.538000,14.097000>0.304800 }
cylinder{<38.989000,0.038000,19.304000><38.989000,-1.538000,19.304000>0.304800 }
cylinder{<32.131000,0.038000,19.050000><32.131000,-1.538000,19.050000>0.304800 }
cylinder{<30.226000,0.038000,19.812000><30.226000,-1.538000,19.812000>0.304800 }
cylinder{<33.655000,0.038000,19.812000><33.655000,-1.538000,19.812000>0.304800 }
cylinder{<61.849000,0.038000,18.923000><61.849000,-1.538000,18.923000>0.304800 }
cylinder{<63.627000,0.038000,20.701000><63.627000,-1.538000,20.701000>0.304800 }
cylinder{<15.494000,0.038000,21.844000><15.494000,-1.538000,21.844000>0.304800 }
cylinder{<10.160000,0.038000,21.590000><10.160000,-1.538000,21.590000>0.304800 }
cylinder{<76.835000,0.038000,13.208000><76.835000,-1.538000,13.208000>0.304800 }
cylinder{<62.611000,0.038000,14.732000><62.611000,-1.538000,14.732000>0.304800 }
cylinder{<41.783000,0.038000,24.892000><41.783000,-1.538000,24.892000>0.304800 }
cylinder{<44.196000,0.038000,24.892000><44.196000,-1.538000,24.892000>0.304800 }
cylinder{<13.716000,0.038000,23.876000><13.716000,-1.538000,23.876000>0.304800 }
cylinder{<16.256000,0.038000,24.130000><16.256000,-1.538000,24.130000>0.304800 }
cylinder{<30.099000,0.038000,16.129000><30.099000,-1.538000,16.129000>0.304800 }
cylinder{<66.929000,0.038000,19.685000><66.929000,-1.538000,19.685000>0.304800 }
cylinder{<66.929000,0.038000,15.240000><66.929000,-1.538000,15.240000>0.304800 }
cylinder{<12.827000,0.038000,13.589000><12.827000,-1.538000,13.589000>0.304800 }
cylinder{<26.543000,0.038000,11.811000><26.543000,-1.538000,11.811000>0.304800 }
cylinder{<56.261000,0.038000,12.827000><56.261000,-1.538000,12.827000>0.304800 }
cylinder{<43.688000,0.038000,20.193000><43.688000,-1.538000,20.193000>0.304800 }
cylinder{<45.339000,0.038000,21.844000><45.339000,-1.538000,21.844000>0.304800 }
cylinder{<45.339000,0.038000,27.813000><45.339000,-1.538000,27.813000>0.304800 }
cylinder{<36.195000,0.038000,27.813000><36.195000,-1.538000,27.813000>0.304800 }
cylinder{<28.575000,0.038000,24.638000><28.575000,-1.538000,24.638000>0.304800 }
cylinder{<22.606000,0.038000,21.717000><22.606000,-1.538000,21.717000>0.304800 }
cylinder{<18.288000,0.038000,19.050000><18.288000,-1.538000,19.050000>0.304800 }
cylinder{<20.828000,0.038000,17.653000><20.828000,-1.538000,17.653000>0.304800 }
cylinder{<29.337000,0.038000,19.050000><29.337000,-1.538000,19.050000>0.304800 }
cylinder{<42.672000,0.038000,19.558000><42.672000,-1.538000,19.558000>0.304800 }
cylinder{<40.132000,0.038000,19.304000><40.132000,-1.538000,19.304000>0.304800 }
cylinder{<48.768000,0.038000,13.716000><48.768000,-1.538000,13.716000>0.304800 }
cylinder{<47.244000,0.038000,19.431000><47.244000,-1.538000,19.431000>0.304800 }
cylinder{<40.513000,0.038000,25.019000><40.513000,-1.538000,25.019000>0.304800 }
cylinder{<41.783000,0.038000,26.416000><41.783000,-1.538000,26.416000>0.304800 }
cylinder{<54.991000,0.038000,21.463000><54.991000,-1.538000,21.463000>0.304800 }
cylinder{<42.672000,0.038000,25.654000><42.672000,-1.538000,25.654000>0.304800 }
cylinder{<48.768000,0.038000,16.510000><48.768000,-1.538000,16.510000>0.304800 }
cylinder{<52.959000,0.038000,4.953000><52.959000,-1.538000,4.953000>0.304800 }
cylinder{<28.321000,0.038000,12.446000><28.321000,-1.538000,12.446000>0.304800 }
cylinder{<37.592000,0.038000,10.668000><37.592000,-1.538000,10.668000>0.304800 }
//Holes(fast)/Board
texture{col_hls}
}
#if(pcb_silkscreen=on)
//Silk Screen
union{
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.568800,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,20.320800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.568800,-1.536000,20.151300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,20.320800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<27.738300,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,20.151300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.077300,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,19.473400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.246700,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,19.473400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,19.304000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.077300,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,19.304000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<27.738300,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.568800,-1.536000,19.473400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.568800,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.077400,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,20.320800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<26.908000,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,20.320800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,20.151300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.399500,-1.536000,20.151300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.981900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<26.399500,-1.536000,19.981900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.981900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<26.399500,-1.536000,19.981900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.738500,-1.536000,19.812400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,19.812400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.642900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.399500,-1.536000,19.642900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.642900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.473400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<26.399500,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.473400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.304000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<26.399500,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,19.304000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.077400,-1.536000,19.473400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.908000,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.178400,-1.536000,12.927700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.178400,-1.536000,13.605600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<27.178400,-1.536000,13.605600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.517300,-1.536000,13.266600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.839400,-1.536000,13.266600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<26.839400,-1.536000,13.266600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.229100,-1.536000,17.865300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,18.034800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.229100,-1.536000,17.865300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,18.034800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<17.398600,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.865300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<17.737600,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.865300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.187400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<17.907000,-1.536000,17.187400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.187400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,17.018000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.737600,-1.536000,17.018000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,17.018000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<17.398600,-1.536000,17.018000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.229100,-1.536000,17.187400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<17.229100,-1.536000,17.187400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,18.034800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<16.229300,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.737700,-1.536000,17.526400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<16.229300,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.737700,-1.536000,17.526400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.059800,-1.536000,17.526400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<16.059800,-1.536000,17.526400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.033800,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,26.035800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.033800,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,26.035800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<65.203300,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.866300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<65.542300,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.188400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<65.711700,-1.536000,25.188400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.188400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,25.019000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.542300,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,25.019000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,25.019000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<65.203300,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,25.019000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.033800,-1.536000,25.188400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.033800,-1.536000,25.188400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,26.035800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.864500,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,25.866300>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<63.864500,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.188400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.864500,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.188400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.019000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.542400,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.103400,-1.536000,21.817700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.103400,-1.536000,22.495600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.103400,-1.536000,22.495600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.442300,-1.536000,22.156600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.764400,-1.536000,22.156600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<61.764400,-1.536000,22.156600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.374100,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<34.374100,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<34.543600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<34.882600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,13.377400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.052000,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<34.882600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<34.543600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.374100,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<34.374100,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.882700,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,14.224800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<33.543800,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,13.208000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.543800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.882700,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.204800,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<33.204800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.035500,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.885900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<32.035500,-1.536000,13.885900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,14.055300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<32.035500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.205000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.035500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.205000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.544000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<32.205000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.544000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<32.544000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.199100,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,21.844800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.199100,-1.536000,21.675300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,21.844800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<31.368600,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,21.675300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.707600,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,20.997400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<31.877000,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,20.997400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,20.828000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.707600,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,20.828000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<31.368600,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.199100,-1.536000,20.997400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<31.199100,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.707700,-1.536000,21.505900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,21.844800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<30.368800,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,20.828000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.368800,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.707700,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.029800,-1.536000,20.828000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.029800,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.538400,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,21.844800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<29.369000,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.844800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.675300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.860500,-1.536000,21.675300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.505900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.860500,-1.536000,21.505900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.505900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<28.860500,-1.536000,21.505900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.199500,-1.536000,21.336400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,21.336400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.166900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.860500,-1.536000,21.166900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.166900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,20.997400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.860500,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,20.997400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,20.828000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<28.860500,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,20.828000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.538400,-1.536000,20.997400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.369000,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.628200,-1.536000,27.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,27.305800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.628200,-1.536000,27.136300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,27.305800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.797700,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,27.136300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<38.136700,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,27.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,26.458400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.306100,-1.536000,26.458400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,26.458400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,26.289000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.136700,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,26.289000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.797700,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.628200,-1.536000,26.458400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.628200,-1.536000,26.458400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.136800,-1.536000,26.966900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,27.305800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<36.797900,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,26.289000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.797900,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.136800,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.458900,-1.536000,26.289000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<36.458900,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,27.305800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<35.459100,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.967500,-1.536000,26.797400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<35.459100,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.967500,-1.536000,26.797400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.289600,-1.536000,26.797400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.289600,-1.536000,26.797400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068400,-1.536000,19.912700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068400,-1.536000,20.590600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068400,-1.536000,20.590600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.407300,-1.536000,20.251600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729400,-1.536000,20.251600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.729400,-1.536000,20.251600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.598200,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,15.240800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<51.598200,-1.536000,15.071300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,15.240800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<51.767700,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,15.071300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<52.106700,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,14.393400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<52.276100,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,14.224000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.106700,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,14.224000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<51.767700,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.598200,-1.536000,14.393400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<51.598200,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.106800,-1.536000,14.901900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,15.240800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<50.767900,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,14.224000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.767900,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.106800,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.428900,-1.536000,14.224000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<50.428900,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.598600,-1.536000,15.071300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,26.563298,0> translate<49.259600,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.598600,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<49.598600,-1.536000,15.071300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.393400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<49.937500,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.768100,-1.536000,14.224000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<49.768100,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.768100,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.224000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<49.429100,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.393400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<49.259600,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.562900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<49.259600,-1.536000,14.562900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.562900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.732400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<49.259600,-1.536000,14.562900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.732400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<49.429100,-1.536000,14.732400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.498400,-1.536000,12.927700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.498400,-1.536000,13.605600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<47.498400,-1.536000,13.605600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.837300,-1.536000,13.266600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.159400,-1.536000,13.266600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.159400,-1.536000,13.266600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.343200,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,23.495800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.343200,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,23.495800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<43.512700,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,23.326300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<43.851700,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,22.648400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.021100,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,22.479000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.851700,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,22.479000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<43.512700,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.343200,-1.536000,22.648400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<43.343200,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.851800,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,23.495800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<42.512900,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,22.479000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.512900,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.851800,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.173900,-1.536000,22.479000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.173900,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,23.495800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<41.513100,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,23.495800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.326300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.004600,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.156900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.004600,-1.536000,23.156900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<41.004600,-1.536000,23.156900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.817900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.004600,-1.536000,22.817900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.817900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.648400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.004600,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.479000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<41.004600,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.479000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.648400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.513100,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.817900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<41.682500,-1.536000,22.817900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.817900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<41.513100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.156900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<41.513100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.326300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<41.682500,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.243400,-1.536000,18.642700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.243400,-1.536000,19.320600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<39.243400,-1.536000,19.320600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.582300,-1.536000,18.981600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.904400,-1.536000,18.981600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<38.904400,-1.536000,18.981600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.534100,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<44.534100,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.703600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<45.042600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,13.377400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.212000,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.042600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.703600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.534100,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<44.534100,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.042700,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,14.224800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<43.703800,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,13.208000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.703800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.042700,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.364800,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<43.364800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.704000,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<42.365000,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.195500,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,14.055300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<42.195500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.195500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<42.365000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<42.704000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.885900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.873400,-1.536000,13.885900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.716400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<42.704000,-1.536000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.716400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.716400>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,0.000000,0> translate<42.195500,-1.536000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.564100,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,26.924800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.564100,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,26.924800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<30.733600,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.755300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.072600,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.077400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<31.242000,-1.536000,26.077400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.077400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,25.908000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.072600,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,25.908000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<30.733600,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.564100,-1.536000,26.077400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<30.564100,-1.536000,26.077400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,25.908000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<29.394800,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.585900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<29.394800,-1.536000,26.585900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.585900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.755300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<29.394800,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.564300,-1.536000,26.924800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.394800,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.564300,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.903300,-1.536000,26.924800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.564300,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.903300,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,26.755300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<29.903300,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.903400,-1.536000,26.585900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,26.924800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<28.564500,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,25.908000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.564500,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.903400,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.225500,-1.536000,25.908000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<28.225500,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,12.192000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<72.898000,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,12.192000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.389600,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,12.361400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<72.220100,-1.536000,12.361400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,12.361400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,13.039300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<72.220100,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,13.208800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<72.220100,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,13.208800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.389600,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,12.192000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<71.050800,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.869900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<71.050800,-1.536000,12.869900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.869900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,13.039300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<71.050800,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.220300,-1.536000,13.208800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<71.050800,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.220300,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.559300,-1.536000,13.208800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<71.220300,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.559300,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,13.039300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<71.559300,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,24.257000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<71.628000,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,24.257000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.119600,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,24.426400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<70.950100,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,24.426400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,25.104300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<70.950100,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,25.273800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.950100,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,25.273800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.119600,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.458700,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,25.273800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<70.289300,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,25.273800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,25.104300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<69.780800,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.934900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.780800,-1.536000,24.934900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.934900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<69.780800,-1.536000,24.934900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.119800,-1.536000,24.765400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,24.765400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.595900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<69.780800,-1.536000,24.595900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.595900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.426400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.780800,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.426400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.257000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<69.780800,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,24.257000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.458700,-1.536000,24.426400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.289300,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,19.812000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.738000,-1.536000,19.812000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,19.812000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,19.812000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,19.981400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.060100,-1.536000,19.981400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,19.981400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,20.659300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.060100,-1.536000,20.659300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,20.659300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,20.828800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.060100,-1.536000,20.659300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,20.828800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,20.828800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<61.060300,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,20.320400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<61.060300,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,20.320400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,20.320400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.890800,-1.536000,20.320400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,17.907000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<72.263000,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,17.907000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.754600,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.076400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<71.585100,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.076400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.754300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<71.585100,-1.536000,18.754300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.754300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,18.923800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<71.585100,-1.536000,18.754300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,18.923800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.754600,-1.536000,18.923800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.923800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<70.415800,-1.536000,18.923800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.415400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<71.093700,-1.536000,18.415400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.415400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.754800,-1.536000,18.584900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,26.570060,0> translate<70.754800,-1.536000,18.584900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.754800,-1.536000,18.584900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,18.584900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<70.585300,-1.536000,18.584900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,18.584900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.415400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.415800,-1.536000,18.415400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.415400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.076400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<70.415800,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.076400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,17.907000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<70.415800,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.924300,-1.536000,17.907000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.585300,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.924300,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.076400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.924300,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,16.002000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.738000,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,16.002000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.171400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.060100,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.849300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.060100,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.849300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,17.018800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.060100,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,17.018800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,17.018800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.229800,-1.536000,16.849300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,26.563298,0> translate<60.890800,-1.536000,17.018800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.229800,-1.536000,16.849300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<61.229800,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.171400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.568700,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.399300,-1.536000,16.002000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<61.399300,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.399300,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.002000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<61.060300,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.171400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.890800,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.340900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<60.890800,-1.536000,16.340900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.340900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.510400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.890800,-1.536000,16.340900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.510400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.060300,-1.536000,16.510400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,16.637000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,16.637000>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,16.637000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,16.637000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,17.145400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,17.145400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,17.572500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,17.572500>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,17.572500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,17.572500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,17.953800>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.040400,0.000000,17.953800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,17.953800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,18.080900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.040400,0.000000,17.953800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,18.080900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,18.080900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<74.167500,0.000000,18.080900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,18.080900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,17.953800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.421700,0.000000,18.080900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,17.953800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,17.572500>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.548800,0.000000,17.572500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,19.016400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,18.889300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.040400,0.000000,18.889300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,18.889300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,18.635100>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.040400,0.000000,18.635100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,18.635100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,18.508000>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.040400,0.000000,18.635100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,18.508000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,18.508000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.167500,0.000000,18.508000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,18.508000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,18.635100>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.675900,0.000000,18.508000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,18.635100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,18.889300>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,18.889300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,18.889300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,19.016400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,19.016400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,19.443500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,19.951900>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,-33.687844,0> translate<74.040400,0.000000,19.443500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,19.951900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,19.443500>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,33.687844,0> translate<74.040400,0.000000,19.951900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.057200,0.000000,20.379000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,20.379000>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.294600,0.000000,20.379000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,20.379000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,20.760300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.294600,0.000000,20.760300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,20.760300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,20.887400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.294600,0.000000,20.760300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,20.887400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,20.887400>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<74.421700,0.000000,20.887400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,20.887400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,20.760300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,20.887400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,20.760300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,20.379000>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.803000,0.000000,20.379000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,21.314500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,21.314500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.294600,0.000000,21.314500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,21.314500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,21.568700>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<74.294600,0.000000,21.568700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,21.568700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,21.695800>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<74.294600,0.000000,21.695800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,22.475300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,22.221100>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.803000,0.000000,22.221100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,22.221100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,22.094000>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.675900,0.000000,22.094000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,22.094000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,22.094000>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<74.421700,0.000000,22.094000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,22.094000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,22.221100>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.294600,0.000000,22.221100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,22.221100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,22.475300>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.294600,0.000000,22.475300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,22.475300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,22.602400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.294600,0.000000,22.475300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,22.602400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,22.602400>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,0.000000,0> translate<74.421700,0.000000,22.602400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,22.602400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,22.094000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.548800,0.000000,22.094000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,23.029500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,23.410800>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,23.410800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,23.410800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,23.537900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,23.537900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,23.537900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,23.410800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.548800,0.000000,23.410800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,23.410800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,23.156600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.548800,0.000000,23.156600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,23.156600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,23.029500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.421700,0.000000,23.029500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,23.029500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,23.156600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.294600,0.000000,23.156600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,23.156600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,23.537900>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.294600,0.000000,23.537900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,23.965000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,24.346300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,24.346300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,24.346300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,24.473400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,24.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,24.473400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,24.346300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.548800,0.000000,24.346300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,24.346300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,24.092100>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.548800,0.000000,24.092100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,24.092100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,23.965000>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.421700,0.000000,23.965000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,23.965000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,24.092100>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.294600,0.000000,24.092100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,24.092100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,24.473400>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<74.294600,0.000000,24.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,25.027600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,25.281800>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,25.281800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,25.281800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,25.408900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,25.408900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,25.408900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,25.408900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<74.421700,0.000000,25.408900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,25.408900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,25.281800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.294600,0.000000,25.281800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,25.281800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,25.027600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.294600,0.000000,25.027600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,25.027600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,24.900500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.294600,0.000000,25.027600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.421700,0.000000,24.900500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,24.900500>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<74.421700,0.000000,24.900500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,24.900500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,25.027600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.675900,0.000000,24.900500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.930100,0.000000,25.836000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.930100,0.000000,26.344400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<74.930100,0.000000,26.344400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,26.771500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,27.025700>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,27.025700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,26.898600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,26.898600>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,26.898600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,26.771500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,27.025700>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.040400,0.000000,27.025700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,27.395100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,27.395100>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,27.395100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,27.395100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,27.649300>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.040400,0.000000,27.395100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,27.649300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,27.903500>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<74.040400,0.000000,27.903500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,27.903500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,27.903500>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,27.903500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,28.330600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,28.330600>}
box{<0,0,-0.127000><0.635500,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,28.330600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,28.330600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,28.457700>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.675900,0.000000,28.330600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,28.457700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,28.711900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,28.711900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,28.711900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,28.839000>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,28.839000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,28.839000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,28.839000>}
box{<0,0,-0.127000><0.635500,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,28.839000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,30.201600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,30.201600>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,30.201600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,30.201600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,30.455800>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.548800,0.000000,30.201600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,30.455800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,30.710000>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<74.548800,0.000000,30.710000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.548800,0.000000,30.710000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,30.710000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,30.710000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.294600,0.000000,31.137100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,31.391300>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<74.040400,0.000000,31.391300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,31.391300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,31.391300>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<74.040400,0.000000,31.391300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,31.137100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,31.645500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<74.803000,0.000000,31.645500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.072600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.072600>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,0.000000,0> translate<74.675900,0.000000,32.072600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.072600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.199700>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<74.675900,0.000000,32.199700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.199700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.199700>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,0.000000,0> translate<74.675900,0.000000,32.199700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.199700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.072600>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.803000,0.000000,32.072600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.540300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,32.540300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.167500,0.000000,32.540300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,32.540300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,32.667400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.040400,0.000000,32.667400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,32.667400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,32.921600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<74.040400,0.000000,32.921600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.040400,0.000000,32.921600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,33.048700>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.040400,0.000000,32.921600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,33.048700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,33.048700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<74.167500,0.000000,33.048700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,33.048700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.921600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<74.675900,0.000000,33.048700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.921600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.667400>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.803000,0.000000,32.667400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.803000,0.000000,32.667400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.540300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<74.675900,0.000000,32.540300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.675900,0.000000,32.540300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.167500,0.000000,33.048700>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<74.167500,0.000000,33.048700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<83.781100,0.000000,4.430500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<83.781100,0.000000,8.359600>}
box{<0,0,-0.127000><3.929100,0.036000,0.127000> rotate<0,90.000000,0> translate<83.781100,0.000000,8.359600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,4.557500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,4.557500>}
box{<0,0,-0.127000><1.169300,0.036000,0.127000> rotate<0,0.000000,0> translate<84.288200,0.000000,4.557500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,4.557500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,5.142100>}
box{<0,0,-0.127000><0.584600,0.036000,0.127000> rotate<0,90.000000,0> translate<84.288200,0.000000,5.142100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,5.142100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.483100,0.000000,5.337000>}
box{<0,0,-0.127000><0.275630,0.036000,0.127000> rotate<0,-44.997030,0> translate<84.288200,0.000000,5.142100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.483100,0.000000,5.337000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,5.337000>}
box{<0,0,-0.127000><0.389800,0.036000,0.127000> rotate<0,0.000000,0> translate<84.483100,0.000000,5.337000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,5.337000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,5.142100>}
box{<0,0,-0.127000><0.275630,0.036000,0.127000> rotate<0,44.997030,0> translate<84.872900,0.000000,5.337000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,5.142100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,4.557500>}
box{<0,0,-0.127000><0.584600,0.036000,0.127000> rotate<0,-90.000000,0> translate<85.067800,0.000000,4.557500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,4.947200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,5.337000>}
box{<0,0,-0.127000><0.551190,0.036000,0.127000> rotate<0,-45.004380,0> translate<85.067800,0.000000,4.947200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.483100,0.000000,6.646700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,6.451800>}
box{<0,0,-0.127000><0.275630,0.036000,0.127000> rotate<0,-44.997030,0> translate<84.288200,0.000000,6.451800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,6.451800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,6.062000>}
box{<0,0,-0.127000><0.389800,0.036000,0.127000> rotate<0,-90.000000,0> translate<84.288200,0.000000,6.062000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,6.062000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.483100,0.000000,5.867200>}
box{<0,0,-0.127000><0.275560,0.036000,0.127000> rotate<0,44.982329,0> translate<84.288200,0.000000,6.062000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.483100,0.000000,5.867200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.678000,0.000000,5.867200>}
box{<0,0,-0.127000><0.194900,0.036000,0.127000> rotate<0,0.000000,0> translate<84.483100,0.000000,5.867200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.678000,0.000000,5.867200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,6.062000>}
box{<0,0,-0.127000><0.275560,0.036000,0.127000> rotate<0,-44.982329,0> translate<84.678000,0.000000,5.867200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,6.062000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,6.451800>}
box{<0,0,-0.127000><0.389800,0.036000,0.127000> rotate<0,90.000000,0> translate<84.872900,0.000000,6.451800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.872900,0.000000,6.451800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,6.646700>}
box{<0,0,-0.127000><0.275630,0.036000,0.127000> rotate<0,-44.997030,0> translate<84.872900,0.000000,6.451800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.067800,0.000000,6.646700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.262700,0.000000,6.646700>}
box{<0,0,-0.127000><0.194900,0.036000,0.127000> rotate<0,0.000000,0> translate<85.067800,0.000000,6.646700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.262700,0.000000,6.646700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,6.451800>}
box{<0,0,-0.127000><0.275560,0.036000,0.127000> rotate<0,45.011732,0> translate<85.262700,0.000000,6.646700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,6.451800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,6.062000>}
box{<0,0,-0.127000><0.389800,0.036000,0.127000> rotate<0,-90.000000,0> translate<85.457500,0.000000,6.062000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,6.062000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.262700,0.000000,5.867200>}
box{<0,0,-0.127000><0.275489,0.036000,0.127000> rotate<0,-44.997030,0> translate<85.262700,0.000000,5.867200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<85.457500,0.000000,7.566600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,7.566600>}
box{<0,0,-0.127000><1.169300,0.036000,0.127000> rotate<0,0.000000,0> translate<84.288200,0.000000,7.566600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,7.176900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<84.288200,0.000000,7.956400>}
box{<0,0,-0.127000><0.779500,0.036000,0.127000> rotate<0,90.000000,0> translate<84.288200,0.000000,7.956400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,21.097000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.685100,0.000000,21.097000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.685100,0.000000,21.097000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.685100,0.000000,21.097000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,21.435900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<30.346200,0.000000,21.435900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,21.435900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.685100,0.000000,21.774900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<30.346200,0.000000,21.435900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.685100,0.000000,21.774900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,21.774900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.685100,0.000000,21.774900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.854600,0.000000,21.097000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.854600,0.000000,21.774900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<30.854600,0.000000,21.774900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,22.944200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,22.774700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.346200,0.000000,22.774700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,22.774700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,22.435700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.346200,0.000000,22.435700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,22.435700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,22.266300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<30.346200,0.000000,22.435700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,22.266300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,22.266300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.515700,0.000000,22.266300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,22.266300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,22.435700>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.193600,0.000000,22.266300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,22.435700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,22.774700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<31.363000,0.000000,22.774700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,22.774700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,22.944200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.193600,0.000000,22.944200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,24.113500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,23.944000>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.346200,0.000000,23.944000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,23.944000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,23.605000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.346200,0.000000,23.605000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,23.605000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,23.435600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<30.346200,0.000000,23.605000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.515700,0.000000,23.435600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,23.435600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.515700,0.000000,23.435600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,23.435600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,23.605000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.193600,0.000000,23.435600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,23.605000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,23.944000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<31.363000,0.000000,23.944000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,23.944000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.193600,0.000000,24.113500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.193600,0.000000,24.113500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,25.282800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,24.604900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.346200,0.000000,24.604900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,24.604900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,24.604900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<30.346200,0.000000,24.604900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,24.604900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,25.282800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<31.363000,0.000000,25.282800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.854600,0.000000,24.604900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.854600,0.000000,24.943800>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,90.000000,0> translate<30.854600,0.000000,24.943800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,25.774200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,25.774200>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<30.346200,0.000000,25.774200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,25.774200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,26.452100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<31.363000,0.000000,26.452100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.685100,0.000000,26.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,27.282400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<30.346200,0.000000,27.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.346200,0.000000,27.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,27.282400>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<30.346200,0.000000,27.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,26.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.363000,0.000000,27.621400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<31.363000,0.000000,27.621400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.922000,0.000000,26.122000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.922000,0.000000,26.291400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<33.922000,0.000000,26.291400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.922000,0.000000,26.291400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.091400,0.000000,26.291400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.922000,0.000000,26.291400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.091400,0.000000,26.291400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.091400,0.000000,26.122000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<34.091400,0.000000,26.122000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.091400,0.000000,26.122000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.922000,0.000000,26.122000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.922000,0.000000,26.122000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.004000,0.000000,25.781600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.512400,0.000000,25.019000>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,56.306216,0> translate<32.004000,0.000000,25.781600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.512400,0.000000,25.781600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.004000,0.000000,25.019000>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,-56.306216,0> translate<32.004000,0.000000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.036000,0.000000,27.686600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.036000,0.000000,27.559500>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,-90.000000,0> translate<34.036000,0.000000,27.559500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.036000,0.000000,27.559500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.290200,0.000000,27.305300>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<34.036000,0.000000,27.559500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.290200,0.000000,27.305300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.544400,0.000000,27.559500>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<34.290200,0.000000,27.305300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.544400,0.000000,27.559500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.544400,0.000000,27.686600>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<34.544400,0.000000,27.686600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.290200,0.000000,27.305300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.290200,0.000000,26.924000>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<34.290200,0.000000,26.924000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.025000,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.025000,0.000000,10.075900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<73.025000,0.000000,10.075900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.025000,0.000000,10.075900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.363900,0.000000,10.414800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<73.025000,0.000000,10.075900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.363900,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.702900,0.000000,10.075900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<73.363900,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.702900,0.000000,10.075900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.702900,0.000000,9.398000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<73.702900,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.025000,0.000000,9.906400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<73.702900,0.000000,9.906400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<73.025000,0.000000,9.906400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.194300,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.194300,0.000000,9.567400>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.194300,0.000000,9.567400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.194300,0.000000,9.567400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.363700,0.000000,9.398000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<74.194300,0.000000,9.567400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.363700,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.702700,0.000000,9.398000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<74.363700,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.702700,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.872200,0.000000,9.567400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<74.702700,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.872200,0.000000,9.567400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.872200,0.000000,10.414800>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<74.872200,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.363600,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.041500,0.000000,9.398000>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,56.304916,0> translate<75.363600,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.041500,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.363600,0.000000,9.398000>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,-56.304916,0> translate<75.363600,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.422000,0.000000,1.651400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.099900,0.000000,1.651400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<74.422000,0.000000,1.651400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.760900,0.000000,1.990300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.760900,0.000000,1.312400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<74.760900,0.000000,1.312400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.269200,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.591300,0.000000,2.159800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.591300,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.591300,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.591300,0.000000,1.651400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<75.591300,0.000000,1.651400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.591300,0.000000,1.651400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.930200,0.000000,1.820900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<75.591300,0.000000,1.651400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.930200,0.000000,1.820900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.099700,0.000000,1.820900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<75.930200,0.000000,1.820900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.099700,0.000000,1.820900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.269200,0.000000,1.651400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<76.099700,0.000000,1.820900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.269200,0.000000,1.651400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.269200,0.000000,1.312400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.269200,0.000000,1.312400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.269200,0.000000,1.312400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.099700,0.000000,1.143000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<76.099700,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.099700,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.760700,0.000000,1.143000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<75.760700,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.760700,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.591300,0.000000,1.312400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<75.591300,0.000000,1.312400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.760600,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.760600,0.000000,1.481900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.760600,0.000000,1.481900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.760600,0.000000,1.481900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.099500,0.000000,1.143000>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<76.760600,0.000000,1.481900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.099500,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.438500,0.000000,1.481900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-44.988579,0> translate<77.099500,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.438500,0.000000,1.481900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.438500,0.000000,2.159800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<77.438500,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.654900,0.000000,1.990300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.485400,0.000000,2.159800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<70.485400,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.485400,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.146400,0.000000,2.159800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.146400,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.146400,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.977000,0.000000,1.990300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<69.977000,0.000000,1.990300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.977000,0.000000,1.990300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.977000,0.000000,1.312400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.977000,0.000000,1.312400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.977000,0.000000,1.312400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.146400,0.000000,1.143000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<69.977000,0.000000,1.312400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.146400,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.485400,0.000000,1.143000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.146400,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.485400,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.654900,0.000000,1.312400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<70.485400,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.654900,0.000000,1.312400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.654900,0.000000,1.651400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<70.654900,0.000000,1.651400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.654900,0.000000,1.651400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.315900,0.000000,1.651400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.315900,0.000000,1.651400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.146300,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.146300,0.000000,2.159800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<71.146300,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.146300,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.824200,0.000000,1.143000>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,56.304916,0> translate<71.146300,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.824200,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.824200,0.000000,2.159800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<71.824200,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.315600,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.315600,0.000000,1.143000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<72.315600,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.315600,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.824000,0.000000,1.143000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.315600,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.824000,0.000000,1.143000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.993500,0.000000,1.312400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<72.824000,0.000000,1.143000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.993500,0.000000,1.312400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.993500,0.000000,1.990300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<72.993500,0.000000,1.990300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.993500,0.000000,1.990300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.824000,0.000000,2.159800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<72.824000,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.824000,0.000000,2.159800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.315600,0.000000,2.159800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.315600,0.000000,2.159800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.075200,0.000000,24.088300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.905700,0.000000,24.257800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<44.905700,0.000000,24.257800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.905700,0.000000,24.257800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.566700,0.000000,24.257800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.566700,0.000000,24.257800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.566700,0.000000,24.257800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.397300,0.000000,24.088300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<44.397300,0.000000,24.088300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.397300,0.000000,24.088300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.397300,0.000000,23.410400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.397300,0.000000,23.410400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.397300,0.000000,23.410400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.566700,0.000000,23.241000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<44.397300,0.000000,23.410400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.566700,0.000000,23.241000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.905700,0.000000,23.241000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.566700,0.000000,23.241000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.905700,0.000000,23.241000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.075200,0.000000,23.410400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<44.905700,0.000000,23.241000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.566600,0.000000,23.918900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.905500,0.000000,24.257800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.566600,0.000000,23.918900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.905500,0.000000,24.257800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.905500,0.000000,23.241000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.905500,0.000000,23.241000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.566600,0.000000,23.241000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.244500,0.000000,23.241000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.566600,0.000000,23.241000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.000900,0.000000,21.040300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.831400,0.000000,21.209800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<44.831400,0.000000,21.209800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.831400,0.000000,21.209800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.492400,0.000000,21.209800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.492400,0.000000,21.209800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.492400,0.000000,21.209800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.323000,0.000000,21.040300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<44.323000,0.000000,21.040300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.323000,0.000000,21.040300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.323000,0.000000,20.362400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.323000,0.000000,20.362400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.323000,0.000000,20.362400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.492400,0.000000,20.193000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<44.323000,0.000000,20.362400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.492400,0.000000,20.193000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.831400,0.000000,20.193000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.492400,0.000000,20.193000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.831400,0.000000,20.193000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.000900,0.000000,20.362400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<44.831400,0.000000,20.193000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.170200,0.000000,20.193000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.492300,0.000000,20.193000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.492300,0.000000,20.193000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.492300,0.000000,20.193000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.170200,0.000000,20.870900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.492300,0.000000,20.193000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.170200,0.000000,20.870900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.170200,0.000000,21.040300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.170200,0.000000,21.040300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.170200,0.000000,21.040300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.000700,0.000000,21.209800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<46.000700,0.000000,21.209800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.000700,0.000000,21.209800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.661700,0.000000,21.209800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<45.661700,0.000000,21.209800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.661700,0.000000,21.209800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.492300,0.000000,21.040300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<45.492300,0.000000,21.040300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.816200,0.000000,25.231300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.646700,0.000000,25.400800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<4.646700,0.000000,25.400800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.646700,0.000000,25.400800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.307700,0.000000,25.400800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<4.307700,0.000000,25.400800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.307700,0.000000,25.400800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.138300,0.000000,25.231300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<4.138300,0.000000,25.231300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.138300,0.000000,25.231300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.138300,0.000000,24.553400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<4.138300,0.000000,24.553400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.138300,0.000000,24.553400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.307700,0.000000,24.384000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<4.138300,0.000000,24.553400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.307700,0.000000,24.384000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.646700,0.000000,24.384000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<4.307700,0.000000,24.384000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.646700,0.000000,24.384000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.816200,0.000000,24.553400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<4.646700,0.000000,24.384000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.985500,0.000000,25.400800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.307600,0.000000,25.400800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<5.307600,0.000000,25.400800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.307600,0.000000,25.400800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.307600,0.000000,24.892400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<5.307600,0.000000,24.892400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.307600,0.000000,24.892400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.646500,0.000000,25.061900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<5.307600,0.000000,24.892400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.646500,0.000000,25.061900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.816000,0.000000,25.061900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<5.646500,0.000000,25.061900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.816000,0.000000,25.061900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.985500,0.000000,24.892400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<5.816000,0.000000,25.061900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.985500,0.000000,24.892400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.985500,0.000000,24.553400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<5.985500,0.000000,24.553400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.985500,0.000000,24.553400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.816000,0.000000,24.384000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<5.816000,0.000000,24.384000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.816000,0.000000,24.384000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.477000,0.000000,24.384000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<5.477000,0.000000,24.384000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.477000,0.000000,24.384000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.307600,0.000000,24.553400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<5.307600,0.000000,24.553400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.767700,0.000000,26.543400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.445600,0.000000,26.543400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<2.767700,0.000000,26.543400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.106600,0.000000,26.882300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.106600,0.000000,26.204400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.106600,0.000000,26.204400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.400900,0.000000,12.150300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.231400,0.000000,12.319800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<70.231400,0.000000,12.319800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.231400,0.000000,12.319800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.892400,0.000000,12.319800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.892400,0.000000,12.319800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.892400,0.000000,12.319800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.723000,0.000000,12.150300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<69.723000,0.000000,12.150300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.723000,0.000000,12.150300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.723000,0.000000,11.472400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.723000,0.000000,11.472400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.723000,0.000000,11.472400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.892400,0.000000,11.303000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<69.723000,0.000000,11.472400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.892400,0.000000,11.303000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.231400,0.000000,11.303000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.892400,0.000000,11.303000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.231400,0.000000,11.303000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.400900,0.000000,11.472400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<70.231400,0.000000,11.303000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.570200,0.000000,12.319800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.231200,0.000000,12.150300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,-26.563298,0> translate<71.231200,0.000000,12.150300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.231200,0.000000,12.150300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.892300,0.000000,11.811400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.892300,0.000000,11.811400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.892300,0.000000,11.811400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.892300,0.000000,11.472400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<70.892300,0.000000,11.472400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.892300,0.000000,11.472400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.061700,0.000000,11.303000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<70.892300,0.000000,11.472400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.061700,0.000000,11.303000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.400700,0.000000,11.303000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<71.061700,0.000000,11.303000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.400700,0.000000,11.303000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.570200,0.000000,11.472400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<71.400700,0.000000,11.303000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.570200,0.000000,11.472400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.570200,0.000000,11.641900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<71.570200,0.000000,11.641900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.570200,0.000000,11.641900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.400700,0.000000,11.811400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<71.400700,0.000000,11.811400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.400700,0.000000,11.811400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.892300,0.000000,11.811400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<70.892300,0.000000,11.811400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.395900,0.000000,11.515300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.226400,0.000000,11.684800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<30.226400,0.000000,11.684800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.226400,0.000000,11.684800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.887400,0.000000,11.684800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.887400,0.000000,11.684800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.887400,0.000000,11.684800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.718000,0.000000,11.515300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<29.718000,0.000000,11.515300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.718000,0.000000,11.515300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.718000,0.000000,10.837400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<29.718000,0.000000,10.837400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.718000,0.000000,10.837400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.887400,0.000000,10.668000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<29.718000,0.000000,10.837400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.887400,0.000000,10.668000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.226400,0.000000,10.668000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.887400,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.226400,0.000000,10.668000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.395900,0.000000,10.837400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<30.226400,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.887300,0.000000,11.345900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.226200,0.000000,11.684800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.887300,0.000000,11.345900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.226200,0.000000,11.684800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.226200,0.000000,10.668000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<31.226200,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.887300,0.000000,10.668000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.565200,0.000000,10.668000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.887300,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.056600,0.000000,11.345900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.395500,0.000000,11.684800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.056600,0.000000,11.345900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.395500,0.000000,11.684800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.395500,0.000000,10.668000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<32.395500,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.056600,0.000000,10.668000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.734500,0.000000,10.668000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.056600,0.000000,10.668000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.272000,0.000000,23.368800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.272000,0.000000,22.352000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<17.272000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.272000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.780400,0.000000,22.352000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<17.272000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.780400,0.000000,22.352000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949900,0.000000,22.521400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<17.780400,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949900,0.000000,22.521400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949900,0.000000,23.199300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<17.949900,0.000000,23.199300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949900,0.000000,23.199300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.780400,0.000000,23.368800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<17.780400,0.000000,23.368800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.780400,0.000000,23.368800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.272000,0.000000,23.368800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<17.272000,0.000000,23.368800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.441300,0.000000,23.029900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.780200,0.000000,23.368800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<18.441300,0.000000,23.029900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.780200,0.000000,23.368800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.780200,0.000000,22.352000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<18.780200,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.441300,0.000000,22.352000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.119200,0.000000,22.352000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<18.441300,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.177000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.177000,0.000000,28.321800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<19.177000,0.000000,28.321800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.177000,0.000000,28.321800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.854900,0.000000,28.321800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.177000,0.000000,28.321800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.177000,0.000000,27.813400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.515900,0.000000,27.813400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.177000,0.000000,27.813400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.346300,0.000000,27.982900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.685200,0.000000,28.321800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<20.346300,0.000000,27.982900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.685200,0.000000,28.321800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.685200,0.000000,27.305000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<20.685200,0.000000,27.305000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.346300,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<21.024200,0.000000,27.305000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<20.346300,0.000000,27.305000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.484900,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.315400,0.000000,13.268800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<41.315400,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.315400,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.976400,0.000000,13.268800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<40.976400,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.976400,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.807000,0.000000,13.099300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<40.807000,0.000000,13.099300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.807000,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.807000,0.000000,12.421400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<40.807000,0.000000,12.421400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.807000,0.000000,12.421400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.976400,0.000000,12.252000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<40.807000,0.000000,12.421400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.976400,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.315400,0.000000,12.252000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<40.976400,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.315400,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.484900,0.000000,12.421400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<41.315400,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.484900,0.000000,12.421400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.484900,0.000000,12.760400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<41.484900,0.000000,12.760400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.484900,0.000000,12.760400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.145900,0.000000,12.760400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.145900,0.000000,12.760400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.976300,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.976300,0.000000,13.099300>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.976300,0.000000,13.099300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.976300,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.315200,0.000000,12.760400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<41.976300,0.000000,13.099300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.315200,0.000000,12.760400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.654200,0.000000,13.099300>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-44.988579,0> translate<42.315200,0.000000,12.760400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.654200,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.654200,0.000000,13.268800>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<42.654200,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.315200,0.000000,12.760400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.315200,0.000000,12.252000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.315200,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.145600,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.145600,0.000000,13.268800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<43.145600,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.145600,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.654000,0.000000,13.268800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.145600,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.654000,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.823500,0.000000,13.099300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<43.654000,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.823500,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.823500,0.000000,12.760400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.823500,0.000000,12.760400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.823500,0.000000,12.760400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.654000,0.000000,12.590900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.654000,0.000000,12.590900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.654000,0.000000,12.590900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.145600,0.000000,12.590900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.145600,0.000000,12.590900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.484500,0.000000,12.590900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.823500,0.000000,12.252000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<43.484500,0.000000,12.590900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.823300,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.484300,0.000000,13.268800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.484300,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.484300,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.314900,0.000000,13.099300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<44.314900,0.000000,13.099300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.314900,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.314900,0.000000,12.421400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.314900,0.000000,12.421400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.314900,0.000000,12.421400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.484300,0.000000,12.252000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<44.314900,0.000000,12.421400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.484300,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.823300,0.000000,12.252000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.484300,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.823300,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.992800,0.000000,12.421400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<44.823300,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.992800,0.000000,12.421400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.992800,0.000000,13.099300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<44.992800,0.000000,13.099300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.992800,0.000000,13.099300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.823300,0.000000,13.268800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<44.823300,0.000000,13.268800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.484200,0.000000,12.929900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.823100,0.000000,13.268800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.484200,0.000000,12.929900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.823100,0.000000,13.268800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.823100,0.000000,12.252000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.823100,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.484200,0.000000,12.252000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.162100,0.000000,12.252000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.484200,0.000000,12.252000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.398000,0.000000,18.727400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228600,0.000000,18.727400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.228600,0.000000,18.727400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228600,0.000000,18.727400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228600,0.000000,18.896800>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.228600,0.000000,18.896800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228600,0.000000,18.896800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.398000,0.000000,18.896800>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.228600,0.000000,18.896800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.398000,0.000000,18.896800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.398000,0.000000,18.727400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.398000,0.000000,18.727400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.782400,0.000000,19.384500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.909500,0.000000,19.384500>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,0.000000,0> translate<41.782400,0.000000,19.384500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.909500,0.000000,19.384500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.163700,0.000000,19.638700>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.909500,0.000000,19.384500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.163700,0.000000,19.638700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.909500,0.000000,19.892900>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<41.909500,0.000000,19.892900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.909500,0.000000,19.892900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.782400,0.000000,19.892900>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,0.000000,0> translate<41.782400,0.000000,19.892900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.163700,0.000000,19.638700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.545000,0.000000,19.638700>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,0.000000,0> translate<42.163700,0.000000,19.638700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.623400,0.000000,17.098500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.386000,0.000000,17.606900>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,-33.687844,0> translate<39.623400,0.000000,17.098500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.623400,0.000000,17.606900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.386000,0.000000,17.098500>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,33.687844,0> translate<39.623400,0.000000,17.606900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.662800,0.000000,13.778900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.832200,0.000000,13.609500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<9.662800,0.000000,13.778900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.832200,0.000000,13.609500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.001700,0.000000,13.609500>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<9.832200,0.000000,13.609500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.001700,0.000000,13.609500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.171200,0.000000,13.778900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<10.001700,0.000000,13.609500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.171200,0.000000,13.778900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.171200,0.000000,14.626300>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<10.171200,0.000000,14.626300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.001700,0.000000,14.626300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.340700,0.000000,14.626300>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<10.001700,0.000000,14.626300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.832100,0.000000,14.287400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.171000,0.000000,14.626300>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<10.832100,0.000000,14.287400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.171000,0.000000,14.626300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.171000,0.000000,13.609500>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<11.171000,0.000000,13.609500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.832100,0.000000,13.609500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.510000,0.000000,13.609500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<10.832100,0.000000,13.609500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.893300,0.000000,34.586400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.062700,0.000000,34.417000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<75.893300,0.000000,34.586400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.062700,0.000000,34.417000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.232200,0.000000,34.417000>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<76.062700,0.000000,34.417000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.232200,0.000000,34.417000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.401700,0.000000,34.586400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<76.232200,0.000000,34.417000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.401700,0.000000,34.586400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.401700,0.000000,35.433800>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<76.401700,0.000000,35.433800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.232200,0.000000,35.433800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.571200,0.000000,35.433800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<76.232200,0.000000,35.433800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.740500,0.000000,34.417000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.062600,0.000000,34.417000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<77.062600,0.000000,34.417000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.062600,0.000000,34.417000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.740500,0.000000,35.094900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<77.062600,0.000000,34.417000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.740500,0.000000,35.094900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.740500,0.000000,35.264300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<77.740500,0.000000,35.264300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.740500,0.000000,35.264300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.571000,0.000000,35.433800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<77.571000,0.000000,35.433800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.571000,0.000000,35.433800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.232000,0.000000,35.433800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<77.232000,0.000000,35.433800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.232000,0.000000,35.433800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.062600,0.000000,35.264300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<77.062600,0.000000,35.264300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,14.774900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,14.605400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<75.691200,0.000000,14.605400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,14.605400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,14.266400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<75.691200,0.000000,14.266400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,14.266400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,14.097000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<75.691200,0.000000,14.266400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,14.097000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,14.097000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,14.097000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,14.097000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,14.266400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<76.030100,0.000000,14.097000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,14.266400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,14.605400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<76.199600,0.000000,14.605400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,14.605400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,14.774900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.199600,0.000000,14.605400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,14.774900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,14.774900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<76.369100,0.000000,14.774900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,14.774900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,14.605400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<76.538600,0.000000,14.774900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,14.605400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,14.266400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.708000,0.000000,14.266400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,14.266400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,14.097000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.538600,0.000000,14.097000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,15.944200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,15.266300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<75.691200,0.000000,15.266300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,15.266300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,15.266300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<75.691200,0.000000,15.266300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,15.266300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,15.944200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<76.708000,0.000000,15.944200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,15.266300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,15.605200>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,90.000000,0> translate<76.199600,0.000000,15.605200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,16.435600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,16.435600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<75.691200,0.000000,16.435600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,16.435600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,16.944000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<75.691200,0.000000,16.944000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,16.944000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,17.113500>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<75.691200,0.000000,16.944000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,17.113500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,17.113500>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,17.113500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,17.113500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,16.944000>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<76.199600,0.000000,17.113500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,16.944000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,16.435600>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.369100,0.000000,16.435600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,16.774500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,17.113500>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<76.369100,0.000000,16.774500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,17.604900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,17.604900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.691200,0.000000,17.604900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,17.604900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,17.943800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.369100,0.000000,17.604900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,17.943800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,18.282800>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,45.005482,0> translate<76.369100,0.000000,18.282800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,18.282800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,18.282800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.691200,0.000000,18.282800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,19.282600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,18.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<75.691200,0.000000,18.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,18.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,18.774200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<75.691200,0.000000,18.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,18.774200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,18.774200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,18.774200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,18.774200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,18.943600>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.538600,0.000000,18.774200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,18.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,19.282600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<76.708000,0.000000,19.282600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,19.282600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,19.452100>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<76.538600,0.000000,19.452100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,19.452100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,19.452100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,19.452100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,19.452100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,19.282600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<75.691200,0.000000,19.282600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,19.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,20.112900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<75.691200,0.000000,20.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,20.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,20.451900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<75.691200,0.000000,20.451900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.691200,0.000000,20.451900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,20.621400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<75.691200,0.000000,20.451900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,20.621400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,20.621400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,20.621400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,20.621400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.451900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<76.030100,0.000000,20.621400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.451900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,20.621400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.199600,0.000000,20.451900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,20.621400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,20.621400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<76.369100,0.000000,20.621400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,20.621400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,20.451900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<76.538600,0.000000,20.621400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,20.451900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,20.112900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.708000,0.000000,20.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.708000,0.000000,20.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,19.943500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<76.538600,0.000000,19.943500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.538600,0.000000,19.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,19.943500>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<76.369100,0.000000,19.943500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369100,0.000000,19.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.112900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<76.199600,0.000000,20.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,19.943500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<76.030100,0.000000,19.943500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030100,0.000000,19.943500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.860700,0.000000,19.943500>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<75.860700,0.000000,19.943500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.199600,0.000000,20.451900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<76.199600,0.000000,20.451900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.692000,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030900,0.000000,33.528800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<75.692000,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030900,0.000000,33.528800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.030900,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.030900,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.692000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.369900,0.000000,32.512000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<75.692000,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.547000,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.716400,0.000000,27.432000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<58.547000,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.716400,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.885900,0.000000,27.432000>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<58.716400,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.885900,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055400,0.000000,27.601400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<58.885900,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055400,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055400,0.000000,28.448800>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<59.055400,0.000000,28.448800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.885900,0.000000,28.448800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.224900,0.000000,28.448800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<58.885900,0.000000,28.448800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.394200,0.000000,28.448800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.716300,0.000000,28.448800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<59.716300,0.000000,28.448800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.716300,0.000000,28.448800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.716300,0.000000,27.940400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<59.716300,0.000000,27.940400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.716300,0.000000,27.940400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.055200,0.000000,28.109900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<59.716300,0.000000,27.940400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.055200,0.000000,28.109900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224700,0.000000,28.109900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<60.055200,0.000000,28.109900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224700,0.000000,28.109900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.394200,0.000000,27.940400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<60.224700,0.000000,28.109900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.394200,0.000000,27.940400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.394200,0.000000,27.601400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<60.394200,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.394200,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224700,0.000000,27.432000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<60.224700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.885700,0.000000,27.432000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<59.885700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.885700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.716300,0.000000,27.601400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<59.716300,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,24.625800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.736400,0.000000,24.625800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,24.625800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,24.371600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<54.736400,0.000000,24.371600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,24.371600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,24.244500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<54.736400,0.000000,24.371600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,24.244500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,24.244500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<54.863500,0.000000,24.244500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,24.244500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,24.371600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371900,0.000000,24.244500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,24.371600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,24.625800>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<55.499000,0.000000,24.625800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,24.625800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,24.752900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<55.371900,0.000000,24.752900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,24.752900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<55.117700,0.000000,24.752900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,24.498700>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.117700,0.000000,24.498700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,25.180000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,25.180000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<54.990600,0.000000,25.180000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,25.180000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,25.561300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<54.990600,0.000000,25.561300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,25.561300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,25.688400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.990600,0.000000,25.561300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,25.688400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,25.688400>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,0.000000,0> translate<55.117700,0.000000,25.688400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,26.623900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,26.623900>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<54.736400,0.000000,26.623900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,26.623900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,26.242600>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.499000,0.000000,26.242600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,26.242600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,26.115500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371900,0.000000,26.115500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,26.115500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,26.115500>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<55.117700,0.000000,26.115500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,26.115500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,26.242600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<54.990600,0.000000,26.242600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,26.242600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,26.623900>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<54.990600,0.000000,26.623900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,22.132200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,22.132200>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<54.736400,0.000000,22.132200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,21.878000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,22.386400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<54.736400,0.000000,22.386400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,22.813500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,23.321900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.990600,0.000000,22.813500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,22.813500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,23.321900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<54.990600,0.000000,23.321900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,19.465000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,19.465000>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<54.736400,0.000000,19.465000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,19.465000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,19.846300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<54.736400,0.000000,19.846300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,19.846300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,19.973400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.736400,0.000000,19.846300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,19.973400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,19.973400>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<54.863500,0.000000,19.973400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,19.973400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.244800,0.000000,19.846300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<55.117700,0.000000,19.973400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.244800,0.000000,19.846300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.244800,0.000000,19.465000>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.244800,0.000000,19.465000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.244800,0.000000,19.719200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,19.973400>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.244800,0.000000,19.719200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,20.400500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,20.908900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.990600,0.000000,20.400500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,20.400500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,20.908900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<54.990600,0.000000,20.908900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,16.798000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,17.306400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<55.117700,0.000000,17.306400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.863500,0.000000,17.052200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,17.052200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<54.863500,0.000000,17.052200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,17.733500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<54.736400,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.736400,0.000000,17.733500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,17.733500>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,0.000000,0> translate<54.736400,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,17.733500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,17.987700>}
box{<0,0,-0.127000><0.284204,0.036000,0.127000> rotate<0,63.430762,0> translate<54.990600,0.000000,17.987700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,17.987700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,18.114800>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<54.990600,0.000000,18.114800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.990600,0.000000,18.114800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,18.241900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.990600,0.000000,18.114800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.117700,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,18.241900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<55.117700,0.000000,18.241900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,18.114800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<55.371900,0.000000,18.241900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,18.114800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,17.860600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.499000,0.000000,17.860600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.499000,0.000000,17.860600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371900,0.000000,17.733500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371900,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.832000,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.001400,0.000000,27.432000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<52.832000,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.001400,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170900,0.000000,27.432000>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<53.001400,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170900,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.340400,0.000000,27.601400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<53.170900,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.340400,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.340400,0.000000,28.448800>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<53.340400,0.000000,28.448800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170900,0.000000,28.448800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509900,0.000000,28.448800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<53.170900,0.000000,28.448800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.679200,0.000000,28.448800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.340200,0.000000,28.279300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,-26.563298,0> translate<54.340200,0.000000,28.279300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.340200,0.000000,28.279300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.001300,0.000000,27.940400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.001300,0.000000,27.940400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.001300,0.000000,27.940400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.001300,0.000000,27.601400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<54.001300,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.001300,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.170700,0.000000,27.432000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<54.001300,0.000000,27.601400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.170700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.509700,0.000000,27.432000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<54.170700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.509700,0.000000,27.432000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.679200,0.000000,27.601400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<54.509700,0.000000,27.432000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.679200,0.000000,27.601400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.679200,0.000000,27.770900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<54.679200,0.000000,27.770900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.679200,0.000000,27.770900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.509700,0.000000,27.940400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<54.509700,0.000000,27.940400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.509700,0.000000,27.940400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.001300,0.000000,27.940400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<54.001300,0.000000,27.940400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,24.625800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.481400,0.000000,24.625800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,24.625800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,24.371600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.481400,0.000000,24.371600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,24.371600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,24.244500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<46.481400,0.000000,24.371600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,24.244500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,24.244500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.608500,0.000000,24.244500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,24.244500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,24.371600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.116900,0.000000,24.244500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,24.371600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,24.625800>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,90.000000,0> translate<47.244000,0.000000,24.625800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,24.625800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,24.752900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<47.116900,0.000000,24.752900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,24.752900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<46.862700,0.000000,24.752900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,24.752900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,24.498700>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.862700,0.000000,24.498700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,25.180000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,25.180000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.735600,0.000000,25.180000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,25.180000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,25.561300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<46.735600,0.000000,25.561300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,25.561300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,25.688400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.735600,0.000000,25.561300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,25.688400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,25.688400>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,0.000000,0> translate<46.862700,0.000000,25.688400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,26.623900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,26.623900>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<46.481400,0.000000,26.623900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,26.623900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,26.242600>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<47.244000,0.000000,26.242600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,26.242600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,26.115500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.116900,0.000000,26.115500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,26.115500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,26.115500>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<46.862700,0.000000,26.115500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,26.115500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,26.242600>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<46.735600,0.000000,26.242600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,26.242600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,26.623900>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<46.735600,0.000000,26.623900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,22.132200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,22.132200>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<46.481400,0.000000,22.132200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,21.878000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,22.386400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.481400,0.000000,22.386400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,22.813500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,23.321900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.735600,0.000000,22.813500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,22.813500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,23.321900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<46.735600,0.000000,23.321900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,19.465000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,19.465000>}
box{<0,0,-0.127000><0.762600,0.036000,0.127000> rotate<0,0.000000,0> translate<46.481400,0.000000,19.465000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,19.465000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,19.846300>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,90.000000,0> translate<46.481400,0.000000,19.846300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,19.846300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,19.973400>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.481400,0.000000,19.846300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,19.973400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,19.973400>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<46.608500,0.000000,19.973400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,19.973400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.989800,0.000000,19.846300>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<46.862700,0.000000,19.973400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.989800,0.000000,19.846300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.989800,0.000000,19.465000>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.989800,0.000000,19.465000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.989800,0.000000,19.719200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,19.973400>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.989800,0.000000,19.719200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,20.400500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,20.908900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.735600,0.000000,20.400500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,20.400500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,20.908900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<46.735600,0.000000,20.908900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,16.798000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,17.306400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.862700,0.000000,17.306400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.608500,0.000000,17.052200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,17.052200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.608500,0.000000,17.052200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,17.733500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.481400,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.481400,0.000000,17.733500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,17.733500>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,0.000000,0> translate<46.481400,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,17.733500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,17.987700>}
box{<0,0,-0.127000><0.284204,0.036000,0.127000> rotate<0,63.430762,0> translate<46.735600,0.000000,17.987700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,17.987700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,18.114800>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<46.735600,0.000000,18.114800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.735600,0.000000,18.114800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,18.241900>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.735600,0.000000,18.114800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.862700,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,18.241900>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,0.000000,0> translate<46.862700,0.000000,18.241900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,18.241900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,18.114800>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,44.997030,0> translate<47.116900,0.000000,18.241900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,18.114800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,17.860600>}
box{<0,0,-0.127000><0.254200,0.036000,0.127000> rotate<0,-90.000000,0> translate<47.244000,0.000000,17.860600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.244000,0.000000,17.860600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.116900,0.000000,17.733500>}
box{<0,0,-0.127000><0.179747,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.116900,0.000000,17.733500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.387000,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.387000,0.000000,10.922000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.387000,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.387000,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.064900,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<48.387000,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.556300,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.895200,0.000000,11.938800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<49.556300,0.000000,11.599900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.895200,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.895200,0.000000,10.922000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<49.895200,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.556300,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.234200,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<49.556300,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.938300,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.938300,0.000000,10.922000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<54.938300,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.938300,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.616200,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<54.938300,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.785500,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.107600,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<56.107600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.107600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.785500,0.000000,11.599900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<56.107600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.785500,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.785500,0.000000,11.769300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<56.785500,0.000000,11.769300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.785500,0.000000,11.769300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.616000,0.000000,11.938800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<56.616000,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.616000,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.277000,0.000000,11.938800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<56.277000,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.277000,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.107600,0.000000,11.769300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<56.107600,0.000000,11.769300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,13.837000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,13.837000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.801200,0.000000,13.837000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,13.837000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,14.175900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.801200,0.000000,13.837000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,14.175900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,14.514900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,45.005482,0> translate<32.801200,0.000000,14.514900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,14.514900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,14.514900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.801200,0.000000,14.514900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,15.006300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,15.006300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<33.140100,0.000000,15.006300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,15.006300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,15.345200>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<32.801200,0.000000,15.345200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,15.345200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,15.684200>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<32.801200,0.000000,15.345200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,15.684200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,15.684200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<33.140100,0.000000,15.684200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.309600,0.000000,15.006300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.309600,0.000000,15.684200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<33.309600,0.000000,15.684200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.970700,0.000000,16.853500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,16.684000>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.801200,0.000000,16.684000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,16.684000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,16.345000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<32.801200,0.000000,16.345000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,16.345000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.970700,0.000000,16.175600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<32.801200,0.000000,16.345000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.970700,0.000000,16.175600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.648600,0.000000,16.175600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.970700,0.000000,16.175600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.648600,0.000000,16.175600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,16.345000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<33.648600,0.000000,16.175600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,16.345000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,16.684000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<33.818000,0.000000,16.684000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,16.684000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.648600,0.000000,16.853500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<33.648600,0.000000,16.853500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.648600,0.000000,16.853500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.309600,0.000000,16.853500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<33.309600,0.000000,16.853500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.309600,0.000000,16.853500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.309600,0.000000,16.514500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.309600,0.000000,16.514500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,17.344900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,17.344900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.801200,0.000000,17.344900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,17.344900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,18.022800>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,-33.689144,0> translate<32.801200,0.000000,17.344900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,18.022800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,18.022800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.801200,0.000000,18.022800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.140100,0.000000,18.514200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,18.853100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<32.801200,0.000000,18.853100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.801200,0.000000,18.853100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,18.853100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.801200,0.000000,18.853100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,18.514200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.818000,0.000000,19.192100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<33.818000,0.000000,19.192100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.357000,0.000000,17.737000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.357000,0.000000,17.906400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<28.357000,0.000000,17.906400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.357000,0.000000,17.906400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.526400,0.000000,17.906400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.357000,0.000000,17.906400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.526400,0.000000,17.906400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.526400,0.000000,17.737000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.526400,0.000000,17.737000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.526400,0.000000,17.737000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.357000,0.000000,17.737000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.357000,0.000000,17.737000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.924000,0.000000,17.526600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.432400,0.000000,16.764000>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,56.306216,0> translate<26.924000,0.000000,17.526600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.432400,0.000000,17.526600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.924000,0.000000,16.764000>}
box{<0,0,-0.127000><0.916531,0.036000,0.127000> rotate<0,-56.306216,0> translate<26.924000,0.000000,16.764000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.829000,0.000000,19.431600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.829000,0.000000,19.304500>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.829000,0.000000,19.304500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.829000,0.000000,19.304500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.083200,0.000000,19.050300>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,44.997030,0> translate<28.829000,0.000000,19.304500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.083200,0.000000,19.050300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.337400,0.000000,19.304500>}
box{<0,0,-0.127000><0.359493,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.083200,0.000000,19.050300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.337400,0.000000,19.304500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.337400,0.000000,19.431600>}
box{<0,0,-0.127000><0.127100,0.036000,0.127000> rotate<0,90.000000,0> translate<29.337400,0.000000,19.431600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.083200,0.000000,19.050300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.083200,0.000000,18.669000>}
box{<0,0,-0.127000><0.381300,0.036000,0.127000> rotate<0,-90.000000,0> translate<29.083200,0.000000,18.669000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,29.332100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,29.332100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<3.682200,0.000000,29.332100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,29.332100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.021100,0.000000,29.671000>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<3.682200,0.000000,29.332100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.021100,0.000000,29.671000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,30.010000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,45.005482,0> translate<3.682200,0.000000,30.010000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,30.010000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,30.010000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<3.682200,0.000000,30.010000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,31.009800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,30.670800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.682200,0.000000,30.670800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,30.670800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,30.501400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<3.682200,0.000000,30.670800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,30.501400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,30.501400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.851700,0.000000,30.501400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,30.501400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,30.670800>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<4.529600,0.000000,30.501400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,30.670800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,31.009800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<4.699000,0.000000,31.009800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,31.009800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,31.179300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<4.529600,0.000000,31.179300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,31.179300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,31.179300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.851700,0.000000,31.179300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,31.179300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,31.009800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<3.682200,0.000000,31.009800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,32.009600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,32.009600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<3.682200,0.000000,32.009600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,31.670700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,32.348600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<3.682200,0.000000,32.348600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,33.348400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,33.009400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.682200,0.000000,33.009400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,33.009400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,32.840000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<3.682200,0.000000,33.009400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,32.840000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,32.840000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.851700,0.000000,32.840000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,32.840000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,33.009400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<4.529600,0.000000,32.840000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,33.009400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,33.348400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<4.699000,0.000000,33.348400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,33.348400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,33.517900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<4.529600,0.000000,33.517900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.529600,0.000000,33.517900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,33.517900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.851700,0.000000,33.517900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,33.517900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,33.348400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<3.682200,0.000000,33.348400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,34.009300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,34.009300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<3.682200,0.000000,34.009300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,34.009300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,34.517700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<3.682200,0.000000,34.517700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.682200,0.000000,34.517700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,34.687200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<3.682200,0.000000,34.517700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.851700,0.000000,34.687200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.190600,0.000000,34.687200>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.851700,0.000000,34.687200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.190600,0.000000,34.687200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.360100,0.000000,34.517700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<4.190600,0.000000,34.687200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.360100,0.000000,34.517700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.360100,0.000000,34.009300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<4.360100,0.000000,34.009300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.360100,0.000000,34.348200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.699000,0.000000,34.687200>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<4.360100,0.000000,34.348200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.603900,0.000000,36.449400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.281800,0.000000,36.449400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<3.603900,0.000000,36.449400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.942800,0.000000,36.788300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.942800,0.000000,36.110400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.942800,0.000000,36.110400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.451100,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.773200,0.000000,36.957800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<4.773200,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.773200,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.773200,0.000000,36.449400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<4.773200,0.000000,36.449400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.773200,0.000000,36.449400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.112100,0.000000,36.618900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<4.773200,0.000000,36.449400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.112100,0.000000,36.618900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.281600,0.000000,36.618900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<5.112100,0.000000,36.618900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.281600,0.000000,36.618900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.451100,0.000000,36.449400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<5.281600,0.000000,36.618900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.451100,0.000000,36.449400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.451100,0.000000,36.110400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<5.451100,0.000000,36.110400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.451100,0.000000,36.110400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.281600,0.000000,35.941000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<5.281600,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.281600,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.942600,0.000000,35.941000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<4.942600,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.942600,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.773200,0.000000,36.110400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<4.773200,0.000000,36.110400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.942500,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.942500,0.000000,36.279900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<5.942500,0.000000,36.279900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.942500,0.000000,36.279900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<6.281400,0.000000,35.941000>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<5.942500,0.000000,36.279900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<6.281400,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<6.620400,0.000000,36.279900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-44.988579,0> translate<6.281400,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<6.620400,0.000000,36.279900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<6.620400,0.000000,36.957800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<6.620400,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.726800,0.000000,36.788300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.557300,0.000000,36.957800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<8.557300,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.557300,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.218300,0.000000,36.957800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<8.218300,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.218300,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.048900,0.000000,36.788300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<8.048900,0.000000,36.788300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.048900,0.000000,36.788300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.048900,0.000000,36.110400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<8.048900,0.000000,36.110400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.048900,0.000000,36.110400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.218300,0.000000,35.941000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<8.048900,0.000000,36.110400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.218300,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.557300,0.000000,35.941000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<8.218300,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.557300,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.726800,0.000000,36.110400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<8.557300,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.726800,0.000000,36.110400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.726800,0.000000,36.449400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<8.726800,0.000000,36.449400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.726800,0.000000,36.449400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.387800,0.000000,36.449400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<8.387800,0.000000,36.449400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.218200,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.218200,0.000000,36.957800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<9.218200,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.218200,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.896100,0.000000,35.941000>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,56.304916,0> translate<9.218200,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.896100,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.896100,0.000000,36.957800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<9.896100,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.387500,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.387500,0.000000,35.941000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<10.387500,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.387500,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.895900,0.000000,35.941000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<10.387500,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.895900,0.000000,35.941000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.065400,0.000000,36.110400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<10.895900,0.000000,35.941000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.065400,0.000000,36.110400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.065400,0.000000,36.788300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<11.065400,0.000000,36.788300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.065400,0.000000,36.788300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.895900,0.000000,36.957800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<10.895900,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.895900,0.000000,36.957800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.387500,0.000000,36.957800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<10.387500,0.000000,36.957800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.333900,0.000000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.333900,0.000000,13.208800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<2.333900,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.333900,0.000000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.842300,0.000000,13.208800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.333900,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.842300,0.000000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.011800,0.000000,13.039300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<2.842300,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.011800,0.000000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.011800,0.000000,12.700400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.011800,0.000000,12.700400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.011800,0.000000,12.700400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.842300,0.000000,12.530900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.842300,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.842300,0.000000,12.530900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.333900,0.000000,12.530900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.333900,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.503200,0.000000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.503200,0.000000,12.192000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.503200,0.000000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.503200,0.000000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.842100,0.000000,12.530900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<3.503200,0.000000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.842100,0.000000,12.530900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.181100,0.000000,12.192000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<3.842100,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.181100,0.000000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.181100,0.000000,13.208800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<4.181100,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.672500,0.000000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.672500,0.000000,13.208800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<4.672500,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.672500,0.000000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.180900,0.000000,13.208800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<4.672500,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.180900,0.000000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.350400,0.000000,13.039300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<5.180900,0.000000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.350400,0.000000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.350400,0.000000,12.700400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<5.350400,0.000000,12.700400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.350400,0.000000,12.700400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.180900,0.000000,12.530900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<5.180900,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.180900,0.000000,12.530900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.672500,0.000000,12.530900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<4.672500,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.011400,0.000000,12.530900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.350400,0.000000,12.192000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<5.011400,0.000000,12.530900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.320300,0.000000,14.351000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.320300,0.000000,15.367800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<63.320300,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.320300,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.828700,0.000000,15.367800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.320300,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.828700,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.998200,0.000000,15.198300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<63.828700,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.998200,0.000000,15.198300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.998200,0.000000,14.859400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<63.998200,0.000000,14.859400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.998200,0.000000,14.859400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.828700,0.000000,14.689900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<63.828700,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.828700,0.000000,14.689900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.320300,0.000000,14.689900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.320300,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.659200,0.000000,14.689900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.998200,0.000000,14.351000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<63.659200,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.489600,0.000000,15.028900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.828500,0.000000,15.367800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<64.489600,0.000000,15.028900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.828500,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.828500,0.000000,14.351000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.828500,0.000000,14.351000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.489600,0.000000,14.351000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.167500,0.000000,14.351000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<64.489600,0.000000,14.351000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.325000,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.325000,0.000000,10.414800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<60.325000,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.325000,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.833400,0.000000,10.414800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<60.325000,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.833400,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.002900,0.000000,10.245300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<60.833400,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.002900,0.000000,10.245300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.002900,0.000000,9.906400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.002900,0.000000,9.906400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.002900,0.000000,9.906400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.833400,0.000000,9.736900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.833400,0.000000,9.736900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.833400,0.000000,9.736900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.325000,0.000000,9.736900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<60.325000,0.000000,9.736900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.663900,0.000000,9.736900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.002900,0.000000,9.398000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<60.663900,0.000000,9.736900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.172200,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.494300,0.000000,9.398000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<61.494300,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.494300,0.000000,9.398000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.172200,0.000000,10.075900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<61.494300,0.000000,9.398000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.172200,0.000000,10.075900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.172200,0.000000,10.245300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<62.172200,0.000000,10.245300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.172200,0.000000,10.245300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.002700,0.000000,10.414800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<62.002700,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.002700,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.663700,0.000000,10.414800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<61.663700,0.000000,10.414800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.663700,0.000000,10.414800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.494300,0.000000,10.245300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<61.494300,0.000000,10.245300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.975000,0.000000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.975000,0.000000,14.224800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<53.975000,0.000000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.975000,0.000000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.483400,0.000000,14.224800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.975000,0.000000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.483400,0.000000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.652900,0.000000,14.055300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<54.483400,0.000000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.652900,0.000000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.652900,0.000000,13.716400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<54.652900,0.000000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.652900,0.000000,13.716400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.483400,0.000000,13.546900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<54.483400,0.000000,13.546900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.483400,0.000000,13.546900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.975000,0.000000,13.546900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.975000,0.000000,13.546900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.313900,0.000000,13.546900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<54.652900,0.000000,13.208000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<54.313900,0.000000,13.546900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.144300,0.000000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.313700,0.000000,14.224800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<55.144300,0.000000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.313700,0.000000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<55.313700,0.000000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,14.055300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<55.652700,0.000000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.885900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.822200,0.000000,13.885900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,13.716400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.652700,0.000000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,13.716400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.483200,0.000000,13.716400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<55.483200,0.000000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,13.716400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.546900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<55.652700,0.000000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.546900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.377400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.822200,0.000000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.822200,0.000000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,13.208000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<55.652700,0.000000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.652700,0.000000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.313700,0.000000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<55.313700,0.000000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.313700,0.000000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.144300,0.000000,13.377400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<55.144300,0.000000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055000,0.000000,14.478000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055000,0.000000,15.494800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<59.055000,0.000000,15.494800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055000,0.000000,15.494800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.563400,0.000000,15.494800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<59.055000,0.000000,15.494800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.563400,0.000000,15.494800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.732900,0.000000,15.325300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<59.563400,0.000000,15.494800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.732900,0.000000,15.325300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.732900,0.000000,14.986400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<59.732900,0.000000,14.986400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.732900,0.000000,14.986400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.563400,0.000000,14.816900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<59.563400,0.000000,14.816900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.563400,0.000000,14.816900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.055000,0.000000,14.816900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<59.055000,0.000000,14.816900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.393900,0.000000,14.816900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<59.732900,0.000000,14.478000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<59.393900,0.000000,14.816900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.732700,0.000000,14.478000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.732700,0.000000,15.494800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<60.732700,0.000000,15.494800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.732700,0.000000,15.494800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224300,0.000000,14.986400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.224300,0.000000,14.986400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.224300,0.000000,14.986400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.902200,0.000000,14.986400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.224300,0.000000,14.986400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765300,0.000000,14.351000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765300,0.000000,15.367800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<67.765300,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765300,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.273700,0.000000,15.367800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<67.765300,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.273700,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443200,0.000000,15.198300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<68.273700,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443200,0.000000,15.198300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443200,0.000000,14.859400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.443200,0.000000,14.859400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443200,0.000000,14.859400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.273700,0.000000,14.689900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.273700,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.273700,0.000000,14.689900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765300,0.000000,14.689900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<67.765300,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104200,0.000000,14.689900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443200,0.000000,14.351000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<68.104200,0.000000,14.689900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612500,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934600,0.000000,15.367800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<68.934600,0.000000,15.367800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934600,0.000000,15.367800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934600,0.000000,14.859400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.934600,0.000000,14.859400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934600,0.000000,14.859400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273500,0.000000,15.028900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<68.934600,0.000000,14.859400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273500,0.000000,15.028900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.443000,0.000000,15.028900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<69.273500,0.000000,15.028900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.443000,0.000000,15.028900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612500,0.000000,14.859400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<69.443000,0.000000,15.028900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612500,0.000000,14.859400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612500,0.000000,14.520400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.612500,0.000000,14.520400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612500,0.000000,14.520400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.443000,0.000000,14.351000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<69.443000,0.000000,14.351000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.443000,0.000000,14.351000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.104000,0.000000,14.351000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.104000,0.000000,14.351000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.104000,0.000000,14.351000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934600,0.000000,14.520400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<68.934600,0.000000,14.520400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.430000,0.000000,10.033000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.430000,0.000000,11.049800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<11.430000,0.000000,11.049800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.430000,0.000000,11.049800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.938400,0.000000,11.049800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<11.430000,0.000000,11.049800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.938400,0.000000,11.049800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.107900,0.000000,10.880300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<11.938400,0.000000,11.049800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.107900,0.000000,10.880300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.107900,0.000000,10.541400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.107900,0.000000,10.541400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.107900,0.000000,10.541400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.938400,0.000000,10.371900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<11.938400,0.000000,10.371900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.938400,0.000000,10.371900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.430000,0.000000,10.371900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<11.430000,0.000000,10.371900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<11.768900,0.000000,10.371900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.107900,0.000000,10.033000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<11.768900,0.000000,10.371900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.599300,0.000000,11.049800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.277200,0.000000,11.049800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.599300,0.000000,11.049800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.277200,0.000000,11.049800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.277200,0.000000,10.880300>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.277200,0.000000,10.880300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.277200,0.000000,10.880300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.599300,0.000000,10.202400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.599300,0.000000,10.202400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.599300,0.000000,10.202400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.599300,0.000000,10.033000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.599300,0.000000,10.033000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.125300,0.000000,26.416000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.125300,0.000000,27.432800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<27.125300,0.000000,27.432800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.125300,0.000000,27.432800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.633700,0.000000,27.432800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<27.125300,0.000000,27.432800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.633700,0.000000,27.432800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.803200,0.000000,27.263300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<27.633700,0.000000,27.432800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.803200,0.000000,27.263300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.803200,0.000000,26.924400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<27.803200,0.000000,26.924400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.803200,0.000000,26.924400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.633700,0.000000,26.754900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.633700,0.000000,26.754900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.633700,0.000000,26.754900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.125300,0.000000,26.754900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<27.125300,0.000000,26.754900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.464200,0.000000,26.754900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.803200,0.000000,26.416000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<27.464200,0.000000,26.754900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.294600,0.000000,26.585400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,26.416000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<28.294600,0.000000,26.585400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,26.416000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.803000,0.000000,26.416000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<28.464000,0.000000,26.416000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.803000,0.000000,26.416000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.972500,0.000000,26.585400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<28.803000,0.000000,26.416000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.972500,0.000000,26.585400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.972500,0.000000,27.263300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<28.972500,0.000000,27.263300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.972500,0.000000,27.263300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.803000,0.000000,27.432800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<28.803000,0.000000,27.432800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.803000,0.000000,27.432800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,27.432800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<28.464000,0.000000,27.432800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,27.432800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.294600,0.000000,27.263300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<28.294600,0.000000,27.263300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.294600,0.000000,27.263300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.294600,0.000000,27.093900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.294600,0.000000,27.093900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.294600,0.000000,27.093900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,26.924400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.294600,0.000000,27.093900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.464000,0.000000,26.924400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.972500,0.000000,26.924400>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,0.000000,0> translate<28.464000,0.000000,26.924400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.495000,0.000000,22.733000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.495000,0.000000,23.749800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<23.495000,0.000000,23.749800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.495000,0.000000,23.749800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.003400,0.000000,23.749800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<23.495000,0.000000,23.749800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.003400,0.000000,23.749800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.172900,0.000000,23.580300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<24.003400,0.000000,23.749800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.172900,0.000000,23.580300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.172900,0.000000,23.241400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<24.172900,0.000000,23.241400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.172900,0.000000,23.241400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.003400,0.000000,23.071900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.003400,0.000000,23.071900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.003400,0.000000,23.071900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.495000,0.000000,23.071900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<23.495000,0.000000,23.071900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.833900,0.000000,23.071900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.172900,0.000000,22.733000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<23.833900,0.000000,23.071900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.664300,0.000000,23.410900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.003200,0.000000,23.749800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.664300,0.000000,23.410900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.003200,0.000000,23.749800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.003200,0.000000,22.733000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<25.003200,0.000000,22.733000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.664300,0.000000,22.733000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.342200,0.000000,22.733000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<24.664300,0.000000,22.733000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.833600,0.000000,22.902400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.833600,0.000000,23.580300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<25.833600,0.000000,23.580300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.833600,0.000000,23.580300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.003000,0.000000,23.749800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<25.833600,0.000000,23.580300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.003000,0.000000,23.749800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.342000,0.000000,23.749800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.003000,0.000000,23.749800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.342000,0.000000,23.749800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.511500,0.000000,23.580300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<26.342000,0.000000,23.749800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.511500,0.000000,23.580300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.511500,0.000000,22.902400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<26.511500,0.000000,22.902400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.511500,0.000000,22.902400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.342000,0.000000,22.733000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<26.342000,0.000000,22.733000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.342000,0.000000,22.733000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.003000,0.000000,22.733000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.003000,0.000000,22.733000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.003000,0.000000,22.733000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.833600,0.000000,22.902400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<25.833600,0.000000,22.902400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.833600,0.000000,22.902400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.511500,0.000000,23.580300>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<25.833600,0.000000,22.902400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.845900,0.000000,16.256000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.845900,0.000000,17.272800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<34.845900,0.000000,17.272800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.845900,0.000000,17.272800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.354300,0.000000,17.272800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<34.845900,0.000000,17.272800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.354300,0.000000,17.272800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.523800,0.000000,17.103300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<35.354300,0.000000,17.272800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.523800,0.000000,17.103300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.523800,0.000000,16.764400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.523800,0.000000,16.764400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.523800,0.000000,16.764400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.354300,0.000000,16.594900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.354300,0.000000,16.594900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.354300,0.000000,16.594900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.845900,0.000000,16.594900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<34.845900,0.000000,16.594900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.184800,0.000000,16.594900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.523800,0.000000,16.256000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<35.184800,0.000000,16.594900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.015200,0.000000,16.933900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.354100,0.000000,17.272800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<36.015200,0.000000,16.933900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.354100,0.000000,17.272800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.354100,0.000000,16.256000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.354100,0.000000,16.256000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.015200,0.000000,16.256000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.693100,0.000000,16.256000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<36.015200,0.000000,16.256000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.184500,0.000000,16.933900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.523400,0.000000,17.272800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.184500,0.000000,16.933900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.523400,0.000000,17.272800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.523400,0.000000,16.256000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<37.523400,0.000000,16.256000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.184500,0.000000,16.256000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.862400,0.000000,16.256000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.184500,0.000000,16.256000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.145900,0.000000,19.431000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.145900,0.000000,20.447800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<22.145900,0.000000,20.447800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.145900,0.000000,20.447800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.654300,0.000000,20.447800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<22.145900,0.000000,20.447800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.654300,0.000000,20.447800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.823800,0.000000,20.278300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<22.654300,0.000000,20.447800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.823800,0.000000,20.278300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.823800,0.000000,19.939400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<22.823800,0.000000,19.939400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.823800,0.000000,19.939400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.654300,0.000000,19.769900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<22.654300,0.000000,19.769900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.654300,0.000000,19.769900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.145900,0.000000,19.769900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<22.145900,0.000000,19.769900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.484800,0.000000,19.769900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.823800,0.000000,19.431000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<22.484800,0.000000,19.769900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.315200,0.000000,20.108900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.654100,0.000000,20.447800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<23.315200,0.000000,20.108900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.654100,0.000000,20.447800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.654100,0.000000,19.431000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<23.654100,0.000000,19.431000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.315200,0.000000,19.431000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.993100,0.000000,19.431000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<23.315200,0.000000,19.431000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.162400,0.000000,19.431000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.484500,0.000000,19.431000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<24.484500,0.000000,19.431000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.484500,0.000000,19.431000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.162400,0.000000,20.108900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.484500,0.000000,19.431000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.162400,0.000000,20.108900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.162400,0.000000,20.278300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<25.162400,0.000000,20.278300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.162400,0.000000,20.278300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.992900,0.000000,20.447800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<24.992900,0.000000,20.447800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.992900,0.000000,20.447800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.653900,0.000000,20.447800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<24.653900,0.000000,20.447800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.653900,0.000000,20.447800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.484500,0.000000,20.278300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<24.484500,0.000000,20.278300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.480900,0.000000,12.446000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.480900,0.000000,13.462800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<35.480900,0.000000,13.462800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.480900,0.000000,13.462800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.989300,0.000000,13.462800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.480900,0.000000,13.462800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.989300,0.000000,13.462800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.158800,0.000000,13.293300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<35.989300,0.000000,13.462800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.158800,0.000000,13.293300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.158800,0.000000,12.954400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.158800,0.000000,12.954400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.158800,0.000000,12.954400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.989300,0.000000,12.784900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.989300,0.000000,12.784900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.989300,0.000000,12.784900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.480900,0.000000,12.784900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.480900,0.000000,12.784900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.819800,0.000000,12.784900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.158800,0.000000,12.446000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<35.819800,0.000000,12.784900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.650200,0.000000,13.123900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.989100,0.000000,13.462800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<36.650200,0.000000,13.123900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.989100,0.000000,13.462800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.989100,0.000000,12.446000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.989100,0.000000,12.446000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.650200,0.000000,12.446000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.328100,0.000000,12.446000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<36.650200,0.000000,12.446000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.819500,0.000000,13.293300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.988900,0.000000,13.462800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<37.819500,0.000000,13.293300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.988900,0.000000,13.462800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,13.462800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.988900,0.000000,13.462800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,13.462800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,13.293300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<38.327900,0.000000,13.462800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,13.293300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,13.123900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.497400,0.000000,13.123900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,13.123900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,12.954400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.327900,0.000000,12.954400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,12.954400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.158400,0.000000,12.954400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<38.158400,0.000000,12.954400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,12.954400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,12.784900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<38.327900,0.000000,12.954400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,12.784900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,12.615400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.497400,0.000000,12.615400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.497400,0.000000,12.615400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,12.446000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<38.327900,0.000000,12.446000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.327900,0.000000,12.446000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.988900,0.000000,12.446000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.988900,0.000000,12.446000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.988900,0.000000,12.446000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.819500,0.000000,12.615400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<37.819500,0.000000,12.615400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.675000,0.000000,16.383000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.675000,0.000000,17.399800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<66.675000,0.000000,17.399800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.675000,0.000000,17.399800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.183400,0.000000,17.399800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.675000,0.000000,17.399800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.183400,0.000000,17.399800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.352900,0.000000,17.230300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<67.183400,0.000000,17.399800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.352900,0.000000,17.230300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.352900,0.000000,16.891400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<67.352900,0.000000,16.891400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.352900,0.000000,16.891400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.183400,0.000000,16.721900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.183400,0.000000,16.721900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.183400,0.000000,16.721900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.675000,0.000000,16.721900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.675000,0.000000,16.721900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.013900,0.000000,16.721900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.352900,0.000000,16.383000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<67.013900,0.000000,16.721900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.844300,0.000000,17.060900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.183200,0.000000,17.399800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.844300,0.000000,17.060900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.183200,0.000000,17.399800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.183200,0.000000,16.383000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.183200,0.000000,16.383000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.844300,0.000000,16.383000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.522200,0.000000,16.383000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<67.844300,0.000000,16.383000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.522000,0.000000,16.383000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.522000,0.000000,17.399800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<69.522000,0.000000,17.399800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.522000,0.000000,17.399800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.013600,0.000000,16.891400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<69.013600,0.000000,16.891400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.013600,0.000000,16.891400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.691500,0.000000,16.891400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<69.013600,0.000000,16.891400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,18.796000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,19.812800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<66.595900,0.000000,19.812800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,19.812800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,19.812800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.595900,0.000000,19.812800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,19.812800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,19.643300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<67.104300,0.000000,19.812800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,19.643300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,19.304400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<67.273800,0.000000,19.304400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,19.304400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,19.134900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.104300,0.000000,19.134900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,19.134900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,19.134900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.595900,0.000000,19.134900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.934800,0.000000,19.134900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,18.796000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<66.934800,0.000000,19.134900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765200,0.000000,19.473900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,19.812800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.765200,0.000000,19.473900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,19.812800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,18.796000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.104100,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765200,0.000000,18.796000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443100,0.000000,18.796000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<67.765200,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,19.812800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,19.812800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<68.934500,0.000000,19.812800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,19.812800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,19.304400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.934500,0.000000,19.304400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,19.304400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273400,0.000000,19.473900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,-26.570060,0> translate<68.934500,0.000000,19.304400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273400,0.000000,19.473900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,19.473900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<69.273400,0.000000,19.473900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,19.473900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,19.304400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<69.442900,0.000000,19.473900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,19.304400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,18.965400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.612400,0.000000,18.965400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,18.965400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,18.796000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<69.442900,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,18.796000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.103900,0.000000,18.796000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.103900,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.103900,0.000000,18.796000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,18.965400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<68.934500,0.000000,18.965400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,21.336000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,22.352800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<66.595900,0.000000,22.352800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,22.352800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,22.352800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.595900,0.000000,22.352800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,22.352800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,22.183300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<67.104300,0.000000,22.352800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,22.183300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,21.844400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<67.273800,0.000000,21.844400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,21.844400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,21.674900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.104300,0.000000,21.674900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.104300,0.000000,21.674900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.595900,0.000000,21.674900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.595900,0.000000,21.674900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.934800,0.000000,21.674900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.273800,0.000000,21.336000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<66.934800,0.000000,21.674900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765200,0.000000,22.013900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,22.352800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<67.765200,0.000000,22.013900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,22.352800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.104100,0.000000,21.336000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.104100,0.000000,21.336000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<67.765200,0.000000,21.336000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.443100,0.000000,21.336000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<67.765200,0.000000,21.336000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,22.352800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273400,0.000000,22.183300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,-26.563298,0> translate<69.273400,0.000000,22.183300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.273400,0.000000,22.183300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,21.844400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.934500,0.000000,21.844400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,21.844400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,21.505400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.934500,0.000000,21.505400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,21.505400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.103900,0.000000,21.336000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<68.934500,0.000000,21.505400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.103900,0.000000,21.336000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,21.336000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.103900,0.000000,21.336000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,21.336000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,21.505400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<69.442900,0.000000,21.336000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,21.505400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,21.674900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<69.612400,0.000000,21.674900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.612400,0.000000,21.674900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,21.844400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<69.442900,0.000000,21.844400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.442900,0.000000,21.844400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.934500,0.000000,21.844400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<68.934500,0.000000,21.844400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.163400,0.000000,36.322000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.163400,0.000000,37.338800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<75.163400,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<74.824500,0.000000,37.338800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.502400,0.000000,37.338800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<74.824500,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.671700,0.000000,37.169300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,37.338800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<76.502200,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,37.338800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,37.338800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<76.163200,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,37.338800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.993800,0.000000,37.169300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<75.993800,0.000000,37.169300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.993800,0.000000,37.169300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.993800,0.000000,36.999900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<75.993800,0.000000,36.999900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.993800,0.000000,36.999900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,36.830400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<75.993800,0.000000,36.999900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,36.830400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,36.830400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<76.163200,0.000000,36.830400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,36.830400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.671700,0.000000,36.660900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<76.502200,0.000000,36.830400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.671700,0.000000,36.660900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.671700,0.000000,36.491400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<76.671700,0.000000,36.491400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.671700,0.000000,36.491400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,36.322000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<76.502200,0.000000,36.322000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.502200,0.000000,36.322000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,36.322000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<76.163200,0.000000,36.322000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<76.163200,0.000000,36.322000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<75.993800,0.000000,36.491400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<75.993800,0.000000,36.491400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.502000,0.000000,36.322000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.502000,0.000000,37.338800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<77.502000,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.163100,0.000000,37.338800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<77.841000,0.000000,37.338800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<77.163100,0.000000,37.338800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<78.332400,0.000000,36.999900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<78.671300,0.000000,37.338800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<78.332400,0.000000,36.999900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<78.671300,0.000000,37.338800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<78.671300,0.000000,36.322000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<78.671300,0.000000,36.322000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<78.332400,0.000000,36.322000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<79.010300,0.000000,36.322000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<78.332400,0.000000,36.322000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.031200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,0.931400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<2.031200,0.000000,0.931400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,0.931400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,0.762000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<2.031200,0.000000,0.931400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,0.762000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<2.200700,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,0.931400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.878600,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,0.931400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,1.270400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<3.048000,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,1.439900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<2.878600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,1.439900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<2.539600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,1.100900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<2.539600,0.000000,1.100900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,1.931300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<2.031200,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,2.609200>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,-33.689144,0> translate<2.031200,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,2.609200>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<2.031200,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,3.100600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<2.031200,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,3.609000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<3.048000,0.000000,3.609000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,3.609000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,3.778500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<2.878600,0.000000,3.778500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,3.778500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,3.778500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<2.200700,0.000000,3.778500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,3.778500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,3.609000>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.031200,0.000000,3.609000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,3.609000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,3.100600>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<2.031200,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.249100,0.000000,0.762000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<4.571200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.249100,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,1.100900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<5.249100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,1.100900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.249100,0.000000,1.439900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,45.005482,0> translate<5.249100,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.249100,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,1.439900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<4.571200,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,2.270200>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,90.000000,0> translate<5.588000,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,2.100700>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<4.571200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,2.270200>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,90.000000,0> translate<4.571200,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,2.710800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,2.710800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<4.571200,0.000000,2.710800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,2.710800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,3.388700>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,-33.689144,0> translate<4.571200,0.000000,2.710800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<5.588000,0.000000,3.388700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<4.571200,0.000000,3.388700>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<4.571200,0.000000,3.388700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,0.762000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<7.111200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,1.100900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<7.789100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,1.100900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,1.439900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,45.005482,0> translate<7.789100,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,1.439900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<7.111200,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,1.931300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<7.111200,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,2.439700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<7.111200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.111200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.280700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<7.111200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.280700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,2.609200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<7.280700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,2.439700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<7.450100,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<7.619600,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,2.609200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<7.789100,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<7.958600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,1.931300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<8.128000,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,2.439700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<7.619600,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,3.609000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<7.450100,0.000000,3.609000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,3.609000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,3.778500>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<7.450100,0.000000,3.609000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.619600,0.000000,3.778500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,3.778500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<7.619600,0.000000,3.778500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,3.778500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,3.270000>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,-90.000000,0> translate<8.128000,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,3.100600>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<7.958600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,3.270000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<7.789100,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.789100,0.000000,3.778500>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,90.000000,0> translate<7.789100,0.000000,3.778500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.280700,0.000000,4.439300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,4.439300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<7.280700,0.000000,4.439300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.958600,0.000000,4.439300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<8.128000,0.000000,4.608800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<7.958600,0.000000,4.439300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,4.269900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<7.450100,0.000000,4.608800>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,90.000000,0> translate<7.450100,0.000000,4.608800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.144000,0.000000,0.635000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.144000,0.000000,4.143100>}
box{<0,0,-0.127000><3.508100,0.036000,0.127000> rotate<0,90.000000,0> translate<9.144000,0.000000,4.143100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<9.651200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<9.651200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.820700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<9.651200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.820700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<9.820700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<10.159600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<10.329100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,1.100900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,1.439900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<10.329100,0.000000,1.100900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.820700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,2.439700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<9.651200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<9.651200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.820700,0.000000,1.931300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<9.651200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.820700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.990100,0.000000,1.931300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<9.820700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.990100,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<9.990100,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<10.159600,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.159600,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<10.159600,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.329100,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.498600,0.000000,2.609200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<10.329100,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.498600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<10.498600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<10.668000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.498600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<10.498600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<10.668000,0.000000,3.439500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,3.439500>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<9.651200,0.000000,3.439500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<9.651200,0.000000,3.778500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<9.651200,0.000000,3.778500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<12.191200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<12.191200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.191200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<12.699600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.869100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<12.191200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<12.191200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.191200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<13.038600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.208000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<13.038600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<12.360700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<13.038600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<13.038600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<13.038600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.208000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.854600>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<13.038600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<13.208000,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,4.363100>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<13.038600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.191200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.191200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<12.191200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.530100,0.000000,3.685200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.530100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<12.530100,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,4.363100>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,90.000000,0> translate<12.699600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<14.731200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<14.731200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<14.731200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<15.239600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<15.409100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<14.731200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<14.731200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<14.731200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<15.578600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<15.748000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<15.578600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<14.900700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<15.578600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<15.578600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<15.578600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<15.748000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<14.731200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<14.731200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<14.731200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.070100,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.070100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<15.070100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<15.239600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<15.409100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,4.193600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<15.578600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<15.748000,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.685200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<15.578600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,3.685200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<15.409100,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<15.239600,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.070100,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<15.070100,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.070100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,3.685200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<15.239600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<17.271200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<17.271200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.271200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.779600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<17.440700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.779600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<17.779600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.949100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<17.949100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<17.440700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<17.271200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<17.271200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.271200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<17.440700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<18.118600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<18.288000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<18.118600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<17.440700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<18.118600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<18.118600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<18.118600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<18.288000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<17.271200,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<17.271200,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.685200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<17.440700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,3.685200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<18.118600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<19.811200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<19.811200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<19.811200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.980700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.489100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<20.319600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.489100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.489100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<20.489100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.980700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<19.811200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<19.811200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<19.811200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.980700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<20.658600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<20.828000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<20.658600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<19.980700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<20.658600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<20.658600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<20.658600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<20.828000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,4.024100>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,63.430762,0> translate<19.811200,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,3.685200>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<19.980700,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.685200>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<20.319600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.854600>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<20.658600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<20.828000,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,4.363100>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<20.658600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.489100,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<20.489100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.489100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<20.319600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,3.685200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<20.319600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<22.351200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<22.351200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<22.351200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.859600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.859600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.029100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<22.859600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.029100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.029100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<23.029100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<22.351200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<22.351200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<22.351200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<23.198600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<23.368000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<23.198600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<22.520700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<23.198600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<23.198600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<23.198600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<23.368000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<22.351200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<22.351200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<22.351200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,4.193600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<23.198600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<23.368000,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.685200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<23.198600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<22.520700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<24.891200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<24.891200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.891200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.399600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<25.060700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.399600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.569100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<25.399600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.569100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.569100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<25.569100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<25.060700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<24.891200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<24.891200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.891200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<25.060700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<25.738600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<25.908000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<25.738600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<25.060700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<25.738600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<25.738600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<25.738600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<25.908000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.230100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<24.891200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<24.891200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<25.908000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<27.431200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<27.431200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.431200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<27.939600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.109100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.431200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<27.431200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.431200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.278600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.448000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.278600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<27.600700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.278600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<28.278600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.278600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.448000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.770100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<27.431200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<27.431200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<28.448000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.431200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<27.431200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.431200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.770100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.770100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<27.770100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.939600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<28.109100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.278600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.448000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.278600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,4.854500>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<28.109100,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.939600,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.770100,0.000000,4.854500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<27.770100,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.770100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,4.854500>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<27.939600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<29.971200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<29.971200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.971200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<30.479600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.649100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<29.971200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<29.971200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.971200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<30.818600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.988000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.818600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<30.140700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<30.818600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<30.818600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<30.818600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.988000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.310100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<29.971200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<29.971200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<30.988000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<29.971200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<29.971200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,4.854500>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<30.140700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,4.854500>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<30.818600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.511200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<32.511200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.511200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<33.019600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.189100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<32.511200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<32.511200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.511200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<33.358600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<33.358600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<32.680700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.358600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<33.358600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.358600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<32.511200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.511200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<33.528000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,4.854500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<32.511200,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,4.854500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<32.511200,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,5.193400>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,63.424001,0> translate<32.850100,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,5.362900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<32.850100,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.850100,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,5.532400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<33.019600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<33.358600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<33.358600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<35.051200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<35.051200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.051200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<35.559600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.729100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<35.051200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<35.051200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.051200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<35.898600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.068000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.898600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<35.220700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.898600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<35.898600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.898600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.068000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.390100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<35.051200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<35.051200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,5.193400>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,63.430762,0> translate<35.051200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,4.854500>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<35.220700,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,4.854500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<35.559600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,5.023900>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.898600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068000,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,5.532400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<35.898600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<35.729100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.559600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,4.854500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.559600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<37.591200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<37.591200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<38.099600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.269100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.591200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<37.591200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<38.438600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.438600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<37.760700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<38.438600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<38.438600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<38.438600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<37.930100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<37.591200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.591200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.591200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<37.591200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<37.930100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,5.193400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.099600,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.099600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<38.269100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<38.438600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.438600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<40.131200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<40.131200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.131200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<40.639600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<40.809100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<40.131200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<40.131200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.131200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<40.978600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.148000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.978600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<40.300700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.978600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<40.978600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.978600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.148000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.148000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.470100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<40.470100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.470100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.131200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<40.131200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<40.131200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,5.362900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<40.131200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,4.854500>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<40.131200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<40.639600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<42.671200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<42.671200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<43.179600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.349100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.671200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<42.671200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<43.518600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.518600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<42.840700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.518600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<43.518600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.518600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<43.010100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.671200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.671200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,4.854500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.671200,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,4.854500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.671200,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,5.193400>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,63.424001,0> translate<43.010100,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,5.362900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<43.010100,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.010100,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,5.532400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<43.179600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<43.518600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.518600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<45.211200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<45.211200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<45.719600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.889100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<45.211200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<45.211200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<46.058600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.058600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<45.380700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.058600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.058600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.058600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<45.550100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.211200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<45.211200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,5.193400>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,63.430762,0> translate<45.211200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,4.854500>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<45.380700,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,4.854500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<45.719600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,5.023900>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.058600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<46.228000,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,5.532400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<46.058600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<45.889100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.719600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,4.854500>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.719600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<47.751200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<47.751200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.751200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<48.259600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.429100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.090100,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,2.270200>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<47.751200,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,2.270200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,2.270200>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<47.751200,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<48.768000,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<48.598600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<48.598600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<48.598600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.768000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<47.751200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<47.751200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.751200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.090100,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.090100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<48.090100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,4.024100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.259600,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<48.259600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<48.429100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,4.193600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<48.598600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.768000,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,3.685200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<48.598600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,4.854500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<47.751200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<47.751200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.751200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<48.598600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.768000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<48.598600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,5.532400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<47.920700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<50.291200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<50.291200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.291200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<50.460700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<50.799600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.969100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,2.270200>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<50.291200,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,2.270200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,2.270200>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<50.291200,0.000000,2.270200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<51.308000,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<51.138600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<51.138600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<51.138600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<51.308000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<50.291200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<50.291200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.291200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<50.460700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<50.630100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,4.024100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.799600,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.799600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<50.969100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,4.193600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<51.138600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<51.308000,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,3.685200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<51.138600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,5.193400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<50.291200,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,5.193400>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<50.291200,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<51.308000,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<52.831200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<52.831200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.831200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<53.339600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.509100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<52.831200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<52.831200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.831200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<53.678600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.848000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<53.678600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<53.000700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.678600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<53.678600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.678600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.848000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.848000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<53.170100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.831200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<52.831200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<52.831200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<55.371200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<55.371200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<55.879600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.049100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<55.371200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<55.371200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<56.218600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.388000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<56.218600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<55.540700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<56.218600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<56.218600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<56.218600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.388000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,3.854600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<55.371200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,4.193600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<55.371200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.710100,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.710100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<55.710100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,4.024100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.879600,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,4.363100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.879600,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,4.363100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<56.049100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,4.193600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<56.218600,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.388000,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,3.685200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<56.218600,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<57.911200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<57.911200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<58.419600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.589100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<57.911200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<57.911200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<58.758600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<58.758600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<58.080700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.758600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<58.758600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.758600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<58.250100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<57.911200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<57.911200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,5.193400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<57.911200,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,5.193400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,5.193400>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<57.911200,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<58.928000,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<60.451200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<60.451200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.959600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.959600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<60.959600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.129100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.451200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<60.451200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<61.298600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<61.298600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<60.620700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.298600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<61.298600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.298600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<60.790100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<60.451200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.451200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,4.854500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,5.532400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<60.790100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,5.532400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<60.451200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,4.854500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.451200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<62.991200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<62.991200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.991200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.499600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.499600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<63.499600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<63.669100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.991200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<62.991200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.991200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<63.838600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.008000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<63.838600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.160700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.838600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<63.838600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.838600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.008000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.008000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.330100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.991200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.991200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.991200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,5.532400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.991200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<62.991200,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,4.854500>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.160700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,4.854500>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.838600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<65.531200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<65.531200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<66.039600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.209100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,2.100700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.531200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,2.439700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<65.531200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,2.609200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,2.609200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,2.439700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<66.378600,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,1.931300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<66.378600,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<65.700700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.378600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<66.378600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.378600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.685200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,3.685200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,4.363100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<65.870100,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,4.363100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,4.363100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,4.193600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,4.193600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,4.193600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,3.854600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<65.531200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,3.854600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,3.685200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.531200,0.000000,3.854600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.531200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<65.531200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<65.870100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<66.039600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<66.209100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<66.378600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<66.378600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,4.854500>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<66.209100,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<66.039600,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,4.854500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<65.870100,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,4.854500>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<66.039600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,0.762000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<68.071200,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,0.762000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,1.270400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<68.071200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,1.439900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.071200,0.000000,1.270400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,1.439900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<68.240700,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,1.439900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.749100,0.000000,1.270400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<68.579600,0.000000,1.439900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.749100,0.000000,1.270400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.749100,0.000000,0.762000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.749100,0.000000,0.762000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,1.931300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.088000,0.000000,1.931300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,1.931300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.410100,0.000000,2.609200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<68.410100,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.410100,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,2.609200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<68.240700,0.000000,2.609200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,2.609200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,2.439700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.071200,0.000000,2.439700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,2.439700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,2.100700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.071200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,2.100700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,1.931300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<68.071200,0.000000,2.100700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<68.918600,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,3.100600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<68.918600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,3.270000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<68.918600,0.000000,3.270000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,3.270000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,3.100600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.088000,0.000000,3.100600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.410100,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,4.024100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<68.071200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,4.024100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,4.024100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<68.071200,0.000000,4.024100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,3.685200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,4.363100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<69.088000,0.000000,4.363100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,4.854500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,5.023900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<68.071200,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,5.362900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<68.071200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.071200,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.410100,0.000000,5.532400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<68.240700,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.410100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,5.362900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<68.410100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,5.193400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.579600,0.000000,5.193400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.749100,0.000000,5.532400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.579600,0.000000,5.362900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.749100,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,5.532400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<68.749100,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,5.532400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,5.362900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<68.918600,0.000000,5.532400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,5.362900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,5.023900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.088000,0.000000,5.023900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,5.023900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,4.854500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.918600,0.000000,4.854500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,33.189900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<2.539600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,32.850900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,32.850900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<2.200700,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,33.850700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<2.031200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,34.189700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<2.031200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.031200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.370100,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.200700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.370100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<2.370100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,34.020200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<2.539600,0.000000,34.020200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.709100,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.539600,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.709100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,34.359200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<2.709100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,34.189700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<2.878600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.048000,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,33.681300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.878600,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.878600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<2.878600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.878600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.048000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,35.604600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<2.031200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<2.031200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.031200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.031200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.200700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.370100,0.000000,36.113100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<2.200700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.370100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,35.943600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<2.370100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,35.774100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<2.539600,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.539600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.709100,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.539600,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.709100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,36.113100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<2.709100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<2.878600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<3.048000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<3.048000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<2.878600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<2.878600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<12.191200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<12.191200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.191200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<12.699600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.869100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.869100,0.000000,32.850900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,33.189900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<12.869100,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,33.681300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<12.191200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,34.189700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<13.208000,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.208000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,34.359200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<13.038600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.038600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<12.360700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.360700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<12.191200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.191200,0.000000,33.681300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.191200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.699600,0.000000,35.528500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<12.699600,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<14.731200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<14.731200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<14.731200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<15.239600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<15.409100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.409100,0.000000,32.850900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,33.189900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-45.005482,0> translate<15.409100,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,33.681300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<14.731200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,34.189700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<15.748000,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.748000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,34.359200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<15.578600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<14.731200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.731200,0.000000,33.681300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<14.731200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.239600,0.000000,35.528500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<15.239600,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.900700,0.000000,35.189500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.578600,0.000000,35.189500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<14.900700,0.000000,35.189500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,32.850900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,32.850900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<17.271200,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,33.189900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<17.271200,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,33.681300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<17.271200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,34.189700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<18.288000,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.288000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,34.359200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<18.118600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<18.118600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<17.440700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.440700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.271200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.271200,0.000000,33.681300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<17.271200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.779600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.779600,0.000000,35.528500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<17.779600,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,32.850900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,32.850900>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<19.811200,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,33.189900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<19.811200,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,33.681300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<19.811200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,34.189700>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<20.828000,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.828000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,34.359200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<20.658600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.980700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<19.811200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.811200,0.000000,33.681300>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<19.811200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.319600,0.000000,35.528500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<20.319600,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<19.980700,0.000000,35.189500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<20.658600,0.000000,35.189500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<19.980700,0.000000,35.189500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<22.351200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<23.368000,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.368000,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,33.189900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<23.198600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<23.198600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,33.189900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<22.520700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.520700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<22.351200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.351200,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<22.351200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.859600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<22.859600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<22.859600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<24.891200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<25.908000,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.908000,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,33.189900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<25.738600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,33.189900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<25.060700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<24.891200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<24.891200,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<24.891200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.399600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.399600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<25.399600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.060700,0.000000,34.020200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<25.738600,0.000000,34.020200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<25.060700,0.000000,34.020200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<27.431200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<27.431200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.431200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<27.939600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.109100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.109100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,33.850700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.431200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,34.189700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<27.431200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.431200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<27.600700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,34.189700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.278600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.448000,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,33.681300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.278600,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.600700,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<27.600700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.278600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<28.278600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.278600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<28.278600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.448000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.448000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,35.943600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<27.431200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.431200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,35.435200>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<27.431200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.939600,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<27.939600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<29.971200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<29.971200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.971200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<30.479600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.649100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.649100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,33.850700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<29.971200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,34.189700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<29.971200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.971200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.140700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,34.189700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<30.818600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.988000,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,33.681300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.818600,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.140700,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<30.140700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<30.818600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<30.818600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<30.818600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.988000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,35.435200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<29.971200,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.971200,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,35.435200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<29.971200,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.310100,0.000000,35.774100>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,63.424001,0> translate<30.310100,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.310100,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.310100,0.000000,35.943600>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<30.310100,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.310100,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.310100,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.479600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,36.113100>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<30.479600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<30.818600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.988000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.988000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.818600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.818600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.511200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<32.511200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.511200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.019600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<33.019600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.189100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.189100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,33.850700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<32.511200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,34.189700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<32.511200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.511200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,34.189700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<33.358600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,33.681300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<33.358600,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<32.680700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.358600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<33.358600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<33.358600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.850100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<32.511200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<32.511200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<33.528000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,36.604500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,36.604500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,36.773900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<32.511200,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,36.773900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,37.112900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<32.511200,0.000000,37.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.511200,0.000000,37.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,37.282400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.511200,0.000000,37.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,37.282400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.680700,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,37.112900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<33.358600,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,37.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,36.773900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.528000,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.528000,0.000000,36.773900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,36.604500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<33.358600,0.000000,36.604500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.358600,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.680700,0.000000,37.282400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<32.680700,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<35.051200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<35.051200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.051200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.559600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<35.559600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.729100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,33.850700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<35.051200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,34.189700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<35.051200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,34.359200>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.051200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,34.359200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.220700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,34.189700>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<35.898600,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.068000,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,33.681300>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<35.898600,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.220700,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<35.220700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.898600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<35.898600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.898600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<35.898600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.068000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.390100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<35.051200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<35.051200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.390100,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,36.943400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<35.051200,0.000000,36.943400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.051200,0.000000,36.943400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,36.943400>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<35.051200,0.000000,36.943400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068000,0.000000,37.282400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068000,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<37.591200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<37.591200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.099600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<38.099600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.269100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.269100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<37.930100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.930100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<37.591200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.591200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<38.438600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<38.438600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<38.438600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,35.435200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,35.604600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.591200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<37.591200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.591200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.591200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<37.760700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<38.438600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.608000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.608000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.438600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.438600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.760700,0.000000,36.113100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<37.760700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<40.131200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<40.131200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.131200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.639600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<40.639600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.809100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<40.809100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.148000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.470100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<40.470100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.470100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.300700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.131200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<40.131200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.300700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<40.131200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.978600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<40.978600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.978600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<40.978600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.148000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.470100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<40.131200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.131200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<40.131200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.148000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<41.148000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<42.671200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<42.671200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.179600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<43.179600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.349100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<43.010100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.671200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.671200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.518600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<43.518600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.518600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<43.518600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,35.435200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.688000,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.688000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,36.113100>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<43.010100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.010100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,36.113100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.840700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,35.943600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.671200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.671200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.671200,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.840700,0.000000,35.435200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.671200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<45.211200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<45.211200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<45.719600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.889100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<45.550100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.211200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<45.211200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.058600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<46.058600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<46.058600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,35.604600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<45.211200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<45.211200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.211200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.211200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.380700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,36.113100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<45.380700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.550100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,35.943600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<45.550100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,35.774100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.719600,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.719600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.719600,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.889100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,36.113100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<45.889100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<46.058600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.228000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.228000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.058600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<46.058600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<47.751200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<47.751200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.751200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<48.259600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.429100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.429100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.768000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.090100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<48.090100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.090100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<47.920700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<47.751200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<47.751200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.920700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<47.751200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<48.598600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<48.598600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.598600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<48.598600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<48.768000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.768000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,35.943600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<47.751200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.751200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,35.435200>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<47.751200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<48.259600,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<48.259600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<50.291200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<50.291200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.291200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<50.460700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<50.799600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.969100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.969100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<51.308000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<50.630100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<50.460700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.291200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.291200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.460700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<50.291200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<51.138600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<51.138600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<51.138600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<51.308000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,35.435200>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.291200,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.291200,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,35.435200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<50.291200,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,35.774100>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,63.424001,0> translate<50.630100,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,35.943600>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<50.630100,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.630100,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<50.630100,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.799600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,36.113100>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<50.799600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<51.138600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<51.308000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.308000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.138600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<51.138600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<52.831200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<52.831200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.831200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<53.339600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.509100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.848000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<53.170100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.170100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.000700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.831200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<52.831200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<52.831200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.678600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<53.678600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<53.678600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.848000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.831200,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,35.774100>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,63.430762,0> translate<52.831200,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.000700,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,35.435200>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<53.000700,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,35.435200>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<53.339600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.604600>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<53.678600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<53.848000,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.848000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,36.113100>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<53.678600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.678600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,36.113100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<53.509100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.509100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,35.943600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<53.339600,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<53.339600,0.000000,35.435200>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<53.339600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<55.371200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<55.371200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.879600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<55.879600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.049100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.049100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.388000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.710100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<55.710100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.710100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<55.540700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<55.371200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<55.371200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<55.371200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<56.218600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<56.218600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<56.218600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<56.388000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<55.371200,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.371200,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,36.113100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<55.371200,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<55.540700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,35.435200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<55.540700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.218600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<56.388000,0.000000,35.435200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<56.218600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<57.911200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<57.911200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<58.419600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.589100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<58.250100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<57.911200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<57.911200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.758600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<58.758600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.758600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,35.604600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<57.911200,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<57.911200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<57.911200,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<57.911200,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,36.113100>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.943600>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<58.250100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,36.113100>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<58.419600,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,36.113100>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<58.589100,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,36.113100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.943600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<58.758600,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.943600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.604600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<58.928000,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.928000,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,35.435200>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<58.758600,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.758600,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,35.435200>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<58.589100,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.589100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.604600>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<58.419600,0.000000,35.604600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,35.435200>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<58.250100,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.250100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.080700,0.000000,35.435200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<58.080700,0.000000,35.435200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.604600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<58.419600,0.000000,35.943600>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<58.419600,0.000000,35.943600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<60.451200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<60.451200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.959600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.959600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<60.959600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.129100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.129100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<60.790100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<60.451200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.451200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.298600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<61.298600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.298600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.790100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<60.451200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<60.451200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<61.468000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,36.604500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,36.604500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,36.773900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.451200,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,36.773900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,37.112900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<60.451200,0.000000,37.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.451200,0.000000,37.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,37.282400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.451200,0.000000,37.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,37.282400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.620700,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,37.112900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<61.298600,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,37.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,36.773900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.468000,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.468000,0.000000,36.773900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,36.604500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<61.298600,0.000000,36.604500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.298600,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.620700,0.000000,37.282400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<60.620700,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<62.991200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<62.991200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.991200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.499600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.499600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<63.499600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.669100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<63.669100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.008000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.330100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.160700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.991200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.991200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.160700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.991200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.838600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<63.838600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.838600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<63.838600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.008000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<62.991200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<62.991200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<64.008000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.330100,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,36.943400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<62.991200,0.000000,36.943400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.991200,0.000000,36.943400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,36.943400>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<62.991200,0.000000,36.943400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.008000,0.000000,37.282400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<64.008000,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,32.512000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<65.531200,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,33.020400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<65.531200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,33.189900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,33.189900>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.039600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<66.039600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.209100,0.000000,32.512000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.209100,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,33.681300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,34.359200>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<65.870100,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,34.359200>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,34.189700>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,34.189700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,34.189700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,33.850700>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<65.531200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,33.850700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,33.681300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.531200,0.000000,33.850700> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.378600,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<66.378600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.378600,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,35.020000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<66.378600,0.000000,35.020000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,35.020000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,34.850600>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,35.774100>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<65.531200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,35.774100>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,35.774100>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<65.531200,0.000000,35.774100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,35.435200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,36.113100>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<66.548000,0.000000,36.113100> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,36.604500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<66.548000,0.000000,36.604500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<66.548000,0.000000,36.604500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,37.282400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<65.870100,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.870100,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,37.282400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<65.700700,0.000000,37.282400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,37.282400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,37.112900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.531200,0.000000,37.112900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,37.112900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,36.773900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<65.531200,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.531200,0.000000,36.773900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.700700,0.000000,36.604500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.531200,0.000000,36.773900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,33.020400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.071200,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,32.681400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.071200,0.000000,32.681400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,32.681400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,32.512000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<68.071200,0.000000,32.681400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,32.512000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<68.240700,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,32.512000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,32.681400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.918600,0.000000,32.512000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,32.681400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,33.020400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<69.088000,0.000000,33.020400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,33.020400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,33.189900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<68.918600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,33.189900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<68.579600,0.000000,33.189900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,33.189900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.579600,0.000000,32.850900>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.579600,0.000000,32.850900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,33.681300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<68.071200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,33.681300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,34.359200>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,-33.689144,0> translate<68.071200,0.000000,33.681300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,34.359200>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,34.359200>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<68.071200,0.000000,34.359200> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,34.850600>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,0.000000,0> translate<68.071200,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,34.850600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,35.359000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,90.000000,0> translate<69.088000,0.000000,35.359000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.088000,0.000000,35.359000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,35.528500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<68.918600,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.918600,0.000000,35.528500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,35.528500>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<68.240700,0.000000,35.528500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.240700,0.000000,35.528500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,35.359000>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<68.071200,0.000000,35.359000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,35.359000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<68.071200,0.000000,34.850600>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<68.071200,0.000000,34.850600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.672000,0.000000,26.162000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.672000,0.000000,27.178800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<42.672000,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.672000,0.000000,27.178800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.180400,0.000000,27.178800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.672000,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.180400,0.000000,27.178800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349900,0.000000,27.009300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<43.180400,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349900,0.000000,27.009300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349900,0.000000,26.670400>}
box{<0,0,-0.127000><0.338900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.349900,0.000000,26.670400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.349900,0.000000,26.670400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.180400,0.000000,26.500900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.180400,0.000000,26.500900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.180400,0.000000,26.500900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.672000,0.000000,26.500900>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<42.672000,0.000000,26.500900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.841300,0.000000,27.178800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.841300,0.000000,26.162000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.841300,0.000000,26.162000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.841300,0.000000,26.162000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.180200,0.000000,26.500900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.841300,0.000000,26.162000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.180200,0.000000,26.500900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.519200,0.000000,26.162000>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<44.180200,0.000000,26.500900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.519200,0.000000,26.162000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.519200,0.000000,27.178800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<44.519200,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.010600,0.000000,26.162000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.010600,0.000000,27.178800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<45.010600,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.010600,0.000000,27.178800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.349500,0.000000,26.839900>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<45.010600,0.000000,27.178800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.349500,0.000000,26.839900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.688500,0.000000,27.178800>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,-44.988579,0> translate<45.349500,0.000000,26.839900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.688500,0.000000,27.178800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.688500,0.000000,26.162000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.688500,0.000000,26.162000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.767000,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.767000,0.000000,11.599900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<40.767000,0.000000,11.599900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.767000,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.105900,0.000000,11.938800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<40.767000,0.000000,11.599900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.105900,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.444900,0.000000,11.599900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<41.105900,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.444900,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.444900,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.444900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<40.767000,0.000000,11.430400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.444900,0.000000,11.430400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<40.767000,0.000000,11.430400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.936300,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.936300,0.000000,11.938800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<41.936300,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.936300,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.614200,0.000000,10.922000>}
box{<0,0,-0.127000><1.222060,0.036000,0.127000> rotate<0,56.304916,0> translate<41.936300,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.614200,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.614200,0.000000,11.938800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<42.614200,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.105600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.105600,0.000000,11.599900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<43.105600,0.000000,11.599900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.105600,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.444500,0.000000,11.938800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.105600,0.000000,11.599900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.444500,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.783500,0.000000,11.599900>}
box{<0,0,-0.127000><0.479348,0.036000,0.127000> rotate<0,44.988579,0> translate<43.444500,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.783500,0.000000,11.599900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.783500,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.783500,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.105600,0.000000,11.430400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.783500,0.000000,11.430400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<43.105600,0.000000,11.430400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.274900,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.274900,0.000000,10.922000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.274900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.274900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.952800,0.000000,10.922000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<44.274900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.952600,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.613600,0.000000,11.938800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<45.613600,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.613600,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.444200,0.000000,11.769300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<45.444200,0.000000,11.769300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.444200,0.000000,11.769300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.444200,0.000000,11.091400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.444200,0.000000,11.091400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.444200,0.000000,11.091400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.613600,0.000000,10.922000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<45.444200,0.000000,11.091400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.613600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.952600,0.000000,10.922000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<45.613600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.952600,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.122100,0.000000,11.091400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<45.952600,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.122100,0.000000,11.091400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.122100,0.000000,11.769300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<46.122100,0.000000,11.769300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.122100,0.000000,11.769300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.952600,0.000000,11.938800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<45.952600,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.291400,0.000000,11.769300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.121900,0.000000,11.938800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<47.121900,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.121900,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.782900,0.000000,11.938800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<46.782900,0.000000,11.938800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.782900,0.000000,11.938800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.613500,0.000000,11.769300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<46.613500,0.000000,11.769300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.613500,0.000000,11.769300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.613500,0.000000,11.091400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<46.613500,0.000000,11.091400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.613500,0.000000,11.091400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.782900,0.000000,10.922000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<46.613500,0.000000,11.091400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.782900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.121900,0.000000,10.922000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<46.782900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.121900,0.000000,10.922000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.291400,0.000000,11.091400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<47.121900,0.000000,10.922000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.291400,0.000000,11.091400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.291400,0.000000,11.430400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,90.000000,0> translate<47.291400,0.000000,11.430400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.291400,0.000000,11.430400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<46.952400,0.000000,11.430400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<46.952400,0.000000,11.430400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.232000,0.000000,19.573800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.232000,0.000000,18.726400>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,-90.000000,0> translate<14.232000,0.000000,18.726400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.232000,0.000000,18.726400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.401400,0.000000,18.557000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<14.232000,0.000000,18.726400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.401400,0.000000,18.557000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.740400,0.000000,18.557000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<14.401400,0.000000,18.557000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.740400,0.000000,18.557000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.909900,0.000000,18.726400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<14.740400,0.000000,18.557000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.909900,0.000000,18.726400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<14.909900,0.000000,19.573800>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<14.909900,0.000000,19.573800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.079200,0.000000,18.557000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.401300,0.000000,18.557000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<15.401300,0.000000,18.557000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.401300,0.000000,18.557000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.079200,0.000000,19.234900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,-44.997030,0> translate<15.401300,0.000000,18.557000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.079200,0.000000,19.234900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.079200,0.000000,19.404300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<16.079200,0.000000,19.404300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.079200,0.000000,19.404300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.909700,0.000000,19.573800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<15.909700,0.000000,19.573800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.909700,0.000000,19.573800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.570700,0.000000,19.573800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<15.570700,0.000000,19.573800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.570700,0.000000,19.573800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<15.401300,0.000000,19.404300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<15.401300,0.000000,19.404300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.732000,0.000000,17.827000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.732000,0.000000,17.996400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<13.732000,0.000000,17.996400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.732000,0.000000,17.996400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.901400,0.000000,17.996400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<13.732000,0.000000,17.996400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.901400,0.000000,17.996400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.901400,0.000000,17.827000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.901400,0.000000,17.827000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.901400,0.000000,17.827000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.732000,0.000000,17.827000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,0.000000,0> translate<13.732000,0.000000,17.827000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.058300,0.000000,23.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.058300,0.000000,22.288900>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,-90.000000,0> translate<12.058300,0.000000,22.288900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.058300,0.000000,22.288900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.227700,0.000000,22.119500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<12.058300,0.000000,22.288900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.227700,0.000000,22.119500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.566700,0.000000,22.119500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<12.227700,0.000000,22.119500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.566700,0.000000,22.119500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.736200,0.000000,22.288900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<12.566700,0.000000,22.119500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.736200,0.000000,22.288900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<12.736200,0.000000,23.136300>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<12.736200,0.000000,23.136300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.227600,0.000000,22.966800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.397000,0.000000,23.136300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<13.227600,0.000000,22.966800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.397000,0.000000,23.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,23.136300>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<13.397000,0.000000,23.136300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,23.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.966800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<13.736000,0.000000,23.136300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.966800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.797400>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.905500,0.000000,22.797400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.797400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,22.627900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<13.736000,0.000000,22.627900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,22.627900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.566500,0.000000,22.627900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<13.566500,0.000000,22.627900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,22.627900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.458400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<13.736000,0.000000,22.627900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.458400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.288900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<13.905500,0.000000,22.288900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.905500,0.000000,22.288900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,22.119500>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<13.736000,0.000000,22.119500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.736000,0.000000,22.119500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.397000,0.000000,22.119500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<13.397000,0.000000,22.119500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.397000,0.000000,22.119500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<13.227600,0.000000,22.288900>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<13.227600,0.000000,22.288900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.843300,0.000000,28.851300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.843300,0.000000,28.003900>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.843300,0.000000,28.003900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.843300,0.000000,28.003900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.012700,0.000000,27.834500>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,44.997030,0> translate<69.843300,0.000000,28.003900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.012700,0.000000,27.834500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.351700,0.000000,27.834500>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.012700,0.000000,27.834500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.351700,0.000000,27.834500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.521200,0.000000,28.003900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-44.980125,0> translate<70.351700,0.000000,27.834500> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.521200,0.000000,28.003900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.521200,0.000000,28.851300>}
box{<0,0,-0.127000><0.847400,0.036000,0.127000> rotate<0,90.000000,0> translate<70.521200,0.000000,28.851300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.521000,0.000000,27.834500>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.521000,0.000000,28.851300>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<71.521000,0.000000,28.851300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.521000,0.000000,28.851300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.012600,0.000000,28.342900>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,-44.997030,0> translate<71.012600,0.000000,28.342900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.012600,0.000000,28.342900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.690500,0.000000,28.342900>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<71.012600,0.000000,28.342900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.568800,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,20.320800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<27.568800,-1.536000,20.151300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,20.320800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<27.738300,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,20.151300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<28.077300,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,19.473400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.246700,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.246700,-1.536000,19.473400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,19.304000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.077300,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.077300,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,19.304000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<27.738300,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.738300,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.568800,-1.536000,19.473400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<27.568800,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.077400,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,20.320800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<26.908000,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,20.320800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,20.320800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,20.320800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,20.151300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.399500,-1.536000,20.151300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,20.151300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.981900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<26.399500,-1.536000,19.981900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.981900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<26.399500,-1.536000,19.981900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.738500,-1.536000,19.812400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,19.812400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.812400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.642900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.399500,-1.536000,19.642900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.642900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.473400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<26.399500,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.399500,-1.536000,19.473400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.304000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<26.399500,-1.536000,19.473400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.569000,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,19.304000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<26.569000,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.908000,-1.536000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.077400,-1.536000,19.473400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<26.908000,-1.536000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.178400,-1.536000,12.927700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.178400,-1.536000,13.605600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<27.178400,-1.536000,13.605600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<27.517300,-1.536000,13.266600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<26.839400,-1.536000,13.266600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<26.839400,-1.536000,13.266600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.229100,-1.536000,17.865300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,18.034800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.229100,-1.536000,17.865300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,18.034800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<17.398600,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.865300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<17.737600,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.865300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.187400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<17.907000,-1.536000,17.187400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.907000,-1.536000,17.187400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,17.018000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<17.737600,-1.536000,17.018000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.737600,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,17.018000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<17.398600,-1.536000,17.018000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.398600,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<17.229100,-1.536000,17.187400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<17.229100,-1.536000,17.187400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,17.018000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,18.034800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<16.229300,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.229300,-1.536000,18.034800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.737700,-1.536000,17.526400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<16.229300,-1.536000,18.034800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.737700,-1.536000,17.526400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<16.059800,-1.536000,17.526400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<16.059800,-1.536000,17.526400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.033800,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,26.035800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.033800,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,26.035800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<65.203300,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.866300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<65.542300,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.188400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<65.711700,-1.536000,25.188400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.711700,-1.536000,25.188400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,25.019000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<65.542300,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.542300,-1.536000,25.019000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,25.019000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<65.203300,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.203300,-1.536000,25.019000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<65.033800,-1.536000,25.188400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<65.033800,-1.536000,25.188400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,26.035800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<63.864500,-1.536000,26.035800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,26.035800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,25.866300>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<63.864500,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<63.864500,-1.536000,25.866300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.188400>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<63.864500,-1.536000,25.866300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.188400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<64.542400,-1.536000,25.019000>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<64.542400,-1.536000,25.019000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.103400,-1.536000,21.817700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.103400,-1.536000,22.495600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.103400,-1.536000,22.495600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.442300,-1.536000,22.156600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.764400,-1.536000,22.156600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<61.764400,-1.536000,22.156600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.374100,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<34.374100,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<34.543600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<34.882600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,13.377400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<35.052000,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.052000,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<34.882600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.882600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<34.543600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.543600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<34.374100,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<34.374100,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.882700,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,14.224800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<33.543800,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.543800,-1.536000,13.208000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<33.543800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.882700,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<33.204800,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<33.204800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<32.035500,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.885900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<32.035500,-1.536000,13.885900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,14.055300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<32.035500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.035500,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.205000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<32.035500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.205000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.544000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<32.205000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.544000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<32.713400,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<32.544000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.199100,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,21.844800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.199100,-1.536000,21.675300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,21.844800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<31.368600,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,21.675300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.707600,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,20.997400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<31.877000,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.877000,-1.536000,20.997400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,20.828000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.707600,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.707600,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,20.828000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<31.368600,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.368600,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.199100,-1.536000,20.997400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<31.199100,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.707700,-1.536000,21.505900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,21.844800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<30.368800,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.368800,-1.536000,20.828000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<30.368800,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.707700,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.029800,-1.536000,20.828000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<30.029800,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.538400,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,21.844800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<29.369000,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.844800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,21.844800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.844800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.675300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.860500,-1.536000,21.675300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.675300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.505900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.860500,-1.536000,21.505900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.505900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<28.860500,-1.536000,21.505900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.199500,-1.536000,21.336400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,21.336400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,21.336400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.166900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<28.860500,-1.536000,21.166900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,21.166900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,20.997400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.860500,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.860500,-1.536000,20.997400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,20.828000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<28.860500,-1.536000,20.997400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.030000,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,20.828000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.030000,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.369000,-1.536000,20.828000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.538400,-1.536000,20.997400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.369000,-1.536000,20.828000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.628200,-1.536000,27.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,27.305800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<37.628200,-1.536000,27.136300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,27.305800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.797700,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,27.136300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<38.136700,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,27.136300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,26.458400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<38.306100,-1.536000,26.458400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.306100,-1.536000,26.458400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,26.289000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<38.136700,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.136700,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,26.289000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<37.797700,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.797700,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.628200,-1.536000,26.458400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<37.628200,-1.536000,26.458400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.136800,-1.536000,26.966900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,27.305800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<36.797900,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.797900,-1.536000,26.289000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<36.797900,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<37.136800,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.458900,-1.536000,26.289000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<36.458900,-1.536000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,27.305800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<35.459100,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.459100,-1.536000,27.305800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.967500,-1.536000,26.797400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<35.459100,-1.536000,27.305800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.967500,-1.536000,26.797400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.289600,-1.536000,26.797400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.289600,-1.536000,26.797400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068400,-1.536000,19.912700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.068400,-1.536000,20.590600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<36.068400,-1.536000,20.590600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<36.407300,-1.536000,20.251600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<35.729400,-1.536000,20.251600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<35.729400,-1.536000,20.251600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.598200,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,15.240800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<51.598200,-1.536000,15.071300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,15.240800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<51.767700,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,15.071300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<52.106700,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,14.393400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<52.276100,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.276100,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,14.224000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<52.106700,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<52.106700,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,14.224000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<51.767700,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.767700,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.598200,-1.536000,14.393400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<51.598200,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.106800,-1.536000,14.901900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,15.240800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<50.767900,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.767900,-1.536000,14.224000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<50.767900,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<51.106800,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<50.428900,-1.536000,14.224000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<50.428900,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,15.240800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.598600,-1.536000,15.071300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,26.563298,0> translate<49.259600,-1.536000,15.240800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.598600,-1.536000,15.071300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<49.598600,-1.536000,15.071300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.393400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<49.937500,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.768100,-1.536000,14.224000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<49.768100,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.768100,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.224000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<49.429100,-1.536000,14.224000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.224000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.393400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<49.259600,-1.536000,14.393400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.393400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.562900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<49.259600,-1.536000,14.562900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.259600,-1.536000,14.562900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.732400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<49.259600,-1.536000,14.562900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.429100,-1.536000,14.732400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<49.937500,-1.536000,14.732400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<49.429100,-1.536000,14.732400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.498400,-1.536000,12.927700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.498400,-1.536000,13.605600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<47.498400,-1.536000,13.605600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.837300,-1.536000,13.266600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<47.159400,-1.536000,13.266600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<47.159400,-1.536000,13.266600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.343200,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,23.495800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.343200,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,23.495800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<43.512700,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,23.326300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<43.851700,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,22.648400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<44.021100,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.021100,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,22.479000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<43.851700,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.851700,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,22.479000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<43.512700,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.512700,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.343200,-1.536000,22.648400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<43.343200,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.851800,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,23.495800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<42.512900,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.512900,-1.536000,22.479000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.512900,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.851800,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.173900,-1.536000,22.479000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<42.173900,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,23.495800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<41.513100,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,23.495800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,23.495800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,23.495800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.326300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.004600,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.326300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.156900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.004600,-1.536000,23.156900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<41.004600,-1.536000,23.156900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.817900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.004600,-1.536000,22.817900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.817900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.648400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<41.004600,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.004600,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.479000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<41.004600,-1.536000,22.648400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.479000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.479000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.648400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<41.513100,-1.536000,22.479000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.648400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.817900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<41.682500,-1.536000,22.817900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,22.817900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<41.513100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.156900>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<41.513100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.156900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.682500,-1.536000,23.326300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<41.682500,-1.536000,23.326300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.513100,-1.536000,22.987400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<41.174100,-1.536000,22.987400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<41.174100,-1.536000,22.987400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.243400,-1.536000,18.642700>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.243400,-1.536000,19.320600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<39.243400,-1.536000,19.320600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<39.582300,-1.536000,18.981600>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<38.904400,-1.536000,18.981600>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<38.904400,-1.536000,18.981600> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.534100,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<44.534100,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.703600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<45.042600,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,13.377400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<45.212000,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.212000,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<45.042600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<45.042600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<44.703600,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.703600,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.534100,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<44.534100,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.042700,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,14.224800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<43.703800,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.703800,-1.536000,13.208000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<43.703800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<44.042700,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<43.364800,-1.536000,13.208000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<43.364800,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.208000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.704000,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,13.208000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<42.365000,-1.536000,13.208000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,13.208000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.377400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<42.195500,-1.536000,13.377400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.377400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,14.055300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<42.195500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<42.195500,-1.536000,14.055300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.365000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,14.224800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<42.365000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,14.224800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,14.055300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<42.704000,-1.536000,14.224800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,14.055300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.885900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<42.873400,-1.536000,13.885900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.873400,-1.536000,13.885900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.716400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,-45.013935,0> translate<42.704000,-1.536000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.704000,-1.536000,13.716400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<42.195500,-1.536000,13.716400>}
box{<0,0,-0.127000><0.508500,0.036000,0.127000> rotate<0,0.000000,0> translate<42.195500,-1.536000,13.716400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.564100,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,26.924800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<30.564100,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,26.924800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<30.733600,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.755300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<31.072600,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.077400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,-90.000000,0> translate<31.242000,-1.536000,26.077400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.242000,-1.536000,26.077400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,25.908000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<31.072600,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<31.072600,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,25.908000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<30.733600,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.733600,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.564100,-1.536000,26.077400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<30.564100,-1.536000,26.077400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,25.908000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<29.394800,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.585900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<29.394800,-1.536000,26.585900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.585900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.755300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<29.394800,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.394800,-1.536000,26.755300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.564300,-1.536000,26.924800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<29.394800,-1.536000,26.755300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.564300,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.903300,-1.536000,26.924800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<29.564300,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<29.903300,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<30.072700,-1.536000,26.755300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<29.903300,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.903400,-1.536000,26.585900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,26.924800>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<28.564500,-1.536000,26.924800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,26.924800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.564500,-1.536000,25.908000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<28.564500,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.903400,-1.536000,25.908000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<28.225500,-1.536000,25.908000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<28.225500,-1.536000,25.908000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,12.192000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<72.898000,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,12.192000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.389600,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,12.361400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<72.220100,-1.536000,12.361400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,12.361400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,13.039300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<72.220100,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.220100,-1.536000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,13.208800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<72.220100,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.389600,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.898000,-1.536000,13.208800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<72.389600,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,12.192000>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<71.050800,-1.536000,12.192000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,12.192000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.869900>}
box{<0,0,-0.127000><0.958695,0.036000,0.127000> rotate<0,44.997030,0> translate<71.050800,-1.536000,12.869900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,12.869900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,13.039300>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,90.000000,0> translate<71.050800,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.050800,-1.536000,13.039300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.220300,-1.536000,13.208800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<71.050800,-1.536000,13.039300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.220300,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.559300,-1.536000,13.208800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<71.220300,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.559300,-1.536000,13.208800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.728700,-1.536000,13.039300>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<71.559300,-1.536000,13.208800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,24.257000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<71.628000,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,24.257000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.119600,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,24.426400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<70.950100,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,24.426400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,25.104300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<70.950100,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.950100,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,25.273800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.950100,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.119600,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.628000,-1.536000,25.273800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.119600,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.458700,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,25.273800>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,45.013935,0> translate<70.289300,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,25.273800>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,25.273800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,25.273800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,25.104300>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<69.780800,-1.536000,25.104300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,25.104300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.934900>}
box{<0,0,-0.127000><0.169400,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.780800,-1.536000,24.934900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.934900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,44.997030,0> translate<69.780800,-1.536000,24.934900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.119800,-1.536000,24.765400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,24.765400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.765400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.595900>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<69.780800,-1.536000,24.595900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.595900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.426400>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,-90.000000,0> translate<69.780800,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.780800,-1.536000,24.426400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.257000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<69.780800,-1.536000,24.426400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<69.950300,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,24.257000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<69.950300,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.289300,-1.536000,24.257000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.458700,-1.536000,24.426400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.289300,-1.536000,24.257000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,19.812000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.738000,-1.536000,19.812000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,19.812000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,19.812000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,19.981400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.060100,-1.536000,19.981400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,19.981400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,20.659300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.060100,-1.536000,20.659300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,20.659300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,20.828800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.060100,-1.536000,20.659300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,20.828800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,19.812000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,20.828800>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,90.000000,0> translate<61.060300,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,20.828800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,20.320400>}
box{<0,0,-0.127000><0.718986,0.036000,0.127000> rotate<0,44.997030,0> translate<61.060300,-1.536000,20.828800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,20.320400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,20.320400>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<60.890800,-1.536000,20.320400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,17.907000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<72.263000,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,17.907000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.754600,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.076400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<71.585100,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.076400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.754300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<71.585100,-1.536000,18.754300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.585100,-1.536000,18.754300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,18.923800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<71.585100,-1.536000,18.754300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.754600,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<72.263000,-1.536000,18.923800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<71.754600,-1.536000,18.923800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.923800>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,0.000000,0> translate<70.415800,-1.536000,18.923800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.923800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.415400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,-90.000000,0> translate<71.093700,-1.536000,18.415400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.415400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.754800,-1.536000,18.584900>}
box{<0,0,-0.127000><0.378924,0.036000,0.127000> rotate<0,26.570060,0> translate<70.754800,-1.536000,18.584900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.754800,-1.536000,18.584900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,18.584900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,0.000000,0> translate<70.585300,-1.536000,18.584900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,18.584900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.415400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.415800,-1.536000,18.415400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.415400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.076400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<70.415800,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.415800,-1.536000,18.076400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,17.907000>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<70.415800,-1.536000,18.076400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.585300,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.924300,-1.536000,17.907000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<70.585300,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<70.924300,-1.536000,17.907000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<71.093700,-1.536000,18.076400>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<70.924300,-1.536000,17.907000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,16.002000>}
box{<0,0,-0.127000><1.016800,0.036000,0.127000> rotate<0,-90.000000,0> translate<62.738000,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,16.002000>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.171400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<62.060100,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.849300>}
box{<0,0,-0.127000><0.677900,0.036000,0.127000> rotate<0,90.000000,0> translate<62.060100,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.060100,-1.536000,16.849300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,17.018800>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<62.060100,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.229600,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<62.738000,-1.536000,17.018800>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<62.229600,-1.536000,17.018800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,17.018800>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.229800,-1.536000,16.849300>}
box{<0,0,-0.127000><0.379014,0.036000,0.127000> rotate<0,26.563298,0> translate<60.890800,-1.536000,17.018800> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.229800,-1.536000,16.849300>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
box{<0,0,-0.127000><0.479277,0.036000,0.127000> rotate<0,44.997030,0> translate<61.229800,-1.536000,16.849300> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.171400>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,-90.000000,0> translate<61.568700,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.399300,-1.536000,16.002000>}
box{<0,0,-0.127000><0.239568,0.036000,0.127000> rotate<0,-44.997030,0> translate<61.399300,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.399300,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.002000>}
box{<0,0,-0.127000><0.339000,0.036000,0.127000> rotate<0,0.000000,0> translate<61.060300,-1.536000,16.002000> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.002000>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.171400>}
box{<0,0,-0.127000><0.239638,0.036000,0.127000> rotate<0,44.980125,0> translate<60.890800,-1.536000,16.171400> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.171400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.340900>}
box{<0,0,-0.127000><0.169500,0.036000,0.127000> rotate<0,90.000000,0> translate<60.890800,-1.536000,16.340900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<60.890800,-1.536000,16.340900>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.510400>}
box{<0,0,-0.127000><0.239709,0.036000,0.127000> rotate<0,-44.997030,0> translate<60.890800,-1.536000,16.340900> }
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.060300,-1.536000,16.510400>}
cylinder{<0,0,0><0,0.036000,0>0.127000 translate<61.568700,-1.536000,16.510400>}
box{<0,0,-0.127000><0.508400,0.036000,0.127000> rotate<0,0.000000,0> translate<61.060300,-1.536000,16.510400> }
//!RST silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<83.629500,0.000000,4.060500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<77.629500,0.000000,4.060500>}
box{<0,0,-0.063500><6.000000,0.036000,0.063500> rotate<0,0.000000,0> translate<77.629500,0.000000,4.060500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<77.629500,0.000000,4.060500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<77.629500,0.000000,9.960500>}
box{<0,0,-0.063500><5.900000,0.036000,0.063500> rotate<0,90.000000,0> translate<77.629500,0.000000,9.960500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<77.629500,0.000000,9.960500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<83.629500,0.000000,9.960500>}
box{<0,0,-0.063500><6.000000,0.036000,0.063500> rotate<0,0.000000,0> translate<77.629500,0.000000,9.960500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<83.629500,0.000000,9.960500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<83.629500,0.000000,4.060500>}
box{<0,0,-0.063500><5.900000,0.036000,0.063500> rotate<0,-90.000000,0> translate<83.629500,0.000000,4.060500> }
difference{
cylinder{<80.629500,0,7.060500><80.629500,0.036000,7.060500>2.122600 translate<0,0.000000,0>}
cylinder{<80.629500,-0.1,7.060500><80.629500,0.135000,7.060500>1.995600 translate<0,0.000000,0>}}
difference{
cylinder{<78.329500,0,4.960500><78.329500,0.036000,4.960500>0.287100 translate<0,0.000000,0>}
cylinder{<78.329500,-0.1,4.960500><78.329500,0.135000,4.960500>0.160100 translate<0,0.000000,0>}}
difference{
cylinder{<78.429500,0,9.060500><78.429500,0.036000,9.060500>0.287100 translate<0,0.000000,0>}
cylinder{<78.429500,-0.1,9.060500><78.429500,0.135000,9.060500>0.160100 translate<0,0.000000,0>}}
difference{
cylinder{<82.829500,0,9.060500><82.829500,0.036000,9.060500>0.287100 translate<0,0.000000,0>}
cylinder{<82.829500,-0.1,9.060500><82.829500,0.135000,9.060500>0.160100 translate<0,0.000000,0>}}
difference{
cylinder{<82.829500,0,4.960500><82.829500,0.036000,4.960500>0.287100 translate<0,0.000000,0>}
cylinder{<82.829500,-0.1,4.960500><82.829500,0.135000,4.960500>0.160100 translate<0,0.000000,0>}}
//ACCEL1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,25.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<36.695000,0.000000,25.995000>}
box{<0,0,-0.063500><1.000000,0.036000,0.063500> rotate<0,0.000000,0> translate<36.695000,0.000000,25.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,21.195000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,20.995000>}
box{<0,0,-0.063500><0.200000,0.036000,0.063500> rotate<0,-90.000000,0> translate<34.595000,0.000000,20.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,20.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<35.595000,0.000000,20.995000>}
box{<0,0,-0.063500><1.000000,0.036000,0.063500> rotate<0,0.000000,0> translate<34.595000,0.000000,20.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<36.695000,0.000000,20.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,20.995000>}
box{<0,0,-0.063500><1.000000,0.036000,0.063500> rotate<0,0.000000,0> translate<36.695000,0.000000,20.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,20.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,21.195000>}
box{<0,0,-0.063500><0.200000,0.036000,0.063500> rotate<0,90.000000,0> translate<37.695000,0.000000,21.195000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,25.795000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<37.695000,0.000000,25.995000>}
box{<0,0,-0.063500><0.200000,0.036000,0.063500> rotate<0,90.000000,0> translate<37.695000,0.000000,25.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<35.695000,0.000000,25.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,25.995000>}
box{<0,0,-0.063500><1.100000,0.036000,0.063500> rotate<0,0.000000,0> translate<34.595000,0.000000,25.995000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,25.995000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<34.595000,0.000000,25.795000>}
box{<0,0,-0.063500><0.200000,0.036000,0.063500> rotate<0,-90.000000,0> translate<34.595000,0.000000,25.795000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.385000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.655000,0.000000,27.305000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,0.000000,0> translate<32.385000,0.000000,27.305000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.385000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.385000,0.000000,26.035000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<32.385000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.655000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.401000,0.000000,27.559000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<33.401000,0.000000,27.559000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.401000,0.000000,27.559000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.401000,0.000000,27.051000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,-90.000000,0> translate<33.401000,0.000000,27.051000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.401000,0.000000,27.051000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<33.655000,0.000000,27.305000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<33.401000,0.000000,27.051000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.385000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.639000,0.000000,26.289000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<32.385000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.639000,0.000000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.131000,0.000000,26.289000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,0.000000,0> translate<32.131000,0.000000,26.289000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.131000,0.000000,26.289000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<32.385000,0.000000,26.035000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<32.131000,0.000000,26.289000> }
//AUX silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.120000,0.000000,2.540000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.200000,0.000000,2.540000>}
box{<0,0,-0.063500><5.080000,0.036000,0.063500> rotate<0,0.000000,0> translate<71.120000,0.000000,2.540000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.200000,0.000000,2.540000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.200000,0.000000,8.890000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,90.000000,0> translate<76.200000,0.000000,8.890000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.200000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<75.565000,0.000000,8.890000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<75.565000,0.000000,8.890000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<75.565000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.755000,0.000000,8.890000>}
box{<0,0,-0.063500><3.810000,0.036000,0.063500> rotate<0,0.000000,0> translate<71.755000,0.000000,8.890000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.755000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.120000,0.000000,8.890000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<71.120000,0.000000,8.890000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.120000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.120000,0.000000,2.540000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,-90.000000,0> translate<71.120000,0.000000,2.540000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.755000,0.000000,8.890000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.755000,0.000000,7.620000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<71.755000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<71.755000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<75.565000,0.000000,7.620000>}
box{<0,0,-0.063500><3.810000,0.036000,0.063500> rotate<0,0.000000,0> translate<71.755000,0.000000,7.620000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<75.565000,0.000000,7.620000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<75.565000,0.000000,8.890000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,90.000000,0> translate<75.565000,0.000000,8.890000> }
//C1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.164000,0.000000,24.155000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.926000,0.000000,24.155000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,0.000000,0> translate<42.164000,0.000000,24.155000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.189000,0.000000,22.835000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.926000,0.000000,22.835000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,0.000000,0> translate<42.189000,0.000000,22.835000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<41.827800,0.000000,23.496100>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<43.275600,0.000000,23.496100>}
//C2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.926000,0.000000,20.930000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.164000,0.000000,20.930000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,0.000000,0> translate<42.164000,0.000000,20.930000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.901000,0.000000,22.250000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.164000,0.000000,22.250000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,0.000000,0> translate<42.164000,0.000000,22.250000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-180.000000,0> translate<43.262000,0.000000,21.588900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-180.000000,0> translate<41.814400,0.000000,21.588900>}
//C3 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<26.518000,-1.536000,17.475000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<26.518000,-1.536000,15.545000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<26.518000,-1.536000,15.545000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<28.092000,-1.536000,17.475000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<28.092000,-1.536000,15.545000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<28.092000,-1.536000,15.545000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<27.305800,-1.536000,17.836700>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<27.304100,-1.536000,15.183300>}
//C4 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<17.805000,-1.536000,14.859000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<17.805000,-1.536000,15.621000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,90.000000,0> translate<17.805000,-1.536000,15.621000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<16.485000,-1.536000,14.884000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<16.485000,-1.536000,15.621000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,90.000000,0> translate<16.485000,-1.536000,15.621000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<17.146000,-1.536000,14.522900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<17.146100,-1.536000,15.970600>}
//C5 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<7.315000,0.000000,25.883000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<5.385000,0.000000,25.883000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,0.000000,0> translate<5.385000,0.000000,25.883000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<7.315000,0.000000,27.457000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<5.385000,0.000000,27.457000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,0.000000,0> translate<5.385000,0.000000,27.457000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-180.000000,0> translate<7.676600,0.000000,26.670900>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-180.000000,0> translate<5.023300,0.000000,26.669100>}
//C6 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<67.564000,0.000000,11.455000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<68.326000,0.000000,11.455000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,0.000000,0> translate<67.564000,0.000000,11.455000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<67.589000,0.000000,10.135000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<68.326000,0.000000,10.135000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,0.000000,0> translate<67.589000,0.000000,10.135000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<67.227800,0.000000,10.796100>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<68.675600,0.000000,10.796100>}
//C7 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<61.443000,-1.536000,26.365000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<61.443000,-1.536000,24.435000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<61.443000,-1.536000,24.435000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<63.017000,-1.536000,26.365000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<63.017000,-1.536000,24.435000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<63.017000,-1.536000,24.435000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<62.230800,-1.536000,26.726700>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<62.229100,-1.536000,24.073300>}
//C11 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<30.099000,0.000000,13.360000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<30.861000,0.000000,13.360000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,0.000000,0> translate<30.099000,0.000000,13.360000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<30.124000,0.000000,12.040000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<30.861000,0.000000,12.040000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,0.000000,0> translate<30.124000,0.000000,12.040000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<29.762800,0.000000,12.701100>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-0.000000,0> translate<31.210600,0.000000,12.701100>}
//C12 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<34.315000,-1.536000,16.129000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<34.315000,-1.536000,16.891000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,90.000000,0> translate<34.315000,-1.536000,16.891000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.995000,-1.536000,16.154000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.995000,-1.536000,16.891000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,90.000000,0> translate<32.995000,-1.536000,16.891000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.656000,-1.536000,15.792900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.656100,-1.536000,17.240600>}
//C13 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<33.680000,-1.536000,21.844000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<33.680000,-1.536000,22.606000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,90.000000,0> translate<33.680000,-1.536000,22.606000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.360000,-1.536000,21.869000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.360000,-1.536000,22.606000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,90.000000,0> translate<32.360000,-1.536000,22.606000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.021000,-1.536000,21.507900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.021100,-1.536000,22.955600>}
//C14 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<35.408000,-1.536000,24.460000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<35.408000,-1.536000,22.530000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<35.408000,-1.536000,22.530000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<36.982000,-1.536000,24.460000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<36.982000,-1.536000,22.530000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<36.982000,-1.536000,22.530000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<36.195800,-1.536000,24.821700>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<36.194100,-1.536000,22.168300>}
//C16 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<46.838000,-1.536000,17.475000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<46.838000,-1.536000,15.545000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<46.838000,-1.536000,15.545000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<48.412000,-1.536000,17.475000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<48.412000,-1.536000,15.545000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<48.412000,-1.536000,15.545000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<47.625800,-1.536000,17.836700>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<47.624100,-1.536000,15.183300>}
//C18 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<38.583000,-1.536000,23.190000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<38.583000,-1.536000,21.260000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<38.583000,-1.536000,21.260000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<40.157000,-1.536000,23.190000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<40.157000,-1.536000,21.260000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,-90.000000,0> translate<40.157000,-1.536000,21.260000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<39.370800,-1.536000,23.551700>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-270.000000,0> translate<39.369100,-1.536000,20.898300>}
//C19 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<43.840000,-1.536000,16.129000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<43.840000,-1.536000,16.891000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,90.000000,0> translate<43.840000,-1.536000,16.891000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.520000,-1.536000,16.154000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<42.520000,-1.536000,16.891000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,90.000000,0> translate<42.520000,-1.536000,16.891000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<43.181000,-1.536000,15.792900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<43.181100,-1.536000,17.240600>}
//C21 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<33.680000,-1.536000,25.654000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<33.680000,-1.536000,26.416000>}
box{<0,0,-0.050800><0.762000,0.036000,0.050800> rotate<0,90.000000,0> translate<33.680000,-1.536000,26.416000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.360000,-1.536000,25.679000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<32.360000,-1.536000,26.416000>}
box{<0,0,-0.050800><0.737000,0.036000,0.050800> rotate<0,90.000000,0> translate<32.360000,-1.536000,26.416000> }
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.021000,-1.536000,25.317900>}
box{<-0.375000,0,-0.725000><0.375000,0.036000,0.725000> rotate<0,-90.000000,0> translate<33.021100,-1.536000,26.765600>}
//D1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,21.437600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.294600,0.000000,21.437600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,0.000000,0> translate<20.294600,0.000000,21.437600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.294600,0.000000,21.437600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.294600,0.000000,24.282400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,90.000000,0> translate<20.294600,0.000000,24.282400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.294600,0.000000,24.282400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,24.282400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,0.000000,0> translate<20.294600,0.000000,24.282400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,24.282400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,21.437600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,-90.000000,0> translate<21.615400,0.000000,21.437600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.802600,0.000000,24.282400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,24.282400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,0.000000,0> translate<20.802600,0.000000,24.282400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,24.282400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,23.723600>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,-90.000000,0> translate<21.615400,0.000000,23.723600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,21.437600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<20.802600,0.000000,21.437600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,0.000000,0> translate<20.802600,0.000000,21.437600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,21.996400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<21.615400,0.000000,21.437600>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,-90.000000,0> translate<21.615400,0.000000,21.437600> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-270.000000,0> translate<21.958300,0.000000,22.860000>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-270.000000,0> translate<19.951700,0.000000,21.920200>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-270.000000,0> translate<19.951700,0.000000,23.799800>}
//D2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,13.995400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,12.674600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,12.674600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,12.674600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,12.674600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,12.674600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,12.674600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,13.995400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,13.995400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,13.995400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,13.995400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,13.995400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,13.182600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,13.995400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,13.995400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,13.995400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<69.443600,-1.536000,13.995400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<69.443600,-1.536000,13.995400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,13.995400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,13.182600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,13.182600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.716400,-1.536000,13.995400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,13.995400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,13.995400> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<68.580000,-1.536000,14.338300>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<67.640200,-1.536000,12.331700>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<69.519800,-1.536000,12.331700>}
//D3 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,23.520400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,22.199600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,22.199600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,22.199600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,22.199600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,22.199600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,22.199600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,23.520400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,23.520400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,23.520400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,23.520400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,23.520400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,22.707600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,23.520400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,23.520400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,23.520400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<69.443600,-1.536000,23.520400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<69.443600,-1.536000,23.520400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,23.520400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,22.707600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,22.707600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.716400,-1.536000,23.520400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,23.520400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,23.520400> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<68.580000,-1.536000,23.863300>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<67.640200,-1.536000,21.856700>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<69.519800,-1.536000,21.856700>}
//D4 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,20.980400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,19.659600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,-90.000000,0> translate<63.347600,-1.536000,19.659600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,19.659600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,19.659600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,19.659600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,19.659600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,20.980400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,90.000000,0> translate<66.192400,-1.536000,20.980400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,20.980400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,20.980400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,20.980400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,20.167600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,20.980400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,90.000000,0> translate<66.192400,-1.536000,20.980400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,20.980400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<65.633600,-1.536000,20.980400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<65.633600,-1.536000,20.980400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,20.980400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,20.167600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,-90.000000,0> translate<63.347600,-1.536000,20.167600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.906400,-1.536000,20.980400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,20.980400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,20.980400> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<64.770000,-1.536000,21.323300>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<63.830200,-1.536000,19.316700>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<65.709800,-1.536000,19.316700>}
//D5 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,18.440400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,17.119600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,17.119600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,17.119600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,17.119600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,17.119600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,17.119600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,18.440400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,18.440400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,18.440400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,18.440400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,18.440400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,17.627600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,18.440400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,90.000000,0> translate<70.002400,-1.536000,18.440400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<70.002400,-1.536000,18.440400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<69.443600,-1.536000,18.440400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<69.443600,-1.536000,18.440400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,18.440400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,17.627600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,-90.000000,0> translate<67.157600,-1.536000,17.627600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.716400,-1.536000,18.440400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<67.157600,-1.536000,18.440400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<67.157600,-1.536000,18.440400> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<68.580000,-1.536000,18.783300>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<67.640200,-1.536000,16.776700>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<69.519800,-1.536000,16.776700>}
//D6 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,16.535400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,15.214600>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,-90.000000,0> translate<63.347600,-1.536000,15.214600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,15.214600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,15.214600>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,15.214600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,15.214600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,16.535400>}
box{<0,0,-0.076200><1.320800,0.036000,0.076200> rotate<0,90.000000,0> translate<66.192400,-1.536000,16.535400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,16.535400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,16.535400>}
box{<0,0,-0.076200><2.844800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,16.535400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,15.722600>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,16.535400>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,90.000000,0> translate<66.192400,-1.536000,16.535400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<66.192400,-1.536000,16.535400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<65.633600,-1.536000,16.535400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<65.633600,-1.536000,16.535400> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,16.535400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,15.722600>}
box{<0,0,-0.076200><0.812800,0.036000,0.076200> rotate<0,-90.000000,0> translate<63.347600,-1.536000,15.722600> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.906400,-1.536000,16.535400>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.347600,-1.536000,16.535400>}
box{<0,0,-0.076200><0.558800,0.036000,0.076200> rotate<0,0.000000,0> translate<63.347600,-1.536000,16.535400> }
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<64.770000,-1.536000,16.878300>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<63.830200,-1.536000,14.871700>}
box{<-0.228600,0,-0.292100><0.228600,0.036000,0.292100> rotate<0,-180.000000,0> translate<65.709800,-1.536000,14.871700>}
//F1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<18.720000,0.000000,26.822000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<20.650000,0.000000,26.822000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,0.000000,0> translate<18.720000,0.000000,26.822000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<18.720000,0.000000,25.248000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<20.650000,0.000000,25.248000>}
box{<0,0,-0.050800><1.930000,0.036000,0.050800> rotate<0,0.000000,0> translate<18.720000,0.000000,25.248000> }
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-0.000000,0> translate<18.358200,0.000000,26.034100>}
box{<-0.375000,0,-0.850000><0.375000,0.036000,0.850000> rotate<0,-0.000000,0> translate<21.011700,0.000000,26.035900>}
//GYRO1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,17.810000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,18.510000>}
box{<0,0,-0.063500><0.700000,0.036000,0.063500> rotate<0,90.000000,0> translate<45.180000,0.000000,18.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,18.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<44.580000,0.000000,18.510000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,0.000000,0> translate<44.580000,0.000000,18.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,15.110000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,90.000000,0> translate<41.180000,0.000000,15.110000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,15.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,14.510000>}
box{<0,0,-0.063500><0.700000,0.036000,0.063500> rotate<0,-90.000000,0> translate<45.180000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<45.180000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<44.580000,0.000000,14.510000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,0.000000,0> translate<44.580000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,14.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.780000,0.000000,14.510000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,0.000000,0> translate<41.180000,0.000000,14.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,17.910000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,18.510000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,90.000000,0> translate<41.180000,0.000000,18.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.180000,0.000000,18.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.780000,0.000000,18.510000>}
box{<0,0,-0.063500><0.600000,0.036000,0.063500> rotate<0,0.000000,0> translate<41.180000,0.000000,18.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.275000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.005000,0.000000,19.685000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,0.000000,0> translate<40.005000,0.000000,19.685000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.005000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.005000,0.000000,18.415000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<40.005000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.005000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.259000,0.000000,18.669000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<40.005000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.259000,0.000000,18.669000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<39.751000,0.000000,18.669000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,0.000000,0> translate<39.751000,0.000000,18.669000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<39.751000,0.000000,18.669000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<40.005000,0.000000,18.415000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<39.751000,0.000000,18.669000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.275000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.021000,0.000000,19.939000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<41.021000,0.000000,19.939000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.021000,0.000000,19.939000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.021000,0.000000,19.431000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,-90.000000,0> translate<41.021000,0.000000,19.431000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.021000,0.000000,19.431000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<41.275000,0.000000,19.685000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<41.021000,0.000000,19.431000> }
//J1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,20.320000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<4.402000,0.000000,19.685000>}
box{<0,0,-0.063500><3.237877,0.036000,0.063500> rotate<0,11.309186,0> translate<1.227000,0.000000,20.320000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<4.402000,0.000000,19.685000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<4.402000,0.000000,18.415000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<4.402000,0.000000,18.415000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<4.402000,0.000000,18.415000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,17.780000>}
box{<0,0,-0.063500><3.237877,0.036000,0.063500> rotate<0,-11.309186,0> translate<1.227000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<3.767000,0.000000,15.875000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,16.192500>}
box{<0,0,-0.063500><2.559767,0.036000,0.063500> rotate<0,7.124546,0> translate<1.227000,0.000000,16.192500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,16.192500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,16.827500>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,90.000000,0> translate<1.227000,0.000000,16.827500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,16.827500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<3.767000,0.000000,17.145000>}
box{<0,0,-0.063500><2.559767,0.036000,0.063500> rotate<0,-7.124546,0> translate<1.227000,0.000000,16.827500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<3.767000,0.000000,22.225000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,21.907500>}
box{<0,0,-0.063500><2.559767,0.036000,0.063500> rotate<0,-7.124546,0> translate<1.227000,0.000000,21.907500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,21.907500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,21.272500>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,-90.000000,0> translate<1.227000,0.000000,21.272500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<1.227000,0.000000,21.272500>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<3.767000,0.000000,20.955000>}
box{<0,0,-0.063500><2.559767,0.036000,0.063500> rotate<0,7.124546,0> translate<1.227000,0.000000,21.272500> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,21.336000>}
box{<0,0,-0.063500><1.016000,0.036000,0.063500> rotate<0,-90.000000,0> translate<9.144000,0.000000,21.336000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,16.764000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,15.748000>}
box{<0,0,-0.063500><1.016000,0.036000,0.063500> rotate<0,-90.000000,0> translate<9.144000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<0.000000,0.000000,15.748000>}
box{<0,0,-0.063500><9.144000,0.036000,0.063500> rotate<0,0.000000,0> translate<0.000000,0.000000,15.748000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<0.000000,0.000000,15.748000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<0.000000,0.000000,22.352000>}
box{<0,0,-0.063500><6.604000,0.036000,0.063500> rotate<0,90.000000,0> translate<0.000000,0.000000,22.352000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<0.000000,0.000000,22.352000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.144000,0.000000,22.352000>}
box{<0,0,-0.063500><9.144000,0.036000,0.063500> rotate<0,0.000000,0> translate<0.000000,0.000000,22.352000> }
//J2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.835000,0.000000,33.655000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<84.455000,0.000000,33.655000>}
box{<0,0,-0.063500><7.620000,0.036000,0.063500> rotate<0,0.000000,0> translate<76.835000,0.000000,33.655000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<84.455000,0.000000,33.655000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<84.455000,0.000000,13.335000>}
box{<0,0,-0.063500><20.320000,0.036000,0.063500> rotate<0,-90.000000,0> translate<84.455000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<84.455000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.835000,0.000000,13.335000>}
box{<0,0,-0.063500><7.620000,0.036000,0.063500> rotate<0,0.000000,0> translate<76.835000,0.000000,13.335000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.835000,0.000000,13.335000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<76.835000,0.000000,33.655000>}
box{<0,0,-0.063500><20.320000,0.036000,0.063500> rotate<0,90.000000,0> translate<76.835000,0.000000,33.655000> }
//J5 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<55.880000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<55.880000,0.000000,16.510000>}
box{<0,0,-0.063500><10.160000,0.036000,0.063500> rotate<0,-90.000000,0> translate<55.880000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<55.880000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,16.510000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,0.000000,0> translate<55.880000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,17.145000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,90.000000,0> translate<62.230000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,26.035000>}
box{<0,0,-0.063500><8.890000,0.036000,0.063500> rotate<0,90.000000,0> translate<62.230000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,26.670000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,90.000000,0> translate<62.230000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<55.880000,0.000000,26.670000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,0.000000,0> translate<55.880000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<61.595000,0.000000,26.035000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<61.595000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<61.595000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<61.595000,0.000000,17.145000>}
box{<0,0,-0.063500><8.890000,0.036000,0.063500> rotate<0,-90.000000,0> translate<61.595000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<61.595000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<62.230000,0.000000,17.145000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<61.595000,0.000000,17.145000> }
//J6 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<47.625000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<47.625000,0.000000,16.510000>}
box{<0,0,-0.063500><10.160000,0.036000,0.063500> rotate<0,-90.000000,0> translate<47.625000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<47.625000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,16.510000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,0.000000,0> translate<47.625000,0.000000,16.510000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,17.145000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,90.000000,0> translate<53.975000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,26.035000>}
box{<0,0,-0.063500><8.890000,0.036000,0.063500> rotate<0,90.000000,0> translate<53.975000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,26.670000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,90.000000,0> translate<53.975000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,26.670000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<47.625000,0.000000,26.670000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,0.000000,0> translate<47.625000,0.000000,26.670000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.340000,0.000000,26.035000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<53.340000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.340000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.340000,0.000000,17.145000>}
box{<0,0,-0.063500><8.890000,0.036000,0.063500> rotate<0,-90.000000,0> translate<53.340000,0.000000,17.145000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.340000,0.000000,17.145000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<53.975000,0.000000,17.145000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<53.340000,0.000000,17.145000> }
//L1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<51.620000,0.000000,10.805000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<52.520000,0.000000,10.805000>}
box{<0,0,-0.050800><0.900000,0.036000,0.050800> rotate<0,0.000000,0> translate<51.620000,0.000000,10.805000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<51.620000,0.000000,12.055000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<52.545000,0.000000,12.055000>}
box{<0,0,-0.050800><0.925000,0.036000,0.050800> rotate<0,0.000000,0> translate<51.620000,0.000000,12.055000> }
box{<-0.075000,0,-0.150000><0.075000,0.036000,0.150000> rotate<0,-90.000000,0> translate<51.920000,0.000000,10.830000>}
box{<-0.075000,0,-0.150000><0.075000,0.036000,0.150000> rotate<0,-90.000000,0> translate<51.920000,0.000000,12.030000>}
box{<-0.150000,0,-0.150000><0.150000,0.036000,0.150000> rotate<0,-90.000000,0> translate<51.920000,0.000000,11.430000>}
box{<-0.675000,0,-0.300000><0.675000,0.036000,0.300000> rotate<0,-90.000000,0> translate<51.320000,0.000000,11.430000>}
box{<-0.675000,0,-0.300000><0.675000,0.036000,0.300000> rotate<0,-90.000000,0> translate<52.820000,0.000000,11.430000>}
//L2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<58.605000,0.000000,10.805000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<59.505000,0.000000,10.805000>}
box{<0,0,-0.050800><0.900000,0.036000,0.050800> rotate<0,0.000000,0> translate<58.605000,0.000000,10.805000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<58.605000,0.000000,12.055000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<59.530000,0.000000,12.055000>}
box{<0,0,-0.050800><0.925000,0.036000,0.050800> rotate<0,0.000000,0> translate<58.605000,0.000000,12.055000> }
box{<-0.075000,0,-0.150000><0.075000,0.036000,0.150000> rotate<0,-90.000000,0> translate<58.905000,0.000000,10.830000>}
box{<-0.075000,0,-0.150000><0.075000,0.036000,0.150000> rotate<0,-90.000000,0> translate<58.905000,0.000000,12.030000>}
box{<-0.150000,0,-0.150000><0.150000,0.036000,0.150000> rotate<0,-90.000000,0> translate<58.905000,0.000000,11.430000>}
box{<-0.675000,0,-0.300000><0.675000,0.036000,0.300000> rotate<0,-90.000000,0> translate<58.305000,0.000000,11.430000>}
box{<-0.675000,0,-0.300000><0.675000,0.036000,0.300000> rotate<0,-90.000000,0> translate<59.805000,0.000000,11.430000>}
//MAGN1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,15.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,15.010000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,-90.000000,0> translate<28.980000,0.000000,15.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,15.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<29.430000,0.000000,15.010000>}
box{<0,0,-0.063500><0.450000,0.036000,0.063500> rotate<0,0.000000,0> translate<28.980000,0.000000,15.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.480000,0.000000,15.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,15.010000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<31.480000,0.000000,15.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,15.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,15.460000>}
box{<0,0,-0.063500><0.450000,0.036000,0.063500> rotate<0,90.000000,0> translate<31.980000,0.000000,15.460000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,17.510000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,18.010000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,90.000000,0> translate<31.980000,0.000000,18.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.980000,0.000000,18.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<31.530000,0.000000,18.010000>}
box{<0,0,-0.063500><0.450000,0.036000,0.063500> rotate<0,0.000000,0> translate<31.530000,0.000000,18.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<29.480000,0.000000,18.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,18.010000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<28.980000,0.000000,18.010000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,18.010000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.980000,0.000000,17.560000>}
box{<0,0,-0.063500><0.450000,0.036000,0.063500> rotate<0,-90.000000,0> translate<28.980000,0.000000,17.560000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.305000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.575000,0.000000,19.050000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,0.000000,0> translate<27.305000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.305000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.305000,0.000000,17.780000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<27.305000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.575000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.321000,0.000000,19.304000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<28.321000,0.000000,19.304000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.321000,0.000000,19.304000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.321000,0.000000,18.796000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,-90.000000,0> translate<28.321000,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.321000,0.000000,18.796000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<28.575000,0.000000,19.050000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<28.321000,0.000000,18.796000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.305000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.559000,0.000000,18.034000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,-44.997030,0> translate<27.305000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.559000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.051000,0.000000,18.034000>}
box{<0,0,-0.063500><0.508000,0.036000,0.063500> rotate<0,0.000000,0> translate<27.051000,0.000000,18.034000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.051000,0.000000,18.034000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<27.305000,0.000000,17.780000>}
box{<0,0,-0.063500><0.359210,0.036000,0.063500> rotate<0,44.997030,0> translate<27.051000,0.000000,18.034000> }
//MOTOR silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<10.160000,0.000000,35.560000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.080000,0.000000,35.560000>}
box{<0,0,-0.063500><5.080000,0.036000,0.063500> rotate<0,0.000000,0> translate<5.080000,0.000000,35.560000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.080000,0.000000,35.560000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.080000,0.000000,29.210000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,-90.000000,0> translate<5.080000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.080000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.715000,0.000000,29.210000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<5.080000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.715000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.525000,0.000000,29.210000>}
box{<0,0,-0.063500><3.810000,0.036000,0.063500> rotate<0,0.000000,0> translate<5.715000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.525000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<10.160000,0.000000,29.210000>}
box{<0,0,-0.063500><0.635000,0.036000,0.063500> rotate<0,0.000000,0> translate<9.525000,0.000000,29.210000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<10.160000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<10.160000,0.000000,35.560000>}
box{<0,0,-0.063500><6.350000,0.036000,0.063500> rotate<0,90.000000,0> translate<10.160000,0.000000,35.560000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.525000,0.000000,29.210000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.525000,0.000000,30.480000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,90.000000,0> translate<9.525000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<9.525000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.715000,0.000000,30.480000>}
box{<0,0,-0.063500><3.810000,0.036000,0.063500> rotate<0,0.000000,0> translate<5.715000,0.000000,30.480000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.715000,0.000000,30.480000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<5.715000,0.000000,29.210000>}
box{<0,0,-0.063500><1.270000,0.036000,0.063500> rotate<0,-90.000000,0> translate<5.715000,0.000000,29.210000> }
//PWR silk screen
object{ARC(0.400800,0.101600,273.690466,446.309534,0.036000) translate<2.819200,0.000000,10.795000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<5.395000,0.000000,9.995000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<3.495000,0.000000,9.995000>}
box{<0,0,-0.050800><1.900000,0.036000,0.050800> rotate<0,0.000000,0> translate<3.495000,0.000000,9.995000> }
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<3.495000,0.000000,11.595000>}
cylinder{<0,0,0><0,0.036000,0>0.050800 translate<5.395000,0.000000,11.595000>}
box{<0,0,-0.050800><1.900000,0.036000,0.050800> rotate<0,0.000000,0> translate<3.495000,0.000000,11.595000> }
difference{
cylinder{<3.020000,0,10.245000><3.020000,0.036000,10.245000>0.150800 translate<0,0.000000,0>}
cylinder{<3.020000,-0.1,10.245000><3.020000,0.135000,10.245000>0.049200 translate<0,0.000000,0>}}
box{<-0.250000,0,-0.062500><0.250000,0.036000,0.062500> rotate<0,-90.000000,0> translate<2.857500,0.000000,10.195000>}
box{<-0.112500,0,-0.162500><0.112500,0.036000,0.162500> rotate<0,-90.000000,0> translate<3.057500,0.000000,10.057500>}
box{<-0.062500,0,-0.112500><0.062500,0.036000,0.112500> rotate<0,-90.000000,0> translate<3.107500,0.000000,10.407500>}
box{<-0.212500,0,-0.062500><0.212500,0.036000,0.062500> rotate<0,-90.000000,0> translate<3.157500,0.000000,10.357500>}
box{<-0.250000,0,-0.175000><0.250000,0.036000,0.175000> rotate<0,-90.000000,0> translate<2.970000,0.000000,11.395000>}
box{<-0.300000,0,-0.062500><0.300000,0.036000,0.062500> rotate<0,-90.000000,0> translate<3.157500,0.000000,11.345000>}
box{<-0.850000,0,-0.150000><0.850000,0.036000,0.150000> rotate<0,-90.000000,0> translate<3.345000,0.000000,10.795000>}
box{<-0.850000,0,-0.350000><0.850000,0.036000,0.350000> rotate<0,-90.000000,0> translate<5.745000,0.000000,10.795000>}
box{<-0.162500,0,-0.212500><0.162500,0.036000,0.212500> rotate<0,-90.000000,0> translate<3.882500,0.000000,10.107500>}
box{<-0.162500,0,-0.212500><0.162500,0.036000,0.212500> rotate<0,-90.000000,0> translate<3.882500,0.000000,11.482500>}
box{<-0.175000,0,-0.175000><0.175000,0.036000,0.175000> rotate<0,-90.000000,0> translate<4.270000,0.000000,10.795000>}
//R1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<64.545000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.725000,0.000000,12.700000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<63.725000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<64.545000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.725000,0.000000,13.970000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<63.725000,0.000000,13.970000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<63.403600,0.000000,13.333500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<64.876800,0.000000,13.333500>}
//R2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.725000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<64.545000,0.000000,11.430000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<63.725000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<63.725000,0.000000,10.160000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<64.545000,0.000000,10.160000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<63.725000,0.000000,10.160000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<64.866400,0.000000,10.796500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<63.393200,0.000000,10.796500>}
//R3 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<52.480000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<51.660000,0.000000,12.700000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<51.660000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<52.480000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<51.660000,0.000000,13.970000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<51.660000,0.000000,13.970000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<51.338600,0.000000,13.333500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<52.811800,0.000000,13.333500>}
//R4 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<58.830000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<58.010000,0.000000,12.700000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<58.010000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<58.830000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<58.010000,0.000000,13.970000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<58.010000,0.000000,13.970000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<57.688600,0.000000,13.333500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<59.161800,0.000000,13.333500>}
//R5 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,14.605000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,14.605000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,14.605000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,15.875000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,15.875000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,15.875000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<71.023600,0.000000,15.238500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<72.496800,0.000000,15.238500>}
//R7 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<9.115000,0.000000,11.430000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<9.935000,0.000000,11.430000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<9.115000,0.000000,11.430000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<9.115000,0.000000,10.160000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<9.935000,0.000000,10.160000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<9.115000,0.000000,10.160000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<10.256400,0.000000,10.796500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<8.783200,0.000000,10.796500>}
//R9 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<25.175000,0.000000,26.035000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.355000,0.000000,26.035000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<24.355000,0.000000,26.035000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<25.175000,0.000000,27.305000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.355000,0.000000,27.305000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<24.355000,0.000000,27.305000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<24.033600,0.000000,26.668500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<25.506800,0.000000,26.668500>}
//R10 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.355000,0.000000,25.400000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<25.175000,0.000000,25.400000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<24.355000,0.000000,25.400000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.355000,0.000000,24.130000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<25.175000,0.000000,24.130000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<24.355000,0.000000,24.130000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<25.496400,0.000000,24.766500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<24.023200,0.000000,24.766500>}
//R11 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<36.420000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.240000,0.000000,19.050000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<36.420000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<36.420000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.240000,0.000000,17.780000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<36.420000,0.000000,17.780000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<37.561400,0.000000,18.416500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<36.088200,0.000000,18.416500>}
//R12 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.540000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<23.720000,0.000000,17.780000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<23.720000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<24.540000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<23.720000,0.000000,19.050000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<23.720000,0.000000,19.050000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<23.398600,0.000000,18.413500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<24.871800,0.000000,18.413500>}
//R13 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.875000,0.000000,13.970000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.055000,0.000000,13.970000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<37.055000,0.000000,13.970000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.875000,0.000000,15.240000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<37.055000,0.000000,15.240000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<37.055000,0.000000,15.240000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<36.733600,0.000000,14.603500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<38.206800,0.000000,14.603500>}
//R14 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,17.780000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,17.780000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,17.780000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,16.510000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,16.510000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,16.510000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<72.486400,0.000000,17.146500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-0.000000,0> translate<71.013200,0.000000,17.146500>}
//R15 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,19.050000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,19.050000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,19.050000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,20.320000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,20.320000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,20.320000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<71.023600,0.000000,19.683500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<72.496800,0.000000,19.683500>}
//R16 silk screen
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,21.590000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,21.590000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,21.590000> }
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<72.165000,0.000000,22.860000>}
cylinder{<0,0,0><0,0.036000,0>0.076200 translate<71.345000,0.000000,22.860000>}
box{<0,0,-0.076200><0.820000,0.036000,0.076200> rotate<0,0.000000,0> translate<71.345000,0.000000,22.860000> }
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<71.023600,0.000000,22.223500>}
box{<-0.325000,0,-0.700000><0.325000,0.036000,0.700000> rotate<0,-180.000000,0> translate<72.496800,0.000000,22.223500>}
//TST1 silk screen
//U1 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<72.390000,0.000000,38.100000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<0.000000,0.000000,38.100000>}
box{<0,0,-0.063500><72.390000,0.036000,0.063500> rotate<0,0.000000,0> translate<0.000000,0.000000,38.100000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<36.830000,0.000000,10.160000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<52.070000,0.000000,10.160000>}
box{<0,0,-0.063500><15.240000,0.036000,0.063500> rotate<0,0.000000,0> translate<36.830000,0.000000,10.160000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<36.830000,0.000000,27.940000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<52.070000,0.000000,27.940000>}
box{<0,0,-0.063500><15.240000,0.036000,0.063500> rotate<0,0.000000,0> translate<36.830000,0.000000,27.940000> }
//U2 silk screen
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,13.200000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,12.700000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,-90.000000,0> translate<14.605000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<16.105000,0.000000,12.700000>}
box{<0,0,-0.063500><1.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<14.605000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<18.105000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,12.700000>}
box{<0,0,-0.063500><1.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<18.105000,0.000000,12.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,12.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,13.200000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,90.000000,0> translate<19.605000,0.000000,13.200000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,17.200000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,17.700000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,90.000000,0> translate<19.605000,0.000000,17.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<19.605000,0.000000,17.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<18.105000,0.000000,17.700000>}
box{<0,0,-0.063500><1.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<18.105000,0.000000,17.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<16.105000,0.000000,17.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,17.700000>}
box{<0,0,-0.063500><1.500000,0.036000,0.063500> rotate<0,0.000000,0> translate<14.605000,0.000000,17.700000> }
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,17.700000>}
cylinder{<0,0,0><0,0.036000,0>0.063500 translate<14.605000,0.000000,17.200000>}
box{<0,0,-0.063500><0.500000,0.036000,0.063500> rotate<0,-90.000000,0> translate<14.605000,0.000000,17.200000> }
//U3 silk screen
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,23.762600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,23.762600>}
box{<0,0,-0.088900><2.720800,0.036000,0.088900> rotate<0,0.000000,0> translate<12.859600,0.000000,23.762600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,23.762600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,28.307400>}
box{<0,0,-0.088900><4.544800,0.036000,0.088900> rotate<0,90.000000,0> translate<12.859600,0.000000,28.307400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,28.307400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,28.307400>}
box{<0,0,-0.088900><2.720800,0.036000,0.088900> rotate<0,0.000000,0> translate<12.859600,0.000000,28.307400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,28.307400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,23.762600>}
box{<0,0,-0.088900><4.544800,0.036000,0.088900> rotate<0,-90.000000,0> translate<15.580400,0.000000,23.762600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.867600,0.000000,28.307400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,28.307400>}
box{<0,0,-0.088900><2.712800,0.036000,0.088900> rotate<0,0.000000,0> translate<12.867600,0.000000,28.307400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,28.307400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,27.398600>}
box{<0,0,-0.088900><0.908800,0.036000,0.088900> rotate<0,-90.000000,0> translate<15.580400,0.000000,27.398600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,23.762600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.867600,0.000000,23.762600>}
box{<0,0,-0.088900><2.712800,0.036000,0.088900> rotate<0,0.000000,0> translate<12.867600,0.000000,23.762600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,24.671400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<15.580400,0.000000,23.762600>}
box{<0,0,-0.088900><0.908800,0.036000,0.088900> rotate<0,-90.000000,0> translate<15.580400,0.000000,23.762600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,26.612600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,26.971400>}
box{<0,0,-0.088900><0.358800,0.036000,0.088900> rotate<0,90.000000,0> translate<12.859600,0.000000,26.971400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,25.112600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<12.859600,0.000000,25.471400>}
box{<0,0,-0.088900><0.358800,0.036000,0.088900> rotate<0,90.000000,0> translate<12.859600,0.000000,25.471400> }
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-270.000000,0> translate<12.320000,0.000000,27.535000>}
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-270.000000,0> translate<12.320000,0.000000,26.035000>}
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-270.000000,0> translate<12.320000,0.000000,24.535000>}
box{<-0.850000,0,-0.275000><0.850000,0.036000,0.275000> rotate<0,-270.000000,0> translate<15.895000,0.000000,26.035000>}
//U4 silk screen
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,27.672400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,27.672400>}
box{<0,0,-0.088900><2.720800,0.036000,0.088900> rotate<0,0.000000,0> translate<65.699600,0.000000,27.672400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,27.672400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,23.127600>}
box{<0,0,-0.088900><4.544800,0.036000,0.088900> rotate<0,-90.000000,0> translate<68.420400,0.000000,23.127600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,23.127600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,23.127600>}
box{<0,0,-0.088900><2.720800,0.036000,0.088900> rotate<0,0.000000,0> translate<65.699600,0.000000,23.127600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,23.127600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,27.672400>}
box{<0,0,-0.088900><4.544800,0.036000,0.088900> rotate<0,90.000000,0> translate<65.699600,0.000000,27.672400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.412400,0.000000,23.127600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,23.127600>}
box{<0,0,-0.088900><2.712800,0.036000,0.088900> rotate<0,0.000000,0> translate<65.699600,0.000000,23.127600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,23.127600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,24.036400>}
box{<0,0,-0.088900><0.908800,0.036000,0.088900> rotate<0,90.000000,0> translate<65.699600,0.000000,24.036400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,27.672400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.412400,0.000000,27.672400>}
box{<0,0,-0.088900><2.712800,0.036000,0.088900> rotate<0,0.000000,0> translate<65.699600,0.000000,27.672400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,26.763600>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<65.699600,0.000000,27.672400>}
box{<0,0,-0.088900><0.908800,0.036000,0.088900> rotate<0,90.000000,0> translate<65.699600,0.000000,27.672400> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,24.822400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,24.463600>}
box{<0,0,-0.088900><0.358800,0.036000,0.088900> rotate<0,-90.000000,0> translate<68.420400,0.000000,24.463600> }
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,26.322400>}
cylinder{<0,0,0><0,0.036000,0>0.088900 translate<68.420400,0.000000,25.963600>}
box{<0,0,-0.088900><0.358800,0.036000,0.088900> rotate<0,-90.000000,0> translate<68.420400,0.000000,25.963600> }
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-90.000000,0> translate<68.960000,0.000000,23.900000>}
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-90.000000,0> translate<68.960000,0.000000,25.400000>}
box{<-0.250000,0,-0.500000><0.250000,0.036000,0.500000> rotate<0,-90.000000,0> translate<68.960000,0.000000,26.900000>}
box{<-0.850000,0,-0.275000><0.850000,0.036000,0.275000> rotate<0,-90.000000,0> translate<65.385000,0.000000,25.400000>}
texture{col_slk}
}
#end
translate<mac_x_ver,mac_y_ver,mac_z_ver>
rotate<mac_x_rot,mac_y_rot,mac_z_rot>
}//End union
#end